# -*- coding: utf-8 -*-
from global_defines import *
import dynamic_camera
import enemy_script
import dialog

__doc__ = """Handles interactive items that are useable in every zone.

(E.g. a book that starts a cutscene when it is examined)."""

global_items_list = ["SET_BIGUCHU", "SET_MAP","SET_AAC_BROCHURE","SET_DIARY_DROPOUT",
	"SET_TATTERED_NOTE","SET_PLIX_COMPENSATOR","SET_RATSKULL_DIARY",
	"SET_SPECIAL_PICKLOCK","SET_THEODOLIT","SET_BUG","SET_WALKIE_TALKIE",
	"SET_RAT_FUR_JACKET","SET_SOAP","SET_HAIRSTYLE_MAGAZINE",
	"SET_TEDDY_BEAR","SET_NECKLACE","SET_BIG_KEY","SET_TIZOCS_DIARY",	# [Derfflinger]
	"SET_WANTED_POSTER","SET_BROKEN_DOWN_GHETTO_BLASTER","SET_REPAIRED_GHETTOBLASTER",	# [Derfflinger]
	"SET_TOXICOLOGY_BOOK","SET_COILED_UP_MESSAGE","SET_APPLE_W_VALIUM",
	"SET_GENERATOR_CONTROL_PANEL","SET_WHISKEY_BARREL","SET_CALEBS_SHIRT",
 	"SET_DISPOSABLE_SYRINGE","SET_SEANS_NOTES_B","SET_SEANS_DIARY","SET_BUCKET_WITH_VASELINE",	# [Derfflinger]
 	"SET_TIN_WITH_ALCOHOL","SET_CARBURATOR","SET_WINDSHIELD","SET_TAIL_ROTOR",	# [Derfflinger],[BrainRipper]
	"SET_CHILDBIRTH_KIT","SET_OVERALL","SET_BEGGING_LETTER","SET_CAMPING_STOVE",
 	"SET_DEAD_DONKEY","SET_TOBACCO","SET_EMPTY_BOWL","SET_BOWL_WITH_WATER","SET_WHITE_CLOTHS",	# [Derfflinger]
	"SET_DISTRIBUTOR","SET_CORTICAL_INTERFACE","SET_CEREBRAL_MEMORY_MODULE",
	"SET_PLAN_OF_ACTION","SET_BUTCHERS_LIST","SET_BAKERS_LIST","SET_BUNCH_OF_RYE_PLANTS",
	"SET_BROKEN_CHAIN","SET_REPAIRED_CHAIN","SET_WHEEL","SET_RED_KEY","SET_SHADOW_DOCUMENT",
	"SET_SKELETON_DIARY","SET_EAR_DEVICE_01","SET_EAR_DEVICE_02","SET_EAR_DEVICE_03",
	"SET_PAPER_DOCUMENT_01","SET_PAPER_DOCUMENT_02","SET_PAPER_DOCUMENT_03", "SET_SECRET_DOCUMENTS"]

global_items_map = {
	"zone_1.zone_1" : [],
	"zone_2.zone_2" : ["SET_DIARY_DROPOUT","SET_TATTERED_NOTE","SET_PLIX_COMPENSATOR"],
	"zone_3.zone_3" : ["SET_RATSKULL_DIARY","SET_SPECIAL_PICKLOCK"],
	"zone_4.zone_4" : ["SET_THEODOLIT","SET_BUG","SET_WALKIE_TALKIE",
				"SET_RAT_FUR_JACKET","SET_SOAP","SET_HAIRSTYLE_MAGAZINE",
				"SET_TEDDY_BEAR","SET_NECKLACE","SET_BIG_KEY"],	# [Derfflinger]
	"zone_5.zone_5" : ["SET_TIZOCS_DIARY","SET_WANTED_POSTER",
				"SET_BROKEN_DOWN_GHETTO_BLASTER","SET_REPAIRED_GHETTOBLASTER"],	# [Derfflinger]
	"zone_6.zone_6" : ["SET_TOXICOLOGY_BOOK","SET_COILED_UP_MESSAGE","SET_APPLE_W_VALIUM",
				"SET_GENERATOR_CONTROL_PANEL","SET_WHISKEY_BARREL","SET_CALEBS_SHIRT",
				"SET_DISPOSABLE_SYRINGE", "SET_SECRET_DOCUMENTS"],
	"zone_7.zone_7" : ["SET_SEANS_NOTES_B", "SET_SEANS_DIARY","SET_BUCKET_WITH_VASELINE",	# [Derfflinger]
				"SET_TIN_WITH_ALCOHOL","SET_CARBURATOR","SET_WINDSHIELD","SET_TAIL_ROTOR"],	# [Derfflinger],[BrainRipper]
	"zone_8.zone_8" : ["SET_CHILDBIRTH_KIT","SET_OVERALL","SET_BEGGING_LETTER","SET_CAMPING_STOVE",
				"SET_DEAD_DONKEY","SET_TOBACCO","SET_EMPTY_BOWL","SET_BOWL_WITH_WATER","SET_WHITE_CLOTHS"],	# [Derfflinger],[BrainRipper]
	"zone_9.zone_9" : ["SET_DISTRIBUTOR","SET_CORTICAL_INTERFACE","SET_CEREBRAL_MEMORY_MODULE",],
	"zone_10.zone_10" : [],
	"zzone_1.zzone_1" : [],
	"zzone_2.zzone_2" : ["SET_PLAN_OF_ACTION"],
	"zzone_3.zzone_3" : [],
	"zzone_4.zzone_4" : ['SET_PAPER_DOCUMENT_01'],
	"zzone_5.zzone_5" : ["SET_BUTCHERS_LIST","SET_BAKERS_LIST","SET_BUNCH_OF_RYE_PLANTS"],
	"zzone_6.zzone_6" : ["SET_BROKEN_CHAIN","SET_REPAIRED_CHAIN","SET_WHEEL"],
	"zzone_7.zzone_7" : ["SET_RED_KEY","SET_SHADOW_DOCUMENT"],
	"zzone_8.zzone_8" : ["SET_SKELETON_DIARY"],
	"sqzone_1.sqzone_1" : [],
	"sqzone_2.sqzone_2" : [],
	"sqzone_3.sqzone_3" : [],
	"sqzone_5.sqzone_5" : [],
	"sqzone_6.sqzone_6" : [],
}

def on_use( character_id, object_id, item_id, item_type ):
	"""Called when the player wants to use an item.

Parameters:
        character_id - Id of the character.
        object_id    - Id of the object the item should be used on
                       (can be the same as character_id).
        item_id      - Id of the object that should be used.
        item_type    - Type of the object that should be used.
"""

	if item_id == 'SCHATZKARTE':
		if not hasattr(data('schatzkarte'), 'schatzkarte_gelesen'):
			data('schatzkarte').schatzkarte_gelesen = True
		data('schatzkarte').schatzkarte_gelesen = True
		
		system.information_panel(mode=IPM_NOTE, gui_resource="gui\\gui_mission\\special\\schatzkarte.png")
		return True

	print "global_on_use"
	print item_id
	print object_id
	if item_id != None and object_id == None:
		# For Freedom Mod. Until elif
		if objects.has_attribute(item_id, 'opened_zone'):
			zone_name = objects.get_attribute(item_id, 'opened_zone')
			if not is_zone_enabled(zone_name):
				import helpfile
				helpfile.use_sign_item( item_id, zone_name )	
				return True

		elif item_type in global_items_list:
			try:
				# special behaviour
				print character_id
				print item_type
				if item_type == "SET_RATSKULL_DIARY" and character_id != "ALTER_EGO":
					MercenaryDenyTalk(character_id, "default")
					return True
				elif item_type == "SET_RATSKULL_DIARY" and hasattr(data('zone_3.zone_3'), 'reading_ratskull_diary') and data('zone_3.zone_3').reading_ratskull_diary:
					return True
				elif item_id == 'Z6 GEHEIMDOKUMENTE':
					if item_type == 'SET_SECRET_DOCUMENTS' and character_id == "ALTER_EGO":
						Z6_GEHEIMDOKUMENTE()
						return True
					else:
						MercenaryDenyTalk(character_id, "default")
						return True
				else:
					print "call function"
					function = eval(item_type)
					if callable(function):
						if function(item_id):
							return True
			except:
				# default behaviour
				zone = system.get_act_mission_name()
				if zone in global_items_map.keys():
					if item_type in global_items_map[zone]:
						return False
				if simple_examine(item_type):
					return True
		else: raise ValueError, "item type not registered"
	return False

def can_use( character_id, object_id ):
	"""Returns True for items the character is able to use.

Parameters:
        character_id - Id of the character.
        object_id    - Id of the object that should be used.
"""
	if object_id != None:
		_type = objects.get_attribute(object_id, "type")
		if _type=="equipment":
			typeid = objects.get_attribute(object_id, "typeid")
			if typeid in global_items_list:
				return True
		if objects.has_attribute(object_id, 'opened_zone'):
			zone_name = objects.get_attribute(object_id, 'opened_zone')
			if not is_zone_enabled(zone_name):
				return True			
	return False

###############################################################################
#ronny todo: hilfsfunktion zum initialisieren eines dialoges, muss auf
#comment modul umgebaut werden
def initDlg(_text, _speaker):
	"""Helper function to initialize a dialog."""
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text=_text, speaker=_speaker, follower="ENDDIALOG")
	dialog.start()

def simple_examine( item_type ):
	"""Helper function for on_use for items that only have an examine comment."""
	import string
	item_type = string.replace(item_type, "SET", "EXAMINE")
	initDlg(item_type, "ALTER_EGO")
	return True

def Z6_GEHEIMDOKUMENTE():
	"""Helper function to handle Z6_GEHEIMDOKUMENTE."""
	objects.remove_item_from_inventory('ALTER_EGO', 'Z6 GEHEIMDOKUMENTE')
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='Z6_GEHEIMDOKUMENTE_EXAMINE_1', speaker="ALTER_EGO")
	dialog.add_text(text='Z6_GEHEIMDOKUMENTE_EXAMINE_2', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Z6_GEHEIMDOKUMENTE_ENDE)
	dialog.start()

def Z6_GEHEIMDOKUMENTE_ENDE():
	"""Helper function to handle Z6_GEHEIMDOKUMENTE."""
	if not is_zone_enabled('zone_7'):
		character.add_experience_party(50)
	set_zone_enabled("zone_7",True)
	if hasattr(data('zone_7.zone_7'), 'QB_001') and not system.get_qb_entry_state(data('zone_7.zone_7').QB_001) in [UNCOMPLETE, COMPLETE]:
		if not was_zone_entered("zone_7.zone_7"):
			system.set_qb_entry_state(data('zone_7.zone_7').QB_001, UNCOMPLETE)
	data('zone_6.zone_6').SchattenbasisDokumenteGelesen = True
	

def SET_RATSKULL_DIARY(item_id):
	"""Helper function to handle SET_RATSKULL_DIARY."""
	if hasattr(data('zone_3.zone_3'), 'reading_ratskull_diary') and data('zone_3.zone_3').reading_ratskull_diary:
		return True
		
	data('zone_3.zone_3').reading_ratskull_diary = True
	if not (objects.get_grid("ALTER_EGO") == "landscape"):
		SET_RATSKULL_DIARYon_dialog_132_start2()
		return True
	system.start_cutscene()
	dynamic_camera.set_conversation("ALTER_EGO", cam_x=0.0, cam_y=1.0, mode="medium")
	objects.cancel_commandos("ALTER_EGO")
	
	objects.turn_to_direction("ALTER_EGO", DIR_SOUTH, callback=['ONEND', SET_RATSKULL_DIARYon_dialog_132_start])
	if objects.count_in_inventory('ALTER_EGO', 'Z3 RATSKULL_DIARY'):
		objects.remove_item_from_inventory("ALTER_EGO", "Z3 RATSKULL_DIARY")
	else:
		if 'Z3 RATSKULL_DIARY' in system.get_objects():
			objects.set_active_state('Z3 RATSKULL_DIARY', False)
	if not objects.count_in_inventory("ALTER_EGO", "SET_OPEN_BOOK"):
		objects.create_item_in_inventory("ALTER_EGO", "SET_OPEN_BOOK")
	return True
def SET_RATSKULL_DIARYon_dialog_132_start(char=None):
	"""Helper function to handle SET_RATSKULL_DIARY."""
	global RatskullDiaryGelesen
	character.equip("ALTER_EGO", "SET_OPEN_BOOK")
	RatskullDiaryGelesen = 0
	buchLesen()
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='EXAMINE_RATSKULL_DIARY', speaker="ALTER_EGO", follower='ENDDIALOG', callback=SET_RATSKULL_DIARYonDlg_132_Ende)
	dialog.start()

def SET_RATSKULL_DIARYon_dialog_132_start2():
	"""Helper function to handle SET_RATSKULL_DIARY."""
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.add_text(text='EXAMINE_RATSKULL_DIARY', speaker="ALTER_EGO", follower='ENDDIALOG', callback=SET_RATSKULL_DIARYonDlg_132_Ende)
	dialog.start()

def SET_RATSKULL_DIARYonDlg_132_Ende():
	"""Helper function to handle SET_RATSKULL_DIARY."""
	#print "onDlg_132_Ende"
	data('zone_3.zone_3').reading_ratskull_diary = False
	global RatskullDiaryGelesen
	if system.is_cutscene():
		RatskullDiaryGelesen=1
		system.end_cutscene()
		character.un_equip("ALTER_EGO", "SET_OPEN_BOOK")
		objects.remove_item_from_inventory("ALTER_EGO", "SET_OPEN_BOOK")
		if 'Z3 RATSKULL_DIARY' in system.get_objects():
			objects.set_active_state('Z3 RATSKULL_DIARY', True)
		else:
			objects.create_item_in_inventory(object="ALTER_EGO", equipment="SET_RATSKULL_DIARY", id="Z3 RATSKULL_DIARY")
			objects.set_attribute("Z3 RATSKULL_DIARY", "generic_item", False)
	#if system.get_qb_entry_state(data("zone_3.zone_3").QB_024) in [ INACTIVE]:
	if not was_zone_entered('sqzone_2.sqzone_2'):
		system.set_qb_entry_state(data("zone_3.zone_3").QB_024,UNCOMPLETE) 
	if not is_zone_enabled('sqzone_2'):
		character.add_experience_party(50)
		set_zone_enabled("sqzone_2",True)
	
bookdo = 'loop'
RatskullDiaryGelesen=0

def buchLoop(char):
	"""Helper function to handle SET_RATSKULL_DIARY."""
	global bookdo
	global RatskullDiaryGelesen
	#print RatskullDiaryGelesen, bookdo
	if not RatskullDiaryGelesen == 1:
		if bookdo == 'loop':
			character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_LOOP",callback=["ONEND",Lambda('buchLoop("ALTER_EGO")')])
		elif bookdo == 'scrape':
			character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_KRATZEN_LOOP",callback=["ONEND",Lambda('buchLoop("ALTER_EGO")')])
			bookdo = 'loop'
		elif bookdo == 'turnOver':
			character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_UMBLAETTERN_LOOP",callback=["ONEND",Lambda('buchLoop("ALTER_EGO")')])
			bookdo = 'loop'
		else:
			character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_LOOP",callback=["ONEND",Lambda('buchLoop("ALTER_EGO")')])
	else:
		character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_ENDE")
		pass
	
def MercenaryDenyTalk(id,type='default'):
	"""Helper function for on_use; called when an item cannot be used by a mercenary."""
#	gender = objects.get_attribute("ALTER_EGO","gender")
	gender = objects.get_attribute(id,"gender")
	dialog.init_dialog(type=DIALOGSMALL)
	if type == 'default':
		if gender == MALE:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY_F', speaker=id, follower='ENDDIALOG')
	else:
		if gender == MALE:
			dialog.add_text(text='MERCENERY_USEITEM_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_USEITEM_DENY_F', speaker=id, follower='ENDDIALOG')
	dialog.start(False)

def buchLesen():
	"""Helper function to handle SET_RATSKULL_DIARY."""
	global RatskullDiaryGelesen
	RatskullDiaryGelesen=0
	objects.cancel_commandos("ALTER_EGO")
	character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_START",callback=["ONEND",Lambda('buchLoop("ALTER_EGO")')])
	readBookTurnOver(3.3)
	
def changeBookDo(do):
	"""Helper function to handle SET_RATSKULL_DIARY."""
	global bookdo
	bookdo = do
	
def readBookTurnOver(de):
	"""Helper function to handle SET_RATSKULL_DIARY."""
	if de > 0.0:
		enemy_script.delay(de,Lambda("changeBookDo('turnOver')"))
	else:
		changeBookDo('turnOver')
		pass

def readBookScrape(de):
	"""Helper function to handle SET_RATSKULL_DIARY."""
	if de > 0.0:
		enemy_script.delay(de,Lambda("changeBookDo('scrape')"))
	else:
		changeBookDo('scrape')
		pass
	

def SET_BIGUCHU( item_id ):
	"""Helper function to handle SET_BIGUCHU."""
	clock = system.get_mission_time().get_day_time()
	if not hasattr(data("global_item"), "KommentarNummerBiguchu"):
		data("global_item").KommentarNummerBiguchu = 1

	if data("global_item").KommentarNummerBiguchu == 1:
		if clock >= time("00:00:00") and clock < time("04:30:00"):
			initDlg("ITEM_BIGUCHU_T_001", item_id)
		elif clock >= time("04:30:00") and clock < time("06:00:00"):
			initDlg("ITEM_BIGUCHU_T_002", item_id)
		elif clock >= time("06:00:00") and clock < time("12:00:00"):
			initDlg("ITEM_BIGUCHU_T_003", item_id)
		elif clock >= time("12:00:00") and clock < time("15:00:00"):
			initDlg("ITEM_BIGUCHU_T_004", item_id)
		elif clock >= time("15:00:00") and clock < time("21:30:00"):
			initDlg("ITEM_BIGUCHU_T_005", item_id)
		elif clock >= time("21:30:00") and clock < time("23:00:00"):
			initDlg("ITEM_BIGUCHU_T_006", item_id)
		elif clock >= time("23:00:00"):
			initDlg("ITEM_BIGUCHU_T_007", item_id)
		data("global_item").KommentarNummerBiguchu = 0
	else:
		initDlg("ITEM_BIGUCHU_T_008", item_id)
		data("global_item").KommentarNummerBiguchu = 1
	return True

def SET_AAC_BROCHURE( item_id ):
	"""Helper function to handle SET_AAC_BROCHURE."""
	system.information_panel(
		mode=IPM_BOOK,
		gui_resource="gui\\gui_mission\\special\\brochure.png",
		content=[
			["MBA_PIC_1","SET_AAC_BROCHURE_1"],
			["SET_AAC_BROCHURE_2","MBA_PIC_2"],
			["MBA_PIC_3","SET_AAC_BROCHURE_3"],
			["SET_AAC_BROCHURE_4","MBA_PIC_4"],
			["MBA_PIC_5","SET_AAC_BROCHURE_5"],
			["SET_AAC_BROCHURE_6"]])
	return True

def SET_MAP( item_id ):
	"""Helper function to handle SET_MAP."""
	system.information_panel(mode=IPM_NOTE,
		gui_resource="gui\\gui_mission\\special\\paradise_map.png")
	return True
	
def SET_EAR_DEVICE_01(item_id):
	"""Helper function to handle SET_EAR_DEVICE_01."""
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='TONDOC_001_001', speaker='ALTER_EGO')
	dialog.add_text(text='TONDOC_001_002', speaker='ALTER_EGO')#Counter
	dialog.add_text(text='TONDOC_001_003', speaker='ALTER_EGO')#Counter
	dialog.add_text(text='TONDOC_001_004', speaker='ALTER_EGO')#Counter
	dialog.add_text(text='TONDOC_001_005', speaker='ALTER_EGO', follower='ENDDIALOG')#Counter
	dialog.start()
	return True

def SET_EAR_DEVICE_02(item_id):
	"""Helper function to handle SET_EAR_DEVICE_02."""
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='TONDOC_002_001', speaker='ALTER_EGO')
	dialog.add_text(text='TONDOC_002_002', speaker='ALTER_EGO')#Victor
	dialog.add_text(text='TONDOC_002_003', speaker='ALTER_EGO')#Counter
	dialog.add_text(text='TONDOC_002_004', speaker='ALTER_EGO')#Counter
	dialog.add_text(text='TONDOC_002_005', speaker='ALTER_EGO')#Blake
	dialog.add_text(text='TONDOC_002_006', speaker='ALTER_EGO')#Counter
	dialog.add_text(text='TONDOC_002_007', speaker='ALTER_EGO')#Blake
	dialog.add_text(text='TONDOC_002_008', speaker='ALTER_EGO')#Counter
	dialog.add_text(text='TONDOC_002_009', speaker='ALTER_EGO')#Blake
	dialog.add_text(text='TONDOC_002_010', speaker='ALTER_EGO')#Counter
	dialog.add_text(text='TONDOC_002_011', speaker='ALTER_EGO', follower='ENDDIALOG')#Blake
	dialog.start()
	return True

def SET_EAR_DEVICE_03(item_id):
	"""Helper function to handle SET_EAR_DEVICE_03."""
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='TONDOC_003_001', speaker='ALTER_EGO')
	dialog.add_text(text='TONDOC_003_002', speaker='ALTER_EGO')#Rich
	dialog.add_text(text='TONDOC_003_003', speaker='ALTER_EGO')#Rich
	dialog.add_text(text='TONDOC_003_004', speaker='ALTER_EGO')#Rich
	dialog.add_text(text='TONDOC_003_005', speaker='ALTER_EGO', follower='ENDDIALOG')#Rich
	dialog.start()
	return True

def SET_PAPER_DOCUMENT_01(item_id):
	"""Helper function to handle SET_PAPER_DOCUMENT_01."""
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='PAPERDOC_001_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start()
	return True

def SET_PAPER_DOCUMENT_02(item_id):
	"""Helper function to handle SET_PAPER_DOCUMENT_02."""
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='PAPERDOC_002_001', speaker='ALTER_EGO')
	dialog.add_text(text='PAPERDOC_002_002', speaker='ALTER_EGO')#Patricia
	dialog.add_text(text='PAPERDOC_002_003', speaker='ALTER_EGO')#Patricia
	dialog.add_text(text='PAPERDOC_002_004', speaker='ALTER_EGO')#Patricia
	dialog.add_text(text='PAPERDOC_002_005', speaker='ALTER_EGO')#Patricia
	dialog.add_text(text='PAPERDOC_002_006', speaker='ALTER_EGO')#Patricia
	dialog.add_text(text='PAPERDOC_002_007', speaker='ALTER_EGO')#Patricia
	dialog.add_text(text='PAPERDOC_002_008', speaker='ALTER_EGO')#Patricia
	dialog.add_text(text='PAPERDOC_002_009', speaker='ALTER_EGO', follower='ENDDIALOG')#Patricia
	dialog.start()
	return True

def SET_PAPER_DOCUMENT_03(item_id):
	"""Helper function to handle SET_PAPER_DOCUMENT_03."""
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text='PAPERDOC_003_001', speaker='ALTER_EGO')
	dialog.add_text(text='PAPERDOC_003_002', speaker='ALTER_EGO')#Harold
	dialog.add_text(text='PAPERDOC_003_003', speaker='ALTER_EGO')#Harold
	dialog.add_text(text='PAPERDOC_003_004', speaker='ALTER_EGO', follower='ENDDIALOG')#Rich
	dialog.start()
	return True
