# -*- coding: utf-8 -*-
from global_defines import *
from const import *
import npc
import schedules
from dynamic_camera import *
import enemy_script
import dialog
from daily_routine import *
import object_events
import sounds

#*********************************************************************
#		aktuelle revison: Revision 33, 6.10.2004 und 36 und 40
#*********************************************************************
def count_wargheads(char):
	count = 0
	i = 0
	for dummy in ["WARG_1","WARG_2","WARG_3","WARG_4","WARG_5"]:
		i += 1
		warghead_id = QI_WARGHEAD[1]+"_"+str(i)
		if objects.count_in_inventory(char, warghead_id):
			count += 1
	return count

def on_approach(target, operator):
	if dialog.is_dialog_active():
		return
	
	if system.is_cutscene():
		return
	
	if schedules.Dialog(target, operator):
		return
	
	if target in ["SCHLAEGER_1","SCHLAEGER_2","SCHLAEGER_3"]:
		initDlg_079_SchlaegerVerscheuchenSpieler()
		
	if target == "TIZOC":
		if not data().Sekte_Ausgerottet1:
			initDlg_050_SpielerVersuchtTizocZuSprechen()
		elif data().Sekte_Ausgerottet1 and system.get_qb_entry_state(data().QB_010) == UNCOMPLETE:
			initCutscene_021_SpielerSagtZukunftVoraus()

	if target == "NICHOLAS":
		if (system.get_qb_entry_state(data().QB_008) == INACTIVE):
			if not data().INFOS_UEBER_BESTIEN_ERHALTEN:
				if data().ratstod == 1:
					initDlg_073_NicolasInfoBestienRatskullsErledigt()
				else:
					initDlg_024_NicholasGibtInfosZuBestien()
			else:
				initDlg_025_NicolasHatKeineWeiterenInfos()
	
		elif (system.get_qb_entry_state(data().QB_008) == UNCOMPLETE):
			# Gruppenmitglieder in der Nähe (10m) von Nicholas
			group = enemy_script.is_in_area(system.get_pcs(),10,"NICHOLAS")
			for char in group:
				data().NumberOfHeads += count_wargheads(char)
			if data().NumberOfHeads > 1:
				data().FirstTimeDlg081 = True
				for i in range(1,6):
					for char in group:
						if objects.count_in_inventory(char, QI_WARGHEAD[1]+"_"+str(i)):
							objects.transfer_item(char, QI_WARGHEAD[1]+"_"+str(i), "NICHOLAS")
							data().Kopfe += 1
							if not data().Kopfe == 5:
								character.add_experience_party(70)
							else:
								character.add_experience_party(100)
				data().headsAtBeginning = data().NumberOfHeads
				initDlg_081_SpielerHatMehrere()
			elif data().NumberOfHeads == 1:
				for char in group:
					head = hasWargHead(char)
					if head != None:
						data().Kopfe += 1
						objects.transfer_item(char,head,"NICHOLAS")
						if not data().Kopfe == 5:
							character.add_experience_party(70)
						else:
							character.add_experience_party(100)
						if (data().Kopfgeld_fuer_Schaedel == 0):
							initDlg_026_SpielerHoltKopfgeld_1()
						elif data().Kopfgeld_fuer_Schaedel == 1:
							initDlg_047_SpielerHoltKopfgeld_2()
						elif data().Kopfgeld_fuer_Schaedel == 2:
							initDlg_029_SpielerHoltKopfgeld_3()
						elif data().Kopfgeld_fuer_Schaedel == 3:
							initDlg_049_SpielerHoltKopfgeld_4()
						elif data().Kopfgeld_fuer_Schaedel == 4:
							initDlg_048_SpielerHoltKopfgeld_5()
						data().NumberOfHeads -= 1
			else:
				initDlg_025_NicolasHatKeineWeiterenInfos()
		
		elif (system.get_qb_entry_state(data().QB_008) == COMPLETE):
			if ((system.get_qb_entry_state(data().QB_005) == INACTIVE) and data().Sekte_Ausgerottet1):
				if data().nicholasende == 0:
					initDlg_027_SpielerKlaertNicolasUeberRitualAuf() 
				else:
					initDlg_051_NicholasWillNixMehrVonSpieler()
			else:
				initDlg_025_NicolasHatKeineWeiterenInfos()

	if target == "ZACHARY":
		if system.get_qb_entry_state(data().QB_006) == IMPOSSIBLE:
			initDlg_040_Zachary_ist_sauer()
		elif system.get_qb_entry_state(data().QB_006) == INACTIVE:
			initDlg_036_ZacharyBittetSpielerUmHilfe()
		elif system.get_qb_entry_state(data().QB_006) == UNCOMPLETE:
			erg = enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = [QI_BLASTERFIXED[1], "SET_REPAIRED_GHETTOBLASTER"])
			if erg[QI_BLASTERFIXED[1]] or erg["SET_REPAIRED_GHETTOBLASTER"]:
				initCutscene_038_SpielerGibtZacharyBlasterZurueck()
			else:
				initDlg_037_ZacharyWillBlasterWiederHaben()
		elif system.get_qb_entry_state(data().QB_006) == COMPLETE:
			initDlg_039_ZacharyBedanktSich()
	
	if target == "BRANDON":
		if not data().Ziel4:
			initDlg_017_SpielerVerscheuchen()
		else:
			initDlg_018_SpielerWillBrandonUndCoUmlegen()


	if target == "MUSTAFA":
		if (system.get_qb_entry_state(data().QB_001) == INACTIVE and system.get_qb_entry_state(data().QB_004) == INACTIVE):
			if data().Mustafa_ansprechen == 0:
				initDlg_004_ErsteBegegnungMitMustafa()
			else:
				initDlg_005_Hau_ab()
			
		elif ((system.get_qb_entry_state(data().QB_001) in [UNCOMPLETE,COMPLETE]) or
		       (system.get_qb_entry_state(data().QB_004) == UNCOMPLETE and system.get_qb_entry_state(data().QB_001) == INACTIVE)):
			if not data().MustafaAufforderung:
				initDlg_006_Aufforderung()
				data().MustafaAufforderung = True
			elif (system.get_qb_entry_state(data().QB_004) == UNCOMPLETE):
				initDlg_007_aufmerksam_machen()
			elif (system.get_qb_entry_state(data().QB_004) == INACTIVE and system.get_qb_entry_state(data().QB_001) == UNCOMPLETE):
				if data().geloest1 == 0:
					initCutscene_008_Rowdies_aufgemischt()
				else:
					initDlg_009_Rowdies_aufgemischt2()
			else:
				initDlg_005_Hau_ab()
		else:
			initDlg_005_Hau_ab()


	if target == "GENERAL_LEWIS":
		if data().d_045_als_naechster == 0:
			if data().general_first_approach:
				if data().ratstod == 0:
					initDlg_001_GeneralBrauchtSpielerRatskullsNichtBesiegt()
				else:
					initDlg_060_GeneralBrauchtSpielerRatskullsBesiegt()
				data().general_first_approach = False
			else:
				#checkQuestItemsGeneral()
				checkQuestSchrottGeneral()
				if(system.get_qb_entry_state(data().QB_003) == INACTIVE and
					system.get_qb_entry_state(data().QB_013) == UNCOMPLETE and
					(system.get_qb_entry_state(data().QB_001) in [UNCOMPLETE,COMPLETE,INACTIVE]) and
					(system.get_qb_entry_state(data().QB_002) in [UNCOMPLETE,COMPLETE,INACTIVE]) and
					not data().Wesley_Ziel3):
					if objects.exists("FRANKLIN"):
						if objects.get_distance("FRANKLIN","GENERAL_LEWIS") <= 15.0:
							data("zone_3.zone_3").franklin_folgt = False
							objects.set_attribute("FRANKLIN","zone_transfer",False)
							initCutscene_012_GeneralBedanktSichFuerDenDoc()

				elif(system.get_qb_entry_state(data().QB_001) == COMPLETE and
					(system.get_qb_entry_state(data().QB_002) in [UNCOMPLETE,COMPLETE,INACTIVE]) and
					(system.get_qb_entry_state(data().QB_003) in [UNCOMPLETE,COMPLETE,INACTIVE]) and
					not data().Wesley_Ziel1):
					initCutscene_003_GeneralBedanktSichFuerSchrott()
				
				elif checkQuestItemsGeneral() and not data().Wesley_Ziel2:
					#system.get_qb_entry_state(data().QB_002) == COMPLETE and
					#(system.get_qb_entry_state(data().QB_001) in [UNCOMPLETE,COMPLETE,INACTIVE]) and
					#(system.get_qb_entry_state(data().QB_003) in [UNCOMPLETE,COMPLETE,INACTIVE]) and
					initDlg_011_GeneralBedanktSichFuerZelteUndWasser()
				
				elif (data().Wesley_Ziel1 and data().Wesley_Ziel2 and data().Wesley_Ziel3):
					if (data().ratstod == 0):
						initDlg_014_GeneralFordertSpielerAufRatskullsZuToeten()
					else:
						initDlg_046_GeneralDanktSpieler()
				else:
					initDlg_013_GeneralFordertSpielerAufZuArbeiten()
	
		else:
			initDlg_045_GeneralAergertSichUeberSpieler()

	if target == "OLIVIA":
		if data().Sekte_Ausgerottet:
			if data().Olivia_Dank:
				initDlg_052_Olivia_dankt()
			else:
				initCutscene_033_Olivia_ist_gerettet()
	
	if data().last_sectarian != None:
		if target == data().last_sectarian:
			initDlg_032_Sekten_Mitgl()


	if target == "DAN":
		initDlg_070_DanIstEinFeigling()
	
	if target == "PATRICK":
		if not data().seeker_aufgehalten:
			initCutscene_067_SeekerWillFluechten()
		else:
			initDlg_068_SpielerFragtSeekerAus()

	if target == "PHOENIX":
		#if ((data().ratstod == 0) or 
		if (data().kill_wasser >= 20 and not objects.is_fighting("ALTER_EGO")):
			if not data().phoenix_gesprochen:
				initCutscene_063_PhoenixGibtSichGeschlagen()
		else:
			initDlg_072_SpielerWillNichtMitPhoenixSprechen()
			

	if target in ["IAN", "PAULA", "LINDA"]:
#		for id in NPC_FAMILY:
#			if id == "IAN":
#				objects.cancel_commandos("IAN")
		if target != "IAN":
			objects.cancel_commandos("ALTER_EGO")
			objects.turn_to_object("ALTER_EGO", "IAN")
			character.set_approachable_state("IAN", False)
			objects.cancel_commandos("IAN")
			prohibit_activity("IAN")
			objects.move_to_object("IAN", "ALTER_EGO")
			#print "ich bin ein if"
			objects.turn_to_object("IAN", "ALTER_EGO", callback=["ONEND",on_approach_family])
			return True
		else:
			#print "ich bin ein else"
			on_approach_family("IAN")
			return True
	
	if target == 'CLIVE':
		if data().Dlg_088_Ende_2 and data().Clive_gesprochen > 0:
			initDlg_089_Ansprache_nach_088_Endde_2()
		elif data().Clive_gesprochen == 0:
			initDlg_085_Clive_erstes_mal()
		elif data().Clive_gesprochen > 0:
			if global_defines.was_zone_entered('zzone_9.zzone_9') and data().Dlg_085_Ende_2:
				if not data('zzone_9.zzone_9').Benson_Killed and not data('zzone_9.zzone_9').Howard_Killed:
					initDlg_086_Kein_Bruder_Tot()
				elif ((data('zzone_9.zzone_9').Benson_Killed and not data('zzone_9.zzone_9').Howard_Killed) or
					  not (data('zzone_9.zzone_9').Benson_Killed and data('zzone_9.zzone_9').Howard_Killed)):
						  initDlg_087_Ein_Bruder_Tot()
				#if ((data('zzone_9.zzone_9').Benson_Gang_Killed and data('zzone_9.zzone_9').Howard_Gang_Killed) or
				#	(data('zzone_9.zzone_9').Benson_Killed and data('zzone_9.zzone_9').Howard_Killed)):
				elif system.get_qb_entry_state(data('zzone_9.zzone_9').QB_009) == UNCOMPLETE:
					initDlg_088_Beide_Gangs_Tot()
				else:
					initDlg_086_Kein_Bruder_Tot()
			else:
				initDlg_086_Kein_Bruder_Tot()
		else:
			initDlg_086_Kein_Bruder_Tot()
	return None

def initDlg_085_Clive_erstes_mal():
	
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_085')
	dialog.add_text(text='D_085_T_001', speaker="CLIVE")
	
	dialog.add_choice(text='D_085_C_001_1', follower='D_085_T_003')
	dialog.add_choice(text='D_085_C_001_2', follower='D_085_T_004')
	dialog.add_choice(text='D_085_C_001_3', follower='D_085_T_002')
	
	dialog.add_text(text='D_085_T_002', speaker="CLIVE", follower='ENDDIALOG', callback = Dlg_085_ENDE_1)
	dialog.add_text(text='D_085_T_003', speaker="CLIVE", follower='D_085_C_002')
	dialog.add_text(text='D_085_T_004', speaker="CLIVE", follower='D_085_C_002')
	
	dialog.add_choice(text='D_085_C_002_1', follower='D_085_T_005')
	dialog.add_choice(text='D_085_C_002_2', follower='D_085_T_006')
	dialog.add_choice(text='D_085_C_002_3', follower='D_085_T_002')
	
	dialog.add_text(text='D_085_T_005', speaker="CLIVE", follower='D_085_C_002')
	dialog.add_text(text='D_085_T_006', speaker="CLIVE")
	dialog.add_text(text='D_085_T_007', speaker="CLIVE")
	dialog.add_text(text='D_085_T_008', speaker="CLIVE")
	dialog.add_text(text='D_085_T_009', speaker="ALTER_EGO")
	dialog.add_text(text='D_085_T_010', speaker="CLIVE")
	dialog.add_text(text='D_085_T_011', speaker="ALTER_EGO", follower='ENDDIALOG', callback = Dlg_085_ENDE_2)
	
	dialog.start(True, data("zone_5.zone_5").QB_019)
	

def Dlg_085_ENDE_1():
	pass
	
def Dlg_085_ENDE_2():
	data().Clive_gesprochen = 1
	data().Dlg_085_Ende_2 = True
	system.set_qb_entry_state(data().QB_019, UNCOMPLETE)
	if not is_zone_enabled('zzone_9'):
		character.add_experience_party(50)
	set_zone_enabled('zzone_9', True)
	
def initDlg_086_Kein_Bruder_Tot():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_086')
	dialog.add_text(text='D_086_T_001', speaker="CLIVE")
	dialog.add_text(text='D_086_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	
	dialog.start(True, data("zzone_9.zzone_9").QB_001)

def initDlg_087_Ein_Bruder_Tot():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_087')
	dialog.add_text(text='D_087_T_001', speaker="CLIVE")
	dialog.add_text(text='D_087_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	
	dialog.start(True, data("zzone_9.zzone_9").QB_001)

def initDlg_088_Beide_Gangs_Tot():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_088')
	dialog.add_text(text='D_088_T_001', speaker="CLIVE")
	
	dialog.add_choice(text='D_088_C_001_1', follower='D_088_T_002')
	dialog.add_choice(text='D_088_C_001_3', follower='ENDDIALOG', callback = Dlg_088_ENDE_1)
	
	dialog.add_text(text='D_088_T_002', speaker="CLIVE")
	dialog.add_text(text='D_088_T_003', speaker="ALTER_EGO", follower='D_088_C_001_1', callback = Dlg_088_C_001_2)
	dialog.add_text(text='D_088_T_004', speaker="CLIVE")
	dialog.add_text(text='D_088_T_005', speaker="CLIVE", follower='ENDDIALOG', callback = Dlg_088_ENDE_2)
	dialog.add_text(text='D_088_T_006', speaker="CLIVE", follower='D_088_C_001_1')
	
	if data().restart_T_006:
		dialog.jump_to('D_088_T_006')
	dialog.start(False, data("zzone_9.zzone_9").QB_001)

def Dlg_088_ENDE_1():
	data().restart_T_006 = True
	
def Dlg_088_ENDE_2():
	data().Dlg_088_Ende_2 = True
	if hasattr(data('zzone_9.zzone_9'), 'QB_009'):
		if data('zzone_9.zzone_9').QB_009 != -1:
			if system.get_qb_entry_state(data('zzone_9.zzone_9').QB_009) != COMPLETE:
				system.set_qb_entry_state(data('zzone_9.zzone_9').QB_009, COMPLETE)
				character.add_experience_party(300)
	

def Dlg_088_C_001_2():
	dialog.add_choice(text='D_088_C_001_2', follower='D_088_T_004')

def initDlg_089_Ansprache_nach_088_Endde_2():
	
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_089')
	dialog.add_text(text='D_089_T_001', speaker="CLIVE", follower='ENDDIALOG')
	
	dialog.start()

def on_approach_family(char):
#	print("on_approach_family")
	character.set_approachable_state("IAN", True)
	if not data("zone_5.zone_5").Familie_wird_Eskortiert and not data("zone_5.zone_5").Familie_bleibt_stehen:
		initDlg_053_RatskullsHabenHausNiederGebrannt()


def hasWargHead(id):
	for i in range(1,6):
		#print "has_warg_head",str(i)
		head_id = QI_WARGHEAD[1]+"_"+str(i)
		if objects.count_in_inventory(id, head_id):
			#print "[ found warg head (",head_id,") ]"
			return head_id
	#print "[ found no warg head ]"
	return None
		
def checkQuestItemsGeneral():
	count = enemy_script.count_party_inventory(area = 15, object_id = "GENERAL_LEWIS", items = ["SET_WATER_DETECTOR","SET_TENT_CANVAS"])
	if (count["SET_WATER_DETECTOR"] >= 4) and (count["SET_TENT_CANVAS"] >= 4):
		if system.get_qb_entry_state(data().QB_002)==UNCOMPLETE:
			system.set_qb_entry_state(data().QB_002,COMPLETE)
		return True
	return False

	#for pc in system.get_pcs():
		#tents += objects.count_in_inventory(pc,"SET_TENT_CANVAS")
		#waterdetectors += objects.count_in_inventory(pc,"SET_WATER_DETECTOR")

	#print "[ counted (",str(tents),"/4) tents and (",str(waterdetectors),"/4) water detectors ]"
	#if (tents >= 4) and (waterdetectors >= 4):

#def checkQuestDoctorGeneral():
#	if objects.exists("FRANKLIN"):
#		if objects.get_distance("FRANKLIN","GENERAL_LEWIS") <= 25.0:
#			data("zone_3.zone_3").franklin_folgt = False
#			objects.set_attribute("FRANKLIN","zone_transfer",False)
#			system.set_qb_entry_state(data().QB_003,COMPLETE)

def checkQuestSchrottGeneral():
	if objects.is_destroyed("MUSTAFA"):
		if system.get_qb_entry_state(data().QB_001)==UNCOMPLETE:
			system.set_qb_entry_state(data().QB_001,COMPLETE)

#[NM]Dialog 023: Spieler liest Steckbrief
def initDlg_023_Steckbriefe():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_023')
	dialog.add_text(text='D_023_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_023_Ende)
	dialog.start(True, data().QB_017)
	
def onDlg_023_Ende():
	if system.get_qb_entry_state(data().QB_017) in [INACTIVE]:
		if not system.get_qb_entry_state(data().QB_008) in [UNCOMPLETE, COMPLETE]:
			system.set_qb_entry_state(data().QB_017, UNCOMPLETE)

#[NM]Dialog 020: Verwunderung über komische Leichen
#def initDlg_Schattenleiche():
def initDlg_020_VerwundertUeberLeiche():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_020')
	#Wenn Schatten schon aus Zone 3 bekannt, sonst anderer Text
	if hasattr(data("shadow_info"), "know_shadows") and data("shadow_info").know_shadows:
		dialogText = "D_066_T_001"
	else:
		dialogText = "D_020_T_001"

	dialog.add_text(text=dialogText, speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[M]Dialog 036: Zachary bittet den Spieler darum seinen Ghettoblaster zu reparieren.
#def initDlg_Blaster_rep():
def initDlg_036_ZacharyBittetSpielerUmHilfe():
	onDlg_036_marker()
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_036')
	dialog.add_text(text='D_036_T_001', speaker="ZACHARY", follower='D_036_C_001')
	dialog.add_choice(text='D_036_C_001_1', follower='D_036_T_002')
	dialog.add_choice(text='D_036_C_001_2', follower='ENDDIALOG')
	dialog.add_text(text='D_036_T_002', speaker="ZACHARY", follower='D_036_C_002')
	dialog.add_choice(text='D_036_C_002_1', follower='D_036_T_003')
	dialog.add_choice(text='D_036_C_002_2', follower='ENDDIALOG')
	dialog.add_text(text='D_036_T_003', speaker="ZACHARY", follower='D_036_T_005')
	dialog.add_text(text='D_036_T_005', speaker="ALTER_EGO", follower='D_036_T_006')
	dialog.add_text(text='D_036_T_006', speaker="ZACHARY", follower='D_036_C_003')

	if data().C_003_2:
		dialog.add_choice(text='D_036_C_003_1', follower='D_036_T_009')
		dialog.add_choice(text='D_036_C_003_3', follower='D_036_T_007', callback=Lambda('data().C_003_3 = True'))
	elif data().C_003_3:
		dialog.add_choice(text='D_036_C_003_1', follower='D_036_T_009')
		dialog.add_choice(text='D_036_C_003_2', follower='D_036_T_008', callback=Lambda('data().C_003_2 = True'))
	elif data().C_003_3 and data().C_003_2:
		dialog.add_choice(text='D_036_C_003_1', follower='D_036_T_009')
	else:
		dialog.add_choice(text='D_036_C_003_1', follower='D_036_T_009')
		dialog.add_choice(text='D_036_C_003_2', follower='D_036_T_008', callback=Lambda('data().C_003_2 = True'))
		dialog.add_choice(text='D_036_C_003_3', follower='D_036_T_007', callback=Lambda('data().C_003_3 = True'))

	dialog.add_text(text='D_036_T_007', speaker="ZACHARY", follower='D_036_C_003')
	dialog.add_text(text='D_036_T_008', speaker="ZACHARY", follower='D_036_C_003')
	dialog.add_text(text='D_036_T_009', speaker="ZACHARY", follower='D_036_C_004')

	dialog.add_choice(text='D_036_C_004_1', follower='D_036_T_010')
	dialog.add_choice(text='D_036_C_004_2', follower='ENDDIALOG')
	dialog.add_text(text='D_036_T_010', speaker="ZACHARY", follower='ENDDIALOG', callback=onDlg_036_Ende)
	dialog.start(False, data().QB_006)

def onDlg_036_marker():
	if not data().player_knows_zachary:
		data().player_knows_zachary = True
		system.add_minimap_marker(342.73, 664.17,"MM_008")#Zachary

def onDlg_036_Ende():
	objects.create_item_in_inventory("ALTER_EGO", QI_BLASTER[0], id=QI_BLASTER[1])
	objects.set_attribute(object=QI_BLASTER[1], attribute="generic_item", value=False)
	data().Ghettoblaster_Defekt=True
	system.set_qb_entry_state(data().QB_006,UNCOMPLETE)

#[NM]Dialog 037: Zachary will seinen Ghettoblaster wieder haben.
#def initDlg_Blaster_inrep():
def initDlg_037_ZacharyWillBlasterWiederHaben():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_037')
	dialog.add_text(text='D_037_T_001', speaker="ZACHARY", follower='D_037_T_002')
	dialog.add_text(text='D_037_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_006)

#[NM/CS]Dialog 038: Der Spieler gib Zachary seinen Ghettoblaster wieder.
def initCutscene_038_SpielerGibtZacharyBlasterZurueck():
	system.start_cutscene()
	pos = objects.get_position("ZACHARY")
	objects.move_to("ALTER_EGO",pos[0]-1.0,pos[1]-0.75,"landscape",MT_SLOW)
	prohibit_activity("ZACHARY", False)
	objects.turn_to_object("ALTER_EGO","ZACHARY",callback=["ONEND",onDlg_038_StartDialog])
	objects.turn_to_object("ZACHARY","ALTER_EGO")

def onDlg_038_StartDialog(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_038')
	dialog.add_text(text='D_038_T_001', speaker="ALTER_EGO", follower='D_038_T_002', callback=Lambda('set_conversation("ZACHARY","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_038_T_002', speaker="ZACHARY", follower='D_038_T_003', callback=Lambda('set_conversation("ALTER_EGO","ZACHARY",mode="close")'))
	dialog.add_text(text='D_038_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_038_Ende)
	dialog.start(True, data().QB_006)

def onDlg_038_Ende():
	end_cutscene(chars=["ALTER_EGO", "ZACHARY"])
	data().Zachary_dank2 = True
	if enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = QI_BLASTERFIXED[1]):
		objects.transfer_item(enemy_script.get_next_transfer_partner("ZACHARY",QI_BLASTERFIXED[1]),QI_BLASTERFIXED[1],"ZACHARY")
	elif enemy_script.count_party_inventory(area = 15, object_id = "ZACHARY", items = "SET_REPAIRED_GHETTOBLASTER"):
		objects.transfer_item(enemy_script.get_next_transfer_partner("ZACHARY","SET_REPAIRED_GHETTOBLASTER"),"SET_REPAIRED_GHETTOBLASTER","ZACHARY")
	objects.create_item_in_inventory("ALTER_EGO", "SET_COFFEE_BEANS")
	objects.create_item_in_inventory("ALTER_EGO", "SET_COFFEE_BEANS")
	system.set_qb_entry_state(data().QB_006,COMPLETE)
	
	character.add_experience_party(data().Exp_Ghettoblaster)
	allow_activity("ZACHARY")

#[M]Dialog 039: Zachary bedankt sich für die Hilfe.
def initDlg_039_ZacharyBedanktSich():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_039')
	dialog.add_text(text='D_039_T_001', speaker="ZACHARY", follower='D_039_C_001')
	if system.get_qb_entry_state(data().QB_018) == INACTIVE:
		dialog.add_choice(text='D_039_C_001_1', order=3, follower='D_039_T_002')
	dialog.add_choice(text='D_039_C_001_3', order=1, follower='ENDDIALOG')
	dialog.add_text(text='D_039_T_002', speaker="ZACHARY", follower='D_039_C_001', callback=Lambda('dialog.add_choice(text="D_039_C_001_2", order=2, follower="D_039_T_003")'))
	dialog.add_text(text='D_039_T_003', speaker="ZACHARY", follower='D_039_C_001', callback=onDlg_039_Ende1 ) #Lambda('global_defines.set_zone_enabled("sqzone_5", True)'))
	#, Lambda(system.set_qb_entry_state(data().QB_018, UNCOMPLETE)))
	dialog.start(False, data().QB_018)
	
def onDlg_039_Ende1():
	if not is_zone_enabled('sqzone_5'):
		character.add_experience_party(50)
	global_defines.set_zone_enabled("sqzone_5", True)
	if system.get_qb_entry_state(data().QB_018) != COMPLETE:
		system.set_qb_entry_state(data().QB_018, UNCOMPLETE)
	
#[M]Dialog 059: Der Spieler gib Zachary Solarzelle und Ghettoblaster.
def initDlg_059_Zellen_Blaster():
	prohibit_activity("ZACHARY")
	pos = objects.get_position("ZACHARY")
	objects.move_to("ALTER_EGO",pos[0]-1.0,pos[1]-0.75,"landscape",MT_SLOW)
	objects.turn_to_object("ALTER_EGO","ZACHARY",callback=["ONEND",onDlg_059_StartDialog])

def onDlg_059_StartDialog(id):
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_059')
	dialog.add_text(text='D_059_T_001', speaker="ALTER_EGO", follower='D_059_T_002')
	dialog.add_text(text='D_059_T_002', speaker="ZACHARY")
	if object_events.get_speech_skill("ALTER_EGO") > 75:
		dialog.add_choice(text='D_059_C_001_1', follower='D_059_T_003')
	else:
		dialog.add_choice(text='D_059_C_001_1', follower='D_059_T_004')
	
	dialog.add_choice(text='D_059_C_001_2', follower='ENDDIALOG', callback=onDlg_059_Ende)

	dialog.add_text(text='D_059_T_003', speaker="ZACHARY", follower='ENDDIALOG', callback=onDlg_059_Ende_Extra)	# [BrainRipper]
	dialog.add_text(text='D_059_T_004', speaker="ZACHARY", follower='ENDDIALOG', callback=onDlg_059_Ende)		# [BrainRipper]
	dialog.start(False, data().QB_006)

def onDlg_059_Ende_Extra():
	objects.create_item_in_inventory("ALTER_EGO", "SET_COFFEE_BEANS")
	onDlg_059_Ende()
	
def onDlg_059_Ende():
	objects.create_item_in_inventory("ALTER_EGO", "SET_COFFEE_BEANS")
	system.set_qb_entry_state(data().QB_006,COMPLETE)
	character.add_experience_party(data().Exp_Ghettoblaster)
	system.set_qb_entry_text(data().QB_006,id_reward="ZONE5_AIM_06_REWARD_MIN")
	allow_activity("ZACHARY")

#[NM]Dialog 040: Zachary ist sauer, dass der Spieler ihm nicht geholfen hat.
def initDlg_040_Zachary_ist_sauer():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_040')
	dialog.add_text(text='D_040_T_001', speaker="ZACHARY", follower='ENDDIALOG')
	dialog.start(True, data().QB_006)

#[M]Dialog 024: Nicholas gibt Infos zu den Bestien.
def initDlg_024_NicholasGibtInfosZuBestien():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_024')
	if data().ERSTE_ODER_ZWEITE_C_001:
		if data().Poster_gelesen:
			dialog.add_choice(text='D_024_C_001_2', follower='D_024_T_006')
			dialog.add_choice(text='D_024_C_001_3', follower='ENDDIALOG')
		else:
			dialog.add_choice(text='D_024_C_001_3', follower='ENDDIALOG')
	else:
		if data().Poster_gelesen:
			dialog.add_choice(text='D_024_C_001_1', follower='D_024_T_001')
			dialog.add_choice(text='D_024_C_001_2', follower='D_024_T_006')
			dialog.add_choice(text='D_024_C_001_3', follower='ENDDIALOG')
		else:
			dialog.add_choice(text='D_024_C_001_1', follower='D_024_T_001')
			dialog.add_choice(text='D_024_C_001_3', follower='ENDDIALOG')

	dialog.add_text(text='D_024_T_001', speaker="NICHOLAS")
	dialog.add_text(text='D_024_T_002', speaker="NICHOLAS")
	dialog.add_text(text='D_024_T_003', speaker="NICHOLAS", follower='D_024_C_002')
	dialog.add_choice(text='D_024_C_002_1', follower='D_024_T_004')
	dialog.add_choice(text='D_024_C_002_2', follower='D_024_C_001', callback=Lambda('data().ERSTE_ODER_ZWEITE_C_001 = True'))
	dialog.add_text(text='D_024_T_004', speaker="NICHOLAS")
	dialog.add_text(text='D_024_T_005', speaker="ALTER_EGO", follower='D_024_C_001', callback=Lambda('data().ERSTE_ODER_ZWEITE_C_001 = True'))
	dialog.add_text(text='D_024_T_006', speaker="NICHOLAS")
	dialog.add_text(text='D_024_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_024_T_008', speaker="NICHOLAS")
	dialog.add_text(text='D_024_T_009', speaker="ALTER_EGO")
	dialog.add_text(text='D_024_T_010', speaker="NICHOLAS")
	dialog.add_text(text='D_024_T_011', speaker="NICHOLAS", follower='D_024_T_013')
	dialog.add_text(text='D_024_T_013', speaker="NICHOLAS")
	dialog.add_text(text='D_024_T_014', speaker="ALTER_EGO")
	dialog.add_text(text='D_024_T_015', speaker="NICHOLAS", follower='D_024_C_003')
	dialog.add_choice(text='D_024_C_003_1', follower='D_024_T_016')
	dialog.add_choice(text='D_024_C_003_2', follower='D_024_T_017')
	dialog.add_text(text='D_024_T_016', speaker="NICHOLAS", follower='ENDDIALOG', callback=[Lambda('data().INFOS_UEBER_BESTIEN_ERHALTEN=True'),
												Lambda('system.set_qb_entry_state(data().QB_008,UNCOMPLETE)'),
												Lambda('system.set_qb_entry_state(data().QB_017,INACTIVE)')])
	dialog.add_text(text='D_024_T_017', speaker="NICHOLAS", follower='ENDDIALOG', callback=[Lambda('data().INFOS_UEBER_BESTIEN_ERHALTEN=True'),Lambda('data().SPIELER_JAGT_BESTIEN_NICHT = True')])
	onDlg_024_marker()
	dialog.start(False, data().QB_017)

def onDlg_024_marker():
	if not data().player_knows_nicholas:
		data().player_knows_nicholas = True
		system.add_minimap_marker(278.04, 723.79,"MM_002")# Nicholas
	
#[NM]Dialog 025: Nicholas hat keine weiteren Infos mehr; gute Jagd
def initDlg_025_NicolasHatKeineWeiterenInfos():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_025')
	if data().SPIELER_JAGT_BESTIEN_NICHT:
		dialog.add_text(text='D_025_T_001', speaker="NICHOLAS", follower='ENDDIALOG', callback = Dlg_025_Ende)
	if not data().SPIELER_JAGT_BESTIEN_NICHT:
		dialog.add_text(text='D_025_T_002', speaker="NICHOLAS", follower='ENDDIALOG')
	dialog.start(True, data().QB_017)

def Dlg_025_Ende():
	if system.get_qb_entry_state(data().QB_017) == INACTIVE:
		if system.get_qb_entry_state(data().QB_008) == INACTIVE:
			group = system.get_pcs()
			for i in range(1,6):
				for char in group:
					if objects.count_in_inventory(char, QI_WARGHEAD[1]+"_"+str(i)):
						system.set_qb_entry_state(data().QB_008, UNCOMPLETE)
						data().SPIELER_JAGT_BESTIEN_NICHT = False
						return

#[M] Dialog 026: Spieler holt sich Kopfgeld (1).
#def initDlg_Spieler_holt_sich_Kopfgeld1():
def initDlg_026_SpielerHoltKopfgeld_1():
	data().Kopfgeld_fuer_Schaedel+=1
	# data().Kopfe += 1
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_026')
	dialog.add_text(text='D_026_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_026_T_002', speaker="NICHOLAS", follower='D_026_C_001')
	dialog.add_choice(text='D_026_C_001_1', follower='D_026_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_BOTTLE_OF_GAS")'))
	dialog.add_choice(text='D_026_C_001_2', follower='D_026_T_003', callback=
		[Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")'),
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")')])
	dialog.add_choice(text='D_026_C_001_3', follower='D_026_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_WATER_SKIN")'))
	dialog.add_choice(text='D_026_C_001_4', follower='D_026_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_GRAINS")'))
	dialog.add_text(text='D_026_T_003', speaker="NICHOLAS", follower='ENDDIALOG')
	dialog.start(True, data().QB_017)


#[M] Dialog 047: Spieler holt sich Kopfgeld (2).
#def initDlg_Spieler_holt_sich_Kopfgeld2():
def initDlg_047_SpielerHoltKopfgeld_2():
	data().Kopfgeld_fuer_Schaedel+=1
	# data().Kopfe += 1
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_047')
	dialog.add_text(text='D_047_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_047_T_002', speaker="NICHOLAS", follower='D_047_C_001')
	dialog.add_choice(text='D_047_C_001_1', follower='D_047_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_BOTTLE_OF_GAS")'))
	dialog.add_choice(text='D_047_C_001_2', follower='D_047_T_003', callback=
		[Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")'),
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")')])
	dialog.add_choice(text='D_047_C_001_3', follower='D_047_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_WATER_SKIN")'))
	dialog.add_choice(text='D_047_C_001_4', follower='D_047_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_GRAINS")'))
	dialog.add_text(text='D_047_T_003', speaker="NICHOLAS", follower='ENDDIALOG')
	dialog.start(True, data().QB_017)

#[M] Dialog 029: Spieler holt sich Kopgeld (3).
#def initDlg_Spieler_holt_sich_Kopfgeld3():
def initDlg_029_SpielerHoltKopfgeld_3():
	data().Kopfgeld_fuer_Schaedel+=1
	# data().Kopfe += 1
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_029')
	dialog.add_text(text='D_029_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_029_T_002', speaker="NICHOLAS", follower='D_029_C_001')
	dialog.add_choice(text='D_029_C_001_1', follower='D_029_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_BOTTLE_OF_GAS")'))
	dialog.add_choice(text='D_029_C_001_2', follower='D_029_T_003', callback=
		[Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")'),
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")')])
	dialog.add_choice(text='D_029_C_001_3', follower='D_029_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_WATER_SKIN")'))
	dialog.add_choice(text='D_029_C_001_4', follower='D_029_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_GRAINS")'))
	dialog.add_text(text='D_029_T_003', speaker="NICHOLAS", follower='D_029_T_004')
	dialog.add_text(text='D_029_T_004', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_017)

#[M] Dialog 049: Spieler holt sich Kopgeld (4).
#def initDlg_Spieler_holt_sich_Kopfgeld4():
def initDlg_049_SpielerHoltKopfgeld_4():
	data().Kopfgeld_fuer_Schaedel+=1
	# data().Kopfe += 1
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_049')
	dialog.add_text(text='D_049_T_001', speaker="NICHOLAS", follower='D_049_C_001')
	dialog.add_choice(text='D_049_C_001_1', follower='D_049_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_BOTTLE_OF_GAS")'))
	dialog.add_choice(text='D_049_C_001_2', follower='D_049_T_003', callback=
		[Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")'),
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")')])
	dialog.add_choice(text='D_049_C_001_3', follower='D_049_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_WATER_SKIN")'))
	dialog.add_choice(text='D_049_C_001_4', follower='D_049_T_003', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_GRAINS")'))
	dialog.add_text(text='D_049_T_003', speaker="NICHOLAS", follower='ENDDIALOG')
	dialog.start(True, data().QB_017)

#[M]Dialog 048: Spieler holt sich Kopfgeld (5).
#def initDlg_Spieler_holt_sich_Kopfgeld5():
def initDlg_048_SpielerHoltKopfgeld_5():
	data().Kopfgeld_fuer_Schaedel+=1
	# data().Kopfe += 1
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_048')
	dialog.add_text(text='D_048_T_001', speaker="NICHOLAS")
	dialog.add_text(text='D_048_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_048_T_003', speaker="NICHOLAS", follower='D_048_C_001')
	dialog.add_choice(text='D_048_C_001_1', follower='D_048_T_004', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_BOTTLE_OF_GAS")'))
	dialog.add_choice(text='D_048_C_001_2', follower='D_048_T_004', callback=
		[Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")'),
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")')])
	dialog.add_choice(text='D_048_C_001_3', follower='D_048_T_004', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_WATER_SKIN")'))
	dialog.add_choice(text='D_048_C_001_4', follower='D_048_T_004', callback=
		Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_GRAINS")'))
	dialog.add_text(text='D_048_T_004', speaker="NICHOLAS", follower='D_048_T_005')
	dialog.add_text(text='D_048_T_005', speaker="NICHOLAS", follower='D_048_T_006')
	dialog.add_text(text='D_048_T_006', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_Sekte_aktivieren)
	dialog.start(True, data().QB_017)

#[M]Dialog 081: Spieler hat mehrere Wargköpfe dabei
def initDlg_081_SpielerHatMehrere():
	# print 'data().NumberOfHeads', data().NumberOfHeads
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_081')
	dialog.add_text(text='D_081_T_001', speaker="NICHOLAS")
	#print ">data().headsAtBeginning",data().headsAtBeginning
	if data().NumberOfHeads == 2:
		dialog.add_text(text='D_081_T_002', speaker="ALTER_EGO")
	elif data().NumberOfHeads == 3:
		dialog.add_text(text='D_081_T_003', speaker="ALTER_EGO")
	elif data().NumberOfHeads == 4:
		dialog.add_text(text='D_081_T_004', speaker="ALTER_EGO")
	elif data().NumberOfHeads == 5:
		dialog.add_text(text='D_081_T_005', speaker="ALTER_EGO")
	
	dialog.add_text(text='D_081_T_006', speaker="NICHOLAS")
	
	if data().NumberOfHeads <= 1:
		dialog.add_choice(text='D_081_C_001_1', follower='D_081_T_008', callback=[
			Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_BOTTLE_OF_GAS")'),
			NumberOfHeadsMinusOne,
			FirstTimeDlg081], auto_deactivation='none')
	else:
		dialog.add_choice(text='D_081_C_001_1', follower='ENDDIALOG', callback=[
			Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_BOTTLE_OF_GAS")'),
			NumberOfHeadsMinusOne,
			RestartDlg081], auto_deactivation='none')
	
	if data().NumberOfHeads <= 1:
		dialog.add_choice(text='D_081_C_001_2', follower='D_081_T_008', callback=[
			Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")'),
			Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")'),
			NumberOfHeadsMinusOne,
			FirstTimeDlg081], auto_deactivation='none')
	else:
		dialog.add_choice(text='D_081_C_001_2', follower='ENDDIALOG', callback=[
			Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")'),
			Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_MEAT_RAW")'),
			NumberOfHeadsMinusOne,
			RestartDlg081], auto_deactivation='none')
	
	if data().NumberOfHeads <= 1:
		dialog.add_choice(text='D_081_C_001_3', follower='D_081_T_008', callback=[
			Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_WATER_SKIN")'),
			NumberOfHeadsMinusOne,
			FirstTimeDlg081], auto_deactivation='none')
	else:
		dialog.add_choice(text='D_081_C_001_3', follower='ENDDIALOG', callback=[
			Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_WATER_SKIN")'),
			NumberOfHeadsMinusOne,
			RestartDlg081], auto_deactivation='none')
			
	if data().NumberOfHeads <= 1:
		dialog.add_choice(text='D_081_C_001_4', follower='D_081_T_008', callback=[
			Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_GRAINS")'),
			NumberOfHeadsMinusOne,
			FirstTimeDlg081], auto_deactivation='none')
	else:
		dialog.add_choice(text='D_081_C_001_4', follower='ENDDIALOG', callback=[
			Lambda('objects.create_item_in_inventory("ALTER_EGO", "SET_GRAINS")'),
			NumberOfHeadsMinusOne,
			RestartDlg081], auto_deactivation='none')
			
	if data().Kopfe == 5:
		dialog.add_text(text='D_081_T_008', speaker="NICHOLAS", follower='D_081_T_010')
	else:
		dialog.add_text(text='D_081_T_008', speaker="NICHOLAS", follower='D_081_T_009')
		
	dialog.add_text(text='D_081_T_009', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.add_text(text='D_081_T_010', speaker="NICHOLAS")
	dialog.add_text(text='D_081_T_011', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_Sekte_aktivieren) #
	
	if not data().FirstTimeDlg081:
		dialog.jump_to('D_081_C_001')
	
	if data().Kopfe == 5:
		dialog.start(False, data().QB_017)
	else:
		dialog.start(False, data().QB_017)

def NumberOfHeadsMinusOne():
	data().Kopfgeld_fuer_Schaedel += 1
	data().NumberOfHeads = data().NumberOfHeads - 1
	#print "[NUMBEROFHEADS: ", data().NumberOfHeads, " ]"
	
def FirstTimeDlg081():
	data().FirstTimeDlg081 = False
	#print "[FIRSTTIMEDLG081: ", data().FirstTimeDlg081, " ]"
	
def RestartDlg081():
	FirstTimeDlg081()
	#print "[RESTARTDLG081: ", data().FirstTimeDlg081, " ]"
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_081')
	dialog.add_text(text='D_081_T_007', speaker="NICHOLAS", follower = 'ENDDIALOG', callback = initDlg_081_SpielerHatMehrere)
	dialog.start()
	
def onDlg_Sekte_aktivieren():
	if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_008,COMPLETE)
	if ((not data().Sekte_Ausgerottet1) and (not data().Sekte_Ausgerottet)):
		system.set_qb_entry_state(data().QB_005,UNCOMPLETE)
	else:
		system.set_qb_entry_state(data().QB_005,INACTIVE)
	for char in NPC_SEKTE:
		objects.set_active_state(char,ACTIVE)
	objects.set_active_state("SECTARIAN",ACTIVE)
	objects.set_active_state("OLIVIA",ACTIVE)
	#if data().player_knows_station_im_wald:
	if not data().Sekte_Tod1:
		system.notify_region_entered(region="REGION_RITUAL",partyid="UISPIELER")
		system.notify_region_entered(region="REGION_RITUAL_2",partyid="UISPIELER")
		system.notify_region_entered(region="REGION_OLIVIA_1",partyid="UISPIELER")

#[NM]Dialog 051: Nicholas ist nicht mehr am Spieler interessiert.
def initDlg_051_NicholasWillNixMehrVonSpieler():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_051')
	dialog.add_text(text='D_051_T_001', speaker="NICHOLAS", follower='ENDDIALOG')
	dialog.start(True, data().QB_017)

#[M]Dialog 027: Spieler hat das Ritual gesehen und klärt Nicholas auf.
def initDlg_027_SpielerKlaertNicolasUeberRitualAuf():
	data().nicholasende = 1
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_027')
	dialog.add_text(text='D_027_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_027_T_002', speaker="NICHOLAS", follower='D_027_C_001')
	dialog.add_choice(text='D_027_C_001_1', follower='D_027_T_003')
	dialog.add_choice(text='D_027_C_001_2', follower='D_027_T_008')
	dialog.add_text(text='D_027_T_003', speaker="NICHOLAS")
	dialog.add_text(text='D_027_T_004', speaker="ALTER_EGO")
	dialog.add_text(text='D_027_T_005', speaker="NICHOLAS")
	dialog.add_text(text='D_027_T_006', speaker="ALTER_EGO")
	dialog.add_text(text='D_027_T_007', speaker="NICHOLAS", follower='ENDDIALOG')
	dialog.add_text(text='D_027_T_008', speaker="NICHOLAS")
	if object_events.get_speech_skill("ALTER_EGO") > 80:
		dialog.add_text(text='D_027_T_009', speaker="ALTER_EGO", follower='D_027_T_011')
	else:
		dialog.add_text(text='D_027_T_009', speaker="ALTER_EGO", follower='D_027_T_010')
	dialog.add_text(text='D_027_T_010', speaker="NICHOLAS", follower='ENDDIALOG')
	dialog.add_text(text='D_027_T_011', speaker="NICHOLAS", follower='ENDDIALOG', callback=onDlg_027_Ende)
	dialog.start(False, data().QB_017)
	
def onDlg_027_Ende():
	objects.create_item_in_inventory("NICHOLAS", "SET_M249")
	objects.transfer_item("NICHOLAS", "SET_M249", "ALTER_EGO")

#[NM]Dialog 017: Spieler verscheuchen
#def initDlg_Rowdies_Abwimmeln():
def initDlg_017_SpielerVerscheuchen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_017')
	dialog.add_text(text='D_017_T_00' + str(random.randint(1, 4)), speaker="BRANDON", follower='ENDDIALOG')
	dialog.start()

#[M]: Spieler will Brandon und seine Kumpels umlegen.
#def initDlg_Rowdies_Kampf():
def initDlg_018_SpielerWillBrandonUndCoUmlegen():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_018')
	dialog.add_text(text='D_018_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_018_T_002', speaker="BRANDON")
	dialog.add_choice(text='D_018_C_001', follower='ENDDIALOG', callback=onDlg_Rowdies_Kampf)
	dialog.add_choice(text='D_018_C_002', follower='ENDDIALOG', callback=Lambda('data().BrandonNeustart = True'))
	dialog.add_text(text='D_018_T_003', speaker="BRANDON", follower='D_018_C_001')
	
	if data().BrandonNeustart:
		dialog.jump_to('D_018_T_003')
	dialog.start(False, data().QB_004)

def onDlg_Rowdies_Kampf():
	objects.cancel_commandos("BRANDON")
	if not data().rowdies_bewaffnet:
		character.equip_direct( "BRANDON", equipment="SET_COLT_45", direct_ammo_load=True)
		character.equip_direct( "SCHLAEGER_1", equipment="SET_SPECIAL_38", direct_ammo_load=True)
		character.equip_direct( "SCHLAEGER_2", equipment="SET_SPECIAL_38", direct_ammo_load=True)
		character.equip_direct( "SCHLAEGER_3", equipment="SET_COLT_45", direct_ammo_load=True)
		data().rowdies_bewaffnet = True
	objects.set_attribute( "BRANDON", attribute="foes", value= ["UISPIELER"])
	objects.set_attribute( "SCHLAEGER_1", attribute="foes", value=["UISPIELER"])
	objects.set_attribute( "SCHLAEGER_2", attribute="foes", value=["UISPIELER"])
	objects.set_attribute( "SCHLAEGER_3", attribute="foes", value=["UISPIELER"])

#[M]Dialog 004: Erste Begegnung mit Mustafa
#def initDlg_Mustafa():
def initDlg_004_ErsteBegegnungMitMustafa():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_004')
	dialog.add_text(text='D_004_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_004_T_002', speaker="MUSTAFA", follower='D_004_C_001')

	dialog.add_choice(text='D_004_C_001_1', follower='D_004_T_007')
	dialog.add_choice(text='D_004_C_001_2', follower='D_004_T_004')
	dialog.add_choice(text='D_004_C_001_3', follower='D_004_T_003')

	dialog.add_text(text='D_004_T_003', speaker="MUSTAFA", follower='ENDDIALOG')	# [BrainRipper]
	dialog.add_text(text='D_004_T_004', speaker="MUSTAFA", follower='D_004_C_002')	# [BrainRipper]

	dialog.add_choice(text='D_004_C_002_1', follower='D_004_T_006')
	dialog.add_choice(text='D_004_C_002_2', follower='D_004_T_005')

	dialog.add_text(text='D_004_T_005', speaker="MUSTAFA", follower='ENDDIALOG', callback=onDlg_Mustafa_Kampf)
	dialog.add_text(text='D_004_T_006', speaker="MUSTAFA", follower='ENDDIALOG', callback=
		Lambda('data().Mustafa_ansprechen = 1'))
	dialog.add_text(text='D_004_T_007', speaker="MUSTAFA", follower='D_004_C_003')

	if not data().Bruch_Mit_Hayes:
		dialog.add_choice(text='D_004_C_003_1', follower='D_004_T_009')
	dialog.add_choice(text='D_004_C_003_2', follower='D_004_T_008')

	dialog.add_text(text='D_004_T_008', speaker="MUSTAFA", follower='ENDDIALOG', callback=
		Lambda('data().Mustafa_ansprechen = 1'))
	dialog.add_text(text='D_004_T_009', speaker="MUSTAFA", follower='ENDDIALOG', callback=
		Lambda('data().Mustafa_ansprechen = 1'))

	dialog.start()

#[NM]Dialog 041: Nix anfassen!
#def initDlg_erstes_betreten():
def initDlg_041_NixAnfassen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_041')
	dialog.add_text(text='D_041_T_001', speaker="MUSTAFA", follower='ENDDIALOG', callback=
		Lambda('data().erstes_betreten = True'))
	dialog.start()

def onDlg_Mustafa_Kampf():
	if not data().mustafas_bewaffnet:
		prohibit_activity("ALI")
		prohibit_activity("MEHMET")
		character.equip_direct( "MUSTAFA", equipment="SET_COLT_45" )
		character.equip_direct( "ALI", equipment="SET_SPECIAL_38" )
		character.equip_direct( "MEHMET", equipment="SET_SPECIAL_38" )
		data().mustafas_bewaffnet = True
	
	objects.set_attribute( "MUSTAFA", attribute="foes", value=["UISPIELER"])
	objects.set_attribute( "ALI", attribute="foes", value=["UISPIELER"])
	objects.set_attribute( "MEHMET", attribute="foes", value=["UISPIELER"])
	character.set_approachable_state("MUSTAFA", NOTAPPROACHABLE)
	character.set_approachable_state("ALI", NOTAPPROACHABLE)
	character.set_approachable_state("MEHMET", NOTAPPROACHABLE)
	# todo: AYSHA rennt ins haus

#[NM]Dialog 010: Der Spieler stellt fest, dass durch das Ableben Mustafas der Schottplatz jetzt der Regierung zur Verfügung steht
def initDlg_010_Mustafa_ist_killed():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_010')
	dialog.add_text(text='D_010_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_010_Ende)
	dialog.start(True, data().QB_001)

def onDlg_010_Ende():
	if ((system.get_qb_entry_state(data().QB_001) == INACTIVE and 
		system.get_qb_entry_state(data().QB_004) == UNCOMPLETE) or
		(system.get_qb_entry_state(data().QB_001) == UNCOMPLETE)):
		system.set_qb_entry_state(data().QB_001, COMPLETE)
		system.set_qb_entry_state(data().QB_004, INACTIVE)
	
#[NM]Dialog 005: Hau ab…
def initDlg_005_Hau_ab():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_005')
	dialog.add_text(text='D_005_T_001', speaker="MUSTAFA", follower='ENDDIALOG')
	dialog.start(True, [data().QB_001, data().QB_004])

#[M]Dialog 006: Spieler fordert Mustafa im Namen der Regierung auf sein Gelände zur Verfügung zu stellen
def initDlg_006_Aufforderung():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_006')
	dialog.add_text(text='D_006_T_001', speaker="MUSTAFA", follower='D_006_C_001')
	if not data().Bruch_Mit_Hayes:
		dialog.add_choice(text='D_006_C_001_1', follower='D_006_T_005')
	dialog.add_choice(text='D_006_C_001_2', follower='D_006_T_002')
	dialog.add_text(text='D_006_T_002', speaker="MUSTAFA", follower='ENDDIALOG', callback=onDlg_Mustafa_Kampf)
	dialog.add_text(text='D_006_T_005', speaker="MUSTAFA", follower='D_006_C_002')
	if object_events.get_speech_skill("ALTER_EGO") > 80:
		dialog.add_choice(text='D_006_C_002_1', follower='D_006_T_013')
	else:
		dialog.add_choice(text='D_006_C_002_1', follower='D_006_T_006')
	dialog.add_choice(text='D_006_C_002_2', follower='D_006_T_002')
	dialog.add_text(text='D_006_T_006', speaker="MUSTAFA", follower='D_006_T_007')
	dialog.add_text(text='D_006_T_007', speaker="ALTER_EGO", follower='D_006_T_010')
	dialog.add_text(text='D_006_T_010', speaker="MUSTAFA", follower='D_006_C_003')
	dialog.add_choice(text='D_006_C_003_1', follower='ENDDIALOG', callback=onDlg_006_Ende)
	if objects.is_destroyed("BRANDON"):
		dialog.add_choice(text='D_006_C_003_2', follower='D_006_T_012')
	dialog.add_choice(text='D_006_C_003_3', follower='D_006_T_011')
	dialog.add_text(text='D_006_T_011', speaker="MUSTAFA", follower='ENDDIALOG', callback=onDlg_Mustafa_Kampf)
	dialog.add_text(text='D_006_T_012', speaker="MUSTAFA", follower='D_006_T_004')
	dialog.add_text(text='D_006_T_004', speaker="ALTER_EGO", follower='D_006_T_009')
	dialog.add_text(text='D_006_T_009', speaker="MUSTAFA", follower='ENDDIALOG', callback=Lambda('system.set_qb_entry_state(data().QB_001,COMPLETE)'))
	dialog.add_text(text='D_006_T_013', speaker="MUSTAFA")
	dialog.add_text(text='D_006_T_014', speaker="ALTER_EGO")
	dialog.add_text(text='D_006_T_015', speaker="MUSTAFA", follower='ENDDIALOG', callback=Lambda('system.set_qb_entry_state(data().QB_001,COMPLETE)'))
	dialog.start(False, [data().QB_001, data().QB_004])

def onDlg_006_Ende():
	system.set_qb_entry_state(data().QB_001,INACTIVE)
	data().Ziel4 = True
	if data().rowdies_killed==4:
		system.set_qb_entry_state(data().QB_004,COMPLETE)
	else:
		system.set_qb_entry_state(data().QB_004,UNCOMPLETE)
	
#[NM]Dialog 007: Spieler auf aktive Quest aufmerksam machen
def initDlg_007_aufmerksam_machen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_007')
	dialog.add_text(text='D_007_T_001', speaker="MUSTAFA", follower='ENDDIALOG')
	dialog.start(True, [data().QB_001, data().QB_004])

#[NM/CS]Dialog 008: Der Spieler berichtet, wie er die Rowdies aufgemischt hat
def initCutscene_008_Rowdies_aufgemischt():
	start_cutscene()
	pos = objects.get_position("MUSTAFA")
	objects.move_to("ALTER_EGO",pos[0]+1.0,pos[1]+1.5,"landscape",MT_SLOW)
	objects.turn_to_object("ALTER_EGO","MUSTAFA",callback=["ONEND",onDlg_008_StartDialog])

def onDlg_008_StartDialog(id):
	objects.turn_to_object("MUSTAFA","ALTER_EGO")
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_008')
	dialog.add_text(text='D_008_T_001', speaker="MUSTAFA", callback=Lambda('set_conversation("ALTER_EGO","MUSTAFA",mode="medium")'))
	dialog.add_text(text='D_008_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("MUSTAFA","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_008_T_003', speaker="MUSTAFA", callback=Lambda('set_conversation("ALTER_EGO","MUSTAFA",mode="close")'))
	dialog.add_text(text='D_008_T_004', speaker="ALTER_EGO", callback=Lambda('set_conversation("MUSTAFA","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_008_T_005', speaker="MUSTAFA", follower='ENDDIALOG', callback=onDlg_008_Ende)
	dialog.start(True, [data().QB_001, data().QB_004])

def onDlg_008_Ende():
	end_cutscene(chars=["MUSTAFA","ALTER_EGO"])
	data().geloest1 = 1
	system.set_qb_entry_state(data().QB_001,COMPLETE)
	system.set_qb_entry_state(data().QB_004,INACTIVE)

#[NM]Dialog 009: Danke für die Hilfe, Kurs findet statt.
def initDlg_009_Rowdies_aufgemischt2():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_009')
	dialog.add_text(text='D_009_T_001', speaker="MUSTAFA", follower='ENDDIALOG')
	dialog.start(True, data().QB_001)

#[NM]Dialog 042: Spieler will irgendwas auf dem Schrottplatz nehmen
def initDlg_042_Spieler_Aufheben1():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_042')
	dialog.add_text(text='D_042_T_001', speaker="MUSTAFA", follower='ENDDIALOG', callback=
		Lambda('data().SPIELER_VORGEWARNT = True'))
	dialog.start()

#[NM]Dialog 043: Mustafa greift Spieler an
def initDlg_043_Spieler_Aufheben2():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_043')
	dialog.add_text(text='D_043_T_001', speaker="MUSTAFA", follower='ENDDIALOG', callback=onDlg_Mustafa_Kampf)
	dialog.start()

#[M]Dialog 053: Die Ratskulls haben Lindas und Ians Haus abgebrannt.
#def initDlg_Family():
def initDlg_053_RatskullsHabenHausNiederGebrannt():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_053')
	dialog.add_text(text='D_053_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_053_T_002', speaker="IAN")
	dialog.add_text(text='D_053_T_003', speaker="ALTER_EGO")

	if was_zone_entered("zone_3.zone_3"):
		if data("zone_3.zone_3").VonDonaldInfoWhg:
			dialog.add_text(text='D_053_T_004', speaker="IAN", follower='D_053_T_005')
		else:
			dialog.add_text(text='D_053_T_004', speaker="IAN", follower='D_053_T_016')
	else:
		dialog.add_text(text='D_053_T_004', speaker="IAN", follower='D_053_T_016')

	dialog.add_text(text='D_053_T_005', speaker="ALTER_EGO")
	dialog.add_text(text='D_053_T_008', speaker="IAN")
	dialog.add_text(text='D_053_T_009', speaker="ALTER_EGO")
	dialog.add_text(text='D_053_T_010', speaker="IAN", follower='D_053_C_001')

	dialog.add_choice(text='D_053_C_001_1', follower='D_053_T_012')
	import zone_5
	dialog.add_choice(text='D_053_C_001_2', follower='ENDDIALOG', callback=
		[Lambda('system.set_qb_entry_state(data().QB_011,UNCOMPLETE)'),zone_5.Familie_in_Zone3_bringen])#ende1
	dialog.add_choice(text='D_053_C_001_3', follower='D_053_T_015')

	dialog.add_text(text='D_053_T_012', speaker="IAN", follower='D_053_C_002')

	dialog.add_choice(text='D_053_C_002_1', follower='ENDDIALOG', callback=
		[Lambda('system.set_qb_entry_state(data().QB_011,UNCOMPLETE)'), Lambda('data().Familie_Bezahlung = True'), zone_5.Familie_in_Zone3_bringen])#ende1
	dialog.add_choice(text='D_053_C_002_2', follower='D_053_T_015')

	dialog.add_text(text='D_053_T_015', speaker="IAN", follower='ENDDIALOG', callback=
		onDlg_Familie_geht_alleine)# ende 2

	dialog.add_text(text='D_053_T_016', speaker="ALTER_EGO")
	dialog.add_text(text='D_053_T_017', speaker="IAN")
	dialog.add_text(text='D_053_T_018', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(False, data().QB_011)

def onDlg_Familie_geht_alleine():
	character.set_approachable_state("IAN",NOTAPPROACHABLE)
	character.set_approachable_state("PAULA",NOTAPPROACHABLE)
	character.set_approachable_state("LINDA",NOTAPPROACHABLE)
	system.set_qb_entry_state(data().QB_011,IMPOSSIBLE)
	objects.move_to("IAN", 326,713, "landscape",MT_SLOW,["ONEND",D1])
	objects.move_to("PAULA", 326,712, "landscape",MT_SLOW,["ONEND",D1])
	objects.move_to("LINDA", 326,714, "landscape",MT_SLOW,["ONEND",D1])
	
def D1(id):
	if id == "IAN":
		objects.move_to("IAN", 322,933, "landscape",MT_SLOW,["ONEND",Lambda('objects.set_active_state("IAN",INACTIVE)')])
	elif id == "PAULA":
		objects.move_to("PAULA", 323,816, "landscape",MT_FAST,["ONEND",D2])
	else:
		objects.move_to("LINDA", 322,933, "landscape",MT_SLOW,["ONEND",Lambda('objects.set_active_state("LINDA",INACTIVE)')])

def D2(id):
	objects.move_to("PAULA", 322,933, "landscape",MT_SLOW,["ONEND",Lambda('objects.set_active_state("PAULA",INACTIVE)')])


#[NM]Dialog 050: Spieler versucht mit Tizoc zu sprechen.
def initDlg_050_SpielerVersuchtTizocZuSprechen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_050')
	dialog.add_text(text='D_050_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	onDlg_021_marker()
	dialog.start()

#[NM/CS]Dialog 021: Der Spieler sagt dem Doktor die Zukunft voraus...
def initCutscene_021_SpielerSagtZukunftVoraus():
	system.start_cutscene()
	set_camera(CAMVIEW_TIZOC)
	init_cutscene("ALTER_EGO", "TIZOC", dx=1.0, dy=1.5)
	objects.turn_to_object("ALTER_EGO","TIZOC",callback=["ONEND",onDlg_021_StartDialog])
	

def onDlg_021_StartDialog(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_021')
	dialog.add_text(text='D_021_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("TIZOC","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_021_T_002', speaker="TIZOC", callback=Lambda('set_conversation("ALTER_EGO","TIZOC",mode="medium")'))
	dialog.add_text(text='D_021_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("TIZOC","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_021_T_004', speaker="TIZOC", callback=Lambda('set_conversation("ALTER_EGO","TIZOC",mode="close")'))
	dialog.add_text(text='D_021_T_005', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_Tizoc_Kampf)
	onDlg_021_marker()
	dialog.start(True, data().QB_007)

def onDlg_021_marker():
	if not data().player_knows_tizoc:
		data().player_knows_tizoc = True
		system.add_minimap_marker(675.89, 501.01,"MM_005")# Wissender des Waldes

def onDlg_Tizoc_Kampf():
	objects.set_immortal_state("TIZOC", False)
	if system.get_qb_entry_state(data().QB_010) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_010,COMPLETE)
	
	end_cutscene(chars=["ALTER_EGO", "TIZOC"])
	objects.cancel_commandos("TIZOC")
	objects.set_attribute( "TIZOC", attribute="foes", value=["UISPIELER"])
	character.equip_direct( "TIZOC", equipment="SET_SPECIAL_38" )
	objects.attack("TIZOC", "ALTER_EGO")

#[M]Dialog 076: Der Spieler liest in Tizocs Tagebuch.
def initDlg_076_Tagebuch():
	if system.get_qb_entry_state(data().QB_010) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_010,COMPLETE)
	
	if not objects.exists(QI_TAGEBUCH[1]):
		return True
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_076')
	
	# dialog should show tizocs face
	voice_id = None
	if objects.has_attribute( "ALTER_EGO", "voice_id" ):
		voice_id = objects.get_attribute( "ALTER_EGO", "voice_id" )
	
	objects.set_attribute(QI_TAGEBUCH[1], "voice_id", voice_id)
	objects.set_attribute(QI_TAGEBUCH[1], "dialog_face", "tizoc.png")
	
	dialog.add_text(text='D_076_T_001', speaker=QI_TAGEBUCH[1])
	dialog.add_text(text='D_076_T_002', speaker=QI_TAGEBUCH[1])
	dialog.add_text(text='D_076_T_003', speaker=QI_TAGEBUCH[1])
	dialog.add_text(text='D_076_T_004', speaker=QI_TAGEBUCH[1])
	dialog.add_text(text='D_076_T_005', speaker=QI_TAGEBUCH[1])
	dialog.add_text(text='D_076_T_006', speaker=QI_TAGEBUCH[1])
	dialog.add_text(text='D_076_T_007', speaker=QI_TAGEBUCH[1])
	dialog.add_text(text='D_076_T_008', speaker=QI_TAGEBUCH[1], follower='ENDDIALOG',callback=onDlg_076_Ende)
	dialog.start(True, data().QB_017)
	return None

def onDlg_076_Ende():
	objects.set_attribute("TIZOC","hitpoints",0)
	if (system.get_qb_entry_state(data().QB_005) == UNCOMPLETE):
		system.set_qb_entry_state(data().QB_005,INACTIVE)
	
#[NM]Dialog 035: Spieler stellt fest, dass hier wohl Tiere frei gelassen wurden.
#def initDlg_35_Kaefige_untersuchen():
def initDlg_035_SpielerUntersuchtKaefige():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_035')
	dialog.add_text(text='D_035_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[M]Dialog 001: General Lewis beauftragt/bittet den Spieler die Kurse möglich zu machen, Variante vor der Ratskulls-Zerschlagung
def initDlg_001_GeneralBrauchtSpielerRatskullsNichtBesiegt():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_001')
	if not data().d_001_restart_c_001:
		dialog.add_text(text='D_001_T_018', speaker="GENERAL_LEWIS", follower='D_001_C_001')
	dialog.add_choice(text='D_001_C_001_1', follower='D_001_T_003')
	dialog.add_choice(text='D_001_C_001_2', follower='D_001_T_001')
	dialog.add_choice(text='D_001_C_001_3', follower='ENDDIALOG', callback=onDlg_001_Ende1)
	dialog.add_text(text='D_001_T_001', speaker="GENERAL_LEWIS", follower='D_001_C_002')
	dialog.add_choice(text='D_001_C_002_1', follower='D_001_T_003')
	if data().d_001_c_002_3_sichtbar == 0:
		dialog.add_choice(text='D_001_C_002_2', follower='D_001_T_002', callback=Lambda('data().d_001_c_002_3_sichtbar = 1'))
	else:
		dialog.add_choice(text='D_001_C_002_3', follower='D_001_T_002')
	dialog.add_text(text='D_001_T_002', speaker="GENERAL_LEWIS", follower='ENDDIALOG', callback=onDlg_001_Ende1)
	dialog.add_text(text='D_001_T_003', speaker="GENERAL_LEWIS")
	dialog.add_text(text='D_001_T_004', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_005', speaker="GENERAL_LEWIS")
	dialog.add_text(text='D_001_T_006', speaker="GENERAL_LEWIS", follower='D_001_C_003')
	dialog.add_choice(text='D_001_C_003_1', follower='D_001_T_011')
	dialog.add_choice(text='D_001_C_003_2', follower='D_001_T_009')
	dialog.add_choice(text='D_001_C_003_3', follower='ENDDIALOG', callback=onDlg_001_060_Ende3)
	dialog.add_text(text='D_001_T_009', speaker="GENERAL_LEWIS", follower='D_001_C_004')
	dialog.add_text(text='D_001_T_011', speaker="GENERAL_LEWIS", follower='D_001_C_004')
	dialog.add_choice(text='D_001_C_004_1', follower='D_001_T_014')
	dialog.add_choice(text='D_001_C_004_2', follower='D_001_T_013')
	dialog.add_choice(text='D_001_C_004_3', follower='ENDDIALOG', callback=onDlg_001_060_Ende3)
	dialog.add_text(text='D_001_T_013', speaker="GENERAL_LEWIS", follower='D_001_C_004')
	dialog.add_text(text='D_001_T_014', speaker="GENERAL_LEWIS")
	dialog.add_text(text='D_001_T_015', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_016', speaker="GENERAL_LEWIS")
	dialog.add_text(text='D_001_T_017', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_001_060_Ende4)
	onDlg_001_marker()
	dialog.start(True, [data().QB_001, data().QB_002, data().QB_003])

def onDlg_001_marker():
	if not data().player_knows_glewis:
			data().player_knows_glewis = True
			system.add_minimap_marker(239.40, 777.47,"MM_003")# General Lewis

def onDlg_001_Ende1():
	data().d_001_restart_c_001 = True

def onDlg_001_060_Ende3():
	data().d_045_als_naechster = 1

def onDlg_001_060_Ende4():
	if not objects.is_destroyed("MUSTAFA"):
		system.set_qb_entry_state(data().QB_001,UNCOMPLETE)
	else:
		system.set_qb_entry_state(data().QB_001,COMPLETE)
	system.set_qb_entry_state(data().QB_002,UNCOMPLETE)
	system.set_qb_entry_state(data().QB_003,UNCOMPLETE)
#MOSEL
#[M]Dialog 060: General Lewis beauftragt/bittet den Spieler die Kurse möglich zu machen, Variante nach der Ratskulls-Zerschlagung
def initDlg_060_GeneralBrauchtSpielerRatskullsBesiegt():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_60')
	dialog.add_text(text='D_060_T_018', speaker="GENERAL_LEWIS")
	dialog.add_text(text='D_060_T_019', speaker="GENERAL_LEWIS")
	dialog.add_text(text='D_060_T_020', speaker="ALTER_EGO", follower='D_060_T_005')
	dialog.add_text(text='D_060_T_005', speaker="GENERAL_LEWIS")
	dialog.add_text(text='D_060_T_006', speaker="GENERAL_LEWIS", follower='D_060_C_003')
	dialog.add_choice(text='D_060_C_003_1', follower='D_060_T_011')
	dialog.add_choice(text='D_060_C_003_2', follower='D_060_T_009')
	dialog.add_choice(text='D_060_C_003_3', follower='ENDDIALOG', callback=onDlg_001_060_Ende3)
	dialog.add_text(text='D_060_T_009', speaker="GENERAL_LEWIS", follower='D_060_C_004')
	dialog.add_text(text='D_060_T_011', speaker="GENERAL_LEWIS", follower='D_060_C_004')
	if data().Bruch_Mit_Hayes:
		dialog.add_choice(text='D_060_C_004_1', follower='D_060_T_016')
	else:
		dialog.add_choice(text='D_060_C_004_1', follower='D_060_T_014')
	
	if data().D_060_C_004_2:
		dialog.add_choice(text='D_060_C_004_2', follower='D_060_T_013')
	
	dialog.add_choice(text='D_060_C_004_3', follower='ENDDIALOG', callback=onDlg_001_060_Ende3)
	dialog.add_text(text='D_060_T_013', speaker="GENERAL_LEWIS", follower='D_060_C_004', callback=Lambda('data().D_060_C_004_2 = False'))
	dialog.add_text(text='D_060_T_014', speaker="GENERAL_LEWIS", follower='D_060_T_016')
	dialog.add_text(text='D_060_T_016', speaker="GENERAL_LEWIS", follower='D_060_T_017')
	dialog.add_text(text='D_060_T_017', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_001_060_Ende4)
	onDlg_001_marker()
	dialog.start(True, [data().QB_001, data().QB_002, data().QB_003])

#[NM]Dialog 045: General Lewis ärgert sich, dass der Spieler ihm nicht geholfen hat
#def initDlg_Wesley_D_045():
def initDlg_045_GeneralAergertSichUeberSpieler():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_045')
	dialog.add_text(text='D_045_T_001', speaker="GENERAL_LEWIS", follower='ENDDIALOG')
	dialog.start()

#[NM/CS]Dialog 003: General Lewis bedankt sich beim Spieler für den Schrott
def initCutscene_003_GeneralBedanktSichFuerSchrott():
	start_cutscene()
	#set_camera(CAMVIEW_GENERAL)
	init_cutscene("ALTER_EGO", "GENERAL_LEWIS", dx=-1.3, dy=-1.0)
	objects.turn_to_object("ALTER_EGO","GENERAL_LEWIS",callback=["ONEND",onDlg_003_StartDialog])

def onDlg_003_StartDialog(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_003')
	dialog.add_text(text='D_003_T_001', speaker="ALTER_EGO", follower='D_003_T_002',callback=Lambda('set_conversation("GENERAL_LEWIS","ALTER_EGO",mode="far")'))
	if data().Mustafa_Tod :
		dialog.add_text(text='D_003_T_002', speaker="GENERAL_LEWIS", follower='D_003_T_003',callback=Lambda('set_conversation("ALTER_EGO","GENERAL_LEWIS",mode="medium")'))
	else:
		dialog.add_text(text='D_003_T_002', speaker="GENERAL_LEWIS", follower='D_003_T_007',callback=Lambda('set_conversation("ALTER_EGO","GENERAL_LEWIS",mode="medium")'))
	dialog.add_text(text='D_003_T_003', speaker="ALTER_EGO",callback=Lambda('set_conversation("GENERAL_LEWIS","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_003_T_004', speaker="GENERAL_LEWIS",callback=Lambda('set_conversation("ALTER_EGO","GENERAL_LEWIS",mode="close")'))
	dialog.add_text(text='D_003_T_005', speaker="ALTER_EGO",callback=Lambda('set_conversation("GENERAL_LEWIS","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_003_T_006', speaker="GENERAL_LEWIS",callback=Lambda('set_conversation("ALTER_EGO","GENERAL_LEWIS",mode="close")'))
	dialog.add_text(text='D_003_T_007', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_003_Ende1)
	dialog.start(False, data().QB_001)

def onDlg_003_Ende1():
	character.add_experience_party(250)
	end_cutscene()
	
	data().Wesley_Ziel1 = True
	if (data().Wesley_Ziel2 and data().Wesley_Ziel3):
		initDlg_016_GeneralBedanktSichFurArbeit()

#[M]Dialog 011: General Lewis bedankt sich beim Spieler für die Zelte und Wasserdetektoren
#def initDlg_Zelte_Wasser():
def initDlg_011_GeneralBedanktSichFuerZelteUndWasser():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_011')
	dialog.add_text(text='D_011_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_011_T_002', speaker="GENERAL_LEWIS", callback=onDlg_011_PlayerMoveToGeneral)## player move general
	dialog.add_text(text='D_011_T_003', speaker="GENERAL_LEWIS", follower='D_011_C_001')
	if not data().Bruch_Mit_Hayes:
		dialog.add_choice(text='D_011_C_001_1', follower='D_011_T_004')
	dialog.add_choice(text='D_011_C_001_2', follower='D_011_T_005')
	dialog.add_text(text='D_011_T_004', speaker="GENERAL_LEWIS", follower='ENDDIALOG', callback=onDlg_011_Ende1)
	dialog.add_text(text='D_011_T_005', speaker="GENERAL_LEWIS", follower='ENDDIALOG', callback=onDlg_011_Ende2)
	dialog.start(True, data().QB_002)

def onDlg_011_Ende1():
	character.add_experience_party(150)
	data().Wesley_Ziel2 = True
	if (data().Wesley_Ziel1 and data().Wesley_Ziel3):
			initDlg_016_GeneralBedanktSichFurArbeit()
	#onDlg_011_StartRecruitComment

def onDlg_011_Ende2():
	character.add_experience_party(150)
	data().Wesley_Ziel2 = True
	onDlg_Kiste_freischalten()
	if (data().Wesley_Ziel1 and data().Wesley_Ziel3):
			initDlg_016_GeneralBedanktSichFurArbeit()
			
def onDlg_011_PlayerMoveToGeneral():
	erg = enemy_script.count_party_inventory(area = 15, object_id = "GENERAL_LEWIS", items = ["SET_WATER_DETECTOR","SET_TENT_CANVAS"])
	if erg["SET_WATER_DETECTOR"] or erg["SET_TENT_CANVAS"]:
		onDlg_011_PutItemDown()

def onDlg_011_PutItemDown():
	count = enemy_script.count_party_inventory(area = 15, object_id = "GENERAL_LEWIS", items = ["SET_WATER_DETECTOR","SET_TENT_CANVAS"])
	while (count["SET_WATER_DETECTOR"] and (data().detectors_lay_down < 4)):
		data().detectors_lay_down += 1
		count["SET_WATER_DETECTOR"] -= 1
		objects.transfer_item(enemy_script.get_next_transfer_partner("GENERAL_LEWIS","SET_WATER_DETECTOR"),"SET_WATER_DETECTOR","GENERAL_LEWIS")

	while (count["SET_TENT_CANVAS"] and (data().tents_lay_down < 4)):
		data().tents_lay_down += 1
		count["SET_TENT_CANVAS"] -= 1
		objects.transfer_item(enemy_script.get_next_transfer_partner("GENERAL_LEWIS","SET_TENT_CANVAS"),"SET_TENT_CANVAS","GENERAL_LEWIS")


#[NM/CS]Dialog 012: General Lewis bedankt sich beim Spieler für den Doc
#def initDlg_DOC_Franklin():
def initCutscene_012_GeneralBedanktSichFuerDenDoc():
	start_cutscene()
	#set_camera(CAMVIEW_GENERAL)
	init_cutscene("ALTER_EGO", "GENERAL_LEWIS", dx=-1.4, dy=-1.4)
	objects.move_to("FRANKLIN", 237.22, 777.62,"landscape",MT_SLOW)	#pos[0]+1.4,pos[1]-1.4
	objects.turn_to_object("ALTER_EGO","GENERAL_LEWIS", callback=["ONEND",onDlg_012_StartDialog])
	objects.turn_to_object("FRANKLIN","GENERAL_LEWIS")

def onDlg_012_StartDialog(id):
	set_conversation("GENERAL_LEWIS","ALTER_EGO",mode="medium_deep")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_012')
	dialog.add_text(text='D_012_T_001', speaker="GENERAL_LEWIS", callback=Lambda('set_conversation("ALTER_EGO","GENERAL_LEWIS",mode="medium_deep")'))
	dialog.add_text(text='D_012_T_002', speaker="ALTER_EGO", callback=onDlg_012_DocMoveToGeneral)
	dialog.add_text(text='D_012_T_003', speaker="FRANKLIN", callback=Lambda('set_conversation("GENERAL_LEWIS","FRANKLIN",mode="close_deep")'))
	dialog.add_text(text='D_012_T_004', speaker="GENERAL_LEWIS", callback=Lambda('set_conversation("FRANKLIN","GENERAL_LEWIS",mode="close_deep")'))
	dialog.add_text(text='D_012_T_005', speaker="FRANKLIN", callback=onDlg_012_DocMoveAway)
	dialog.add_text(text='D_012_T_006', speaker="GENERAL_LEWIS", follower='ENDDIALOG', callback=onDlg_012_Ende1)
	dialog.start(True, [data().QB_003, data().QB_013])

def onDlg_012_Ende1():
	character.add_experience_party(200)
	end_cutscene(chars=["ALTER_EGO", "GENERAL_LEWIS"])
	data().Wesley_Ziel3 = True
	if (data().Wesley_Ziel1 and data().Wesley_Ziel2):
		initDlg_016_GeneralBedanktSichFurArbeit()
	system.set_qb_entry_state(data().QB_013,INACTIVE)
	system.set_qb_entry_state(data().QB_003,COMPLETE)

def onDlg_012_DocMoveAway():
	set_conversation("GENERAL_LEWIS","ALTER_EGO",mode="close_deep", first_obj='ALTER_EGO')
	## todo: ta für den doc starten
	objects.cancel_commandos("FRANKLIN")

def onDlg_012_DocMoveToGeneral():
	set_conversation("FRANKLIN","GENERAL_LEWIS",mode="medium_deep",first_obj='GENERAL_LEWIS')
	objects.cancel_commandos("ALTER_EGO")

#[M]Dialog 016: General Lewis bedankt sich beim Spieler dafür, dass er die Kurse möglich gemacht hat.
#def initDlg_016_Wesley_dankt():
def initDlg_016_GeneralBedanktSichFurArbeit():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_016')
	if data().ratstod == 1:
		dialog.add_text(text='D_016_T_001', speaker="GENERAL_LEWIS", follower='D_016_T_003')
	else:
		dialog.add_text(text='D_016_T_001', speaker="GENERAL_LEWIS", follower='D_016_T_002')
	dialog.add_text(text='D_016_T_002', speaker="GENERAL_LEWIS", follower='D_016_T_005')
	dialog.add_text(text='D_016_T_003', speaker="GENERAL_LEWIS", follower='D_016_T_004')
	dialog.add_text(text='D_016_T_004', speaker="ALTER_EGO", follower='ENDDIALOG')#ä, callback=onDlg_016_Ende1)
	dialog.add_text(text='D_016_T_005', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_016_Ende1)
	dialog.start(False)

def onDlg_016_Ende1():
	character.add_experience_party(300)
	for char in NPC_RECRUITS:
		character.set_approachable_state(char, NOTAPPROACHABLE)
		objects.set_active_state(char, 1)
		prohibit_activity(char)
		objects.move_to_object(char, "GENERAL_LEWIS", speed=MT_FAST)
	system.notify_timer(data().Timer_GeneralBefehltRekruten,random.randint(1,2)*data().Timervalue_GeneralBefehltRekruten)

#[NM]Dialog 013: General Lewis fordert den Spieler auf sich um die Aufträge zu kümmern
#def initDlg_Um_Kurse_kuemmern():
def initDlg_013_GeneralFordertSpielerAufZuArbeiten():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_013')
	dialog.add_text(text='D_013_T_001', speaker="GENERAL_LEWIS")
	dialog.add_text(text='D_013_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_001, data().QB_002, data().QB_003])

#[NM]Dialog 002: General Lewis gibt den Rekruten Befehle
def initDlg_002_GeneraGibtRekrutenBefehle():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_002')
	dialog.add_text(text='D_002_T_00' + str(random.randint(1, 5)), speaker="GENERAL_LEWIS", follower='ENDDIALOG',callback=onDlg_002_Ende)
	dialog.start()

def onDlg_002_Ende():
	system.notify_timer(data().Timer_GeneralBefehltRekruten,random.randint(1,2)*data().Timervalue_GeneralBefehltRekruten)

#[NM]Dialog 014: General Lewis fordert den Spieler auf, die Ratskulls zu vernichten
#def initDlg_014_rats_toeten():
def initDlg_014_GeneralFordertSpielerAufRatskullsZuToeten():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_014')
	dialog.add_text(text='D_014_T_001', speaker="GENERAL_LEWIS", follower='ENDDIALOG')
	dialog.start()

#[NM]Dailog 046: General Lewis bedankt sich beim Spieler für seine Hilfe (letztes default)
#def initDlg_046_letzte_kommentare():
def initDlg_046_GeneralDanktSpieler():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_046')
	dialog.add_text(text='D_046_T_00' + str(random.randint(1, 3)), speaker="GENERAL_LEWIS", follower='ENDDIALOG')
	dialog.start()

def onDlg_Kiste_freischalten():
	objects.create_item_in_inventory("BUILDING_3189",["SET_AMMOPACK_7_62NATO_MM","SET_AMMOPACK_7_62NATO_MM","SET_AMMOPACK_7_62NATO_MM","SET_STEEL_HELMET", "SET_STEEL_CLAD_BOOTS" ])

#[NM/CS]Dialog 028: Einleitung des Rituals
#def initDlg_028_Ritual_beginnt():
def initCutscene_028_Ritual_beginnt():
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_RITUAL_1)
	objects.cancel_commandos("ALTER_EGO")
	objects.set_position("ALTER_EGO",686.5,645.43)
	objects.move_to("ALTER_EGO",698.69,629.64,"landscape",MT_FAST, callback=["ONEND", onDlg_028_StartDialog])
	objects.turn_to_object("ALTER_EGO","SECT_PRIEST")

def onDlg_028_StartDialog(char_id):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_028')
	if ((system.get_qb_entry_state(data().QB_005) == UNCOMPLETE) or (system.get_qb_entry_state(data().QB_008) in [UNCOMPLETE,COMPLETE])):
		dialog.add_text(text='D_028_T_001', speaker="ALTER_EGO", follower='D_028_T_002', callback=Lambda('character.play_animation("SECT_PRIEST","CM_NPC_STEHEN_KONVERSATION_3")'))
	else:
		dialog.add_text(text='D_028_T_008', speaker="ALTER_EGO", follower='D_028_T_002', callback=Lambda('character.play_animation("SECT_PRIEST","CM_NPC_STEHEN_KONVERSATION_3")'))
	
	dialog.add_text(text='D_028_T_002', speaker="SECT_PRIEST")
	dialog.add_text(text='D_028_T_003', speaker="ALTER_EGO", callback=Lambda('character.play_animation("SECT_PRIEST","CM_NPC_STEHEN_KONVERSATION_2")'))
	dialog.add_text(text='D_028_T_004', speaker="SECT_PRIEST")
	dialog.add_text(text='D_028_T_005', speaker="ALTER_EGO", callback=Lambda('character.play_animation("SECT_PRIEST","CM_NPC_STEHEN_KONVERSATION_4")'))
	dialog.add_text(text='D_028_T_006', speaker="SECT_PRIEST")
	dialog.add_text(text='D_028_T_007', speaker="ALTER_EGO", follower='ENDDIALOG', callback=[
		Lambda('system.set_qb_entry_state(data().QB_007,UNCOMPLETE)'),
		Lambda('objects.move_to_object("SECT_PRIEST", OBJ_MARTERPFAHL, "dmyp_002")'),
		onDlg_028_Ritual_vorbereitung])
	dialog.start(False, data().QB_007)

def onDlg_028_Ritual_vorbereitung():
	objects.move_to("SEKTE_1", 721.01,641.31, "landscape",MT_SLOW)
	objects.turn_to_object("SEKTE_1","OLIVIA")
	objects.move_to("SEKTE_2", 719.58,642.20, "landscape",MT_SLOW)
	objects.turn_to_object("SEKTE_2","OLIVIA")
	objects.move_to("SEKTE_3", 718.34,642.19, "landscape",MT_SLOW)
	objects.turn_to_object("SEKTE_3","OLIVIA")
	objects.move_to("SEKTE_4", 717.09,641.19, "landscape",MT_SLOW, callback=["ONEND",
		Lambda('end_cutscene()')])
	objects.turn_to_object("SEKTE_4","OLIVIA")
	objects.move_to("SEKTE_5", 716.54,639.24, "landscape",MT_SLOW)
	objects.turn_to_object("SEKTE_5","OLIVIA")
	objects.turn_to_object("SECT_PRIEST","OLIVIA", callback=["ONEND", initDlg_074_PriesterVerhoehntOpfer])

#[NM/CS]Dialog 031: Der Priester beendet das Ritual.
def initDlg_031_Das_Erstechen():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_031')
	dialog.add_text(text='D_031_T_001', speaker="SECT_PRIEST")
	dialog.add_text(text='D_031_T_002', speaker="SECT_PRIEST", follower='ENDDIALOG', callback = on_dlg_031_ende_1)
	dialog.start(True, data().QB_007)

def on_dlg_031_ende_1():
	import zone_5
	zone_5.Sekte_Verschwindet(None)
	enemy_script.delay(4, Lambda('on_dlg_031_ende_2()'))
	
def on_dlg_031_ende_2():	
	system.set_qb_entry_state(data().QB_007,IMPOSSIBLE)
	system.set_qb_entry_state(data().QB_005,IMPOSSIBLE)
	data().Olivia_Erstochen = True
	system.fade(FADE_OUT, callback = on_dlg_031_ende_3)
	
def on_dlg_031_ende_3():
	for id in ["SEKTE_1","SEKTE_2","SEKTE_3","SEKTE_4","SEKTE_5","SECTARIAN", 'SECT_PRIEST']:
		objects.set_active_state(id, False)
	system.fade(FADE_IN)
	end_cutscene()

#[NM]Dialog 034: Spieler stellt fest, dass er das Opfer nicht verhindern konnte.
def initDlg_034_SpielerKonnteOpferNichtVerhindern():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_034')
	if data().Sekte_Tod1:
		dialog.add_text(text='D_034_T_001', speaker="ALTER_EGO")
		dialog.add_text(text='D_034_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('system.set_qb_entry_state(data().QB_009, UNCOMPLETE)'))
	else:
		dialog.add_text(text='D_034_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_007)

#[NM]Dialog 030: Der Priester fordert seine Jünger auf zu kämpfen.
#def initDlg_30_Sekte_hat_Spieler_entdeckt():
def initDlg_030_PriesterFordertJuengerAufZuKaempfen():
	if not objects.is_destroyed("SECT_PRIEST"):
		onDlg_030_StartDialog("SECT_PRIEST")
		#objects.cancel_commandos("SECT_PRIEST")
		#objects.turn_to_object("SECT_PRIEST","ALTER_EGO", callback=["ONEND",onDlg_030_StartDialog])
	else:
		onDlg_030_Sekte_Kampf()

def onDlg_030_StartDialog(id):
	onDlg_030_Sekte_Kampf()
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_030')
	dialog.add_text(text='D_030_T_001', speaker="SECT_PRIEST", follower='ENDDIALOG')
	dialog.start(True, data().QB_007)

def onDlg_030_Sekte_Kampf():
	for char in ["SECT_PRIEST","SEKTE_1","SEKTE_2","SEKTE_3","SEKTE_4","SEKTE_5", "SECTARIAN"]:
		if not objects.is_destroyed(char):
			if not objects.is_fighting(char):
				objects.cancel_commandos(char)
				if char == "SECT_PRIEST":
					objects.step_away("SECT_PRIEST")
				objects.set_attribute(char,"foes",["UISPIELER"])
				character.equip_direct(char,"SET_SPECIAL_38")
				objects.turn_to_object(char,"ALTER_EGO")
	data().Sekte_Tod1 = True

#[NM/CS]Dialog 033: Spieler befreit Olivia, Dank.
def initCutscene_033_Olivia_ist_gerettet():
	start_cutscene()
	set_camera(CAMVIEW_BEFREIUNG_OLIVIA_1)
	objects.move_to_object("ALTER_EGO", OBJ_MARTERPFAHL, dummy="dmyp_003", speed=MT_SLOW)
	objects.turn_to_object("ALTER_EGO","OLIVIA",callback=["ONEND",onDlg_033_MainCharFreesOlivia])

def onDlg_033_MainCharFreesOlivia(id):
	character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_OPFERUNG_BEFREIER_BEFREIUNG", callback=["ONEND",onDlg_033_OliviaFreed])

def onDlg_033_OliviaFreed(id):
	objects.step_away("ALTER_EGO")
	prohibit_activity("OLIVIA",False)
	objects.cancel_commandos("OLIVIA")
	character.play_animation("OLIVIA", "CM_NPC_STEHEN_OPFERUNG_OPFER_BEFREIUNG", callback=["ONEND",onDlg_033_OliviaFreeCamera])
	objects.move_to("ALTER_EGO",717.64,640.40,"landscape",MT_SLOW)
	objects.step_away("OLIVIA")
	objects.move_to("OLIVIA",718.36,639.0,"landscape",MT_SLOW)
	objects.turn_to_object("OLIVIA","ALTER_EGO")
	objects.turn_to_object("ALTER_EGO","OLIVIA")

def onDlg_033_OliviaFreeCamera(id):
	set_camera(CAMVIEW_BEFREIUNG_OLIVIA_1)
	initDlg_033_OliviaIstBefreit()

def initDlg_033_OliviaIstBefreit():
	data().Olivia_frei = True
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_033')
	dialog.add_text(text='D_033_T_001', speaker="OLIVIA", callback=Lambda('set_conversation("ALTER_EGO","OLIVIA",mode="medium")'))
	dialog.add_text(text='D_033_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("OLIVIA","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_033_T_003', speaker="OLIVIA", callback=Lambda('set_conversation("ALTER_EGO","OLIVIA",mode="close")'))
	dialog.add_text(text='D_033_T_004', speaker="ALTER_EGO", callback=Lambda('set_conversation("OLIVIA","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_033_T_005', speaker="OLIVIA")
	if not data().Sekte_Ausgerottet1:
		dialog.add_text(text='D_033_T_006', speaker="OLIVIA", callback=Lambda('set_conversation("ALTER_EGO","OLIVIA",mode="close")'))
		dialog.add_text(text='D_033_T_007', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_033_Ende)
		dialog.start(False, data().QB_007)
	if data().Sekte_Ausgerottet1:
		dialog.add_text(text='D_033_T_008', speaker="OLIVIA", follower='ENDDIALOG', callback=onDlg_033_Ende_1)
		dialog.start(False, data().QB_007)

def onDlg_033_Ende():
	system.set_qb_entry_state(data().QB_007,COMPLETE)
	system.set_qb_entry_state(data().QB_009,UNCOMPLETE)
	onDlg_Olivia_geht_ins_Dorf()
	character.add_experience_party(data().Exp_Sekte_beobachtet)
	end_cutscene()
	
def onDlg_033_Ende_1():
	onDlg_Olivia_geht_ins_Dorf()
	character.add_experience_party(data().Exp_Sekte_beobachtet)
	end_cutscene()
	system.set_qb_entry_state(data().QB_007,COMPLETE)

def onDlg_Olivia_geht_ins_Dorf():
	objects.cancel_commandos("OLIVIA")
	data().Olivia_Dank = True
	objects.move_to("OLIVIA", 618,642, "landscape",MT_SLOW)
	objects.move_to("OLIVIA", 494,685, "landscape",MT_SLOW)
	objects.move_to("OLIVIA", 326,710, "landscape",MT_SLOW)
	objects.move_to("OLIVIA", 266,731, "landscape",MT_SLOW, callback=["ONEND",allow_activity])

#[NM]Dialog 052: Olivia bedankt sich für die Rettung
def initDlg_052_Olivia_dankt():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_052')
	dialog.add_text(text='D_052_T_001', speaker="OLIVIA", follower='ENDDIALOG')
	dialog.start(True, data().QB_007)

#[M]Dialog 032: Gespräch mit feigem Sektenmitglied.
def initDlg_032_Sekten_Mitgl():
	if data().last_sectarian == None:
		return True
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_032')
	dialog.add_text(text='D_032_T_001', speaker=data().last_sectarian)
	dialog.add_text(text='D_032_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_032_T_003', speaker=data().last_sectarian)
	dialog.add_text(text='D_032_T_004', speaker="ALTER_EGO")
	dialog.add_text(text='D_032_T_005', speaker=data().last_sectarian, follower='D_032_T_008')
	dialog.add_text(text='D_032_T_008', speaker="ALTER_EGO")
	dialog.add_text(text='D_032_T_009', speaker=data().last_sectarian)
	dialog.add_text(text='D_032_T_010', speaker="ALTER_EGO")
	dialog.add_text(text='D_032_T_011', speaker=data().last_sectarian)
	dialog.add_text(text='D_032_T_012', speaker="ALTER_EGO")
	dialog.add_text(text='D_032_T_013', speaker=data().last_sectarian)
	dialog.add_text(text='D_032_T_014', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_032_Sekten_Mitgl_Kampf)
	dialog.start(True, data().QB_007)
	return None

def onDlg_032_Sekten_Mitgl_Kampf():
	objects.set_immortal_state(data().last_sectarian, False)
	character.equip_direct( data().last_sectarian, equipment="SET_SPECIAL_38" )
	objects.set_attribute( data().last_sectarian, attribute="foes", value=["UISPIELER"])
	system.set_qb_entry_state(data().QB_009, COMPLETE)

#[NM]Dialog 044: Kommentar beim Ableben des letzten Sektenmitgliedes.
def initDlg_044_Sekte_komplett():
	system.set_qb_entry_state(data().QB_010,UNCOMPLETE)
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_044')
	dialog.add_text(text='D_044_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=
		Lambda('system.set_qb_entry_state(data().QB_010, UNCOMPLETE)'))
	dialog.start(True, data().QB_007)

#[NM/CS] Dialog 061: Wesley hat einen guten Tipp
def initCutscene_061_WesleyHatEinenGutenTipp():
	objects.turn_to_object("WESLEY","ALTER_EGO")
	objects.turn_to_object("ALTER_EGO","WESLEY")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_061')
	set_conversation("ALTER_EGO", "WESLEY", new_camera=False)
	dialog.add_text(text='D_061_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("WESLEY","ALTER_EGO",mode="medium_deep")'))
	dialog.add_text(text='D_061_T_002', speaker="WESLEY", callback=Lambda('set_conversation("ALTER_EGO","WESLEY",mode="medium_deep")'))
	dialog.add_text(text='D_061_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("WESLEY","ALTER_EGO",mode="medium_deep")'))
	dialog.add_text(text='D_061_T_004', speaker="WESLEY", callback=Lambda('set_conversation("ALTER_EGO","WESLEY",mode="close_deep")'))
	dialog.add_text(text='D_061_T_005', speaker="ALTER_EGO", callback=Lambda('set_conversation("WESLEY","ALTER_EGO",mode="close_deep")'))
	dialog.add_text(text='D_061_T_006', speaker="WESLEY", follower='ENDDIALOG', callback=onDlg_061_Ende)
	dialog.start(True, data().QB_014)

def onDlg_061_Ende():
	system.set_qb_entry_state(data().QB_014, UNCOMPLETE)
	end_cutscene(chars=["ALTER_EGO", "WESLEY"])
	points_s = [[318.5,890.1],[345.52, 988.25],[414.83, 1039.73]]
	points_n = [[318.5,890.1],[345.52, 988.25],[414.83, 1039.73]]
	points_e = [[318.5,890.1],[345.52, 988.25],[414.83, 1039.73]]
	points_w = [[168.6,730.9],[89.49,758.5]]
	enter_direction = system.zone_transfer_get_direction()
	points = []
	if enter_direction == "NORTH":
		points = points_n
	elif enter_direction == "SOUTH":
		points = points_s
	elif enter_direction == "WEST":
		points = points_w
	else:
		points = points_e
	for p in points:
		if p == points[len(points)-1]:
			objects.move_to("WESLEY",p[0],p[1],"landscape",MT_SLOW, callback=["ONEND",onWesleyGoHome])
		else:
			objects.move_to("WESLEY",p[0],p[1],"landscape",MT_SLOW)

def onWesleyGoHome(id):
	objects.set_active_state(id,INACTIVE)

#[NM]Dialog 015: General Lewis ist voll mit der Ausbildung der Rekruten beschäftigt/Dank für Hilfe.
def initDlg_015_GeneralIstBeschaeftigt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_015')
	dialog.add_text(text='D_015_T_001', speaker="GENERAL_LEWIS",follower='ENDDIALOG')
	dialog.start()

#[M]Dialog 073: Nicholas gibt Infos zu den Bestien, Variante: Ratskulls sind schon erledigt
def initDlg_073_NicolasInfoBestienRatskullsErledigt():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_073')
	dialog.add_choice(text='D_073_C_001_1', follower='D_073_T_001')
	if data().Poster_gelesen:
		dialog.add_choice(text='D_073_C_001_2', follower='D_073_T_006')
	dialog.add_choice(text='D_073_C_001_3', follower='ENDDIALOG', callback=onDlg_073_Ende1)
	dialog.add_text(text='D_073_T_001', speaker="NICHOLAS")
	dialog.add_text(text='D_073_T_002', speaker="NICHOLAS")
	dialog.add_text(text='D_073_T_003', speaker="NICHOLAS", follower='D_073_C_002')
	dialog.add_choice(text='D_073_C_002_1', follower='D_073_T_004')
	dialog.add_choice(text='D_073_C_002_2', follower='D_073_C_001')
	dialog.add_text(text='D_073_T_004', speaker="NICHOLAS")
	dialog.add_text(text='D_073_T_005', speaker="ALTER_EGO", follower='D_073_C_001')
	dialog.add_text(text='D_073_T_006', speaker="NICHOLAS")
	dialog.add_text(text='D_073_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_073_T_008', speaker="NICHOLAS")
	dialog.add_text(text='D_073_T_009', speaker="ALTER_EGO")
	dialog.add_text(text='D_073_T_010', speaker="NICHOLAS")
	dialog.add_text(text='D_073_T_011', speaker="NICHOLAS")
	dialog.add_text(text='D_073_T_013', speaker="NICHOLAS")
	dialog.add_text(text='D_073_T_014', speaker="ALTER_EGO")
	dialog.add_text(text='D_073_T_015', speaker="NICHOLAS", follower='D_073_C_003')
	dialog.add_choice(text='D_073_C_003_1', follower='D_073_T_016')
	dialog.add_choice(text='D_073_C_003_2', follower='D_073_T_017')
	dialog.add_text(text='D_073_T_016', speaker="NICHOLAS", follower='ENDDIALOG', callback=onDlg_073_Ende2)
	dialog.add_text(text='D_073_T_017', speaker="NICHOLAS", follower='ENDDIALOG', callback=onDlg_073_Ende3)
	onDlg_024_marker()
	dialog.start(False, data().QB_017)

def onDlg_073_Ende1():
#Wiederkehr möglich
	pass

def onDlg_073_Ende2():
#Ab jetzt kann der Spieler Nicholas die Warg-Köpfe geben
	system.set_qb_entry_state(data().QB_008, UNCOMPLETE)
	if system.get_qb_entry_state(data().QB_017) != INACTIVE:
		system.set_qb_entry_state(data().QB_017, INACTIVE)
	data().INFOS_UEBER_BESTIEN_ERHALTEN = True

def onDlg_073_Ende3():
#Ab jetzt kann der Spieler Nicholas die Warg-Köpfe geben
	if system.get_qb_entry_state(data().QB_017) != INACTIVE:
		system.set_qb_entry_state(data().QB_017, INACTIVE)
	# system.set_qb_entry_state(data().QB_008, UNCOMPLETE)
	data().SPIELER_JAGT_BESTIEN_NICHT = True
	data().INFOS_UEBER_BESTIEN_ERHALTEN = True

#[NM]Dialog 054: Spieler hat keinen Grund mit Ian zu sprechen.
def initDlg_054_SpielerWillNichtMitIanSprechen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_054')	
	dialog.add_text(text='D_054_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM]Dialog 022: Was ist das für ein Plakat?
def initDlg_022_WasIstDasFuerEinPlakat():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_022')	
	dialog.add_text(text='D_022_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM/CS] Dialog 071: Der Spieler hat Phoenix angeschossen
def initCutscene_071_SpielerHatPhoenixAngeschossen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_071')	
	dialog.add_text(text='D_071_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_012)

#[NM] Dialog 072: Der Spieler will nicht mit Phoenix sprechen
def initDlg_072_SpielerWillNichtMitPhoenixSprechen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_072')	
	dialog.add_text(text='D_072_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_012)

#[NM/CS] Dialog 063: Phoenix gibt sich geschlagen
def initCutscene_063_PhoenixGibtSichGeschlagen():
	system.start_cutscene()
	set_conversation("PHOENIX", cam_x = 3.0, cam_y=2.0, mode="far_up", animate=False)
	data().phoenix_gesprochen = True
	objects.set_immortal_state("PHOENIX",False)
	objects.set_attribute("PHOENIX", "maxhitpoints", 60)
	objects.set_attribute("PHOENIX", "hitpoints", 45)
	pos = objects.get_position("PHOENIX")
	character.play_animation("PHOENIX","CM_AUFSTEHEN_KNIEND_WAFFE", callback=["ONEND",prohibit_activity])
	objects.move_to("ALTER_EGO",pos[0]+1.5,pos[1]+1,"landscape",MT_SLOW, callback=["ONEND",onDlg_063_StartDialog])

def onDlg_063_StartDialog(id):
	set_conversation("PHOENIX","ALTER_EGO",mode="medium_deep")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_063')	
	dialog.add_text(text='D_063_T_001', speaker="PHOENIX", callback=Lambda('set_conversation("ALTER_EGO","PHOENIX",mode="medium_deep")'))
	dialog.add_text(text='D_063_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("PHOENIX","ALTER_EGO",mode="medium_deep")'))
	dialog.add_text(text='D_063_T_003', speaker="PHOENIX", callback=[Lambda('data().spieler_von_wesley_betrogen = True'),Lambda('set_conversation("ALTER_EGO","PHOENIX",mode="close")')])
	dialog.add_text(text='D_063_T_004', speaker="ALTER_EGO", callback=Lambda('set_conversation("PHOENIX","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_063_T_005', speaker="PHOENIX", callback=Lambda('set_conversation("ALTER_EGO","PHOENIX",mode="medium_deep")'))
	dialog.add_text(text='D_063_T_006', speaker="ALTER_EGO", callback=Lambda('set_conversation("PHOENIX","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_063_T_007', speaker="PHOENIX", callback=Lambda('set_conversation("ALTER_EGO","PHOENIX",mode="close")'))
	if not data().hummer_explodiert:
		dialog.add_text(text='D_063_T_008', speaker="ALTER_EGO", follower='D_063_T_010', callback=Lambda('set_conversation("PHOENIX","ALTER_EGO",mode="close")'))
	else:
		dialog.add_text(text='D_063_T_009', speaker="ALTER_EGO", callback=Lambda('set_conversation("PHOENIX","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_063_T_010', speaker="PHOENIX", follower='ENDDIALOG', callback=onDlg_063_Ende)
	dialog.start(False, [data().QB_012, data("zone_4.zone_4").QB_021, data().QB_016])

def onDlg_063_Ende():
	end_cutscene(chars=["ALTER_EGO", "PHOENIX"])
	system.set_qb_entry_state(data().QB_012,INACTIVE)
	if was_zone_entered("zone_4.zone_4"):
		system.set_qb_entry_state(data("zone_4.zone_4").QB_021,COMPLETE)
	initDlg_064_SpielerTrifftEntscheidung()

#[M] Dialog 064: Der Spieler trifft eine Entscheidung
def initDlg_064_SpielerTrifftEntscheidung():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_064')	
	dialog.add_choice(text='D_064_C_001_1', follower='ENDDIALOG', callback=onDlg_064_Ende1)
	dialog.add_choice(text='D_064_C_001_2', follower='D_064_T_008')
	if data().D_064_C_001_3:
		dialog.add_choice(text='D_064_C_001_3', follower='D_064_T_001')
	dialog.add_text(text='D_064_T_001', speaker="PHOENIX")
	dialog.add_text(text='D_064_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_064_T_003', speaker="PHOENIX", follower='D_064_C_001', callback=Lambda('data().D_064_C_001_3 = False'))
	dialog.add_text(text='D_064_T_008', speaker="PHOENIX")
	dialog.add_text(text='D_064_T_009', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_064_Ende2)
	dialog.start(False, [data().QB_012, data("zone_4.zone_4").QB_021, data().QB_016])

def onDlg_064_Ende1():
	## phoenix kann gekillt werden
	objects.set_attribute("PHOENIX","foes",["UISPIELER"])
	objects.attack("PHOENIX","ALTER_EGO")
	# system.set_qb_entry_state(data().QB_015, INACTIVE)
	system.set_qb_entry_state(data().QB_016, UNCOMPLETE)
	data('zone_5.zone_5').phoenix_kill = True
	
def onDlg_064_Ende2():
	# system.set_qb_entry_state(data().QB_015, INACTIVE)
	system.set_qb_entry_state(data().QB_016, UNCOMPLETE)
	objects.set_attribute("PHOENIX","hitpoints",5)
	character.set_approachable_state("PHOENIX",NOTAPPROACHABLE)
	
	objects.create_item_in_inventory("PHOENIX", "SET_SUPERLW");
	objects.drop_item("PHOENIX","SET_SUPERLW")
	
	for p in ROUTE_PHOENIX:
		if p == ROUTE_PHOENIX[len(ROUTE_PHOENIX)-1]:
			objects.move_to("PHOENIX",p[0],p[1],"landscape",MT_SLOW, callback=["ONEND",onPhoenixFluchtDeactivate])
		else:
			objects.move_to("PHOENIX",p[0],p[1],"landscape",MT_SLOW)
	onDlg_082_PhoenixFertig()
	character.add_experience_party(data().Exp_Kampf_gegen_Ratskulls)
	## todo: Phoenix humpelt davon

def onPhoenixFluchtDeactivate(id):
	objects.set_active_state(id,INACTIVE)

#[NM] Dialog 082: Der Spieler ist mit Phoenix fertig
def onDlg_082_PhoenixFertig():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_082')
	dialog.add_text(text='D_082_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_016)
	
#[M] Dialog 070: Dan ist ein Feigling
def initDlg_070_DanIstEinFeigling():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_070')
	dialog.add_text(text='D_070_T_001', speaker="DAN")
	dialog.add_text(text='D_070_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_070_T_003', speaker="DAN")
	dialog.add_choice(text='D_070_C_001_1', follower='D_070_T_004')
	dialog.add_choice(text='D_070_C_001_2', follower='D_070_T_007')
	dialog.add_choice(text='D_070_C_001_3', follower='ENDDIALOG', callback=onDlg070_Ende1)
	dialog.add_text(text='D_070_T_004', speaker="DAN")
	dialog.add_text(text='D_070_T_005', speaker="ALTER_EGO")
	dialog.add_text(text='D_070_T_006', speaker="DAN", follower='ENDDIALOG', callback=onDlg070_Ende3)
	dialog.add_text(text='D_070_T_007', speaker="DAN")
	dialog.add_text(text='D_070_T_008', speaker="ALTER_EGO")
	dialog.add_text(text='D_070_T_009', speaker="DAN", follower='ENDDIALOG', callback=onDlg070_Ende3)
	dialog.start(False)

def onDlg070_Ende1():
	#Dan greift an
	character.set_approachable_state("DAN", NOTAPPROACHABLE)
	objects.set_immortal_state("DAN", False)
	objects.set_attribute("DAN","foes",["UISPIELER"])
	objects.attack("DAN","ALTER_EGO")

def onDlg070_Ende2():
	objects.set_immortal_state("DAN",False)
	character.set_approachable_state("DAN", NOTAPPROACHABLE)
	#Dan flieht, ist erschießbar
	#objects.set_attribute("DAN","foes",["UISPIELER"])
	import zone_5
	zone_5.dan_finish_drugwork()
	for p in ROUTE_PHOENIX:
		if not p == ROUTE_PHOENIX[len(ROUTE_PHOENIX)-1]:
			objects.move_to("DAN",p[0],p[1],"landscape",MT_FAST)
		else:
			objects.move_to("DAN",p[0],p[1],"landscape",MT_FAST, callback=["ONEND", deactivate])

def ratskulls_add_foe(foe):
	for char in NPC_RATSKULLS:
		if not objects.is_destroyed(char):
			foes = objects.get_attribute(char, "foes")
			if foes != None:
				if isinstance(foes, list):
					foes.append(foe)
				else:
					foes = [foes]+[foe]
			else:
				foes = [foe]
			objects.set_attribute(char,"foes",foes)
	
def onDlg070_Ende3():
	objects.set_immortal_state("DAN", False)
	character.set_approachable_state("DAN", NOTAPPROACHABLE)
	#Dan ist desertiert und haut ab. Ist nicht angreifbar, außer von Ratskulls.
	import zone_5
	zone_5.dan_finish_drugwork()
	#ratskulls_add_foe("DAN")
	for p in ROUTE_PHOENIX:
		if not p == ROUTE_PHOENIX[len(ROUTE_PHOENIX)-1]:
			objects.move_to("DAN",p[0],p[1],"landscape",MT_FAST)
		else:
			objects.move_to("DAN",p[0],p[1],"landscape",MT_FAST, callback=["ONEND", deactivate])

def deactivate(id):
	objects.set_active_state(id,INACTIVE)

#[NM]Dialog 066: Verwunderung über Schattenleiche
def initDlg_066_VerwunderungUeberSchattenleiche():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_066')
	dialog.add_text(text='D_066_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 069: Der Spieler erkennt die Drogenausgabestelle
def initDlg_069_SpielerErkenntDrogenAusgabeStelle():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_069')
	dialog.add_text(text='D_069_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 084: Der Spieler findet einen Pick-Up
def initDlg_084_SpielerFindetEinenPickUp():
	objects.cancel_commandos("ALTER_EGO")
	objects.turn_to_object("ALTER_EGO", "Z5 PICKUP")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_084')
	dialog.add_text(text='D_084_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 074: Der Priester verhöhnt sein Opfer
def initDlg_074_PriesterVerhoehntOpfer(char):
	data().Opferung_Active = True
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_074')
	dialog.set_dialog_identifier("Opferung")
	dialog.add_text(text='D_074_T_001', speaker="OLIVIA")
	dialog.add_text(text='D_074_T_002', speaker="SECT_PRIEST")
	dialog.add_text(text='D_074_T_003', speaker="OLIVIA")
	dialog.add_text(text='D_074_T_004', speaker="SECT_PRIEST")
	dialog.add_text(text='D_074_T_005', speaker="OLIVIA")
	dialog.add_text(text='D_074_T_006', speaker="SECT_PRIEST", follower='ENDDIALOG', callback=onDlg_074_Ende)
	dialog.start(True, data().QB_007)

def onDlg_074_Ende():
	data().Opferung_Active = False
	system.notify_timer(data().Timer_Olivias_Tod,data().Timervalue_Olivias_Tod)

#[NM/CS] Dialog 075: Der Priester tötet Olivia doch noch
def initCutscene_075_PriesterToetetOliviaDochNoch():
	if character.is_equiped("SECT_PRIEST", "SET_SPECIAL_38"):
		character.un_equip_direct("SECT_PRIEST", "SET_SPECIAL_38")
	objects.move_to("SECT_PRIEST", 718.96,639, "landscape",MT_SLOW, callback=["ONEND", onDlg_075_StartDialog])

def onDlg_075_StartDialog(char):
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_RITUAL_2)
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_075')
	dialog.add_text(text='D_075_T_001', speaker="OLIVIA")
	dialog.add_text(text='D_075_T_002', speaker="SECT_PRIEST", callback=onDlg_074_PriesterKilltOlivia)
	dialog.add_text(text='D_075_T_003', speaker="SECT_PRIEST", follower='ENDDIALOG')
	dialog.start(True, data().QB_007)

def onDlg_074_PriesterKilltOlivia():
	objects.cancel_commandos(object="OLIVIA")
	objects.cancel_commandos(object="SECT_PRIEST")
	objects.move_to_object("SECT_PRIEST", OBJ_MARTERPFAHL, "dmyp_002")
	if not objects.count_in_inventory("SECT_PRIEST","SET_BIG_KNIFE"):
		objects.create_item_in_inventory("SECT_PRIEST","SET_BIG_KNIFE")
		if not character.is_equiped("SECT_PRIEST","SET_BIG_KNIFE"):
			character.equip("SECT_PRIEST","SET_BIG_KNIFE")
	#objects.turn_to_object("SECT_PRIEST","OLIVIA", callback=["ONEND", Lambda('objects.set_immortal_state("OLIVIA", False)')])
	character.play_animation("OLIVIA", "CM_NPC_STEHEN_OPFERUNG_OPFER", callback=["ONEND", Lambda('objects.set_attribute("OLIVIA","hitpoints", -5)')])
	character.play_animation("SECT_PRIEST", "CM_NPC_STEHEN_OPFERUNG_HENKER", callback=["ONEND",onDlg_075_Ende])

def onDlg_075_Ende(char_id):
	system.set_qb_entry_state(data().QB_007,IMPOSSIBLE)
	data().Olivia_Erstochen = True
	end_cutscene()
	import zone_5
	zone_5.Sekte_Verschwindet(char_id)

#[NM/CS] Dialog 062: Der Spieler findet den Hummer
def initCutscene_062_SpielerFindetHummer():
	data().cutscene_standup = False
	data().counter_party_hummer = 0
	start_cutscene()
	data().spieler_lauert = []
	objects.cancel_commandos("ALTER_EGO")
	pos = POS_PARTY_HUMMER[data().counter_party_hummer]
	objects.set_position("ALTER_EGO",pos[0],pos[1])
	set_camera(CAMVIEW_HUMMER_1)
	character.change_body_mode("ALTER_EGO","LIE")
	objects.move_to("ALTER_EGO",497.5,769.05,grid="landscape",speed=MT_FAST, callback=["ONEND", Lambda('character.change_body_mode("ALTER_EGO","LIE")')])
	objects.turn_to_object("ALTER_EGO","Z5 HUMMER", callback=["ONEND",onDlg_062_PCsFollow])

	## spieler legt sich auf den boden beobachtet
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_062')
	dialog.add_text(text='D_062_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_062_RatskullsAppear) # ratskulls tauchen auf
	dialog.start(True, data().QB_014)

def onDlg_062_PCsFollow(char_id):
	character.change_body_mode("ALTER_EGO","LIE")
	p = objects.get_position(char_id)
	for pc_id in system.get_pcs():
		if pc_id != "ALTER_EGO":
			objects.cancel_commandos(pc_id)
			data().counter_party_hummer += 1
			pos = POS_PARTY_HUMMER[data().counter_party_hummer]
			objects.set_position(pc_id,pos[0],pos[1])
			character.change_body_mode(pc_id,"LIE")
			objects.move_to(pc_id, p[0]+(random.randint(-3,-1)),p[1]+(random.randint(-1,1)),speed=MT_SLOW, grid="landscape")
			objects.turn_to_object(pc_id, "Z5 HUMMER",callback=["ONEND",onDlg_062_CharLaysDown])

def onDlg_062_CharLaysDown(char_id):
	objects.turn_to_object(char_id,"Z5 HUMMER")
	data().spieler_lauert.append([char_id, character.get_body_mode(char_id)])

def onDlg_062_RatskullsAppear():
	#positionieren der rs in hoehle
	objects.set_position_free("RATSKULL_HUMMER_1",521.31, 755.31, 0)
	objects.set_position_free("RATSKULL_HUMMER_2",521.68, 755.97, 0)
	objects.set_position_free("RATSKULL_HUMMER_3",521.92, 756.64, 0)
	objects.set_position_free("RATSKULL_HUMMER_4",521.82, 757.80, 0)
	#aktivieren der rs
	objects.set_active_state("RATSKULL_HUMMER_1",ACTIVE)
	objects.set_active_state("RATSKULL_HUMMER_2",ACTIVE)
	objects.set_active_state("RATSKULL_HUMMER_3",ACTIVE)
	objects.set_active_state("RATSKULL_HUMMER_4",ACTIVE)
	#bewegen der rs aus höhle heraus
	objects.step_to("RATSKULL_HUMMER_1",515.80, 759.40, speed=MT_SLOW, callback=["ONEND",initDlg_062_ContinueAfterRatskullsAppear])
	objects.step_to("RATSKULL_HUMMER_2",516.89, 760.40, speed=MT_SLOW)
	objects.step_to("RATSKULL_HUMMER_3",517.60, 761.30, speed=MT_SLOW)
	objects.step_to("RATSKULL_HUMMER_4",517.60, 762.00, speed=MT_SLOW)
	#bewegen der rs um hummer
	objects.move_to("RATSKULL_HUMMER_1",520.14, 765.64, speed=MT_SLOW)
	objects.turn_to_object("RATSKULL_HUMMER_1","Z5 HUMMER")
	objects.move_to("RATSKULL_HUMMER_2",518.22, 766.92, speed=MT_SLOW)
	objects.turn_to_object("RATSKULL_HUMMER_2","Z5 HUMMER")
	objects.move_to("RATSKULL_HUMMER_3",514.09, 758.25, speed=MT_SLOW)
	objects.turn_to_object("RATSKULL_HUMMER_3","Z5 HUMMER")
	objects.move_to("RATSKULL_HUMMER_4",512.12, 758.85, speed=MT_SLOW)
	objects.turn_to_object("RATSKULL_HUMMER_4","Z5 HUMMER")
	
	objects.move_to("RATSKULL_HUMMER_1",518.0, 766.0,"landscape",MT_SLOW, callback=["ONEND",onDlg_062_RatskullsEnterHummer]) # ratskulls steigen lachen in den hummer ein
	
def initDlg_062_ContinueAfterRatskullsAppear(param=None):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_062')
	dialog.add_text(text='D_062_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_014)

def onDlg_062_RatskullsEnterHummer(param=None):
	set_camera(CAMVIEW_HUMMER_2)
	data().counter_ratskulls_inactive = 0
	objects.move_to("RATSKULL_HUMMER_1",516.3, 765.26,speed=MT_SLOW, callback=["ONEND", ratskulls_get_in_car])
	objects.move_to("RATSKULL_HUMMER_2",511.43, 763.54,speed=MT_SLOW, callback=["ONEND", ratskulls_get_in_car])

def ratskulls_get_in_car(char=None):
	character.get_in(char, "Z5 HUMMER", callback=["ONEND", ratskulls_are_in_car])
	
def ratskulls_are_in_car(id):
	data().counter_ratskulls_inactive += 1	
	if data().counter_ratskulls_inactive == 2:
		data().counter_ratskulls_inactive = 0
		system.notify_timer(data().Timer_GetInHummerWait,data().Timervalue_GetInHummerWait)

def ratskulls_start_hummer():
	sounds.play_3d_sound_object(sfx_id="humvee_failstart",object="Z5 HUMMER")
	#objects.play_animation("Z5 HUMMER","HUMVEE_ANLASSEN")
	if not data().spieler_von_wesley_betrogen:
		initDlg_062_ContinueAfterRatskullsEnterHummer()
	else:
		initDlg_078_ContinueAfterRatskullsEnterHummer()

def initDlg_062_ContinueAfterRatskullsEnterHummer(param=None):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_062')
	dialog.add_text(text='D_062_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_062_Explosion) # explosion, kleine pause
	dialog.start(True, data().QB_014)

def onDlg_062_Explosion():
	set_camera(CAMVIEW_HUMMER_3)
	sounds.play_3d_sound_object(sfx_id="humvee_explosion",object="Z5 HUMMER")
	objects.destroy("Z5 HUMMER")
	data().hummer_explodiert = True
	import zone_5
	zone_5.explode(object_id="Z5 HUMMER",count=7)
	system.notify_timer(data().Timer_HummerExplodiert,data().Timervalue_HummerExplodiert)
	character.play_animation("RATSKULL_HUMMER_3","CM_NPC_STEHEN_MIT_WAFFE_SCHUETZEN")
	
	#raucheffekte starten
	system.start_effect_object(object="Z5 HUMMER",node="lafette",parameter=fx_smoke)
	system.start_effect_object(object="Z5 HUMMER",node="wheel_steer_r",parameter=fx_smoke)

def initDlg_062_ContinueAfterExplosion():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_062')
	dialog.add_text(text='D_062_T_004', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_062_RatskullsLeaveHummer) # ratskulls kommen aus rauchenden trümmern gelaufen
	dialog.start(True, data().QB_014)

def onDlg_062_RatskullsLeaveHummer():
	set_camera(CAMVIEW_HUMMER_1)
	objects.move_to("RATSKULL_HUMMER_3",516.28,766.39)
	objects.move_to("RATSKULL_HUMMER_4",511.51,763.41)
	system.notify_timer(data().Timer_HummerSzeneEnde,data().Timervalue_HummerSzeneEnde)

def initDlg_062_ContinueAfterRatskullsComeOutOfExplosion():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_062')
	dialog.add_text(text='D_062_T_005', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_062_Ende)
	dialog.start(True, data().QB_014)

def onDlg_062_Ende():
	for pc in system.get_pcs():
		for pc_data in data().spieler_lauert:
			if pc == pc_data[0]:
				character.change_body_mode(pc,pc_data[1])
				data().spieler_lauert.remove(pc_data)
	end_cutscene(chars=[])
	character.set_approachable_state("RATSKULL_HUMMER_3", NOTAPPROACHABLE)
	character.set_approachable_state("RATSKULL_HUMMER_4", NOTAPPROACHABLE)
	objects.set_attribute("RATSKULL_HUMMER_3","foes",["UISPIELER"])
	objects.set_attribute("RATSKULL_HUMMER_4","foes",["UISPIELER"])
	system.set_qb_entry_state(data().QB_014, COMPLETE)
	# system.set_qb_entry_state(data().QB_015, UNCOMPLETE)

#[NM/CS] Dialog 067: Der Seeker will flüchten
def initCutscene_067_SeekerWillFluechten():
	data().seeker_aufgehalten = True
	system.start_cutscene()
	p = objects.get_position("PATRICK")
	ae = objects.get_position("ALTER_EGO")
	dx, dy = 3, 3
	if p[0] < ae[0]:
		dx = 0- dx
	if p[1] < ae[1]:
		dy = 0- dy
	set_conversation("ALTER_EGO",cam_x=-dx, cam_y=-dy,mode="medium",animate=False)
	objects.move_to("ALTER_EGO",p[0],p[1],"landscape",MT_SLOW)
	objects.move_to("PATRICK",p[0]+dx,p[1]+dy)
	objects.turn_to_object("ALTER_EGO","PATRICK",callback=["ONEND",onDlg_067_StartDialog])

def onDlg_067_StartDialog(id):
	## spieler legt sich auf den boden beobachtet
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_067')
	dialog.add_text(text='D_067_T_001', speaker="ALTER_EGO", callback=onDlg_067_SeekerHalts) # seeker bleibt aprubt stehen
	dialog.add_text(text='D_067_T_002', speaker="PATRICK", follower='ENDDIALOG', callback=onDlg_067_PlayerApproaches) # spieler kommt näher
	dialog.start()
	
def onDlg_067_ContinueAfterApproach(id):
	set_conversation("ALTER_EGO","PATRICK",mode="medium_deep")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_067')
	dialog.add_text(text='D_067_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("PATRICK","ALTER_EGO",mode="close_deep")'))
	dialog.add_text(text='D_067_T_004', speaker="PATRICK", follower='ENDDIALOG', callback=Lambda('end_cutscene(chars=["ALTER_EGO","PATRICK"]); initDlg_068_SpielerFragtSeekerAus()'))
	dialog.start()

def onDlg_067_SeekerHalts():
	objects.cancel_commandos("PATRICK")
	objects.turn_to_object("PATRICK","ALTER_EGO")

def onDlg_067_PlayerApproaches():
	p = objects.get_position("PATRICK")
	ae = objects.get_position("ALTER_EGO")
	dx, dy = 1.0, 1.4
	if p[0] > ae[0]:
		dx = 0- dx
	if p[1] > ae[1]:
		dy = 0- dy
	init_cutscene("ALTER_EGO", "PATRICK", dx=dx, dy=dy)
	objects.turn_to_object("ALTER_EGO", "PATRICK", callback=["ONEND", onDlg_067_ContinueAfterApproach])

#[M] Dialog 068: Der Spieler fragt den Seeker aus
def initDlg_068_SpielerFragtSeekerAus():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_068')
	dialog.add_choice(text='D_068_C_001_1', follower='D_068_T_001')
	dialog.add_choice(text='D_068_C_001_2', follower='D_068_T_004')
	dialog.add_choice(text='D_068_C_001_3', follower='D_068_T_009')
	dialog.add_choice(text='D_068_C_001_4', follower='D_068_T_010')
	dialog.add_text(text='D_068_T_001', speaker="PATRICK")
	dialog.add_text(text='D_068_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_068_T_003', speaker="PATRICK", follower='D_068_C_001')
	dialog.add_text(text='D_068_T_004', speaker="PATRICK")
	dialog.add_text(text='D_068_T_005', speaker="ALTER_EGO")
	dialog.add_text(text='D_068_T_006', speaker="PATRICK")
	dialog.add_text(text='D_068_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_068_T_008', speaker="PATRICK", follower='D_068_C_001')
	dialog.add_text(text='D_068_T_009', speaker="PATRICK", follower='D_068_C_001')
	dialog.add_text(text='D_068_T_010', speaker="PATRICK", follower='ENDDIALOG', callback=onDlg_068_Ende)
	dialog.start(True, [data().QB_012, data("zone_4.zone_4").QB_021])

def onDlg_068_Ende():
	objects.move_to("PATRICK",212.2,265.9,"landscape",MT_SLOW)
	objects.move_to("PATRICK",113.2,235.0,"landscape",MT_SLOW,callback=["ONEND",deactivate])
	system.set_qb_entry_state(data().QB_012, UNCOMPLETE)
	if was_zone_entered("zone_4.zone_4"):
		system.set_qb_entry_state(data("zone_4.zone_4").QB_021, INACTIVE)

#[NM] Dialog 057: Der Spieler mag die Holzgestelle nicht verwenden.
def initDlg_057_SpielerMagHolzGestelleNichtVerwenden():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_057')
	dialog.add_text(text='D_057_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 058: Der Spieler mag von dem Wasser nichts trinken
def initDlg_058_SpielerMagNichtVomWasserTrinken():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_058')
	dialog.add_text(text='D_058_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM]Dialog 077: Kommentar beim Ableben des letzten Sektenmitgliedes, Variante: Spieler weiß nichts von den Wargen
def initDlg_077_SpielerKilltSekteOhneWargInfo():
	system.set_qb_entry_state(data().QB_009,COMPLETE)
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_077')
	dialog.add_text(text='D_077_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=
		Lambda('system.set_qb_entry_state(data().QB_010,UNCOMPLETE)'))
	dialog.start(True, data().QB_007)

#[NM/CS] Dialog 078: Der Spieler findet den Hummer, Variante: Wesley enttarnt
def initCutscene_078_SpielerFindetHummerWesleyEnttarnt():
	data().counter_party_hummer = 0
	data().cutscene_standup = False
	start_cutscene()
	data().spieler_lauert = []
	objects.cancel_commandos("ALTER_EGO")
	pos = POS_PARTY_HUMMER[data().counter_party_hummer]
	objects.set_position("ALTER_EGO",pos[0],pos[1])
	set_camera(CAMVIEW_HUMMER_1)
	character.change_body_mode("ALTER_EGO","LIE")
	objects.move_to("ALTER_EGO",497.5,769.05,grid="landscape",speed=MT_FAST, callback=["ONEND", Lambda('character.change_body_mode("ALTER_EGO","LIE")')])
	objects.turn_to_object("ALTER_EGO","Z5 HUMMER", callback=["ONEND",onDlg_062_PCsFollow])

	## spieler legt sich auf den boden beobachtet
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_078')
	dialog.add_text(text='D_078_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_078_RatskullsAppear) # ratskulls tauchen auf
	dialog.start(True, data().QB_014)

def onDlg_078_RatskullsAppear():
	#positionieren der rs in hoehle
	objects.set_position_free("RATSKULL_HUMMER_1",521.31, 755.31, 0)
	objects.set_position_free("RATSKULL_HUMMER_2",521.68, 755.97, 0)
	objects.set_position_free("RATSKULL_HUMMER_3",521.92, 756.64, 0)
	objects.set_position_free("RATSKULL_HUMMER_4",521.82, 757.80, 0)
	#aktivieren der rs
	objects.set_active_state("RATSKULL_HUMMER_1",ACTIVE)
	objects.set_active_state("RATSKULL_HUMMER_2",ACTIVE)
	objects.set_active_state("RATSKULL_HUMMER_3",ACTIVE)
	objects.set_active_state("RATSKULL_HUMMER_4",ACTIVE)
	#bewegen der rs aus höhle heraus
	objects.step_to("RATSKULL_HUMMER_1",515.80, 759.40, speed=MT_SLOW, callback=["ONEND",initDlg_062_ContinueAfterRatskullsAppear])
	objects.step_to("RATSKULL_HUMMER_2",516.89, 760.40, speed=MT_SLOW)
	objects.step_to("RATSKULL_HUMMER_3",517.60, 761.30, speed=MT_SLOW)
	objects.step_to("RATSKULL_HUMMER_4",517.60, 762.00, speed=MT_SLOW)
	#bewegen der rs um hummer
	objects.move_to("RATSKULL_HUMMER_1",520.14, 765.64, speed=MT_SLOW)
	objects.turn_to_object("RATSKULL_HUMMER_1","Z5 HUMMER")
	objects.move_to("RATSKULL_HUMMER_2",518.22, 766.92, speed=MT_SLOW)
	objects.turn_to_object("RATSKULL_HUMMER_2","Z5 HUMMER")
	objects.move_to("RATSKULL_HUMMER_3",514.09, 758.25, speed=MT_SLOW)
	objects.turn_to_object("RATSKULL_HUMMER_3","Z5 HUMMER")
	objects.move_to("RATSKULL_HUMMER_4",512.12, 758.85, speed=MT_SLOW)
	objects.turn_to_object("RATSKULL_HUMMER_4","Z5 HUMMER")
	
	objects.move_to("RATSKULL_HUMMER_1",518.0, 766.0,"landscape",MT_SLOW, callback=["ONEND",onDlg_062_RatskullsEnterHummer]) # ratskulls steigen lachen in den hummer ein
	
def initDlg_078_ContinueAfterRatskullsAppear(param=None):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_078')
	dialog.add_text(text='D_078_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_014)

def initDlg_078_ContinueAfterRatskullsEnterHummer(param=None):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_078')
	dialog.add_text(text='D_078_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_062_Explosion) # explosion, kleine pause
	dialog.start(True, data().QB_014)

def initDlg_078_ContinueAfterExplosion():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_078')
	dialog.add_text(text='D_078_T_004', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_062_RatskullsLeaveHummer) # ratskulls kommen aus rauchenden trümmern gelaufen
	dialog.start(True, data().QB_014)

def initDlg_078_ContinueAfterRatskullsComeOutOfExplosion():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_078')
	dialog.add_text(text='D_078_T_005', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_062_Ende)
	dialog.start(True, data().QB_014)

def initDlg_079_SchlaegerVerscheuchenSpieler():
	objects.cancel_commandos('BRANDON')
	prohibit_activity("BRANDON")
	objects.turn_to_object("BRANDON","ALTER_EGO", callback=["ONEND", onDlg_079_StartDialog])

def onDlg_079_StartDialog(char_id):
	text_id = 'D_079_T_00'+str(random.choice([1,2,3,4]))
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_079')
	dialog.add_text(text=text_id, speaker="BRANDON", follower='ENDDIALOG', callback=Lambda('allow_activity("BRANDON")'))
	dialog.start()

#[NM] Dialog 083: Der Spieler staunt über die Warge
def initDlg_083_SpielerStauntUeberWarge():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_083')
	dialog.add_text(text='D_083_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_017)

