# -*- coding: utf-8 -*-
from global_defines import *
from npc_activities import *
from const import *
import global_schedules

#*********************************************************************
#		aktuelle revison: Revision 33, 6.10.2004
#*********************************************************************
def check_stand_up(character_id):
	if character.get_body_mode(character_id) == "LIE":
		character.change_body_mode(character_id,"STAND")
		
def switchDialog(c,d1,d2):
	return lambda _c_: ifelse(c,d1,d2)

def equip_torch(c):
	if not objects.count_in_inventory(c, "SET_TORCH"):
		objects.create_item_in_inventory(c, "SET_TORCH")
	if not character.is_equiped(c, "SET_TORCH"):
		character.equip_direct(c, "SET_TORCH")

def unequip_torch(c):
	if objects.count_in_inventory(c, "SET_TORCH"):
		if character.is_equiped(c, "SET_TORCH"):
			character.un_equip_direct(c, "SET_TORCH")
		objects.remove_item_from_inventory(c, "SET_TORCH")
	
def route(char):
	if char == "PETER":
		data().counter_route_ta_peter += 1
		if (data().counter_route_ta_peter > (len(ROUTE_TA_PETER)-1)):
			data().counter_route_ta_peter = 0

	elif char == "RAYMOND":
		data().counter_route_ta_raymond += 1
		if (data().counter_route_ta_raymond > (len(ROUTE_TA_RAYMOND)-1)):
			data().counter_route_ta_raymond = 0

	elif char == "EGON":
		data().counter_route_ta_egon += 1
		if (data().counter_route_ta_egon > (len(ROUTE_TA_EGON)-1)):
			data().counter_route_ta_egon = 0
		#print "egons waypoint:",str(data().counter_route_ta_egon)

	elif char == "JANINE":
		data().counter_route_ta_janine += 1
		if (data().counter_route_ta_janine > (len(ROUTE_TA_JANINE)-1)):
			data().counter_route_ta_janine = 0
	
	elif char == "RATSKULL_DRUG_MULE_1":
		data().counter_route_rs_drugmule_1 += 1
		if (data().counter_route_rs_drugmule_1 > (len(ROUTE_RS_DRUGMULE_1)-1)):
			data().counter_route_rs_drugmule_1 = 0
	
	elif char == "RATSKULL_DRUG_MULE_2":
		data().counter_route_rs_drugmule_2 += 1
		if (data().counter_route_rs_drugmule_2 > (len(ROUTE_RS_DRUGMULE_2)-1)):
			data().counter_route_rs_drugmule_2 = 0
	
	elif char == "RATSKULL_DRUG_MULE_3":
		data().counter_route_rs_drugmule_3 += 1
		if (data().counter_route_rs_drugmule_3 > (len(ROUTE_RS_DRUGMULE_3)-1)):
			data().counter_route_rs_drugmule_3 = 0
	

def drugissuingoffice_drugissuer(s_type):
	return lambda c: drugissuer_helper(char=c,s_type=s_type)
	
def drugissuer_helper(char, s_type):
	if s_type == S_START:
		objects.move_to(char, grid="ZONE_5_BUILDING_10565_INTERIOR_GRID1", x=630.28607177734375, y=376.99139404296875, speed=MT_SLOW)
		objects.turn_to_direction(char, 52.6506462097)
		objects.move_to_object(char, "BUILDING_12659", "dmyp_001")
		character.play_animation(char, 'CM_NPC_STEHEN_HINSETZEN')
	else:
		character.play_animation(char, 'CM_NPC_SITZEN_BANK_LOOP')

def drugissuingoffice_drugtaker(s_type, action):
	return lambda c: drugtaker_helper(char=c, s_type=s_type, action=action)

def drugtaker_helper(char, s_type, action):
	if action == "lay_bed":
		if s_type == S_START:
			objects.move_to(char, grid="ZONE_5_BUILDING_10565_INTERIOR_GRID2", x=626.26007080078125, y=374.30856323242187, speed=MT_SLOW)
			objects.turn_to_direction(char, 65.8428192139)
			objects.move_to_object(char, "BUILDING_12672", "dmyp_001")
			character.play_animation(char, 'CM_NPC_HINLEGEN_BETT')
		else:
			character.play_animation(char, 'CM_NPC_LIEGEN_BETT_LOOP')
	elif action == "wait_drugs":
		if s_type == S_START:
			objects.move_to(char, grid="ZONE_5_BUILDING_10565_INTERIOR_GRID1", x=628.4234619140625, y=377.54266357421875)
			objects.turn_to_direction(char, 50.6913146973)
			character.play_animation(char, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN')
		else:
			if random.randint(0,200) <= 66:
				character.play_animation(char, 'CM_STEHEN_TASCHENDIEBSTAHL_VORN')
			else:
				return "perform_wait_command"
	else:
		if s_type == S_START:
			objects.move_to(char, grid="ZONE_5_BUILDING_10565_INTERIOR_GRID1", x=629.97320556640625, y=371.325927734375, speed=MT_SLOW)
			objects.turn_to_direction(char, 164.144668579)
			
			if action == "sit_couch_1":
				objects.move_to_object(char, "BUILDING_12670", "dmyp_001")
		
			elif action == "sit_couch_2":
				objects.move_to_object(char, "BUILDING_12670", "dmyp_002")
			
				## todo: dummy fixen
			elif action == "sit_chair_1":
				objects.move_to_object(char, "BUILDING_12665")#, "dmyp_001")
		
			elif action == "sit_chair_2":
				objects.move_to_object(char, "BUILDING_12666", "dmyp_001")
				
				## todo: dummy fixen
			elif action == "sit_chair_3":
				objects.move_to_object(char, "BUILDING_12668")#, "dmyp_001")
			
			elif action == "sit_chair_4":
				objects.move_to_object(char, "BUILDING_12667", "dmyp_001")
			
			elif action == "sit_bench_1":
				objects.move_to_object(char, "BUILDING_12673", "dmyp_001")
			
			elif action == "sit_bench_2":
				objects.move_to_object(char, "BUILDING_12673", "dmyp_002")
	
			character.play_animation(char, "CM_NPC_STEHEN_HINSETZEN")
		else:
			r = random.randint(0,200)
			if r <= 66:
				if character.get_act_animation_name(char) in ['CM_NPC_SITZEN_BANK_BUCH_LESEN_START','CM_NPC_SITZEN_BANK_BUCH_LESEN_LOOP']:
					character.play_animation(char, 'CM_NPC_SITZEN_BANK_BUCH_LESEN_ENDE')
				character.play_animation(char, 'CM_NPC_SITZEN_BANK_TRINKEN_LOOP')
			elif r <= 99:
				if character.get_act_animation_name(char) in ['CM_NPC_SITZEN_BANK_LOOP','CM_NPC_SITZEN_BANK_TRINKEN_LOOP']:
					character.play_animation(char, 'CM_NPC_SITZEN_BANK_BUCH_LESEN_START')
				else:
					character.play_animation(char, 'CM_NPC_SITZEN_BANK_BUCH_LESEN_LOOP')
			else:
				if character.get_act_animation_name(char) in ['CM_NPC_SITZEN_BANK_BUCH_LESEN_START','CM_NPC_SITZEN_BANK_BUCH_LESEN_LOOP']:
					character.play_animation(char, 'CM_NPC_SITZEN_BANK_BUCH_LESEN_ENDE')
				character.play_animation(char, 'CM_NPC_SITZEN_BANK_LOOP')
	return None
	
def save_spitting_fire(character_id):
	party_list = system.get_pcs()
	for char in party_list:
		if objects.get_distance_to_object(char,character_id) < 4:
			return "perform_wait_command"
			
	spit_fire_helper(character_id)
	return None
			
#lambda c: zone_8_tent_helper(c, enterPoint, insidePoint, enter)
##########################
### Tagesabläufe:
##########################
schedules = {}

def init_schedules():
	global schedules
	schedules = {
"DAN" : {
	"00:00:00" : {
		S_START : [drugissuingoffice_drugissuer(S_START)],
		S_LOOP  : [drugissuingoffice_drugissuer(S_LOOP)],
	}
},
"RATSKULL_P_1" : ({
	S_CONDITION : lambda: data().ratskull_base_alarmed,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : (patrol(ROUTE_P1))
	}
},{
	"11:37:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='wait_drugs')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='wait_drugs')],
	},
	"12:15:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='sit_chair_2')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='sit_chair_2')],
	},
	"16:13:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='lay_bed')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='lay_bed')],
	},
	"17:32:00" : {
		S_START : [goto(638,282, "landscape"),
					turn_to_direction(225)],
		S_LOOP  : [global_schedules.wait()],
	},
}),

"RATSKULL_P_2" : ({
	S_CONDITION : lambda: data().ratskull_base_alarmed,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : (patrol(ROUTE_P2))
	}
},{
	"15:10:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='wait_drugs')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='wait_drugs')],
	},
	"16:20:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='sit_couch_2')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='sit_couch_2')],
	},
	"17:00:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='sit_bench_1')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='sit_bench_1')],
	},
	"19:00:00" : {
		S_START : [goto(638,398,"landscape"),
					turn_to_direction(300)],
		S_LOOP  : [global_schedules.wait()],
	},
}),

"RATSKULL_P_3" : ({
	S_CONDITION : lambda:data().ratskull_base_alarmed,
	"00:00:00" : {
		S_START : (),
		S_LOOP  : (patrol(ROUTE_P3))
	}
},{
	"09:45:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='wait_drugs')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='wait_drugs')],
	},
	"10:34:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='lay_bed')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='lay_bed')],
	},
	"15:45:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='sit_chair_3')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='sit_chair_3')],
	},
	"17:00:00" : {
		S_START : [goto(509,403,"landscape"),
					turn_to_direction(0)],
		S_LOOP  : [global_schedules.wait()],
	},
}),

"RATSKULL_P_4" : ({
	S_CONDITION : lambda: data().ratskull_base_alarmed,
	"15:40:00" : {
		S_START : (),
		S_LOOP  : (patrol(ROUTE_P4))
	}
},{
	"12:30:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='wait_drugs')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='wait_drugs')],
	},
	"15:00:00" : {
		S_START : [drugissuingoffice_drugtaker(S_START, action='sit_chair_4')],
		S_LOOP  : [drugissuingoffice_drugtaker(S_LOOP, action='sit_chair_4')],
	},
	"17:00:00" : {
		S_START : [goto(516,291,"landscape"),
					turn_to_direction(135)],
		S_LOOP  : [global_schedules.wait()],
	},
}),


"PHOENIX": {
	S_CONDITION : lambda:(data().phoenix_angeschossen and not data().phoenix_gesprochen),
	"00:00:00" : {
		S_START : (start_kneel()),
		S_LOOP  : (kneel())
	}
},

"OLIVIA": {
	"22:50:00" : {
	#Aktion: Schlafen
	S_START : (goto(315.4,662.6), 
			enter_building("BUILDING_299"),
			lay_down_to_sleep(bed="BUILDING_13152")),
	S_LOOP  : (sleep())
	},
	"04:00:00" : {
	#Aktion: Frühstücken am Lagerfeuer
	S_START : (leave_building("BUILDING_299"),
			goto_dummy("BUILDING_3336","dmyp_003"),
			sit_down_to_cook()),
	S_LOOP  : (cook())
	},
	"06:00:00" : {
	#Aktion: auf Bank Sitzen, Gitarre spielen
	S_START : (goto_dummy("BUILDING_3338","dmyp_001"),
			sit_down_on_bench()),
	S_LOOP  : (play_guitar_on_bench())
	},
	"14:00:00" : {
	#Aktion: auf dem Boden sitzen, Warten)
	S_START : (goto(346.4,688.1),
			turn_to_direction(DIR_EAST),
			sit_down_on_ground()),
	S_LOOP  : (sit_on_ground())
	}
},

"ZACHARY": {
	"05:00:00" : {
	#Aktion: Frühstücken am Lagerfeuer
	S_START : (goto_dummy("BUILDING_3337","dmyp_001"), 
			sit_down_on_bench()),
	S_LOOP  : (sit_eat_drink_on_bench)
	},
	"06:20:00" : {
	#Aktion: Rumstehen und Feuerspucken
	S_START : (goto(342.6,664.2),
			turn_to_direction(DIR_WEST),
			lambda c: equip_torch(c)),
	S_LOOP  : (lambda c: save_spitting_fire(c))
	},
	"13:45:00" : {
	#Aktion: Lagerfeuer sitzen, Gitarre spielen
	S_START : (lambda c: unequip_torch(c),
				goto_dummy("BUILDING_3337","dmyp_001"),
				sit_down_on_bench()),
	S_LOOP  : (play_guitar_on_bench())
	},
	"18:10:00" : {
	#Aktion: vor Haus sitzen, Warten
	S_START : (goto(336.6,689.0),
			turn_to_direction(DIR_WEST),
			sit_down_on_ground()),
	S_LOOP  : (sit_on_ground())
	}
},

"NICHOLAS": {
	"01:20:00" : {
	#Aktion: Schlafen
	S_START : (goto(275.5,735.4),
			enter_building("BUILDING_287"),
			lay_down_to_sleep()),
	S_LOOP  : (sleep())
	},
	"06:00:00" : {
	#Aktion: vor Haus stehen, Warten
	S_START : (leave_building("BUILDING_287"),
			goto(275.70, 721.68),
			turn_to_direction(DIR_NORTH)),
	S_LOOP  : (stand())
	},
	"12:10:00" : {
	#Aktion: Lagerfeuer sitzen (bei Natalie in der Nähe), Essen und Trinken
	S_START : (goto_dummy("BUILDING_3322","dmyp_001"),
			sit_down_on_bench()),
	S_LOOP  : (sit_eat_drink_on_bench)
	},
	"15:30:00" : {
	#Aktion: vor Haus stehen, Warten
	S_START : (goto(272.97, 718.88),
			turn_to_direction(DIR_NORTH)),
	S_LOOP  : (stand())
	}
},

"TIZOC": (
{	S_CONDITION  : lambda: data().Sekte_Ausgerottet1,
	"00:00:00":{
		S_START	:(goto(678,500)),
		S_LOOP	:(stand()),
	}
},	
{
	"23:15:00" : {
	#Aktion: Schlafen
	S_START : (goto(677.3,500.7),
			enter_building("BUILDING_446"),
			lay_down_to_sleep(bed='BUILDING_13650')),
	S_LOOP  : (sleep())
	},
	"03:20:00" : {
	#Aktion: vor Haus stehen, Warten
	S_START : (leave_building("BUILDING_446"),
			goto(676.5,497.3),
			turn_to_direction(DIR_EAST)),
	S_LOOP  : (stand())
	},
	"14:45:00" : {
	#Aktion: vor Haus sitzen, Warten
	S_START : (goto(677.3,500.7),
			turn_to_direction(DIR_EAST),
			sit_down_on_ground()),
	S_LOOP  : (sit_on_ground())
	},
	"21:30:00" : {
	#Aktion: am Lagerfeuer kochen
	S_START : (goto_dummy("BUILDING_447","dmyp_001"),
			sit_down_to_cook()),
	S_LOOP  : (cook())
	}
}),

"BRANDON": {
	"21:15:00" : {
	##Aktion: Schlafen
	S_START : (goto(349.3,763.4),
				enter_building("BUILDING_5793"),
				goto_dummy("BUILDING_13305","dmyp_001"),
				sit_down_on_bench()),
	S_LOOP  : (sit_on_bench())
	},
	"00:10:00" : {
	#Aktion: auf Grundstück umherlaufen
	S_START : (leave_building("BUILDING_5793"),
			lambda _c_: goto(random.choice(ROUTE_BRANDON))(_c_)),
	S_LOOP  : (stand())
	},
	"05:30:00" : {
	#Aktion: an Auto basteln
	S_START : (goto(336.5,771.5),
			stepto(336.5,771.5),
			turn_to_object("BUILDING_2647")),
	S_LOOP  : (work_on_machine())
	},
	"12:10:00" : {
	#Aktion: auf Grundstück herumstehen
	S_START : (goto(336.9,766.9),
			turn_to_direction(DIR_WEST)),
	S_LOOP  : (stand())
	}
},

"SCHLAEGER_1": {
	"21:15:00" : {
	#Aktion: Schlafen
	S_START : (goto(349.3,763.4),
			enter_building("BUILDING_5793"),
			lay_down_to_sleep(bed='BUILDING_13308')),
	S_LOOP  : (sleep())
	},
	"00:10:00" : {
	#Aktion: auf Grundstück herumstehen / sitzen
	S_START : (leave_building("BUILDING_5793"),
			goto(339,762),
			turn_to_direction(DIR_NORTH_WEST),
			sit_down_on_ground()),
	S_LOOP  : (sit_on_ground())
	},
	"04:25:00" : {
	#Aktion: ums Auto herumstehen / sitzen
	S_START : (goto(336,767),
			turn_to_object("BUILDING_2647")),
	S_LOOP  : (stand())
	},
	"13:40:00" : {
	#Aktion: auf Grundstück herumstehen / sitzen
	S_START : (goto(338,772),
			turn_to_direction(DIR_NORTH)),
	S_LOOP  : (stand())
	}
},

"SCHLAEGER_2": {
	"21:15:00" : {
	#Aktion: Schlafen
	S_START : (goto(349.3,763.4),
				enter_building("BUILDING_5793"),
				lay_down_to_sleep(bed='BUILDING_13312')),
	S_LOOP  : (sleep())
	},
	"00:10:00" : {
	#Aktion: auf Grundstück herumstehen / sitzen
	S_START : (leave_building("BUILDING_5793"),
				goto(341,774),
				turn_to_direction(DIR_WEST)),
	S_LOOP  : (stand())
	},
	"04:25:00" : {
	#Aktion: ums Auto herumstehen / sitzen
	S_START : (goto(334,769),
			turn_to_object("BUILDING_2647")),
	S_LOOP  : (stand())
	},
	"13:40:00" : {
	#Aktion: auf Grundstück herumstehen / sitzen
	S_START : (goto(345,763),
			turn_to_direction(DIR_WEST),
			sit_down_on_ground()),
	S_LOOP  : (sit_on_ground())
	}
},

"SCHLAEGER_3": {
	"21:15:00" : {
	#Aktion: Schlafen
	S_START : (goto(349.3,763.4),
			enter_building("BUILDING_5793"),
			goto_dummy('BUILDING_13304','dmyp_001'),
			sit_down_on_bench()),
	S_LOOP  : (sit_on_bench())
	},
	"00:10:00" : {
	#Aktion: auf Grundstück herumstehen / sitzen
	S_START : (leave_building("BUILDING_5793"),
				goto(339,774),
				turn_to_direction(DIR_NORTH_WEST),
				sit_down_on_ground()),
	S_LOOP  : (sit_on_ground())
	},
	"04:25:00" : {
	#Aktion: ums Auto herumstehen / sitzen
	S_START : (goto(338,772),
			turn_to_object("BUILDING_2647")),
	S_LOOP  : (stand())
	},
	"13:40:00" : {
	#Aktion: auf Grundstück herumstehen / sitzen
	S_START : (goto(338,772),
			turn_to_direction(DIR_NORTH_WEST)),
	S_LOOP  : (stand())
	}
},

"NATALIE" : ({ # Nicholas' Frau
	S_CONDITION : lambda:(data().Wesley_Ziel1 and
				data().Wesley_Ziel2 and
				 data().Wesley_Ziel3),

##########
	"00:00:00" : { # Schlafen
		S_START  : [Lambda('check_stand_up("NATALIE")'),
				goto(275.6,735.4),
				enter_building("BUILDING_287"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { # Lagerfeuer Kochen
		S_DIALOG : "NPC_NATALIE_T_001",
		S_START  : [Lambda('check_stand_up("NATALIE")'),
				goto_dummy("BUILDING_2527","dmyp_002"),
					sit_down_to_cook()],
		S_LOOP   : [cook()]},
	# General kommandiert, Milizen robben herum.
	"06:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_001"),)),
		S_START	: (goto(234,773)),
		S_LOOP	: (Lambda('character.change_body_mode("NATALIE", "LIE")'),
				goto(234,773),
				goto(209,777),
 				goto(217,810),
 				goto(236,796)),
	},
	# Auf Zielscheibe schießen
	"08:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_002"),)),
		S_START	: (Lambda('check_stand_up("NATALIE")'),
				goto(POINTS_SCHIESSEN[4][0],POINTS_SCHIESSEN[4][1]),
				turn_to_direction(DIR_EAST),
				start_hunt()),
		S_LOOP	: (hunt()),
	},
	# Marschieren
	"10:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_003"),)),
		S_START	: (Lambda('check_stand_up("NATALIE")'),
				end_hunt()),
		S_LOOP	: (patrol(ROUTE_MARSCHIEREN, circle=True)),
	},
	# Am Feuer sitzen, essen
	"12:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("NATALIE")'),
				goto(POINTS_ESSEN[4][0],POINTS_ESSEN[4][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_on_ground()),
	},
	# Beim Schrottplatz stehen und an den Schrottgegenständen hantieren (Taschendiebstahl-Animation u.ä.)
	"13:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_005"),)),
		S_START	: (Lambda('check_stand_up("NATALIE")'),
				goto(POINTS_SCHROTT[2][0],POINTS_SCHROTT[2][1]),
				turn_to_object(POINTS_SCHROTT[0][2])),
		S_LOOP	: (work_on_machine()),
	},
	# Am Feuer sitzen, essen
	"16:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),	# [BrainRipper]
		S_START	: (Lambda('check_stand_up("NATALIE")'),
				goto(POINTS_ESSEN[4][0],POINTS_ESSEN[4][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	"21:30:00" : { # Lagerfeuer Kochen
		S_DIALOG : "NPC_NATALIE_T_005",
		S_START  : [Lambda('check_stand_up("NATALIE")'),
				goto_object("BUILDING_2527"), turn_to_object("BUILDING_2527"),
					sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"23:00:00" : { # Essen
		S_DIALOG : "NPC_NATALIE_T_006",
		S_START  : [Lambda('check_stand_up("NATALIE")'),
				goto(264.55,731.97),
					sit_down_on_ground()],
		S_LOOP   : [sit_on_ground(actions = ['eat', 'drink'])]},
	S_SECONDDIALOG : "NPC_NATALIE_T_007"
},{
	"00:00:00" : { # Schlafen
		S_START  : [goto(275.6,735.4),
				enter_building("BUILDING_287"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { # Lagerfeuer Kochen
		S_DIALOG : "NPC_NATALIE_T_001",
		S_START  : [goto_dummy("BUILDING_2527","dmyp_002"),
					sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"06:00:00" : { # Waschen
		S_DIALOG : "NPC_NATALIE_T_002", # todo: Waschen einbauen
		S_START  : [goto_object("BUILDING_2548"),
				stepto(255.41, 737.03),
				turn_to_direction(347.08)],
		S_LOOP   : [wash_laundry()]},
	"12:00:00" : { # Lagerfeuer Kochen
		S_DIALOG : "NPC_NATALIE_T_003",
		S_START  : [goto_object("BUILDING_2527"),
				turn_to_object("BUILDING_2527"),
					sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"15:00:00" : { # Detektor führen
		S_DIALOG : "NPC_NATALIE_T_004",
		S_START  : [goto_find_water((228.05,752.04))],
		S_LOOP   : [find_water()]},
	"21:30:00" : { # Lagerfeuer Kochen
		S_DIALOG : "NPC_NATALIE_T_005",
		S_START  : [goto_object("BUILDING_2527"), turn_to_object("BUILDING_2527"),
					sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"23:00:00" : { # Essen
		S_DIALOG : "NPC_NATALIE_T_006",
		S_START  : [goto(264.55,731.97),
					sit_down_on_ground()],
		S_LOOP   : [sit_on_ground(actions = ['eat', 'drink'])]},
	S_SECONDDIALOG : "NPC_NATALIE_T_007"
}),

"PEGGY" : ({ # die Hühnerzüchterin
	S_CONDITION : lambda:(data().Wesley_Ziel1 and
				data().Wesley_Ziel2 and
				 data().Wesley_Ziel3),

##########
	"00:00:00" : { # Schlafen
		S_START  : [Lambda('check_stand_up("PEGGY")'),
				goto(241.3,733.5),
				enter_building("BUILDING_294"),
				lay_down_to_sleep(bed='BUILDING_13367')],
		S_LOOP   : [sleep()]},
	"04:30:00" : { # Tiere füttern
		S_DIALOG : "NPC_PEGGY_T_001",
		S_START  : [Lambda('check_stand_up("PEGGY")'),
				leave_building("BUILDING_294"), goto(296.90,760.65),
				start_feed_animal()],
		S_LOOP   : [feed_animal()]},
	# General kommandiert, Milizen robben herum.
	"06:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_001"),)),
		S_START	: (goto(234,773)),
		S_LOOP	: (Lambda('character.change_body_mode("PEGGY", "LIE")'),
				goto(234,773),
 				goto(209,777),
 				goto(217,810),
 				goto(236,796)),
	},
	# Auf Zielscheibe schießen
	"08:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_002"),)),
		S_START	: (Lambda('check_stand_up("PEGGY")'),
				goto(POINTS_SCHIESSEN[5][0],POINTS_SCHIESSEN[5][1]),
				turn_to_direction(DIR_EAST),
				start_hunt()),
		S_LOOP	: (hunt()),
	},
	# Marschieren
	"10:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_003"),)),
		S_START	: (Lambda('check_stand_up("PEGGY")'),
				end_hunt()),
		S_LOOP	: (patrol(ROUTE_MARSCHIEREN, circle=True)),
	},
	# Am Feuer sitzen, essen
	"12:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("PEGGY")'),
				goto(POINTS_ESSEN[5][0],POINTS_ESSEN[5][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_on_ground()),
	},
	# Beim Schrottplatz stehen und an den Schrottgegenständen hantieren (Taschendiebstahl-Animation u.ä.)
	"13:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_005"),)),
		S_START	: (Lambda('check_stand_up("PEGGY")'),
				goto(POINTS_SCHROTT[3][0],POINTS_SCHROTT[3][1]),
				turn_to_object(POINTS_SCHROTT[0][2])),
		S_LOOP	: (work_on_machine()),
	},
	# Am Feuer sitzen, essen
	"16:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),	# [BrainRipper]
		S_START	: (Lambda('check_stand_up("PEGGY")'),
				goto(POINTS_ESSEN[5][0],POINTS_ESSEN[5][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	"21:30:00" : { # Tiere füttern
		S_DIALOG : "NPC_PEGGY_T_005",
		S_START  : [Lambda('check_stand_up("PEGGY")'),
				goto(296.90,760.65),
					start_feed_animal()],
		S_LOOP   : [feed_animal()]},
	"23:00:00" : { # Am Feuer sitzen
		S_DIALOG : "NPC_PEGGY_T_006",
		S_START  : [Lambda('check_stand_up("PEGGY")'),
				goto_object("BUILDING_2527"), turn_to_object("BUILDING_2527"),
					sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_PEGGY_T_007"
},{
	"00:00:00" : { # Schlafen
		S_START  : [goto(241.3,733.5),
				enter_building("BUILDING_294"),
				lay_down_to_sleep(bed='BUILDING_13367')],
		S_LOOP   : [sleep()]},
	"04:30:00" : { # Tiere füttern
		S_DIALOG : "NPC_PEGGY_T_001",
		S_START  : [goto(296.90,760.65),
				start_feed_animal()],
		S_LOOP   : [feed_animal()]},
	"06:00:00" : { # Gehege fegen
		S_DIALOG : "NPC_PEGGY_T_002",
		S_START  : [goto(296.90,760.65),
					start_sweep()],
		S_LOOP   : [sweep()]},
	"12:00:00" : { # Lagerfeuer Kochen
		#S_NOSTOP : [5],
		S_DIALOG : "NPC_PEGGY_T_003",
		S_START  : [goto_dummy("BUILDING_2527","dmyp_003"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"15:00:00" : { # Sitzen
		#S_NOSTOP : [4],
		S_DIALOG : "NPC_PEGGY_T_004",
		S_START  : [goto(291.90,766.91), turn_to_direction(DIR_SOUTH),
					sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"21:30:00" : { # Tiere füttern
		S_DIALOG : "NPC_PEGGY_T_005",
		S_START  : [goto(296.90,760.65),
					start_feed_animal()],
		S_LOOP   : [feed_animal()]},
	"23:00:00" : { # Am Feuer sitzen
		S_DIALOG : "NPC_PEGGY_T_006",
		S_START  : [goto_object("BUILDING_2527"), turn_to_object("BUILDING_2527"),
					sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_PEGGY_T_007"
}),

"LINDSAY" : { # die Alte
##########
	"00:00:00" : { # Schlafen
		S_START  : [goto(282.7,758.6),
				enter_building("BUILDING_295"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"04:30:00" : { # Am Feuer
		S_DIALOG : "NPC_LINDSAY_T_001",
		S_START  : [leave_building("BUILDING_295"), goto_dummy("BUILDING_3322","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"06:00:00" : { # Sitzen
		S_DIALOG : "NPC_LINDSAY_T_002",
		S_START  : [goto(239.40,757.81),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"12:00:00" : { # Rumlaufen
		S_DIALOG : "NPC_LINDSAY_T_003",
		S_START  : [goto_object("BUILDING_2527")],
		S_LOOP   : []},
	"15:00:00" : { # Beim Holzhacken zusehen
		S_DIALOG : "NPC_LINDSAY_T_004",
		S_START  : [goto(340.59,777.40)],
		S_LOOP   : []},
	"21:30:00" : { # Am Feuer sitzen
		S_DIALOG : "NPC_LINDSAY_T_005",
		S_START  : [goto_object("BUILDING_2527"),
				turn_to_object("BUILDING_2527"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	"23:00:00" : { # Schlafen
		S_START  : [goto(289.64,755.09),
					lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	S_SECONDDIALOG : "NPC_LINDSAY_T_006"
},

"PETER" : {
##########
	"22:00:00" : { # Schlafen
		S_START  : [goto(316.25,622.67),
				enter_building("BUILDING_299"),
				lay_down_to_sleep(bed="BUILDING_13153")],
		S_LOOP   : [sleep()]},
	"06:00:00" : { # Frühstücken
		S_DIALOG : "NPC_PETER_T_001",
		S_START  : [leave_building("BUILDING_299"), goto_dummy("BUILDING_3325","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"07:00:00" : { # Spaziergang
		S_DIALOG : "NPC_PETER_T_002",
		S_START  : [lambda _c_: goto(ROUTE_TA_PETER[data().counter_route_ta_peter])(_c_),
				route],
		S_LOOP   : [lambda _c_: goto(ROUTE_TA_PETER[data().counter_route_ta_peter])(_c_),
				route]},
	"12:00:00" : { # Mittagessen
		S_DIALOG : "NPC_PETER_T_003",
		S_START  : [goto_dummy("BUILDING_3325","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"13:00:00" : { # Dösen
		S_DIALOG : "NPC_PETER_T_004",
		S_START  : [goto_dummy("BUILDING_3325","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"14:00:00" : { # Spaziergang
		S_DIALOG : "NPC_PETER_T_005",
		S_START  : [lambda _c_: goto(ROUTE_TA_PETER[data().counter_route_ta_peter])(_c_),
				route],
		S_LOOP   : [lambda _c_: goto(ROUTE_TA_PETER[data().counter_route_ta_peter])(_c_),
				route]},
	"16:00:00" : { # Ein Buch lesen
		S_DIALOG : "NPC_PETER_T_006",
		S_START  : [goto_dummy("BUILDING_3325","dmyp_001"),
						sit_down_on_bench()],
		S_LOOP   : [read_book_on_bench()]},
	"19:00:00" : { # Lagerfeuer Action
		S_DIALOG : switchDialog(data().general_quest_beendet,"NPC_PETER_T_007","NPC_PETER_T_008"),
		S_START  : [goto(251,720),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()],
		S_LOOP   : [sit_on_ground()]},
	S_SECONDDIALOG : "NPC_PETER_T_009"
},

## Mehmet, ( Angelo )der Mechaniker
"MEHMET" : ({
	S_CONDITION : lambda:(data().Wesley_Ziel1 and
				data().Wesley_Ziel2 and
				 data().Wesley_Ziel3),

##########
	"00:00:00" : { # Wache schieben (ab und zu im Schrottplatz patrouillieren, sonst am Feuer sitzen)
		S_DIALOG : "NPC_MEHMET_T_001",
		S_START  : [Lambda('check_stand_up("MEHMET")'),
				lambda _c_:goto(random.choice(ROUTE_TA_WACHE_SCHROTTPLATZ))(_c_),
				stand()],
		S_LOOP   : [lambda _c_:goto(random.choice(ROUTE_TA_WACHE_SCHROTTPLATZ))(_c_),
				stand(),
				stand(),
				stand()]},
	"04:30:00" : { # Schlafen
		S_START  : [Lambda('check_stand_up("MEHMET")'),
				goto(232.2,619.3),
				enter_building("BUILDING_415"),
				lay_down_to_sleep(bed="BUILDING_13125")],
		S_LOOP   : [sleep()]},
	# General kommandiert, Milizen robben herum.
	"06:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_001"),)),
		S_START	: (goto(234,773)),
		S_LOOP	: (Lambda('character.change_body_mode("MEHMET", "LIE")'),
				goto(234,773),
 				goto(209,777),
 				goto(217,810),
 				goto(236,796)),
	},
	# Auf Zielscheibe schießen
	"08:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_002"),)),
		S_START	: (Lambda('check_stand_up("MEHMET")'),
				goto(POINTS_SCHIESSEN[6][0],POINTS_SCHIESSEN[6][1]),
				turn_to_direction(DIR_EAST),
				start_hunt()),
		S_LOOP	: (hunt()),
	},
	# Marschieren
	"10:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_003"),)),
		S_START	: (Lambda('check_stand_up("MEHMET")'),
				end_hunt()),
		S_LOOP	: (patrol(ROUTE_MARSCHIEREN, circle=True)),
	},
	# Am Feuer sitzen, essen
	"12:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("MEHMET")'),
				goto(POINTS_ESSEN[6][0],POINTS_ESSEN[6][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_on_ground()),
	},
	# Beim Schrottplatz stehen und an den Schrottgegenständen hantieren (Taschendiebstahl-Animation u.ä.)
	"13:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_005"),)),
		S_START	: (Lambda('check_stand_up("MEHMET")'),
				goto(POINTS_SCHROTT[0][0],POINTS_SCHROTT[0][1]),
				turn_to_object(POINTS_SCHROTT[0][2])),
		S_LOOP	: (work_on_machine()),
	},
	# Am Feuer sitzen, essen
	"16:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),	# [BrainRipper]
		S_START	: (Lambda('check_stand_up("MEHMET")'),
				goto(POINTS_ESSEN[6][0],POINTS_ESSEN[6][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	"21:30:00" : { # Am Feuer sitzen und essen
		S_DIALOG : "NPC_MEHMET_T_005",
		S_START  : [Lambda('check_stand_up("MEHMET")'),
				goto_dummy("BUILDING_2457","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"23:00:00" : { # Mit Ali Karten spielen
		S_DIALOG : "NPC_MEHMET_T_006",
		S_START  : [Lambda('check_stand_up("MEHMET")'),
				goto(231.0,632.0),
				turn_to_object("ALI"),
				sit_down_to_play_cards()],
		S_LOOP   : [play_cards()]},
	S_SECONDDIALOG : "NPC_MEHMET_T_007"
},{
	"00:00:00" : { # Wache schieben (ab und zu im Schrottplatz patrouillieren, sonst am Feuer sitzen)
		S_DIALOG : "NPC_MEHMET_T_001",
		S_START  : [lambda _c_:goto(random.choice(ROUTE_TA_WACHE_SCHROTTPLATZ))(_c_),
				stand()],
		S_LOOP   : [lambda _c_:goto(random.choice(ROUTE_TA_WACHE_SCHROTTPLATZ))(_c_),
				stand(),
				stand(),
				stand()]},
	"04:30:00" : { # Schlafen
		S_START  : [goto(232.2,619.3),
				enter_building("BUILDING_415"),
				lay_down_to_sleep(bed="BUILDING_13125")],
		S_LOOP   : [sleep()]},
	"06:00:00" : { # Unter Wagen kriechen, an Motorrad rumschrauben
		S_DIALOG : "NPC_MEHMET_T_002",
		S_START  : [goto_dummy("BUILDING_3345", "dmyp_001"),
				start_repair_motorbike("BUILDING_3345")],
		S_LOOP   : [repair_motorbike()]},
	"12:00:00" : { # Am Feuer Kochen, Essen
		S_DIALOG : "NPC_MEHMET_T_003",
		S_START  : [goto_dummy("BUILDING_2455","dmyp_003"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"15:00:00" : { # Am Tisch sitzen und schreiben
		S_DIALOG : "NPC_MEHMET_T_004",
		S_START  : [goto_dummy("BUILDING_2458","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [write_on_bench()]},
	"21:30:00" : { # Am Feuer sitzen und essen
		S_DIALOG : "NPC_MEHMET_T_005",
		S_START  : [goto_dummy("BUILDING_2457","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"23:00:00" : { # Mit Ali Karten spielen
		S_DIALOG : "NPC_MEHMET_T_006",
		S_START  : [goto(231.0,632.0),
				turn_to_object("ALI"),
				sit_down_to_play_cards()],
		S_LOOP   : [play_cards()]},
	S_SECONDDIALOG : "NPC_MEHMET_T_007"
}),

## Ali (GIORGIO), Mehmets (ANGELOS) Bruder
"ALI" : ({
	S_CONDITION : lambda:(data().Wesley_Ziel1 and
				data().Wesley_Ziel2 and
				 data().Wesley_Ziel3),
##########
	"00:00:00" : { # Schlafen
		S_START  : [Lambda('check_stand_up("ALI")'),
				goto(232.2,619.3),
				enter_building("BUILDING_415"),
				lay_down_to_sleep(bed="BUILDING_13126")],
		S_LOOP   : [sleep()]},
	"04:30:00" : { # Wache schieben (ab und zu im Schrottplatz patrouillieren, sonst am Feuer sitzen)
		S_DIALOG : "NPC_ALI_T_001",
		S_START  : [Lambda('check_stand_up("ALI")'),
				lambda _c_:goto(random.choice(ROUTE_TA_WACHE_SCHROTTPLATZ))(_c_),
				stand()],
		S_LOOP   : [lambda _c_:goto(random.choice(ROUTE_TA_WACHE_SCHROTTPLATZ))(_c_),
				stand(),
				stand(),
				stand()]},
	# General kommandiert, Milizen robben herum.
	"06:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_001"),)),
		S_START	: (goto(234,773)),
		S_LOOP	: (Lambda('character.change_body_mode("ALI", "LIE")'),
				goto(234,773),
 				goto(209,777),
 				goto(217,810),
 				goto(236,796)),
	},
	# Auf Zielscheibe schießen
	"08:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_002"),)),
		S_START	: (Lambda('check_stand_up("ALI")'),
				goto(POINTS_SCHIESSEN[7][0],POINTS_SCHIESSEN[7][1]),
				turn_to_direction(DIR_EAST),
				start_hunt()),
		S_LOOP	: (hunt()),
	},
	# Marschieren
	"10:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_003"),)),
		S_START	: (Lambda('check_stand_up("ALI")'),
				end_hunt()),
		S_LOOP	: (patrol(ROUTE_MARSCHIEREN, circle=True)),
	},
	# Am Feuer sitzen, essen
	"12:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("ALI")'),
				goto(POINTS_ESSEN[7][0],POINTS_ESSEN[7][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_on_ground()),
	},
	# Beim Schrottplatz stehen und an den Schrottgegenständen hantieren (Taschendiebstahl-Animation u.ä.)
	"13:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_005"),)),
		S_START	: (Lambda('check_stand_up("ALI")'),
				goto(POINTS_SCHROTT[1][0],POINTS_SCHROTT[1][1]),
				turn_to_object(POINTS_SCHROTT[0][2])),
		S_LOOP	: (work_on_machine()),
	},
	# Am Feuer sitzen, essen
	"16:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),	# [BrainRipper]
		S_START	: (Lambda('check_stand_up("ALI")'),
				goto(POINTS_ESSEN[7][0],POINTS_ESSEN[7][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	"21:30:00" : { # Am Feuer kochen und essen
		S_DIALOG : "NPC_ALI_T_005",
		S_START  : [Lambda('check_stand_up("ALI")'),
				goto_dummy("BUILDING_2455","dmyp_001"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"23:00:00" : { # Mit Mehmet Karten spielen
		S_DIALOG : "NPC_ALI_T_006",
		S_START  : [Lambda('check_stand_up("ALI")'),
				goto(230.0,633.0),
				turn_to_object("MEHMET"),
				sit_down_to_play_cards()],
		S_LOOP   : [play_cards()]},
	S_SECONDDIALOG : "NPC_ALI_T_007"
},{
	"00:00:00" : { # Schlafen
		S_START  : [goto(232.2,619.3),
				enter_building("BUILDING_415"),
				lay_down_to_sleep(bed="BUILDING_13126")],
		S_LOOP   : [sleep()]},
	"04:30:00" : { # Wache schieben (ab und zu im Schrottplatz patrouillieren, sonst am Feuer sitzen)
		S_DIALOG : "NPC_ALI_T_001",
		S_START  : [lambda _c_:goto(random.choice(ROUTE_TA_WACHE_SCHROTTPLATZ))(_c_),
				stand()],
		S_LOOP   : [lambda _c_:goto(random.choice(ROUTE_TA_WACHE_SCHROTTPLATZ))(_c_),
				stand(),
				stand(),
				stand()]},
	"06:00:00" : { # Holzhacken beim Schrottplatz
		S_DIALOG : "NPC_ALI_T_002",
		S_START  : [goto_dummy("BUILDING_3341","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"12:00:00" : { # Am Feuer sitzen und essen
		S_DIALOG : "NPC_ALI_T_003",
		S_START  : [goto_dummy("BUILDING_2457","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"15:00:00" : { # Jagen
		S_DIALOG : "NPC_ALI_T_004",
		S_START  : [goto(213.0,645.0),
				turn_to_direction(DIR_WEST),
				start_hunt()],
		S_LOOP   : [hunt()]},
	"21:30:00" : { # Am Feuer kochen und essen
		S_DIALOG : "NPC_ALI_T_005",
		S_START  : [goto_dummy("BUILDING_2455","dmyp_001"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"23:00:00" : { # Mit Mehmet Karten spielen
		S_DIALOG : "NPC_ALI_T_006",
		S_START  : [goto(230.0,633.0),
				turn_to_object("MEHMET"),
				sit_down_to_play_cards()],
		S_LOOP   : [play_cards()]},
	S_SECONDDIALOG : "NPC_ALI_T_007"
}),

## Aysha (SILVANA), Mustafas (UMBERTO) Schwester
"AYSHA" : {
##########
	"00:00:00" : { # Schlafen
		S_START  : [goto(232.2,619.3),
				enter_building("BUILDING_415"),
				lay_down_to_sleep(bed="BUILDING_13127")],
		S_LOOP   : [sleep()]},
	"06:00:00" : { # Fegen
		S_DIALOG : "NPC_AYSHA_T_001",
		S_START  : [lambda _c_:goto(random.choice(ROUTE_TA_AYSHA_FEGEN_1))(_c_)],
		S_LOOP   : [lambda _c_:goto(random.choice(ROUTE_TA_AYSHA_FEGEN_1))(_c_),
				sweep()]},
	"12:00:00" : { # Fegen
		S_DIALOG : "NPC_AYSHA_T_002",
		S_START  : [lambda _c_:goto(random.choice(ROUTE_TA_AYSHA_FEGEN_2))(_c_)],
		S_LOOP   : [lambda _c_:goto(random.choice(ROUTE_TA_AYSHA_FEGEN_2))(_c_),
				sweep()]},
	"15:00:00" : { # Buch lesen
		S_DIALOG : "NPC_AYSHA_T_003",
		S_START  : [goto_dummy("BUILDING_2458","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [read_book_on_bench()]},
	"21:30:00" : { # Am Feuer sitzen und essen
		S_DIALOG : "NPC_AYSHA_T_004",
		S_START  : [goto_dummy("BUILDING_2458","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"23:00:00" : { # Flöte spielen
		S_DIALOG : "NPC_AYSHA_T_005",
		S_START  : [goto_dummy("BUILDING_2458","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [play_fluit_on_bench()]},
	S_SECONDDIALOG : "NPC_AYSHA_T_005"
},

## Connor, Tunichtgut und Alkoholiker
"CONNOR" : {
##########
	"00:00:00" : { # Schlafen
		S_START  : [goto(346.7,763.0),
					enter_building("BUILDING_5793"),
					lay_down_to_sleep(bed='BUILDING_13310')],
		S_LOOP   : [sleep()]},
	"06:00:00" : { # Rumsitzen, Essen und Trinken 
		S_DIALOG : "NPC_CONNOR_T_001",
		S_START  : [leave_building("BUILDING_5793"),
						goto_dummy("BUILDING_3337","dmyp_003"),
						sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"12:00:00" : { # Waffe reinigen
		S_DIALOG : "NPC_CONNOR_T_002",
		S_START  : [goto(341.0,745.0),
				turn_to_direction(DIR_WEST),
				start_clean_weapon()],
		S_LOOP   : [clean_weapon()]},
	"15:00:00" : { # Holz hacken
		S_DIALOG : "NPC_CONNOR_T_003",
		S_START  : [goto_dummy("BUILDING_3342","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"21:30:00" : { # Trinken
		S_DIALOG : "NPC_CONNOR_T_004",
		S_START  : [goto_dummy("BUILDING_3337","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink"])]},
	"23:00:00" : { # Trinken
		S_DIALOG : "NPC_CONNOR_T_005",
		S_START  : [goto_dummy("BUILDING_3337","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink"])]},
	S_SECONDDIALOG : "NPC_CONNOR_T_006"
},

## Gavin
"GAVIN" : {
##########
	"00:00:00" : { # Schlafen
		S_START  : [goto(346.7,763.0),
					enter_building("BUILDING_5793"),
					lay_down_to_sleep(bed='BUILDING_13309')],
		S_LOOP   : [sleep()]},
	"06:00:00" : { # An einem Brett rumsägen ## todo: brett
		S_DIALOG : "NPC_GAVIN_T_001",
		S_START  : [leave_building("BUILDING_5793"),
						goto(240.09, 793.84),
						stepto(241.08, 792.53),
						turn_to_direction(41.5),
						start_saw_board()],
		S_LOOP   : [saw_board()]},
	"12:00:00" : { # Schnitzen ## fixme: obsolete schnitzen fehlt noch
		S_DIALOG : "NPC_GAVIN_T_002",
		S_START  : [goto_dummy("BUILDING_3338","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"15:00:00" : { # Am Tisch sitzen und zeichnen.## fixme: obsolete
		S_DIALOG : "NPC_GAVIN_T_003",
		S_START  : [goto_dummy("BUILDING_3338","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [write_on_bench()]},
	"21:30:00" : { # Essen, Trinken zubereiten
		S_DIALOG : "NPC_GAVIN_T_004",
		S_START  : [goto_dummy("BUILDING_3336","dmyp_005"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"23:00:00" : { # Trinken
		S_DIALOG : "NPC_GAVIN_T_005",
		S_START  : [goto_dummy("BUILDING_3338","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench(["drink","sit"])]},
	S_SECONDDIALOG : "NPC_GAVIN_T_006"
},

## Raymond
"RAYMOND" : {
##########
	"23:00:00" : { # Schlafen
		S_START  : [goto(314.5,690.5),
				enter_building("BUILDING_288"),
				lay_down_to_sleep(bed="BUILDING_13267")],
		S_LOOP   : [sleep()]},
	"06:00:00" : { # Joggen im Dorf
		S_DIALOG : "NPC_RAYMOND_T_001",
		S_START  : [lambda _c_: goto(ROUTE_TA_RAYMOND[data().counter_route_ta_raymond])(_c_),
				route],
		S_LOOP   : [lambda _c_: goto(ROUTE_TA_RAYMOND[data().counter_route_ta_raymond])(_c_),
				route]},
	"08:30:00" : { #Frühstücken
		S_DIALOG : "NPC_RAYMOND_T_002",
		S_START  : [goto_dummy("BUILDING_3337","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"10:00:00" : { # Holz hacken
		S_DIALOG : "NPC_RAYMOND_T_003",
		S_START  : [goto_dummy("BUILDING_3342","dmyp_001"),
				start_chop_wood()],
		S_LOOP   : [chop_wood()]},
	"12:30:00" : { # Mittagessen
		S_DIALOG : "NPC_RAYMOND_T_004",
		S_START  : [goto_dummy("BUILDING_3337","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"13:30:00" : { # Waffe reinigen
		S_DIALOG : "NPC_RAYMOND_T_005",
		S_START  : [goto(300.5,692.3),
				turn_to_direction(DIR_WEST),
				start_clean_weapon()],
		S_LOOP   : [clean_weapon()]},
	"16:00:00" : { # Dösen
		S_DIALOG : "NPC_RAYMOND_T_006",
		S_START  : [goto_dummy("BUILDING_3337","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"20:00:00" : { # Lagerfeueraction ## todo: milizstart
		S_DIALOG : switchDialog(data().general_quest_beendet,"NPC_RAYMOND_T_007","NPC_RAYMOND_T_008"),
		S_START  : [goto(350,683),
				turn_to_object("BUILDING_3336")],
		S_LOOP   : [stand()]},
	S_SECONDDIALOG : "NPC_RAYMOND_T_009"
},

## EGON
"EGON" : {
##########
	"21:00:00" : { # Schlafen
		S_START  : [goto(314.5,690.5),
				enter_building("BUILDING_288"),
				lay_down_to_sleep(bed="BUILDING_13268")],
		S_LOOP   : [sleep()]},
	"06:00:00" : { # Frühstücken
		S_DIALOG : "NPC_EGON_T_001",
		S_START  : [goto_dummy("BUILDING_3324","dmyp_002"),
				sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"07:00:00" : { # Im Dorf spazieren gehen
		S_DIALOG : "NPC_EGON_T_002",
		S_START  : [lambda _c_: goto(ROUTE_TA_EGON[data().counter_route_ta_egon])(_c_),
				route],
		S_LOOP   : [lambda _c_: goto(ROUTE_TA_EGON[data().counter_route_ta_egon])(_c_),
				route]},
	"11:00:00" : { # Dösen
		S_DIALOG : "NPC_EGON_T_003",
		S_START  : [goto_dummy("BUILDING_3324","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"13:00:00" : { # Mittagessen kochen
		S_DIALOG : "NPC_EGON_T_004",
		S_START  : [goto_dummy("BUILDING_3323","dmyp_001"),
				sit_down_to_cook()],
		S_LOOP   : [cook()]},
	"14:00:00" : { # Dösen
		S_DIALOG : "NPC_EGON_T_005",
		S_START  : [goto_dummy("BUILDING_3324","dmyp_001"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"16:00:00" : { # Konversation mit Janine
		S_DIALOG : "NPC_EGON_T_006",
		S_START  : [goto(312.0,721.0),
				turn_to_object("JANINE")],
		S_LOOP   : [conversate("JANINE")]},
	"18:00:00" : { # Lagerfeueraction
		S_DIALOG : "NPC_EGON_T_007",
		S_START  : [goto_dummy("BUILDING_3324","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	S_SECONDDIALOG : "NPC_EGON_T_008"
},

## JANINE
"JANINE" : {
##########
	"22:00:00" : { # Schlafen
		S_START  : [goto(304.6,720.6),
				enter_building("BUILDING_292"),
				lay_down_to_sleep()],
		S_LOOP   : [sleep()]},
	"06:00:00" : { # Frühstücken
		S_DIALOG : "NPC_JANINE_T_001",
		S_START  : [leave_building("BUILDING_292"), goto_dummy("BUILDING_3324","dmyp_001"),
					sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"08:00:00" : { # Joggen im Dorf
		S_DIALOG : "NPC_JANINE_T_002",
		S_START  : [lambda _c_: goto(ROUTE_TA_JANINE[data().counter_route_ta_janine])(_c_),
				route],
		S_LOOP   : [lambda _c_: goto(ROUTE_TA_JANINE[data().counter_route_ta_janine])(_c_),
				route]},
	"12:30:00" : { # Mittagessen
		S_DIALOG : "NPC_JANINE_T_003",
		S_START  : [goto_dummy("BUILDING_3325","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : sit_eat_drink_on_bench},
	"13:00:00" : { # Gitarre spielen
		S_DIALOG : "NPC_JANINE_T_004",
		S_START  : [goto_dummy("BUILDING_3325","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [play_guitar_on_bench()]},
	"15:00:00" : { # Dösen
		S_DIALOG : "NPC_JANINE_T_005",
		S_START  : [goto_dummy("BUILDING_3324","dmyp_003"),
				sit_down_on_bench()],
		S_LOOP   : [sit_on_bench()]},
	"16:00:00" : { # Konversation mit Egon
		S_DIALOG : "NPC_JANINE_T_006",
		S_START  : [goto(310.0,719.0),
				turn_to_object("EGON")],
		S_LOOP   : [conversate("EGON")]},
	"18:00:00" : { # Lagerfeueraction
		S_DIALOG : switchDialog(data().general_quest_beendet,"NPC_JANINE_T_007","NPC_JANINE_T_008"),
		S_START  : [goto(252,724),
				turn_to_object("BUILDING_3323")],
		S_LOOP   : [stand()]},
	S_SECONDDIALOG : "NPC_JANINE_T_009"
},

# quest npcs:
### family
"PAULA" : ({
	S_CONDITION : lambda : not data().Familie_wird_Eskortiert,
	# schlafen
	"23:45:00" : {
		S_START : (goto(254.0,694.0),
				lay_down_to_sleep()),
		S_LOOP	: (sleep())
	},
	# rumlaufen
	"02:30:00" : {
		S_START : (goto(random.choice(ROUTE_TA_NPC_FAMILY))),
		S_LOOP	: (lambda _c_:goto(random.choice(ROUTE_TA_NPC_FAMILY))(_c_))
	},
	# rumstehen
	"11:20:00" : {
		S_START : (goto(259.5,694.4),
				turn_to_object("BUILDING_3123")),
		S_LOOP	: (stand())
	},
	# rumsitzen
	"18:00:00" : {
		S_START : (goto(254.0,694.0),
				turn_to_object("BUILDING_3123"),
				sit_down_on_ground()),
		S_LOOP	: (sit_on_ground())
	},
},{# EGO folgen
	S_CONDITION: lambda: not data().Familie_bleibt_stehen,
	"00:00:00" : {
		S_START :[],
		S_LOOP	:[global_schedules.follow_in_distance("ALTER_EGO")]
	}
}),

"IAN" : ({
	S_CONDITION : lambda : not data().Familie_wird_Eskortiert,
	# rumsitzen
	"19:20:00" : {
		S_START : (goto(254.5,694.5),
				turn_to_object("BUILDING_3123"),
				sit_down_on_ground()),
		S_LOOP	: (sit_on_ground())
	},
	# rumstehen
	"02:00:00" : {
		S_START : (goto(256.7,694.8),
				turn_to_object("BUILDING_3123")),
		S_LOOP	: (stand())
	},
	# rumlaufen
	"10:15:00" : {
		S_START : (goto(random.choice(ROUTE_TA_NPC_FAMILY))),
		S_LOOP	: (lambda _c_:goto(random.choice(ROUTE_TA_NPC_FAMILY))(_c_))
	},
	# schlafen
	"14:30:00" : {
		S_START : (goto(254.5,694.5),
				lay_down_to_sleep()),
		S_LOOP	: (sleep())
	},
},{# EGO folgen
	S_CONDITION: lambda: not data().Familie_bleibt_stehen,
	"00:00:00" : {
		S_START :[],
		S_LOOP	:[global_schedules.follow_in_distance("ALTER_EGO")]
	}
}),

"LINDA" : ({
	S_CONDITION : lambda : not data().Familie_wird_Eskortiert,
	# rumstehen
	"22:15:00" : {
		S_START : (goto(258.6,695.2),
				turn_to_object("BUILDING_3123")),
		S_LOOP	: (stand())
	},
	# rumsitzen
	"03:15:00" : {
		S_START : (goto(254.0,694.5),
				turn_to_object("BUILDING_3123"),
				sit_down_on_ground()),
		S_LOOP	: (sit_on_ground())
	},
	# schlafen
	"08:20:00" : {
		S_START : (goto(254.0,694.5),
				lay_down_to_sleep()),
		S_LOOP	: (sleep())
	},
	# rumlaufen
	"12:20:00" : {
		S_START : (goto(random.choice(ROUTE_TA_NPC_FAMILY))),
		S_LOOP	: (lambda _c_:goto(random.choice(ROUTE_TA_NPC_FAMILY))(_c_))
	},
},{# EGO folgen
	S_CONDITION: lambda: not data().Familie_bleibt_stehen,
	"00:00:00" : {
		S_START :[],
		S_LOOP	:[global_schedules.follow_in_distance("ALTER_EGO")]
	}
}),

"RATSKULL_DRUG_MULE_1" : {
	"00:00:00" : {
		S_START  : [lambda _c_: goto(ROUTE_RS_DRUGMULE_1[data().counter_route_rs_drugmule_1])(_c_),
				route],
		S_LOOP   : [lambda _c_: goto(ROUTE_RS_DRUGMULE_1[data().counter_route_rs_drugmule_1])(_c_),
				route]
	}
},
"RATSKULL_DRUG_MULE_2" : {
	"00:00:00" : {
		S_START  : [lambda _c_: goto(ROUTE_RS_DRUGMULE_2[data().counter_route_rs_drugmule_2])(_c_),
				route],
		S_LOOP   : [lambda _c_: goto(ROUTE_RS_DRUGMULE_2[data().counter_route_rs_drugmule_2])(_c_),
				route]
	}
},
"RATSKULL_DRUG_MULE_3" : {
	"00:00:00" : {
		S_START  : [lambda _c_: goto(ROUTE_RS_DRUGMULE_3[data().counter_route_rs_drugmule_3])(_c_),
				route],
		S_LOOP   : [lambda _c_: goto(ROUTE_RS_DRUGMULE_3[data().counter_route_rs_drugmule_3])(_c_),
				route]
	}
},

"RECRUIT_SANCHEZ" : ({
	S_CONDITION : lambda: data().recruit_ta_active,

	# General kommandiert, Milizen robben herum.
	"06:00:00" : {
		S_LOCATION: 1,
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_001"),)),
		S_START	: (goto(234,773)),
		S_LOOP	: (Lambda('character.change_body_mode("RECRUIT_SANCHEZ", "LIE")'),
				goto(234,773),
				goto(209,777),
				goto(217,810),
				goto(236,796)),
	},
	# Auf Zielscheibe schießen
	"08:00:00" : {
		S_LOCATION: 2,
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_002"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_SANCHEZ")'),
				goto(POINTS_SCHIESSEN[3][0],POINTS_SCHIESSEN[3][1]),
				#goto(238.0,788.0),
				turn_to_direction(DIR_EAST),
				start_hunt()),
		S_LOOP	: (hunt()),
	},
	# Marschieren
	"10:00:00" : {
		S_LOCATION: 3,
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_003"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_SANCHEZ")'),
				end_hunt()),
		S_LOOP	: (patrol(ROUTE_MARSCHIEREN, circle=True)),
	},
	# Medizinische Ausbildung (Herzdruckmassage o.ä.)
	"12:00:00" : {
		S_LOCATION: 4,
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_SANCHEZ")'),
				goto(POINTS_ESSEN[3][0],POINTS_ESSEN[3][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	# Beim Schrottplatz stehen und an den Schrottgegenständen hantieren (Taschendiebstahl-Animation u.ä.)
	"13:00:00" : {
		S_LOCATION: 5,
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_005"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_SANCHEZ")'),
				goto(POINTS_SCHROTT[3][0],POINTS_SCHROTT[3][1]),
				turn_to_object(POINTS_SCHROTT[3][2])),
		S_LOOP	: (work_on_machine()),
	},
	# Am Feuer sitzen, essen
	"16:00:00" : {
		S_LOCATION: 6,
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_SANCHEZ")'),
				goto(POINTS_ESSEN[3][0],POINTS_ESSEN[3][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	# Schlafen
	"22:00:00" : {
		S_LOCATION: 7,
		S_START	: (Lambda('check_stand_up("RECRUIT_SANCHEZ")'),
				enter_building("BUILDING_369"),
				lay_down_to_sleep(bed="BUILDING_13492")),
		S_LOOP	: (sleep()),
	}
},{
	"00:00:00":{
		S_START : (enter_building("BUILDING_369"),
					sit_down_on_ground()),
		S_LOOP : (sit_on_ground(),
					lambda c: objects.set_active_state(c,0))
	}
}),

"RECRUIT_BROKOVICH" : ({
	S_CONDITION : lambda: data().recruit_ta_active,

	# General kommandiert, Milizen robben herum.
	"06:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_001"),)),
		S_START	: (goto(234,773)),
		S_LOOP	: (Lambda('character.change_body_mode("RECRUIT_BROKOVICH", "LIE")'),
				goto(234,773),
 				goto(209,777),
 				goto(217,810),
				goto(236,796)),
	},
	# Auf Zielscheibe schießen
	"08:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_002"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_BROKOVICH")'),
				goto(POINTS_SCHIESSEN[1][0],POINTS_SCHIESSEN[1][1]),
				turn_to_direction(DIR_EAST),
				start_hunt()),
		S_LOOP	: (hunt()),
	},
	# Marschieren
	"10:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_003"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_BROKOVICH")'),
				end_hunt()),
		S_LOOP	: (patrol(ROUTE_MARSCHIEREN, circle=True)),
	},
	# Medizinische Ausbildung (Herzdruckmassage o.ä.)
	"12:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_BROKOVICH")'),
				goto(POINTS_ESSEN[1][0],POINTS_ESSEN[1][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	# Beim Schrottplatz stehen und an den Schrottgegenständen hantieren (Taschendiebstahl-Animation u.ä.)
	"13:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_005"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_BROKOVICH")'),
				goto(POINTS_SCHROTT[1][0],POINTS_SCHROTT[1][1]),
				turn_to_object(POINTS_SCHROTT[1][2])),
		S_LOOP	: (work_on_machine()),
	},
	# Am Feuer sitzen, essen
	"16:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_BROKOVICH")'),
				goto(POINTS_ESSEN[1][0],POINTS_ESSEN[1][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	# Schlafen
	"22:00:00" : {
		S_LOCATION: 3,
		S_START	: (Lambda('check_stand_up("RECRUIT_BROKOVICH")'),
				enter_building("BUILDING_369"),
				lay_down_to_sleep(bed="BUILDING_13493")),
		S_LOOP	: (sleep()),
	}
},{
	"00:00:00":{
		S_START : (enter_building("BUILDING_369"),
					sit_down_on_ground()),
		S_LOOP : (sit_on_ground(),
					lambda c: objects.set_active_state(c,0))
	}
}),

"RECRUIT_HILL" : ({
	S_CONDITION : lambda: data().recruit_ta_active,

	# General kommandiert, Milizen robben herum.
	"06:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_001"),)),
		S_START	: (goto(234,773)),
		S_LOOP	: (Lambda('character.change_body_mode("RECRUIT_HILL", "LIE")'),
				goto(234,773),
 				goto(209,777),
 				goto(217,810),
				goto(236,796)),
	},
	# Auf Zielscheibe schießen
	"08:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_002"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_HILL")'),
				goto(POINTS_SCHIESSEN[2][0],POINTS_SCHIESSEN[2][1]),
				turn_to_direction(DIR_EAST),
				start_hunt()),
		S_LOOP	: (hunt()),
	},
	# Marschieren
	"10:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_003"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_HILL")'),
				end_hunt()),
		S_LOOP	: (patrol(ROUTE_MARSCHIEREN, circle=True)),
	},
	# Medizinische Ausbildung (Herzdruckmassage o.ä.)
	"12:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_HILL")'),
				goto(POINTS_ESSEN[2][0],POINTS_ESSEN[2][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	# Beim Schrottplatz stehen und an den Schrottgegenständen hantieren (Taschendiebstahl-Animation u.ä.)
	"13:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_005"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_HILL")'),
				goto(POINTS_SCHROTT[2][0],POINTS_SCHROTT[2][1]),
				turn_to_object(POINTS_SCHROTT[2][2])),
		S_LOOP	: (work_on_machine()),
	},
	# Am Feuer sitzen, essen
	"16:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_HILL")'),
				goto(POINTS_ESSEN[2][0],POINTS_ESSEN[2][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	# Schlafen
	"22:00:00" : {
		S_LOCATION: 3,
		S_START	: (Lambda('check_stand_up("RECRUIT_HILL")'),
				enter_building("BUILDING_369"),
				goto(252.26,752.87, grid='ZONE_5_BUILDING_369_INTERIOR_GRID2'),
				lay_down_to_sleep()),
		S_LOOP	: (sleep()),
	}
},{
	"00:00:00":{
		S_START : (enter_building("BUILDING_369"),
					sit_down_on_ground()),
		S_LOOP : (sit_on_ground(),
					lambda c: objects.set_active_state(c,0))
	}
}),

"RECRUIT_POPE" : ({
	S_CONDITION : lambda: data().recruit_ta_active,

	# General kommandiert, Milizen robben herum.
	"06:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_001"),)),
		S_START	: (goto(234,773)),
		S_LOOP	: (Lambda('character.change_body_mode("RECRUIT_POPE", "LIE")'),
				goto(234,773),
 				goto(209,777),
 				goto(217,810),
 				goto(236,796)),
	},
	# Auf Zielscheibe schießen
	"08:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_002"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_POPE")'),
				goto(POINTS_SCHIESSEN[0][0],POINTS_SCHIESSEN[0][1]),
				turn_to_direction(DIR_EAST),
				start_hunt()),
		S_LOOP	: (hunt()),
	},
	# Marschieren
	"10:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_003"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_POPE")'),
				end_hunt()),
		S_LOOP	: (patrol(ROUTE_MARSCHIEREN, circle=True)),
	},
	# Medizinische Ausbildung (Herzdruckmassage o.ä.)
	"12:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_POPE")'),
				goto(POINTS_ESSEN[0][0],POINTS_ESSEN[0][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	# Beim Schrottplatz stehen und an den Schrottgegenständen hantieren (Taschendiebstahl-Animation u.ä.)
	"13:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_005"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_POPE")'),
				goto(POINTS_SCHROTT[0][0],POINTS_SCHROTT[0][1]),
				turn_to_object(POINTS_SCHROTT[0][2])),
		S_LOOP	: (work_on_machine()),
	},
	# Am Feuer sitzen, essen
	"16:00:00" : {
		S_DIALOG: long_dialog((("ALTER_EGO","NPC_MILIZEN_T_004"),)),
		S_START	: (Lambda('check_stand_up("RECRUIT_POPE")'),
				goto(POINTS_ESSEN[0][0],POINTS_ESSEN[0][1]),
				turn_to_object("BUILDING_3323"),
				sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	# Schlafen
	"22:00:00" : {
		S_LOCATION: 3,
		S_START	: (Lambda('check_stand_up("RECRUIT_POPE")'),
				enter_building("BUILDING_369"),
				goto(255.77,753.13, grid='ZONE_5_BUILDING_369_INTERIOR_GRID2'),
				lay_down_to_sleep()),
		S_LOOP	: (sleep()),
	}
},{
	"00:00:00":{
		S_START : (enter_building("BUILDING_369"),
					sit_down_on_ground()),
		S_LOOP : (sit_on_ground(),
					lambda c: objects.set_active_state(c,0))
	}
}),

"GENERAL_LEWIS" : ({
	S_CONDITION : lambda: data().recruit_ta_active,

	# General kommandiert, Milizen robben herum.
	"06:00:00" : {
		S_START	: (goto(240.9,792.6)),
		S_LOOP	: (lambda _c_:turn_to_object(random.choice(["RECRUIT_SANCHEZ","RECRUIT_BROKOVICH","RECRUIT_HILL","RECRUIT_POPE"]))(_c_),
				stand(),
				stand(),
				stand()),
	},
	# Auf Zielscheibe schießen
	"08:00:00" : {
		S_START	: (goto(238.5,789.5),
				turn_to_direction(DIR_NORTH_EAST)),
		S_LOOP	: (),
	},
	# Marschieren
	"10:00:00" : {
		S_START	: (),
		S_LOOP	: (patrol(ROUTE_MARSCHIEREN, circle=True)),
	},
	# Am Feuer sitzen, essen
	"12:00:00" : {
		S_START	: (goto(252.4,725.0),
				turn_to_object("BUILDING_3323"), sit_down_on_ground()),
		S_LOOP	: (sit_eat_drink_on_ground),
	},
	# Beim Schrottplatz stehen und an den Schrottgegenständen hantieren (Taschendiebstahl-Animation u.ä.) #TODO
	"13:00:00" : {
		S_START	: (goto(241,642),
				turn_to_direction(90)),
		S_LOOP	: (),
	},
	# Am Feuer sitzen, essen
	"16:00:00" : {
		S_START	: (goto(252.4,725.0),
				turn_to_object("BUILDING_3323")),
		S_LOOP	: (),
	},
	# Schlafen
	"22:00:00" : {
		S_LOCATION: 3,
		S_START	: (enter_building("BUILDING_294"),
				lay_down_to_sleep(bed="BUILDING_13368")),
		S_LOOP	: (sleep()),
	},
	# Am Feuer sitzen, essen
	"05:00:00" : {
		S_START	: (goto(252.4,725.0),
				turn_to_object("BUILDING_3323")),
		S_LOOP	: (),
	}
},{
	"00:00:00":{
		S_START : (),
		S_LOOP : ()
	}
}),

"FRANKLIN" : ({ # der arzt
##########
	S_CONDITION : lambda : not data('zone_3.zone_3').franklin_folgt and system.get_qb_entry_state(data().QB_003)==COMPLETE,
	"00:00:00" : { # schlafen
		S_START  : [enter_building("BUILDING_369"), lay_down_to_sleep(bed="BUILDING_13502")],
		S_LOOP   : [sleep()]
	},
	"08:00:00" : { # Frühstücken
		S_START : (goto_dummy("BUILDING_3323","dmyp_001"), sit_down_to_cook()),
		S_LOOP  : (cook())
	},
	"10:00:00" : { # auf einer Bank sitzen und lesen
		S_START : (goto_dummy("BUILDING_3324","dmyp_001"),
					sit_down_on_bench()),
		S_LOOP  : (read_book_on_bench())
	},
	"12:00:00" : { # Medizinische Ausbildung # TODO
		S_START : (),
		S_LOOP  : ()
	},
	"14:00:00" : { # Mittagessen
		S_START : (goto_dummy("BUILDING_3323","dmyp_006"), sit_down_to_cook()),
		S_LOOP  : (cook())
	},
	"15:00:00" : { # Spazieren gehen # TODO
		S_START : (),
		S_LOOP  : ()
	},
	"18:00:00" : { # Abendessen
		S_START : (goto_dummy("BUILDING_3324","dmyp_001"),
					sit_down_on_bench()),
		S_LOOP  : (sit_eat_drink_on_bench)
	},
	"20:00:00" : { # LF-Aktion
		S_START : (goto_dummy("BUILDING_3323","dmyp_006"), sit_down_on_ground()),
		S_LOOP  : (sit_on_ground())
	}
},{# folgen
	"00:00:00" : { 
		S_START  : [],
		S_LOOP   : [global_schedules.follow_in_distance("ALTER_EGO")]}
})}
	# update with global schedules
	schedules.update(global_schedules.update_schedules(schedules))

### wrapper functions, do not modify!
def Activity(id):
	return npc_activity(id, schedules)
	
def GetCurrentPlan(id):
	return npc_get_current_plan(id, schedules)
	
def Dialog(id, partymemberid):
	return npc_dialog(id, partymemberid, schedules)
