# -*- coding: utf-8 -*-
from global_defines import *
from const import *
import npc
from dynamic_camera import *
import schedules
import daily_routine
import enemy_script
import dialog

#*** aktuelle Revision 4, 12.10.2004 *******************************************

# ansprechen von chars - callback
def on_approach(target, operator):
	if dialog.is_dialog_active():
		return
	if system.is_cutscene():
		return
	if schedules.Dialog(target, operator):
		return
		
	if target == "EX" and data().ex_got_hit:
		if data().verrat:
			initDlg_004_LetzteWorteExVerrat()
		else:
			initDlg_003_LetzteWorteEx()
	
	elif target == "ROWLAND":
		if data().GNO != [] and not data().gno_refugees:
			initDlg_015_SpielerNichtRowland()
		elif not data().WissenschaftlerGesprochen:
			initDlg_016_RowlandBerichtet()
			data().WissenschaftlerGesprochen = True
		else:
			initDlg_017_RowlandZweitesMal()
			
	elif target == "BANKS":
		if data().GNO != [] and not data().gno_refugees:
			#if not objects.is_destroyed(gno) or not objects.is_active(gno):
			initDlg_018_SpielerNichtBanks()
		elif not data().WissenschaftlerGesprochen:
			initDlg_019_BanksBerichtet()
			data().WissenschaftlerGesprochen = True
		else:
			initDlg_020_BanksZweitesMal()
	
# *** dialogs ******************************************************************
#[NM/CS] Dialog 002: Der Spieler trifft auf die GNO
def initDlg_002_SpielerTrifftAufGNO():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_002')
	dialog.add_text(text='D_002_T_001', speaker='ALTER_EGO', follower='ENDDIALOG', callback=on_dialog_002_ende)
	dialog.start(True, data('zone_9.zone_9').QB_019)

def on_dialog_002_ende():
	system.notify_region_entered("REGION_EXIT_COMMENT", objectid="ALTER_EGO")
	for id in data().GNO_1:
		objects.set_attribute( id, attribute="foes", value=["UISPIELER"])

#[NM/CS] Dialog 021: Der Spieler bricht zur Biosphäre auf
def initDlg_021_SpielerBrichtZurBiosphaereAuf():
	system.start_cutscene()
	set_conversation("ALTER_EGO", cam_x=-3, cam_y=0, mode="medium")
	objects.turn_to_direction("ALTER_EGO", DIR_WEST, callback=["ONEND", on_dialog_021_start])

def on_dialog_021_start(char):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_021')
	dialog.add_text(text='D_021_T_001', speaker='ALTER_EGO', follower='ENDDIALOG', callback=on_dialog_021_ende)
	dialog.start(True, data('zzone_8.zzone_8').QB_001)

def on_dialog_021_ende():
	system.end_cutscene()

#[NM] Dialog 003: Die letzten Worte von EX
def initDlg_003_LetzteWorteEx():
	data().ex_last_dialog = True
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_003')
	dialog.add_text(text='D_003_T_001', speaker='EX', follower='ENDDIALOG', callback=ExStirbt)
	dialog.start(True, data('zone_9.zone_9').QB_019)

#[NM] Dialog 004: Die letzten Worte von EX, Variante: Spieler hat GNO-Soldaten verraten
def initDlg_004_LetzteWorteExVerrat():
	data().ex_last_dialog = True
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_004')
	dialog.add_text(text='D_004_T_001', speaker='EX', follower='ENDDIALOG', callback=ExStirbt)
	dialog.start(True, data('zone_9.zone_9').QB_019)
	
def ExStirbt():
	if not objects.is_destroyed("EX"):
		objects.set_immortal_state("EX", False)
		objects.destroy("EX")
	
#[NM] Dialog 005: Der Spieler findet die Skelette, Version: Erster Skelettfund
def initDlg_005_S1SpielerFindetSkelettErsterFund():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_005')
	dialog.add_text(text='D_005_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data('zone_9.zone_9').QB_019)
	
#[NM] Dialog 006: Der Spieler findet die Skelette, Version: Zweiter Skelettfund
def initDlg_006_S1SpielerFindetSkelettZweiterFund():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_005')
	dialog.add_text(text='D_006_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data('zone_9.zone_9').QB_019)

#[NM] Dialog 007: Der Spieler untersucht das erste Skelett
def initDlg_007_SpielerUntersuchtDasErsteSkelett():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_005')
	dialog.add_text(text='D_007_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data('zone_9.zone_9').QB_019)

#[NM] Dialog 008: Der Spieler untersucht das zweite Skelett
def initDlg_008_SpielerUntersuchtDasZweiteSkelett():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_005')
	dialog.add_text(text='D_008_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data('zone_9.zone_9').QB_019)


#[NM] Dialog 009: Der Spieler findet das Skelett, Version: Erster Skelettfund
def initDlg_009_S2SpielerFindetSkelettErsterFund():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_005')
	dialog.add_text(text='D_009_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data('zone_9.zone_9').QB_019)
	
#[NM] Dialog 010: Der Spieler findet das Skelett, Version: Zweiter Skelettfund
def initDlg_010_S2SpielerFindetSkelettZweiterFund():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_005')
	dialog.add_text(text='D_010_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data('zone_9.zone_9').QB_019)

#[NM] Dialog 011: Der Spieler findet das Tagebuch
def initDlg_011_SpielerFindetDasTagebuch():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_001')
	dialog.add_text(text='D_011_T_001', speaker='ALTER_EGO', follower='ENDDIALOG', callback=on_dialog_011_ende)
	dialog.start(True, data('zone_9.zone_9').QB_019)

def on_dialog_011_ende():
	objects.create_item_in_inventory("ALTER_EGO",data().qi_diary[0], data().qi_diary[1])
	objects.set_attribute(data().qi_diary[1], "generic_item", False)
	# data().diary_found = True

#[NM/CS] Dialog 001: Der Spieler liest das Tagebuch
def initDlg_001_SpielerLiestDasTagebuch():
	system.start_cutscene()
	set_conversation("ALTER_EGO", cam_x=-3, cam_y=-3, mode="medium")
	objects.turn_to_direction("ALTER_EGO", DIR_NORTH_WEST, callback=["ONEND", on_dialog_001_start])
	
def on_dialog_001_start(char):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_001')
	dialog.add_text(text='D_001_T_001', speaker='ALTER_EGO')
	dialog.add_text(text='D_001_T_002', speaker='ALTER_EGO')
	dialog.add_text(text='D_001_T_003', speaker='ALTER_EGO', callback=Lambda('set_conversation("ALTER_EGO", cam_x=-1.5, cam_y=-1.5, mode="medium")'))
	dialog.add_text(text='D_001_T_004', speaker='ALTER_EGO')
	dialog.add_text(text='D_001_T_005', speaker='ALTER_EGO', follower='ENDDIALOG', callback=on_dialog_001_ende)
	dialog.start(True, data('zone_9.zone_9').QB_019)

def on_dialog_001_ende():
	system.end_cutscene()

#[NM] Dialog 012: Der Spieler untersucht das dritte Skelett
def initDlg_012_SpielerUntersuchtDasDritteSkelett():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_005')
	dialog.add_text(text='D_012_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data('zone_9.zone_9').QB_019)

#[NM/CS] Dialog 013: Der Spieler betritt den Lagerraum
def initDlg_013_SpielerBetrittLagerraum():
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_LAGERRAUM)
	objects.cancel_commandos("ALTER_EGO")
	objects.set_position("ALTER_EGO", x = 322.65, y = 229.12)
	objects.move_to("ALTER_EGO", x = 323.82, y = 224.87, speed=MT_SLOW, grid="landscape")
	objects.turn_to_object("ALTER_EGO", "BUILDING_670", callback=['ONEND', on_dialog_013_start])

def on_dialog_013_start(char):
	objects.move_to("ALTER_EGO", x = 321.44, y = 214.40, speed=MT_SLOW, grid="landscape")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_013')
	dialog.add_text(text='D_013_T_001', speaker='ALTER_EGO', callback=on_dialog_013_switch_camera)
	dialog.add_text(text='D_013_T_002', speaker='ALTER_EGO', follower='ENDDIALOG', callback=on_dialog_013_ende)
	dialog.start(True, data('zone_9.zone_9').QB_019)

def on_dialog_013_switch_camera():
	system.set_camera_view(CAMVIEW_LAGERRAUM_NAH)

def on_dialog_013_ende():
	system.end_cutscene()
	
#[M] Dialog 014: Oh, und übrigens, EX...
def initDlg_014_UndUebrigensEX(object_id = None):
	data().ex_got_hit = False
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_014')
	dialog.add_text(text='D_014_T_001', speaker='ALTER_EGO')
	dialog.add_text(text='D_014_T_002', speaker='EX')
	dialog.add_choice(text='D_014_C_001_1', follower='D_014_T_004')
	dialog.add_choice(text='D_014_C_001_2', follower='D_014_T_003')
	dialog.add_text(text='D_014_T_003', speaker='EX', follower='ENDDIALOG', callback=GNOWaffenSammeln) # Ende1
	dialog.add_text(text='D_014_T_004', speaker='EX', follower='ENDDIALOG', callback=GNOfliehen) # Ende2
	dialog.start(True, data('zone_9.zone_9').QB_019)

def GNOfliehen():
	check_all_gno_gone(data().GNO)
	data().gno_refugees = True
	data().ex_got_hit = False
	objects.set_immortal_state("EX", False)
	objects.set_attribute("EX", "hitpoints", data().ex_normal_hitpoints)
	for gno in data().GNO:
		objects.cancel_commandos(gno)
		objects.set_attribute(gno, attribute="foes", value=None)
		system.notify_region_entered("REGION_EXIT_COMMENT", objectid=gno)
		if not objects.is_destroyed(gno):
			if gno in data().GNO_1:
				wps = WP_GNO_FLUCHT_1[:]
			else:
				wps = WP_GNO_FLUCHT_2[:]
			
			for wp in wps:
				if wp == wps[-1]:
					objects.move_to(gno, wp[0],wp[1],grid="landscape",speed=MT_SLOW)
					objects.move_to(gno, 200.98, 249.17, grid="landscape", speed=MT_SLOW)
				else:
					objects.move_to(gno, wp[0],wp[1],grid="landscape",speed=MT_SLOW)

def check_all_gno_gone(liste):
	if liste != [] or data().gno_refugees:
		character.set_main_quest_npc_state(char='BANKS', state=True)
		character.set_main_quest_npc_state(char='ROWLAND', state=True)
		system.notify_region_entered("REGION_CAGE_ENTRY", partyid="UISPIELER")
		if not is_zone_enabled('zone_10'):
			character.add_experience_party(50)
			set_zone_enabled("zone_10", True)
	
#TODO: korrigieren
# ich will, dass jeder GNO Futzi die Waffe, die er erst vorhin weggeschmissen hat, wieder aufsammelt!
def GNOWaffenSammeln():
	data().verrat = True
	data().ex_got_hit = False
	objects.set_immortal_state("EX", False)
	objects.set_attribute("EX", "hitpoints", 1000)
	for gno in data().GNO:
		if not objects.is_destroyed(gno):
			objects.cancel_commandos(gno)
			for eintrag in data().liste:
				if eintrag[0] == gno:
					if len(eintrag[1]):
						#print ">>> eintrag gefunden",gno,eintrag[1]
						enemy_script.delay(1.0, Lambda('GNO_Einzel_Angriff("%s")' %(gno)))
						objects.pick_up_item(gno, eintrag[1][0], callback = ['ONEND', Lambda('GNO_Einzel_Angriff("%s")'%gno)])
					else:
						GNO_Einzel_Angriff(gno)

# der pick_up_item callback funktioniert nur bedingt da er nicht am ende der animation ausgelöst wird sondern früher.
# daher habe ich eine kleine zeitverzögerung eingebaut, ist aber mehr als suboptimal
# der callback muss auf jeden fall geändert werden

def GNO_Einzel_Angriff(char):
	character.arm_direct(char)
	objects.set_attribute(char, attribute="foes", value=["UISPIELER"])
	enemies = character.get_visible_enemies(char)
	if len(enemies):
		myEnemy = random.choice(enemies)
		objects.attack(char, myEnemy)

#[NM] Dialog 015: Der Spieler will nicht mit Rowland sprechen
def initDlg_015_SpielerNichtRowland():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_015')
	dialog.add_text(text='D_015_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data('zone_9.zone_9').QB_019)
	
#[M]Dialog 016: Dr. Jeff Rowland berichtet über die Biosphäre
def initDlg_016_RowlandBerichtet():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier("initDlg_016_RowlandBerichtet")
	
	dialog.add_text(text='D_016_T_001', speaker='ROWLAND')
	dialog.add_text(text='D_016_T_002', speaker='ALTER_EGO')
	dialog.add_text(text='D_016_T_003', speaker='ROWLAND')
	
	dialog.add_choice(text='D_016_C_001_1', follower='D_016_T_005', auto_deactivation='permanent')
	dialog.add_choice(text='D_016_C_001_2', follower='D_016_T_011', auto_deactivation='permanent')
	dialog.add_choice(text='D_016_C_001_3', follower='D_016_T_016', auto_deactivation='permanent')
	if data().C_001_4:
		dialog.add_choice(text='D_016_C_001_4', follower='D_016_T_013', auto_deactivation='permanent')
	if data().C_001_5:
		dialog.add_choice(text='D_016_C_001_5', follower='D_016_T_014', auto_deactivation='permanent')
	if data().C_001_6:
		dialog.add_choice(text='D_016_C_001_6', follower='D_016_T_015', auto_deactivation='permanent')
	if data().C_001_7:
		dialog.add_choice(text='D_016_C_001_7', follower='D_016_T_017', auto_deactivation='permanent')
	dialog.add_choice(text='D_016_C_001_8', follower='ENDDIALOG', callback=RowlandBanksAbgang)
	
	dialog.add_text(text='D_016_T_005', speaker='ROWLAND')
	dialog.add_text(text='D_016_T_006', speaker='ALTER_EGO')
	dialog.add_text(text='D_016_T_009', speaker='ROWLAND')
	dialog.add_text(text='D_016_T_010', speaker='ROWLAND', follower='D_016_C_001')
	
	dialog.add_text(text='D_016_T_011', speaker='ROWLAND')
	dialog.add_text(text='D_016_T_012', speaker='ROWLAND', follower='ENDDIALOG', callback=[
		Lambda('data().C_001_4 = True'), #C_001_4 aktiv
		Lambda('RestartDlg016()')])
	
	dialog.add_text(text='D_016_T_013', speaker='ROWLAND', follower='ENDDIALOG', callback=[
		Lambda('data().C_001_5 = True'), #C_001_5 aktiv
		Lambda('RestartDlg016()')])
		
	dialog.add_text(text='D_016_T_014', speaker='ROWLAND', follower='ENDDIALOG', callback=[
		Lambda('data().C_001_6 = True'), #C_001_6 aktiv
		Lambda('RestartDlg016()')])
		
	dialog.add_text(text='D_016_T_015', speaker='ROWLAND', follower='D_016_C_001')
	
	dialog.add_text(text='D_016_T_016', speaker='ROWLAND', follower='ENDDIALOG', callback=[
		Lambda('data().C_001_7 = True'), #C_001_7 aktiv
		Lambda('RestartDlg016()')])
		
	dialog.add_text(text='D_016_T_017', speaker='ROWLAND', follower='D_016_C_001')
	
	if not data().FirstTimeDlg016or019:
		dialog.jump_to('D_016_C_001')
	dialog.start(False, [data('zone_9.zone_9').QB_019,
						 data('zzone_8.zzone_8').QB_001])
	
def RestartDlg016():
	data().FirstTimeDlg016or019 = False
	initDlg_016_RowlandBerichtet()
	
#[NM]Dialog 017: Rowland wird zum zweiten Mal angesprochen
def initDlg_017_RowlandZweitesMal():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_017')
	dialog.add_text(text='D_017_T_001', speaker='ROWLAND', follower='ENDDIALOG')
	dialog.start(True, data('zzone_8.zzone_8').QB_001)

#[NM] Dialog 018: Der Spieler will nicht mit Banks sprechen
def initDlg_018_SpielerNichtBanks():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_015')
	dialog.add_text(text='D_015_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start()
	
#[M] Dialog 019: Prof. Rodney Banks berichtet über die Biosphäre
def initDlg_019_BanksBerichtet():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier("initDlg_019_BanksBerichtet")
	
	dialog.add_text(text='D_019_T_001', speaker='BANKS')
	dialog.add_text(text='D_019_T_002', speaker='ALTER_EGO')
	dialog.add_text(text='D_019_T_003', speaker='BANKS')
	
	dialog.add_choice(text='D_019_C_001_1', follower='D_019_T_005', auto_deactivation='permanent')
	dialog.add_choice(text='D_019_C_001_2', follower='D_019_T_011', auto_deactivation='permanent')
	dialog.add_choice(text='D_019_C_001_3', follower='D_019_T_016', auto_deactivation='permanent')
	if data().C_001_4:
		dialog.add_choice(text='D_019_C_001_4', follower='D_019_T_013', auto_deactivation='permanent')
	if data().C_001_5:
		dialog.add_choice(text='D_019_C_001_5', follower='D_019_T_014', auto_deactivation='permanent')
	if data().C_001_6:
		dialog.add_choice(text='D_019_C_001_6', follower='D_019_T_015', auto_deactivation='permanent')
	if data().C_001_7:
		dialog.add_choice(text='D_019_C_001_7', follower='D_019_T_017', auto_deactivation='permanent')
	dialog.add_choice(text='D_019_C_001_8', follower='ENDDIALOG', callback=RowlandBanksAbgang)
	
	dialog.add_text(text='D_019_T_005', speaker='BANKS')
	dialog.add_text(text='D_019_T_006', speaker='ALTER_EGO')
	dialog.add_text(text='D_019_T_009', speaker='BANKS')
	dialog.add_text(text='D_019_T_010', speaker='BANKS', follower='D_019_C_001')
	
	dialog.add_text(text='D_019_T_011', speaker='BANKS')
	dialog.add_text(text='D_019_T_012', speaker='BANKS', follower='ENDDIALOG', callback=[
		Lambda('data().C_001_4 = True'), #C_001_4 aktiv
		Lambda('RestartDlg019()')])
	
	dialog.add_text(text='D_019_T_013', speaker='BANKS', follower='ENDDIALOG', callback=[
		Lambda('data().C_001_5 = True'), #C_001_5 aktiv
		Lambda('RestartDlg019()')])
	
	dialog.add_text(text='D_019_T_014', speaker='BANKS', follower='ENDDIALOG', callback=[
		Lambda('data().C_001_6 = True'), #C_001_6 aktiv
		Lambda('RestartDlg019()')])
	
	dialog.add_text(text='D_019_T_015', speaker='BANKS', follower='D_019_C_001')
	
	dialog.add_text(text='D_019_T_016', speaker='BANKS', follower='ENDDIALOG', callback=[
		Lambda('data().C_001_7 = True'), #C_001_7 aktiv
		Lambda('RestartDlg019()')])
	
	dialog.add_text(text='D_019_T_017', speaker='BANKS', follower='D_019_C_001')
	
	if not data().FirstTimeDlg016or019:
		dialog.jump_to('D_019_C_001')
	dialog.start(False, [data('zone_9.zone_9').QB_019,
						 data('zzone_8.zzone_8').QB_001])
	
def RestartDlg019():
	data().FirstTimeDlg016or019 = False
	initDlg_019_BanksBerichtet()
	
#[NM] Dialog 020: Der Spieler spricht Prof. Rodney Banks erneut an
def initDlg_020_BanksZweitesMal():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_0')
	dialog.add_text(text='D_020_T_001', speaker='BANKS', follower='ENDDIALOG')
	dialog.start(True, data('zzone_8.zzone_8').QB_001)
	
#Rowland und Banks verlassen die Zone und gehen nach Z10
def RowlandBanksAbgang():
	if was_zone_entered("zone_9.zone_9"):
		if system.get_qb_entry_state(data("zone_9.zone_9").QB_019)==UNCOMPLETE:
			system.set_qb_entry_state(data("zone_9.zone_9").QB_019, COMPLETE)
	character.add_experience_party(data().Exp)
	system.set_qb_entry_state(data().QB_001, INACTIVE)
	objects.move_to("ROWLAND", 200.98, 249.17, "landscape", MT_SLOW, callback=["ONEND", 
		Lambda('objects.set_position_free("ROWLAND", 398.40, 218.59, 0.0, "landscape", "zone_10.zone_10")')])
	objects.move_to("BANKS", 200.98, 249.17, "landscape", MT_SLOW, callback=["ONEND", 
		Lambda('objects.set_position_free("BANKS", 398.40, 218.59, 0.0, "landscape", "zone_10.zone_10")')])

#[M] Dialog 022: EX bedroht die Geiseln
def initDlg_022_EXbedrohtGeiseln():
	data().ex_got_hit = False
	character.set_main_quest_npc_state(char='EX', state=True)
	for id in data().GNO_1:
		if not objects.is_destroyed(id):
			objects.cancel_commandos(id)
			objects.set_attribute(id, "foes", None)
	objects.cancel_commandos("EX")
	objects.turn_to_object("EX", "ALTER_EGO", callback=["ONEND", on_dialog_022_start])

def on_dialog_022_start(char):
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_022')
	dialog.add_text(text='D_022_T_001', speaker='EX')
	dialog.add_choice(text='D_022_C_001_1', follower='D_022_T_004')
	dialog.add_choice(text='D_022_C_001_2', follower='D_022_T_003')
	dialog.add_choice(text='D_022_C_001_3', follower='D_022_T_002')
	dialog.add_text(text='D_022_T_002', speaker='EX', follower='D_022_C_001')
	dialog.add_text(text='D_022_T_003', speaker='EX', follower='ENDDIALOG', callback=GNO_greift_an) # Ende1
	dialog.add_text(text='D_022_T_004', speaker='EX')
	dialog.add_choice(text='D_022_C_002_1', follower='D_022_T_005')
	dialog.add_choice(text='D_022_C_002_2', follower='D_022_T_006')
	dialog.add_choice(text='D_022_C_002_3', follower='D_022_T_003')
	dialog.add_text(text='D_022_T_005', speaker='EX', follower='D_022_C_002')	# [BrainRipper]
	dialog.add_text(text='D_022_T_006', speaker='EX', follower='ENDDIALOG', callback=GNO_legen_Waffen_nieder) # Ende2
	dialog.start(True, data('zone_9.zone_9').QB_019)
	
def GNO_greift_an(object_id=None):
	objects.set_immortal_state("EX", False)
	objects.set_attribute("EX", "hitpoints", 1000)
	data().ex_got_hit = False
	for id in data().GNO:
		objects.set_attribute(id, attribute="foes", value=["UISPIELER"])

def GNO_legen_Waffen_nieder():
	for gno in data().GNO:
		objects.cancel_commandos(gno)
		objects.set_attribute(gno, "foes", None)
	
	waffen_ablegen()
	
def waffen_ablegen():
	for gno in data().GNO:
		weapons = []
		eintrag = []
		inventory = objects.get_inventory_ids(gno)
		for item in inventory:
			if len(item) and len(item[0]):
				for i in item[0]:
					if objects.has_attribute(i, "weapon_type"):
						weapons.append(i)
		eintrag.append(gno)
		eintrag.append(weapons)
		data().liste.append(eintrag)
		# alle waffen ablegen
		if len(weapons):
			for w in weapons:
				if w == weapons[-1]:
					objects.cancel_commandos(gno)
					if gno == data().GNO[-1]:
						objects.put_down_item(gno, w, callback=["ONEND", Lambda('initDlg_014_UndUebrigensEX("%s")' %(id))])
					else:
						objects.put_down_item(gno, w)
				else:
					objects.drop_item(gno, w)

#[NM] Dialog 023: Der Spieler kann die Höhle noch nicht verlassen
def initDlg_023_SpielerKannHoehleNichtVerlassen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_023')
	dialog.add_text(text='D_023_T_001', speaker='ALTER_EGO', follower='ENDDIALOG', callback=on_dialog_023_ende)
	dialog.start(True, data('zone_9.zone_9').QB_019)

def on_dialog_023_ende():
	enemy_script.delay(15.0, Lambda('system.notify_region_entered("REGION_EXIT_COMMENT", objectid="ALTER_EGO")'))
