# -*- coding: utf-8 -*-
from global_defines import *
import npc
from const import *
import daily_routine
import dynamic_camera
import enemy_script
import dialog
import random
import object_events	# [BrainRipper]

# Rev 1, 24.3.2005

def on_approach(target, operator):
	
	if dialog.is_dialog_active():
		return
	
	# JODIE
	if target == "JODIE":
		if data().Jodie_Dlg_002:
			Dlg_002_Jodie_Eingeschnappt()
		elif data().Jodie_Dlg_001_1st:
			Dlg_001_Jodie_Begruessung()
		elif system.get_qb_entry_state(data().QB_010) == COMPLETE:
			Dlg_005_Jodie_Freut_Sich()
		elif data().Howard_Gang_Killed:
			Dlg_004_Jodie_Bedankt_Sich()
		elif system.get_qb_entry_state(data().QB_010) == UNCOMPLETE:
			Dlg_003_Jodie_wartet_Telescop()
		return
	
	# BENSON
	if target == "BENSON":
		# Gespraeche nur über Region?
		if (system.get_qb_entry_state(data().QB_002) == UNCOMPLETE):
			Dlg_032_Benson_Bruder_lebt()
		return
	# Rolling Thunderer
	if target in data().Benson_Gang:
		Dlg_006_Thunderer(target)
		return
	
	# Howard
	if target == "HOWARD":
		# Gespraeche nur über Region?
		if (system.get_qb_entry_state(data().QB_003) == UNCOMPLETE):
			Dlg_031_Howard_Bruder_lebt()
		return
	# Deathstriker
	if target in data().Howard_Gang:
		Dlg_007_Deathstriker(target)
		return
	
	# Dick
	if target == "DICK_THE_DIGGER":
		if data().Dick_Dlg_027:
			Dlg_027_Dick_will_Ruhe()
		elif ((system.get_qb_entry_state(data().QB_007) == COMPLETE)
			or (system.get_qb_entry_state(data().QB_006) == COMPLETE)):
			Dlg_026_Dick_Seeker_Tot()
		elif data().Dick_1st_Time:
			initDlg_024_Dick_Warnung()
		else:
			Dlg_025_Dick_Huette()
		return
	
	return

#---------------------------------------------------------------------------------
#JODIE
#---------------------------------------------------------------------------------
def Dlg_001_Jodie_Begruessung():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_001')
	dialog.add_text(text='D_001_T_001', speaker="JODIE", follower="D_001_C_001")
	dialog.add_text(text='D_001_T_002', speaker="JODIE", follower="D_001_C_001")
	dialog.add_choice(text='D_001_C_001_1', follower = 'D_001_T_003')
	dialog.add_choice(text='D_001_C_001_2', follower = 'D_001_T_004')
	dialog.add_choice(text='D_001_C_001_3', follower = 'D_001_T_005')
	dialog.add_choice(text='D_001_C_001_4', follower = 'ENDDIALOG', callback = Dlg_001_ENDE1)
	dialog.add_text(text='D_001_T_003', speaker="JODIE", follower="D_001_C_001")
	dialog.add_text(text='D_001_T_004', speaker="JODIE", follower="D_001_C_002")
	dialog.add_text(text='D_001_T_005', speaker="JODIE", follower="D_001_C_002")
	dialog.add_choice(text='D_001_C_002_1', follower = 'D_001_T_007')
	dialog.add_choice(text='D_001_C_002_2', follower = 'ENDDIALOG', callback = Dlg_001_ENDE2)
	dialog.add_choice(text='D_001_C_002_3', follower = 'ENDDIALOG', callback = Dlg_001_ENDE1)
	dialog.add_text(text='D_001_T_006', speaker="JODIE", follower="D_001_C_003")
	dialog.add_text(text='D_001_T_007', speaker="JODIE", follower="D_001_C_003")
	if (object_events.get_speech_skill("ALTER_EGO") < 70):	# [BrainRipper]
		dialog.add_choice(text='D_001_C_003_1', follower='D_001_T_009')
	else:
		dialog.add_choice(text='D_001_C_003_1', follower='D_001_T_008')
	dialog.add_choice(text='D_001_C_003_2', follower = 'D_001_T_009')
	dialog.add_choice(text='D_001_C_003_3', follower = 'ENDDIALOG', callback = Dlg_001_ENDE3)
	dialog.add_text(text='D_001_T_008', speaker="JODIE", follower="D_001_T_009")
	dialog.add_text(text='D_001_T_009', speaker="ALTER_EGO", follower="D_001_T_010")
	dialog.add_text(text='D_001_T_010', speaker="JODIE", follower="D_001_C_004")
	dialog.add_choice(text='D_001_C_004_1', follower = 'D_001_T_011')
	dialog.add_choice(text='D_001_C_004_2', follower = 'D_001_T_012')
	dialog.add_choice(text='D_001_C_004_3', follower = 'D_001_T_013')
	if was_zone_entered("sqzone_1.sqzone_1"):
		dialog.add_choice(text='D_001_C_004_4', follower = 'D_001_T_014')
	dialog.add_choice(text='D_001_C_004_5', follower = 'ENDDIALOG', callback = Dlg_001_ENDE4)
	dialog.add_text(text='D_001_T_011', speaker="JODIE", follower="ENDDIALOG", callback = Dlg_001_ENDE4)
	dialog.add_text(text='D_001_T_012', speaker="JODIE", follower="D_001_T_015")
	dialog.add_text(text='D_001_T_013', speaker="JODIE", follower="D_001_C_004")				# [BrainRipper]
	dialog.add_text(text='D_001_T_014', speaker="JODIE", follower="D_001_C_004")
	dialog.add_text(text='D_001_T_015', speaker="ALTER_EGO", follower="D_001_T_016")
	dialog.add_text(text='D_001_T_016', speaker="JODIE", follower="D_001_C_005")
	dialog.add_choice(text='D_001_C_005_1', follower = 'D_001_T_017')
	dialog.add_choice(text='D_001_C_005_2', follower = 'D_001_T_018')
	dialog.add_choice(text='D_001_C_005_3', follower = 'ENDDIALOG', callback = Dlg_001_ENDE4)	# [BrainRipper]
	dialog.add_text(text='D_001_T_017', speaker="JODIE", follower="D_001_C_006")				# [BrainRipper]
	dialog.add_text(text='D_001_T_018', speaker="JODIE", follower="D_001_C_005")
	dialog.add_choice(text='D_001_C_006_1', follower = 'D_001_T_019')
	dialog.add_choice(text='D_001_C_006_2', follower = 'D_001_T_020')
	dialog.add_choice(text='D_001_C_006_3', follower = 'D_001_T_021')
	dialog.add_text(text='D_001_T_019', speaker="JODIE", follower="ENDDIALOG", callback = Dlg_001_ENDE5)
	dialog.add_text(text='D_001_T_020', speaker="JODIE", follower="ENDDIALOG", callback = Dlg_001_ENDE4)
	dialog.add_text(text='D_001_T_021', speaker="JODIE", follower="D_001_C_006")
	#dialog.add_text(text='D_001_T_022', speaker="ALTER_EGO", follower="")
	if data().Jodie_Restart_T_002:
		dialog.jump_to('D_001_T_002')
	elif data().Jodie_Restart_T_006:
		dialog.jump_to('D_001_T_006')
	dialog.start(False, data().QB_010)
	
def Dlg_001_ENDE1():
	data().Jodie_Restart_T_002 = True
	
def Dlg_001_ENDE2():
	# Jodie greift an oder besser fliehen lassen?
	#objects.create_item_in_inventory("JODIE", "SET_GIANT_KNIFE")
	#character.equip_direct("JODIE", "SET_GIANT_KNIFE")
	daily_routine.prohibit_activity("JODIE")
	objects.set_attribute("JODIE","agility",20)
	objects.move_to("JODIE",500,1000,speed = MT_FAST, callback = ["ONEND",Lambda('objects.set_active_state("JODIE",INACTIVE)')])
	#objects.set_attribute("JODIE", "foes", ["UISPIELER"])
	
def Dlg_001_ENDE3():
	data().Jodie_Restart_T_006 = True
	data().Jodie_Restart_T_002 = False
	
def Dlg_001_ENDE4():
	# Jodie eingeschnappt
	data().Jodie_Dlg_002 = True
	
def Dlg_001_ENDE5():
	# Quest Radiotelescop starten
	data().Jodie_Dlg_001_1st = False
	system.set_qb_entry_state(data().QB_010,UNCOMPLETE)

def Dlg_002_Jodie_Eingeschnappt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_002')
	dialog.add_text(text='D_002_T_001', speaker="JODIE", follower="D_002_T_002")
	dialog.add_text(text='D_002_T_002', speaker="ALTER_EGO", follower="ENDDIALOG")
	dialog.start(True, data().QB_010)
	
def Dlg_003_Jodie_wartet_Telescop():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_003')
	dialog.add_text(text='D_003_T_001', speaker="JODIE", follower="D_003_T_002")
	dialog.add_text(text='D_003_T_002', speaker="ALTER_EGO", follower="ENDDIALOG")
	dialog.start(True, data().QB_010)
	
def Dlg_004_Jodie_Bedankt_Sich():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_004')
	dialog.add_text(text='D_004_T_001', speaker="JODIE", follower="D_004_C_001")
	dialog.add_choice(text='D_004_C_001_1', follower = 'D_004_T_002')
	dialog.add_choice(text='D_004_C_001_2', follower = 'ENDDIALOG') #, callback = Dlg_004_ENDE1)
	dialog.add_text(text='D_004_T_002', speaker="JODIE", follower="D_004_T_003")
	dialog.add_text(text='D_004_T_003', speaker="ALTER_EGO", follower="ENDDIALOG", callback = Dlg_004_ENDE2)
	dialog.start(True, data().QB_010)
	
#def Dlg_004_ENDE1():
	
def Dlg_004_ENDE2():
	#Quest RadioTelescop fertig
	system.set_qb_entry_state(data().QB_010,COMPLETE)
	data().Radiotelescop = True
	character.add_experience_party(150)
	
def Dlg_005_Jodie_Freut_Sich():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_005')
	dialog.add_text(text='D_005_T_001', speaker="JODIE", follower="D_005_T_002")
	dialog.add_text(text='D_005_T_002', speaker="ALTER_EGO", follower="ENDDIALOG")
	dialog.start(True, data().QB_010)
	
#-----------------------------------------------------------------------------------------
#DICK_THE_DIGGER
#-----------------------------------------------------------------------------------------
# Startdialog
def initDlg_024_Dick_Warnung(char = "ALTER_EGO"):
	# Verzoegerung ausnutzen fuer Turret Startposition
	objects.set_position_free(Turret_id[1],Turret_Pos[1][0],Turret_Pos[1][1],data().Turret_High[1])
	objects.set_position_free(Turret_id[0],Turret_Pos[0][0],Turret_Pos[0][1],data().Turret_High[0])
	data().Dick_1st_Time = False
	system.start_cutscene()
	system.set_camera_view([294.33767700195312, 790.60205078125, 10.440395355224609, 0.4124414324760437, -0.88524961471557617, -0.21500034630298615])
	#dynamic_camera.set_cutscene("DICK_THE_DIGGER", "ALTER_EGO", mode = 'far')
	# AE, den Weg lang kommen
	objects.move_to("ALTER_EGO", CUTSCENE_D_024_PARTY[0][0], CUTSCENE_D_024_PARTY[0][1], speed = MT_NORMAL, callback = Lambda('system.set_camera_view([295.90643310546875, 779.18707275390625, 10.688973426818848, 0.4000687301158905, -0.89090961217880249, -0.21500004827976227])'))
	x = 1
	for char in system.get_pcs():
		if char != 'ALTER_EGO':
			# print x
			objects.move_to(char, CUTSCENE_D_024_PARTY[x][0], CUTSCENE_D_024_PARTY[x][1], speed = MT_NORMAL)
			x += 1


	# Spazieren(Dick)
	objects.move_to("DICK_THE_DIGGER",311,754, speed = MT_SLOW, callback = ["ONEND",initDlg_024_Dick_Warnung_2])

def initDlg_024_Dick_Warnung_2(char = "ALTER_EGO"):
	#dynamic_camera.set_cutscene("DICK_THE_DIGGER", "ALTER_EGO", mode = 'far')
	system.set_camera_view([295.90643310546875, 779.18707275390625, 10.688973426818848, 0.4000687301158905, -0.89090961217880249, -0.21500004827976227])
	objects.turn_to_object("DICK_THE_DIGGER","ALTER_EGO")
	character.play_animation("DICK_THE_DIGGER", "CM_NPC_STEHEN_WINKEN_START")
	character.play_animation("DICK_THE_DIGGER", "CM_NPC_STEHEN_WINKEN_LOOP")
	
	#Positionieren
	objects.move_to("DICK_THE_DIGGER",305,760)
	objects.turn_to_object("DICK_THE_DIGGER","ALTER_EGO", callback = ["ONEND",initDlg_024_Dick_Warnung_3])
	#system.start_cutscene()
	#dynamic_camera.set_conversation("ALTER_EGO", cam_x = 1, cam_y = 1, mode = 'far')
	# on End Movement

def initDlg_024_Dick_Warnung_3(char = "ALTER_EGO"):
	#system.set_camera_view([295.90643310546875, 779.18707275390625, 10.688973426818848, 0.4000687301158905, -0.89090961217880249, -0.21500004827976227])
	system.end_cutscene()
	Dlg_024_Dick_Warnung()

def Dlg_024_Dick_Warnung(char = "ALTER_EGO"):
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_024')
	dialog.add_text(text='D_024_T_001', speaker="DICK_THE_DIGGER", follower="D_024_C_001")
	if objects.get_attribute("ALTER_EGO", 'gender') == MALE:
		dialog.add_choice(text='D_024_C_001_1', follower = 'D_024_T_002')
	else:
		dialog.add_choice(text='D_024_C_001_1', follower = 'D_024_T_002F')
	dialog.add_choice(text='D_024_C_001_2', follower = 'D_024_T_003')
	dialog.add_choice(text='D_024_C_001_3', follower = 'D_024_T_004')
	dialog.add_choice(text='D_024_C_001_4', follower = 'D_024_T_005')
	dialog.add_text(text='D_024_T_002', speaker="DICK_THE_DIGGER", follower="D_024_C_002")
	dialog.add_text(text='D_024_T_002F', speaker="DICK_THE_DIGGER", follower="D_024_C_002")
	dialog.add_text(text='D_024_T_003', speaker="DICK_THE_DIGGER", follower="D_024_C_002")
	dialog.add_text(text='D_024_T_004', speaker="DICK_THE_DIGGER", follower="D_024_C_002")
	dialog.add_text(text='D_024_T_005', speaker="DICK_THE_DIGGER", follower="ENDDIALOG", callback = Dlg_024_Restart_C_002)
	dialog.add_choice(text='D_024_C_002_1', follower = 'D_024_T_006', order = 4)
	
	dialog.add_choice(text='D_024_C_002_3', follower = 'D_024_T_008', order = 2)
	if data().Dick_D_024_C_002_2:
		dialog.add_choice(text='D_024_C_002_2', follower = 'D_024_T_007', order = 3)
	if data().Dick_D_024_C_002_4:	
		dialog.add_choice(text='D_024_C_002_4', follower = 'D_024_T_017', order = 1)
	dialog.add_text(text='D_024_T_017', speaker="DICK_THE_DIGGER", follower="ENDDIALOG", callback = Dlg_024_Restart_C_002)
	dialog.add_text(text='D_024_T_006', speaker="DICK_THE_DIGGER", follower="D_024_C_003")
	dialog.add_text(text='D_024_T_007', speaker="DICK_THE_DIGGER", follower="D_024_C_003")
	dialog.add_text(text='D_024_T_008', speaker="DICK_THE_DIGGER", follower="D_024_C_003")
	dialog.add_choice(text='D_024_C_003_1', follower = 'D_024_T_009')
	dialog.add_choice(text='D_024_C_003_2', follower = 'D_024_T_010')
	dialog.add_choice(text='D_024_C_003_3', follower = 'D_024_T_011')
	dialog.add_choice(text='D_024_C_003_4', follower = 'D_024_T_013')
	dialog.add_choice(text='D_024_C_003_5', follower = 'D_024_T_012')
	dialog.add_text(text='D_024_T_009', speaker="DICK_THE_DIGGER", follower="D_024_C_004")
	dialog.add_text(text='D_024_T_010', speaker="DICK_THE_DIGGER", follower="D_024_C_004")
	dialog.add_text(text='D_024_T_011', speaker="DICK_THE_DIGGER", follower="D_024_C_004")
	dialog.add_text(text='D_024_T_012', speaker="DICK_THE_DIGGER", follower="ENDDIALOG", callback = Lambda('Dlg_024_Restart_C_004(True)'))
	dialog.add_text(text='D_024_T_013', speaker="DICK_THE_DIGGER", follower="ENDDIALOG", callback = Lambda('Dlg_024_Restart_C_004(True)'))
	#print "C_004_1 ",data().Dick_C_004_Restart_1
	if data().Dick_C_004_Restart_1:
		dialog.add_choice(text='D_024_C_004_1', follower = 'D_024_T_014')
	dialog.add_choice(text='D_024_C_004_2', follower = 'D_024_T_015')
	dialog.add_choice(text='D_024_C_004_3', follower = 'D_024_T_016')
	dialog.add_choice(text='D_024_C_004_4', follower = 'ENDDIALOG', callback = Dlg_024_ENDE1)
	dialog.add_text(text='D_024_T_014', speaker="DICK_THE_DIGGER", follower="ENDDIALOG", callback = Lambda("Dlg_024_Restart_C_004(False)"))
	dialog.add_text(text='D_024_T_015', speaker="DICK_THE_DIGGER", follower="ENDDIALOG", callback = Dlg_024_ENDE1)
	dialog.add_text(text='D_024_T_016', speaker="DICK_THE_DIGGER", follower="ENDDIALOG", callback = Dlg_024_ENDE1)
	
	if data().Dick_C_002_Restart:
		data().Dick_C_002_Restart = False
		dialog.jump_to("D_024_C_002")
	if data().Dick_C_004_Restart:
		dialog.jump_to("D_024_C_004")
	dialog.start(False, data().QB_008)
	data().Dick_C_002_Restart = False
	data().Dick_C_004_Restart = False
	
def Dlg_024_ENDE1():
	#Dick zu seiner Huette: Schedules einfach einschalten?
	daily_routine.allow_activity("DICK_THE_DIGGER")
	
	
#Helper fuer D_024
def Dlg_024_Restart_C_002(dialog_id):
	data().Dick_C_002_Restart = True
	if dialog_id == 'D_024_T_005':
		data().Dick_D_024_C_002_4 = True
	else:
		data().Dick_D_024_C_002_2 = False
		data().Dick_D_024_C_002_4 = False
	Dlg_024_Dick_Warnung()
	#data().Dick_C_002_Restart = False
	
	
def Dlg_024_Restart_C_004(restart = True):
	data().Dick_C_004_Restart = True
	data().Dick_C_004_Restart_1 = restart
	Dlg_024_Dick_Warnung()
	#data().Dick_C_004_Restart = False
	
	
# Dick in seiner Hütte(025)
def Dlg_025_Dick_Huette():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_025')
	if not data().Dick_D_025_Again:
		dialog.add_text(text='D_025_T_001', speaker="DICK_THE_DIGGER", follower="D_025_C_001")
	else:
		dialog.add_text(text='D_025_T_002', speaker="DICK_THE_DIGGER", follower="D_025_C_001")
	if not data().Dick_D_025_C_001_Restart_4_1:
		dialog.add_choice(text='D_025_C_001_1', follower = 'D_025_T_003')
	if not data().Dick_D_025_C_001_Restart_4_2:
		dialog.add_choice(text='D_025_C_001_2', follower = 'D_025_T_004')
	if not data().Dick_D_025_C_001_Restart_4_3:
		dialog.add_choice(text='D_025_C_001_3', follower = 'D_025_T_005')
	if not data().Dick_D_025_C_001_Restart_4:
		dialog.add_choice(text='D_025_C_001_4', follower = 'ENDDIALOG')
	else:
		dialog.add_choice(text='D_025_C_001_5', follower = 'ENDDIALOG')
	dialog.add_text(text='D_025_T_003', speaker="DICK_THE_DIGGER", follower="ENDDIALOG", callback = Dlg_025_Restart_C_001_1)
	dialog.add_text(text='D_025_T_004', speaker="DICK_THE_DIGGER", follower="ENDDIALOG", callback = Dlg_025_Restart_C_001_2)
	dialog.add_text(text='D_025_T_005', speaker="DICK_THE_DIGGER", follower="ENDDIALOG", callback = Dlg_025_Restart_C_001_3)
	if data().Dick_D_025_C_001_Restart_4:
		dialog.jump_to("D_025_C_001_5")
	dialog.start(False)
	
# Helper Dlg_025
def Dlg_025_Restart_C_001_1():
	data().Dick_D_025_C_001_Restart_4 = True
	data().Dick_D_025_C_001_Restart_4_1 = True
	Dlg_025_Dick_Huette()

def Dlg_025_Restart_C_001_2():
	data().Dick_D_025_C_001_Restart_4 = True
	data().Dick_D_025_C_001_Restart_4_2 = True
	Dlg_025_Dick_Huette()
	
def Dlg_025_Restart_C_001_3():
	data().Dick_D_025_C_001_Restart_4 = True
	data().Dick_D_025_C_001_Restart_4_3 = True
	Dlg_025_Dick_Huette()
	
# Dick nach Loesung des Seekerproblems(026)
def Dlg_026_Dick_Seeker_Tot():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_026')
	dialog.add_text(text='D_026_T_001', speaker="DICK_THE_DIGGER", follower="D_026_C_001")
	dialog.add_choice(text='D_026_C_001_1', follower = 'D_026_T_002')
	if objects.get_attribute("ALTER_EGO", 'gender') == MALE:
		dialog.add_choice(text='D_026_C_001_2', follower = 'D_026_T_003')
	else:
		dialog.add_choice(text='D_026_C_001_2', follower = 'D_026_T_003F')
	dialog.add_text(text='D_026_T_002', speaker="DICK_THE_DIGGER", follower="ENDDIALOG")
	dialog.add_text(text='D_026_T_003', speaker="DICK_THE_DIGGER", follower="D_026_C_002")
	dialog.add_text(text='D_026_T_003F', speaker="DICK_THE_DIGGER", follower="D_026_C_002")
	dialog.add_choice(text='D_026_C_002_1', follower = 'D_026_T_004')
	dialog.add_choice(text='D_026_C_002_2', follower = 'ENDDIALOG', callback = Dlg_026_ENDE1)
	dialog.add_text(text='D_026_T_004', speaker="DICK_THE_DIGGER", follower="ENDDIALOG")
	dialog.start(False)
	data().Dick_Dlg_027 = True
	
def Dlg_026_ENDE1():
	#objects.create_item_in_inventory("DICK_THE_DIGGER", "SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL")
	character.equip_direct("DICK_THE_DIGGER", "SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL", creation = True, direct_ammo_load=True)
	objects.set_attribute("DICK_THE_DIGGER", "foes", ["UISPIELER"])

	
# Dick will Ruhe (027)
def Dlg_027_Dick_will_Ruhe():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_027')
	dialog.add_text(text='D_027_T_001', speaker="DICK_THE_DIGGER", follower="ENDDIALOG")
	dialog.start()


#-----------------------------------------------------------------------------
#Schussanlage und Bunker
#-----------------------------------------------------------------------------

def Dlg_014_Turrets_Warnung_1(character_id = "ALTER_EGO"):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_014')
	dialog.add_text(text='D_014_T_001', speaker=character_id, follower="ENDDIALOG")
	dialog.start(True, data().QB_010)
	
def Dlg_015_Turrets_Warnung_2(character_id = "ALTER_EGO"):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_015')
	dialog.add_text(text='D_015_T_001', speaker=character_id, follower="ENDDIALOG")
	dialog.start(True, data().QB_010)
	
def Dlg_016_Turrets_Uhrzeit_Falsch(character_id = "ALTER_EGO"):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_016')
	dialog.add_text(text='D_016_T_001', speaker=character_id, follower="ENDDIALOG")
	dialog.start(True, data().QB_010)
	
def Dlg_017_Turrets_Uhrzeit_Richtig(character_id = "ALTER_EGO"):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_017')
	dialog.add_text(text='D_017_T_001', speaker=character_id, follower="ENDDIALOG")
	dialog.start(True, data().QB_010)
	
def Dlg_018_Turrets_Zufall(character_id = "ALTER_EGO"):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_018')
	dialog.add_text(text='D_018_T_001', speaker=character_id)
	dialog.add_text(text='D_018_T_002', speaker=character_id, follower="ENDDIALOG")
	dialog.start(True, data().QB_010)
	
def Dlg_019_Turrets_Passiert(character_id = "ALTER_EGO"):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_019')
	dialog.add_text(text='D_019_T_001', speaker=character_id, follower="ENDDIALOG")
	dialog.start(True, data().QB_010)

#--------------------------------------------------------------------------------------
# Bunkeranlage	Cutscene
#--------------------------------------------------------------------------------------

def init_Dlg_023_Bunker(character_id = "ALTER_EGO"):
	# Punkt auf Vorplatz als Zentrum waehlen?
	for id in system.get_pcs():
		objects.cancel_commandos(id)
	#if data().Dlg_023_First_Time:
	init_Dlg_023_Bunker_2()
	
def init_Dlg_023_Bunker_2(character_id = "ALTER_EGO"):
	# Alle auf Anfang
	if objects.get_distance_to_position("ALTER_EGO",315,277) > 10:
		data().Dlg_023_Fade = True
	counter = 0
	for id in system.get_pcs():
		if id != "ALTER_EGO":
			if objects.get_distance_to_position(id,315,273)> 8:
				counter += 1
				data().Dlg_023_Fade = True
	# Action
	if data().Dlg_023_Fade:
		init_Dlg_023_Bunker_Fade_Out()
	else:
		system.start_cutscene()
		system.set_camera_view([315.44906616210937, 291.67599487304687, 20.098552703857422, 0.65268713235855103, -0.72647953033447266, -0.21500459313392639])
		init_Dlg_023_Bunker_Move_1("ALTER_EGO")
	
def init_Dlg_023_Bunker_Fade_Out():
	system.fade(FADE_OUT)#, callback = init_Dlg_023_Bunker_Fade_Out_2)
	system.notify_timer(data().Timer_Fade_In, data().Timervalue_Fade_In)
	
def init_Dlg_023_Bunker_Fade_Out_2():
	counter = 0
	for id in system.get_pcs():
		if id != "ALTER_EGO":
			if objects.get_distance_to_position(id,319,276)> 6:
				objects.set_position(id,Dlg_023_PCs_Positions_Start[counter][0],Dlg_023_PCs_Positions_Start[counter][1])
				counter += 1

	system.start_cutscene()
	system.set_camera_view([315.44906616210937, 291.67599487304687, 20.098552703857422, 0.65268713235855103, -0.72647953033447266, -0.21500459313392639])
	if objects.get_distance_to_position("ALTER_EGO",318,279) > 6:
		#data().Dlg_023_Fade = True
		objects.set_position("ALTER_EGO",318,279)
		system.fade(FADE_IN)
		init_Dlg_023_Bunker_Move_1()
		
	else:
		system.fade(FADE_IN)
		objects.move_to("ALTER_EGO",330,283, callback = ["ONEND", init_Dlg_023_Bunker_Move_1])
	
def init_Dlg_023_Bunker_Move_1(character_id = "ALTER_EGO"):
	objects.move_to("ALTER_EGO",327.5,283.5, callback = ["ONEND", init_Dlg_023_Bunker_Move_2])
	counter = 0
	for id in system.get_pcs():
		if id != "ALTER_EGO":
			objects.move_to(id, Dlg_023_PCs_Positions_Door[counter][0], Dlg_023_PCs_Positions_Door[counter][1], speed = MT_SLOW, callback = ["ONEND", init_Dlg_023_Bunker_Look])
			counter += 1
	
def init_Dlg_023_Bunker_Move_2(character_id = "ALTER_EGO"):
	Dlg_023_Bunker()
	system.set_camera_view([324.59246826171875, 290.39334106445312, 18.59813117980957, 0.74289911985397339, -0.63393688201904297, -0.21500006318092346])
	objects.move_to_object(character_id, "ZZONE_9_BUILDING_19234", dummy = "dmyp_001", callback = ["ONEND",init_Dlg_023_Bunker_Move_3])

def init_Dlg_023_Bunker_Move_3(character_id = "ALTER_EGO"):
	if objects.has_attribute("ALTER_EGO",'slots') and objects.get_attribute("ALTER_EGO","slots").has_key("right_hand"):
		data().Dlg_023_AE_Weapon = objects.get_attribute("ALTER_EGO","slots")["right_hand"]
		if data().Dlg_023_AE_Weapon:
			character.un_equip("ALTER_EGO", data().Dlg_023_AE_Weapon)
	character.play_animation(character_id, animation = "CM_STEHEN_CODE_TIPPEN", callback = ["ONEND", init_Dlg_023_Bunker_Door])
	
def init_Dlg_023_Bunker_Door(character_id = "ALTER_EGO"):
	system.set_camera_view([332.57595825195312, 270.33865356445312, 18.520055770874023, -0.15180665254592896, 0.96474337577819824, -0.21500000357627869])
	objects.step_away("ALTER_EGO")
	if data().Dlg_023_AE_Weapon:
		character.equip("ALTER_EGO", data().Dlg_023_AE_Weapon)
	objects.move_to("ALTER_EGO",330,282, speed = MT_SLOW, callback = ["ONEND", init_Dlg_023_Bunker_Look])
	objects.play_animation("ZZONE_9_BUILDING_19234","ANIM_BUNKERANLAGE_DOOR")
	import sounds
	sounds.play_3d_sound_object(sfx_id = 'bunkerdoor',object = "ZZONE_9_BUILDING_19234")
	
def init_Dlg_023_Bunker_Look(character_id):
	objects.turn_to_object(character_id,"ZZONE_9_BUILDING_19234")
	
def Dlg_023_Bunker(character_id = "ALTER_EGO"):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_023')
	dialog.add_text(text='D_023_T_001', speaker=character_id, follower="ENDDIALOG", callback = helper_switch_zone)
	dialog.start()
	
def helper_switch_zone():
	system.fade(FADE_OUT, callback = helper_switch_zone_2)
	
	if system.get_qb_entry_state(data().QB_008) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_008,COMPLETE)
	elif system.get_qb_entry_state(data().QB_008) != COMPLETE:
		#print"Questbook aufraeumen"
		if system.get_qb_entry_state(data().Marker_QB_001) == UNCOMPLETE:
			#print"QB_001"
			system.set_qb_entry_state(data().Marker_QB_001,IMPOSSIBLE)
			data().Rampage = True
			# Bensons Gang(Rolling Thunder) auf aggro setzen
			for id in data().Benson_Gang:
				objects.set_immortal_state(id,False)
				objects.set_attribute(id,"foes", ["UISPIELER"])
			# Lookout Starten
			data().Benson_Lookout = True
			data().Gang_Field_Glasses = objects.create_item_in_inventory("GANG_A_1",'SET_BINOCULARS')
			character.equip("GANG_A_1", data().Gang_Field_Glasses)
			#notifier Abfangen
			data().Benson_Lager_Betreten = True
			
			# Howards Gang(Deathstrike) auf aggro setzen
			for id in data().Howard_Gang:
				objects.set_immortal_state(id,False)
				objects.set_attribute(id,"foes", ["UISPIELER"])
			# Lookout starten
			data().Howard_Lookout = True
			data().Gang_Field_Glasses = objects.create_item_in_inventory("GANG_B_1",'SET_BINOCULARS')
			character.equip("GANG_B_1", data().Gang_Field_Glasses)
			
			#notifier Abfangen
			data().Howard_Lager_Betreten = True
		elif system.get_qb_entry_state(data().QB_002) == UNCOMPLETE:
			#print"QB_002"
			system.set_qb_entry_state(data().QB_002,IMPOSSIBLE)
			data().Rampage = True
			# Bensons Gang(Rolling Thunder) auf aggro setzen
			for id in data().Benson_Gang:
				objects.set_immortal_state(id,False)
				objects.set_attribute(id,"foes", ["UISPIELER"])
			# Lookout Starten
			data().Benson_Lookout = True
			data().Gang_Field_Glasses = objects.create_item_in_inventory("GANG_A_1",'SET_BINOCULARS')
			character.equip("GANG_A_1", data().Gang_Field_Glasses)
			#notifier Abfangen
			data().Benson_Lager_Betreten = True
			data().Gang_1_XP = False
		elif system.get_qb_entry_state(data().QB_003) == UNCOMPLETE:
			#print"QB_003"
			system.set_qb_entry_state(data().QB_003,IMPOSSIBLE)
			data().Rampage = True
			# Howards Gang(Deathstrike) auf aggro setzen
			for id in data().Howard_Gang:
				objects.set_immortal_state(id,False)
				objects.set_attribute(id,"foes", ["UISPIELER"])
			# Lookout starten
			data().Howard_Lookout = True
			data().Gang_Field_Glasses = objects.create_item_in_inventory("GANG_B_1",'SET_BINOCULARS')
			character.equip("GANG_B_1", data().Gang_Field_Glasses)
			
			#notifier Abfangen
			data().Howard_Lager_Betreten = True
			
		elif system.get_qb_entry_state(data().QB_004) == UNCOMPLETE:
			#print"QB_004"
			system.set_qb_entry_state(data().QB_004,IMPOSSIBLE)
			data().Rampage = True
			# Bensons Gang(Rolling Thunder) auf aggro setzen
			for id in data().Benson_Gang:
				objects.set_immortal_state(id,False)
				objects.set_attribute(id,"foes", ["UISPIELER"])
			# Lookout Starten
			data().Benson_Lookout = True
			data().Gang_Field_Glasses = objects.create_item_in_inventory("GANG_A_1",'SET_BINOCULARS')
			character.equip("GANG_A_1", data().Gang_Field_Glasses)
			#notifier Abfangen
			data().Benson_Lager_Betreten = True
			data().Gang_1_XP = False
		elif system.get_qb_entry_state(data().QB_005) == UNCOMPLETE:
			#print"QB_005"
			system.set_qb_entry_state(data().QB_005,IMPOSSIBLE)
			data().Rampage = True
			# Howards Gang(Deathstrike) auf aggro setzen
			for id in data().Howard_Gang:
				objects.set_immortal_state(id,False)
				objects.set_attribute(id,"foes", ["UISPIELER"])
			# Lookout starten
			data().Howard_Lookout = True
			data().Gang_Field_Glasses = objects.create_item_in_inventory("GANG_B_1",'SET_BINOCULARS')
			character.equip("GANG_B_1", data().Gang_Field_Glasses)
			
			#notifier Abfangen
			data().Howard_Lager_Betreten = True
			
def helper_switch_zone_2():
	if system.is_cutscene():
		system.end_cutscene()
	
	
	data().Bunker_Betreten = True
	print "Zonenwechsel"
	system.switch_zone("zzone_10")
	

#------------------------------------------------------------------
# Seeker Leiche
#------------------------------------------------------------------
def Daddy_Cool_Helper(character_id = "ALTER_EGO"):
	if system.get_qb_entry_state(data().Marker_QB_001) == UNCOMPLETE:
		Dlg_021_Daddy_Cool_Unknown(character_id)
	elif system.get_qb_entry_state(data().QB_008) == COMPLETE:
		Dlg_022_Daddy_Cool_Alt(character_id)
	elif system.get_qb_entry_state(data().Marker_QB_001) == INACTIVE:
		Dlg_020_Daddy_Cool(character_id)
	
def Dlg_020_Daddy_Cool(character_id= "ALTER_EGO"):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_020')
	dialog.add_text(text='D_020_T_001', speaker=character_id)
	dialog.add_text(text='D_020_T_002', speaker=character_id, follower="ENDDIALOG")
	dialog.start()
	
def Dlg_021_Daddy_Cool_Unknown(character_id= "ALTER_EGO"):
	data().D_029_C_002_2 = True
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_021')
	dialog.add_text(text='D_021_T_001', speaker=character_id)
	dialog.add_text(text='D_021_T_002', speaker=character_id, follower="ENDDIALOG")
	dialog.start()
	
def Dlg_022_Daddy_Cool_Alt(character_id= "ALTER_EGO"):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_022')
	dialog.add_text(text='D_022_T_001', speaker=character_id, follower="ENDDIALOG")
	dialog.start()
	
	
#------------------------------------------------------------------------
#GANGS Gemeinsam genutzt
#------------------------------------------------------------------------


def Gang_Look_Pc(character_id, body_mode = 'STAND'):
	pc_list = system.get_pcs()
	if pc_list > 1:
		pc_nr = random.randint(1,len(pc_list))-1
		objects.turn_to_object(character_id,pc_list[pc_nr])
	else:
		objects.turn_to_object(character_id,"ALTER_EGO")
	character.change_body_mode(character_id,body_mode)
	
def Gang_List_Look_PCs(char_list):
	for id in char_list:
		if not id in ["BENSON","HOWARD"]:
			pc_list = system.get_pcs()
			if pc_list > 1:
				pc_nr = random.randint(1,len(pc_list))-1
				objects.turn_to_object(id,pc_list[pc_nr])
			else:
				objects.turn_to_object(id,"ALTER_EGO")
	
		
def Dlg_XXX_Move_NPC(character_id, dataset):
	if dataset[character_id][0]:
		move_counter = 0
		if len(dataset[character_id][0]) > 1:
			for dummy in range(0,len(dataset[character_id][0])-1):
				objects.move_to(character_id,dataset[character_id][0][move_counter][0],dataset[character_id][0][move_counter][1],speed = dataset[character_id][0][move_counter][2])
				move_counter += 1
		objects.move_to(character_id, dataset[character_id][0][move_counter][0], dataset[character_id][0][move_counter][1], speed = dataset[character_id][0][move_counter][2]
				, callback = ['ONEND', Lambda('Dlg_XXX_Move_NPC_Finish("%s",%s)'%(character_id,dataset))])
	else:
		Dlg_XXX_Move_NPC_Finish(character_id,dataset)
	
def Dlg_XXX_Move_NPC_Finish(character_id,dataset):
	if character_id in data().Gang_B_Combat_Moving:
		data().Gang_B_Combat_Moving.remove(character_id)
		objects.turn_to_position(character_id,525,560)
	if character_id in data().Gang_A_Combat_Moving:
		data().Gang_A_Combat_Moving.remove(character_id)
		objects.turn_to_position(character_id,270,583)
	#character.change_body_mode(character_id,dataset[character_id][1], callback = ['ONEND', Lambda("Gang_List_Look_PCs(['%s'])"%(character_id))])
	
	#Gang_List_Look_PCs([character_id])
	body_mode_text = "character.change_body_mode('%s','%s')"%(character_id,dataset[character_id][1])
	enemy_script.delay(1,Lambda(body_mode_text))
	
#------------------------------------------------------------------------
#BENSON + GANG
#------------------------------------------------------------------------
# Vorlauf bei Betreten
def Gang_A_Kampfposition_1(move_spd = MT_SLOW):
	data().Gang_A_Combat_Position = True
	
	data().Benson_Reached_Position = False
	for id in data().Benson_Gang:
		objects.cancel_commandos(id)
		daily_routine.prohibit_activity(id)
		
		if objects.get_distance_to_position(id,Data_Gang_A_Haltungen_1[id][0][0][0], Data_Gang_A_Haltungen_1[id][0][0][1]) > 35:
			move_spd = MT_FAST
		elif move_spd != MT_FAST:
			move_spd = Data_Gang_A_Haltungen_1[id][0][0][2]
		#if id != "BENSON":
		objects.move_to(id,Data_Gang_A_Haltungen_1[id][0][0][0], Data_Gang_A_Haltungen_1[id][0][0][1],speed = move_spd, callback = ["ONEND",Gang_Look_Pc_2])
		#else:
		#	print"BENSON moving",Data_Gang_A_Haltungen_1[id][0][0][0],",", Data_Gang_A_Haltungen_1[id][0][0][1]
		#	objects.move_to(id,Data_Gang_A_Haltungen_1[id][0][0][0], Data_Gang_A_Haltungen_1[id][0][0][1],speed = move_spd, callback = ["ONEND",initDlg_008_Benson_Talk])
	
	# Zurueck auf Anfang wenn Spieler nicht kommt
	system.notify_timer(data().Timer_Gang_A_Schedule_2,data().Timervalue_Gang_A_Schedule_2)
	data().Gang_A_Schedule_Return = True
			
def Gang_Look_Pc_2(character_id, body_mode = 'STAND'):
	objects.turn_to_position(character_id,267,567)
	#print character_id,"mode",Data_Gang_A_Haltungen_1[character_id][1]
	character.change_body_mode(character_id,Data_Gang_A_Haltungen_1[character_id][1])
	if id == "BENSON":
		 data().Benson_Reached_Position = True
		
	"""	
	for i in range(0,3):
		for i2 in range(0,len(data().Benson_Team_List[i])):
			if not objects.is_destroyed(data().Benson_Team_List[i][i2]):
				objects.cancel_commandos(data().Benson_Team_List[i][i2])
				daily_routine.prohibit_activity(data().Benson_Team_List[i][i2])
				if objects.get_distance_to_position(data().Benson_Team_List[i][i2],Data_Gang_A_Kampfposition_1[i][i2][0], Data_Gang_A_Kampfposition_1[i][i2][1]) > 35:
					move_spd = MT_FAST
				elif move_spd != MT_FAST:
					move_spd = MT_SLOW
				objects.move_to(data().Benson_Team_List[i][i2],Data_Gang_A_Kampfposition_1[i][i2][0], Data_Gang_A_Kampfposition_1[i][i2][1], speed = move_spd, callback = ["ONEND",Gang_Look_Pc])
	objects.cancel_commandos("BENSON")
	daily_routine.prohibit_activity("BENSON")
	objects.move_to("BENSON",262,550,speed = move_spd, callback = ["ONEND", initDlg_008_Benson_Talk])
	"""

def Gang_A_Schedule():
	data().Gang_A_Combat_Position = False
	for id in data().Benson_Gang:
		character.change_body_mode(id,"STAND")
		daily_routine.allow_activity(id)	
	
# Cutscene Begruessung
def initDlg_008_Benson_Talk(character_id):
	objects.turn_to_object("BENSON", "ALTER_EGO")
	data().Benson_Reached_Position = True
	#dynamic_camera.talk_animation_weapon("BENSON")
	
def initDlg_008_Benson_Begruessung():
	#system.add_minimap_marker(260,563,"MM_001") #Bensons Lager
	if not data().Gang_A_Combat_Position:
		Gang_A_Kampfposition_1(MT_FAST)
	data().Gang_A_Schedule_Return = False
	data().Dlg_008_AE_Reached_Position = False
	system.start_cutscene()
	system.set_camera_view(CAM_B_1)
	i = 0
	for id in data().PC_List:
		if objects.get_distance_to_position(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1]) > 50:
			objects.set_position(id,272.5,580.5)
		if id == "ALTER_EGO":
			objects.move_to(id,Data_Gang_A_Kampfpositionen_PCs_1[i][0], Data_Gang_A_Kampfpositionen_PCs_1[i][1], callback = ["ONEND", init_Dlg_008_AE_Camera])
		else:
			objects.move_to(id,Data_Gang_A_Kampfpositionen_PCs_1[i][0], Data_Gang_A_Kampfpositionen_PCs_1[i][1])
		objects.move_to(id,Data_Gang_A_Kampfpositionen_PCs_2[i][0], Data_Gang_A_Kampfpositionen_PCs_2[i][1], speed = MT_SLOW,
				callback = ["ONEND", Lambda('initDlg_008_PCs_Look("%s", "BENSON","%s")' % (id,Data_Gang_A_Kampfpositionen_PCs_2[i][2]))])
		i += 1
	
def init_Dlg_008_AE_Camera(character_id= "ALTER_EGO"):
	system.set_camera_view(CAM_B_2)
	#if data().Benson_Reached_Position:
	#	dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	Dlg_008_Benson_Begruessung()
	
def initDlg_008_PCs_Look(character_id,direction, body_mode = "STAND"):
	character.change_body_mode(character_id,body_mode)
	objects.turn_to_object(character_id,direction)
	if character_id == "ALTER_EGO":
		objects.turn_to_object("BENSON", "ALTER_EGO")
		data().Dlg_008_AE_Reached_Position = True
		#dynamic_camera.talk_animation_weapon("ALTER_EGO")
	
def Dlg_008_Benson_Begruessung():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_008')
	dialog.add_text(text='D_008_T_001', speaker="BENSON", follower="D_008_T_002",callback = Dlg_008_Camera_3)
	dialog.add_text(text='D_008_T_002', speaker="ALTER_EGO", follower="D_008_T_003",callback = Dlg_008_Camera_4)
	dialog.add_text(text='D_008_T_003', speaker="BENSON", follower="ENDDIALOG", callback = initDlg_009_Benson_Endscheidung)
	dialog.start(True, data("zone_5.zone_5").QB_019)
	
def Dlg_008_Camera_3():
	system.set_camera_view(CAM_B_3)
	if data().Dlg_008_AE_Reached_Position and data().Benson_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="BENSON", new_camera=False)
	
def Dlg_008_Camera_4():
	system.set_camera_view(CAM_B_4)
	if data().Benson_Reached_Position and data().Dlg_008_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	
def initDlg_009_Benson_Endscheidung():
	system.end_cutscene()
	objects.cancel_commandos("BENSON")
	Dlg_009_Benson_Endscheidung()
	
def Dlg_009_Benson_Endscheidung():
	data().Seeker_Stress = True
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_009')
	dialog.set_dialog_identifier('D_009')
	dialog.add_choice(text='D_009_C_001_1', follower = 'D_009_T_001', auto_deactivation='permanent')
	dialog.add_choice(text='D_009_C_001_2', follower = 'D_009_T_004', auto_deactivation='permanent')
	if data().D_009_C_001_3:
		dialog.add_choice(text='D_009_C_001_3', follower = 'D_009_T_009', auto_deactivation='permanent')
	if data().D_009_C_001_4:
		dialog.add_choice(text='D_009_C_001_4', follower = 'D_009_T_010', auto_deactivation='permanent')
	dialog.add_choice(text='D_009_C_001_5', follower = 'D_009_T_018', auto_deactivation='permanent')
	dialog.add_text(text='D_009_T_001', speaker="BENSON", follower="D_009_T_002")
	dialog.add_text(text='D_009_T_002', speaker="ALTER_EGO", follower="D_009_T_003")
	dialog.add_text(text='D_009_T_003', speaker="BENSON", follower="D_009_C_001")
	dialog.add_text(text='D_009_T_004', speaker="BENSON", follower="D_009_T_005")
	dialog.add_text(text='D_009_T_005', speaker="ALTER_EGO", follower="D_009_T_006")
	dialog.add_text(text='D_009_T_006', speaker="BENSON", follower="D_009_T_007")
	dialog.add_text(text='D_009_T_007', speaker="ALTER_EGO", follower="D_009_T_008")
	dialog.add_text(text='D_009_T_008', speaker="BENSON", follower="ENDDIALOG", callback = Dlg_009_Restart_C_001)
	dialog.add_text(text='D_009_T_009', speaker="BENSON", follower="ENDDIALOG", callback = Dlg_009_Restart_C_001)
	dialog.add_text(text='D_009_T_010', speaker="BENSON", follower="D_009_T_011")
	if objects.get_attribute("ALTER_EGO", 'gender') == MALE:
		dialog.add_text(text='D_009_T_011', speaker="ALTER_EGO", follower="D_009_T_012")
	else:
		dialog.add_text(text='D_009_T_011', speaker="ALTER_EGO", follower="D_009_T_012F")
	dialog.add_text(text='D_009_T_012', speaker="BENSON", follower="D_009_C_002")
	dialog.add_text(text='D_009_T_012F', speaker="BENSON", follower="D_009_C_002")
	if (object_events.get_speech_skill("ALTER_EGO") < 70):	# [BrainRipper]
		dialog.add_choice(text='D_009_C_002_1', follower='D_009_T_014')
	else:
		dialog.add_choice(text='D_009_C_002_1', follower='D_009_T_013')
	dialog.add_choice(text='D_009_C_002_2', follower='D_009_T_017')
	dialog.add_text(text='D_009_T_013', speaker="BENSON", follower="ENDDIALOG", callback = Dlg_009_ENDE2)
	dialog.add_text(text='D_009_T_014', speaker="BENSON", follower="D_009_T_015")
	dialog.add_text(text='D_009_T_015', speaker="ALTER_EGO", follower="D_009_T_016")
	dialog.add_text(text='D_009_T_016', speaker="BENSON", follower="ENDDIALOG", callback = Dlg_009_ENDE1)
	dialog.add_text(text='D_009_T_017', speaker="BENSON", follower="ENDDIALOG", callback = Dlg_009_ENDE2)
	dialog.add_text(text='D_009_T_018', speaker="BENSON", follower="ENDDIALOG", callback = Dlg_009_ENDE1)

	dialog.start(False, data("zone_5.zone_5").QB_019) #[data().QB_001, data().QB_002])
	
	
def Dlg_009_Restart_C_001(source = ""):
	if source == 'D_009_T_008':
		data().D_009_C_001_3 = True
	elif source == 'D_009_T_009':
		data().D_009_C_001_4 = True
	Dlg_009_Benson_Endscheidung()
	
def Dlg_009_ENDE2():
	system.set_qb_entry_state(data().Marker_QB_001,INACTIVE)
	system.set_qb_entry_state(data().QB_002,UNCOMPLETE)
	data().Gang_1_XP = True
	# Howards Gang(Deathstrike) auf aggro setzen
	for id in data().Howard_Gang:
		objects.set_immortal_state(id,False)
		objects.set_attribute(id,"foes", ["UISPIELER"])
	# Lookout starten
	data().Howard_Lookout = True
	data().Gang_Field_Glasses = objects.create_item_in_inventory("GANG_B_1",'SET_BINOCULARS')
	character.equip("GANG_B_1", data().Gang_Field_Glasses)

	#notifier Abfangen
	data().Howard_Lager_Betreten = True
	# Schedule wieder aktivieren
	system.notify_timer(data().Timer_Gang_A_Schedule,data().Timervalue_Gang_A_Schedule)
	
def Dlg_009_ENDE1():
	data().Gang_1_XP = False
	#system.set_qb_entry_state(data().Marker_QB_001,INACTIVE)	
	objects.cancel_commandos("BENSON")
	character.equip("BENSON","SET_FN_MAG")
	for id in data().Benson_Gang:
		objects.set_immortal_state(id,False)
		objects.set_attribute(id,"foes", ["UISPIELER"])
	#	Select_Team_Target(id)
	
	
	
# Bensons Verrat
def initDlg_010_Benson_Verrat():
	# Granate fuer Cutscene
	data().Gang_A_Grenade_id = system.create_object("SET_FRAGGRENADE",265.2,540.5)
	objects.set_position_free(data().Gang_A_Grenade_id,265.2,540.5,0.1)
	
	if not data().Gang_A_Combat_Position:
		Gang_A_Kampfposition_1(MT_FAST)
	data().Gang_A_Schedule_Return = False
	data().Dlg_010_AE_Reached_Position = False
	system.start_cutscene()
	system.set_camera_view(CAM_B_1)
	i = 0
	for id in data().PC_List:
		if objects.get_distance_to_position(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1]) > 50:
			objects.set_position(id,267.5,573.5)
		if id == "ALTER_EGO":
			objects.move_to(id,Data_Gang_A_Kampfpositionen_PCs_1[i][0], Data_Gang_A_Kampfpositionen_PCs_1[i][1], callback = ["ONEND", init_Dlg_010_AE_Camera])
		else:
			objects.move_to(id,Data_Gang_A_Kampfpositionen_PCs_1[i][0], Data_Gang_A_Kampfpositionen_PCs_1[i][1])
		objects.move_to(id,Data_Gang_A_Kampfpositionen_PCs_3[i][0], Data_Gang_A_Kampfpositionen_PCs_3[i][1], speed = MT_SLOW)
		#callback = ["ONEND", Lambda('initDlg_008_PCs_Look("%s", "BENSON","%s")' % (id,Data_Gang_A_Kampfpositionen_PCs_2[i][2]))])
		i += 1
	
def init_Dlg_010_AE_Camera(character_id= "ALTER_EGO"):
	system.set_camera_view(CAM_B_2)
	Dlg_010_Benson_Verrat()
	
def initDlg_010_PCs_Look(character_id,direction, body_mode = "STAND"):
	character.change_body_mode(character_id,body_mode)
	objects.turn_to_object(character_id,direction)
	if character_id == "ALTER_EGO":
		objects.turn_to_object("BENSON", "ALTER_EGO")
		data().Dlg_010_AE_Reached_Position = True
	
def Dlg_010_Camera_2():
	system.set_camera_view(CAM_B_5)
	if data().Benson_Reached_Position and data().Dlg_010_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Benson_Gang)
	
def Dlg_010_Camera_3():
	system.set_camera_view(CAM_B_11)
	objects.cancel_commandos("GANG_A_5")
	objects.turn_to_position("GANG_A_5",269,557)
	character.play_animation("GANG_A_5","CM_STEHEN_GEWEHRSCHUSS_1_ANLEGEN")
	character.play_animation("GANG_A_5","CM_STEHEN_GEWEHRSCHUSS_1_GESTE")
	character.play_animation("GANG_A_5","CM_STEHEN_GEWEHRSCHUSS_1_GESTE")
	enemy_script.delay(3,Dlg_010_Camera_3_2)
	if data().Benson_Reached_Position and data().Dlg_010_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Benson_Gang)
	
def Dlg_010_Camera_3_2():
	system.set_camera_view(CAM_B_18)
	
def Dlg_010_Camera_4():
	system.set_camera_view(CAM_B_19)
	if data().Dlg_010_AE_Reached_Position and data().Benson_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="BENSON", new_camera=False)
	Gang_List_Look_PCs(data().Benson_Gang)
	
def Dlg_010_Camera_5():
	system.set_camera_view(CAM_B_13)
	if data().Benson_Reached_Position and data().Dlg_010_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Benson_Gang)
	
def Dlg_010_Camera_6():
	system.set_camera_view(CAM_B_14)
	character.change_body_mode("GANG_A_6","STAND")
	Dlg_XXX_Move_NPC("GANG_A_6", Data_Gang_A_Haltungen_3)
	
	if data().Dlg_010_AE_Reached_Position and data().Benson_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="BENSON", new_camera=False)
	#Gang_List_Look_PCs(data().Benson_Gang)
	
def Dlg_010_Camera_7():
	system.set_camera_view(CAM_B_20)
	objects.pick_up_item("GANG_A_9", data().Gang_A_Grenade_id, callback = Lambda("Gang_List_Look_PCs(['GANG_A_9'])"))
	enemy_script.delay(3,Dlg_010_Camera_7_2)
	
	if data().Benson_Reached_Position and data().Dlg_010_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	#Gang_List_Look_PCs(data().Benson_Team_List[0] + data().Benson_Team_List[2])
	
def Dlg_010_Camera_7_2():
	system.set_camera_view(CAM_B_15)
	objects.remove_item_from_inventory("GANG_A_9",data().Gang_A_Grenade_id)
	objects.turn_to_position("GANG_A_9",267,567)
	Dlg_XXX_Move_NPC("GANG_A_1", Data_Gang_A_Haltungen_3)
	Dlg_XXX_Move_NPC("GANG_A_2", Data_Gang_A_Haltungen_3)
	Dlg_XXX_Move_NPC("GANG_A_3", Data_Gang_A_Haltungen_3)
	objects.cancel_commandos("BENSON")
	character.equip("BENSON","SET_FN_MAG")
	
def Dlg_010_Camera_8():
	system.set_camera_view(CAM_B_16)
	if data().Dlg_010_AE_Reached_Position and data().Benson_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="BENSON", new_camera=False)
	#Gang_List_Look_PCs(data().Benson_Team_List[0] + data().Benson_Team_List[2])
	
def Dlg_010_Camera_9():
	system.set_camera_view(CAM_B_17)
	Dlg_XXX_Move_NPC("GANG_A_8", Data_Gang_A_Haltungen_3)
	Dlg_XXX_Move_NPC("GANG_A_7", Data_Gang_A_Haltungen_3)
	Dlg_XXX_Move_NPC("GANG_A_4", Data_Gang_A_Haltungen_3)
	Dlg_XXX_Move_NPC("BENSON", Data_Gang_A_Haltungen_3)
	Dlg_XXX_Move_NPC("GANG_A_10", Data_Gang_A_Haltungen_3)
	# Immortal weg nehmen
	for id in data().Benson_Gang:
		objects.set_immortal_state(id,False)
		
	enemy_script.delay(2,Dlg_010_Ende1)
	
def Dlg_010_Gang_Look_Pc(character_id):
	if len(data().PC_List) > 3:
		objects.turn_to_object(character_id,data().PC_List[3])
	else:
		Gang_List_Look_PCs([character_id])
	
def Dlg_010_Benson_Verrat():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_010')
	dialog.add_text(text='D_010_T_001', speaker="ALTER_EGO", follower="D_010_T_002", callback = Dlg_010_Camera_2)
	dialog.add_text(text='D_010_T_002', speaker="BENSON", follower="D_010_T_003", callback = Dlg_010_Camera_3)
	dialog.add_text(text='D_010_T_003', speaker="BENSON", follower="D_010_T_004", callback = Dlg_010_Camera_4)
	dialog.add_text(text='D_010_T_004', speaker="ALTER_EGO", follower="D_010_T_005", callback = Dlg_010_Camera_5)
	dialog.add_text(text='D_010_T_005', speaker="BENSON", follower="D_010_T_006", callback = Dlg_010_Camera_6)
	dialog.add_text(text='D_010_T_006', speaker="ALTER_EGO", follower="D_010_T_007", callback = Dlg_010_Camera_7)
	dialog.add_text(text='D_010_T_007', speaker="BENSON", follower="D_010_T_008", callback = Dlg_010_Camera_8)
	dialog.add_text(text='D_010_T_008', speaker="ALTER_EGO", follower="D_010_T_009", callback = Dlg_010_Camera_9)
	dialog.add_text(text='D_010_T_009', speaker="BENSON", follower="ENDDIALOG", callback = Dlg_010_Ende1)
	dialog.start(True, [data("zone_5.zone_5").QB_019, data().QB_008]) #[data().QB_001, data().QB_002, data().QB_008, data().QB_004, data().QB_006])
	
def Dlg_010_Ende1():
	if system.is_cutscene():
		system.end_cutscene()
		system.set_qb_entry_state(data().QB_004,INACTIVE)
		#character.add_experience_party(data().Exp_1_Gang_Tot)
		system.set_qb_entry_state(data().QB_006,UNCOMPLETE)
		system.set_qb_entry_state(data().QB_008,UNCOMPLETE)
		# Kampf starten
		for id in data().Benson_Gang:
			#objects.set_immortal_state(id,False)
			objects.set_attribute(id,"foes", ["UISPIELER"])
		if len(data().PC_List) > 4:
			data().Gang_A_Grenade_Target = data().PC_List[4]
			data().Gang_A_Grenade = True
	"""
	if len(data().PC_List) > 3:
		for i2 in range(0,len(data().Benson_Team_List[1])):
			if not objects.is_destroyed(data().Benson_Team_List[1][i2]):
				objects.attack(id,data().PC_List[3])
	"""
	
def Dlg_032_Benson_Bruder_lebt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_032')
	dialog.add_text(text='D_032_T_001', speaker="BENSON", follower="D_032_T_002")
	dialog.add_text(text='D_032_T_002', speaker="ALTER_EGO", follower="ENDDIALOG")
	dialog.start(True, data("zone_5.zone_5").QB_019) #[data().QB_001, data().QB_002, data().QB_004])
	
# Bruder Tot
def initDlg_033_Benson_Bruder_Tot():
	if not data().Gang_A_Combat_Position:
		Gang_A_Kampfposition_1(MT_FAST)
	data().Gang_A_Schedule_Return = False
	data().Dlg_033_AE_Reached_Position = False
	system.start_cutscene()
	system.set_camera_view(CAM_B_1)
	i = 0
	for id in data().PC_List:
		if objects.get_distance_to_position(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1]) > 50:
			objects.set_position(id,267.5,573.5)
		if id == "ALTER_EGO":
			objects.move_to(id,Data_Gang_A_Kampfpositionen_PCs_1[i][0], Data_Gang_A_Kampfpositionen_PCs_1[i][1], callback = ["ONEND", init_Dlg_033_AE_Camera])
		else:
			objects.move_to(id,Data_Gang_A_Kampfpositionen_PCs_1[i][0], Data_Gang_A_Kampfpositionen_PCs_1[i][1])
		objects.move_to(id,Data_Gang_A_Kampfpositionen_PCs_2[i][0], Data_Gang_A_Kampfpositionen_PCs_2[i][1], speed = MT_SLOW,
				callback = ["ONEND", Lambda('initDlg_008_PCs_Look("%s", "BENSON","%s")' % (id,Data_Gang_A_Kampfpositionen_PCs_2[i][2]))])
		i += 1
	
def init_Dlg_033_AE_Camera(character_id= "ALTER_EGO"):
	system.set_camera_view(CAM_B_2)
	Dlg_033_Benson_Bruder_Tot()
	
def initDlg_033_PCs_Look(character_id,direction, body_mode = "STAND"):
	character.change_body_mode(character_id,body_mode)
	objects.turn_to_object(character_id,direction)
	if character_id == "ALTER_EGO":
		objects.turn_to_object("BENSON", "ALTER_EGO")
		data().Dlg_033_AE_Reached_Position = True
		
def Dlg_033_Camera_2():
	system.set_camera_view(CAM_B_5)
	if data().Benson_Reached_Position and data().Dlg_033_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Benson_Gang)
	
def Dlg_033_Camera_3():
	system.set_camera_view(CAM_B_3)
	if data().Dlg_033_AE_Reached_Position and data().Benson_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="BENSON", new_camera=False)
	Gang_List_Look_PCs(data().Benson_Gang)
		
def Dlg_033_Camera_4():
	system.set_camera_view(CAM_B_6)
	if data().Benson_Reached_Position and data().Dlg_033_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Benson_Gang)
	
def Dlg_033_Camera_4_1():
	system.set_camera_view(CAM_B_7_2)
	enemy_script.delay(6,Dlg_033_Camera_4_2)
	if data().Benson_Reached_Position and data().Dlg_033_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Benson_Gang)
	
def Dlg_033_Camera_4_2():
	system.set_camera_view(CAM_B_11)
	objects.cancel_commandos("GANG_A_5")
	objects.turn_to_position("GANG_A_5",269,557)
	character.play_animation("GANG_A_5","CM_STEHEN_GEWEHRSCHUSS_1_ANLEGEN")
	character.play_animation("GANG_A_5","CM_STEHEN_GEWEHRSCHUSS_1_GESTE")
	character.play_animation("GANG_A_5","CM_STEHEN_GEWEHRSCHUSS_1_GESTE")
	enemy_script.delay(3,Dlg_033_Camera_4_3)
	
def Dlg_033_Camera_4_3():
	system.set_camera_view(CAM_B_7_2)
	
def Dlg_033_Camera_5():
	system.set_camera_view(CAM_B_8)
	if data().Dlg_033_AE_Reached_Position and data().Benson_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="BENSON", new_camera=False)
	Gang_List_Look_PCs(data().Benson_Gang)
	
def Dlg_033_Camera_6():
	system.set_camera_view(CAM_B_10)
	#Action
	objects.cancel_commandos("BENSON")
	character.equip("BENSON","SET_FN_MAG")
	Dlg_XXX_Move_NPC("GANG_A_4", Data_Gang_A_Haltungen_2)
	Dlg_XXX_Move_NPC("GANG_A_7", Data_Gang_A_Haltungen_2)
	Dlg_XXX_Move_NPC("GANG_A_10", Data_Gang_A_Haltungen_2)
	
	enemy_script.delay(3,Dlg_033_Camera_6_2)
	if data().Benson_Reached_Position and data().Dlg_033_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Benson_Gang)
	
def Dlg_033_Camera_6_2():
	system.set_camera_view(CAM_B_12)
	enemy_script.delay(2,Dlg_033_Camera_6_3)
	Dlg_XXX_Move_NPC("BENSON", Data_Gang_A_Haltungen_2)
	Dlg_XXX_Move_NPC("GANG_A_3", Data_Gang_A_Haltungen_2)
	Dlg_XXX_Move_NPC("GANG_A_5", Data_Gang_A_Haltungen_2)
	
def Dlg_033_Camera_6_3():
	system.set_camera_view(CAM_B_9)
	Dlg_XXX_Move_NPC("GANG_A_8", Data_Gang_A_Haltungen_2)
	# Immortal weg nehmen
	for id in data().Benson_Gang:
		objects.set_immortal_state(id,False)
	enemy_script.delay(2, Dlg_033_Ende1)
	
def Dlg_033_Benson_Bruder_Tot():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_033')
	dialog.add_text(text='D_033_T_001', speaker="ALTER_EGO", follower="D_033_T_002", callback = Dlg_033_Camera_2)
	dialog.add_text(text='D_033_T_002', speaker="BENSON", follower="D_033_T_003", callback = Dlg_033_Camera_3)
	dialog.add_text(text='D_033_T_003', speaker="ALTER_EGO", follower="D_033_T_004", callback = Dlg_033_Camera_4)
	dialog.add_text(text='D_033_T_004', speaker="BENSON", follower="D_033_T_005", callback = Dlg_033_Camera_4_1)
	dialog.add_text(text='D_033_T_005', speaker="BENSON", follower="D_033_T_006", callback = Dlg_033_Camera_5)
	if objects.get_attribute("ALTER_EGO", 'gender') == MALE:
		dialog.add_text(text='D_033_T_006', speaker="ALTER_EGO", follower="D_033_T_007", callback = Dlg_033_Camera_6)
	else:
		dialog.add_text(text='D_033_T_006', speaker="ALTER_EGO", follower="D_033_T_007F", callback = Dlg_033_Camera_6)
	dialog.add_text(text='D_033_T_007', speaker="BENSON", follower="ENDDIALOG", callback = Dlg_033_Ende1)
	dialog.add_text(text='D_033_T_007F', speaker="BENSON", follower="ENDDIALOG", callback = Dlg_033_Ende1)
	dialog.start(False, [data("zone_5.zone_5").QB_019, data().QB_008]) #[data().QB_001, data().QB_002, data().QB_004, data().QB_006])
	
def Dlg_033_Ende1():
	if system.is_cutscene():
		system.end_cutscene()
		# alle Quests platkloppen
		system.set_qb_entry_state(data().Marker_QB_001,INACTIVE)
		system.set_qb_entry_state(data().QB_002,INACTIVE)
		system.set_qb_entry_state(data().QB_003,INACTIVE)
		system.set_qb_entry_state(data().QB_005,INACTIVE)
		system.set_qb_entry_state(data().QB_007,INACTIVE)
		# Quests setzen
		# system.set_qb_entry_state(data().QB_004,COMPLETE)
		system.set_qb_entry_state(data().QB_006,UNCOMPLETE)
		system.set_qb_entry_state(data().QB_008,UNCOMPLETE)
		# Kampf starten
		for id in data().Benson_Gang:
			objects.set_immortal_state(id,False)
			objects.set_attribute(id,"foes", ["UISPIELER"])
	
	
def Dlg_006_Thunderer(character_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_006')
	dialog.add_text(text='D_006_T_001', speaker=character_id, follower="ENDDIALOG")
	dialog.start()
	
#----------------------------------------------------------------------------------
#HOWARD + GANG
#----------------------------------------------------------------------------------
""" Beispiele: Original bei anderer Gang	
def Gang_Look_Pc(character_id):
	pc_list = system.get_pcs()
	pc_nr = random.randint(1,len(pc_list))-1
	objects.turn_to_object(character_id,pc_list[pc_nr])

def Gang_List_Look_PCs(char_list):
	for id in char_list:
		pc_list = system.get_pcs()
		pc_nr = random.randint(1,len(pc_list))-1
		objects.turn_to_object(id,pc_list[pc_nr])
	
	
def Dlg_XXX_Move_NPC(character_id, dataset):
	if dataset[character_id][0]:
		move_counter = 0
		if len(dataset[character_id][0]) > 1:
			for i in range(0,len(dataset[character_id][0])-1):
				objects.move_to(character_id,dataset[character_id][0][move_counter][0],dataset[character_id][0][move_counter][1],speed = dataset[character_id][0][move_counter][2])
				move_counter += 1
		objects.move_to(character_id, dataset[character_id][0][move_counter][0], dataset[character_id][0][move_counter][1], speed = dataset[character_id][0][move_counter][2]
				, callback = ['ONEND', Lambda('Dlg_XXX_Move_NPC_Finish("%s",%s)'%(character_id,dataset))])
	else:
		Dlg_XXX_Move_NPC_Finish(character_id,dataset)
	
def Dlg_XXX_Move_NPC_Finish(character_id,dataset):
	if character_id in data().Gang_B_Combat_Moving:
		data().Gang_B_Combat_Moving.remove(character_id)
	if character_id in data().Gang_A_Combat_Moving:
		data().Gang_A_Combat_Moving.remove(character_id)
	character.change_body_mode(character_id,dataset[character_id][1], callback = ['ONEND', Lambda("Gang_List_Look_PCs(['%s'])"%(character_id))])
	#Gang_List_Look_PCs([character_id])
	
"""
# Vorlauf bei Betreten
def Gang_B_Kampfposition_1(move_spd = MT_SLOW):
	data().Gang_B_Combat_Position = True
	
	data().Howard_Reached_Position = False
	for i in range(0,3):
		for i2 in range(0,len(data().Howard_Team_List[i])):
			if not objects.is_destroyed(data().Howard_Team_List[i][i2]):
				if objects.get_distance_to_position(data().Howard_Team_List[i][i2],Data_Gang_B_Kampfposition_1[i][i2][0], Data_Gang_B_Kampfposition_1[i][i2][1]) > 35:
					move_spd = MT_FAST
				elif move_spd != MT_FAST:
					move_spd = MT_SLOW
				objects.cancel_commandos(data().Howard_Team_List[i][i2])
				daily_routine.prohibit_activity(data().Howard_Team_List[i][i2])
				objects.move_to(data().Howard_Team_List[i][i2],Data_Gang_B_Kampfposition_1[i][i2][0], Data_Gang_B_Kampfposition_1[i][i2][1], speed = move_spd
						, callback = ["ONEND",Lambda('Gang_Look_Pc("%s","%s")'%(data().Howard_Team_List[i][i2],Data_Gang_B_Haltungen_1[data().Howard_Team_List[i][i2]]))])
	objects.cancel_commandos("HOWARD")
	daily_routine.prohibit_activity("HOWARD")
	objects.move_to("HOWARD",529.5,533.5,speed = MT_SLOW, callback = ["ONEND", initDlg_028_Howard_Talk])
	# Zurueck auf Anfang wenn Spieler nicht kommt
	system.notify_timer(data().Timer_Gang_B_Schedule_2,data().Timervalue_Gang_B_Schedule_2)
	data().Gang_B_Schedule_Return = True
	
	
def Gang_B_Schedule():
	data().Gang_B_Combat_Position = False
	for id in data().Howard_Gang:
		character.change_body_mode(id,"STAND")
		daily_routine.allow_activity(id)
	
def initDlg_028_Howard_Talk(character_id):
	objects.turn_to_object("HOWARD", "ALTER_EGO")
	data().Howard_Reached_Position = True
	#dynamic_camera.talk_animation_weapon("HOWARD")


def initDlg_028_Howard_Begruessung():
	#system.add_minimap_marker(523, 547,"MM_002") #Howards Lager
	if not data().Gang_B_Combat_Position:
		Gang_B_Kampfposition_1(MT_FAST)
	data().Gang_B_Schedule_Return = False
	data().Dlg_028_AE_Reached_Position = False
	system.start_cutscene()
	system.set_camera_view(CAM_H_1)
	i = 0
	for id in data().PC_List:
		if objects.get_distance_to_position(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1]) > 50:
			objects.set_position(id,526.5,556.5)
		if id == "ALTER_EGO":
			objects.move_to(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1], callback = ["ONEND", init_Dlg_028_AE_Camera])
		else:
			objects.move_to(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1])
		objects.move_to(id,Data_Gang_B_Kampfpositionen_PCs_2[i][0], Data_Gang_B_Kampfpositionen_PCs_2[i][1], speed = MT_SLOW, callback = ["ONEND", Lambda('initDlg_028_PCs_Look("%s", "HOWARD")' % (id))])
		i += 1
	
def init_Dlg_028_AE_Camera(character_id= "ALTER_EGO"):
	system.set_camera_view(CAM_H_2)
	#if data().Benson_Reached_Position:
	#	dynamic_camera.set_conversation(talker="BENSON", listener="ALTER_EGO", new_camera=False)
	Dlg_028_Howard_Begruessung()
	
def initDlg_028_PCs_Look(character_id,direction):
	objects.turn_to_object(character_id,direction)
	if character_id == "ALTER_EGO":
		objects.turn_to_object("HOWARD", "ALTER_EGO")
		data().Dlg_028_AE_Reached_Position = True
		#dynamic_camera.talk_animation_weapon("ALTER_EGO")
		
def Dlg_028_Camera_3():
	system.set_camera_view(CAM_H_3)
	if data().Howard_Reached_Position and data().Dlg_028_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="HOWARD", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Howard_Gang)
	
def Dlg_028_Howard_Begruessung():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_028')
	dialog.add_text(text='D_028_T_001', speaker="HOWARD", follower="D_028_T_002")
	dialog.add_text(text='D_028_T_002', speaker="ALTER_EGO", follower="D_028_T_003", callback = Dlg_028_Camera_3)
	dialog.add_text(text='D_028_T_003', speaker="HOWARD", follower="ENDDIALOG", callback = initDlg_029_Howard_Endscheidung)
	dialog.start(True, data("zone_5.zone_5").QB_019) #data().QB_001)
	
def initDlg_029_Howard_Endscheidung():
	system.end_cutscene()
	Dlg_029_Howard_Endscheidung()
	
def Dlg_029_Howard_Endscheidung():
	data().Seeker_Stress = True
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('D_029')
	dialog.add_choice(text='D_029_C_001_1', follower = 'D_029_T_001', auto_deactivation='permanent')
	dialog.add_choice(text='D_029_C_001_2', follower = 'D_029_T_003', auto_deactivation='permanent')
	dialog.add_choice(text='D_029_C_001_3', follower = 'D_029_T_004', auto_deactivation='permanent')
	dialog.add_text(text='D_029_T_001', speaker="HOWARD", follower="D_029_T_002")
	dialog.add_text(text='D_029_T_002', speaker="ALTER_EGO", follower="D_029_T_003")
	dialog.add_text(text='D_029_T_003', speaker="HOWARD", follower="D_029_C_002")
	dialog.add_text(text='D_029_T_004', speaker="HOWARD", follower="D_029_C_002")
	dialog.add_choice(text='D_029_C_002_1', follower = 'D_029_T_005', auto_deactivation='permanent')
	if data().D_029_C_002_2:
		dialog.add_choice(text='D_029_C_002_2', follower = 'D_029_T_006', auto_deactivation='permanent')
	if data().D_029_C_002_3:
		dialog.add_choice(text='D_029_C_002_3', follower = 'D_029_T_011', auto_deactivation='permanent')
	dialog.add_choice(text='D_029_C_002_4', follower = 'D_029_T_009', auto_deactivation='permanent')
	if objects.get_attribute("ALTER_EGO", 'gender') == MALE:
		dialog.add_choice(text='D_029_C_002_5', follower = 'D_029_T_017', auto_deactivation='permanent')
	else:
		dialog.add_choice(text='D_029_C_002_5', follower = 'D_029_T_017F', auto_deactivation='permanent')
	dialog.add_text(text='D_029_T_005', speaker="HOWARD", follower="D_029_C_002")
	dialog.add_text(text='D_029_T_006', speaker="HOWARD", follower="D_029_T_007")
	dialog.add_text(text='D_029_T_007', speaker="ALTER_EGO", follower="D_029_T_008")
	dialog.add_text(text='D_029_T_008', speaker="HOWARD", follower="ENDDIALOG", callback = Dlg_029_Restart_C_002)
	dialog.add_text(text='D_029_T_009', speaker="HOWARD", follower="D_029_C_003")
	dialog.add_text(text='D_029_T_011', speaker="HOWARD", follower="D_029_T_012")
	dialog.add_text(text='D_029_T_012', speaker="ALTER_EGO", follower="D_029_T_013")
	dialog.add_text(text='D_029_T_013', speaker="HOWARD", follower="D_029_C_002")
	dialog.add_choice(text='D_029_C_003_1', follower = 'D_029_T_010', auto_deactivation='permanent')
	dialog.add_choice(text='D_029_C_003_2', follower = 'D_029_T_010', auto_deactivation='permanent')
	if system.get_qb_entry_state(data().QB_010) == UNCOMPLETE:
		dialog.add_choice(text='D_029_C_003_3', follower = 'D_029_T_020', auto_deactivation='permanent')
	dialog.add_text(text='D_029_T_010', speaker="HOWARD", follower="D_029_C_004")
	dialog.add_text(text='D_029_T_020', speaker="HOWARD", follower="D_029_C_003")
	dialog.add_choice(text='D_029_C_004_1', follower='D_029_T_019')
	if (object_events.get_speech_skill("ALTER_EGO") < 60):	# [BrainRipper]
		dialog.add_choice(text='D_029_C_004_2', follower='D_029_T_015')
	else:
		dialog.add_choice(text='D_029_C_004_2', follower='D_029_T_014')
	dialog.add_text(text='D_029_T_014', speaker="HOWARD", follower="D_029_C_005")
	dialog.add_text(text='D_029_T_015', speaker="HOWARD", follower="D_029_C_005")
	if (object_events.get_speech_skill("ALTER_EGO") >= 60):		# [BrainRipper]
		if (object_events.get_speech_skill("ALTER_EGO") < 70):	# [BrainRipper]
			dialog.add_choice(text='D_029_C_005_1', follower='D_029_T_015', auto_deactivation='permanent')
		else:
			dialog.add_choice(text='D_029_C_005_1', follower='D_029_T_016', auto_deactivation='permanent')
	dialog.add_choice(text='D_029_C_005_2', follower='D_029_T_019')
	if objects.get_attribute("ALTER_EGO", 'gender') == MALE:
		dialog.add_choice(text='D_029_C_005_3', follower='D_029_T_018')
	else:
		dialog.add_choice(text='D_029_C_005_3', follower='D_029_T_018F')
	dialog.add_text(text='D_029_T_016', speaker="HOWARD", follower="D_029_C_005")
	dialog.add_text(text='D_029_T_017', speaker="HOWARD", follower="ENDDIALOG", callback = Dlg_029_ENDE2)
	dialog.add_text(text='D_029_T_017F', speaker="HOWARD", follower="ENDDIALOG", callback = Dlg_029_ENDE2)
	dialog.add_text(text='D_029_T_018', speaker="HOWARD", follower="ENDDIALOG", callback = Dlg_029_ENDE2)
	dialog.add_text(text='D_029_T_018F', speaker="HOWARD", follower="ENDDIALOG", callback = Dlg_029_ENDE2)
	dialog.add_text(text='D_029_T_019', speaker="HOWARD", follower="ENDDIALOG", callback = Dlg_029_ENDE1)
	
	if data().Dlg_029_Restart_C_002:
		dialog.jump_to('D_029_C_002_4')
	dialog.start(False, data("zone_5.zone_5").QB_019)
	
def Dlg_029_Restart_C_002(source = ""):
	data().Dlg_029_Restart_C_002 = True
	data().D_029_C_002_3 = True
	Dlg_029_Howard_Endscheidung()
	
def Dlg_029_ENDE1():
	system.set_qb_entry_state(data().Marker_QB_001,INACTIVE)
	system.set_qb_entry_state(data().QB_003,UNCOMPLETE)
	data().Gang_1_XP = True
	# Bensons Gang(Rolling Thunder) auf aggro setzen
	for id in data().Benson_Gang:
		objects.set_immortal_state(id,False)
		objects.set_attribute(id,"foes", ["UISPIELER"])
	# Lookout Starten
	data().Benson_Lookout = True
	data().Gang_Field_Glasses = objects.create_item_in_inventory("GANG_A_1",'SET_BINOCULARS')
	character.equip("GANG_A_1", data().Gang_Field_Glasses)
	#notifier Abfangen
	data().Benson_Lager_Betreten = True
	# Schedule wieder aktivieren
	system.notify_timer(data().Timer_Gang_B_Schedule,data().Timervalue_Gang_B_Schedule)
	
	
def Dlg_029_ENDE2():
	system.set_qb_entry_state(data().Marker_QB_001,INACTIVE)
	#system.add_text("Zum Angriff")
	# Kampf Howards Gang(Deathstrike)
	for id in data().Howard_Gang:
		objects.set_immortal_state(id,False)
		objects.set_attribute(id,"foes", ["UISPIELER"])
	Dlg_XXX_Move_NPC('GANG_B_4',Data_Gang_B_Haltungen_2)
	Dlg_XXX_Move_NPC('GANG_B_1',Data_Gang_B_Haltungen_2)
	Dlg_XXX_Move_NPC('GANG_B_10',Data_Gang_B_Haltungen_2)
	Dlg_XXX_Move_NPC('HOWARD',Data_Gang_B_Haltungen_2)
	
	
def initDlg_030_Howard_Verrat():
	if not data().Gang_B_Combat_Position:
		Gang_B_Kampfposition_1(MT_FAST)
	data().Gang_B_Schedule_Return = False
	data().Dlg_030_AE_Reached_Position = False
	system.start_cutscene()
	system.set_camera_view(CAM_H_1)
	i = 0
	for id in data().PC_List:
		if objects.get_distance_to_position(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1]) > 50:
			objects.set_position(id,532.5,543.5)
		
		if id == "ALTER_EGO":
			objects.move_to(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1], callback = ["ONEND", init_Dlg_030_AE_Camera])
		else:
			objects.move_to(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1])
		objects.move_to(id,Data_Gang_B_Kampfpositionen_PCs_3[i][0], Data_Gang_B_Kampfpositionen_PCs_3[i][1], speed = MT_SLOW, callback = ["ONEND", Lambda('initDlg_030_PCs_Look("%s", "HOWARD")' % (id))])
		i += 1
	
def init_Dlg_030_AE_Camera(character_id= "ALTER_EGO"):
	system.set_camera_view(CAM_H_2)
	Dlg_030_Howard_Verrat()
	
def initDlg_030_PCs_Look(character_id,direction):
	objects.turn_to_object(character_id,direction)
	if character_id == "ALTER_EGO":
		objects.turn_to_object("HOWARD", "ALTER_EGO")
		data().Dlg_030_AE_Reached_Position = True
		#dynamic_camera.talk_animation_weapon("ALTER_EGO")
	
def Dlg_030_Camera_1():
	system.set_camera_view(CAM_H_12)
	if data().Howard_Reached_Position and data().Dlg_030_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="HOWARD", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Howard_Gang)
	
def Dlg_030_Camera_2():
	system.set_camera_view(CAM_H_13)
	if data().Howard_Reached_Position and data().Dlg_030_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="HOWARD", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Howard_Gang)
	
def Dlg_030_Camera_3():
	system.set_camera_view(CAM_H_14)
	if data().Howard_Reached_Position and data().Dlg_030_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="HOWARD", new_camera=False)
	
def Dlg_030_Camera_4():
	system.set_camera_view(CAM_H_15)
	if data().Howard_Reached_Position and data().Dlg_030_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="HOWARD", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Howard_Gang)
	Dlg_XXX_Move_NPC("GANG_B_2",Data_Gang_B_Haltungen_3)
	
def Dlg_030_Camera_5():
	system.set_camera_view(CAM_H_16)
	
	if data().Howard_Reached_Position and data().Dlg_030_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="HOWARD", new_camera=False)
	
def Dlg_030_Camera_6():
	data().Gang_B_Grenade_id = system.create_object("SET_FRAGGRENADE",531,522.3)
	objects.set_position_free(data().Gang_B_Grenade_id,531,522.3,0.1)
	objects.pick_up_item("GANG_B_3", data().Gang_B_Grenade_id, callback = Lambda("Gang_List_Look_PCs(['GANG_B_3'])"))
	system.set_camera_view(CAM_H_17)
	system.notify_timer(data().Timer_Dlg_030_Grenade,data().Timervalue_Dlg_030_Grenade)
	for id in ["GANG_B_6","GANG_B_8"]:
		Dlg_XXX_Move_NPC(id,Data_Gang_B_Haltungen_3)
	if data().Howard_Reached_Position and data().Dlg_030_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="HOWARD", listener="ALTER_EGO", new_camera=False)
	#Gang_List_Look_PCs(data().Howard_Team_List[0] + data().Howard_Team_List[2])
	
def Dlg_030_Camera_6_2():
	system.set_camera_view(CAM_H_8)
	objects.remove_item_from_inventory("GANG_B_3",data().Gang_B_Grenade_id)
	
def Dlg_030_Camera_7():
	system.set_camera_view(CAM_H_18)
	system.notify_timer(data().Timer_Dlg_030_Tree,data().Timervalue_Dlg_030_Tree)
	if data().Howard_Reached_Position and data().Dlg_030_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="HOWARD", new_camera=False)
	Gang_List_Look_PCs(data().Howard_Gang)
	
def Dlg_030_Camera_7_2():
	system.set_camera_view(CAM_H_9)
	
def Dlg_030_Camera_8():
	system.set_camera_view(CAM_H_11)
	system.notify_timer(data().Timer_Howard_Close,data().Timervalue_Howard_Close)
	#system.set_camera_view(CAM_H_10)
	#if data().Howard_Reached_Position and data().Dlg_030_AE_Reached_Position:
	#	dynamic_camera.set_conversation(talker="HOWARD", listener="ALTER_EGO", new_camera=False)
	Dlg_XXX_Move_NPC("GANG_B_1",Data_Gang_B_Haltungen_3)
	Dlg_XXX_Move_NPC("GANG_B_4",Data_Gang_B_Haltungen_3)
	objects.cancel_commandos("HOWARD")
	character.equip("HOWARD","SET_FN_MAG")
	Dlg_XXX_Move_NPC("HOWARD",Data_Gang_B_Haltungen_3)
	Dlg_XXX_Move_NPC("GANG_B_10",Data_Gang_B_Haltungen_3)
	for id in data().Howard_Gang:
		objects.set_immortal_state(id,False)
	enemy_script.delay(3.5,Dlg_030_Ende1)
	
	
def Dlg_030_Gang_Look_Pc(character_id):
	if len(data().PC_List) > 3:
		objects.turn_to_object(character_id,data().PC_List[3])
	else:
		Gang_List_Look_PCs([character_id])
	
def Dlg_030_Howard_Verrat():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_030')
	dialog.add_text(text='D_030_T_001', speaker="ALTER_EGO", follower="D_030_T_002", callback = Dlg_030_Camera_1)
	dialog.add_text(text='D_030_T_002', speaker="HOWARD", follower="D_030_T_003", callback = Dlg_030_Camera_2)
	dialog.add_text(text='D_030_T_003', speaker="HOWARD", follower="D_030_T_004", callback = Dlg_030_Camera_3)
	dialog.add_text(text='D_030_T_004', speaker="ALTER_EGO", follower="D_030_T_005", callback = Dlg_030_Camera_4)
	dialog.add_text(text='D_030_T_005', speaker="HOWARD", follower="D_030_T_006", callback = Dlg_030_Camera_5)
	dialog.add_text(text='D_030_T_006', speaker="ALTER_EGO", follower="D_030_T_007", callback = Dlg_030_Camera_6)
	dialog.add_text(text='D_030_T_007', speaker="HOWARD", follower="D_030_T_008", callback = Dlg_030_Camera_7)
	dialog.add_text(text='D_030_T_008', speaker="ALTER_EGO", follower="D_030_T_009", callback = Dlg_030_Camera_8)
	dialog.add_text(text='D_030_T_009', speaker="HOWARD", follower="ENDDIALOG", callback = Dlg_030_Ende1)
	dialog.start(True, [data("zone_5.zone_5").QB_019, data().QB_008]) #[data().QB_001, data().QB_003, data().QB_005, data().QB_007])
	
def Dlg_030_Ende1():
	if system.is_cutscene():
		system.end_cutscene()
		system.set_qb_entry_state(data().QB_005,INACTIVE)
		system.set_qb_entry_state(data().QB_007,UNCOMPLETE)
		system.set_qb_entry_state(data().QB_008,UNCOMPLETE)
		
		#system.add_text("Zum Angriff")
		# Kampf Howards Gang(Deathstrike)
		for id in data().Howard_Gang:
			#objects.set_immortal_state(id,False)
			objects.set_attribute(id,"foes", ["UISPIELER"])
		if len(data().PC_List) > 4:
			data().Gang_B_Grenade_Target = data().PC_List[4]
			data().Gang_B_Grenade = True
	"""
	if len(data().PC_List) > 3:
		for i2 in range(0,len(data().Howard_Team_List[1])):
			if not objects.is_destroyed(data().Howard_Team_List[1][i2]):
				objects.attack(id,data().PC_List[3])
	"""
	
def Dlg_031_Howard_Bruder_lebt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_031')
	dialog.add_text(text='D_031_T_001', speaker="HOWARD", follower="D_031_T_002")
	dialog.add_text(text='D_031_T_002', speaker="ALTER_EGO", follower="ENDDIALOG")
	dialog.start(True, data("zone_5.zone_5").QB_019) #[data().QB_001, data().QB_003])
	
def initDlg_034_Howard_Bruder_Tot():
	data().Gang_B_Schedule_Return = False
	if not data().Gang_B_Combat_Position:
		Gang_B_Kampfposition_1(MT_FAST)
	data().Dlg_034_AE_Reached_Position = False
	system.start_cutscene()
	system.set_camera_view(CAM_H_1)
	i = 0
	for id in data().PC_List:
		if objects.get_distance_to_position(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1]) > 50:
			objects.set_position(id,532.5,543.5)
		
		if id == "ALTER_EGO":
			objects.move_to(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1], callback = ["ONEND", init_Dlg_034_AE_Camera])
		else:
			objects.move_to(id,Data_Gang_B_Kampfpositionen_PCs_1[i][0], Data_Gang_B_Kampfpositionen_PCs_1[i][1])
		objects.move_to(id,Data_Gang_B_Kampfpositionen_PCs_2[i][0], Data_Gang_B_Kampfpositionen_PCs_2[i][1], speed = MT_SLOW, callback = ["ONEND", Lambda('initDlg_034_PCs_Look("%s", "HOWARD")' % (id))])
		i += 1
	
def init_Dlg_034_AE_Camera(character_id= "ALTER_EGO"):
	system.set_camera_view(CAM_H_2)
	Dlg_034_Howard_Bruder_Tot()
	
def initDlg_034_PCs_Look(character_id,direction):
	objects.turn_to_object(character_id,direction)
	if character_id == "ALTER_EGO":
		objects.turn_to_object("HOWARD", "ALTER_EGO")
		data().Dlg_034_AE_Reached_Position = True
	
	
def Dlg_034_Camera_2():
	system.set_camera_view(CAM_H_4)
	if data().Howard_Reached_Position and data().Dlg_034_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="HOWARD", new_camera=False)
	
def Dlg_034_Camera_3():
	system.set_camera_view(CAM_H_3)
	if data().Howard_Reached_Position and data().Dlg_034_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="HOWARD", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Howard_Gang)
	
def Dlg_034_Camera_4():
	system.set_camera_view(CAM_H_5)
	if data().Howard_Reached_Position and data().Dlg_034_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="HOWARD", new_camera=False)
	
def Dlg_034_Camera_5():
	system.set_camera_view(CAM_H_6)
	if data().Howard_Reached_Position and data().Dlg_034_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="HOWARD", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Howard_Gang)
	
def Dlg_034_Camera_6():
	system.set_camera_view(CAM_H_7)
	if data().Howard_Reached_Position and data().Dlg_034_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="HOWARD", new_camera=False)
	
def Dlg_034_Camera_7():
	system.set_camera_view(CAM_H_8)
	if data().Howard_Reached_Position and data().Dlg_034_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="HOWARD", listener="ALTER_EGO", new_camera=False)
	Gang_List_Look_PCs(data().Howard_Gang)
	
def Dlg_034_Camera_8():
	system.set_camera_view(CAM_H_9)
	if data().Howard_Reached_Position and data().Dlg_034_AE_Reached_Position:
		dynamic_camera.set_conversation(talker="ALTER_EGO", listener="HOWARD", new_camera=False)
	
def Dlg_034_Camera_9():
	system.set_camera_view(CAM_H_11)
	#if data().Howard_Reached_Position and data().Dlg_034_AE_Reached_Position:
	#	dynamic_camera.set_conversation(talker="HOWARD", listener="ALTER_EGO", new_camera=False)
	enemy_script.delay(13,Dlg_034_Camera_9_2)
	
def Dlg_034_Camera_9_2():
	
	Dlg_XXX_Move_NPC('GANG_B_4',Data_Gang_B_Haltungen_2)
	Dlg_XXX_Move_NPC('GANG_B_1',Data_Gang_B_Haltungen_2)
	Dlg_XXX_Move_NPC('GANG_B_10',Data_Gang_B_Haltungen_2)
	character.equip("HOWARD","SET_FN_MAG")
	Dlg_XXX_Move_NPC('HOWARD',Data_Gang_B_Haltungen_2)
	system.set_camera_view(CAM_H_10)
	#system.notify_timer(data().Timer_Howard_Close,data().Timervalue_Howard_Close)
	enemy_script.delay(4,Dlg_034_Ende1)
	for id in data().Howard_Gang:
		objects.set_immortal_state(id,False)
	
def Dlg_034_Howard_Close():
	system.set_camera_view(CAM_H_10)
	"""
	for id in data().Howard_Gang:
		if id != "HOWARD" and not objects.is_destroyed(id):
			if id in data().Howard_Team_List[2]:
				body_mode = "LIE"
				if id == "GANG_B_3":
					body_mode = "STAND"
			else:
				body_mode = "KNEEL"
			enemy_script.delay(random.random()*3,Lambda('character.change_body_mode("%s", "%s")'%(id,body_mode)))
	"""
	
def Dlg_034_Howard_Bruder_Tot():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_034')
	dialog.add_text(text='D_034_T_001', speaker="ALTER_EGO", follower="D_034_T_002") #, callback = Dlg_034_Camera_1)
	dialog.add_text(text='D_034_T_002', speaker="HOWARD", follower="D_034_T_003", callback = Dlg_034_Camera_2)
	dialog.add_text(text='D_034_T_003', speaker="ALTER_EGO", follower="D_034_T_004", callback = Dlg_034_Camera_3)
	dialog.add_text(text='D_034_T_004', speaker="HOWARD", follower="D_034_T_005", callback = Dlg_034_Camera_4)
	dialog.add_text(text='D_034_T_005', speaker="ALTER_EGO", follower="D_034_T_006", callback = Dlg_034_Camera_5)
	dialog.add_text(text='D_034_T_006', speaker="HOWARD", follower="D_034_T_007", callback = Dlg_034_Camera_6)
	dialog.add_text(text='D_034_T_007', speaker="ALTER_EGO", follower="D_034_T_008", callback = Dlg_034_Camera_7)
	dialog.add_text(text='D_034_T_008', speaker="HOWARD", follower="D_034_T_009", callback = Dlg_034_Camera_8)
	if objects.get_attribute("ALTER_EGO", 'gender') == MALE:
		dialog.add_text(text='D_034_T_009', speaker="ALTER_EGO", follower="D_034_T_010", callback = Dlg_034_Camera_9)
	else:
		dialog.add_text(text='D_034_T_009', speaker="ALTER_EGO", follower="D_034_T_010F", callback = Dlg_034_Camera_9)
	dialog.add_text(text='D_034_T_010', speaker="HOWARD", follower="ENDDIALOG", callback = Dlg_034_Ende1)
	dialog.add_text(text='D_034_T_010F', speaker="HOWARD", follower="ENDDIALOG", callback = Dlg_034_Ende1)
	dialog.start(False, [data("zone_5.zone_5").QB_019, data().QB_008]) #[data().QB_001, data().QB_003, data().QB_005, data().QB_007])
	
def Dlg_034_Ende1():
	if system.is_cutscene():
		system.end_cutscene()
		#system.set_qb_entry_state(data().QB_001,INACTIVE)
		#system.set_qb_entry_state(data().QB_007,UNCOMPLETE)
		system.set_qb_entry_state(data().QB_008,UNCOMPLETE)
		#system.add_text("Zum Angriff")
		# Kampf Howards Gang(Deathstrike)
		for id in data().Howard_Gang:
			objects.set_immortal_state(id,False)
			objects.set_attribute(id,"foes", ["UISPIELER"])
	
	
	
def Dlg_007_Deathstriker(character_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_007')
	dialog.add_text(text='D_007_T_001', speaker=character_id, follower="ENDDIALOG")
	dialog.start()
	


				
				
				
				
				
				
				
