# -*- coding: utf-8 -*-
from global_defines import *
from item import *
import combos
import globaltext

def clone_weapon_type(typeid, new_typeid, attachments=None):
	assert typeid!=new_typeid
	attributes = objects.get_attributes(object=typeid)
	for attribute in attributes:
		if attribute!="id":
			objects.set_attribute(object=new_typeid,
				attribute=attribute,
				value=objects.get_attribute(object=typeid, attribute=attribute))
	if attachments:
		value = objects.get_attribute(object=typeid, attribute="value")
		weight = objects.get_attribute(object=typeid, attribute="weight")

		for part in attachments:
			value+=objects.get_attribute(object=part, attribute="value")
			weight+=objects.get_attribute(object=part, attribute="weight")

		objects.set_attribute(object=new_typeid, attribute="value", value=value)
		objects.set_attribute(object=new_typeid, attribute="weight", value=weight)
		objects.set_attribute(object=new_typeid, attribute="attachments", value=attachments)
		baseid = typeid
		while objects.has_attribute(baseid, "base_weapon"):
			baseid = objects.get_attribute(baseid, "base_weapon")
		objects.set_attribute(object=new_typeid, attribute="base_weapon", value=baseid)

		if "SET_SILENCER" in attachments:
			if objects.has_attribute(typeid, "hoerweite"):
				basic_earshot = objects.get_attribute(typeid, "hoerweite") / 2
			else: basic_earshot = 0.0
			earshot = min(basic_earshot, 10.0)
			objects.set_attribute(object=new_typeid, attribute="hoerweite", value=earshot)
		if "SET_LASERPOINTER" in attachments:
			if objects.has_attribute(typeid, "genauigkeit"):
				hitchance = objects.get_attribute(typeid, "genauigkeit")
			else: hitchance = 0.0
			hitchance *= 1.5
			objects.set_attribute(object=new_typeid, attribute="genauigkeit", value=hitchance)

## leichte waffen
create_weapon_type(typeid='SET_WALTER_PPK')
objects.set_attribute(object='SET_WALTER_PPK', attribute="name", value=globaltext.SET_WALTER_PPK_NAME)
objects.set_attribute(object='SET_WALTER_PPK', attribute="hint", value=globaltext.SET_WALTER_PPK_HINT)
objects.set_attribute(object='SET_WALTER_PPK', attribute="resourceui", value='RES_ITEM65X32_WEAPON_WALTER_PPK')
objects.set_attribute(object='SET_WALTER_PPK', attribute="resource3d", value='RES3D_WALTER_PPK')
objects.set_attribute(object='SET_WALTER_PPK', attribute="value", value=3.00)
objects.set_attribute(object='SET_WALTER_PPK', attribute="weight", value=0.57)
objects.set_attribute(object='SET_WALTER_PPK', attribute="stacking", value=1)
objects.set_attribute(object='SET_WALTER_PPK', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_WALTER_PPK', attribute="maximale_feuerreichweite", value=13)
objects.set_attribute(object='SET_WALTER_PPK', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_WALTER_PPK', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_WALTER_PPK', attribute="genauigkeit", value=0.7)
objects.set_attribute(object='SET_WALTER_PPK', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_WALTER_PPK', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_WALTER_PPK', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_WALTER_PPK', attribute="munitionsarten", value=['SET_AMMOPACK_7_65_MM','SET_AMMOPACK_7_65_MM_DUMDUM','SET_AMMOPACK_7_65_MM_SUBSONIC','SET_AMMOPACK_7_65_MM_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_WALTER_PPK', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_WALTER_PPK', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_WALTER_PPK', attribute="magazingroesse", 				value=7.0)
objects.set_attribute(object='SET_WALTER_PPK', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_WALTER_PPK', attribute="schusspausenzeit", 				value=0.8)
objects.set_attribute(object='SET_WALTER_PPK', attribute="genauigkeit_bewegte_ziele",		value=0.5)
objects.set_attribute(object='SET_WALTER_PPK', attribute="blockadewahrscheinlichkeit",	value=25.0)
objects.set_attribute(object='SET_WALTER_PPK', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_WALTER_PPK', attribute="effects", value={
		"sound_shot"	: "shot_walther_ppk",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_WALTER_PPK_W_SILENCER')
clone_weapon_type(typeid='SET_WALTER_PPK', new_typeid='SET_WALTER_PPK_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="name", value=globaltext.SET_WALTER_PPK_W_SILENCER_NAME)
objects.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="hint", value=globaltext.SET_WALTER_PPK_W_SILENCER_HINT)
objects.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="resource3d", value='RES3D_WALTER_PPK_W_SILENCER')
objects.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="value", value=8.00)
objects.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "shot_walther_ppk_silenced",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.1,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_WALTER_PPK_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_WALTER_PPK','SET_SILENCER']]})

create_weapon_type(typeid='SET_SPECIAL_38')
objects.set_attribute(object='SET_SPECIAL_38', attribute="name", value=globaltext.SET_SPECIAL_38_NAME)
objects.set_attribute(object='SET_SPECIAL_38', attribute="hint", value=globaltext.SET_SPECIAL_38_HINT)
objects.set_attribute(object='SET_SPECIAL_38', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SPECIAL_38')
objects.set_attribute(object='SET_SPECIAL_38', attribute="resource3d", value='RES3D_SPECIAL_38')
objects.set_attribute(object='SET_SPECIAL_38', attribute="value", value=2.00)
objects.set_attribute(object='SET_SPECIAL_38', attribute="weight", value=0.270)
objects.set_attribute(object='SET_SPECIAL_38', attribute="stacking", value=1)
objects.set_attribute(object='SET_SPECIAL_38', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_SPECIAL_38', attribute="maximale_feuerreichweite", value=10)
objects.set_attribute(object='SET_SPECIAL_38', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_SPECIAL_38', attribute="feuergeschwindigkeit", value=50.0)
objects.set_attribute(object='SET_SPECIAL_38', attribute="genauigkeit", value=0.6)
objects.set_attribute(object='SET_SPECIAL_38', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_SPECIAL_38', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_SPECIAL_38', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_SPECIAL_38', attribute="munitionsarten", value=['SET_AMMOPACK_38','SET_AMMOPACK_38_DUMDUM'])
objects.set_attribute(object='SET_SPECIAL_38', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_SPECIAL_38', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_SPECIAL_38', attribute="magazingroesse", 				value=5.0)
objects.set_attribute(object='SET_SPECIAL_38', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_SPECIAL_38', attribute="schusspausenzeit", 				value=1.0)
objects.set_attribute(object='SET_SPECIAL_38', attribute="genauigkeit_bewegte_ziele",		value=0.4)
objects.set_attribute(object='SET_SPECIAL_38', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_SPECIAL_38', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_SPECIAL_38', attribute="effects", value={
		"sound_shot"	: "shot_special_38",
		"sound_unload"	: "revolver_discharge",
		"sound_gunjam"	: "revolver_gunjam",
		"sound_reload"	: "revolver_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.4,
		"stream_type"	: 1,
		"stream_size"	: 0.5,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_COLT_ANACONDA')
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="name", value=globaltext.SET_COLT_ANACONDA_NAME)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="hint", value=globaltext.SET_COLT_ANACONDA_HINT)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="resourceui", value='RES_ITEM65X32_WEAPON_COLT_ANACONDA')
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="resource3d", value='RES3D_COLT_ANACONDA')
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="value", value=8.00)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="weight", value=1.325)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="stacking", value=1)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="maximale_feuerreichweite", value=17)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="genauigkeit", value=0.8)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="munitionsarten", value=['SET_AMMOPACK_44','SET_AMMOPACK_44_DUMDUM','SET_AMMOPACK_44_CORBON','SET_AMMOPACK_44_CORBON_DUMDUM'])
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="magazingroesse", 			value=6.0)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="schusspausenzeit", 			value=1.2)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="genauigkeit_bewegte_ziele",	value=0.5)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_COLT_ANACONDA', attribute="effects", value={
		"sound_shot"	: "shot_colt_anaconda",
		"sound_unload"	: "revolver_discharge",
		"sound_gunjam"	: "revolver_gunjam",
		"sound_reload"	: "revolver_charge",
		"flash_type"	: 5,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_SIG_SAUER')
objects.set_attribute(object='SET_SIG_SAUER', attribute="name", value=globaltext.SET_SIG_SAUER_NAME)
objects.set_attribute(object='SET_SIG_SAUER', attribute="hint", value=globaltext.SET_SIG_SAUER_HINT)
objects.set_attribute(object='SET_SIG_SAUER', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SIG_SAUER')
objects.set_attribute(object='SET_SIG_SAUER', attribute="resource3d", value='RES3D_SIG_SAUER')
objects.set_attribute(object='SET_SIG_SAUER', attribute="value", value=3.00)
objects.set_attribute(object='SET_SIG_SAUER', attribute="weight", value=0.625)
objects.set_attribute(object='SET_SIG_SAUER', attribute="stacking", value=1)
objects.set_attribute(object='SET_SIG_SAUER', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_SIG_SAUER', attribute="maximale_feuerreichweite", value=13)
objects.set_attribute(object='SET_SIG_SAUER', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_SIG_SAUER', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_SIG_SAUER', attribute="genauigkeit", value=1.2)
objects.set_attribute(object='SET_SIG_SAUER', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_SIG_SAUER', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_SIG_SAUER', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_SIG_SAUER', attribute="munitionsarten", value=['SET_AMMOPACK_357','SET_AMMOPACK_357_DUMDUM','SET_AMMOPACK_357_SUBSONIC','SET_AMMOPACK_357_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_SIG_SAUER', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_SIG_SAUER', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_SIG_SAUER', attribute="magazingroesse", 			value=13.0)
objects.set_attribute(object='SET_SIG_SAUER', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_SIG_SAUER', attribute="schusspausenzeit", 			value=0.6)
objects.set_attribute(object='SET_SIG_SAUER', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_SIG_SAUER', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_SIG_SAUER', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_SIG_SAUER', attribute="effects", value={
		"sound_shot"	: "shot_sig_sauer",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_SIG_SAUER_W_SILENCER')
clone_weapon_type(typeid='SET_SIG_SAUER', new_typeid='SET_SIG_SAUER_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="name", value=globaltext.SET_SIG_SAUER_W_SILENCER_NAME)
objects.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="hint", value=globaltext.SET_SIG_SAUER_W_SILENCER_HINT)
objects.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="resource3d", value='RES3D_SIG_SAUER_W_SILENCER')
objects.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="value", value=8.00)
objects.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "shot_sig_sauer_silenced",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_SIG_SAUER_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_SIG_SAUER','SET_SILENCER']]})

create_weapon_type(typeid='SET_BERETTA_92F')
objects.set_attribute(object='SET_BERETTA_92F', attribute="name", value=globaltext.SET_BERETTA_92F_NAME)
objects.set_attribute(object='SET_BERETTA_92F', attribute="hint", value=globaltext.SET_BERETTA_92F_HINT)
objects.set_attribute(object='SET_BERETTA_92F', attribute="resourceui", value='RES_ITEM65X32_WEAPON_BERETTA_92F')
objects.set_attribute(object='SET_BERETTA_92F', attribute="resource3d", value='RES3D_BERETTA_92F')
objects.set_attribute(object='SET_BERETTA_92F', attribute="value", value=6.00)
objects.set_attribute(object='SET_BERETTA_92F', attribute="weight", value=0.95)
objects.set_attribute(object='SET_BERETTA_92F', attribute="stacking", value=1)
objects.set_attribute(object='SET_BERETTA_92F', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_BERETTA_92F', attribute="maximale_feuerreichweite", value=13)
objects.set_attribute(object='SET_BERETTA_92F', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_BERETTA_92F', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_BERETTA_92F', attribute="genauigkeit", value=1.00)
objects.set_attribute(object='SET_BERETTA_92F', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_BERETTA_92F', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_BERETTA_92F', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_BERETTA_92F', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_BERETTA_92F', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_BERETTA_92F', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_BERETTA_92F', attribute="magazingroesse", 				value=15.0)
objects.set_attribute(object='SET_BERETTA_92F', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_BERETTA_92F', attribute="schusspausenzeit", 			value=0.7)
objects.set_attribute(object='SET_BERETTA_92F', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_BERETTA_92F', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_BERETTA_92F', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_BERETTA_92F', attribute="effects", value={
		"sound_shot"	: "shot_beretta_92f",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_BERETTA_92F_W_SILENCER')
clone_weapon_type(typeid='SET_BERETTA_92F', new_typeid='SET_BERETTA_92F_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="name", value=globaltext.SET_BERETTA_92F_NAME)
objects.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="hint", value=globaltext.SET_BERETTA_92F_HINT)
objects.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="resource3d", value='RES3D_BERETTA_92F_W_SILENCER')
objects.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="value", value=11.00)
objects.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "shot_beretta_92f_silenced",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_BERETTA_92F_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_BERETTA_92F','SET_SILENCER']]})

create_weapon_type(typeid='SET_DESERT_EAGLE')
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="name", value=globaltext.SET_DESERT_EAGLE_NAME)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="hint", value=globaltext.SET_DESERT_EAGLE_HINT)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="resourceui", value='RES_ITEM65X32_WEAPON_DESERT_EAGLE')
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="resource3d", value='RES3D_DESERT_EAGLE')
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="value", value=10.00)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="weight", value=2.0)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="stacking", value=1)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="maximale_feuerreichweite", value=15)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="genauigkeit", value=0.8)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="munitionsarten", value=['SET_AMMOPACK_50', 'SET_AMMOPACK_50_AE_DUMDUM'])
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="magazingroesse", 				value=7.0)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="schusspausenzeit", 			value=1.5)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="genauigkeit_bewegte_ziele",	value=0.4)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="blockadewahrscheinlichkeit",	value=10.0)
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_DESERT_EAGLE', attribute="effects", value={
		"sound_shot"	: "shot_desert_eagle",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_DESERT_EAGLE_W_LASERPOINTER')
clone_weapon_type(typeid='SET_DESERT_EAGLE', new_typeid='SET_DESERT_EAGLE_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
objects.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="name", value=globaltext.SET_DESERT_EAGLE_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="hint", value=globaltext.SET_DESERT_EAGLE_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="resource3d", value='RES3D_DESERT_EAGLE_W_LASERPOINTER')
objects.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="value", value=13.00)
objects.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "shot_desert_eagle",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})
objects.set_attribute(object='SET_DESERT_EAGLE_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_DESERT_EAGLE','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_COLT_45')
objects.set_attribute(object='SET_COLT_45', attribute="name", value=globaltext.SET_COLT_45_NAME)
objects.set_attribute(object='SET_COLT_45', attribute="hint", value=globaltext.SET_COLT_45_HINT)
objects.set_attribute(object='SET_COLT_45', attribute="resourceui", value='RES_ITEM65X32_WEAPON_COLT_45')
objects.set_attribute(object='SET_COLT_45', attribute="resource3d", value='RES3D_COLT_45')
objects.set_attribute(object='SET_COLT_45', attribute="value", value=7.00)
objects.set_attribute(object='SET_COLT_45', attribute="weight", value=1.0)
objects.set_attribute(object='SET_COLT_45', attribute="stacking", value=1)
objects.set_attribute(object='SET_COLT_45', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_COLT_45', attribute="maximale_feuerreichweite", value=14)
objects.set_attribute(object='SET_COLT_45', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_COLT_45', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_COLT_45', attribute="genauigkeit", value=1.00)
objects.set_attribute(object='SET_COLT_45', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_COLT_45', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_COLT_45', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_COLT_45', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_COLT_45', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_COLT_45', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_COLT_45', attribute="magazingroesse", 				value=7.0)
objects.set_attribute(object='SET_COLT_45', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_COLT_45', attribute="schusspausenzeit", 			value=0.5)
objects.set_attribute(object='SET_COLT_45', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_COLT_45', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_COLT_45', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_COLT_45', attribute="effects", value={
		"sound_shot"	: "shot_colt_45",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_COLT_45_W_SILENCER')
clone_weapon_type(typeid='SET_COLT_45', new_typeid='SET_COLT_45_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="name", value=globaltext.SET_COLT_45_W_SILENCER_NAME)
objects.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="hint", value=globaltext.SET_COLT_45_W_SILENCER_HINT)
objects.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="resource3d", value='RES3D_COLT_45_W_SILENCER')
objects.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="value", value=12.00)
objects.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "shot_colt_45_silenced",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_COLT_45_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_COLT_45','SET_SILENCER']]})

create_weapon_type(typeid='SET_GLOCK_21')
objects.set_attribute(object='SET_GLOCK_21', attribute="name", value=globaltext.SET_GLOCK_21_NAME)
objects.set_attribute(object='SET_GLOCK_21', attribute="hint", value=globaltext.SET_GLOCK_21_HINT)
objects.set_attribute(object='SET_GLOCK_21', attribute="resourceui", value='RES_ITEM65X32_WEAPON_GLOCK_21')
objects.set_attribute(object='SET_GLOCK_21', attribute="resource3d", value='RES3D_GLOCK_21')
objects.set_attribute(object='SET_GLOCK_21', attribute="value", value=9.0)
objects.set_attribute(object='SET_GLOCK_21', attribute="weight", value=0.8)
objects.set_attribute(object='SET_GLOCK_21', attribute="stacking", value=1)
objects.set_attribute(object='SET_GLOCK_21', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_GLOCK_21', attribute="maximale_feuerreichweite", value=13)
objects.set_attribute(object='SET_GLOCK_21', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_GLOCK_21', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_GLOCK_21', attribute="genauigkeit", value=1.1)
objects.set_attribute(object='SET_GLOCK_21', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_GLOCK_21', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_GLOCK_21', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_GLOCK_21', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_GLOCK_21', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_GLOCK_21', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_GLOCK_21', attribute="magazingroesse", 				value=13.0)
objects.set_attribute(object='SET_GLOCK_21', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_GLOCK_21', attribute="schusspausenzeit", 			value=0.6)
objects.set_attribute(object='SET_GLOCK_21', attribute="genauigkeit_bewegte_ziele",	value=0.6)
objects.set_attribute(object='SET_GLOCK_21', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_GLOCK_21', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_GLOCK_21', attribute="effects", value={
		"sound_shot"	: "shot_glock_21",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_GLOCK_21_W_SILENCER')
clone_weapon_type(typeid='SET_GLOCK_21', new_typeid='SET_GLOCK_21_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="name", value=globaltext.SET_GLOCK_21_W_SILENCER_NAME)
objects.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="hint", value=globaltext.SET_GLOCK_21_W_SILENCER_HINT)
objects.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="resource3d", value='RES3D_GLOCK_21_W_SILENCER')
objects.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="value", value=14.0)
objects.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "shot_glock_21_silenced",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_GLOCK_21_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_GLOCK_21','SET_SILENCER']]})

create_weapon_type(typeid='SET_HK_USP_45')
objects.set_attribute(object='SET_HK_USP_45', attribute="name", value=globaltext.SET_HK_USP_45_NAME)
objects.set_attribute(object='SET_HK_USP_45', attribute="hint", value=globaltext.SET_HK_USP_45_HINT)
objects.set_attribute(object='SET_HK_USP_45', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_USP_45')
objects.set_attribute(object='SET_HK_USP_45', attribute="resource3d", value='RES3D_HK_USP_45')
objects.set_attribute(object='SET_HK_USP_45', attribute="value", value=10.0)
objects.set_attribute(object='SET_HK_USP_45', attribute="weight", value=0.85)
objects.set_attribute(object='SET_HK_USP_45', attribute="stacking", value=1)
objects.set_attribute(object='SET_HK_USP_45', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_HK_USP_45', attribute="maximale_feuerreichweite", value=15)
objects.set_attribute(object='SET_HK_USP_45', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_HK_USP_45', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_HK_USP_45', attribute="genauigkeit", value=1.2)
objects.set_attribute(object='SET_HK_USP_45', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_HK_USP_45', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_HK_USP_45', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_HK_USP_45', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_HK_USP_45', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_HK_USP_45', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_HK_USP_45', attribute="magazingroesse", 			value=12.0)
objects.set_attribute(object='SET_HK_USP_45', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_HK_USP_45', attribute="schusspausenzeit", 			value=0.8)
objects.set_attribute(object='SET_HK_USP_45', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_HK_USP_45', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_HK_USP_45', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_HK_USP_45', attribute="effects", value={
		"sound_shot"	: "shot_hk_usp_45",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_HK_USP_45_W_SILENCER')
clone_weapon_type(typeid='SET_HK_USP_45', new_typeid='SET_HK_USP_45_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="name", value=globaltext.SET_HK_USP_45_W_SILENCER_NAME)
objects.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="hint", value=globaltext.SET_HK_USP_45_W_SILENCER_HINT)
objects.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="resource3d", value='RES3D_HK_USP_45_W_SILENCER')
objects.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="value", value=15.0)
objects.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "shot_hk_usp_45_silenced",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_HK_USP_45_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_HK_USP_45','SET_SILENCER']]})

create_weapon_type(typeid='SET_CALICO_M950')
objects.set_attribute(object='SET_CALICO_M950', attribute="name", value=globaltext.SET_CALICO_M950_NAME)
objects.set_attribute(object='SET_CALICO_M950', attribute="hint", value=globaltext.SET_CALICO_M950_HINT)
objects.set_attribute(object='SET_CALICO_M950', attribute="resourceui", value='RES_ITEM65X32_WEAPON_CALICO_M950')
objects.set_attribute(object='SET_CALICO_M950', attribute="resource3d", value='RES3D_CALICO_M950')
objects.set_attribute(object='SET_CALICO_M950', attribute="value", value=12.00)
objects.set_attribute(object='SET_CALICO_M950', attribute="weight", value=1.2)
objects.set_attribute(object='SET_CALICO_M950', attribute="stacking", value=1)
objects.set_attribute(object='SET_CALICO_M950', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_CALICO_M950', attribute="maximale_feuerreichweite", value=23)
objects.set_attribute(object='SET_CALICO_M950', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_CALICO_M950', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_CALICO_M950', attribute="genauigkeit", value=0.9)
objects.set_attribute(object='SET_CALICO_M950', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_CALICO_M950', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_CALICO_M950', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_CALICO_M950', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_CALICO_M950', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_CALICO_M950', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_CALICO_M950', attribute="magazingroesse", 				value=50.0)
objects.set_attribute(object='SET_CALICO_M950', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_CALICO_M950', attribute="schusspausenzeit", 			value=1.5)
objects.set_attribute(object='SET_CALICO_M950', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_CALICO_M950', attribute="blockadewahrscheinlichkeit",	value=15.0)
objects.set_attribute(object='SET_CALICO_M950', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_CALICO_M950', attribute="effects", value={
		"sound_shot"	: "shot_calico_m950",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_CALICO_M950_W_SILENCER')
clone_weapon_type(typeid='SET_CALICO_M950', new_typeid='SET_CALICO_M950_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="name", value=globaltext.SET_CALICO_M950_NAME)
objects.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="hint", value=globaltext.SET_CALICO_M950_HINT)
objects.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="resource3d", value='RES3D_CALICO_M950_W_SILENCER')
objects.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="value", value=17.00)
objects.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "shot_calico_m950_silenced",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_CALICO_M950_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_CALICO_M950','SET_SILENCER']]})


create_weapon_type(typeid='SET_AUTOMAG_3')
objects.set_attribute(object='SET_AUTOMAG_3', attribute="name", value=globaltext.SET_AUTOMAG_3_NAME)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="hint", value=globaltext.SET_AUTOMAG_3_HINT)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AUTOMAG_3')
objects.set_attribute(object='SET_AUTOMAG_3', attribute="resource3d", value='RES3D_AUTOMAG_3')
objects.set_attribute(object='SET_AUTOMAG_3', attribute="value", value=7.00)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="weight", value=1.0)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="stacking", value=1)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="maximale_feuerreichweite", value=22)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="genauigkeit", value=0.8)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
objects.set_attribute(object='SET_AUTOMAG_3', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_AUTOMAG_3', attribute="magazingroesse", 			value=5.0)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="schusspausenzeit", 			value=1.0)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="genauigkeit_bewegte_ziele",	value=0.4)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="blockadewahrscheinlichkeit",	value=15.0)
objects.set_attribute(object='SET_AUTOMAG_3', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_AUTOMAG_3', attribute="effects", value={
		"sound_shot"	: "shot_automag_3",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.6,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_AUTOMAG_3_W_LASERPOINTER')
clone_weapon_type(typeid='SET_AUTOMAG_3', new_typeid='SET_AUTOMAG_3_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
objects.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="name", value=globaltext.SET_AUTOMAG_3_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="hint", value=globaltext.SET_AUTOMAG_3_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="resource3d", value='RES3D_AUTOMAG_3_W_LASERPOINTER')
objects.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="value", value=10.00)
objects.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "shot_automag_3",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.55,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})
objects.set_attribute(object='SET_AUTOMAG_3_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_AUTOMAG_3','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_MICRO_UZI')
objects.set_attribute(object='SET_MICRO_UZI', attribute="name", value=globaltext.SET_MICRO_UZI_NAME)
objects.set_attribute(object='SET_MICRO_UZI', attribute="hint", value=globaltext.SET_MICRO_UZI_HINT)
objects.set_attribute(object='SET_MICRO_UZI', attribute="resourceui", value='RES_ITEM65X32_WEAPON_MICRO_UZI')
objects.set_attribute(object='SET_MICRO_UZI', attribute="resource3d", value='RES3D_MICRO_UZI')
objects.set_attribute(object='SET_MICRO_UZI', attribute="value", value=9.00)
objects.set_attribute(object='SET_MICRO_UZI', attribute="weight", value=1.5)
objects.set_attribute(object='SET_MICRO_UZI', attribute="stacking", value=1)
objects.set_attribute(object='SET_MICRO_UZI', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_MICRO_UZI', attribute="maximale_feuerreichweite", value=18)
objects.set_attribute(object='SET_MICRO_UZI', attribute="salvenlaenge", value=6)
objects.set_attribute(object='SET_MICRO_UZI', attribute="feuergeschwindigkeit", value=1500.00)
objects.set_attribute(object='SET_MICRO_UZI', attribute="genauigkeit", value=0.3)
objects.set_attribute(object='SET_MICRO_UZI', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_MICRO_UZI', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_MICRO_UZI', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_MICRO_UZI', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_MICRO_UZI', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
objects.set_attribute(object='SET_MICRO_UZI', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_MICRO_UZI', attribute="magazingroesse", 			value=30.0)
objects.set_attribute(object='SET_MICRO_UZI', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_MICRO_UZI', attribute="schusspausenzeit", 			value=0.5)
objects.set_attribute(object='SET_MICRO_UZI', attribute="genauigkeit_bewegte_ziele",	value=0.5)
objects.set_attribute(object='SET_MICRO_UZI', attribute="blockadewahrscheinlichkeit",	value=20.0)
objects.set_attribute(object='SET_MICRO_UZI', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_MICRO_UZI', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 6,
		"ButtOn"	: "RES_ITEM65X32_WEAPON_MICRO_UZI_X"
		})
objects.set_attribute(object='SET_MICRO_UZI', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_MICRO_UZI', attribute="effects", value={
		"sound_shot"	: "burst_micro_uzi",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_MICRO_UZI_W_SILENCER')
clone_weapon_type(typeid='SET_MICRO_UZI', new_typeid='SET_MICRO_UZI_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="name", value=globaltext.SET_MICRO_UZI_W_SILENCER_NAME)
objects.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="hint", value=globaltext.SET_MICRO_UZI_W_SILENCER_HINT)
objects.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="resource3d", value='RES3D_MICRO_UZI_W_SILENCER')
objects.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="value", value=14.00)	# [BrainRipper]
objects.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "burst_micro_uzi_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_MICRO_UZI_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_MICRO_UZI','SET_SILENCER']]})
		

create_weapon_type(typeid='SET_UZI')
objects.set_attribute(object='SET_UZI', attribute="name", value=globaltext.SET_UZI_NAME)
objects.set_attribute(object='SET_UZI', attribute="hint", value=globaltext.SET_UZI_HINT)
objects.set_attribute(object='SET_UZI', attribute="resourceui", value='RES_ITEM65X32_WEAPON_UZI')
objects.set_attribute(object='SET_UZI', attribute="resource3d", value='RES3D_UZI')
objects.set_attribute(object='SET_UZI', attribute="value", value=10.00)
objects.set_attribute(object='SET_UZI', attribute="weight", value=3.5)
objects.set_attribute(object='SET_UZI', attribute="stacking", value=1)
objects.set_attribute(object='SET_UZI', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_UZI', attribute="maximale_feuerreichweite", value=23)
objects.set_attribute(object='SET_UZI', attribute="salvenlaenge", value=5)
objects.set_attribute(object='SET_UZI', attribute="feuergeschwindigkeit", value=600.00)
objects.set_attribute(object='SET_UZI', attribute="genauigkeit", value=0.8)
objects.set_attribute(object='SET_UZI', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_UZI', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_UZI', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_UZI', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_UZI', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
objects.set_attribute(object='SET_UZI', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_UZI', attribute="magazingroesse", 				value=30.0)
objects.set_attribute(object='SET_UZI', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_UZI', attribute="schusspausenzeit", 			value=0.9)
objects.set_attribute(object='SET_UZI', attribute="genauigkeit_bewegte_ziele",	value=0.6)
objects.set_attribute(object='SET_UZI', attribute="blockadewahrscheinlichkeit",	value=10.0)
objects.set_attribute(object='SET_UZI', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_UZI', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 5,
		"ButtOn"	: "RES_ITEM65X32_WEAPON_UZI_X"
		})
objects.set_attribute(object='SET_UZI', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_UZI', attribute="effects", value={
		"sound_shot"	: "burst_uzi",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_UZI_W_SILENCER')
clone_weapon_type(typeid='SET_UZI', new_typeid='SET_UZI_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_UZI_W_SILENCER', attribute="name", value=globaltext.SET_UZI_W_SILENCER_NAME)
objects.set_attribute(object='SET_UZI_W_SILENCER', attribute="hint", value=globaltext.SET_UZI_W_SILENCER_HINT)
objects.set_attribute(object='SET_UZI_W_SILENCER', attribute="resource3d", value='RES3D_UZI_W_SILENCER')
objects.set_attribute(object='SET_UZI_W_SILENCER', attribute="resource3d", value='RES3D_UZI_W_SILENCER')
objects.set_attribute(object='SET_UZI_W_SILENCER', attribute="value", value=15.00)
objects.set_attribute(object='SET_UZI_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "burst_uzi_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_UZI_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_UZI','SET_SILENCER']]})

create_weapon_type(typeid='SET_UZI_W_LASERPOINTER')
clone_weapon_type(typeid='SET_UZI', new_typeid='SET_UZI_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
objects.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="name", value=globaltext.SET_UZI_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="hint", value=globaltext.SET_UZI_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="resource3d", value='RES3D_UZI_W_LASERPOINTER')
objects.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="value", value=13.00)
objects.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_uzi",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_UZI_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_UZI','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_UZI_W_SILENCER_W_LASERPOINTER')
clone_weapon_type(typeid='SET_UZI', new_typeid='SET_UZI_W_SILENCER_W_LASERPOINTER', attachments=['SET_SILENCER','SET_LASERPOINTER'])
objects.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="name", value=globaltext.SET_UZI_W_SILENCER_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="hint", value=globaltext.SET_UZI_W_SILENCER_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="resource3d", value='RES3D_UZI_W_SILENCER_W_LASERPOINTER')
objects.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="value", value=18.00)
objects.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_uzi_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.2,
		"fade_out"		: 50})
objects.set_attribute(object='SET_UZI_W_SILENCER_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_UZI','SET_LASERPOINTER','SET_SILENCER','SET_DUCT_TAPE'],
								['SET_UZI_W_SILENCER','SET_LASERPOINTER','SET_DUCT_TAPE'],
								['SET_UZI_W_LASERPOINTER','SET_SILENCER']]})

create_weapon_type(typeid='SET_MP5')
objects.set_attribute(object='SET_MP5', attribute="name", value=globaltext.SET_MP5_NAME)
objects.set_attribute(object='SET_MP5', attribute="hint", value=globaltext.SET_MP5_HINT)
objects.set_attribute(object='SET_MP5', attribute="resourceui", value='RES_ITEM65X32_WEAPON_MP5')
objects.set_attribute(object='SET_MP5', attribute="resource3d", value='RES3D_MP5')
objects.set_attribute(object='SET_MP5', attribute="value", value=15.00)
objects.set_attribute(object='SET_MP5', attribute="weight", value=2.5)
objects.set_attribute(object='SET_MP5', attribute="stacking", value=1)
objects.set_attribute(object='SET_MP5', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_MP5', attribute="maximale_feuerreichweite", value=22)
objects.set_attribute(object='SET_MP5', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_MP5', attribute="feuergeschwindigkeit", value=800.00)
objects.set_attribute(object='SET_MP5', attribute="genauigkeit", value=0.9)
objects.set_attribute(object='SET_MP5', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_MP5', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_MP5', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_MP5', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_MP5', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_MP5', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_MP5', attribute="magazingroesse", 				value=30.0)
objects.set_attribute(object='SET_MP5', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_MP5', attribute="schusspausenzeit", 			value=1.0)
objects.set_attribute(object='SET_MP5', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_MP5', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_MP5', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_MP5', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Cutoff"	: 2,
		"Auto"		: 3
		})
objects.set_attribute(object='SET_MP5', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_MP5', attribute="effects", value={
		"sound_shot"	: "burst_mp5",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_MP5_W_SILENCER')
clone_weapon_type(typeid='SET_MP5', new_typeid='SET_MP5_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_MP5_W_SILENCER', attribute="name", value=globaltext.SET_MP5_W_SILENCER_NAME)
objects.set_attribute(object='SET_MP5_W_SILENCER', attribute="hint", value=globaltext.SET_MP5_W_SILENCER_HINT)
objects.set_attribute(object='SET_MP5_W_SILENCER', attribute="resource3d", value='RES3D_MP5_W_SILENCER')
objects.set_attribute(object='SET_MP5_W_SILENCER', attribute="value", value=20)
objects.set_attribute(object='SET_MP5_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "burst_mp5_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_MP5_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_MP5','SET_SILENCER']]})


create_weapon_type(typeid='SET_MP5_W_LASERPOINTER')
clone_weapon_type(typeid='SET_MP5', new_typeid='SET_MP5_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
objects.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="name", value=globaltext.SET_MP5_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="hint", value=globaltext.SET_MP5_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="resource3d", value='RES3D_MP5_W_LASERPOINTER')
objects.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="value", value=18)
objects.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_mp5",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_MP5_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_MP5','SET_LASERPOINTER','SET_DUCT_TAPE']]})


create_weapon_type(typeid='SET_MP5_W_SILENCER_W_LASERPOINTER')
clone_weapon_type(typeid='SET_MP5', new_typeid='SET_MP5_W_SILENCER_W_LASERPOINTER', attachments=['SET_SILENCER','SET_LASERPOINTER'])
objects.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="name", value=globaltext.SET_MP5_W_SILENCER_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="hint", value=globaltext.SET_MP5_W_SILENCER_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="resource3d", value='RES3D_MP5_W_SILENCER_W_LASERPOINTER')
objects.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="value", value=23)
objects.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_mp5_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_MP5_W_SILENCER_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_MP5','SET_LASERPOINTER','SET_SILENCER','SET_DUCT_TAPE'],
								['SET_MP5_W_SILENCER','SET_LASERPOINTER','SET_DUCT_TAPE'],
								['SET_MP5_W_LASERPOINTER','SET_SILENCER']]})

create_weapon_type(typeid='SET_HK_MP7')
objects.set_attribute(object='SET_HK_MP7', attribute="name", value=globaltext.SET_HK_MP7_NAME)
objects.set_attribute(object='SET_HK_MP7', attribute="hint", value=globaltext.SET_HK_MP7_HINT)
objects.set_attribute(object='SET_HK_MP7', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_MP7')
objects.set_attribute(object='SET_HK_MP7', attribute="resource3d", value='RES3D_HK_MP7')
objects.set_attribute(object='SET_HK_MP7', attribute="value", value=35.00)
objects.set_attribute(object='SET_HK_MP7', attribute="weight", value=1.4)
objects.set_attribute(object='SET_HK_MP7', attribute="stacking", value=1)
objects.set_attribute(object='SET_HK_MP7', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_HK_MP7', attribute="maximale_feuerreichweite", value=30)
objects.set_attribute(object='SET_HK_MP7', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_HK_MP7', attribute="feuergeschwindigkeit", value=950.00)
objects.set_attribute(object='SET_HK_MP7', attribute="genauigkeit", value=1.5)
objects.set_attribute(object='SET_HK_MP7', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_HK_MP7', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_HK_MP7', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_HK_MP7', attribute="munitionsarten", value=['SET_AMMOPACK_4_6_MM','SET_AMMOPACK_4_6_MM_DUMDUM','SET_AMMOPACK_4_6_MM_SUBSONIC'])# ,'SET_AMMOPACK_4_6_MM_SUBSONIC_DUMDUM'
objects.set_attribute(object='SET_HK_MP7', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
objects.set_attribute(object='SET_HK_MP7', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_HK_MP7', attribute="magazingroesse", 				value=20.0)
objects.set_attribute(object='SET_HK_MP7', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_HK_MP7', attribute="schusspausenzeit", 			value=1.0)
objects.set_attribute(object='SET_HK_MP7', attribute="genauigkeit_bewegte_ziele",	value=1.2)
objects.set_attribute(object='SET_HK_MP7', attribute="blockadewahrscheinlichkeit",	value=0.0)
objects.set_attribute(object='SET_HK_MP7', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_HK_MP7', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 3,
		"ButtOn"	: "RES_ITEM65X32_WEAPON_HK_MP7_X"
		})
objects.set_attribute(object='SET_HK_MP7', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_HK_MP7', attribute="effects", value={
		"sound_shot"	: "burst_hk_mp7",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.4,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_HK_XM8')
objects.set_attribute(object='SET_HK_XM8', attribute="name", value=globaltext.SET_HK_XM8_NAME)
objects.set_attribute(object='SET_HK_XM8', attribute="hint", value=globaltext.SET_HK_XM8_HINT)
objects.set_attribute(object='SET_HK_XM8', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_XM8')
objects.set_attribute(object='SET_HK_XM8', attribute="resource3d", value='RES3D_HK_XM8')
objects.set_attribute(object='SET_HK_XM8', attribute="value", value=35.00)
objects.set_attribute(object='SET_HK_XM8', attribute="weight", value=2.5)
objects.set_attribute(object='SET_HK_XM8', attribute="stacking", value=1)
objects.set_attribute(object='SET_HK_XM8', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_HK_XM8', attribute="maximale_feuerreichweite", value=36)
objects.set_attribute(object='SET_HK_XM8', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_HK_XM8', attribute="feuergeschwindigkeit", value=800.00)
objects.set_attribute(object='SET_HK_XM8', attribute="genauigkeit", value=2.0)
objects.set_attribute(object='SET_HK_XM8', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_HK_XM8', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_HK_XM8', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_HK_XM8', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
objects.set_attribute(object='SET_HK_XM8', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_HK_XM8', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_HK_XM8', attribute="magazingroesse", 				value=30.0)
objects.set_attribute(object='SET_HK_XM8', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_HK_XM8', attribute="schusspausenzeit", 			value=2.1)
objects.set_attribute(object='SET_HK_XM8', attribute="genauigkeit_bewegte_ziele",	value=0.8)
objects.set_attribute(object='SET_HK_XM8', attribute="blockadewahrscheinlichkeit",	value=3.0)
objects.set_attribute(object='SET_HK_XM8', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_HK_XM8', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 3,
		"ButtOff"	: "RES_ITEM65X32_WEAPON_HK_XM8_X"
		})
objects.set_attribute(object='SET_HK_XM8', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_HK_XM8', attribute="effects", value={
		"sound_shot"	: "burst_xm8",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_HK_G11')
objects.set_attribute(object='SET_HK_G11', attribute="name", value=globaltext.SET_HK_G11_NAME)
objects.set_attribute(object='SET_HK_G11', attribute="hint", value=globaltext.SET_HK_G11_HINT)
objects.set_attribute(object='SET_HK_G11', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G11')
objects.set_attribute(object='SET_HK_G11', attribute="resource3d", value='RES3D_HK_G11')
objects.set_attribute(object='SET_HK_G11', attribute="value", value=40.00)
objects.set_attribute(object='SET_HK_G11', attribute="weight", value=3.8)
objects.set_attribute(object='SET_HK_G11', attribute="stacking", value=1)
objects.set_attribute(object='SET_HK_G11', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_HK_G11', attribute="maximale_feuerreichweite", value=37)
objects.set_attribute(object='SET_HK_G11', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_HK_G11', attribute="feuergeschwindigkeit", value=2000.00)
objects.set_attribute(object='SET_HK_G11', attribute="genauigkeit", value=3.0)
objects.set_attribute(object='SET_HK_G11', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_HK_G11', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_HK_G11', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_HK_G11', attribute="munitionsarten", value=['SET_AMMOPACK_4_73_CASELESS'])
objects.set_attribute(object='SET_HK_G11', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_HK_G11', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_HK_G11', attribute="magazingroesse", 				value=45.0)
objects.set_attribute(object='SET_HK_G11', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_HK_G11', attribute="schusspausenzeit", 			value=1.0)
objects.set_attribute(object='SET_HK_G11', attribute="genauigkeit_bewegte_ziele",	value=1.0)
objects.set_attribute(object='SET_HK_G11', attribute="blockadewahrscheinlichkeit",	value=2.0)
objects.set_attribute(object='SET_HK_G11', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_HK_G11', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 3
		})
objects.set_attribute(object='SET_HK_G11', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_HK_G11', attribute="effects", value={
		"sound_shot"	: "burst_hk_g11",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.4,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_GMG_OCSW')
objects.set_attribute(object='SET_GMG_OCSW', attribute="name", value=globaltext.SET_GMG_OCSW_NAME)
objects.set_attribute(object='SET_GMG_OCSW', attribute="hint", value=globaltext.SET_GMG_OCSW_HINT)
objects.set_attribute(object='SET_GMG_OCSW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_GMG_OCSW')
objects.set_attribute(object='SET_GMG_OCSW', attribute="resource3d", value='RES3D_GMG_OCSW')
objects.set_attribute(object='SET_GMG_OCSW', attribute="value", value=100.00)
objects.set_attribute(object='SET_GMG_OCSW', attribute="weight", value=14.5)
objects.set_attribute(object='SET_GMG_OCSW', attribute="stacking", value=1)
objects.set_attribute(object='SET_GMG_OCSW', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_GMG_OCSW', attribute="maximale_feuerreichweite", value=50)
objects.set_attribute(object='SET_GMG_OCSW', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_GMG_OCSW', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_GMG_OCSW', attribute="genauigkeit", value=1.0)
objects.set_attribute(object='SET_GMG_OCSW', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_GMG_OCSW', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_GMG_OCSW', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_GMG_OCSW', attribute="munitionsarten", value=['SET_AMMOPACK_25_MM_HE','SET_AMMOPACK_25_MM_AP'])
objects.set_attribute(object='SET_GMG_OCSW', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_GMG_OCSW', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_GMG_OCSW', attribute="magazingroesse", 				value=20.0)
objects.set_attribute(object='SET_GMG_OCSW', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_GMG_OCSW', attribute="schusspausenzeit", 			value=1.0)
objects.set_attribute(object='SET_GMG_OCSW', attribute="genauigkeit_bewegte_ziele",	value=0.4)
objects.set_attribute(object='SET_GMG_OCSW', attribute="blockadewahrscheinlichkeit",	value=3.0)
objects.set_attribute(object='SET_GMG_OCSW', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_GMG_OCSW', attribute="effects", value={
		"sound_shot"	: "shot_gmg_ocsw",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 5,
		"flash_size"	: 1.125,
		"stream_type"	: 1,
		"stream_size"	: 1.125,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_MAC_10')
objects.set_attribute(object='SET_MAC_10', attribute="name", value=globaltext.SET_MAC_10_NAME)
objects.set_attribute(object='SET_MAC_10', attribute="hint", value=globaltext.SET_MAC_10_HINT)
objects.set_attribute(object='SET_MAC_10', attribute="resourceui", value='RES_ITEM65X32_WEAPON_MAC_10')
objects.set_attribute(object='SET_MAC_10', attribute="resource3d", value='RES3D_MAC_10')
objects.set_attribute(object='SET_MAC_10', attribute="value", value=12.00)
objects.set_attribute(object='SET_MAC_10', attribute="weight", value=3.8)
objects.set_attribute(object='SET_MAC_10', attribute="stacking", value=1)
objects.set_attribute(object='SET_MAC_10', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_MAC_10', attribute="maximale_feuerreichweite", value=20)
objects.set_attribute(object='SET_MAC_10', attribute="salvenlaenge", value=6)
objects.set_attribute(object='SET_MAC_10', attribute="feuergeschwindigkeit", value=1100.00)
objects.set_attribute(object='SET_MAC_10', attribute="genauigkeit", value=0.4)
objects.set_attribute(object='SET_MAC_10', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_MAC_10', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_MAC_10', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_MAC_10', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_MAC_10', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
objects.set_attribute(object='SET_MAC_10', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_MAC_10', attribute="magazingroesse", 				value=30.0)
objects.set_attribute(object='SET_MAC_10', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_MAC_10', attribute="schusspausenzeit", 				value=1.0)
objects.set_attribute(object='SET_MAC_10', attribute="genauigkeit_bewegte_ziele",		value=0.4)
objects.set_attribute(object='SET_MAC_10', attribute="blockadewahrscheinlichkeit",	value=10.0)
objects.set_attribute(object='SET_MAC_10', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_MAC_10', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 6, 
		"ButtOn"	: "RES_ITEM65X32_WEAPON_MAC_10_X"
		})
objects.set_attribute(object='SET_MAC_10', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_MAC_10', attribute="effects", value={
		"sound_shot"	: "burst_mac_10",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_MAC_10_W_SILENCER')
clone_weapon_type(typeid='SET_MAC_10', new_typeid='SET_MAC_10_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="name", value=globaltext.SET_MAC_10_W_SILENCER_NAME)
objects.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="hint", value=globaltext.SET_MAC_10_W_SILENCER_HINT)
objects.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="resource3d", value='RES3D_MAC_10_W_SILENCER')
objects.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="value", value=17.00)
objects.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "burst_mac_10_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_MAC_10_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_MAC_10','SET_SILENCER']]})

create_weapon_type(typeid='SET_HK_UMP_45')
objects.set_attribute(object='SET_HK_UMP_45', attribute="name", value=globaltext.SET_HK_UMP_45_NAME)
objects.set_attribute(object='SET_HK_UMP_45', attribute="hint", value=globaltext.SET_HK_UMP_45_HINT)
objects.set_attribute(object='SET_HK_UMP_45', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_UMP_45')
objects.set_attribute(object='SET_HK_UMP_45', attribute="resource3d", value='RES3D_HK_UMP_45')
objects.set_attribute(object='SET_HK_UMP_45', attribute="value", value=14.00)
objects.set_attribute(object='SET_HK_UMP_45', attribute="weight", value=2.1)
objects.set_attribute(object='SET_HK_UMP_45', attribute="stacking", value=1)
objects.set_attribute(object='SET_HK_UMP_45', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_HK_UMP_45', attribute="maximale_feuerreichweite", value=24)
objects.set_attribute(object='SET_HK_UMP_45', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_HK_UMP_45', attribute="feuergeschwindigkeit", value=650.00)
objects.set_attribute(object='SET_HK_UMP_45', attribute="genauigkeit", value=0.8)
objects.set_attribute(object='SET_HK_UMP_45', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_HK_UMP_45', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_HK_UMP_45', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_HK_UMP_45', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_HK_UMP_45', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_HK_UMP_45', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_HK_UMP_45', attribute="magazingroesse", 			value=25.0)
objects.set_attribute(object='SET_HK_UMP_45', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_HK_UMP_45', attribute="schusspausenzeit", 			value=1.2)
objects.set_attribute(object='SET_HK_UMP_45', attribute="genauigkeit_bewegte_ziele",	value=0.6)
objects.set_attribute(object='SET_HK_UMP_45', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_HK_UMP_45', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_HK_UMP_45', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Cutoff"	: 2,
		"Auto"		: 3,
		"ButtOff"	: 'RES_ITEM65X32_WEAPON_HK_UMP_45_X'
		})
objects.set_attribute(object='SET_HK_UMP_45', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_HK_UMP_45', attribute="effects", value={
		"sound_shot"	: "burst_hk_ump_45",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_HK_UMP_45_W_SILENCER')
clone_weapon_type(typeid='SET_HK_UMP_45', new_typeid='SET_HK_UMP_45_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="name", value=globaltext.SET_HK_UMP_45_W_SILENCER_NAME)
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="hint", value=globaltext.SET_HK_UMP_45_W_SILENCER_HINT)
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="resource3d", value='RES3D_HK_UMP_45_W_SILENCER')
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="value", value=19.00)
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "burst_hk_ump_45_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_HK_UMP_45','SET_SILENCER']]})

create_weapon_type(typeid='SET_HK_UMP_45_W_LASERPOINTER')
clone_weapon_type(typeid='SET_HK_UMP_45', new_typeid='SET_HK_UMP_45_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
objects.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="name", value=globaltext.SET_HK_UMP_45_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="hint", value=globaltext.SET_HK_UMP_45_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="resource3d", value='RES3D_HK_UMP_45_W_LASERPOINTER')
objects.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="value", value=17.00)
objects.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_hk_ump_45",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_HK_UMP_45_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_HK_UMP_45','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER')
clone_weapon_type(typeid='SET_HK_UMP_45', new_typeid='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attachments=['SET_SILENCER','SET_LASERPOINTER'])
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="name", value=globaltext.SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="hint", value=globaltext.SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="resource3d", value='RES3D_HK_UMP_45_W_SILENCER_W_LASERPOINTER')
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="value", value=22.00)
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_hk_ump_45_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_HK_UMP_45_W_SILENCER_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_HK_UMP_45','SET_LASERPOINTER','SET_SILENCER','SET_DUCT_TAPE'],
								['SET_HK_UMP_45_W_SILENCER','SET_LASERPOINTER','SET_DUCT_TAPE'],
								['SET_HK_UMP_45_W_LASERPOINTER','SET_SILENCER']]})

create_weapon_type(typeid='SET_STEYR_TMP')
objects.set_attribute(object='SET_STEYR_TMP', attribute="name", value=globaltext.SET_STEYR_TMP_NAME)
objects.set_attribute(object='SET_STEYR_TMP', attribute="hint", value=globaltext.SET_STEYR_TMP_HINT)
objects.set_attribute(object='SET_STEYR_TMP', attribute="resourceui", value='RES_ITEM65X32_WEAPON_STEYR_TMP')
objects.set_attribute(object='SET_STEYR_TMP', attribute="resource3d", value='RES3D_STEYR_TMP')
objects.set_attribute(object='SET_STEYR_TMP', attribute="value", value=10.00)
objects.set_attribute(object='SET_STEYR_TMP', attribute="weight", value=1.3)
objects.set_attribute(object='SET_STEYR_TMP', attribute="stacking", value=1)
objects.set_attribute(object='SET_STEYR_TMP', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_STEYR_TMP', attribute="maximale_feuerreichweite", value=22)
objects.set_attribute(object='SET_STEYR_TMP', attribute="salvenlaenge", value=4)
objects.set_attribute(object='SET_STEYR_TMP', attribute="feuergeschwindigkeit", value=850.00)
objects.set_attribute(object='SET_STEYR_TMP', attribute="genauigkeit", value=0.8)
objects.set_attribute(object='SET_STEYR_TMP', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_STEYR_TMP', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_STEYR_TMP', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_STEYR_TMP', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_STEYR_TMP', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
objects.set_attribute(object='SET_STEYR_TMP', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_STEYR_TMP', attribute="magazingroesse", 			value=30.0)
objects.set_attribute(object='SET_STEYR_TMP', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_STEYR_TMP', attribute="schusspausenzeit", 			value=0.6)
objects.set_attribute(object='SET_STEYR_TMP', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_STEYR_TMP', attribute="blockadewahrscheinlichkeit",	value=8.0)
objects.set_attribute(object='SET_STEYR_TMP', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_STEYR_TMP', attribute="effects", value={
		"sound_shot"	: "burst_steyr_tmp",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_STEYR_TMP_W_SILENCER')
clone_weapon_type(typeid='SET_STEYR_TMP', new_typeid='SET_STEYR_TMP_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="name", value=globaltext.SET_STEYR_TMP_W_SILENCER_NAME)
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="hint", value=globaltext.SET_STEYR_TMP_W_SILENCER_HINT)
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="resource3d", value='RES3D_STEYR_TMP_W_SILENCER')
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="value", value=15.00)
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "burst_steyr_tmp_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_STEYR_TMP','SET_SILENCER']]})

create_weapon_type(typeid='SET_STEYR_TMP_W_LASERPOINTER')
clone_weapon_type(typeid='SET_STEYR_TMP', new_typeid='SET_STEYR_TMP_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
objects.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="name", value=globaltext.SET_STEYR_TMP_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="hint", value=globaltext.SET_STEYR_TMP_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="resource3d", value='RES3D_STEYR_TMP_W_LASERPOINTER')
objects.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="value", value=13.00)
objects.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_steyr_tmp",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_STEYR_TMP_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_STEYR_TMP','SET_LASERPOINTER','SET_DUCT_TAPE']]})


create_weapon_type(typeid='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER')
clone_weapon_type(typeid='SET_STEYR_TMP', new_typeid='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attachments=['SET_SILENCER','SET_LASERPOINTER'])
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="name", value=globaltext.SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="hint", value=globaltext.SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="resource3d", value='RES3D_STEYR_TMP_W_SILENCER_W_LASERPOINTER')
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="value", value=18.00)
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_steyr_tmp_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_STEYR_TMP_W_SILENCER_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_STEYR_TMP','SET_LASERPOINTER','SET_SILENCER','SET_DUCT_TAPE'],
								['SET_STEYR_TMP_W_SILENCER','SET_LASERPOINTER','SET_DUCT_TAPE'],
								['SET_STEYR_TMP_W_LASERPOINTER','SET_SILENCER']]})

create_weapon_type(typeid='SET_AKSU74')
objects.set_attribute(object='SET_AKSU74', attribute="name", value=globaltext.SET_AKSU74_NAME)
objects.set_attribute(object='SET_AKSU74', attribute="hint", value=globaltext.SET_AKSU74_HINT)
objects.set_attribute(object='SET_AKSU74', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AKSU74')
objects.set_attribute(object='SET_AKSU74', attribute="resource3d", value='RES3D_AKSU74')
objects.set_attribute(object='SET_AKSU74', attribute="value", value=15.00)
objects.set_attribute(object='SET_AKSU74', attribute="weight", value=2.7)
objects.set_attribute(object='SET_AKSU74', attribute="stacking", value=1)
objects.set_attribute(object='SET_AKSU74', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_AKSU74', attribute="maximale_feuerreichweite", value=26)
objects.set_attribute(object='SET_AKSU74', attribute="salvenlaenge", value=4)
objects.set_attribute(object='SET_AKSU74', attribute="feuergeschwindigkeit", value=700.00)
objects.set_attribute(object='SET_AKSU74', attribute="genauigkeit", value=0.5)
objects.set_attribute(object='SET_AKSU74', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_AKSU74', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_AKSU74', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_AKSU74', attribute="munitionsarten", value=['SET_AMMOPACK_5_45_MM'])
objects.set_attribute(object='SET_AKSU74', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_AKSU74', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_AKSU74', attribute="magazingroesse", 				value=30.0)
objects.set_attribute(object='SET_AKSU74', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_AKSU74', attribute="schusspausenzeit", 				value=1.2)
objects.set_attribute(object='SET_AKSU74', attribute="genauigkeit_bewegte_ziele",		value=0.4)
objects.set_attribute(object='SET_AKSU74', attribute="blockadewahrscheinlichkeit",	value=7.0)
objects.set_attribute(object='SET_AKSU74', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_AKSU74', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 4, 
		"ButtOn"	: 'RES_ITEM65X32_WEAPON_AKSU74_X'
		})
objects.set_attribute(object='SET_AKSU74', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_AKSU74', attribute="effects", value={
		"sound_shot"	: "burst_aksu74",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_AKSU74_W_LASERPOINTER')
clone_weapon_type(typeid='SET_AKSU74', new_typeid='SET_AKSU74_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
objects.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="name", value=globaltext.SET_AKSU74_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="hint", value=globaltext.SET_AKSU74_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="resource3d", value='RES3D_AKSU74_W_LASERPOINTER')
objects.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="value", value=18.00)
objects.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_aksu74",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_AKSU74_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_AKSU74','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_P90_SMG')
objects.set_attribute(object='SET_P90_SMG', attribute="name", value=globaltext.SET_P90_SMG_NAME)
objects.set_attribute(object='SET_P90_SMG', attribute="hint", value=globaltext.SET_P90_SMG_HINT)
objects.set_attribute(object='SET_P90_SMG', attribute="resourceui", value='RES_ITEM65X32_WEAPON_P90_SMG')
objects.set_attribute(object='SET_P90_SMG', attribute="resource3d", value='RES3D_P90_SMG')
objects.set_attribute(object='SET_P90_SMG', attribute="value", value=12.00)
objects.set_attribute(object='SET_P90_SMG', attribute="weight", value=2.5)
objects.set_attribute(object='SET_P90_SMG', attribute="stacking", value=1)
objects.set_attribute(object='SET_P90_SMG', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_P90_SMG', attribute="maximale_feuerreichweite", value=26)
objects.set_attribute(object='SET_P90_SMG', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_P90_SMG', attribute="feuergeschwindigkeit", value=900.00)
objects.set_attribute(object='SET_P90_SMG', attribute="genauigkeit", value=1.00)
objects.set_attribute(object='SET_P90_SMG', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_P90_SMG', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_P90_SMG', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_P90_SMG', attribute="munitionsarten", value=['SET_AMMOPACK_5_7_MM','SET_AMMOPACK_5_7_MM_DUMDUM','SET_AMMOPACK_5_7_MM_SUBSONIC'])# ,'SET_AMMOPACK_5_7_MM_SUBSONIC_DUMDUM'
objects.set_attribute(object='SET_P90_SMG', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
objects.set_attribute(object='SET_P90_SMG', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_P90_SMG', attribute="magazingroesse", 				value=50.0)
objects.set_attribute(object='SET_P90_SMG', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_P90_SMG', attribute="schusspausenzeit", 			value=0.7)
objects.set_attribute(object='SET_P90_SMG', attribute="genauigkeit_bewegte_ziele",	value=0.9)
objects.set_attribute(object='SET_P90_SMG', attribute="blockadewahrscheinlichkeit",	value=20.0)
objects.set_attribute(object='SET_P90_SMG', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_P90_SMG', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 3
		})
objects.set_attribute(object='SET_P90_SMG', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_P90_SMG', attribute="effects", value={
		"sound_shot"	: "burst_p90_smg",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_P90_SMG_W_SILENCER')
clone_weapon_type(typeid='SET_P90_SMG', new_typeid='SET_P90_SMG_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="name", value=globaltext.SET_P90_SMG_W_SILENCER_NAME)
objects.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="hint", value=globaltext.SET_P90_SMG_W_SILENCER_HINT)
objects.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="resource3d", value='RES3D_P90_SMG_W_SILENCER')
objects.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="value", value=17.00)
objects.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "burst_p90_smg_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_P90_SMG_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_P90_SMG','SET_SILENCER']]})

create_weapon_type(typeid='SET_P90_SMG_W_LASERPOINTER')
clone_weapon_type(typeid='SET_P90_SMG', new_typeid='SET_P90_SMG_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
objects.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="name", value=globaltext.SET_P90_SMG_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="hint", value=globaltext.SET_P90_SMG_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="resource3d", value='RES3D_P90_SMG_W_LASERPOINTER')
objects.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="value", value=15.00)
objects.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_p90_smg",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 0,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_P90_SMG_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_P90_SMG','SET_LASERPOINTER','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_P90_SMG_W_SILENCER_W_LASERPOINTER')
clone_weapon_type(typeid='SET_P90_SMG', new_typeid='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attachments=['SET_SILENCER','SET_LASERPOINTER'])
objects.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="name", value=globaltext.SET_P90_SMG_W_SILENCER_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="hint", value=globaltext.SET_P90_SMG_W_SILENCER_W_LASERPOINTER_HINT)
objects.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="resource3d", value='RES3D_P90_SMG_W_SILENCER_W_LASERPOINTER')
objects.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="value", value=20.00)
objects.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="effects", value={
		"sound_shot"	: "burst_p90_smg_silenced",
		"sound_unload"	: "smg_discharge",
		"sound_gunjam"	: "smg_gunjam",
		"sound_reload"	: "smg_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_P90_SMG_W_SILENCER_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_P90_SMG','SET_LASERPOINTER','SET_SILENCER','SET_DUCT_TAPE'],
								['SET_P90_SMG_W_SILENCER','SET_LASERPOINTER','SET_DUCT_TAPE'],
								['SET_P90_SMG_W_LASERPOINTER','SET_SILENCER']]})

create_weapon_type(typeid='SET_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_BROWNING_B_SS_DOUBLE_BARREL_NAME)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_BROWNING_B_SS_DOUBLE_BARREL_HINT)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=13.00)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=3.2)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="stacking", value=1)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="maximale_feuerreichweite", value=17)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="genauigkeit", value=1.1)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="munitionsarten", value=['SET_AMMOPACK_2_12_MM','SET_AMMOPACK_2_12_MM_QB_8'])
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="magazingroesse", 				value=2.0)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="schusspausenzeit", 			value=2.0)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="genauigkeit_bewegte_ziele",	value=1.0)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
		"sound_shot"	: "shot_browning_double_barrel",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 4,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_BROWNING_B_SS_DOUBLE_BARREL', new_typeid='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=12.00)
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=3.0)
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="combine_xp", value=25)
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
		"sound_shot"	: "shot_browning_double_barrel",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 4,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})
objects.set_attribute(object='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",	value={
	"difficulty_assemble"	:	55,
	"assemble_function"		:	"assemble_weapon_sawed_off",
	"combination_list"		:	[
								['SET_BROWNING_B_SS_DOUBLE_BARREL','SET_HACKSAW']]})

create_weapon_type(typeid='SET_REMINGTON_M870')
objects.set_attribute(object='SET_REMINGTON_M870', attribute="name", value=globaltext.SET_REMINGTON_M870_NAME)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="hint", value=globaltext.SET_REMINGTON_M870_HINT)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_REMINGTON_M870')
objects.set_attribute(object='SET_REMINGTON_M870', attribute="resource3d", value='RES3D_REMINGTON_M870')
objects.set_attribute(object='SET_REMINGTON_M870', attribute="value", value=15.00)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="weight", value=4.1)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="stacking", value=1)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="maximale_feuerreichweite", value=20)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="genauigkeit", value=1.3)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="munitionsarten", value=['SET_AMMOPACK_2_12_MM','SET_AMMOPACK_2_12_MM_QB_8'])
objects.set_attribute(object='SET_REMINGTON_M870', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_REMINGTON_M870', attribute="magazingroesse", 				value=7.0)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="schusspausenzeit", 				value=1.8)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="genauigkeit_bewegte_ziele",		value=0.7)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="blockadewahrscheinlichkeit",	value=10.0)
objects.set_attribute(object='SET_REMINGTON_M870', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_REMINGTON_M870', attribute="effects", value={
		"sound_shot"	: "shot_remington_m870",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 3,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_REMINGTON_M870', new_typeid='SET_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_SAWED_OFF_REMINGTON_M870_NAME)
objects.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_SAWED_OFF_REMINGTON_M870_NAME)
objects.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="value", value=14.00)
objects.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="weight", value=3.8)
objects.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="combine_xp", value=25)
objects.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
		"sound_shot"	: "shot_remington_m870",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 3,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})
objects.set_attribute(object='SET_SAWED_OFF_REMINGTON_M870', attribute="item_combination",	value={
	"difficulty_assemble"	:	55,
	"assemble_function"		:	"assemble_weapon_sawed_off",
	"combination_list"		:	[
								['SET_REMINGTON_M870','SET_HACKSAW']]})

create_weapon_type(typeid='SET_SPAS_15')
objects.set_attribute(object='SET_SPAS_15', attribute="name", value=globaltext.SET_SPAS_15_NAME)
objects.set_attribute(object='SET_SPAS_15', attribute="hint", value=globaltext.SET_SPAS_15_HINT)
objects.set_attribute(object='SET_SPAS_15', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SPAS_15')
objects.set_attribute(object='SET_SPAS_15', attribute="resource3d", value='RES3D_SPAS_15')
objects.set_attribute(object='SET_SPAS_15', attribute="value", value=25.00)
objects.set_attribute(object='SET_SPAS_15', attribute="weight", value=4.3)
objects.set_attribute(object='SET_SPAS_15', attribute="stacking", value=1)
objects.set_attribute(object='SET_SPAS_15', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_SPAS_15', attribute="maximale_feuerreichweite", value=21)
objects.set_attribute(object='SET_SPAS_15', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_SPAS_15', attribute="feuergeschwindigkeit", value=450.00)
objects.set_attribute(object='SET_SPAS_15', attribute="genauigkeit", value=1.1)
objects.set_attribute(object='SET_SPAS_15', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_SPAS_15', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_SPAS_15', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_SPAS_15', attribute="munitionsarten", value=['SET_AMMOPACK_2_12_MM','SET_AMMOPACK_2_12_MM_QB_8'])
objects.set_attribute(object='SET_SPAS_15', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_SPAS_15', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_SPAS_15', attribute="magazingroesse", 				value=6.0)
objects.set_attribute(object='SET_SPAS_15', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_SPAS_15', attribute="schusspausenzeit", 			value=1.7)
objects.set_attribute(object='SET_SPAS_15', attribute="genauigkeit_bewegte_ziele",	value=0.8)
objects.set_attribute(object='SET_SPAS_15', attribute="blockadewahrscheinlichkeit",	value=15.0)
objects.set_attribute(object='SET_SPAS_15', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_SPAS_15', attribute="effects", value={
		"sound_shot"	: "burst_hk_caws", #"shot_spas_15",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 3,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_HK_CAWS')
objects.set_attribute(object='SET_HK_CAWS', attribute="name", value=globaltext.SET_HK_CAWS_NAME)
objects.set_attribute(object='SET_HK_CAWS', attribute="hint", value=globaltext.SET_HK_CAWS_HINT)
objects.set_attribute(object='SET_HK_CAWS', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_CAWS')
objects.set_attribute(object='SET_HK_CAWS', attribute="resource3d", value='RES3D_HK_CAWS')
objects.set_attribute(object='SET_HK_CAWS', attribute="value", value=35.00)
objects.set_attribute(object='SET_HK_CAWS', attribute="weight", value=4.0)
objects.set_attribute(object='SET_HK_CAWS', attribute="stacking", value=1)
objects.set_attribute(object='SET_HK_CAWS', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_HK_CAWS', attribute="maximale_feuerreichweite", value=26)
objects.set_attribute(object='SET_HK_CAWS', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_HK_CAWS', attribute="feuergeschwindigkeit", value=600.00)
objects.set_attribute(object='SET_HK_CAWS', attribute="genauigkeit", value=1.2)
objects.set_attribute(object='SET_HK_CAWS', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_HK_CAWS', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_HK_CAWS', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_HK_CAWS', attribute="munitionsarten", value=['SET_AMMOPACK_3_12_MM','SET_AMMOPACK_3_12_MM_QB_8'])
objects.set_attribute(object='SET_HK_CAWS', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_HK_CAWS', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_HK_CAWS', attribute="magazingroesse", 				value=10.0)
objects.set_attribute(object='SET_HK_CAWS', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_HK_CAWS', attribute="schusspausenzeit", 			value=1.5)
objects.set_attribute(object='SET_HK_CAWS', attribute="genauigkeit_bewegte_ziele",	value=1.0)
objects.set_attribute(object='SET_HK_CAWS', attribute="blockadewahrscheinlichkeit",	value=15.0)
objects.set_attribute(object='SET_HK_CAWS', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_HK_CAWS', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 3
		})
objects.set_attribute(object='SET_HK_CAWS', attribute="Current_Fire_Mode", value="Auto" )
objects.set_attribute(object='SET_HK_CAWS', attribute="effects", value={
		"sound_shot"	: "burst_hk_caws",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 3,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_LASER_GUN')
objects.set_attribute(object='SET_LASER_GUN', attribute="name", value=globaltext.SET_LASER_GUN_NAME)
objects.set_attribute(object='SET_LASER_GUN', attribute="hint", value=globaltext.SET_LASER_GUN_HINT)
objects.set_attribute(object='SET_LASER_GUN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_LASER_GUN')
objects.set_attribute(object='SET_LASER_GUN', attribute="resource3d", value='RES3D_LASER_GUN')
objects.set_attribute(object='SET_LASER_GUN', attribute="value", value=50.0)
objects.set_attribute(object='SET_LASER_GUN', attribute="weight", value=10.0) ## !! >>
objects.set_attribute(object='SET_LASER_GUN', attribute="stacking", value=1)
objects.set_attribute(object='SET_LASER_GUN', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_LASER_GUN', attribute="maximale_feuerreichweite", value=35)
objects.set_attribute(object='SET_LASER_GUN', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_LASER_GUN', attribute="feuergeschwindigkeit", value=180.00)
objects.set_attribute(object='SET_LASER_GUN', attribute="genauigkeit", value=2.00)
objects.set_attribute(object='SET_LASER_GUN', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_LASER_GUN', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_LASER_GUN', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_LASER_GUN', attribute="munitionsarten", value=['SET_AMMOPACK_LASER_GUN'])
objects.set_attribute(object='SET_LASER_GUN', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_LASER_GUN', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_LASER_GUN', attribute="magazingroesse", 			value=20.0)
objects.set_attribute(object='SET_LASER_GUN', attribute="hoerweite", 					value=25.0)
objects.set_attribute(object='SET_LASER_GUN', attribute="schusspausenzeit", 			value=1.0)
objects.set_attribute(object='SET_LASER_GUN', attribute="genauigkeit_bewegte_ziele",	value=1.0)
objects.set_attribute(object='SET_LASER_GUN', attribute="blockadewahrscheinlichkeit",	value=0.0)
objects.set_attribute(object='SET_LASER_GUN', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_LASER_GUN', attribute="not_tradable", value=True)
objects.set_attribute(object='SET_LASER_GUN', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Cutoff"	: 2,
		"Auto"		: 3
		})
objects.set_attribute(object='SET_LASER_GUN', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_LASER_GUN', attribute="effects", value={
		"sound_shot"	: "burst_lasergun",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 7,
		"flash_size"	: 0.3,
		"stream_type"	: 2,
		"stream_size"	: 0.2,
		"fade_out"		: 50})

#todo: waffeneffekte
create_weapon_type(typeid='SET_PAINTBALL_GUN')
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="name", value=globaltext.SET_PAINTBALL_GUN_NAME)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="hint", value=globaltext.SET_PAINTBALL_GUN_HINT)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_PAINTBALL_GUN')
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="resource3d", value='RES3D_PAINTBALL_GUN')
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="value", value=3.00)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="weight", value=0.95)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="stacking", value=1)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="maximale_feuerreichweite", value=13)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="genauigkeit", value=1.00)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="munitionsarten", value=['SET_PAINTBALL_GUN_AMMOPACK'])
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="magazingroesse", 				value=15.0)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="schusspausenzeit", 			value=0.7)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_PAINTBALL_GUN', attribute="not_tradable", value=True)

#todo: waffeneffekte
create_weapon_type(typeid='SET_POTATO_GUN')
objects.set_attribute(object='SET_POTATO_GUN', attribute="name", value=globaltext.SET_POTATO_GUN_NAME)
objects.set_attribute(object='SET_POTATO_GUN', attribute="hint", value=globaltext.SET_POTATO_GUN_HINT)
objects.set_attribute(object='SET_POTATO_GUN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_POTATO_GUN')
objects.set_attribute(object='SET_POTATO_GUN', attribute="resource3d", value='RES3D_POTATO_GUN')
objects.set_attribute(object='SET_POTATO_GUN', attribute="value", value=20.00)
objects.set_attribute(object='SET_POTATO_GUN', attribute="weight", value=0.95)
objects.set_attribute(object='SET_POTATO_GUN', attribute="stacking", value=1)
objects.set_attribute(object='SET_POTATO_GUN', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_POTATO_GUN', attribute="maximale_feuerreichweite", value=13)
objects.set_attribute(object='SET_POTATO_GUN', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_POTATO_GUN', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_POTATO_GUN', attribute="genauigkeit", value=1.00)
objects.set_attribute(object='SET_POTATO_GUN', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_POTATO_GUN', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_POTATO_GUN', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_POTATO_GUN', attribute="munitionsarten", value=['SET_POTATO'])
objects.set_attribute(object='SET_POTATO_GUN', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_POTATO_GUN', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_POTATO_GUN', attribute="magazingroesse", 				value=15.0)
objects.set_attribute(object='SET_POTATO_GUN', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_POTATO_GUN', attribute="schusspausenzeit", 			value=0.7)
objects.set_attribute(object='SET_POTATO_GUN', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_POTATO_GUN', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_POTATO_GUN', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_POTATO_GUN', attribute="not_tradable", value=True)
objects.set_attribute(object='SET_POTATO_GUN', attribute="combine_xp", value=100)
objects.set_attribute(object='SET_POTATO_GUN', attribute="item_combination",	value={
	"difficulty_assemble"	:	65,
	"combination_list"		:	[
								['SET_CAR_EXHAUST_PIPE','SET_WATERTIGHT_RING','SET_HAIR_SPRAY','SET_LIGHTER']]})
objects.set_attribute(object='SET_POTATO_GUN', attribute="effects", value={
		"sound_shot"	: "shot_special_38",
		"sound_unload"	: "revolver_discharge",
		"sound_gunjam"	: "revolver_gunjam",
		"sound_reload"	: "revolver_charge",
		"flash_type"	: 5,
		"flash_size"	: 0.2,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_LW_HAMMER')
objects.set_attribute(object='SET_LW_HAMMER', attribute="name", value=globaltext.SET_LW_HAMMER_NAME)
objects.set_attribute(object='SET_LW_HAMMER', attribute="hint", value=globaltext.SET_LW_HAMMER_HINT)
objects.set_attribute(object='SET_LW_HAMMER', attribute="resourceui", value='RES_ITEM65X32_WEAPON_LW_HAMMER')
objects.set_attribute(object='SET_LW_HAMMER', attribute="resource3d", value='RES3D_LW_HAMMER')
objects.set_attribute(object='SET_LW_HAMMER', attribute="value", value=50.00)
objects.set_attribute(object='SET_LW_HAMMER', attribute="weight", value=3.5)
objects.set_attribute(object='SET_LW_HAMMER', attribute="stacking", value=1)
objects.set_attribute(object='SET_LW_HAMMER', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_LW_HAMMER', attribute="maximale_feuerreichweite", value=18)
objects.set_attribute(object='SET_LW_HAMMER', attribute="salvenlaenge", value=10)
objects.set_attribute(object='SET_LW_HAMMER', attribute="feuergeschwindigkeit", value=400.00)
objects.set_attribute(object='SET_LW_HAMMER', attribute="genauigkeit", value=1.0)
objects.set_attribute(object='SET_LW_HAMMER', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_LW_HAMMER', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_LW_HAMMER', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_LW_HAMMER', attribute="munitionsarten", value=['SET_AMMOPACK_2_12_MM','SET_AMMOPACK_2_12_MM_QB_8'])
objects.set_attribute(object='SET_LW_HAMMER', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_LW_HAMMER', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_LW_HAMMER', attribute="magazingroesse", 				value=10.0)
objects.set_attribute(object='SET_LW_HAMMER', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_LW_HAMMER', attribute="schusspausenzeit", 			value=1.5)
objects.set_attribute(object='SET_LW_HAMMER', attribute="genauigkeit_bewegte_ziele",	value=0.9)
objects.set_attribute(object='SET_LW_HAMMER', attribute="blockadewahrscheinlichkeit",	value=10.0)
objects.set_attribute(object='SET_LW_HAMMER', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_LW_HAMMER', attribute="not_tradable", value=True)
objects.set_attribute(object='SET_LW_HAMMER', attribute="effects", value={
		"sound_shot"	: "burst_lw_hammer",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 3,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_QUADHAMMER')
objects.set_attribute(object='SET_QUADHAMMER', attribute="name", value=globaltext.SET_QUADHAMMER_NAME)
objects.set_attribute(object='SET_QUADHAMMER', attribute="hint", value=globaltext.SET_QUADHAMMER_HINT)
objects.set_attribute(object='SET_QUADHAMMER', attribute="resourceui", value='RES_ITEM65X32_WEAPON_QUADHAMMER')
objects.set_attribute(object='SET_QUADHAMMER', attribute="resource3d", value='RES3D_QUADHAMMER')
objects.set_attribute(object='SET_QUADHAMMER', attribute="value", value=200.00)
objects.set_attribute(object='SET_QUADHAMMER', attribute="weight", value=5.3)
objects.set_attribute(object='SET_QUADHAMMER', attribute="stacking", value=1)
objects.set_attribute(object='SET_QUADHAMMER', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_QUADHAMMER', attribute="maximale_feuerreichweite", value=20) #30
objects.set_attribute(object='SET_QUADHAMMER', attribute="salvenlaenge", value=20) # 12
objects.set_attribute(object='SET_QUADHAMMER', attribute="feuergeschwindigkeit", value=1000.00)
objects.set_attribute(object='SET_QUADHAMMER', attribute="genauigkeit", value=0.7) #1.5
objects.set_attribute(object='SET_QUADHAMMER', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_QUADHAMMER', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_QUADHAMMER', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_QUADHAMMER', attribute="munitionsarten", value=['SET_AMMOPACK_2_12_MM','SET_AMMOPACK_2_12_MM_QB_8'])
objects.set_attribute(object='SET_QUADHAMMER', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_QUADHAMMER', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_QUADHAMMER', attribute="magazingroesse", 				value=20.0)
objects.set_attribute(object='SET_QUADHAMMER', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_QUADHAMMER', attribute="schusspausenzeit", 			value=1.5)
objects.set_attribute(object='SET_QUADHAMMER', attribute="genauigkeit_bewegte_ziele",	value=0.6) # 1.0
objects.set_attribute(object='SET_QUADHAMMER', attribute="blockadewahrscheinlichkeit",	value=10.0)
objects.set_attribute(object='SET_QUADHAMMER', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_QUADHAMMER', attribute="not_tradable", value=True)
objects.set_attribute(object='SET_QUADHAMMER', attribute="effects", value={
		"sound_shot"	: "burst_quadhammer",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 3,
		"flash_size"	: 1.0,
		"stream_type"	: 1,
		"stream_size"	: 1.0,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_SUPERLW')
objects.set_attribute(object='SET_SUPERLW', attribute="name", value=globaltext.SET_SUPERLW_NAME)
objects.set_attribute(object='SET_SUPERLW', attribute="hint", value=globaltext.SET_SUPERLW_HINT)
objects.set_attribute(object='SET_SUPERLW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SUPERLW')
objects.set_attribute(object='SET_SUPERLW', attribute="resource3d", value='RES3D_SUPERLW')
objects.set_attribute(object='SET_SUPERLW', attribute="value", value=50.00)
objects.set_attribute(object='SET_SUPERLW', attribute="weight", value=5.6)
objects.set_attribute(object='SET_SUPERLW', attribute="stacking", value=1)
objects.set_attribute(object='SET_SUPERLW', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_SUPERLW', attribute="maximale_feuerreichweite", value=25)
objects.set_attribute(object='SET_SUPERLW', attribute="salvenlaenge", value=10)
objects.set_attribute(object='SET_SUPERLW', attribute="feuergeschwindigkeit", value=1000.00)
objects.set_attribute(object='SET_SUPERLW', attribute="genauigkeit", value=0.6)
objects.set_attribute(object='SET_SUPERLW', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_SUPERLW', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_SUPERLW', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_SUPERLW', attribute="munitionsarten", value=['SET_AMMOPACK_45','SET_AMMOPACK_45_DUMDUM','SET_AMMOPACK_45_SUBSONIC','SET_AMMOPACK_45_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_SUPERLW', attribute="fire_animation", value=FPA_PISTOL_VOLLEY)
objects.set_attribute(object='SET_SUPERLW', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_SUPERLW', attribute="magazingroesse", 				value=30.0)
objects.set_attribute(object='SET_SUPERLW', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_SUPERLW', attribute="schusspausenzeit", 			value=1.1)
objects.set_attribute(object='SET_SUPERLW', attribute="genauigkeit_bewegte_ziele",	value=0.4)
objects.set_attribute(object='SET_SUPERLW', attribute="blockadewahrscheinlichkeit",	value=10.0)
objects.set_attribute(object='SET_SUPERLW', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_SUPERLW', attribute="not_tradable", value=True)
objects.set_attribute(object='SET_SUPERLW', attribute="effects", value={
		"sound_shot"	: "burst_superlw",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_SUPERLW_W_LASERPOINTER')
clone_weapon_type(typeid='SET_SUPERLW', new_typeid='SET_SUPERLW_W_LASERPOINTER', attachments=['SET_LASERPOINTER'])
objects.set_attribute(object='SET_SUPERLW_W_LASERPOINTER', attribute="name", value=globaltext.SET_SET_SUPERLW_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_SUPERLW_W_LASERPOINTER', attribute="hint", value=globaltext.SET_SET_SUPERLW_W_LASERPOINTER_NAME)
objects.set_attribute(object='SET_SUPERLW_W_LASERPOINTER', attribute="item_combination",	value={
	"difficulty_assemble"	:	90,
	"difficulty_disassemble":	90,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_SUPERLW','SET_LASERPOINTER']]})

## schwere waffen
create_weapon_type(typeid='SET_SIMONOV_SKS')
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="name", value=globaltext.SET_SIMONOV_SKS_NAME)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="hint", value=globaltext.SET_SIMONOV_SKS_HINT)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SIMONOV_SKS')
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="resource3d", value='RES3D_SIMONOV_SKS')
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="value", value=15.00)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="weight", value=4.0)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="stacking", value=1)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="maximale_feuerreichweite", value=32)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="genauigkeit", value=0.7)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="munitionsarten", value=['SET_AMMOPACK_7_62SOVJET_MM'])
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="magazingroesse", 				value=10.0)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="schusspausenzeit", 			value=2.4)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="genauigkeit_bewegte_ziele",	value=0.5)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="blockadewahrscheinlichkeit",	value=10.0)
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_SIMONOV_SKS', attribute="effects", value={
		"sound_shot"	: "shot_simonov_sks",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_AK_47')
objects.set_attribute(object='SET_AK_47', attribute="name", value=globaltext.SET_AK_47_NAME)
objects.set_attribute(object='SET_AK_47', attribute="hint", value=globaltext.SET_AK_47_HINT)
objects.set_attribute(object='SET_AK_47', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_47')
objects.set_attribute(object='SET_AK_47', attribute="resource3d", value='RES3D_AK_47')
objects.set_attribute(object='SET_AK_47', attribute="value", value=25.00)
objects.set_attribute(object='SET_AK_47', attribute="weight", value=3.9)
objects.set_attribute(object='SET_AK_47', attribute="stacking", value=1)
objects.set_attribute(object='SET_AK_47', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_AK_47', attribute="maximale_feuerreichweite", value=32)
objects.set_attribute(object='SET_AK_47', attribute="salvenlaenge", value=4)
objects.set_attribute(object='SET_AK_47', attribute="feuergeschwindigkeit", value=600.00)
objects.set_attribute(object='SET_AK_47', attribute="genauigkeit", value=1.0)
objects.set_attribute(object='SET_AK_47', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_AK_47', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_AK_47', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_AK_47', attribute="munitionsarten", value=['SET_AMMOPACK_7_62SOVJET_MM'])
objects.set_attribute(object='SET_AK_47', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_AK_47', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_AK_47', attribute="magazingroesse", 			value=30.0)
objects.set_attribute(object='SET_AK_47', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_AK_47', attribute="schusspausenzeit", 			value=1.8)
objects.set_attribute(object='SET_AK_47', attribute="genauigkeit_bewegte_ziele",	value=0.5)
objects.set_attribute(object='SET_AK_47', attribute="blockadewahrscheinlichkeit",	value=7.0)
objects.set_attribute(object='SET_AK_47', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_AK_47', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 4
		})
objects.set_attribute(object='SET_AK_47', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_AK_47', attribute="effects", value={
		"sound_shot"	: "burst_ak_47",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_AK_74')
objects.set_attribute(object='SET_AK_74', attribute="name", value=globaltext.SET_AK_74_NAME)
objects.set_attribute(object='SET_AK_74', attribute="hint", value=globaltext.SET_AK_74_HINT)
objects.set_attribute(object='SET_AK_74', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_74')
objects.set_attribute(object='SET_AK_74', attribute="resource3d", value='RES3D_AK_74')
objects.set_attribute(object='SET_AK_74', attribute="value", value=25.00)
objects.set_attribute(object='SET_AK_74', attribute="weight", value=4.3)
objects.set_attribute(object='SET_AK_74', attribute="stacking", value=1)
objects.set_attribute(object='SET_AK_74', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_AK_74', attribute="maximale_feuerreichweite", value=36)
objects.set_attribute(object='SET_AK_74', attribute="salvenlaenge", value=4)
objects.set_attribute(object='SET_AK_74', attribute="feuergeschwindigkeit", value=620.00)
objects.set_attribute(object='SET_AK_74', attribute="genauigkeit", value=1.3)
objects.set_attribute(object='SET_AK_74', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_AK_74', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_AK_74', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_AK_74', attribute="munitionsarten", value=['SET_AMMOPACK_5_45_MM'])
objects.set_attribute(object='SET_AK_74', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_AK_74', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_AK_74', attribute="magazingroesse", 				value=30.0)
objects.set_attribute(object='SET_AK_74', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_AK_74', attribute="schusspausenzeit", 			value=2.0)
objects.set_attribute(object='SET_AK_74', attribute="genauigkeit_bewegte_ziele",	value=0.6)
objects.set_attribute(object='SET_AK_74', attribute="blockadewahrscheinlichkeit",	value=10.0)
objects.set_attribute(object='SET_AK_74', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_AK_74', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 4, 
		"ButtOff"	: "RES_ITEM65X32_WEAPON_AK_74_X"
		})
objects.set_attribute(object='SET_AK_74', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_AK_74', attribute="effects", value={
		"sound_shot"	: "burst_ak_74",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_M_16')
objects.set_attribute(object='SET_M_16', attribute="name", value=globaltext.SET_M_16_NAME)
objects.set_attribute(object='SET_M_16', attribute="hint", value=globaltext.SET_M_16_HINT)
objects.set_attribute(object='SET_M_16', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_16')
objects.set_attribute(object='SET_M_16', attribute="resource3d", value='RES3D_M_16')
objects.set_attribute(object='SET_M_16', attribute="value", value=25.00)
objects.set_attribute(object='SET_M_16', attribute="weight", value=3.0)
objects.set_attribute(object='SET_M_16', attribute="stacking", value=1)
objects.set_attribute(object='SET_M_16', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_M_16', attribute="maximale_feuerreichweite", value=36)
objects.set_attribute(object='SET_M_16', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_M_16', attribute="feuergeschwindigkeit", value=800.0)
objects.set_attribute(object='SET_M_16', attribute="genauigkeit", value=1.2)
objects.set_attribute(object='SET_M_16', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_M_16', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_M_16', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_M_16', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
objects.set_attribute(object='SET_M_16', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_M_16', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_M_16', attribute="magazingroesse", 		value=30.0)
objects.set_attribute(object='SET_M_16', attribute="hoerweite", 			value=40.0)
objects.set_attribute(object='SET_M_16', attribute="schusspausenzeit", 		value=2.1)
objects.set_attribute(object='SET_M_16', attribute="genauigkeit_bewegte_ziele",	value=0.5)
objects.set_attribute(object='SET_M_16', attribute="blockadewahrscheinlichkeit",	value=18.0)
objects.set_attribute(object='SET_M_16', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_M_16', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 3,
		"ButtOn"	: "RES_ITEM65X32_WEAPON_M_16_X"
		})
objects.set_attribute(object='SET_M_16', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_M_16', attribute="effects", value={
		"sound_shot"	: "burst_m4a1",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_CALICO_M900')
objects.set_attribute(object='SET_CALICO_M900', attribute="name", value=globaltext.SET_CALICO_M900_NAME)
objects.set_attribute(object='SET_CALICO_M900', attribute="hint", value=globaltext.SET_CALICO_M900_HINT)
objects.set_attribute(object='SET_CALICO_M900', attribute="resourceui", value='RES_ITEM65X32_WEAPON_CALICO_M900')
objects.set_attribute(object='SET_CALICO_M900', attribute="resource3d", value='RES3D_CALICO_M900')
objects.set_attribute(object='SET_CALICO_M900', attribute="value", value=25.00)
objects.set_attribute(object='SET_CALICO_M900', attribute="weight", value=4.5)
objects.set_attribute(object='SET_CALICO_M900', attribute="stacking", value=1)
objects.set_attribute(object='SET_CALICO_M900', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_CALICO_M900', attribute="maximale_feuerreichweite", value=33)
objects.set_attribute(object='SET_CALICO_M900', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_CALICO_M900', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_CALICO_M900', attribute="genauigkeit", value=0.4)
objects.set_attribute(object='SET_CALICO_M900', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_CALICO_M900', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_CALICO_M900', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_CALICO_M900', attribute="munitionsarten", value=['SET_AMMOPACK_9_MM','SET_AMMOPACK_9_MM_DUMDUM','SET_AMMOPACK_9_MM_SUBSONIC','SET_AMMOPACK_9_MM_SUBSONIC_DUMDUM'])
objects.set_attribute(object='SET_CALICO_M900', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_CALICO_M900', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_CALICO_M900', attribute="magazingroesse", 				value=50.0)
objects.set_attribute(object='SET_CALICO_M900', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_CALICO_M900', attribute="schusspausenzeit", 			value=1.7)
objects.set_attribute(object='SET_CALICO_M900', attribute="genauigkeit_bewegte_ziele",	value=0.5)
objects.set_attribute(object='SET_CALICO_M900', attribute="blockadewahrscheinlichkeit",	value=15.0)
objects.set_attribute(object='SET_CALICO_M900', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_CALICO_M900', attribute="effects", value={
		"sound_shot"	: "shot_calico_m900",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.4,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_CALICO_M900_W_SILENCER')
clone_weapon_type(typeid='SET_CALICO_M900', new_typeid='SET_CALICO_M900_W_SILENCER', attachments=['SET_SILENCER'])
objects.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="name", value=globaltext.SET_CALICO_M900_W_SILENCER_NAME)
objects.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="hint", value=globaltext.SET_CALICO_M900_W_SILENCER_HINT)
objects.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="resource3d", value='RES3D_CALICO_M900_W_SILENCER')
objects.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="value", value=30.00)
objects.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="effects", value={
		"sound_shot"	: "shot_calico_m900_silenced",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.3,
		"stream_type"	: 1,
		"stream_size"	: 0.4,
		"fade_out"		: 50})
objects.set_attribute(object='SET_CALICO_M900_W_SILENCER', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"difficulty_disassemble":	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_weapon_silencer_laserpointer",
	"disassemble_function"	:	"disassemble_weapon_silencer_laserpointer",
	"combination_list"		:	[
								['SET_CALICO_M900','SET_SILENCER']]})

create_weapon_type(typeid='SET_SA_80')
objects.set_attribute(object='SET_SA_80', attribute="name", value=globaltext.SET_SA_80_NAME)
objects.set_attribute(object='SET_SA_80', attribute="hint", value=globaltext.SET_SA_80_HINT)
objects.set_attribute(object='SET_SA_80', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SA_80')
objects.set_attribute(object='SET_SA_80', attribute="resource3d", value='RES3D_SA_80')
objects.set_attribute(object='SET_SA_80', attribute="value", value=28.00)
objects.set_attribute(object='SET_SA_80', attribute="weight", value=5.0)
objects.set_attribute(object='SET_SA_80', attribute="stacking", value=1)
objects.set_attribute(object='SET_SA_80', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_SA_80', attribute="maximale_feuerreichweite", value=38)
objects.set_attribute(object='SET_SA_80', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_SA_80', attribute="feuergeschwindigkeit", value=650.00)
objects.set_attribute(object='SET_SA_80', attribute="genauigkeit", value=1.5)
objects.set_attribute(object='SET_SA_80', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_SA_80', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_SA_80', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_SA_80', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
objects.set_attribute(object='SET_SA_80', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_SA_80', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_SA_80', attribute="magazingroesse", 			value=30.0)
objects.set_attribute(object='SET_SA_80', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_SA_80', attribute="schusspausenzeit", 			value=1.6)
objects.set_attribute(object='SET_SA_80', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_SA_80', attribute="blockadewahrscheinlichkeit",	value=23.0)
objects.set_attribute(object='SET_SA_80', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_SA_80', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 3
		})
objects.set_attribute(object='SET_SA_80', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_SA_80', attribute="effects", value={
		"sound_shot"	: "burst_sa_80",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_FAMAS')
objects.set_attribute(object='SET_FAMAS', attribute="name", value=globaltext.SET_FAMAS_NAME)
objects.set_attribute(object='SET_FAMAS', attribute="hint", value=globaltext.SET_FAMAS_HINT)
objects.set_attribute(object='SET_FAMAS', attribute="resourceui", value='RES_ITEM65X32_WEAPON_FAMAS')
objects.set_attribute(object='SET_FAMAS', attribute="resource3d", value='RES3D_FAMAS')
objects.set_attribute(object='SET_FAMAS', attribute="value", value=27.00)
objects.set_attribute(object='SET_FAMAS', attribute="weight", value=4.0)
objects.set_attribute(object='SET_FAMAS', attribute="stacking", value=1)
objects.set_attribute(object='SET_FAMAS', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_FAMAS', attribute="maximale_feuerreichweite", value=34)
objects.set_attribute(object='SET_FAMAS', attribute="salvenlaenge", value=5)
objects.set_attribute(object='SET_FAMAS', attribute="feuergeschwindigkeit", value=1000.00)
objects.set_attribute(object='SET_FAMAS', attribute="genauigkeit", value=1.5)
objects.set_attribute(object='SET_FAMAS', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_FAMAS', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_FAMAS', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_FAMAS', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
objects.set_attribute(object='SET_FAMAS', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_FAMAS', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_FAMAS', attribute="magazingroesse", 			value=30.0)
objects.set_attribute(object='SET_FAMAS', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_FAMAS', attribute="schusspausenzeit", 			value=1.8)
objects.set_attribute(object='SET_FAMAS', attribute="genauigkeit_bewegte_ziele",	value=0.6)
objects.set_attribute(object='SET_FAMAS', attribute="blockadewahrscheinlichkeit",	value=17.0)
objects.set_attribute(object='SET_FAMAS', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_FAMAS', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Cutoff"	: 2,
		"Auto"		: 5
		})
objects.set_attribute(object='SET_FAMAS', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_FAMAS', attribute="effects", value={
		"sound_shot"	: "burst_famas",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_HK_G36C')
objects.set_attribute(object='SET_HK_G36C', attribute="name", value=globaltext.SET_HK_G36C_NAME)
objects.set_attribute(object='SET_HK_G36C', attribute="hint", value=globaltext.SET_HK_G36C_HINT)
objects.set_attribute(object='SET_HK_G36C', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G36C')
objects.set_attribute(object='SET_HK_G36C', attribute="resource3d", value='RES3D_HK_G36C')
objects.set_attribute(object='SET_HK_G36C', attribute="value", value=40.00)
objects.set_attribute(object='SET_HK_G36C', attribute="weight", value=3.4)
objects.set_attribute(object='SET_HK_G36C', attribute="stacking", value=1)
objects.set_attribute(object='SET_HK_G36C', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_HK_G36C', attribute="maximale_feuerreichweite", value=37)
objects.set_attribute(object='SET_HK_G36C', attribute="salvenlaenge", value=4)
objects.set_attribute(object='SET_HK_G36C', attribute="feuergeschwindigkeit", value=750.00)
objects.set_attribute(object='SET_HK_G36C', attribute="genauigkeit", value=2.0)
objects.set_attribute(object='SET_HK_G36C', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_HK_G36C', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_HK_G36C', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_HK_G36C', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
objects.set_attribute(object='SET_HK_G36C', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_HK_G36C', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_HK_G36C', attribute="magazingroesse", 				value=30.0)
objects.set_attribute(object='SET_HK_G36C', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_HK_G36C', attribute="schusspausenzeit", 			value=1.4)
objects.set_attribute(object='SET_HK_G36C', attribute="genauigkeit_bewegte_ziele",	value=0.8)
objects.set_attribute(object='SET_HK_G36C', attribute="blockadewahrscheinlichkeit",	value=15.0)
objects.set_attribute(object='SET_HK_G36C', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_HK_G36C', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Cutoff"	: 2,
		"Auto"		: 4,
		"ButtOff"	: "RES_ITEM65X32_WEAPON_HK_G36C_X"
		})
objects.set_attribute(object='SET_HK_G36C', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_HK_G36C', attribute="effects", value={
		"sound_shot"	: "burst_hk_g36c",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_HK_G41')
objects.set_attribute(object='SET_HK_G41', attribute="name", value=globaltext.SET_HK_G41_NAME)
objects.set_attribute(object='SET_HK_G41', attribute="hint", value=globaltext.SET_HK_G41_HINT)
objects.set_attribute(object='SET_HK_G41', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G41')
objects.set_attribute(object='SET_HK_G41', attribute="resource3d", value='RES3D_HK_G41')
objects.set_attribute(object='SET_HK_G41', attribute="value", value=30.00)
objects.set_attribute(object='SET_HK_G41', attribute="weight", value=4.1)
objects.set_attribute(object='SET_HK_G41', attribute="stacking", value=1)
objects.set_attribute(object='SET_HK_G41', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_HK_G41', attribute="maximale_feuerreichweite", value=34)
objects.set_attribute(object='SET_HK_G41', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_HK_G41', attribute="feuergeschwindigkeit", value=600.00)
objects.set_attribute(object='SET_HK_G41', attribute="genauigkeit", value=1.7)
objects.set_attribute(object='SET_HK_G41', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_HK_G41', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_HK_G41', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_HK_G41', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
objects.set_attribute(object='SET_HK_G41', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_HK_G41', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_HK_G41', attribute="magazingroesse", 				value=30.0)
objects.set_attribute(object='SET_HK_G41', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_HK_G41', attribute="schusspausenzeit", 				value=1.9)
objects.set_attribute(object='SET_HK_G41', attribute="genauigkeit_bewegte_ziele",		value=0.6)
objects.set_attribute(object='SET_HK_G41', attribute="blockadewahrscheinlichkeit",	value=17.0)
objects.set_attribute(object='SET_HK_G41', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_HK_G41', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Cutoff"	: 2,
		"Auto"		: 3,
		"ButtOn"	: "RES_ITEM65X32_WEAPON_HK_G41_X"
		})
objects.set_attribute(object='SET_HK_G41', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_HK_G41', attribute="effects", value={
		"sound_shot"	: "burst_hk_g41",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_SIG_SG_552')
objects.set_attribute(object='SET_SIG_SG_552', attribute="name", value=globaltext.SET_SIG_SG_552_NAME)
objects.set_attribute(object='SET_SIG_SG_552', attribute="hint", value=globaltext.SET_SIG_SG_552_HINT)
objects.set_attribute(object='SET_SIG_SG_552', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SIG_SG_552')
objects.set_attribute(object='SET_SIG_SG_552', attribute="resource3d", value='RES3D_SIG_SG_552')
objects.set_attribute(object='SET_SIG_SG_552', attribute="value", value=30.00)
objects.set_attribute(object='SET_SIG_SG_552', attribute="weight", value=3.5)
objects.set_attribute(object='SET_SIG_SG_552', attribute="stacking", value=1)
objects.set_attribute(object='SET_SIG_SG_552', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_SIG_SG_552', attribute="maximale_feuerreichweite", value=32)
objects.set_attribute(object='SET_SIG_SG_552', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_SIG_SG_552', attribute="feuergeschwindigkeit", value=780.00)
objects.set_attribute(object='SET_SIG_SG_552', attribute="genauigkeit", value=1.4)
objects.set_attribute(object='SET_SIG_SG_552', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_SIG_SG_552', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_SIG_SG_552', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_SIG_SG_552', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
objects.set_attribute(object='SET_SIG_SG_552', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_SIG_SG_552', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_SIG_SG_552', attribute="magazingroesse", 				value=20.0)
objects.set_attribute(object='SET_SIG_SG_552', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_SIG_SG_552', attribute="schusspausenzeit", 				value=1.7)
objects.set_attribute(object='SET_SIG_SG_552', attribute="genauigkeit_bewegte_ziele",		value=0.7)
objects.set_attribute(object='SET_SIG_SG_552', attribute="blockadewahrscheinlichkeit",	value=17.0)
objects.set_attribute(object='SET_SIG_SG_552', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_SIG_SG_552', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Cutoff"	: 3,
		"Auto"		: 5,
		"ButtOff"	: "RES_ITEM65X32_WEAPON_SIG_SG_552_X"
		})
objects.set_attribute(object='SET_SIG_SG_552', attribute="Current_Fire_Mode", value="Cutoff")
objects.set_attribute(object='SET_SIG_SG_552', attribute="effects", value={
		"sound_shot"	: "burst_sig_sg552",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_STEYR_AUG')
objects.set_attribute(object='SET_STEYR_AUG', attribute="name", value=globaltext.SET_STEYR_AUG_NAME)
objects.set_attribute(object='SET_STEYR_AUG', attribute="hint", value=globaltext.SET_STEYR_AUG_HINT)
objects.set_attribute(object='SET_STEYR_AUG', attribute="resourceui", value='RES_ITEM65X32_WEAPON_STEYR_AUG')
objects.set_attribute(object='SET_STEYR_AUG', attribute="resource3d", value='RES3D_STEYR_AUG')
objects.set_attribute(object='SET_STEYR_AUG', attribute="value", value=25.00)
objects.set_attribute(object='SET_STEYR_AUG', attribute="weight", value=4.1)
objects.set_attribute(object='SET_STEYR_AUG', attribute="stacking", value=1)
objects.set_attribute(object='SET_STEYR_AUG', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_STEYR_AUG', attribute="maximale_feuerreichweite", value=38)
objects.set_attribute(object='SET_STEYR_AUG', attribute="salvenlaenge", value=4)
objects.set_attribute(object='SET_STEYR_AUG', attribute="feuergeschwindigkeit", value=650.00)
objects.set_attribute(object='SET_STEYR_AUG', attribute="genauigkeit", value=1.5)
objects.set_attribute(object='SET_STEYR_AUG', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_STEYR_AUG', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_STEYR_AUG', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_STEYR_AUG', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
objects.set_attribute(object='SET_STEYR_AUG', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_STEYR_AUG', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_STEYR_AUG', attribute="magazingroesse", 			value=30.0)
objects.set_attribute(object='SET_STEYR_AUG', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_STEYR_AUG', attribute="schusspausenzeit", 			value=1.8)
objects.set_attribute(object='SET_STEYR_AUG', attribute="genauigkeit_bewegte_ziele",	value=0.8)
objects.set_attribute(object='SET_STEYR_AUG', attribute="blockadewahrscheinlichkeit",	value=15.0)
objects.set_attribute(object='SET_STEYR_AUG', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_STEYR_AUG', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Cutoff"	: 2,
		"Auto"		: 4
		})
objects.set_attribute(object='SET_STEYR_AUG', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_STEYR_AUG', attribute="effects", value={
		"sound_shot"	: "burst_steyr_aug",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_M14')
objects.set_attribute(object='SET_M14', attribute="name", value=globaltext.SET_M14_NAME)
objects.set_attribute(object='SET_M14', attribute="hint", value=globaltext.SET_M14_HINT)
objects.set_attribute(object='SET_M14', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M14')
objects.set_attribute(object='SET_M14', attribute="resource3d", value='RES3D_M14')
objects.set_attribute(object='SET_M14', attribute="value", value=14.00)
objects.set_attribute(object='SET_M14', attribute="weight", value=4.3)
objects.set_attribute(object='SET_M14', attribute="stacking", value=1)
objects.set_attribute(object='SET_M14', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_M14', attribute="maximale_feuerreichweite", value=30)
objects.set_attribute(object='SET_M14', attribute="salvenlaenge", value=12)
objects.set_attribute(object='SET_M14', attribute="feuergeschwindigkeit", value=700.00)
objects.set_attribute(object='SET_M14', attribute="genauigkeit", value=0.3)
objects.set_attribute(object='SET_M14', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_M14', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_M14', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_M14', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
objects.set_attribute(object='SET_M14', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_M14', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_M14', attribute="magazingroesse", 				value=20.0)
objects.set_attribute(object='SET_M14', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_M14', attribute="schusspausenzeit", 			value=1.8)
objects.set_attribute(object='SET_M14', attribute="genauigkeit_bewegte_ziele",	value=0.5)
objects.set_attribute(object='SET_M14', attribute="blockadewahrscheinlichkeit",	value=12.0)
objects.set_attribute(object='SET_M14', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_M14', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 12
		})
objects.set_attribute(object='SET_M14', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_M14', attribute="effects", value={
		"sound_shot"	: "burst_m14",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_MG_3')
objects.set_attribute(object='SET_MG_3', attribute="name", value=globaltext.SET_MG_3_NAME)
objects.set_attribute(object='SET_MG_3', attribute="hint", value=globaltext.SET_MG_3_HINT)
objects.set_attribute(object='SET_MG_3', attribute="resourceui", value='RES_ITEM65X32_WEAPON_MG_3')
objects.set_attribute(object='SET_MG_3', attribute="resource3d", value='RES3D_MG_3')
objects.set_attribute(object='SET_MG_3', attribute="value", value=32.00)
objects.set_attribute(object='SET_MG_3', attribute="weight", value=11.5)
objects.set_attribute(object='SET_MG_3', attribute="stacking", value=1)
objects.set_attribute(object='SET_MG_3', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_MG_3', attribute="maximale_feuerreichweite", value=38)
objects.set_attribute(object='SET_MG_3', attribute="salvenlaenge", value=18)
objects.set_attribute(object='SET_MG_3', attribute="feuergeschwindigkeit", value=1200.00)
objects.set_attribute(object='SET_MG_3', attribute="genauigkeit", value=0.3)
objects.set_attribute(object='SET_MG_3', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_MG_3', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_MG_3', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_MG_3', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
objects.set_attribute(object='SET_MG_3', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_MG_3', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_MG_3', attribute="magazingroesse", 				value=50.0)
objects.set_attribute(object='SET_MG_3', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_MG_3', attribute="schusspausenzeit", 			value=2.7)
objects.set_attribute(object='SET_MG_3', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_MG_3', attribute="blockadewahrscheinlichkeit",	value=12.0)
objects.set_attribute(object='SET_MG_3', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_MG_3', attribute="effects", value={
		"sound_shot"	: "burst_mg_3",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_RPK_74')
objects.set_attribute(object='SET_RPK_74', attribute="name", value=globaltext.SET_RPK_74_NAME)
objects.set_attribute(object='SET_RPK_74', attribute="hint", value=globaltext.SET_RPK_74_HINT)
objects.set_attribute(object='SET_RPK_74', attribute="resourceui", value='RES_ITEM65X32_WEAPON_RPK_74')
objects.set_attribute(object='SET_RPK_74', attribute="resource3d", value='RES3D_RPK_74')
objects.set_attribute(object='SET_RPK_74', attribute="value", value=33.00)
objects.set_attribute(object='SET_RPK_74', attribute="weight", value=5.0)
objects.set_attribute(object='SET_RPK_74', attribute="stacking", value=1)
objects.set_attribute(object='SET_RPK_74', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_RPK_74', attribute="maximale_feuerreichweite", value=40)
objects.set_attribute(object='SET_RPK_74', attribute="salvenlaenge", value=12)
objects.set_attribute(object='SET_RPK_74', attribute="feuergeschwindigkeit", value=600.00)
objects.set_attribute(object='SET_RPK_74', attribute="genauigkeit", value=0.4)
objects.set_attribute(object='SET_RPK_74', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_RPK_74', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_RPK_74', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_RPK_74', attribute="munitionsarten", value=['SET_AMMOPACK_5_45_MM'])
objects.set_attribute(object='SET_RPK_74', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_RPK_74', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_RPK_74', attribute="magazingroesse", 				value=45.0)
objects.set_attribute(object='SET_RPK_74', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_RPK_74', attribute="schusspausenzeit", 				value=2.3)
objects.set_attribute(object='SET_RPK_74', attribute="genauigkeit_bewegte_ziele",		value=0.7)
objects.set_attribute(object='SET_RPK_74', attribute="blockadewahrscheinlichkeit",	value=10.0)
objects.set_attribute(object='SET_RPK_74', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_RPK_74', attribute="Fire_Modes", value={
		"Cutoff"	: 3,
		"Auto"		: 12
		})
objects.set_attribute(object='SET_RPK_74', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_RPK_74', attribute="effects", value={
		"sound_shot"	: "burst_rpk_74",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_M249')
objects.set_attribute(object='SET_M249', attribute="name", value=globaltext.SET_M249_NAME)
objects.set_attribute(object='SET_M249', attribute="hint", value=globaltext.SET_M249_HINT)
objects.set_attribute(object='SET_M249', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M249')
objects.set_attribute(object='SET_M249', attribute="resource3d", value='RES3D_M249')
objects.set_attribute(object='SET_M249', attribute="value", value=30.00)
objects.set_attribute(object='SET_M249', attribute="weight", value=6.8)
objects.set_attribute(object='SET_M249', attribute="stacking", value=1)
objects.set_attribute(object='SET_M249', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_M249', attribute="maximale_feuerreichweite", value=40)
objects.set_attribute(object='SET_M249', attribute="salvenlaenge", value=15)
objects.set_attribute(object='SET_M249', attribute="feuergeschwindigkeit", value=750.00)
objects.set_attribute(object='SET_M249', attribute="genauigkeit", value=0.6)
objects.set_attribute(object='SET_M249', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_M249', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_M249', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_M249', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
objects.set_attribute(object='SET_M249', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_M249', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_M249', attribute="magazingroesse", 				value=100.0)
objects.set_attribute(object='SET_M249', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_M249', attribute="schusspausenzeit", 			value=2.0)
objects.set_attribute(object='SET_M249', attribute="genauigkeit_bewegte_ziele",	value=0.8)
objects.set_attribute(object='SET_M249', attribute="blockadewahrscheinlichkeit",	value=13.0)
objects.set_attribute(object='SET_M249', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_M249', attribute="Fire_Modes", value= {
		"Auto"		: 15,
		"ButtOff"	: 'RES_ITEM65X32_WEAPON_M249_X'
})
objects.set_attribute(object='SET_M249', attribute="effects", value={
		"sound_shot"	: "burst_m249",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_FN_MAG')
objects.set_attribute(object='SET_FN_MAG', attribute="name", value=globaltext.SET_FN_MAG_NAME)
objects.set_attribute(object='SET_FN_MAG', attribute="hint", value=globaltext.SET_FN_MAG_HINT)
objects.set_attribute(object='SET_FN_MAG', attribute="resourceui", value='RES_ITEM65X32_WEAPON_FN_MAG')
objects.set_attribute(object='SET_FN_MAG', attribute="resource3d", value='RES3D_FN_MAG')
objects.set_attribute(object='SET_FN_MAG', attribute="value", value=35.00)
objects.set_attribute(object='SET_FN_MAG', attribute="weight", value=11.0)
objects.set_attribute(object='SET_FN_MAG', attribute="stacking", value=1)
objects.set_attribute(object='SET_FN_MAG', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_FN_MAG', attribute="maximale_feuerreichweite", value=41)
objects.set_attribute(object='SET_FN_MAG', attribute="salvenlaenge", value=15)
objects.set_attribute(object='SET_FN_MAG', attribute="feuergeschwindigkeit", value=700.00)
objects.set_attribute(object='SET_FN_MAG', attribute="genauigkeit", value=0.5)
objects.set_attribute(object='SET_FN_MAG', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_FN_MAG', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_FN_MAG', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_FN_MAG', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
objects.set_attribute(object='SET_FN_MAG', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_FN_MAG', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_FN_MAG', attribute="magazingroesse", 				value=100.0)
objects.set_attribute(object='SET_FN_MAG', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_FN_MAG', attribute="schusspausenzeit", 				value=3.0)
objects.set_attribute(object='SET_FN_MAG', attribute="genauigkeit_bewegte_ziele",		value=0.8)
objects.set_attribute(object='SET_FN_MAG', attribute="blockadewahrscheinlichkeit",	value=12.0)
objects.set_attribute(object='SET_FN_MAG', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_FN_MAG', attribute="Fire_Modes", value={
		"Cutoff"	: 3,
		"Auto"		: 15
		})
objects.set_attribute(object='SET_FN_MAG', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_FN_MAG', attribute="effects", value={
		"sound_shot"	: "burst_fn_mag",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_M60')
objects.set_attribute(object='SET_M60', attribute="name", value=globaltext.SET_M60_NAME)
objects.set_attribute(object='SET_M60', attribute="hint", value=globaltext.SET_M60_HINT)
objects.set_attribute(object='SET_M60', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M60')
objects.set_attribute(object='SET_M60', attribute="resource3d", value='RES3D_M60')
objects.set_attribute(object='SET_M60', attribute="value", value=35.00)
objects.set_attribute(object='SET_M60', attribute="weight", value=10.5)
objects.set_attribute(object='SET_M60', attribute="stacking", value=1)
objects.set_attribute(object='SET_M60', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_M60', attribute="maximale_feuerreichweite", value=43)
objects.set_attribute(object='SET_M60', attribute="salvenlaenge", value=13)
objects.set_attribute(object='SET_M60', attribute="feuergeschwindigkeit", value=550.00)
objects.set_attribute(object='SET_M60', attribute="genauigkeit", value=0.5)
objects.set_attribute(object='SET_M60', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_M60', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_M60', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_M60', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
objects.set_attribute(object='SET_M60', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_M60', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_M60', attribute="magazingroesse", 				value=100.0)
objects.set_attribute(object='SET_M60', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_M60', attribute="schusspausenzeit", 			value=2.5)
objects.set_attribute(object='SET_M60', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_M60', attribute="blockadewahrscheinlichkeit",	value=13.0)
objects.set_attribute(object='SET_M60', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_M60', attribute="effects", value={
		"sound_shot"	: "burst_m60",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_M_79')
objects.set_attribute(object='SET_M_79', attribute="name", value=globaltext.SET_M_79_NAME)
objects.set_attribute(object='SET_M_79', attribute="hint", value=globaltext.SET_M_79_HINT)
objects.set_attribute(object='SET_M_79', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_79')
objects.set_attribute(object='SET_M_79', attribute="resource3d", value='RES3D_M_79')
objects.set_attribute(object='SET_M_79', attribute="value", value=25.00)
objects.set_attribute(object='SET_M_79', attribute="weight", value=3.5)
objects.set_attribute(object='SET_M_79', attribute="stacking", value=1)
objects.set_attribute(object='SET_M_79', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_M_79', attribute="maximale_feuerreichweite", value=30)
objects.set_attribute(object='SET_M_79', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_M_79', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_M_79', attribute="genauigkeit", value=1.00)
objects.set_attribute(object='SET_M_79', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_M_79', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_M_79', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_M_79', attribute="munitionsarten", value=['SET_AMMOPACK_M79_M203'])
objects.set_attribute(object='SET_M_79', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_M_79', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_M_79', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_M_79', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_M_79', attribute="schusspausenzeit", 			value=2.0)
objects.set_attribute(object='SET_M_79', attribute="genauigkeit_bewegte_ziele",	value=0.2)
objects.set_attribute(object='SET_M_79', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_M_79', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_M_79', attribute="causes_explosion", value=True)
objects.set_attribute(object='SET_M_79', attribute="effects", value={
		"sound_shot"	: "shot_m_79",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 5,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.8,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_RPG7')
objects.set_attribute(object='SET_RPG7', attribute="name", value=globaltext.SET_RPG7_NAME)
objects.set_attribute(object='SET_RPG7', attribute="hint", value=globaltext.SET_RPG7_HINT)
objects.set_attribute(object='SET_RPG7', attribute="resourceui", value='RES_ITEM65X32_WEAPON_RPG7')
objects.set_attribute(object='SET_RPG7', attribute="resource3d", value='RES3D_RPG7')
objects.set_attribute(object='SET_RPG7', attribute="value", value=80.00)
objects.set_attribute(object='SET_RPG7', attribute="weight", value=7.9)
objects.set_attribute(object='SET_RPG7', attribute="stacking", value=1)
objects.set_attribute(object='SET_RPG7', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_RPG7', attribute="maximale_feuerreichweite", value=50)
objects.set_attribute(object='SET_RPG7', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_RPG7', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_RPG7', attribute="genauigkeit", value=5.00)
objects.set_attribute(object='SET_RPG7', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_RPG7', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_RPG7', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_RPG7', attribute="munitionsarten", value=['SET_AMMOPACK_40_MM_RPG7_HE'])
objects.set_attribute(object='SET_RPG7', attribute="fire_animation", value=FPA_SHOULDER_BASED)
objects.set_attribute(object='SET_RPG7', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_RPG7', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_RPG7', attribute="hoerweite", 					value=50.0)
objects.set_attribute(object='SET_RPG7', attribute="schusspausenzeit", 			value=3.0)
objects.set_attribute(object='SET_RPG7', attribute="genauigkeit_bewegte_ziele",	value=0.6)
objects.set_attribute(object='SET_RPG7', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_RPG7', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_RPG7', attribute="illegal_bodymodes", value=["LIE"])
objects.set_attribute(object='SET_RPG7', attribute="not_tradable", value=True)
objects.set_attribute(object='SET_RPG7', attribute="effects", value={
		"sound_shot"	: "shot_rpg7",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 5,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.8,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_LAW')
objects.set_attribute(object='SET_LAW', attribute="name", value=globaltext.SET_LAW_NAME)
objects.set_attribute(object='SET_LAW', attribute="hint", value=globaltext.SET_LAW_HINT)
objects.set_attribute(object='SET_LAW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_LAW')
objects.set_attribute(object='SET_LAW', attribute="resource3d", value='RES3D_LAW')
objects.set_attribute(object='SET_LAW', attribute="value", value=75.00)
objects.set_attribute(object='SET_LAW', attribute="weight", value=6.0)
objects.set_attribute(object='SET_LAW', attribute="stacking", value=1)
objects.set_attribute(object='SET_LAW', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_LAW', attribute="maximale_feuerreichweite", value=40)
objects.set_attribute(object='SET_LAW', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_LAW', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_LAW', attribute="genauigkeit", value=3.00)
objects.set_attribute(object='SET_LAW', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_LAW', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_LAW', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_LAW', attribute="munitionsarten", value=['SET_MUN_LAW'])
objects.set_attribute(object='SET_LAW', attribute="fire_animation", value=FPA_SHOULDER_BASED)
objects.set_attribute(object='SET_LAW', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_LAW', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_LAW', attribute="hoerweite", 					value=50.0)
objects.set_attribute(object='SET_LAW', attribute="schusspausenzeit", 			value=3.5)
objects.set_attribute(object='SET_LAW', attribute="genauigkeit_bewegte_ziele",	value=0.4)
objects.set_attribute(object='SET_LAW', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_LAW', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_LAW', attribute="illegal_bodymodes", value=["LIE"])
objects.set_attribute(object='SET_LAW', attribute="not_tradable", value=True)
objects.set_attribute(object='SET_LAW', attribute="effects", value={
		"sound_shot"	: "shot_law",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 5,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.8,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_PLASMABLASTER')
objects.set_attribute(object='SET_PLASMABLASTER', attribute="name", value=globaltext.SET_PLASMABLASTER_NAME)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="hint", value=globaltext.SET_PLASMABLASTER_HINT)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="resourceui", value='RES_ITEM65X32_WEAPON_PLASMABLASTER')
objects.set_attribute(object='SET_PLASMABLASTER', attribute="resource3d", value='RES3D_PLASMABLASTER')
objects.set_attribute(object='SET_PLASMABLASTER', attribute="value", value=200.00)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="weight", value=10.0)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="stacking", value=1)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="maximale_feuerreichweite", value=50)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="salvenlaenge", value=10)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="feuergeschwindigkeit", value=600.00)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="genauigkeit", value=0.5)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="munitionsarten", value=['SET_AMMOPACK_LASER_GUN'])
objects.set_attribute(object='SET_PLASMABLASTER', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_PLASMABLASTER', attribute="magazingroesse", 				value=40.0)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="schusspausenzeit", 			value=1.5)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="blockadewahrscheinlichkeit",	value=1.0)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_PLASMABLASTER', attribute="not_tradable", value=True)
objects.set_attribute(object='SET_PLASMABLASTER', attribute="effects", value={
		"sound_shot"	: "burst_plasmablaster",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 6,
		"flash_size"	: 0.7,
		"stream_type"	: 2,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

## sniper waffen
create_weapon_type(typeid='SET_DRAGUNOV')
objects.set_attribute(object='SET_DRAGUNOV', attribute="name", value=globaltext.SET_DRAGUNOV_NAME)
objects.set_attribute(object='SET_DRAGUNOV', attribute="hint", value=globaltext.SET_DRAGUNOV_HINT)
objects.set_attribute(object='SET_DRAGUNOV', attribute="resourceui", value='RES_ITEM65X32_WEAPON_DRAGUNOV')
objects.set_attribute(object='SET_DRAGUNOV', attribute="resource3d", value='RES3D_DRAGUNOV')
objects.set_attribute(object='SET_DRAGUNOV', attribute="value", value=100.00)
objects.set_attribute(object='SET_DRAGUNOV', attribute="weight", value=4.3)
objects.set_attribute(object='SET_DRAGUNOV', attribute="stacking", value=1)
objects.set_attribute(object='SET_DRAGUNOV', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_DRAGUNOV', attribute="maximale_feuerreichweite", value=50)
objects.set_attribute(object='SET_DRAGUNOV', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_DRAGUNOV', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_DRAGUNOV', attribute="genauigkeit", value=1.5)
objects.set_attribute(object='SET_DRAGUNOV', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_DRAGUNOV', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_DRAGUNOV', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_DRAGUNOV', attribute="munitionsarten", value=['SET_AMMOPACK_7_62_54_MMR'])
objects.set_attribute(object='SET_DRAGUNOV', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
objects.set_attribute(object='SET_DRAGUNOV', attribute="weapon_type", value="sniper")
objects.set_attribute(object='SET_DRAGUNOV', attribute="magazingroesse", 			value=10.0)
objects.set_attribute(object='SET_DRAGUNOV', attribute="hoerweite", 			value=40.0)
objects.set_attribute(object='SET_DRAGUNOV', attribute="schusspausenzeit", 		value=4.0)
objects.set_attribute(object='SET_DRAGUNOV', attribute="genauigkeit_bewegte_ziele",	value=1.5)
objects.set_attribute(object='SET_DRAGUNOV', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_DRAGUNOV', attribute="day_vision_mult",		value=4.0) # Derff's fire range factor
objects.set_attribute(object='SET_DRAGUNOV', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_DRAGUNOV', attribute="effects", value={
		"sound_shot"	: "shot_dragunov",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 1.1,
		"stream_type"	: 1,
		"stream_size"	: 1.1,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_PSG_1')
objects.set_attribute(object='SET_PSG_1', attribute="name", value=globaltext.SET_PSG_1_NAME)
objects.set_attribute(object='SET_PSG_1', attribute="hint", value=globaltext.SET_PSG_1_HINT)
objects.set_attribute(object='SET_PSG_1', attribute="resourceui", value='RES_ITEM65X32_WEAPON_PSG_1')
objects.set_attribute(object='SET_PSG_1', attribute="resource3d", value='RES3D_PSG_1')
objects.set_attribute(object='SET_PSG_1', attribute="value", value=150.00)
objects.set_attribute(object='SET_PSG_1', attribute="weight", value=8.1)
objects.set_attribute(object='SET_PSG_1', attribute="stacking", value=1)
objects.set_attribute(object='SET_PSG_1', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_PSG_1', attribute="maximale_feuerreichweite", value=55)
objects.set_attribute(object='SET_PSG_1', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_PSG_1', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_PSG_1', attribute="genauigkeit", value=2.00)
objects.set_attribute(object='SET_PSG_1', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_PSG_1', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_PSG_1', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_PSG_1', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
objects.set_attribute(object='SET_PSG_1', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
objects.set_attribute(object='SET_PSG_1', attribute="weapon_type", value="sniper")
objects.set_attribute(object='SET_PSG_1', attribute="magazingroesse", 			value=8.0)
objects.set_attribute(object='SET_PSG_1', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_PSG_1', attribute="schusspausenzeit", 			value=4.5)
objects.set_attribute(object='SET_PSG_1', attribute="genauigkeit_bewegte_ziele",	value=1.0)
objects.set_attribute(object='SET_PSG_1', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_PSG_1', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_PSG_1', attribute="effects", value={
		"sound_shot"	: "shot_psg_1",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 1.0,
		"stream_type"	: 1,
		"stream_size"	: 1.0,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_BARRET_M82A2')
objects.set_attribute(object='SET_BARRET_M82A2', attribute="name", value=globaltext.SET_BARRET_M82A2_NAME)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="hint", value=globaltext.SET_BARRET_M82A2_HINT)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="resourceui", value='RES_ITEM65X32_WEAPON_BARRET_M82A2')
objects.set_attribute(object='SET_BARRET_M82A2', attribute="resource3d", value='RES3D_BARRET_M82A2')
objects.set_attribute(object='SET_BARRET_M82A2', attribute="value", value=90.00)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="weight", value=12.9)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="stacking", value=1)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="maximale_feuerreichweite", value=75)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="genauigkeit", value=1.5)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="munitionsarten", value=['SET_AMMOPACK_50_BMG'])
objects.set_attribute(object='SET_BARRET_M82A2', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="weapon_type", value="sniper")
objects.set_attribute(object='SET_BARRET_M82A2', attribute="magazingroesse", 				value=8.0)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="schusspausenzeit", 			value=5.0)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="genauigkeit_bewegte_ziele",	value=1.0)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_BARRET_M82A2', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_BARRET_M82A2', attribute="effects", value={
		"sound_shot"	: "shot_barret_m82a2",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 1.1,
		"stream_type"	: 1,
		"stream_size"	: 1.3,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_M24')
objects.set_attribute(object='SET_M24', attribute="name", value=globaltext.SET_M24_NAME)
objects.set_attribute(object='SET_M24', attribute="hint", value=globaltext.SET_M24_HINT)
objects.set_attribute(object='SET_M24', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M24')
objects.set_attribute(object='SET_M24', attribute="resource3d", value='RES3D_M24')
objects.set_attribute(object='SET_M24', attribute="value", value=80.00)
objects.set_attribute(object='SET_M24', attribute="weight", value=5.4)
objects.set_attribute(object='SET_M24', attribute="stacking", value=1)
objects.set_attribute(object='SET_M24', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_M24', attribute="maximale_feuerreichweite", value=50)
objects.set_attribute(object='SET_M24', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_M24', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_M24', attribute="genauigkeit", value=2.00)
objects.set_attribute(object='SET_M24', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_M24', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_M24', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_M24', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
objects.set_attribute(object='SET_M24', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
objects.set_attribute(object='SET_M24', attribute="weapon_type", value="sniper")
objects.set_attribute(object='SET_M24', attribute="magazingroesse", 				value=10.0)
objects.set_attribute(object='SET_M24', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_M24', attribute="schusspausenzeit", 			value=5.0)
objects.set_attribute(object='SET_M24', attribute="genauigkeit_bewegte_ziele",	value=1.0)
objects.set_attribute(object='SET_M24', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_M24', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_M24', attribute="effects", value={
		"sound_shot"	: "shot_m24",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 1.0,
		"stream_type"	: 1,
		"stream_size"	: 1.1,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_CROSSBOW')
objects.set_attribute(object='SET_CROSSBOW', attribute="name", value=globaltext.SET_CROSSBOW_NAME)
objects.set_attribute(object='SET_CROSSBOW', attribute="hint", value=globaltext.SET_CROSSBOW_HINT)
objects.set_attribute(object='SET_CROSSBOW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_CROSSBOW')
objects.set_attribute(object='SET_CROSSBOW', attribute="resource3d", value='RES3D_CROSSBOW')
objects.set_attribute(object='SET_CROSSBOW', attribute="value", value=60.00)
objects.set_attribute(object='SET_CROSSBOW', attribute="weight", value=4.0)
objects.set_attribute(object='SET_CROSSBOW', attribute="stacking", value=1)
objects.set_attribute(object='SET_CROSSBOW', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_CROSSBOW', attribute="maximale_feuerreichweite", value=33)
objects.set_attribute(object='SET_CROSSBOW', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_CROSSBOW', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_CROSSBOW', attribute="genauigkeit", value=1.00)
objects.set_attribute(object='SET_CROSSBOW', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_CROSSBOW', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_CROSSBOW', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_CROSSBOW', attribute="munitionsarten", value=['SET_AMMOPACK_BOLT'])
objects.set_attribute(object='SET_CROSSBOW', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
objects.set_attribute(object='SET_CROSSBOW', attribute="weapon_type", value="sniper")
objects.set_attribute(object='SET_CROSSBOW', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_CROSSBOW', attribute="hoerweite", 					value=1.0)
objects.set_attribute(object='SET_CROSSBOW', attribute="schusspausenzeit", 			value=5.2)
objects.set_attribute(object='SET_CROSSBOW', attribute="genauigkeit_bewegte_ziele",	value=0.6)
objects.set_attribute(object='SET_CROSSBOW', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_CROSSBOW', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_CROSSBOW', attribute="effects", value={
		"sound_shot"	: "shot_crossbow",
		"sound_unload"	: "crossbow_discharge",
		"sound_reload"	: "crossbow_charge"})

create_weapon_type(typeid='SET_DSR1')
objects.set_attribute(object='SET_DSR1', attribute="name", value=globaltext.SET_DSR1_NAME)
objects.set_attribute(object='SET_DSR1', attribute="hint", value=globaltext.SET_DSR1_HINT)
objects.set_attribute(object='SET_DSR1', attribute="resourceui", value='RES_ITEM65X32_WEAPON_DSR1')
objects.set_attribute(object='SET_DSR1', attribute="resource3d", value='RES3D_DSR1')
objects.set_attribute(object='SET_DSR1', attribute="value", value=200.00)
objects.set_attribute(object='SET_DSR1', attribute="weight", value=5.2)
objects.set_attribute(object='SET_DSR1', attribute="stacking", value=1)
objects.set_attribute(object='SET_DSR1', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_DSR1', attribute="maximale_feuerreichweite", value=60)
objects.set_attribute(object='SET_DSR1', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_DSR1', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_DSR1', attribute="genauigkeit", value=3.00)
objects.set_attribute(object='SET_DSR1', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_DSR1', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_DSR1', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_DSR1', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
objects.set_attribute(object='SET_DSR1', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
objects.set_attribute(object='SET_DSR1', attribute="weapon_type", value="sniper")
objects.set_attribute(object='SET_DSR1', attribute="magazingroesse", 				value=5.0)
objects.set_attribute(object='SET_DSR1', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_DSR1', attribute="schusspausenzeit", 			value=5.3)
objects.set_attribute(object='SET_DSR1', attribute="genauigkeit_bewegte_ziele",	value=1.0)
objects.set_attribute(object='SET_DSR1', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_DSR1', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_DSR1', attribute="effects", value={
		"sound_shot"	: "shot_dsr1",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 1.0,
		"stream_type"	: 1,
		"stream_size"	: 1.0,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_RAILGUN')
objects.set_attribute(object='SET_RAILGUN', attribute="name", value=globaltext.SET_RAILGUN_NAME)
objects.set_attribute(object='SET_RAILGUN', attribute="hint", value=globaltext.SET_RAILGUN_HINT)
objects.set_attribute(object='SET_RAILGUN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_RAILGUN')
objects.set_attribute(object='SET_RAILGUN', attribute="resource3d", value='RES3D_RAILGUN')
objects.set_attribute(object='SET_RAILGUN', attribute="value", value=300.0)
objects.set_attribute(object='SET_RAILGUN', attribute="weight", value=12.0)
objects.set_attribute(object='SET_RAILGUN', attribute="stacking", value=1)
objects.set_attribute(object='SET_RAILGUN', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_RAILGUN', attribute="maximale_feuerreichweite", value=75) #150
objects.set_attribute(object='SET_RAILGUN', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_RAILGUN', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_RAILGUN', attribute="genauigkeit", value=2.00)
objects.set_attribute(object='SET_RAILGUN', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_RAILGUN', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_RAILGUN', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_RAILGUN', attribute="munitionsarten", value=['SET_AMMOPACK_2_5_JHP_ARROW'])
objects.set_attribute(object='SET_RAILGUN', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
objects.set_attribute(object='SET_RAILGUN', attribute="weapon_type", value="sniper")
objects.set_attribute(object='SET_RAILGUN', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_RAILGUN', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_RAILGUN', attribute="schusspausenzeit", 			value=5.0)
objects.set_attribute(object='SET_RAILGUN', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_RAILGUN', attribute="blockadewahrscheinlichkeit",	value=0.0)
objects.set_attribute(object='SET_RAILGUN', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_RAILGUN', attribute="effects", value={
		"sound_shot"	: "shot_railgun",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 6,
		"flash_size"	: 0.5,
		"stream_type"	: 2,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_SR800')
objects.set_attribute(object='SET_SR800', attribute="name", value=globaltext.SET_SR800_NAME)
objects.set_attribute(object='SET_SR800', attribute="hint", value=globaltext.SET_SR800_HINT)
objects.set_attribute(object='SET_SR800', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SR800')
objects.set_attribute(object='SET_SR800', attribute="resource3d", value='RES3D_SR800')
objects.set_attribute(object='SET_SR800', attribute="value", value=300.0)
objects.set_attribute(object='SET_SR800', attribute="weight", value=8.0)
objects.set_attribute(object='SET_SR800', attribute="stacking", value=1)
objects.set_attribute(object='SET_SR800', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_SR800', attribute="maximale_feuerreichweite", value=60)
objects.set_attribute(object='SET_SR800', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_SR800', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_SR800', attribute="genauigkeit", value=3.00)
objects.set_attribute(object='SET_SR800', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_SR800', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_SR800', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_SR800', attribute="munitionsarten", value=['SET_AMMOPACK_7_62NATO_MM','SET_AMMOPACK_7_62NATO_MM_SABOT','SET_AMMOPACK_7_62NATO_MM_DUPLEX'])
objects.set_attribute(object='SET_SR800', attribute="fire_animation", value=FPA_SNIPER_SINGLE)
objects.set_attribute(object='SET_SR800', attribute="weapon_type", value="sniper")
objects.set_attribute(object='SET_SR800', attribute="magazingroesse", 				value=10.0)
objects.set_attribute(object='SET_SR800', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_SR800', attribute="schusspausenzeit", 			value=4.0)
objects.set_attribute(object='SET_SR800', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_SR800', attribute="blockadewahrscheinlichkeit",	value=0.0)
objects.set_attribute(object='SET_SR800', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_SR800', attribute="not_tradable", value=True)
objects.set_attribute(object='SET_SR800', attribute="effects", value={
		"sound_shot"	: "shot_sr800",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 1.0,
		"stream_type"	: 1,
		"stream_size"	: 1.0,
		"fade_out"		: 50})

## Sekundäre Waffen (z.B. Granaten, Messer, usw.)
create_throw_object_type(typeid='SET_HEGRENADE')
objects.set_attribute(object='SET_HEGRENADE', attribute="name", value=globaltext.SET_HEGRENADE_NAME)
objects.set_attribute(object='SET_HEGRENADE', attribute="hint", value=globaltext.SET_HEGRENADE_HINT)
objects.set_attribute(object='SET_HEGRENADE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_HEGRENADE')
objects.set_attribute(object='SET_HEGRENADE', attribute="resource3d", value='RES3D_HEGRENADE')
objects.set_attribute(object='SET_HEGRENADE', attribute="value", value=5.00)
objects.set_attribute(object='SET_HEGRENADE', attribute="weight", value=0.20)
objects.set_attribute(object='SET_HEGRENADE', attribute="stacking", value=5)
objects.set_attribute(object='SET_HEGRENADE', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_HEGRENADE', attribute="maximale_feuerreichweite", value=23)
objects.set_attribute(object='SET_HEGRENADE', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_HEGRENADE', attribute="feuergeschwindigkeit", value=40.00)
objects.set_attribute(object='SET_HEGRENADE', attribute="genauigkeit", value=0.6)
objects.set_attribute(object='SET_HEGRENADE', attribute="kampfwert_air", value=15.00)
objects.set_attribute(object='SET_HEGRENADE', attribute="kampfwert_armoured", value=100.00)
objects.set_attribute(object='SET_HEGRENADE', attribute="kampfwert_infantry", value=100.00)
objects.set_attribute(object='SET_HEGRENADE', attribute="munitionsarten", value=['SET_HEGRENADE_PSEUDOAMMO'])
objects.set_attribute(object='SET_HEGRENADE', attribute="fire_animation", value=FPA_THROW_GRENADE)
objects.set_attribute(object='SET_HEGRENADE', attribute="weapon_type", value="wurf")
objects.set_attribute(object='SET_HEGRENADE', attribute="magazingroesse", 			value=1.0)
objects.set_attribute(object='SET_HEGRENADE', attribute="hoerweite", 				value=0.0)
objects.set_attribute(object='SET_HEGRENADE', attribute="schusspausenzeit", 			value=1.5)
objects.set_attribute(object='SET_HEGRENADE', attribute="genauigkeit_bewegte_ziele",	value=0.3)
objects.set_attribute(object='SET_HEGRENADE', attribute="occupied_slots", value=["throw"])

create_throw_object_type(typeid='SET_FRAGGRENADE')
objects.set_attribute(object='SET_FRAGGRENADE', attribute="name", value=globaltext.SET_FRAGGRENADE_NAME)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="hint", value=globaltext.SET_FRAGGRENADE_HINT)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_FRAGGRENADE')
objects.set_attribute(object='SET_FRAGGRENADE', attribute="resource3d", value='RES3D_FRAGGRENADE')
objects.set_attribute(object='SET_FRAGGRENADE', attribute="value", value=7.00)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="weight", value=0.20)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="stacking", value=5)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="maximale_feuerreichweite", value=23)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="feuergeschwindigkeit", value=40.00)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="genauigkeit", value=0.6)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="kampfwert_air", value=15.00)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="kampfwert_armoured", value=100.00)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="kampfwert_infantry", value=100.00)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="munitionsarten", value=['SET_FRAGGRENADE_PSEUDOAMMO'])
objects.set_attribute(object='SET_FRAGGRENADE', attribute="fire_animation", value=FPA_THROW_GRENADE)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="weapon_type", value="wurf")
objects.set_attribute(object='SET_FRAGGRENADE', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="hoerweite", 					value=0.0)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="schusspausenzeit", 			value=1.5)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="genauigkeit_bewegte_ziele",	value=0.3)
objects.set_attribute(object='SET_FRAGGRENADE', attribute="occupied_slots", value=["throw"])

create_throw_object_type(typeid='SET_MOLOTOV_COCKTAIL')
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="name", value=globaltext.SET_MOLOTOV_COCKTAIL_NAME)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="hint", value=globaltext.SET_MOLOTOV_COCKTAIL_HINT)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_MOLOTOV_COCKTAIL')
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="resource3d", value='RES3D_MOLOTOV_COCKTAIL')
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="value", value=5.00)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="weight", value=0.80)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="stacking", value=5)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="maximale_feuerreichweite", value=23)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="feuergeschwindigkeit", value=40.00)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="genauigkeit", value=0.4)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="kampfwert_air", value=15.00)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="kampfwert_armoured", value=100.00)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="kampfwert_infantry", value=100.00)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="munitionsarten", value=['SET_MOLOTOV_COCKTAIL_PSEUDOAMMO'])
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="fire_animation", value=FPA_THROW_GRENADE)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="weapon_type", value="wurf")
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="hoerweite", 					value=0.0)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="schusspausenzeit", 			value=3.0)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="genauigkeit_bewegte_ziele",	value=0.2)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="occupied_slots", value=["throw"])
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="combine_xp", value=25)
objects.set_attribute(object='SET_MOLOTOV_COCKTAIL', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
#	"skill"					:	"explosives",
	"assemble_function"		:	"assemble_explosives",
	"combination_list"		:	[
								['SET_RAGS','SET_BOTTLE_OF_HOOCH']]})

create_throw_object_type(typeid='SET_THROWING_KNIFE')
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="name", value=globaltext.SET_THROWING_KNIFE_NAME)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="hint", value=globaltext.SET_THROWING_KNIFE_HINT)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="resourceui", value='RES_ITEM65X32_WEAPON_THROWING_KNIFE')
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="resource3d", value='RES3D_THROWING_KNIFE')
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="value", value=3.00)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="weight", value=0.10)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="stacking", value=5)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="maximale_feuerreichweite", value=23)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="feuergeschwindigkeit", value=0)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="genauigkeit", value=0.6)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="kampfwert_air", value=15.00)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="kampfwert_armoured", value=100.00)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="kampfwert_infantry", value=100.00)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="munitionsarten", value=['SET_THROWING_KNIFE_PSEUDOAMMO'])
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="fire_animation", value=FPA_THROW_KNIFE)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="weapon_type", value="wurf")
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="magazingroesse", value=1.0)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="hoerweite", value=0.0)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="schusspausenzeit", value=1.5)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="genauigkeit_bewegte_ziele", value=0.5)
objects.set_attribute(object='SET_THROWING_KNIFE', attribute="occupied_slots", value=["throw"])

create_throw_object_type(typeid='SET_DART')
objects.set_attribute(object='SET_DART', attribute="name", value=globaltext.SET_DART_NAME)
objects.set_attribute(object='SET_DART', attribute="hint", value=globaltext.SET_DART_HINT)
objects.set_attribute(object='SET_DART', attribute="resourceui", value='RES_ITEM65X32_WEAPON_DART')
objects.set_attribute(object='SET_DART', attribute="resource3d", value='RES3D_DART')
objects.set_attribute(object='SET_DART', attribute="value", value=3.00)
objects.set_attribute(object='SET_DART', attribute="weight", value=0.25)
objects.set_attribute(object='SET_DART', attribute="stacking", value=5)
objects.set_attribute(object='SET_DART', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_DART', attribute="maximale_feuerreichweite", value=15)
objects.set_attribute(object='SET_DART', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_DART', attribute="feuergeschwindigkeit", value=40.00)
objects.set_attribute(object='SET_DART', attribute="genauigkeit", value=0.7)
objects.set_attribute(object='SET_DART', attribute="kampfwert_air", value=15.00)
objects.set_attribute(object='SET_DART', attribute="kampfwert_armoured", value=100.00)
objects.set_attribute(object='SET_DART', attribute="kampfwert_infantry", value=100.00)
objects.set_attribute(object='SET_DART', attribute="munitionsarten", value=['SET_DART_PSEUDOAMMO'])
objects.set_attribute(object='SET_DART', attribute="fire_animation", value=FPA_THROW_KNIFE)
objects.set_attribute(object='SET_DART', attribute="weapon_type", value="wurf")
objects.set_attribute(object='SET_DART', attribute="magazingroesse", 			value=1.0)
objects.set_attribute(object='SET_DART', attribute="hoerweite", 					value=0.0)
objects.set_attribute(object='SET_DART', attribute="schusspausenzeit", 			value=0.5)
objects.set_attribute(object='SET_DART', attribute="genauigkeit_bewegte_ziele",	value=0.2)
objects.set_attribute(object='SET_DART', attribute="occupied_slots", value=["throw"])

create_throw_object_type(typeid='SET_SHURIKEN')
objects.set_attribute(object='SET_SHURIKEN', attribute="name", value=globaltext.SET_SHURIKEN_NAME)
objects.set_attribute(object='SET_SHURIKEN', attribute="hint", value=globaltext.SET_SHURIKEN_HINT)
objects.set_attribute(object='SET_SHURIKEN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SHURIKEN')
objects.set_attribute(object='SET_SHURIKEN', attribute="resource3d", value='RES3D_SHURIKEN')
objects.set_attribute(object='SET_SHURIKEN', attribute="value", value=6.00)
objects.set_attribute(object='SET_SHURIKEN', attribute="weight", value=0.10)
objects.set_attribute(object='SET_SHURIKEN', attribute="stacking", value=5)
objects.set_attribute(object='SET_SHURIKEN', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_SHURIKEN', attribute="maximale_feuerreichweite", value=15)
objects.set_attribute(object='SET_SHURIKEN', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_SHURIKEN', attribute="feuergeschwindigkeit", value=40.00)
objects.set_attribute(object='SET_SHURIKEN', attribute="genauigkeit", value=1.0)
objects.set_attribute(object='SET_SHURIKEN', attribute="kampfwert_air", value=15.00)
objects.set_attribute(object='SET_SHURIKEN', attribute="kampfwert_armoured", value=100.00)
objects.set_attribute(object='SET_SHURIKEN', attribute="kampfwert_infantry", value=100.00)
objects.set_attribute(object='SET_SHURIKEN', attribute="munitionsarten", value=['SET_SHURIKEN_PSEUDOAMMO'])
objects.set_attribute(object='SET_SHURIKEN', attribute="fire_animation", value=FPA_THROW_KNIFE)
objects.set_attribute(object='SET_SHURIKEN', attribute="weapon_type", value="wurf")
objects.set_attribute(object='SET_SHURIKEN', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_SHURIKEN', attribute="hoerweite", 					value=0.0)
objects.set_attribute(object='SET_SHURIKEN', attribute="schusspausenzeit", 			value=0.1)
objects.set_attribute(object='SET_SHURIKEN', attribute="genauigkeit_bewegte_ziele",	value=0.8)
objects.set_attribute(object='SET_SHURIKEN', attribute="occupied_slots", value=["throw"])

create_throw_object_type(typeid='SET_GAS_BOMB')
objects.set_attribute(object='SET_GAS_BOMB', attribute="name", value=globaltext.SET_GAS_BOMB_NAME)
objects.set_attribute(object='SET_GAS_BOMB', attribute="hint", value=globaltext.SET_GAS_BOMB_HINT)
objects.set_attribute(object='SET_GAS_BOMB', attribute="resourceui", value='RES_ITEM65X32_WEAPON_GAS_BOMB')
objects.set_attribute(object='SET_GAS_BOMB', attribute="resource3d", value='RES3D_GAS_BOMB')
objects.set_attribute(object='SET_GAS_BOMB', attribute="value", value=3.00)
objects.set_attribute(object='SET_GAS_BOMB', attribute="weight", value=1.00)
objects.set_attribute(object='SET_GAS_BOMB', attribute="stacking", value=5)
objects.set_attribute(object='SET_GAS_BOMB', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_GAS_BOMB', attribute="maximale_feuerreichweite", value=50)
objects.set_attribute(object='SET_GAS_BOMB', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_GAS_BOMB', attribute="feuergeschwindigkeit", value=40.00)
objects.set_attribute(object='SET_GAS_BOMB', attribute="kampfwert_air", value=15.00)
objects.set_attribute(object='SET_GAS_BOMB', attribute="kampfwert_armoured", value=100.00)
objects.set_attribute(object='SET_GAS_BOMB', attribute="kampfwert_infantry", value=100.00)
objects.set_attribute(object='SET_GAS_BOMB', attribute="munitionsarten", value=['SET_GAS_BOMB_PSEUDOAMMO'])
objects.set_attribute(object='SET_GAS_BOMB', attribute="fire_animation", value=FPA_THROW_GRENADE)
objects.set_attribute(object='SET_GAS_BOMB', attribute="weapon_type", value="wurf")
objects.set_attribute(object='SET_GAS_BOMB', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_GAS_BOMB', attribute="hoerweite", 					value=0.0)
objects.set_attribute(object='SET_GAS_BOMB', attribute="not_tradable", value=True)

## explosivwaffen
create_item_type(typeid='SET_C4_TIMEBASED')
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="name", value=globaltext.SET_C4_TIMEBASED_NAME)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="hint", value=globaltext.SET_C4_TIMEBASED_HINT)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_C4_TIMEBASED')
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="resource3d", value='RES3D_C4_TIMEBASED')
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="value", value=15.00)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="weight", value=0.1)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="stacking", value=5)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="weapon_type", value="explosiv")
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="hoerweite", 		value=50.0)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="minimale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="maximale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="salvenlaenge", 			 value=1)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="feuergeschwindigkeit",	 value=0.0)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="bomb_type",	 value="timebased")
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="wirkungsbereich", value=15)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="durchschlag", value=200)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="schaden_organisch_min", value=150)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="schaden_organisch_max", value=200)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="schaden_struktur_min", value=400)
objects.set_attribute(object='SET_C4_TIMEBASED', attribute="schaden_struktur_max", value=500)

create_item_type(typeid='SET_ANTITANKMINE')
objects.set_attribute(object='SET_ANTITANKMINE', attribute="name", value=globaltext.SET_ANTITANKMINE_NAME)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="hint", value=globaltext.SET_ANTITANKMINE_HINT)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="resourceui", value='RES_ITEM65X32_ANTITANKMINE')
objects.set_attribute(object='SET_ANTITANKMINE', attribute="resource3d", value='RES3D_ANTITANKMINE')
objects.set_attribute(object='SET_ANTITANKMINE', attribute="value", value=20.00)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="weight", value=2)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="stacking", value=5)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="weapon_type", value="explosiv")
objects.set_attribute(object='SET_ANTITANKMINE', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="hoerweite", 		value=40.0)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="minimale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="maximale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="salvenlaenge", 			 value=1)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="feuergeschwindigkeit",	 value=0.0)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="bomb_type",	 value="mine")
objects.set_attribute(object='SET_ANTITANKMINE', attribute="wirkungsbereich", value=15)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="durchschlag", value=400)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="schaden_organisch_min", value=500)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="schaden_organisch_max", value=600)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="schaden_struktur_min", value=1500)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="schaden_struktur_max", value=2000)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="targets", value=["vehicle"])
objects.set_attribute(object='SET_ANTITANKMINE', attribute="detection_range", value=10.0)
objects.set_attribute(object='SET_ANTITANKMINE', attribute="not_tradable", value=True)

create_item_type(typeid='SET_LANDMINE')
objects.set_attribute(object='SET_LANDMINE', attribute="name", value=globaltext.SET_LANDMINE_NAME)
objects.set_attribute(object='SET_LANDMINE', attribute="hint", value=globaltext.SET_LANDMINE_HINT)
objects.set_attribute(object='SET_LANDMINE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_LANDMINE')
objects.set_attribute(object='SET_LANDMINE', attribute="resource3d", value='RES3D_LANDMINE')
objects.set_attribute(object='SET_LANDMINE', attribute="value", value=3.00)
objects.set_attribute(object='SET_LANDMINE', attribute="weight", value=0.3)
objects.set_attribute(object='SET_LANDMINE', attribute="stacking", value=5)
objects.set_attribute(object='SET_LANDMINE', attribute="weapon_type", value="explosiv")
objects.set_attribute(object='SET_LANDMINE', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_LANDMINE', attribute="hoerweite", 		value=40.0)
objects.set_attribute(object='SET_LANDMINE', attribute="minimale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_LANDMINE', attribute="maximale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_LANDMINE', attribute="salvenlaenge", 			 value=1)
objects.set_attribute(object='SET_LANDMINE', attribute="feuergeschwindigkeit",	 value=0.0)
objects.set_attribute(object='SET_LANDMINE', attribute="bomb_type",	 value="mine")
objects.set_attribute(object='SET_LANDMINE', attribute="wirkungsbereich", value=15)
objects.set_attribute(object='SET_LANDMINE', attribute="durchschlag", value=200)
objects.set_attribute(object='SET_LANDMINE', attribute="schaden_organisch_min", value=250)
objects.set_attribute(object='SET_LANDMINE', attribute="schaden_organisch_max", value=300)
objects.set_attribute(object='SET_LANDMINE', attribute="schaden_struktur_min", value=50)
objects.set_attribute(object='SET_LANDMINE', attribute="schaden_struktur_max", value=60)
objects.set_attribute(object='SET_LANDMINE', attribute="targets", value=["character", "animal"])
objects.set_attribute(object='SET_LANDMINE', attribute="detection_range", value=4.0)
objects.set_attribute(object='SET_LANDMINE', attribute="not_tradable", value=True)

create_item_type(typeid='SET_C4_REMOTE_CONTROL')
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="name", value=globaltext.SET_C4_REMOTE_CONTROL_NAME)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="hint", value=globaltext.SET_C4_REMOTE_CONTROL_HINT)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_C4_REMOTE_CONTROL')
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="resource3d", value='RES3D_C4_REMOTE_CONTROL')
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="value", value=30.00)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="weight", value=0.25)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="stacking", value=5)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="weapon_type", value="explosiv")
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="hoerweite", 		value=50.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="minimale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="maximale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="salvenlaenge", 			  value=1)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="feuergeschwindigkeit",	  value=0.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="bomb_type",	  value="remotecontrol")
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="wirkungsbereich", value=15)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="durchschlag", value=200)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="schaden_organisch_min", value=150)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="schaden_organisch_max", value=200)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="schaden_struktur_min", value=400)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL', attribute="schaden_struktur_max", value=500)

create_item_type(typeid='SET_C4_TIMEBASED_W_NAILS')
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="name", value=globaltext.SET_C4_TIMEBASED_W_NAILS_NAME)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="hint", value=globaltext.SET_C4_TIMEBASED_W_NAILS_HINT)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_C4_TIMEBASED_W_NAILS')
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="resource3d", value='RES3D_C4_TIMEBASED_W_NAILS')
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="value", value=16.0)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="weight", value=0.3)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="weapon_type", value="explosiv")
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="stacking", value=5)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="hoerweite", 		value=50.0)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="minimale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="maximale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="salvenlaenge", 			  value=1)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="feuergeschwindigkeit",	  value=0.0)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="bomb_type",	  value="timebased")
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="wirkungsbereich", value=15)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="durchschlag", value=200)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="schaden_organisch_min", value=150)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="schaden_organisch_max", value=200)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="schaden_struktur_min", value=400)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="schaden_struktur_max", value=500)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="combine_xp", value=200)
objects.set_attribute(object='SET_C4_TIMEBASED_W_NAILS', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
#	"skill"					:	"explosives",
	"assemble_function"		:	"assemble_explosives",
	"combination_list"		:	[
								['SET_SHORT_NAILS','SET_C4_TIMEBASED']]})

create_item_type(typeid='SET_C4_REMOTE_CONTROL_W_NAILS')
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="name", value=globaltext.SET_C4_REMOTE_CONTROL_W_NAILS_NAME)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="hint", value=globaltext.SET_C4_REMOTE_CONTROL_W_NAILS_HINT)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_C4_REMOTE_CONTROL_W_NAILS')
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="resource3d", value='RES3D_C4_REMOTE_CONTROL_W_NAILS')
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="value", value=31.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="weight", value=0.3)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="weapon_type", value="explosiv")
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="stacking", value=5)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="hoerweite", 		value=50.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="minimale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="maximale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="salvenlaenge", 			  value=1)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="feuergeschwindigkeit",	  value=0.0)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="bomb_type",	  value="remotecontrol")
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="wirkungsbereich", value=15)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="durchschlag", value=200)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="schaden_organisch_min", value=150)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="schaden_organisch_max", value=200)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="schaden_struktur_min", value=400)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="schaden_struktur_max", value=500)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="combine_xp", value=200)
objects.set_attribute(object='SET_C4_REMOTE_CONTROL_W_NAILS', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
#	"skill"					:	"explosives",
	"assemble_function"		:	"assemble_explosives",
	"combination_list"		:	[
								['SET_SHORT_NAILS','SET_C4_REMOTE_CONTROL']]})
create_item_type(typeid='SET_FERTILIZER_EXPLOSIVE_TIME_BASED')
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="name", value=globaltext.SET_FERTILIZER_EXPLOSIVE_TIME_BASED_NAME)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="hint", value=globaltext.SET_FERTILIZER_EXPLOSIVE_TIME_BASED_HINT)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_FERTILIZER_EXPLOSIVE_TIME_BASED')
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="resource3d", value='RES3D_FERTILIZER_EXPLOSIVE_TIME_BASED')
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="value", value=27.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="weight", value=0.2)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="stacking", value=5)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="weapon_type", value="explosiv")
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="hoerweite", 		value=50.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="minimale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="maximale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="salvenlaenge", 			  value=1)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="feuergeschwindigkeit",	  value=0.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="bomb_type",	  value="timebased")
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="wirkungsbereich", value=15)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="durchschlag", value=200)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="schaden_organisch_min", value=150)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="schaden_organisch_max", value=200)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="schaden_struktur_min", value=400)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="schaden_struktur_max", value=500)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_TIME_BASED', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_explosives",
	"combination_list"		:	[
								['SET_AMMONIUM_NITRATE', 'SET_DIESEL', 'SET_LEAD_PIPE', 'SET_TIME_FUSE']]})

create_item_type(typeid='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL')
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="name", value=globaltext.SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL_NAME)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="hint", value=globaltext.SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL_HINT)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL')
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="resource3d", value='RES3D_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL')
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="value", value=37.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="weight", value=0.2)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="stacking", value=5)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="weapon_type", value="explosiv")
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="hoerweite", 		value=50.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="minimale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="maximale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="salvenlaenge", 			  value=1)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="feuergeschwindigkeit",	  value=0.0)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="bomb_type",	  value="remotecontrol")
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="wirkungsbereich", value=15)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="durchschlag", value=200)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="schaden_organisch_min", value=150)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="schaden_organisch_max", value=200)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="schaden_struktur_min", value=400)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="schaden_struktur_max", value=500)
objects.set_attribute(object='SET_FERTILIZER_EXPLOSIVE_REMOTE_CONTROL', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_EVERYBODY,
	"assemble_function"		:	"assemble_explosives",
	"combination_list"		:	[
								['SET_AMMONIUM_NITRATE', 'SET_DIESEL', 'SET_LEAD_PIPE', 'SET_REMOTE_FUSE']]})

create_item_type(typeid='SET_DYNAMITE')
objects.set_attribute(object='SET_DYNAMITE', attribute="name", value=globaltext.SET_DYNAMITE_NAME)
objects.set_attribute(object='SET_DYNAMITE', attribute="hint", value=globaltext.SET_DYNAMITE_HINT)
objects.set_attribute(object='SET_DYNAMITE', attribute="resourceui", value='RES_ITEM65X32_EXPLOSIVE_DYNAMITE')
objects.set_attribute(object='SET_DYNAMITE', attribute="resource3d", value='RES3D_EXPLOSIVE_DYNAMITE')
objects.set_attribute(object='SET_DYNAMITE', attribute="value", value=10.00)
objects.set_attribute(object='SET_DYNAMITE', attribute="weight", value=0.5)
objects.set_attribute(object='SET_DYNAMITE', attribute="stacking", value=5)
objects.set_attribute(object='SET_DYNAMITE', attribute="weapon_type", value="explosiv")
objects.set_attribute(object='SET_DYNAMITE', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_DYNAMITE', attribute="hoerweite", 		value=60.0)
objects.set_attribute(object='SET_DYNAMITE', attribute="minimale_feuerreichweite", value=0.0)
objects.set_attribute(object='SET_DYNAMITE', attribute="maximale_feuerreichweite", value=25.0)
objects.set_attribute(object='SET_DYNAMITE', attribute="salvenlaenge", 			 value=1)
objects.set_attribute(object='SET_DYNAMITE', attribute="feuergeschwindigkeit",	 value=0.0)
objects.set_attribute(object='SET_DYNAMITE', attribute="bomb_type",	  value="remotecontrol")
objects.set_attribute(object='SET_DYNAMITE', attribute="wirkungsbereich", value=15)
objects.set_attribute(object='SET_DYNAMITE', attribute="durchschlag", value=200)
objects.set_attribute(object='SET_DYNAMITE', attribute="schaden_organisch_min", value=150)
objects.set_attribute(object='SET_DYNAMITE', attribute="schaden_organisch_max", value=200)
objects.set_attribute(object='SET_DYNAMITE', attribute="schaden_struktur_min", value=400)
objects.set_attribute(object='SET_DYNAMITE', attribute="schaden_struktur_max", value=500)

#close combat weapons
create_weapon_type(typeid='SET_FIST')
objects.set_attribute(object='SET_FIST', attribute="name", value=globaltext.SET_FIST_NAME)
objects.set_attribute(object='SET_FIST', attribute="hint", value=globaltext.SET_FIST_HINT)
objects.set_attribute(object='SET_FIST', attribute="value", value=0.00)
objects.set_attribute(object='SET_FIST', attribute="weight", value=0.0)
objects.set_attribute(object='SET_FIST', attribute="stacking", value=1)
objects.set_attribute(object='SET_FIST', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_FIST', attribute="hoerweite", value=1.0)
objects.set_attribute(object='SET_FIST', attribute="schusspausenzeit", value=1.0)
objects.set_attribute(object='SET_FIST', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_FIST', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_FIST', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_FIST', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_FIST', attribute="genauigkeit", value=0.7)
objects.set_attribute(object='SET_FIST', attribute="genauigkeit_bewegte_ziele", value=1.0)
objects.set_attribute(object='SET_FIST', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_FIST', attribute="occupied_slots", value=["right_hand","left_hand"])
objects.set_attribute(object='SET_FIST', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BOXING)
objects.set_attribute(object='SET_FIST', attribute="munitionsarten", value=['SET_FIST_PSEUDOAMMO'])
objects.set_attribute(object='SET_FIST', attribute="effects", value={"sound_shot"	: ["attack_fist_01","attack_fist_02","attack_fist_03","attack_fist_04"]})
objects.set_attribute(object='SET_FIST', attribute="illegal_bodymodes", value=["LIE","KNEEL"])
objects.set_attribute(object='SET_FIST', attribute="not_tradable", value=True)

create_weapon_type(typeid='SET_BRASS_KNUCKLES')
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="name", value=globaltext.SET_BRASS_KNUCKLES_NAME)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="hint", value=globaltext.SET_BRASS_KNUCKLES_HINT)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_BRASS_KNUCKLES')
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="resource3d", value='RES3D_BRASS_KNUCKLES')
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="value", value=2.00)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="weight", value=0.20)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="stacking", value=1)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="hoerweite", value=1.0)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="schusspausenzeit", value=0.7)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="genauigkeit_bewegte_ziele",	value=1.0)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="genauigkeit", value=0.6)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="magazingroesse", value=1.0)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BOXING)
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="munitionsarten", value=['SET_BRASS_KNUCKLES_PSEUDOAMMO'])
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="effects", value={"sound_shot"	: ["attack_fist_01","attack_fist_02","attack_fist_03","attack_fist_04"]})
objects.set_attribute(object='SET_BRASS_KNUCKLES', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_MANSLAYER')
objects.set_attribute(object='SET_MANSLAYER', attribute="name", value=globaltext.SET_MANSLAYER_NAME)
objects.set_attribute(object='SET_MANSLAYER', attribute="hint", value=globaltext.SET_MANSLAYER_HINT)
objects.set_attribute(object='SET_MANSLAYER', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_MANSLAYER')
objects.set_attribute(object='SET_MANSLAYER', attribute="resource3d", value='RES3D_MANSLAYER')
objects.set_attribute(object='SET_MANSLAYER', attribute="value", value=3.00)
objects.set_attribute(object='SET_MANSLAYER', attribute="weight", value=1.50)
objects.set_attribute(object='SET_MANSLAYER', attribute="stacking", value=1)
objects.set_attribute(object='SET_MANSLAYER', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_MANSLAYER', attribute="hoerweite", value=1.0)
objects.set_attribute(object='SET_MANSLAYER', attribute="schusspausenzeit", value=0.8)
objects.set_attribute(object='SET_MANSLAYER', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_MANSLAYER', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_MANSLAYER', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_MANSLAYER', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_MANSLAYER', attribute="genauigkeit", value=0.6)
objects.set_attribute(object='SET_MANSLAYER', attribute="genauigkeit_bewegte_ziele", value=1.0)
objects.set_attribute(object='SET_MANSLAYER', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_MANSLAYER', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_MANSLAYER', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
objects.set_attribute(object='SET_MANSLAYER', attribute="munitionsarten", value=['SET_MANSLAYER_PSEUDOAMMO'])
objects.set_attribute(object='SET_MANSLAYER', attribute="effects", value={"sound_shot"	: ["attack_baseball_bat"]})
objects.set_attribute(object='SET_MANSLAYER', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_RUSTY_IRON_ROD')
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="name", value=globaltext.SET_RUSTY_IRON_ROD_NAME)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="hint", value=globaltext.SET_RUSTY_IRON_ROD_HINT)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_RUSTY_IRON_ROD')
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="resource3d", value='RES3D_RUSTY_IRON_ROD')
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="value", value=1.00)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="weight", value=1.00)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="stacking", value=1)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="hoerweite", value=2.0)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="schusspausenzeit", value=3.0)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="genauigkeit_bewegte_ziele",	value=0.6)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="genauigkeit", value=0.4)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="munitionsarten", value=['SET_RUSTY_IRON_ROD_PSEUDOAMMO'])
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="effects", value={"sound_shot"	: ["attack_baseball_bat"]})
objects.set_attribute(object='SET_RUSTY_IRON_ROD', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_BASEBALL_BAT')
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="name", value=globaltext.SET_BASEBALL_BAT_NAME)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="hint", value=globaltext.SET_BASEBALL_BAT_HINT)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_BASEBALL_BAT')
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="resource3d", value='RES3D_BASEBALL_BAT')
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="value", value=3.00)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="weight", value=2.50)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="stacking", value=1)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="hoerweite", value=2.0)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="schusspausenzeit", value=2.0)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="genauigkeit_bewegte_ziele", value=0.7)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="genauigkeit", value=0.5)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="munitionsarten", value=['SET_BASEBALL_BAT_PSEUDOAMMO'])
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="effects", value={"sound_shot"	: ["attack_baseball_bat"]})
objects.set_attribute(object='SET_BASEBALL_BAT', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_SPIKED_BASEBALL_BAT')
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="name", value=globaltext.SET_SPIKED_BASEBALL_BAT_NAME)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="hint", value=globaltext.SET_SPIKED_BASEBALL_BAT_HINT)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_SPIKED_BASEBALL_BAT')
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="resource3d", value='RES3D_SPIKED_BASEBALL_BAT')
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="value", value=10.0)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="weight", value=2.7)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="stacking", value=1)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="hoerweite", value=3.0)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="schusspausenzeit", value=2.2)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="genauigkeit_bewegte_ziele", value=0.75)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="genauigkeit", value=0.4)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="magazingroesse", value=1.0)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="munitionsarten", value=['SET_SPIKED_BASEBALL_BAT_PSEUDOAMMO'])
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="effects", value={"sound_shot"	: ["attack_baseball_bat_nails"]})
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="illegal_bodymodes", value=["LIE","KNEEL"])
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="combine_xp", value=25)
objects.set_attribute(object='SET_SPIKED_BASEBALL_BAT', attribute="item_combination",	value={
	"difficulty_assemble"	:	55,
	"combination_list"		:	[
								['SET_BASEBALL_BAT','SET_LONG_NAILS']]})

create_weapon_type(typeid='SET_CLUB')
objects.set_attribute(object='SET_CLUB', attribute="name", value=globaltext.SET_CLUB_NAME)
objects.set_attribute(object='SET_CLUB', attribute="hint", value=globaltext.SET_CLUB_HINT)
objects.set_attribute(object='SET_CLUB', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_CLUB')
objects.set_attribute(object='SET_CLUB', attribute="resource3d", value='RES3D_CLUB')
objects.set_attribute(object='SET_CLUB', attribute="value", value=4.00)
objects.set_attribute(object='SET_CLUB', attribute="weight", value=3.00)
objects.set_attribute(object='SET_CLUB', attribute="stacking", value=1)
objects.set_attribute(object='SET_CLUB', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_CLUB', attribute="hoerweite", value=2.0)
objects.set_attribute(object='SET_CLUB', attribute="schusspausenzeit", value=1.0)
objects.set_attribute(object='SET_CLUB', attribute="genauigkeit_bewegte_ziele", value=0.8)
objects.set_attribute(object='SET_CLUB', attribute="genauigkeit", value=0.4)
objects.set_attribute(object='SET_CLUB', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_CLUB', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_CLUB', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_CLUB', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_CLUB', attribute="magazingroesse", value=1.0)
objects.set_attribute(object='SET_CLUB', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_CLUB', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
objects.set_attribute(object='SET_CLUB', attribute="munitionsarten", value=['SET_CLUB_PSEUDOAMMO'])
objects.set_attribute(object='SET_CLUB', attribute="effects", value={"sound_shot"	: ["attack_baseball_bat"]})
objects.set_attribute(object='SET_CLUB', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_KNIFE')
objects.set_attribute(object='SET_KNIFE', attribute="name", value=globaltext.SET_KNIFE_NAME)
objects.set_attribute(object='SET_KNIFE', attribute="hint", value=globaltext.SET_KNIFE_HINT)
objects.set_attribute(object='SET_KNIFE', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_KNIFE')
objects.set_attribute(object='SET_KNIFE', attribute="resource3d", value='RES3D_KNIFE')
objects.set_attribute(object='SET_KNIFE', attribute="value", value=7.00)
objects.set_attribute(object='SET_KNIFE', attribute="weight", value=0.10)
objects.set_attribute(object='SET_KNIFE', attribute="stacking", value=1)
objects.set_attribute(object='SET_KNIFE', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_KNIFE', attribute="hoerweite", value=0.0)
objects.set_attribute(object='SET_KNIFE', attribute="schusspausenzeit", value=1.5)
objects.set_attribute(object='SET_KNIFE', attribute="genauigkeit_bewegte_ziele", value=0.6)
objects.set_attribute(object='SET_KNIFE', attribute="genauigkeit", value=0.3)
objects.set_attribute(object='SET_KNIFE', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_KNIFE', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_KNIFE', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_KNIFE', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_KNIFE', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_KNIFE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
objects.set_attribute(object='SET_KNIFE', attribute="munitionsarten", value=['SET_KNIFE_PSEUDOAMMO'])
objects.set_attribute(object='SET_KNIFE', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_KNIFE', attribute="effects", value={"sound_shot"	: "attack_knife"})
objects.set_attribute(object='SET_KNIFE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])
objects.set_attribute(object='SET_KNIFE', attribute="Fire_Modes", value={
		"Throw"	: 10,
		"Baton"	: 3, 
		"Thrust": 2
		})
objects.set_attribute(object='SET_KNIFE', attribute="Current_Fire_Mode", value="Thrust")

create_weapon_type(typeid='SET_BIG_KNIFE')
objects.set_attribute(object='SET_BIG_KNIFE', attribute="name", value=globaltext.SET_BIG_KNIFE_NAME)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="hint", value=globaltext.SET_BIG_KNIFE_HINT)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_BIG_KNIFE')
objects.set_attribute(object='SET_BIG_KNIFE', attribute="resource3d", value='RES3D_BIG_KNIFE')
objects.set_attribute(object='SET_BIG_KNIFE', attribute="value", value=15.00)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="weight", value=0.20)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="stacking", value=1)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_BIG_KNIFE', attribute="hoerweite", value=1.0)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="schusspausenzeit", value=2.5)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="genauigkeit_bewegte_ziele", value=0.5)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="genauigkeit", value=0.4)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_BIG_KNIFE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])
objects.set_attribute(object='SET_BIG_KNIFE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_THRUSTING)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="munitionsarten", value=['SET_BIG_KNIFE_PSEUDOAMMO'])
objects.set_attribute(object='SET_BIG_KNIFE', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_BIG_KNIFE', attribute="effects", value={"sound_shot"	: "attack_knife"})

create_weapon_type(typeid='SET_MACHETE')
objects.set_attribute(object='SET_MACHETE', attribute="name", value=globaltext.SET_MACHETE_NAME)
objects.set_attribute(object='SET_MACHETE', attribute="hint", value=globaltext.SET_MACHETE_HINT)
objects.set_attribute(object='SET_MACHETE', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_MACHETE')
objects.set_attribute(object='SET_MACHETE', attribute="resource3d", value='RES3D_MACHETE')
objects.set_attribute(object='SET_MACHETE', attribute="value", value=20.00)
objects.set_attribute(object='SET_MACHETE', attribute="weight", value=1.20)
objects.set_attribute(object='SET_MACHETE', attribute="stacking", value=1)
objects.set_attribute(object='SET_MACHETE', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_MACHETE', attribute="hoerweite", value=2.0)
objects.set_attribute(object='SET_MACHETE', attribute="schusspausenzeit", value=2.0)
objects.set_attribute(object='SET_MACHETE', attribute="genauigkeit_bewegte_ziele", value=0.5)
objects.set_attribute(object='SET_MACHETE', attribute="genauigkeit", value=0.5)
objects.set_attribute(object='SET_MACHETE', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_MACHETE', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_MACHETE', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_MACHETE', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_MACHETE', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_MACHETE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
objects.set_attribute(object='SET_MACHETE', attribute="munitionsarten", value=['SET_MACHETE_PSEUDOAMMO'])
objects.set_attribute(object='SET_MACHETE', attribute="magazingroesse", value=1.0)
objects.set_attribute(object='SET_MACHETE', attribute="effects", value={"sound_shot"	: "attack_knife"})
objects.set_attribute(object='SET_MACHETE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_AXE')
objects.set_attribute(object='SET_AXE', attribute="name", value=globaltext.SET_AXE_NAME)
objects.set_attribute(object='SET_AXE', attribute="hint", value=globaltext.SET_AXE_HINT)
objects.set_attribute(object='SET_AXE', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AXE')
objects.set_attribute(object='SET_AXE', attribute="resource3d", value='RES3D_AXE')
objects.set_attribute(object='SET_AXE', attribute="value", value=10.00)
objects.set_attribute(object='SET_AXE', attribute="weight", value=4.00)
objects.set_attribute(object='SET_AXE', attribute="stacking", value=1)
objects.set_attribute(object='SET_AXE', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_AXE', attribute="hoerweite", value=2.0)
objects.set_attribute(object='SET_AXE', attribute="schusspausenzeit", value=4.0)
objects.set_attribute(object='SET_AXE', attribute="genauigkeit_bewegte_ziele", value=0.5)
objects.set_attribute(object='SET_AXE', attribute="genauigkeit", value=0.4)
objects.set_attribute(object='SET_AXE', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_AXE', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_AXE', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_AXE', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_AXE', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_AXE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
objects.set_attribute(object='SET_AXE', attribute="munitionsarten", value=['SET_AXE_PSEUDOAMMO'])
objects.set_attribute(object='SET_AXE', attribute="magazingroesse", value=1.0)
objects.set_attribute(object='SET_AXE', attribute="effects", value={"sound_shot"	: "attack_baseball_bat"})
objects.set_attribute(object='SET_AXE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_CHAIN_SAW')
objects.set_attribute(object='SET_CHAIN_SAW', attribute="name", value=globaltext.SET_CHAIN_SAW_NAME)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="hint", value=globaltext.SET_CHAIN_SAW_HINT)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_CHAIN_SAW')
objects.set_attribute(object='SET_CHAIN_SAW', attribute="resource3d", value='RES3D_CHAIN_SAW')
objects.set_attribute(object='SET_CHAIN_SAW', attribute="value", value=25.00)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="weight", value=6.00)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="stacking", value=1)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_CHAIN_SAW', attribute="hoerweite", value=20.0)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="schusspausenzeit", value=5.0)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="genauigkeit_bewegte_ziele", value=0.4)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="genauigkeit", value=0.3)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_CHAIN_SAW', attribute="fire_animation", value=FPA_CLOSE_COMBAT_CHAIN_SAW)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="munitionsarten", value=['SET_CHAIN_SAW_PSEUDOAMMO'])
objects.set_attribute(object='SET_CHAIN_SAW', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_CHAIN_SAW', attribute="effects", value={"sound_shot"	: "attack_chainsaw"})
objects.set_attribute(object='SET_CHAIN_SAW', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_KATANA')
objects.set_attribute(object='SET_KATANA', attribute="name", value=globaltext.SET_KATANA_NAME)
objects.set_attribute(object='SET_KATANA', attribute="hint", value=globaltext.SET_KATANA_HINT)
objects.set_attribute(object='SET_KATANA', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_KATANA')
objects.set_attribute(object='SET_KATANA', attribute="resource3d", value='RES3D_KATANA')
objects.set_attribute(object='SET_KATANA', attribute="value", value=35.00)
objects.set_attribute(object='SET_KATANA', attribute="weight", value=0.10)
objects.set_attribute(object='SET_KATANA', attribute="stacking", value=1)
objects.set_attribute(object='SET_KATANA', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_KATANA', attribute="hoerweite", value=2.0)
objects.set_attribute(object='SET_KATANA', attribute="schusspausenzeit", value=2.5)
objects.set_attribute(object='SET_KATANA', attribute="genauigkeit_bewegte_ziele",	value=0.7)
objects.set_attribute(object='SET_KATANA', attribute="genauigkeit", value=0.7)
objects.set_attribute(object='SET_KATANA', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_KATANA', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_KATANA', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_KATANA', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_KATANA', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_KATANA', attribute="fire_animation", value=FPA_CLOSE_COMBAT_THRUSTING)
objects.set_attribute(object='SET_KATANA', attribute="munitionsarten", value=['SET_KATANA_PSEUDOAMMO'])
objects.set_attribute(object='SET_KATANA', attribute="magazingroesse", value=1.0)
objects.set_attribute(object='SET_KATANA', attribute="effects", value={"sound_shot"	: "attack_knife"})
objects.set_attribute(object='SET_KATANA', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_BROKEN_OFF_BOTTLE')
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="name", value=globaltext.SET_BROKEN_OFF_BOTTLE_NAME)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="hint", value=globaltext.SET_BROKEN_OFF_BOTTLE_HINT)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_BROKEN_OFF_BOTTLE')
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="resource3d", value='RES3D_BROKEN_OFF_BOTTLE')
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="value", value=0.00)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="weight", value=0.10)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="stacking", value=1)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="hoerweite", value=2.0)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="schusspausenzeit", value=1.6)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="genauigkeit_bewegte_ziele",	value=0.6)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="genauigkeit", value=0.2)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="munitionsarten", value=['SET_BROKEN_OFF_BOTTLE_PSEUDOAMMO'])
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="magazingroesse",	value=1.0)
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="effects", value={"sound_shot"	: "attack_knife"})
objects.set_attribute(object='SET_BROKEN_OFF_BOTTLE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_GIANT_KNIFE')
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="name", value=globaltext.SET_GIANT_KNIFE_NAME)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="hint", value=globaltext.SET_GIANT_KNIFE_HINT)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="resourceui", value='RES_ITEM65X32_WEAPON_GIANT_KNIFE')
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="resource3d", value='RES3D_GIANT_KNIFE')
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="value", value=17.00)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="weight", value=0.10)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="stacking", value=1)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="hoerweite", value=2.0)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="schusspausenzeit", value=2.1)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="genauigkeit_bewegte_ziele", value=0.8)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="genauigkeit", value=0.5)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="maximale_feuerreichweite",	value=2)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="feuergeschwindigkeit",	value=0.0)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="fire_animation", value=FPA_CLOSE_COMBAT_BATON)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="munitionsarten", value=['SET_GIANT_KNIFE_PSEUDOAMMO'])
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="magazingroesse", value=1.0)
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="effects", value={"sound_shot"	: "attack_knife"})
objects.set_attribute(object='SET_GIANT_KNIFE', attribute="illegal_bodymodes", value=["LIE","KNEEL"])

create_weapon_type(typeid='SET_ELECTROSHOCKER')
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="name", value=globaltext.SET_ELECTROSHOCKER_NAME)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="hint", value=globaltext.SET_ELECTROSHOCKER_HINT)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="resourceui", value='RES_ITEM65X32_MISCITEM_ELECTROSHOCKER')
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="resource3d", value='RES3D_ELECTROSHOCKER')
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="value", value=17.0)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="weight", value=0.2)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="stacking", value=1)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="weapon_type", value="nahkampf")
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="hoerweite", value=1.0)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="schusspausenzeit", value=2.0)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="genauigkeit_bewegte_ziele",	value=0.4)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="genauigkeit", value=0.4)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="maximale_feuerreichweite", value=2)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="feuergeschwindigkeit", value=0.0)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="fire_animation", value=FPA_CLOSE_COMBAT_THRUSTING)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="munitionsarten", value=['SET_ELECTROSHOCKER_PSEUDOAMMO'])
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="magazingroesse",value=1.0)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="effects", value={"sound_shot"	: "attack_electro_shocker"})
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="illegal_bodymodes", value=["LIE","KNEEL"])
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="combine_xp", value=250)
objects.set_attribute(object='SET_ELECTROSHOCKER', attribute="item_combination",	value={
	"difficulty_assemble"	:	95,
	"combination_list"		:	[
								['SET_STEEL_TUBE','SET_BATTERY','SET_TRANSFORMER','SET_COPPER_WIRE','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_WHEELTANK_CANON')
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="name", value=globaltext.SET_WALTER_PPK_NAME)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="hint", value=globaltext.SET_WALTER_PPK_HINT)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="resourceui", value='RES_ITEM65X32_WEAPON_WALTER_PPK')
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="resource3d", value='RES3D_WALTER_PPK')
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="value", value=3.00)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="weight", value=0.57)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="stacking", value=1)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="maximale_feuerreichweite", value=13)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="feuergeschwindigkeit", value=50.00)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="genauigkeit", value=0.7)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="munitionsarten", value=[])
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="fire_animation", value=FPA_PISTOL_SINGLE)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="weapon_type", value="leicht")
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="magazingroesse", 				value=7.0)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="schusspausenzeit", 				value=0.8)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="genauigkeit_bewegte_ziele",		value=0.5)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="blockadewahrscheinlichkeit",	value=25.0)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="not_tradable", value=True)
objects.set_attribute(object='SET_WHEELTANK_CANON', attribute="effects", value={
		"sound_shot"	: "shot_walther_ppk",
		"sound_unload"	: "pistol_discharge",
		"sound_gunjam"	: "pistol_gunjam",
		"sound_reload"	: "pistol_charge",
		"flash_type"	: 2,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})


# Derff's weapons and modes
create_weapon_type(typeid='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_AK_47', new_typeid='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
objects.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
objects.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=37.00)
objects.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=4.7)
objects.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="undergun", value='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
		"sound_shot"	: "burst_ak_47",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_AK_47_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_AK_47','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_AK_47_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_AK_47', new_typeid='SET_AK_47_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_AK_47_SAWED_OFF_REMINGTON_M870_NAME)
objects.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_AK_47_SAWED_OFF_REMINGTON_M870_HINT)
objects.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_47_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_AK_47_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="value", value=39.00)
objects.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="weight", value=4.7)
objects.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="undergun", value='SET_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
		"sound_shot"	: "burst_ak_47",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_AK_47_SAWED_OFF_REMINGTON_M870', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_AK_47','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})


create_weapon_type(typeid='SET_AK_74_BG_15')
clone_weapon_type(typeid='SET_AK_74', new_typeid='SET_AK_74_BG_15')
objects.set_attribute(object='SET_AK_74_BG_15', attribute="name", value=globaltext.SET_AK_74_BG_15_NAME)
objects.set_attribute(object='SET_AK_74_BG_15', attribute="hint", value=globaltext.SET_AK_74_BG_15_HINT)
objects.set_attribute(object='SET_AK_74_BG_15', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_74_BG_15')
objects.set_attribute(object='SET_AK_74_BG_15', attribute="resource3d", value='RES3D_AK_74_BG_15')
objects.set_attribute(object='SET_AK_74_BG_15', attribute="value", value=50.00)	# [BrainRipper]
objects.set_attribute(object='SET_AK_74_BG_15', attribute="weight", value=5.1)
objects.set_attribute(object='SET_AK_74_BG_15', attribute="undergun", value="SET_BG_15")
objects.set_attribute(object='SET_AK_74_BG_15', attribute="ButtOff", value="RES_ITEM65X32_WEAPON_AK_74_BG_15_X")
objects.set_attribute(object='SET_AK_74_BG_15', attribute="effects", value={
		"sound_shot"	: "burst_ak_74",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_AK_74_BG_15', attribute="item_combination",	value={
	"difficulty_assemble"		:	COMBO_DIFFICULT,
	"difficulty_disassemble"	:	COMBO_DIFFICULT,
	"assemble_function"		:"assemble_over_and_under_gun",
	"disassemble_function"		:"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_AK_74','SET_BG_15']]})		

create_weapon_type(typeid='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_AK_74', new_typeid='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
objects.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
objects.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=37.00)
objects.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=5.1)
objects.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="undergun", value="SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL")
objects.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="ButtOff", value="RES_ITEM65X32_WEAPON_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_X" )
objects.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
		"sound_shot"	: "burst_ak_74",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_AK_74_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_AK_74','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_AK_74_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_AK_74', new_typeid='SET_AK_74_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_AK_74_SAWED_OFF_REMINGTON_M870_NAME)
objects.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_AK_74_SAWED_OFF_REMINGTON_M870_HINT)
objects.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_74_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_AK_74_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="value", value=39.00)
objects.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="weight", value=5.1)
objects.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="undergun", value="SET_SAWED_OFF_REMINGTON_M870")
objects.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="ButtOff", value="RES_ITEM65X32_WEAPON_AK_74_SAWED_OFF_REMINGTON_M870_X" )
objects.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
		"sound_shot"	: "burst_ak_74",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_AK_74_SAWED_OFF_REMINGTON_M870', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_AK_74','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_M_16_M203')
clone_weapon_type(typeid='SET_M_16', new_typeid='SET_M_16_M203')
objects.set_attribute(object='SET_M_16_M203', attribute="name", value=globaltext.SET_M_16_M203_NAME)
objects.set_attribute(object='SET_M_16_M203', attribute="hint", value=globaltext.SET_M_16_M203_HINT)
objects.set_attribute(object='SET_M_16_M203', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_16_M203')
objects.set_attribute(object='SET_M_16_M203', attribute="resource3d", value='RES3D_M_16_M203')
objects.set_attribute(object='SET_M_16_M203', attribute="value", value=50.00)	# [BrainRipper]
objects.set_attribute(object='SET_M_16_M203', attribute="weight", value=3.6)
objects.set_attribute(object='SET_M_16_M203', attribute="undergun", value="SET_M_203")
objects.set_attribute(object='SET_M_16_M203', attribute="ButtOn", value="RES_ITEM65X32_WEAPON_M_16_M203_X")
objects.set_attribute(object='SET_M_16_M203', attribute="effects", value={
		"sound_shot"	: "burst_m4a1",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_M_16_M203', attribute="item_combination",	value={
	"difficulty_assemble"		:	COMBO_DIFFICULT,
	"difficulty_disassemble"	:	COMBO_DIFFICULT,
	"assemble_function"		:"assemble_over_and_under_gun",
	"disassemble_function"		:"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_M_16','SET_M_203']]})
		

create_weapon_type(typeid='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_M_16', new_typeid='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
objects.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
objects.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=37.00)
objects.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=3.8)
objects.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="undergun", value='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="ButtOn", value='RES_ITEM65X32_WEAPON_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_X')
objects.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
		"sound_shot"	: "burst_m4a1",	# [BrainRipper]
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_M_16_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_M_16','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_M_16_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_M_16', new_typeid='SET_M_16_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_M_16_SAWED_OFF_REMINGTON_M870_NAME)
objects.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_M_16_SAWED_OFF_REMINGTON_M870_HINT)
objects.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_16_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_M_16_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="value", value=39.00)
objects.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="weight", value=3.8)
objects.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="undergun", value='SET_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="ButtOn", value='RES_ITEM65X32_WEAPON_M_16_SAWED_OFF_REMINGTON_M870_X')
objects.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
		"sound_shot"	: "burst_m4a1",	# [BrainRipper]
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_M_16_SAWED_OFF_REMINGTON_M870', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_M_16','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_HK_G36C', new_typeid='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=52.00)
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=4.2)
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="undergun", value='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="ButtOff", value='RES_ITEM65X32_WEAPON_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_X')
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
		"sound_shot"	: "burst_hk_g36c",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_HK_G36C','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_HK_G36C_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_HK_G36C', new_typeid='SET_HK_G36C_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_HK_G36C_SAWED_OFF_REMINGTON_M870_NAME)
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_HK_G36C_SAWED_OFF_REMINGTON_M870_HINT)
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G36C_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_HK_G36C_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="value", value=54.00)
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="weight", value=4.2)
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="undergun", value='SET_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="ButtOff", value='RES_ITEM65X32_WEAPON_HK_G36C_SAWED_OFF_REMINGTON_M870_X')
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
		"sound_shot"	: "burst_hk_g36c",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_HK_G36C_SAWED_OFF_REMINGTON_M870', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_HK_G36C','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})


create_weapon_type(typeid='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_HK_G41', new_typeid='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=42.00)	# [BrainRipper]
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=4.9)
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="undergun", value='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="ButtOn", value='RES_ITEM65X32_WEAPON_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_X')
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
		"sound_shot"	: "burst_hk_g41",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_HK_G41','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_HK_G41_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_HK_G41', new_typeid='SET_HK_G41_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_HK_G41_SAWED_OFF_REMINGTON_M870_NAME)
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_HK_G41_SAWED_OFF_REMINGTON_M870_HINT)
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_HK_G41_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_HK_G41_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="value", value=44.00)
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="weight", value=4.9)
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="undergun", value='SET_REMINGTON_M870')
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="ButtOn", value='RES_ITEM65X32_WEAPON_HK_G41_SAWED_OFF_REMINGTON_M870_X')
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
		"sound_shot"	: "burst_hk_g41",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})
objects.set_attribute(object='SET_HK_G41_SAWED_OFF_REMINGTON_M870', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_HK_G41','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_OICW')
objects.set_attribute(object='SET_OICW', attribute="name", value=globaltext.SET_OICW_NAME)
objects.set_attribute(object='SET_OICW', attribute="hint", value=globaltext.SET_OICW_HINT)
objects.set_attribute(object='SET_OICW', attribute="resourceui", value='RES_ITEM65X32_WEAPON_OICW')
objects.set_attribute(object='SET_OICW', attribute="resource3d", value='RES3D_OICW')
objects.set_attribute(object='SET_OICW', attribute="value", value=60.00)
objects.set_attribute(object='SET_OICW', attribute="weight", value=6.0)
objects.set_attribute(object='SET_OICW', attribute="stacking", value=1)
objects.set_attribute(object='SET_OICW', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_OICW', attribute="maximale_feuerreichweite", value=35)
objects.set_attribute(object='SET_OICW', attribute="salvenlaenge", value=3)
objects.set_attribute(object='SET_OICW', attribute="feuergeschwindigkeit", value=750.00)
objects.set_attribute(object='SET_OICW', attribute="genauigkeit", value=1.2)
objects.set_attribute(object='SET_OICW', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_OICW', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_OICW', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_OICW', attribute="munitionsarten", value=['SET_AMMOPACK_5_56_MM','SET_AMMOPACK_5_56_MM_STEYR_FLECHETTE'])
objects.set_attribute(object='SET_OICW', attribute="fire_animation", value=FPA_SHOULDER_VOLLEY)
objects.set_attribute(object='SET_OICW', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_OICW', attribute="magazingroesse", 				value=30.0)
objects.set_attribute(object='SET_OICW', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_OICW', attribute="schusspausenzeit", 			value=3.0)
objects.set_attribute(object='SET_OICW', attribute="genauigkeit_bewegte_ziele",	value=1.2)
objects.set_attribute(object='SET_OICW', attribute="blockadewahrscheinlichkeit",	value=18.0)
objects.set_attribute(object='SET_OICW', attribute="undergun",	value="SET_OICW_UNDERGUN")
objects.set_attribute(object='SET_OICW', attribute="undergun_exists", value=True)
objects.set_attribute(object='SET_OICW', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_OICW', attribute="Fire_Modes", value={
		"Single"	: 1,
		"Auto"		: 3 
		})
objects.set_attribute(object='SET_OICW', attribute="Current_Fire_Mode", value="Auto")
objects.set_attribute(object='SET_OICW', attribute="effects", value={
		"sound_shot"	: "burst_oicw_gewehr",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.6,
		"fade_out"		: 50})


create_weapon_type(typeid='SET_OICW_UNDERGUN')
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="name", value=globaltext.SET_OICW_NAME)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="hint", value=globaltext.SET_OICW_HINT)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_OICW')
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="resource3d", value='RES3D_OICW')
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="value", value=60.00)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="weight", value=6.0)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="stacking", value=1)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="maximale_feuerreichweite", value=30)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="genauigkeit", value=1.0)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="munitionsarten", value=['SET_AMMOPACK_20_MM_HE','SET_AMMOPACK_20_MM_AP'])
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="magazingroesse", 				value=6.0)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="schusspausenzeit", 			value=2.0)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="genauigkeit_bewegte_ziele",	value=0.4)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="blockadewahrscheinlichkeit",	value=3.0)
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="pseudo_weapon", value="SET_OICW")
objects.set_attribute(object='SET_OICW_UNDERGUN', attribute="effects", value={
		"sound_shot"	: "shot_oicw_granate",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 4,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_XM_25')
objects.set_attribute(object='SET_XM_25', attribute="name", value=globaltext.SET_XM_25_HINT)
objects.set_attribute(object='SET_XM_25', attribute="hint", value=globaltext.SET_XM_25_NAME)
objects.set_attribute(object='SET_XM_25', attribute="resourceui", value='RES_ITEM65X32_WEAPON_XM_25')
objects.set_attribute(object='SET_XM_25', attribute="resource3d", value='RES3D_OICW')
objects.set_attribute(object='SET_XM_25', attribute="value", value=120.00)
objects.set_attribute(object='SET_XM_25', attribute="weight", value=5.45)
objects.set_attribute(object='SET_XM_25', attribute="stacking", value=1)
objects.set_attribute(object='SET_XM_25', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_XM_25', attribute="maximale_feuerreichweite", value=33)
objects.set_attribute(object='SET_XM_25', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_XM_25', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_XM_25', attribute="genauigkeit", value=1.2)
objects.set_attribute(object='SET_XM_25', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_XM_25', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_XM_25', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_XM_25', attribute="munitionsarten", value=['SET_AMMOPACK_25_MM_HE','SET_AMMOPACK_25_MM_AP'])
objects.set_attribute(object='SET_XM_25', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_XM_25', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_XM_25', attribute="magazingroesse", 				value=8.0)
objects.set_attribute(object='SET_XM_25', attribute="hoerweite", 				value=40.0)
objects.set_attribute(object='SET_XM_25', attribute="schusspausenzeit", 			value=1.0)
objects.set_attribute(object='SET_XM_25', attribute="genauigkeit_bewegte_ziele",	value=0.5)
objects.set_attribute(object='SET_XM_25', attribute="blockadewahrscheinlichkeit",	value=3.0)
objects.set_attribute(object='SET_XM_25', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_XM_25', attribute="effects", value={
		"sound_shot"	: "shot_oicw_granate",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 4,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
clone_weapon_type(typeid='SET_SIG_SG_552', new_typeid='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="name", value=globaltext.SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_NAME)
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="hint", value=globaltext.SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_HINT)
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="resource3d", value='RES3D_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="value", value=42.00)
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="weight", value=4.3)
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="undergun", value='SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL')
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="ButtOff", value='RES_ITEM65X32_WEAPON_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL_X')
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="effects", value={
		"sound_shot"	: "burst_sig_sg552",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_SIG_SG_552','SET_SAWED_OFF_BROWNING_B_SS_DOUBLE_BARREL','SET_DUCT_TAPE']]})

create_weapon_type(typeid='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870')
clone_weapon_type(typeid='SET_SIG_SG_552', new_typeid='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="name", value=globaltext.SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870_NAME)
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="hint", value=globaltext.SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870_HINT)
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="resourceui", value='RES_ITEM65X32_WEAPON_SIG_SG_552_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="resource3d", value='RES3D_SIG_SG_552_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="value", value=44.00)
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="weight", value=4.3)
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="undergun", value='SET_SAWED_OFF_REMINGTON_M870')
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="ButtOff", value='RES_ITEM65X32_WEAPON_SIG_SG_552_SAWED_OFF_REMINGTON_M870_X')
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="effects", value={
		"sound_shot"	: "burst_sig_sg552",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 1,
		"flash_size"	: 0.7,
		"stream_type"	: 1,
		"stream_size"	: 0.7,
		"fade_out"		: 50})
objects.set_attribute(object='SET_SIG_SG_552_SAWED_OFF_REMINGTON_M870', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_SIG_SG_552','SET_SAWED_OFF_REMINGTON_M870','SET_DUCT_TAPE']]})


create_weapon_type(typeid='SET_M_203')
objects.set_attribute(object='SET_M_203', attribute="name", value=globaltext.SET_M203_NAME)
objects.set_attribute(object='SET_M_203', attribute="hint", value=globaltext.SET_M203_HINT)
objects.set_attribute(object='SET_M_203', attribute="resourceui", value='RES_ITEM65X32_WEAPON_M_203')
objects.set_attribute(object='SET_M_203', attribute="resource3d", value='RES3D_M_203')
objects.set_attribute(object='SET_M_203', attribute="value", value=25.00)
objects.set_attribute(object='SET_M_203', attribute="weight", value=3.5)
objects.set_attribute(object='SET_M_203', attribute="stacking", value=1)
objects.set_attribute(object='SET_M_203', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_M_203', attribute="maximale_feuerreichweite", value=30)
objects.set_attribute(object='SET_M_203', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_M_203', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_M_203', attribute="genauigkeit", value=1.00)
objects.set_attribute(object='SET_M_203', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_M_203', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_M_203', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_M_203', attribute="munitionsarten", value=['SET_AMMOPACK_M79_M203'])
objects.set_attribute(object='SET_M_203', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_M_203', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_M_203', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_M_203', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_M_203', attribute="schusspausenzeit", 			value=2.0)
objects.set_attribute(object='SET_M_203', attribute="genauigkeit_bewegte_ziele",	value=0.2)
objects.set_attribute(object='SET_M_203', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_M_203', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_M_203', attribute="effects", value={
		"sound_shot"	: "shot_m203",	# [BrainRipper]
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 5,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.8,
		"fade_out"		: 50})	

create_weapon_type(typeid='SET_BG_15')
objects.set_attribute(object='SET_BG_15', attribute="name", value=globaltext.SET_BG_15_NAME)
objects.set_attribute(object='SET_BG_15', attribute="hint", value=globaltext.SET_BG_15_HINT)
objects.set_attribute(object='SET_BG_15', attribute="resourceui", value='RES_ITEM65X32_WEAPON_BG_15')
objects.set_attribute(object='SET_BG_15', attribute="resource3d", value='RES3D_BG_15')
objects.set_attribute(object='SET_BG_15', attribute="value", value=25.00)
objects.set_attribute(object='SET_BG_15', attribute="weight", value=3.5)
objects.set_attribute(object='SET_BG_15', attribute="stacking", value=1)
objects.set_attribute(object='SET_BG_15', attribute="minimale_feuerreichweite", value=0)
objects.set_attribute(object='SET_BG_15', attribute="maximale_feuerreichweite", value=30)
objects.set_attribute(object='SET_BG_15', attribute="salvenlaenge", value=1)
objects.set_attribute(object='SET_BG_15', attribute="feuergeschwindigkeit", value=0.00)
objects.set_attribute(object='SET_BG_15', attribute="genauigkeit", value=1.00)
objects.set_attribute(object='SET_BG_15', attribute="kampfwert_air", value=0.00)
objects.set_attribute(object='SET_BG_15', attribute="kampfwert_armoured", value=150.00)
objects.set_attribute(object='SET_BG_15', attribute="kampfwert_infantry", value=150.00)
objects.set_attribute(object='SET_BG_15', attribute="munitionsarten", value=['SET_AMMOPACK_BG15'])
objects.set_attribute(object='SET_BG_15', attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
objects.set_attribute(object='SET_BG_15', attribute="weapon_type", value="schwer")
objects.set_attribute(object='SET_BG_15', attribute="magazingroesse", 				value=1.0)
objects.set_attribute(object='SET_BG_15', attribute="hoerweite", 					value=40.0)
objects.set_attribute(object='SET_BG_15', attribute="schusspausenzeit", 			value=2.0)
objects.set_attribute(object='SET_BG_15', attribute="genauigkeit_bewegte_ziele",	value=0.2)
objects.set_attribute(object='SET_BG_15', attribute="blockadewahrscheinlichkeit",	value=5.0)
objects.set_attribute(object='SET_BG_15', attribute="occupied_slots", value=["left_hand","right_hand"])
objects.set_attribute(object='SET_BG_15', attribute="effects", value={
		"sound_shot"	: "shot_bg_15",
		"sound_unload"	: "rifle_discharge",
		"sound_gunjam"	: "rifle_gunjam",
		"sound_reload"	: "rifle_charge",
		"flash_type"	: 5,
		"flash_size"	: 0.5,
		"stream_type"	: 1,
		"stream_size"	: 0.8,
		"fade_out"		: 50})

create_weapon_type(typeid='SET_AK_74_KNIFED')
clone_weapon_type(typeid='SET_AK_74', new_typeid='SET_AK_74_KNIFED')
objects.set_attribute(object='SET_AK_74_KNIFED', attribute="name", value=globaltext.SET_AK_74_NAME)
objects.set_attribute(object='SET_AK_74_KNIFED', attribute="hint", value=globaltext.SET_AK_74_HINT)
objects.set_attribute(object='SET_AK_74_KNIFED', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_74_KNIFED')
objects.set_attribute(object='SET_AK_74_KNIFED', attribute="resource3d", value='RES3D_AK_74')
objects.set_attribute(object='SET_AK_74_KNIFED', attribute="value", value=32.00)	# [BrainRipper]
objects.set_attribute(object='SET_AK_74_KNIFED', attribute="weight", value=4.3)
objects.set_attribute(object='SET_AK_74_KNIFED', attribute="undergun", value='SET_AK_74_KNIFED_UNDERGUN')
objects.set_attribute(object='SET_AK_74_KNIFED', attribute="undergun_exists", value=True)
objects.set_attribute(object='SET_AK_74_KNIFED', attribute="item_combination",	value={
	"difficulty_assemble"	:	COMBO_DIFFICULT,
	"difficulty_disassemble":	COMBO_DIFFICULT,
	"assemble_function"		:	"assemble_over_and_under_gun",
	"disassemble_function"	:	"disassemble_over_and_under_gun",
	"combination_list"		:	[
								['SET_AK_74','SET_KNIFE','SET_DUCT_TAPE']]})
		
create_weapon_type(typeid='SET_AK_74_KNIFED_UNDERGUN')
clone_weapon_type(typeid='SET_KNIFE', new_typeid='SET_AK_74_KNIFED_UNDERGUN')
objects.set_attribute(object='SET_AK_74_KNIFED_UNDERGUN', attribute="name", value=globaltext.SET_AK_74_NAME)
objects.set_attribute(object='SET_AK_74_KNIFED_UNDERGUN', attribute="hint", value=globaltext.SET_AK_74_HINT)
objects.set_attribute(object='SET_AK_74_KNIFED_UNDERGUN', attribute="resourceui", value='RES_ITEM65X32_WEAPON_AK_74_KNIFED')
objects.set_attribute(object='SET_AK_74_KNIFED_UNDERGUN', attribute="resource3d", value='RES3D_AK_74_KNIFED')
objects.set_attribute(object='SET_AK_74_KNIFED_UNDERGUN', attribute="value", value=32.00)	# [BrainRipper]
objects.set_attribute(object='SET_AK_74_KNIFED_UNDERGUN', attribute="weight", value=4.3)
objects.set_attribute(object='SET_AK_74_KNIFED_UNDERGUN', attribute="fire_animation", value=FPA_SHOULDER_SINGLE )
objects.set_attribute(object='SET_AK_74_KNIFED_UNDERGUN', attribute="occupied_slots", value=["right_hand"])
objects.set_attribute(object='SET_AK_74_KNIFED_UNDERGUN', attribute="pseudo_weapon", value="SET_AK_74_KNIFED")

create_weapon_type(typeid='SET_AK_74_KNIFED_BUTT_UNDERGUN')
clone_weapon_type(typeid='SET_AK_74_KNIFED_UNDERGUN', new_typeid='SET_AK_74_KNIFED_BUTT_UNDERGUN')
objects.set_attribute(object='SET_AK_74_KNIFED_BUTT_UNDERGUN', attribute="pseudo_weapon", value="SET_AK_74_KNIFED_BUTT")

TOUCH_ATT = ["minimale_feuerreichweite","maximale_feuerreichweite","salvenlaenge","feuergeschwindigkeit","genauigkeit", "kampfwert_air", \
"kampfwert_armoured", "kampfwert_infantry", "munitionsarten", "fire_animation", "weapon_type", "magazingroesse", "hoerweite", "schusspausenzeit", \
"genauigkeit_bewegte_ziele", "blockadewahrscheinlichkeit","effects"]

def Generate_weapons_with_fire_mode() :
	for tmp_item in system.get_item_list():
		if objects.has_attribute(tmp_item,"item_type"):
			if objects.get_attribute(tmp_item, "item_type")=="weapon":
				if objects.has_attribute(tmp_item, "undergun"):
					FireModes = objects.get_att(tmp_item,"Fire_Modes").copy()
					if FireModes == None: FireModes = {}
					FireModes['Undergun'] = objects.get_attribute(tmp_item, "undergun")
					objects.set_attribute(tmp_item,"Fire_Modes",FireModes)
				if objects.has_attribute(tmp_item, "ButtOff"):
					FireModes = objects.get_att(tmp_item,"Fire_Modes").copy()
					if FireModes == None: FireModes = {}
					FireModes['ButtOff'] = objects.get_attribute(tmp_item, "ButtOff")
					objects.set_attribute(tmp_item,"Fire_Modes",FireModes)
				if objects.has_attribute(tmp_item, "ButtOn"):
					FireModes = objects.get_att(tmp_item,"Fire_Modes").copy()
					if FireModes == None: FireModes = {}
					FireModes['ButtOn'] = objects.get_attribute(tmp_item, "ButtOn")
					objects.set_attribute(tmp_item,"Fire_Modes",FireModes)

	Fire_Modes = []
	Butt_Modes = []
	for tmp_item in system.get_item_list():
		if objects.has_attribute(tmp_item,"item_type"):
			if objects.get_attribute(tmp_item, "item_type")=="weapon":
				if objects.has_attribute(tmp_item,"Fire_Modes") :
					Fire_Modes.append(tmp_item)
					if objects.get_attribute(tmp_item,"Fire_Modes").has_key("ButtOn") :
						Butt_Modes.append(tmp_item)
					if objects.get_attribute(tmp_item,"Fire_Modes").has_key("ButtOff") :
						Butt_Modes.append(tmp_item)
	
	for old_typeid in Butt_Modes : # First made all butt's that we made modes with butt
		if objects.get_attribute(old_typeid,"Fire_Modes").has_key("ButtOn") :
			RES = objects.get_attribute(old_typeid,"Fire_Modes")["ButtOn"] 
			Butt_State = "ON"
			Not_Butt_State = "OFF"
			X = 1.1
		elif objects.get_attribute(old_typeid,"Fire_Modes").has_key("ButtOff") :
			RES = objects.get_attribute(old_typeid,"Fire_Modes")["ButtOff"] 
			Butt_State = "OFF"
			Not_Butt_State = "ON"			
			X = 0.9 
		new_typeid = old_typeid + "_BUTT"
		create_weapon_type(new_typeid)
		clone_weapon_type(old_typeid, new_typeid)
		objects.set_attribute( new_typeid, "resourceui", RES )
		objects.set_attribute( old_typeid, "mode_Butt", new_typeid )
		objects.set_attribute( new_typeid, "mode_Butt", old_typeid )
		genauigkeit = objects.get_att ( old_typeid, "genauigkeit" )
		genauigkeit_bewegte_ziele = objects.get_att ( old_typeid, "genauigkeit_bewegte_ziele" )		
		schusspausenzeit = objects.get_att ( old_typeid, "schusspausenzeit" )
		maximale_feuerreichweite = objects.get_att ( old_typeid, "maximale_feuerreichweite" )
		if genauigkeit :
			objects.set_attribute ( new_typeid, "genauigkeit", genauigkeit * X )
		if genauigkeit_bewegte_ziele :
			objects.set_attribute ( new_typeid, "genauigkeit_bewegte_ziele", genauigkeit_bewegte_ziele * X )
		if schusspausenzeit :
			objects.set_attribute ( new_typeid, "schusspausenzeit", schusspausenzeit * X )
		if maximale_feuerreichweite :
			objects.set_attribute ( new_typeid, "maximale_feuerreichweite", maximale_feuerreichweite * X )
		objects.set_attribute(object=new_typeid, attribute="pseudo_weapon", value=old_typeid )
		objects.set_attribute( new_typeid, "for_butt", old_typeid )
		objects.set_attribute( old_typeid, "for_butt", new_typeid )
		objects.set_attribute( new_typeid, "butt_state", Butt_State )
		objects.set_attribute( old_typeid, "butt_state", Not_Butt_State )
		Current_Mode = objects.get_att ( old_typeid, "Current_Fire_Mode" )
		if Current_Mode : objects.set_attribute ( new_typeid, "Current_Fire_Mode", Current_Mode )			
		Fire_Modes.append(new_typeid)

	for old_typeid in Fire_Modes :
		Fire_Modes_List = objects.get_attribute ( old_typeid, "Fire_Modes" ) 
		Current_Mode = objects.get_att ( old_typeid, "Current_Fire_Mode")
		if ( Current_Mode == None ) :
			Current_Mode = Fire_Modes_List.keys()[0]
		if Fire_Modes_List.has_key("ButtOff") :
			del Fire_Modes_List["ButtOff"]
		if Fire_Modes_List.has_key("ButtOn") :
			del Fire_Modes_List["ButtOn"]

		Real_Weapon = objects.get_att ( old_typeid, "typeid" ) # We want to state pseudoweapon att to any weapon except main.
		if Real_Weapon == None: Real_Weapon = old_typeid
		
		Mode_Switch = {}
		for mode in Fire_Modes_List.keys() :
			if mode != Current_Mode :
				Mode_Switch["mode_"+mode] = old_typeid + Fire_Modes_Endings [ mode ]
			else :		
				Mode_Switch["mode_"+mode] = old_typeid					
	
		for mode in Fire_Modes_List.keys() :
			if mode != Current_Mode :
				if mode in [ "Single", "Cutoff", "Auto" ] :
					new_typeid = old_typeid + Fire_Modes_Endings [ mode ]
					create_weapon_type(new_typeid)
					clone_weapon_type(old_typeid, new_typeid)
					objects.set_attribute(object=new_typeid, attribute="salvenlaenge", value = Fire_Modes_List[mode] )
					objects.set_attribute(object=new_typeid, attribute="fire_animation", value = Fire_Modes_Animation[mode] )
					objects.set_attribute(object=new_typeid, attribute="pseudo_weapon", value = Real_Weapon )
					if objects.has_attribute( old_typeid, "for_butt" ) :
						for_butt = objects.get_attribute( old_typeid, "for_butt" ) 
						objects.set_attribute( new_typeid, "mode_Butt", for_butt + Fire_Modes_Endings [ mode ] )
				if mode in [ "Throw", "Thrust", "Baton" ] :
					new_typeid = old_typeid + Fire_Modes_Endings [ mode ]
					create_weapon_type(new_typeid)
					clone_weapon_type(old_typeid, new_typeid)
					objects.set_attribute(object=new_typeid, attribute="maximale_feuerreichweite", value = Fire_Modes_List[mode] )
					objects.set_attribute(object=new_typeid, attribute="fire_animation", value = Fire_Modes_Animation[mode] )
					objects.set_attribute(object=new_typeid, attribute="pseudo_weapon", value = Real_Weapon )
					if objects.has_attribute( old_typeid, "for_butt" ) :
						for_butt = objects.get_attribute( old_typeid, "for_butt" ) 
						objects.set_attribute( new_typeid, "mode_Butt", for_butt + Fire_Modes_Endings [ mode ] )
				elif mode == "Undergun" :
					pro_typeid = Fire_Modes_List[mode]
					new_typeid = old_typeid + "_UNDERGUN"

					if not objects.get_att ( old_typeid, "undergun_exists" )  :
						create_weapon_type(new_typeid)
						attributes = objects.get_attributes(object=old_typeid)
						for attribute in attributes:
							if attribute in TOUCH_ATT :
								objects.set_attribute(object=new_typeid, attribute=attribute,
									value=objects.get_attribute(object=pro_typeid, attribute=attribute))
							elif attribute != "id":
								objects.set_attribute(object=new_typeid, attribute=attribute,
									value=objects.get_attribute(object=old_typeid, attribute=attribute))
						objects.set_attribute(object=new_typeid, attribute="fire_animation", value=FPA_SHOULDER_SINGLE)
						objects.set_attribute(object=new_typeid, attribute="pseudo_weapon", value = Real_Weapon )
					else:
						objects.set_attribute(object=new_typeid, attribute="Fire_Modes", \
							value = objects.get_attribute ( old_typeid, "Fire_Modes" ) )

					if objects.has_attribute( old_typeid, "for_butt" ) :
						for_butt = objects.get_attribute( old_typeid, "for_butt" ) 
						objects.set_attribute( new_typeid, "mode_Butt", for_butt+"_UNDERGUN" )					
			else :
				new_typeid = old_typeid 	

			for var in Mode_Switch.keys() :
				object.set_attribute( new_typeid, var, Mode_Switch[var] )
			object.set_attribute( new_typeid, "weapon_mode_current", mode )

Generate_weapons_with_fire_mode()

def generate_weapon_types():
	for tmp_item in system.get_item_list():
		if objects.has_attribute(tmp_item,"item_type"):
			if objects.get_attribute(tmp_item, "item_type")=="weapon" and objects.get_att(tmp_item, "pseudo_weapon") == None:
				if objects.has_attribute(tmp_item,"munitionsarten"):
					sup_munition = objects.get_attribute(tmp_item, "munitionsarten")
					for mun_type in sup_munition:
						if objects.has_attribute(mun_type,"weapon_types"):
							weapon_types = []
							weapon_types = objects.get_attribute(mun_type, "weapon_types")
							weapon_types.append(tmp_item)
							objects.set_attribute(mun_type,"weapon_types",weapon_types)
							
generate_weapon_types()

