# -*- coding: utf-8 -*-
from global_defines import *
import npc
from const import *
import schedules
from dynamic_camera import *
import enemy_script
import dialog
import sounds
from daily_routine import *
import random
import globaltext
import object_events

#*** actual revison: Revision 58, 17.08.2004 ***********************************

def PlaySpeechAnimation(id):
	character.play_animation( id, "CM_NPC_STEHEN_KONVERSATION_%d" % random.randint( 1, 5 ) )

def has_partychar_item_for_target(target, item, remove):
	if target == "MCKANZEE":
		n = data().mckanzee_given_water
		while n > 0:
			item.remove(item[-1])
			n -= 1
		#print ">>> items after exchange", str(item)
	if not isinstance(item, list):
		item = [item]
	item_to_char_map = {}
	#create map: item - char who has item
	for i in item:
		for pc in system.get_pcs():
			if objects.get_distance(pc, target) < 10.0:
				if objects.count_in_inventory(pc, i):
					eintrag = { i : pc }
					item_to_char_map.update(eintrag)
					break
	
	#compare map - itemlist
	k = item_to_char_map.keys()
	#print ">>> exchange if equal:",item_to_char_map,"with:",item
	k.sort()
	item.sort()
	
	#exchange items
	if len(k) == len(item):
		if k == item:
			if remove:
				for i in item_to_char_map.keys():
					#print ">>> gleiche items gefunden und getauscht", i, item_to_char_map[i]
					objects.transfer_item(item_to_char_map[i],i,target)
				return True
	return False

def anyone_has_skill(skill, value):
	has = False
	for char in system.get_pcs():
		if objects.has_attribute(char,skill):
			if objects.get_attribute(char,skill) >= value:
				has = True
	return has

def refuse_action_comment(id,type='default'):
	gender = objects.get_attribute("ALTER_EGO","gender")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_MERCENARY')
	if type == 'default':
		if gender == MALE:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY_F', speaker=id, follower='ENDDIALOG')
	if type == 'gut':
		r = random.randint(0,10)
		if r <= 5:
			dialog.add_text(text='HANDLE_ITEM_3', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='HANDLE_ITEM_8', speaker=id, follower='ENDDIALOG')	
	else:
		if gender == MALE:
			dialog.add_text(text='MERCENERY_USEITEM_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_USEITEM_DENY_F', speaker=id, follower='ENDDIALOG')
	dialog.start(False)
def MercenaryDenyTalk(id,type='default'):
#	gender = objects.get_attribute("ALTER_EGO","gender")
	gender = objects.get_attribute(id,"gender")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_MERCENARY')
	if type == 'default':
		if gender == MALE:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY_F', speaker=id, follower='ENDDIALOG')
	else:
		if gender == MALE:
			dialog.add_text(text='MERCENERY_USEITEM_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_USEITEM_DENY_F', speaker=id, follower='ENDDIALOG')
	dialog.start(False)

def on_approach(target, operator):
	if dialog.is_dialog_active():
		return
	
	if schedules.Dialog(target, operator):
		return
		
	if target == 'MERCENARY_HENRY' and data().Henry_Erstes_Mal:
		data().Henry_Erstes_Mal = False
		init_Dlg_Henry_Aufnahme()
		
	if target == "LUKE_Z3": ## todo: dialoge anschliessen
		#if not data().schloss_knacker_gesucht:
		if system.get_qb_entry_state(data().QB_015)== INACTIVE and system.get_qb_entry_state(data().QB_016) != UNCOMPLETE:
			initDlg_105_LukeStelltSichVor()
		else:
			if not data().luke_folgt:
				if data().spieler_muss_luke_erneut_holen:
					initDlg_115_LukeSollErneutMitkommen()
				else:
					if not data().luke_an_kiste:
						if not data().schloss_geknackt:
							initDlg_106_LukeOeffnetKisteFuerLau()
						else:
							if not data().luke_wieder_zuhause:
								initDlg_114_LukeHatEsEilig()
							else:
								initDlg_113_LukeWillNichtGestoertWerden()
					else:
						if not data().schloss_geknackt:
							if not data().luke_hat_kiste_inspiziert:
								initCutscene_110_LukeInspiziertDasSchloss()
							else:
								if enemy_script.count_party_inventory(object_id = "LUKE_Z3", items = 'SET_SPECIAL_PICKLOCK'):
									#data().Second_Mine_Warning = False
									initCutscene_112_LukeKnacktDasSchloss()
								else:
									initDlg_111_LukeErwartetSpezialdietriche()
			else:
				initDlg_107_LukeWillZumSchloss()
	
	
	if target == 'WALDEMAR':
		
		if (data().Waldemar_Unterwegs == 0):
			initDlg_128_WaldemarInEile()
		
		elif (data().Waldemar_Unterwegs == 1):
			initDlg_129_WaldermarFertig()
		
		elif ((system.get_qb_entry_state(data().QB_019) == INACTIVE or
			  system.get_qb_entry_state(data().QB_022) == INACTIVE) and
			data().BisonDeadAusgeweidet 			and 
			data().BisonKadaberAusgeweidet 			and
			data().BergtigerAusgeweidet):
				initDlg_092_WaldemarSagtNichts()
		
		elif (system.get_qb_entry_state(data().QB_019) == UNCOMPLETE and
			  #system.get_qb_entry_state(data().QB_022) == UNCOMPLETE and
			not data().D_93_Ende2_gelaufen):
				initDlg_093_WaldemarKenntBergtieger()
		
		elif (data().D_93_Ende2_gelaufen and 
			not objects.is_destroyed("BERGTIGERIN")):
				initDlg_094_WaldemarFragtBergtigerTod()
		
		elif (data().D_93_Ende2_gelaufen and 
			objects.is_destroyed("BERGTIGERIN") 	and
			data().Waldemar_Unterwegs == -1 	and
			not data().d_95_gelaufen):
				initCutscene_095_WaldemarErfaehrtBergtigerTod()
		
		elif (data().D_93_Ende2_gelaufen 	and 
			data().Waldemar_Unterwegs == -1 and
			data().d_95_gelaufen):
				initDlg_087_WaldemarSollDasBisonAusweiden()
		else:
			initDlg_092_WaldemarSagtNichts()
		
	if target == "HERMAN":
		if ((not data().luke_hat_kiste_inspiziert) and 
			(not data().schloss_geknackt)):
			initDlg_117_HermanIstImStress()
		else:
			if ((not data().spieler_hat_dietrich) 	and 
				data().luke_an_kiste 		and 
				(not data().schloss_geknackt)):	
				initDlg_118_HermanHatDenDietrich()
			else:
				initDlg_119_SpielerWillHermanNichtMehr()
	
	if target == "DOERFLER A":
		initDlg_122_DoerflerAKommentar()

	if target == "DOERFLER B":
		initDlg_123_DoerflerBKommentar()

	if target == "DOERFLER C":
		initDlg_124_DoerflerCKommentar()
	
	if target in ["RATSKULL_LEADER","RATSKULLS BUNKER A","RATSKULLS BUNKER B","RATSKULLS BUNKER C","RATSKULLS BUNKER D"]:
		if data().ratskulls_laufen_gelassen:
			initDlg_101_RatskullFrohDassEntkommen(target)

	if target == "HAENDLER":
		#Handelsscreen aufrufen
		system.trading_screen(target,operator)

	if target == "DORFBEWOHNERIN":
		if data().ZwillingsQuest_Gesperrt:
			initDlg_052_Dorfbewohnerin_WillNichtMehr()
		else:
			if (system.get_qb_entry_state(data().QB_010) == INACTIVE
				and system.get_qb_entry_state(data().QB_011) == INACTIVE
				and system.get_qb_entry_state(data().QB_012) == INACTIVE):
					initDlg_012_Dorfbewohnerin_Besorgt()
			
			elif (system.get_qb_entry_state(data().QB_010) == UNCOMPLETE
				and system.get_qb_entry_state(data().QB_011) == INACTIVE
				and system.get_qb_entry_state(data().QB_012) == INACTIVE):
					initDlg_048_Dorfbewohnerin_ImmerNochBesorgt()
			
			elif (system.get_qb_entry_state(data().QB_010) == INACTIVE
				and system.get_qb_entry_state(data().QB_011) == UNCOMPLETE
				and system.get_qb_entry_state(data().QB_012) == INACTIVE):
					initDlg_048_Dorfbewohnerin_ImmerNochBesorgt()
			
			elif (system.get_qb_entry_state(data().QB_010) == INACTIVE
				and system.get_qb_entry_state(data().QB_011) == INACTIVE
				and system.get_qb_entry_state(data().QB_012) == UNCOMPLETE):
					if data().miapia_folgen:
						if ((objects.get_distance("DORFBEWOHNERIN", "MIA") <= 15.0) or
							(objects.get_distance("DORFBEWOHNERIN", "PIA") <= 15.0)):
							initDlg_053_Dorfbewohnerin_Gluecklich()
						else:
							initDlg_048_Dorfbewohnerin_ImmerNochBesorgt()
	
			elif (system.get_qb_entry_state(data().QB_010) == INACTIVE
				and system.get_qb_entry_state(data().QB_011) == COMPLETE
				and system.get_qb_entry_state(data().QB_012) == INACTIVE):
					initDlg_053_Dorfbewohnerin_Gluecklich()
			else:
				initDlg_048_Dorfbewohnerin_ImmerNochBesorgt()
	
	if target == "DONALD RUMS":
		
#		if (	(system.get_qb_entry_state(data().QB_019) == UNCOMPLETE or system.get_qb_entry_state(data().QB_020) == UNCOMPLETE or system.get_qb_entry_state(data().QB_021) == UNCOMPLETE) and
#			(system.get_qb_entry_state(data().QB_022) == UNCOMPLETE or system.get_qb_entry_state(data().QB_023) == UNCOMPLETE)):
		housing=False
		hunting=False
		if was_zone_entered("zone_5.zone_5"):
			if data().ian_linda_paula_folgen:
				housing=True

		if not housing:
			# Catch fuer Donald ansprechen, wenn Annaehrungstrigger nicht funtzt
			if system.get_qb_entry_state(data().QB_017) == UNCOMPLETE:
				data().spieler_von_donald_angesprochen = True
				initDlg_008_Sprengmeister_WillNichtJagen()
				return
				
			if (((system.get_qb_entry_state(data().QB_019) == UNCOMPLETE)  or
				 (system.get_qb_entry_state(data().QB_020) == UNCOMPLETE)  or
				 (system.get_qb_entry_state(data().QB_021) == UNCOMPLETE)) or
				((system.get_qb_entry_state(data().QB_022) == UNCOMPLETE)  or
				 (system.get_qb_entry_state(data().QB_023) == UNCOMPLETE))):
				if not hasMeat("DONALD RUMS"):
					initCutscene_Dlg_009_Sprengmeister_WartenAufFleisch()
					hunting=True
				else:
					initDlg_010_Sprengmeister_BekommtFleisch()
					hunting=True
		if housing:
			#if data().ian_linda_paula_folgen:
			initCutscene_Dlg_069_NeuesZuhause()
		if (not hunting) and (not housing): 
			initDlg_045_Sprengmeister_WohnungsMakler()

	if target == "GEORG":
		if not data().Stop_Ratskulls_All:
			if not dialog.is_dialog_active():
				if system.get_qb_entry_state(data().QB_002) == UNCOMPLETE:
					if not data().cutscene_kuehe_treiben_gestartet:
						initCutscene_Dlg_002_Bauer_KueheTreiben()
				elif system.get_qb_entry_state(data().QB_003) == UNCOMPLETE:
					initDlg_044_Bauer_VielSpass()
				else:
					initDlg_007_Bauer_WillNichtMehr()
		else:
			if data().georg_d_126_spoken:
				initDlg_126_GoergHatNixMehrZuSagen()
			else:
				initDlg_125_PeteVerkauftTipp()


	if target == "LUISA":
		if not data().ZwillingsQuest_Gesperrt:
			if (system.get_qb_entry_state(data().QB_010) == UNCOMPLETE and
				not data().ZwillingsQuest_Mit_Lisa_Gesprochen and
				not data().MiaPia_RettungOhneAuftragAktiv):
				initDlg_014_Luisa_VermisstKinder()
			
			elif (system.get_qb_entry_state(data().QB_011) == UNCOMPLETE or
				system.get_qb_entry_state(data().QB_012) == UNCOMPLETE):
				if not data().MiaPia_RettungOhneAuftragAktiv:
					initDlg_054_Luisa_ImmerNochBesorgt()
			
			elif system.get_qb_entry_state(data().QB_012) == COMPLETE:
				if not data().ZwillingsQuest_Luisa_HatSichBedankt:
					if data().MiaPia_RettungOhneAuftragAktiv:
						initCutscene_Dlg_083_Luisa_RettungOhneAuftrag()
					else:
						if data().ZwillingsQuest_Luisa_Bezahlung:
							initCutscene_Dlg_017_Luisa_Dankbar_MitBezahlung()
						else:
							initCutscene_Dlg_016_Luisa_Dankbar_KeineBezahlung()
			
			elif system.get_qb_entry_state(data().QB_011) == COMPLETE:
					initDlg_055_Luisa_HappyHippo()
			else:
				initDlg_013_Luisa_Weint()
		else:
			initDlg_013_Luisa_Weint()

	if target == "DORFAELTESTER":
		if data().Stop_Ratskulls_Distillery:
			initDlg_047_Doerfaeltester_Hick_short()
		elif (system.get_qb_entry_state(data().QB_006) == UNCOMPLETE and 
		system.get_qb_entry_state(data().QB_007) == INACTIVE and 
		data().Doerfeler_TA_gestartet):
			initDlg_020_Doerfaeltester_SorgeUmSchnapps()
		elif system.get_qb_entry_state(data().QB_007) == UNCOMPLETE or system.get_qb_entry_state(data().QB_018) == UNCOMPLETE:
			if data().SchnappsQuest_Ratskulls_Killed >= 2:
				initCutscene_Dlg_021_Doerfaeltester_SchnappsBefreit()
			else:
				initDlg_046_Doerfaeltester_NochNichtsErreicht()
		elif system.get_qb_entry_state(data().QB_007) == COMPLETE:
			initDlg_047_Doerfaeltester_Hick()
		elif system.get_qb_entry_state(data().QB_006) in [INACTIVE, UNCOMPLETE] and data().SchnappsQuest_Ratskulls_Killed >=2:
			initCutscene_Dlg_081_Dorfaeltester_DistillerieOhneAuftragBefreit()
		else:
			initDlg_019_Doerfaeltester_KeinGespraech()

	if target == "BARBARA":
		if not data().GonzoQuest_GonzosFrau_DialogVergeigt:
			if data().GonzoQuest_Gonzo_Dead:
				if data().gonzo_dead_ohne_auftrag:
					if not data().GonzoQuest_Dialog_27_Erledigt:
						initDlg_082_GonzosFrau_TrauerNachTodGonzosOhneAuftrag()
					else:
						initDlg_028_GonzosFrau_GehtsGut()
				else:
					if not data().GonzoQuest_Dialog_27_Erledigt:
						initCutscene_Dlg_027_GonzosFrau_GonzoTot()
					else:
						initDlg_028_GonzosFrau_GehtsGut()
			elif( 		not system.get_qb_entry_state(data().QB_013) == UNCOMPLETE
					and not system.get_qb_entry_state(data().QB_014) == UNCOMPLETE):
				initDlg_022_GonzosFrau_Bote()
			else:
				initDlg_057_GonzosFrau_Hiiiiiilfe()
		else:
			initDlg_056_GonzosFrau_WillNichtMehr()

	if target == "MCKANZEE":
		
		if ((system.get_qb_entry_state(data().QB_008) == INACTIVE and
			system.get_qb_entry_state(data().QB_009) == INACTIVE)) or (system.get_qb_entry_state(data().QB_008) == COMPLETE and not data().car_battery_given):
				if not data().spieler_leiche_gefunden:
					initDlg_038_McKanzee_WillNichtReden()
				else:
					if not data().Spieler_kennt_Schatten:
						initDlg_089_McKanzeeInformiertUeberSchattenLeiche()
						data("shadow_info").know_shadows = True
					else:
						initDlg_038_McKanzee_WillNichtReden()
		
		elif (system.get_qb_entry_state(data().QB_008) == UNCOMPLETE and
			system.get_qb_entry_state(data().QB_009) == INACTIVE):
				if not data().mckanzee_wasser_bekommen:
					initDlg_030_McKanzee_WillWasser()
				elif not data().Spieler_kennt_Schatten:
					initDlg_089_McKanzeeInformiertUeberSchattenLeiche()
				else:
					initDlg_040_McKanzee_HautAb()
					
		elif (system.get_qb_entry_state(data().QB_008) == INACTIVE and
			system.get_qb_entry_state(data().QB_009) == UNCOMPLETE):
				liters = 0
				trans_items = {}
				#if hasWater("MCKANZEE"): #has_partychar_item_for_target(target, item=["SET_WATER_SKIN", "SET_WATER_SKIN", "SET_WATER_SKIN"], remove=True):
				water = enemy_script.count_party_inventory(object_id = "MCKANZEE" , items = ["SET_WATER_SKIN", "SET_WATER_BOTTLE", "SET_WATER_CAN", "SET_WATER_CANISTER"], item_id = True)
				for list_item in ["SET_WATER_SKIN", "SET_WATER_BOTTLE", "SET_WATER_CAN", "SET_WATER_CANISTER"]:
					if water[list_item][0] > 0:
						for pc in water[list_item][1].keys():
							if water[list_item][1][pc]:
								for item in water[list_item][1][pc]:
									if objects.has_attribute( item, "water_repository" ):
										if objects.get_attribute( item, "water_repository" ) == 1:
											if objects.has_attribute( item, "charge" ):
												liter_temp = objects.get_attribute( item, "charge" )
												if not data().mckanzee_given_water >= 3:
													if liter_temp >= 1:
														liters += liter_temp
														if not trans_items.has_key(pc):
															trans_items[pc] = []
														trans_items[pc].append(item)
												if liters >= 3 - data().mckanzee_given_water:
													initCutscene_Dlg_031_McKanzee_BekommtWasser(trans_items)
													data().mckanzee_wasser_bekommen = True
													return None
				initCutscene_Dlg_039_McKanzee_KeinWasser()
				return None

		elif (system.get_qb_entry_state(data().QB_008) == COMPLETE):
			if not data().spieler_leiche_gefunden:
				if data().mckanzee_wasser_bekommen:
					initDlg_040_McKanzee_HautAb()
				else:
					initDlg_038_McKanzee_WillNichtReden()
			else:
				if not data().Spieler_kennt_Schatten:
					initDlg_089_McKanzeeInformiertUeberSchattenLeiche()
				else:
					if data().mckanzee_wasser_bekommen:
						initDlg_040_McKanzee_HautAb()
					else:
						initDlg_038_McKanzee_WillNichtReden()

	if target == "EINSIEDLER":
		if not data().BatterieQuest_Vergeigt:
			if system.get_qb_entry_state(data().QB_008) == INACTIVE and system.get_qb_entry_state(data().QB_009) == INACTIVE:
				initDlg_029_Einsiedler_BrauchtBatterie()
			
			elif  system.get_qb_entry_state(data().QB_008) == UNCOMPLETE or system.get_qb_entry_state(data().QB_009) == UNCOMPLETE :
				if hasBattery("EINSIEDLER"):
					initDlg_032_Einsiedler_BekommtBatterie()
				else:
					initDlg_043_Einsiedler_KeineBatterie()
			
			elif system.get_qb_entry_state(data().QB_008) == COMPLETE:
				initDlg_085_EinsiedlerGluecklich()
		else:
			initDlg_085_EinsiedlerGluecklich()

	if target == "GONZO":
		if not system.get_qb_entry_state(data().QB_013) == UNCOMPLETE:
			initDlg_024_Gonzo_KeineZeit()
		elif system.get_qb_entry_state(data().QB_013) == UNCOMPLETE:
			if not data().gonzo_killing_spree:
				initDlg_025_Gonzo_MahlzeitWeg()
			else:
				initDlg_058_Gonzos_Durchgeknallt_FrauLebt()
		elif system.get_qb_entry_state(data().QB_013) == IMPOSSIBLE:
			initDlg_059_Gonzos_Durchgeknallt_FrauTot()

	if target == "FRANKLIN":
		if data().franklin_folgt:
			initDlg_067_Franklin_QuatschNicht()
		elif was_zone_entered("zone_5.zone_5"): 
			if (system.get_qb_entry_state(data("zone_5.zone_5").QB_003) == UNCOMPLETE):
				initDlg_066_Doktor_Ausbildung()
			else:
				initCutscene_Dlg_065_Doktor_Untersucht()
		else:
			initCutscene_Dlg_065_Doktor_Untersucht()

	if target in ["MIA","PIA"]:
		if (	not objects.is_destroyed("MIA") and #not data().ZwillingsQuest_Gesperrt and
			not objects.is_destroyed("PIA")):
			# Wenn Mia und Pia gefunden aber die Mutter noch nicht gefragt wurde,
			# brauch man sie auch nicht mehr zu fragen wo Ihre Kinder stecken könnten
			if system.get_qb_entry_state(data().QB_010) == UNCOMPLETE:
				system.set_qb_entry_state(data().QB_010,INACTIVE)
				
			if system.get_qb_entry_state(data().QB_012) == COMPLETE:
				initDlg_042_Kinder_Langweilig()
			elif system.get_qb_entry_state(data().QB_012) == UNCOMPLETE:
				initDlg_041_Kinder_AufDemWeg()
			elif system.get_qb_entry_state(data().QB_011) == UNCOMPLETE:
				initDlg_015_Kinder_NachHause(without_quest=False)
			elif system.get_qb_entry_state(data().QB_011) in [INACTIVE, IMPOSSIBLE]:
				initDlg_015_Kinder_NachHause(without_quest=True)

	if target == "RATSKULLS B" or target == "RATSKULLS C":
		if not objects.has_attribute(target, "foes"):
			initDlg_035_Ratskulls_Gespraech()

def init_Dlg_Henry_Aufnahme():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_INTERVIEW_HENRY')
	dialog.add_text(text='INTERVIEW_T_001', speaker="MERCENARY_HENRY")
	dialog.add_choice(text='INTERVIEW_C_001_1', follower = 'INTERVIEW_T_002')
	dialog.add_choice(text='INTERVIEW_C_001_5', follower = 'ENDDIALOG')
	dialog.add_text(text='INTERVIEW_T_002', speaker="MERCENARY_HENRY", callback = init_Dlg_Henry_Aufnahme_2)
	dialog.start(False)
	
def init_Dlg_Henry_Aufnahme_2():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_INTERVIEW_HENRY')
	dialog.add_choice(text='INTERVIEW_C_001_2', follower = 'INTERVIEW_T_003')
	if was_zone_entered('zone_8.zone_8'):
		if data('zone_8.zone_8').BruchMitHayes:
			dialog.add_choice(text='INTERVIEW_C_001_4', follower = 'INTERVIEW_T_005')
		else:
			dialog.add_choice(text='INTERVIEW_C_001_3', follower = 'INTERVIEW_T_004')
	else:
		dialog.add_choice(text='INTERVIEW_C_001_3', follower = 'INTERVIEW_T_004')
	dialog.add_choice(text='INTERVIEW_C_001_5', follower = 'ENDDIALOG')
	dialog.add_text(text='INTERVIEW_T_003', speaker="MERCENARY_HENRY", follower = 'INTERVIEW_C_001_2')
	dialog.add_text(text='INTERVIEW_T_004', speaker="MERCENARY_HENRY", follower = 'ENDDIALOG', callback = Henry_Aufnahme)
	dialog.add_text(text='INTERVIEW_T_005', speaker="MERCENARY_HENRY", follower = 'ENDDIALOG', callback = Henry_Aufnahme)
	
	dialog.start(False)
	
def Henry_Aufnahme():
	if (len(system.get_pcs(True)) < 6):
		system.switch_party("MERCENARY_HENRY", "UISPIELER")
		objects.set_attribute("MERCENARY_HENRY", "joined_party_time", system.get_mission_time())
		prohibit_activity("MERCENARY_HENRY", True)
	else:
		system.add_text(globaltext.PARTY_FULL_ON_RECRUIT)
		

def hasBattery(id):
	b_1 = enemy_script.count_party_inventory(object_id = id, items = data().obj_Autobatterie)
	b_2 = enemy_script.count_party_inventory(object_id = id, items = "SET_CAR_BATTERY")
	return b_1 or b_2

def hasWater(id):
	w_inv = 0 
	w_giv = 0
	w_inv = objects.count_in_inventory(id, equipment="SET_WATER_SKIN")
	w_giv = data().mckanzee_given_water
	
	#print "[debug: hasWater()",str(w_giv),str(w_inv),"]"
	if w_giv == 3:
		return True
	else:
		if w_giv + w_inv >= 3:
			return True
	return False

def hasMeat(id):
	has_bison_meat = False
	has_tiger_meat = False
	x = 0
	data().Fleisch = []
	ergtype = enemy_script.count_party_inventory(area = 15, object_id = id, items = ["SET_BISON_MEAT",  "SET_TIGER_MEAT"])
		
	ergid		= enemy_script.count_party_inventory(area = 15, object_id = id, items = [data().obj_BisonfleischKadaber, data().obj_BisonfleischKill, data().obj_Tigerfleisch, "Z3 TIGER_MEAT_2",
												"Z3 BISON_MEAT_KADABER_2", "Z3 BISON_MEAT_KADABER_KILL_2"])
	
	if ergtype["SET_BISON_MEAT"]:
		data().Fleisch.append("SET_BISON_MEAT")
		if not has_bison_meat:
			has_bison_meat = True
			x += 1

	if ergtype["SET_TIGER_MEAT"]:
		data().Fleisch.append("SET_TIGER_MEAT")
		if not has_tiger_meat:
			has_tiger_meat = True
			x += 1

	if ergid[data().obj_BisonfleischKadaber]:
		data().Fleisch.append(data().obj_BisonfleischKadaber)
		if not has_bison_meat:
			has_bison_meat = True
			x += 1

	if ergid[data().obj_BisonfleischKill]:
		data().Fleisch.append(data().obj_BisonfleischKill)
		if not has_bison_meat:
			has_bison_meat = True
			x += 1
	
	if ergid["Z3 BISON_MEAT_KADABER_2"]:
		data().Fleisch.append("Z3 BISON_MEAT_KADABER_2")
		if not has_bison_meat:
			has_bison_meat = True
			x += 1
	
	if ergid["Z3 BISON_MEAT_KADABER_KILL_2"]:
		data().Fleisch.append("Z3 BISON_MEAT_KADABER_KILL_2")
		if not has_bison_meat:
			has_bison_meat = True
			x += 1
	
	if ergid[data().obj_Tigerfleisch]:
		data().Fleisch.append(data().obj_Tigerfleisch)
		if not has_tiger_meat:
			has_tiger_meat = True
			x += 1
	
	if ergid["Z3 TIGER_MEAT_2"]:
		data().Fleisch.append("Z3 TIGER_MEAT_2")
		if not has_tiger_meat:
			has_tiger_meat = True
			x += 1
	
	#print "[debug: hasMeat()",str(x),"]"
	if (x>=1):
		return True
	return False

def onDlg_001_T_018():
	if data().Dialog_001_C_002_5_ERLEDIGT:
		dialog.add_choice(text='D_001_C_002_6', follower='D_001_T_020')	# anfangs nicht aktivierter Choice

def onDlg_001_T_019():
	if data().Dialog_001_C_002_4_ERLEDIGT:
		dialog.add_choice(text='D_001_C_002_6', follower='D_001_T_020')	# anfangs nicht aktivierter Choice

def initDlg_001_Bauer_Warnung():
	onDlg_001_marker()
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_001')
	dialog.add_text(text='D_001_T_001', speaker="GEORG", follower='D_001_C_001')
	dialog.add_choice(text='D_001_C_001_1', follower='D_001_T_003')
	dialog.add_choice(text='D_001_C_001_2', follower='D_001_T_002')
	dialog.add_choice(text='D_001_C_001_3', follower='D_001_T_006')
	dialog.add_text(text='D_001_T_002', speaker="GEORG", follower='D_001_T_008')
	dialog.add_text(text='D_001_T_003', speaker="GEORG")
	dialog.add_text(text='D_001_T_004', speaker="GEORG")
	dialog.add_text(text='D_001_T_005', speaker="ALTER_EGO", follower='D_001_T_008')
	dialog.add_text(text='D_001_T_006', speaker="GEORG")
	dialog.add_text(text='D_001_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_008', speaker="GEORG", follower='D_001_C_002')
	dialog.add_choice(text='D_001_C_002_1', follower='D_001_T_009')
	dialog.add_choice(text='D_001_C_002_2', follower='D_001_T_012')
	dialog.add_choice(text='D_001_C_002_3', follower='D_001_T_013')
	dialog.add_choice(text='D_001_C_002_5', follower='D_001_T_019',
			callback=Lambda('data().Dialog_001_C_002_5_ERLEDIGT=True'))
	dialog.add_text(text='D_001_T_009', speaker="GEORG")
	dialog.add_text(text='D_001_T_010', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_011', speaker="GEORG", follower='D_001_C_002')
	dialog.add_text(text='D_001_T_012', speaker="GEORG", follower='D_001_C_002')
	dialog.add_text(text='D_001_T_013', speaker="GEORG")
	dialog.add_text(text='D_001_T_014', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_015', speaker="GEORG", follower='D_001_C_002',
			callback=Lambda("dialog.add_choice(text='D_001_C_002_4', follower='D_001_T_016',"
					"callback=Lambda('data().Dialog_001_C_002_5_ERLEDIGT=True'))"))
	dialog.add_text(text='D_001_T_016', speaker="GEORG")
	dialog.add_text(text='D_001_T_017', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_018', speaker="GEORG", follower='D_001_C_002',
			callback=onDlg_001_T_018)
	dialog.add_text(text='D_001_T_019', speaker="GEORG", follower='D_001_C_002',
			callback=onDlg_001_T_019)
	dialog.add_text(text='D_001_T_020', speaker="GEORG")
	dialog.add_text(text='D_001_T_021', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_022', speaker="GEORG")
	dialog.add_text(text='D_001_T_023', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_024', speaker="GEORG")
	dialog.add_text(text='D_001_T_025', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_026', speaker="GEORG")
	dialog.add_text(text='D_001_T_027', speaker="ALTER_EGO")
	dialog.add_text(text='D_001_T_028', speaker="GEORG", follower='ENDDIALOG', callback=on_dialog_001_ende)
	dialog.start(False, [data('zone_2.zone_2').QB_013,
						 data('zone_3.zone_3').QB_002])

def onDlg_001_marker():
	if not data().player_knows_Bauer_Petes_Weide:
		data().player_knows_Bauer_Petes_Weide = True
		system.add_minimap_marker(389,439,"MM_001")#Farmer Petes Weide
	
def on_dialog_001_ende():
	objects.move_to(object="KUH1", x=objects.get_x("GEORG")+3, y=objects.get_y("GEORG")-2, speed=MT_FAST, grid="landscape",callback=["ONEND",onKuhMoveMuh])
	objects.move_to(object="KUH2", x=objects.get_x("GEORG")-1, y=objects.get_y("GEORG")-4, speed=MT_FAST, grid="landscape",callback=["ONEND",onKuhMoveMuh])
	objects.move_to(object="KUH3", x=objects.get_x("GEORG")-1.6, y=objects.get_y("GEORG")+1.5, speed=MT_FAST, grid="landscape",callback=["ONEND",onKuhMoveMuh])
	objects.move_to(object="KUH4", x=objects.get_x("GEORG")-3.4, y=objects.get_y("GEORG")+1.4, speed=MT_FAST, grid="landscape",callback=["ONEND",onKuhMoveMuh])
	objects.move_to(object="KUH5", x=objects.get_x("GEORG")-4, y=objects.get_y("GEORG")-4, speed=MT_FAST, grid="landscape",callback=["ONEND",onKuhMoveMuh])
	if was_zone_entered("zone_2.zone_2"):
		system.set_qb_entry_state(data("zone_2.zone_2").QB_013,INACTIVE)
	system.set_qb_entry_state(data().QB_002,UNCOMPLETE)
	finish_activity("MAGDA")

def onKuhMoveMuh(kuh):
	sound=random.choice(["cow_1","cow_2"])
	sounds.play_3d_sound_object(sfx_id=sound,object=kuh)
	if not dialog.is_dialog_active():
		initDlg_060_Kuehe_Muh(kuh)

def initCutscene_Dlg_002_Bauer_KueheTreiben():
	data().cutscene_kuehe_treiben_gestartet = True
	system.start_cutscene()
	poses = [[393.46, 448.13],[393.29, 448.68],[395.94, 447.55],
			[396.74, 446.32],[396.73, 444.48]]
	for pc in system.get_pcs():
		i = 0
		if pc != "ALTER_EGO":
			p = poses[i]
			i += 1
			if i == len(poses):
				i = 0
			if not objects.get_distance(pc, "ALTER_EGO") > 40:
				objects.move_to(pc, p[0], p[1], speed=MT_FAST)
				objects.turn_to_object(pc, "GEORG")
			
	pos=objects.get_position("GEORG")
	objects.move_to("ALTER_EGO",pos[0]+1.3,pos[1]+1.3,"landscape",MT_SLOW)
	system.set_camera_view(CAMVIEW_GEORGE_INTRO)
	objects.turn_to_object("ALTER_EGO", "GEORG",callback=["ONEND",onDlg_002_StartDialog])
	objects.turn_to_object("GEORG", "ALTER_EGO")

def onDlg_002_StartDialog(id):
	objects.turn_to_object("ALTER_EGO", "GEORG")
	objects.turn_to_object("GEORG", "ALTER_EGO")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_002')
	dialog.add_text(text='D_002_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("GEORG","ALTER_EGO",mode="medium_deep")'))
	dialog.add_text(text='D_002_T_002', speaker="GEORG", callback=Lambda('set_conversation("ALTER_EGO","GEORG",mode="medium_deep")'))
	dialog.add_text(text='D_002_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("GEORG","ALTER_EGO",mode="close_deep")'))
	dialog.add_text(text='D_002_T_004', speaker="GEORG", follower='ENDDIALOG', callback=onDlg_002_Ende)
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_002])

def onDlg_002_Ende():
	system.notify_timer(data().Timer_Kuh_Massaker, data().Timervalue_Kuh_Massaker_1)
	end_cutscene(chars=["ALTER_EGO", "GEORG"])

def initDlg_003_Bauer_ArmeKuehe():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_003')
	dialog.add_text(text='D_003_T_001', speaker="GEORG", follower='ENDDIALOG', callback = onDlg_003_Bauer_ArmeKuehe)
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_002,
						data('zone_3.zone_3').QB_003])

def onDlg_003_Bauer_ArmeKuehe():
	system.set_qb_entry_state(data().QB_002,INACTIVE)
	system.set_qb_entry_state(data().QB_003,UNCOMPLETE)

def initDlg_044_Bauer_VielSpass():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_044')
	dialog.add_text(text='D_044_T_001', speaker="GEORG", follower='ENDDIALOG')
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_003])


def initDlg_006_Bauer_TraktorKaputt():
	if len(data().Pete_Texte_Traktor):
		dialog.init_dialog(type=DIALOGSMALL)
		dialog.set_dialog_identifier('DH_D_006')
		TEXT = random.choice(data().Pete_Texte_Traktor)
		#print '[debug initDlg_006_Bauer_TraktorKaputt] Text = ', TEXT
		#print '[debug initDlg_006_Bauer_TraktorKaputt] data().Pete_Texte_Traktor = ', data().Pete_Texte_Traktor
		data().Pete_Texte_Traktor.remove(TEXT)
		dialog.add_text(text= TEXT, speaker="GEORG", follower='ENDDIALOG')
		dialog.start(False)
	else:
		data().Pete_Texte_Traktor = ['D_006_T_001', 'D_006_T_002', 'D_006_T_003', 'D_006_T_004', 'D_006_T_005', 'D_006_T_006']
	
def initDlg_007_Bauer_WillNichtMehr():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_007')
	dialog.add_text(text='D_007_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_007_T_002', speaker="GEORG", follower='ENDDIALOG')
	dialog.start()

def initDlg_033_Spieler_KeinBockAufMinen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_033')
	dialog.add_text(text='D_033_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_002])

def initCutscene_004_Spieler_BunkerUntersuchen():
	system.start_cutscene()
	system.set_camera_view(data().CamView_SpielerBunkerVerschlossen)
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_004')
	dialog.add_text(text='D_004_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_004_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_004_End)
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_003,
						data('zone_3.zone_3').QB_004])

def onGoergsMove(id):
	#if system.get_qb_entry_state(data().QB_002) == COMPLETE:
	if data().MainQuest_Dialog005:
		data().MainQuest_Dialog005 = False
		initCutscene_Dlg_005_Bauer_RatskullsNichtBesiegt()

def onDlg_004_End():
	system.set_camera_view(data().CamView_SpielerBunker)
	objects.set_position(object="ALTER_EGO", x=494, y=247)
	#objects.move_to(object="ALTER_EGO", x=498, y=236, grid="landscape")
	objects.move_to(object="ALTER_EGO", x=496.8, y=236.7, grid="landscape")
	objects.turn_to_position(object="ALTER_EGO", x=498, y=238)
	objects.set_position(object="GEORG", x=494, y=250)
	objects.move_to(object="GEORG", x=498, y=238, grid="landscape")
	objects.turn_to_position(object="GEORG", x=498, y=236,callback=["ONEND",onGoergsMove])
	data().MainQuest_Dialog005 = True
	objects.set_active_state("DONALD RUMS", ACTIVE)
	system.notify_region_entered(region="Steinbruch1", partyid="UISPIELER", permanent=True)
	system.notify_region_entered(region="Steinbruch2", partyid="UISPIELER", permanent=True)
	system.set_qb_entry_state(data().QB_003,INACTIVE)
	system.set_qb_entry_state(data().QB_004,UNCOMPLETE)
	
def initCutscene_Dlg_005_Bauer_RatskullsNichtBesiegt():
	set_conversation("GEORG","ALTER_EGO",mode='medium_deep')
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_005')
	dialog.add_text(text='D_005_T_001', speaker="GEORG",
		callback=Lambda('set_conversation("ALTER_EGO","GEORG",mode="medium_deep")'))
	dialog.add_text(text='D_005_T_002', speaker="ALTER_EGO",
		callback=Lambda('set_conversation("GEORG","ALTER_EGO",mode="medium_deep")'))
	dialog.add_text(text='D_005_T_003', speaker="GEORG",
		callback=Lambda('set_conversation("ALTER_EGO","GEORG",mode="close_deep")'))
	dialog.add_text(text='D_005_T_004', speaker="ALTER_EGO",
		callback=Lambda('set_conversation("GEORG","ALTER_EGO",mode="close_deep")'))
	dialog.add_text(text='D_005_T_005', speaker="GEORG")
	dialog.add_text(text='D_005_T_006', speaker="GEORG", follower='ENDDIALOG', callback=onDlg_005_End)
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_003,
						data('zone_3.zone_3').QB_017])

def onDlg_005_End():
	end_cutscene(chars=["GEORG", "ALTER_EGO"])
	objects.move_to(object="GEORG", x=496.4, y=226.0, grid="landscape")
	character.play_animation("GEORG", "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_START", callback=["ONEND", Lambda('data().Georg_LiegtUnterTraktor=True')])
	system.notify_region_entered(region="GeorgsTraktor", partyid="UISPIELER")
	system.notify_timer(data().Timer_GeorgGenugGelegen,data().Timervalue_GeorgGenugGelegen)
	system.set_qb_entry_state(data().QB_017,UNCOMPLETE)
	objects.set_active_state("DONALD RUMS", 1)
	system.notify_region_entered(region="Steinbruch1", partyid="UISPIELER")
	system.notify_region_entered(region="Steinbruch2", partyid="UISPIELER")


def initDlg_008_Sprengmeister_WillNichtJagen():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_008')
	dialog.add_text(text='D_008_T_001', speaker="DONALD RUMS")
	dialog.add_text(text='D_008_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_008_T_003', speaker="DONALD RUMS")
	dialog.add_text(text='D_008_T_004', speaker="DONALD RUMS", follower='D_008_C_001')
	dialog.add_choice(text='D_008_C_001_1', follower='D_008_T_018')
	dialog.add_choice(text='D_008_C_001_2', follower='D_008_T_008')
	dialog.add_choice(text='D_008_C_001_3', follower='D_008_T_009')
	dialog.add_choice(text='D_008_C_001_4', follower='D_008_T_005')
	dialog.add_text(text='D_008_T_005', speaker="DONALD RUMS")
	dialog.add_text(text='D_008_T_006', speaker="ALTER_EGO")
	dialog.add_text(text='D_008_T_007', speaker="DONALD RUMS", follower='D_008_C_001')
	dialog.add_text(text='D_008_T_008', speaker="DONALD RUMS", follower='D_008_C_001')
	dialog.add_text(text='D_008_T_009', speaker="DONALD RUMS", follower='D_008_C_001',
			callback=Lambda("dialog.add_choice('D_008_C_001_5', follower='D_008_T_010')"))
	dialog.add_text(text='D_008_T_010', speaker="DONALD RUMS")
	dialog.add_text(text='D_008_T_011', speaker="ALTER_EGO")
	dialog.add_text(text='D_008_T_012', speaker="DONALD RUMS", follower='D_008_C_001',
			callback=Lambda("dialog.add_choice('D_008_C_001_6', follower='D_008_T_013')"))
	dialog.add_text(text='D_008_T_013', speaker="DONALD RUMS")
	dialog.add_text(text='D_008_T_014', speaker="ALTER_EGO")
	dialog.add_text(text='D_008_T_015', speaker="DONALD RUMS")
	dialog.add_text(text='D_008_T_016', speaker="ALTER_EGO")
	dialog.add_text(text='D_008_T_017', speaker="DONALD RUMS", follower='ENDDIALOG', callback=on_dialog_008_ende)
	dialog.add_text(text='D_008_T_018', speaker="DONALD RUMS", follower='D_008_C_002', callback=Lambda('data().VonDonaldInfoWhg = True'))
	dialog.add_choice(text='D_008_C_002_1', follower='D_008_T_020')
	dialog.add_choice(text='D_008_C_002_2', follower='D_008_T_021')
	dialog.add_choice(text='D_008_C_002_3', follower='D_008_T_024')
	dialog.add_text(text='D_008_T_020', speaker="DONALD RUMS", follower='D_008_C_002')
	dialog.add_text(text='D_008_T_021', speaker="DONALD RUMS")
	dialog.add_text(text='D_008_T_022', speaker="ALTER_EGO")
	dialog.add_text(text='D_008_T_023', speaker="DONALD RUMS", follower='D_008_C_002')
	dialog.add_text(text='D_008_T_024', speaker="DONALD RUMS")
	dialog.add_text(text='D_008_T_025', speaker="DONALD RUMS")
	dialog.add_text(text='D_008_T_026', speaker="ALTER_EGO")
	dialog.add_text(text='D_008_T_027', speaker="DONALD RUMS", follower='D_008_C_001')
	dialog.start(False, [data('zone_3.zone_3').QB_005,
						 data('zone_3.zone_3').QB_019,
						 data('zone_3.zone_3').QB_022,
						 data('zone_3.zone_3').QB_017,
						 data('zone_3.zone_3').QB_023])

def on_dialog_008_ende():
	data().VonDonaldAufgabeBesorgeFleisch = True
	system.set_qb_entry_state(data().QB_019, UNCOMPLETE)
	system.set_qb_entry_state(data().QB_022, UNCOMPLETE)
	
	if data().one_dead_bison_found:
		system.set_qb_entry_state(data().QB_022,INACTIVE)
		system.set_qb_entry_state(data().QB_023,UNCOMPLETE)
	
	system.set_qb_entry_state(data().QB_017, INACTIVE)

def initCutscene_Dlg_009_Sprengmeister_WartenAufFleisch():
	system.start_cutscene()
	init_cutscene("ALTER_EGO", "DONALD RUMS", dx=1.0, dy=1.3)
	objects.turn_to_object("ALTER_EGO", "DONALD RUMS", callback=["ONEND", initDlg_009_Sprengmeister_WartenAufFleisch])

def initDlg_009_Sprengmeister_WartenAufFleisch(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_009')
	set_conversation("DONALD RUMS","ALTER_EGO",mode="medium_deep")
	dialog.add_text(text='D_009_T_001', speaker="DONALD RUMS", callback=Lambda('set_conversation("ALTER_EGO","DONALD RUMS",mode="close_deep")'))
	dialog.add_text(text='D_009_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("DONALD RUMS","ALTER_EGO",mode="close_deep")'))
	dialog.add_text(text='D_009_T_003', speaker="DONALD RUMS", follower='ENDDIALOG' , callback=onDlg_009_Ende)
	dialog.start(True, [data('zone_3.zone_3').QB_005,
						data('zone_3.zone_3').QB_019,
						data('zone_3.zone_3').QB_022,
						data('zone_3.zone_3').QB_023])

def onDlg_009_Ende():
	end_cutscene(chars=["DONALD RUMS", "ALTER_EGO"])
	allow_activity("DONALD RUMS")

def onDlg_010_EndDialog():
	system.set_qb_entry_state(data().QB_005, COMPLETE)
	system.set_qb_entry_state(data().QB_019,INACTIVE)
	system.set_qb_entry_state(data().QB_022,INACTIVE)
	system.set_qb_entry_state(data().QB_020,INACTIVE)
	system.set_qb_entry_state(data().QB_021,INACTIVE)
	system.set_qb_entry_state(data().QB_023,INACTIVE)
	character.add_experience_party( 120 )

	if len(data().Fleisch):
		for meat in data().Fleisch:
			objects.transfer_item(enemy_script.get_next_transfer_partner("DONALD RUMS",meat),meat,"DONALD RUMS")
			################################################################################
			# ob das noch gebraucht wird ? glaub nicht lasse es aber zur vorsicht noch drin
			if meat == data().obj_BisonfleischKadaber or meat == data().obj_BisonfleischKill or meat == "SET_BISON_MEAT":
				data().donald_has_bisonmeat = True
			if meat == data().obj_Tigerfleisch or meat == "SET_TIGER_MEAT":
				data().donald_has_tigermeat = True
			################################################################################
		#objects.transfer_item("DONALD RUMS",data().obj_DonaldsC4,"ALTER_EGO")
		if objects.get_attribute("ALTER_EGO","explosives") < 40:
			text_kommentar = globaltext.NOT_ENOUGH_EXPLOSIVE_SKILL_RESULT %{"char":objects.get_attribute("ALTER_EGO","name")}
			system.add_text(text_kommentar)
			objects.drop_item("DONALD RUMS",data().obj_DonaldsC4)
			objects.set_position(data().obj_DonaldsC4, objects.get_x("ALTER_EGO"), objects.get_y("ALTER_EGO"))
			if data().Stop_Ratskulls_All:
				system.create_object(equipmenttype='SET_C4_REMOTE_CONTROL', x = objects.get_x("ALTER_EGO") + 0.3, y = objects.get_y("ALTER_EGO"), direction = 45)
				system.create_object(equipmenttype='SET_C4_REMOTE_CONTROL', x = objects.get_x("ALTER_EGO"), y = objects.get_y("ALTER_EGO") + 0.3, direction = 100)
		else:
			objects.transfer_item("DONALD RUMS",data().obj_DonaldsC4,"ALTER_EGO")
			if data().Stop_Ratskulls_All:
				objects.create_item_in_inventory('ALTER_EGO',['SET_C4_REMOTE_CONTROL','SET_C4_REMOTE_CONTROL'])

	else: pass
#or objects.count_in_inventory('ALTER_EGO',"SET_BISON_MEAT")>0
def initDlg_010_Sprengmeister_BekommtFleisch():
	Invent = data().Fleisch
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_010')
	if ((data().obj_Tigerfleisch in Invent or "SET_TIGER_MEAT" in Invent or "Z3 TIGER_MEAT_2" in Invent) and (data().obj_BisonfleischKill in Invent or data(). obj_BisonfleischKadaber in Invent or "SET_BISON_MEAT" in Invent)):
		data().Fleisch = []
		if data().obj_Tigerfleisch in Invent:
			data().Fleisch.append(data().obj_Tigerfleisch)
		elif "Z3 TIGER_MEAT_2" in Invent:
			data().Fleisch.append("Z3 TIGER_MEAT_2")
		else:
			data().Fleisch.append("SET_TIGER_MEAT")
		if data().obj_BisonfleischKill in Invent:
			data().Fleisch.append(data().obj_BisonfleischKill)
		elif data().obj_BisonfleischKadaber in Invent:
			data().Fleisch.append(data().obj_BisonfleischKadaber)
		elif "Z3 BISON_MEAT_KADABER_2" in Invent:
			data().Fleisch.append("Z3 BISON_MEAT_KADABER_2")
		elif "Z3 BISON_MEAT_KADABER_KILL_2" in Invent:
			data().Fleisch.append("Z3 BISON_MEAT_KADABER_KILL_2")
		else:
			data().Fleisch.append("SET_BISON_MEAT")
		dialog.add_choice(text='D_010_C_002_1', follower='D_010_T_002')

	if (data().obj_Tigerfleisch in Invent or "SET_TIGER_MEAT" in Invent or "Z3 TIGER_MEAT_2" in Invent):
		if object_events.get_speech_skill("ALTER_EGO") >= 70:	# [BrainRipper]
			if data().obj_Tigerfleisch in Invent:
				dialog.add_choice(text='D_010_C_002_2', follower='D_010_T_010', callback = Lambda('data().Fleisch = [];data().Fleisch.append("%s")'%(data().obj_Tigerfleisch)))
			elif  "Z3 TIGER_MEAT_2" in Invent:
				dialog.add_choice(text='D_010_C_002_2', follower='D_010_T_010', callback = Lambda('data().Fleisch = [];data().Fleisch.append("%s")'%("Z3 TIGER_MEAT_2")))
			else:
				dialog.add_choice(text='D_010_C_002_2', follower='D_010_T_010', callback = Lambda('data().Fleisch = [];data().Fleisch.append("%s")'%("SET_TIGER_MEAT")))
		else :
			dialog.add_choice(text='D_010_C_002_2', follower='D_010_T_011')

	if (data().obj_BisonfleischKill in Invent or data(). obj_BisonfleischKadaber in Invent or "SET_BISON_MEAT" in Invent or
			"Z3 BISON_MEAT_KADABER_2" in Invent or "Z3 BISON_MEAT_KADABER_KILL_2" in Invent):

		if object_events.get_speech_skill("ALTER_EGO") >= 70:	# [BrainRipper]
			if (data().obj_BisonfleischKill in Invent):
				dialog.add_choice(text='D_010_C_002_3', follower='D_010_T_010', callback = Lambda('data().Fleisch = [];data().Fleisch.append("%s")'%(data().obj_BisonfleischKill)))
			elif (data().obj_BisonfleischKadaber in Invent):
				dialog.add_choice(text='D_010_C_002_3', follower='D_010_T_010', callback = Lambda('data().Fleisch = [];data().Fleisch.append("%s")'%(data().obj_BisonfleischKadaber)))
			elif ("Z3 BISON_MEAT_KADABER_2" in Invent):
				dialog.add_choice(text='D_010_C_002_3', follower='D_010_T_010', callback = Lambda('data().Fleisch = [];data().Fleisch.append("%s")'%("Z3 BISON_MEAT_KADABER_2")))
			elif ("Z3 BISON_MEAT_KADABER_KILL_2" in Invent):
				dialog.add_choice(text='D_010_C_002_3', follower='D_010_T_010', callback = Lambda('data().Fleisch = [];data().Fleisch.append("%s")'%("Z3 BISON_MEAT_KADABER_KILL_2")))
			
			else:
				dialog.add_choice(text='D_010_C_002_3', follower='D_010_T_010', callback = Lambda('data().Fleisch = [];data().Fleisch.append("%s")'%("SET_BISON_MEAT")))
		else:
			dialog.add_choice(text='D_010_C_002_3', follower='D_010_T_011')
		
	dialog.add_choice(text='D_010_C_002_4', follower='ENDDIALOG')
	dialog.add_text(text='D_010_T_002', speaker="DONALD RUMS")
	dialog.add_choice(text='D_010_C_001_1', follower='D_010_T_005')
	dialog.add_choice(text='D_010_C_001_2', follower='D_010_T_006')
	dialog.add_choice(text='D_010_C_001_3', follower='D_010_T_007')
	dialog.add_text(text='D_010_T_005', speaker="DONALD RUMS", follower='D_010_C_001')
	dialog.add_text(text='D_010_T_006', speaker="DONALD RUMS", follower='D_010_C_001')
	dialog.add_text(text='D_010_T_007', speaker="DONALD RUMS")
	dialog.add_text(text='D_010_T_008', speaker="ALTER_EGO")
	dialog.add_text(text='D_010_T_009', speaker="DONALD RUMS", follower='ENDDIALOG',
		callback= onDlg_010_EndDialog)
	dialog.add_text(text='D_010_T_010', speaker="DONALD RUMS", follower='D_010_C_001')
	dialog.add_text(text='D_010_T_011', speaker="DONALD RUMS", follower='ENDDIALOG')
	dialog.start(False, [data('zone_3.zone_3').QB_005,
						 data('zone_3.zone_3').QB_019,
						 data('zone_3.zone_3').QB_022,
						 data('zone_3.zone_3').QB_023,
						 data('zone_3.zone_3').QB_017])


def initDlg_045_Sprengmeister_WohnungsMakler():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_045')
	dialog.add_text(text='D_045_T_001', speaker="DONALD RUMS")
	dialog.add_text(text='D_045_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('data().VonDonaldInfoWhg=True'))
	dialog.start()


def initCutscene_Dlg_037_Spieler_UntersuchtFelsenwohnung(camview):
	system.start_cutscene()
	objects.turn_to_direction("ALTER_EGO",75)
	system.set_camera_view(camview)
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_037')
	dialog.add_text(text='D_037_T_001', speaker="ALTER_EGO", follower='ENDDIALOG',
		callback=Lambda('system.notify_timer(data().Timer_Wilma_Rufen, data().Timervalue_Wilma_Rufen)'))
	dialog.start()

def initCutscene_Dlg_037_Spieler_UntersuchtFelsenwohnung_2():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_037')
	dialog.add_text(text='D_037_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=end_cutscene)
	dialog.start()


def initCutscene_Dlg_011_Spieler_UntersuchtBison():
	data().one_dead_bison_found = True
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_BISON_KADAVER)
	objects.move_to("ALTER_EGO", 300.6, 328.5, speed=MT_SLOW)
	objects.turn_to_object("ALTER_EGO", data().Obj_BisonKadaver, callback=["ONEND", onDlg_011_StartDialog])

def onDlg_011_StartDialog(char_id):
	character.change_body_mode("ALTER_EGO","KNEEL")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_011')
	dialog.add_text(text='D_011_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_011_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_011_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback = EndDlg_011_StartDialog)
	dialog.start(True, [data('zone_3.zone_3').QB_022,
						data('zone_3.zone_3').QB_023])

def EndDlg_011_StartDialog():
	system.end_cutscene() 
	character.change_body_mode("ALTER_EGO","STAND")
	if system.get_qb_entry_state(data().QB_022) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_022,INACTIVE)
		system.set_qb_entry_state(data().QB_023,UNCOMPLETE)

def initDlg_012_Dorfbewohnerin_Besorgt():
	if not data().ZwillingsQuest_Gesperrt:
		dialog.init_dialog(type=DIALOGLARGE)
		dialog.set_dialog_identifier('DH_D_012')
		if not data().ZwillingsQuest_Mit_Dorfbewohnerin_Gesprochen:
			dialog.add_text(text='D_012_T_001', speaker="DORFBEWOHNERIN")
			dialog.add_text(text='D_012_T_002', speaker="ALTER_EGO")
			dialog.add_text(text='D_012_T_003', speaker="DORFBEWOHNERIN", follower='D_012_C_001')
			dialog.add_choice(text='D_012_C_001_1', follower='D_012_T_006')
			dialog.add_choice(text='D_012_C_001_2', follower='ENDDIALOG',
					callback=Lambda('data().ZwillingsQuest_Mit_Dorfbewohnerin_Gesprochen=True'))
			dialog.add_choice(text='D_012_C_001_3', follower='D_012_T_004')
			dialog.add_text(text='D_012_T_004', speaker="DORFBEWOHNERIN", follower='ENDDIALOG',
					callback=Lambda('data().ZwillingsQuest_Gesperrt=True'))
		dialog.add_text(text='D_012_T_005', speaker="ALTER_EGO")
		dialog.add_text(text='D_012_T_006', speaker="DORFBEWOHNERIN", follower='ENDDIALOG', callback=
				Lambda('system.set_qb_entry_state(data().QB_010,UNCOMPLETE)'))
		dialog.start(False, [data('zone_3.zone_3').QB_010,
							 data('zone_3.zone_3').QB_011])


def initDlg_048_Dorfbewohnerin_ImmerNochBesorgt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_048')
	dialog.add_text(text='D_048_T_001', speaker="DORFBEWOHNERIN", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_010,
						data('zone_3.zone_3').QB_011])

def initDlg_013_Luisa_Weint():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_013')
	dialog.add_text(text='D_013_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_010,
						data('zone_3.zone_3').QB_011])


def initDlg_014_Luisa_VermisstKinder():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_014')
	dialog.add_choice(text='D_014_C_001_1', follower='D_014_T_001',
			callback=Lambda('data().ZwillingsQuest_Mit_Lisa_Gesprochen=True'))
	dialog.add_choice(text='D_014_C_001_2', follower='ENDDIALOG')
	dialog.add_text(text='D_014_T_001', speaker="LUISA", follower='D_014_C_002')
	dialog.add_choice(text='D_014_C_002_1', follower='D_014_T_003',
			callback=Lambda('data().ZwillingsQuest_Luisa_Bezahlung=True'))
	dialog.add_choice(text='D_014_C_002_2', follower='D_014_T_002')
	dialog.add_choice(text='D_014_C_002_3', follower='D_014_T_004')
	dialog.add_text(text='D_014_T_002', speaker="LUISA", follower='ENDDIALOG', callback=[
			Lambda('data().ZwillingsQuest_Gesperrt=True')])
	dialog.add_text(text='D_014_T_003', speaker="LUISA", follower='D_014_T_006')
	dialog.add_text(text='D_014_T_004', speaker="LUISA")
	dialog.add_text(text='D_014_T_005', speaker="ALTER_EGO")
	dialog.add_text(text='D_014_T_006', speaker="ALTER_EGO")
	dialog.add_text(text='D_014_T_007', speaker="LUISA")
	dialog.add_text(text='D_014_T_008', speaker="LUISA")
	dialog.add_text(text='D_014_T_009', speaker="ALTER_EGO", follower='ENDDIALOG', callback=[
			Lambda('system.set_qb_entry_state(data().QB_010,INACTIVE)'),
			Lambda('system.set_qb_entry_state(data().QB_011,UNCOMPLETE)')])
	dialog.start(True, [data('zone_3.zone_3').QB_010,
						data('zone_3.zone_3').QB_011])


def initCutscene_Dlg_016_Luisa_Dankbar_KeineBezahlung():
	system.start_cutscene()
	init_cutscene("ALTER_EGO", "LUISA", dx=1.3, dy=1.0)
	objects.turn_to_object("ALTER_EGO","LUISA", callback=["ONEND", initDlg_016_Luisa_Dankbar_KeineBezahlung])

def initDlg_016_Luisa_Dankbar_KeineBezahlung(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_016')
	set_conversation("LUISA","ALTER_EGO", mode="medium_deep")
	dialog.add_text(text='D_016_T_001', speaker="LUISA", callback=Lambda('set_conversation("ALTER_EGO","LUISA", mode="close_deep")'))
	dialog.add_text(text='D_016_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("LUISA","ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_016_T_003', speaker="LUISA", follower='ENDDIALOG', callback=onDlg_016_Ende)
	dialog.start(True, [data('zone_3.zone_3').QB_012,
						data('zone_3.zone_3').QB_011])

def onDlg_016_Ende():
	system.set_qb_entry_state(data().QB_011,COMPLETE)
	system.set_qb_entry_state(data().QB_012,INACTIVE)
	end_cutscene(chars=["LUISA", "ALTER_EGO"])
	allow_activity("LUISA")
	data().ZwillingsQuest_Luisa_HatSichBedankt = True

def initCutscene_Dlg_017_Luisa_Dankbar_MitBezahlung():
	system.start_cutscene()
	init_cutscene("ALTER_EGO", "LUISA", dx=1.3, dy=1.0)
	objects.turn_to_object("ALTER_EGO","LUISA", callback=["ONEND", initDlg_017_Luisa_Dankbar_MitBezahlung])

def initDlg_017_Luisa_Dankbar_MitBezahlung(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_017')
	set_conversation("LUISA","ALTER_EGO", mode="medium_deep")
	dialog.add_text(text='D_017_T_001', speaker="LUISA", callback=Lambda('set_conversation("ALTER_EGO","LUISA", mode="medium_deep")'))
	dialog.add_text(text='D_017_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("LUISA","ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_017_T_003', speaker="LUISA", callback=Lambda('set_conversation("LUISA","ALTER_EGO", mode="close_deep", new_camera=False)'))
	dialog.add_text(text='D_017_T_004', speaker="LUISA", callback=Lambda('set_conversation("ALTER_EGO","LUISA", mode="close_deep")'))
	dialog.add_text(text='D_017_T_005', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_017_Ende)
	dialog.start(True, [data('zone_3.zone_3').QB_012,
						data('zone_3.zone_3').QB_011])

def onDlg_017_Ende():
	end_cutscene(chars=["LUISA", "ALTER_EGO"])
	allow_activity("LUISA")
	data().ZwillingsQuest_Luisa_HatSichBedankt = True
	system.set_qb_entry_state(data().QB_011,COMPLETE)
	system.set_qb_entry_state(data().QB_012,INACTIVE)

def initCutscene_Dlg_018_Doerfler_WoIstDerSchnapps():
	system.start_cutscene()
	for char in system.get_pcs():
		objects.turn_to_object(char,"DOERFLER A")
	system.set_camera_view(CAMVIEW_BESOFFENE_INTRO)
	PlaySpeechAnimation("DOERFLER A")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_018')
	dialog.add_text(text='D_018_T_001', speaker="DOERFLER A", callback=[
		Lambda("PlaySpeechAnimation('DOERFLER B')")])
	dialog.add_text(text='D_018_T_002', speaker="DOERFLER B", callback=[
		Lambda('system.set_camera_view(CAMVIEW_BESOFFENE_3)'),
		Lambda("PlaySpeechAnimation('DOERFLER C')")])
	dialog.add_text(text='D_018_T_003', speaker="DOERFLER C", callback=[
		Lambda("system.set_camera_view(CAMVIEW_BESOFFENE_INTRO)"),#[254.49*2, 362.01*2, 5.42*2, -0.22*2, -0.94*2, -0.21*2])"),
		Lambda("PlaySpeechAnimation( 'DOERFLER B' )")])
	dialog.add_text(text='D_018_T_004', speaker="DOERFLER B", callback=[
		Lambda('system.set_camera_view(CAMVIEW_BESOFFENE_2)'),
		Lambda("PlaySpeechAnimation( 'DOERFLER A' )")])
	dialog.add_text(text='D_018_T_005', speaker="DOERFLER A", callback=[
		Lambda("system.set_camera_view(CAMVIEW_BESOFFENE_INTRO)"),#[254.49*2, 362.01*2, 5.42*2, -0.22*2, -0.94*2, -0.21*2])"),
		Lambda("PlaySpeechAnimation( 'DOERFLER B' )")])
	dialog.add_text(text='D_018_T_006', speaker="DOERFLER B", callback=[
		Lambda('system.set_camera_view(CAMVIEW_BESOFFENE_3)'),
		Lambda("PlaySpeechAnimation( 'DOERFLER C' )")])
	dialog.add_text(text='D_018_T_007', speaker="DOERFLER C", follower='ENDDIALOG',callback = Dlg_018_QB)
	dialog.start(True, data('zone_3.zone_3').QB_006)

def Dlg_018_QB():
	if not data().Stop_Ratskulls_Distillery:
		system.set_qb_entry_state(data().QB_006,UNCOMPLETE)
	system.end_cutscene()
	data().Doerfeler_TA_gestartet = True
	
def initDlg_019_Doerfaeltester_KeinGespraech():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_019')
	dialog.add_text(text='D_019_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()


def initDlg_020_Doerfaeltester_SorgeUmSchnapps():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_020')
	dialog.add_text(text='D_020_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_020_T_002', speaker="DORFAELTESTER")
	dialog.add_text(text='D_020_T_012', speaker="DORFAELTESTER")
	dialog.add_text(text='D_020_T_003', speaker="ALTER_EGO")
	dialog.add_choice(text='D_020_C_001_1', follower='D_020_T_004')
	dialog.add_choice(text='D_020_C_001_2', follower='D_020_T_005')
	dialog.add_choice(text='D_020_C_001_3', follower='D_020_T_006')
	dialog.add_text(text='D_020_T_004', speaker="DORFAELTESTER", follower='ENDDIALOG', callback=[
			Lambda('system.set_qb_entry_state(data().QB_006,INACTIVE)')])
	dialog.add_text(text='D_020_T_005', speaker="DORFAELTESTER", follower="D_020_C_001_1")
	dialog.add_text(text='D_020_T_006', speaker="DORFAELTESTER")
	dialog.add_choice(text='D_020_C_002_1', follower='D_020_T_008')
	dialog.add_choice(text='D_020_C_002_2', follower='D_020_T_007')
	dialog.add_text(text='D_020_T_007', speaker="DORFAELTESTER", follower='ENDDIALOG', callback=[
			Lambda('system.set_qb_entry_state(data().QB_006,INACTIVE)')])
	dialog.add_text(text='D_020_T_008', speaker="DORFAELTESTER")
	dialog.add_text(text='D_020_T_009', speaker="ALTER_EGO")
	dialog.add_text(text='D_020_T_010', speaker="DORFAELTESTER")
	dialog.add_choice(text='D_020_C_003_1', follower='ENDDIALOG', callback=[
			Lambda('system.set_qb_entry_state(data().QB_006,INACTIVE)'),
			Lambda('system.set_qb_entry_state(data().QB_007,UNCOMPLETE)')])
	dialog.add_choice(text='D_020_C_003_2', follower='D_020_T_011')
	dialog.add_text(text='D_020_T_011', speaker="DORFAELTESTER", follower='ENDDIALOG', callback=[
			Lambda('system.set_qb_entry_state(data().QB_006,INACTIVE)')])
	dialog.start(True, data('zone_3.zone_3').QB_006)

def initDlg_046_Doerfaeltester_NochNichtsErreicht():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_046')
	dialog.add_text(text='D_046_T_001', speaker="DORFAELTESTER")
	dialog.add_text(text='D_046_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_046_T_003', speaker="DORFAELTESTER", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_006)

def initDlg_021_Doerfaeltester_SchnappsBefreit_spawn_loot():
	objects.create_item_in_inventory("BUILDING_2552","SET_COLT_ANACONDA")
	objects.create_item_in_inventory("BUILDING_2552","SET_AMMOPACK_44")
	objects.create_item_in_inventory("BUILDING_2552","SET_AMMOPACK_44")
	objects.create_item_in_inventory("BUILDING_2768","SET_WALTER_PPK")
	objects.create_item_in_inventory("BUILDING_2768","SET_AMMOPACK_7_65_MM")
	objects.create_item_in_inventory("BUILDING_2768","SET_AMMOPACK_7_65_MM")

def initCutscene_Dlg_021_Doerfaeltester_SchnappsBefreit():
	system.start_cutscene()
	init_cutscene("ALTER_EGO", "DORFAELTESTER", dx=1.0, dy=-1.3, step_away=(get_location("DORFAELTESTER") in [4]))
	objects.turn_to_object("ALTER_EGO","DORFAELTESTER", callback=["ONEND", initDlg_021_Doerfaeltester_SchnappsBefreit])

def initDlg_021_Doerfaeltester_SchnappsBefreit(id):
	set_conversation("ALTER_EGO","DORFAELTESTER", mode="close_deep")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_021')
	dialog.add_text(text='D_021_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("DORFAELTESTER","ALTER_EGO", mode="medium_deep")'))
	dialog.add_text(text='D_021_T_002', speaker="DORFAELTESTER", callback=Lambda('set_conversation("ALTER_EGO","DORFAELTESTER", mode="close_deep")'))
	dialog.add_text(text='D_021_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("DORFAELTESTER","ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_021_T_004', speaker="DORFAELTESTER", callback=Lambda('set_conversation("ALTER_EGO","DORFAELTESTER", mode="close_deep")'))
	dialog.add_text(text='D_021_T_005', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_021_Ende)
	dialog.start(True, data('zone_3.zone_3').QB_006)

def onDlg_021_Ende():
	allow_activity("DORFAELTESTER")
	end_cutscene(chars=["DORFAELTESTER", "ALTER_EGO"])
	system.set_qb_entry_state(data().QB_007,COMPLETE)
	system.set_qb_entry_state(data().QB_018,INACTIVE)
	initDlg_021_Doerfaeltester_SchnappsBefreit_spawn_loot()
	character.add_experience_party(data().Exp_Schnaps)

def initDlg_047_Doerfaeltester_Hick():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_047')
	dialog.add_text(text='D_047_T_001', speaker="DORFAELTESTER")
	dialog.add_text(text='D_047_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_006)
	
def initDlg_047_Doerfaeltester_Hick_short():
	if system.get_qb_entry_state(data().QB_006) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_006, IMPOSSIBLE)
	if system.get_qb_entry_state(data().QB_007) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_007, IMPOSSIBLE)
	if system.get_qb_entry_state(data().QB_018) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_018, IMPOSSIBLE)
	
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_047')
	dialog.add_text(text='D_047_T_001', speaker="DORFAELTESTER", follower='ENDDIALOG')
	#dialog.add_text(text='D_047_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_006)

def initCutscene_Dlg_081_Dorfaeltester_DistillerieOhneAuftragBefreit():
	system.start_cutscene()
	init_cutscene("ALTER_EGO", "DORFAELTESTER", dx=1.0, dy=-1.3, step_away=(get_location("DORFAELTESTER") in [4]))
	objects.turn_to_object("ALTER_EGO","DORFAELTESTER", callback=["ONEND", initDlg_081_Dorfaeltester_DistillerieOhneAuftragBefreit])

def Dlg_081_TurnTo(id):
	objects.turn_to_object("DORFAELTESTER","ALTER_EGO", callback=["ONEND", initDlg_081_Dorfaeltester_DistillerieOhneAuftragBefreit])

def initDlg_081_Dorfaeltester_DistillerieOhneAuftragBefreit(id):
	set_conversation("ALTER_EGO","DORFAELTESTER", mode="close_deep")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_081')
	dialog.add_text(text='D_081_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("DORFAELTESTER","ALTER_EGO", mode="medium_deep")'))
	dialog.add_text(text='D_081_T_002', speaker="DORFAELTESTER", callback=Lambda('set_conversation("ALTER_EGO","DORFAELTESTER", mode="close_deep")'))
	dialog.add_text(text='D_081_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("DORFAELTESTER","ALTER_EGO", mode="medium_deep")'))
	dialog.add_text(text='D_081_T_004', speaker="DORFAELTESTER", callback=Lambda('set_conversation("ALTER_EGO","DORFAELTESTER", mode="close_deep")'))
	dialog.add_text(text='D_081_T_005', speaker="ALTER_EGO", callback=Lambda('set_conversation("DORFAELTESTER","ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_081_T_006', speaker="DORFAELTESTER", callback=Lambda('set_conversation("ALTER_EGO","DORFAELTESTER", mode="close_deep")'))
	dialog.add_text(text='D_081_T_007', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_081_Ende)
	dialog.start(True, data('zone_3.zone_3').QB_006)

def onDlg_081_Ende():
	end_cutscene(chars=["DORFAELTESTER", "ALTER_EGO"])
	allow_activity("DORFAELTESTER")
	initDlg_021_Doerfaeltester_SchnappsBefreit_spawn_loot()
	system.set_qb_entry_state(data().QB_007,COMPLETE)
	system.set_qb_entry_state(data().QB_006,INACTIVE)
	data().Doerfeler_TA_gestartet = True

def initDlg_022_GonzosFrau_Bote():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_022')
	dialog.add_choice(text='D_022_C_001_1', follower='D_022_T_001')
	dialog.add_choice(text='D_022_C_001_2', follower='D_022_T_005')
	dialog.add_choice(text='D_022_C_001_3', follower='ENDDIALOG')
	dialog.add_text(text='D_022_T_001', speaker="BARBARA", follower='D_022_T_003')
	dialog.add_text(text='D_022_T_003', speaker="ALTER_EGO")
	dialog.add_text(text='D_022_T_004', speaker="BARBARA", follower='D_022_C_002')
	dialog.add_choice(text='D_022_C_002_1', follower='D_022_T_005')
	dialog.add_choice(text='D_022_C_002_2', follower='D_022_T_005')
	dialog.add_choice(text='D_022_C_002_3', follower='ENDDIALOG')
	dialog.add_text(text='D_022_T_005', speaker="BARBARA", follower='D_022_C_003')
	dialog.add_choice(text='D_022_C_003_1', follower='D_022_T_010')
	dialog.add_choice(text='D_022_C_003_2', follower='D_022_T_012')
	dialog.add_choice(text='D_022_C_003_3', follower='ENDDIALOG', callback=
			Lambda('data().GonzoQuest_GonzosFrau_DialogVergeigt=True'))
	dialog.add_text(text='D_022_T_010', speaker="BARBARA")
	dialog.add_text(text='D_022_T_011', speaker="ALTER_EGO", follower='D_022_C_003')
	dialog.add_text(text='D_022_T_012', speaker="BARBARA", follower='D_022_C_004')
	dialog.add_choice(text='D_022_C_004_1', follower='D_022_T_017')
	dialog.add_choice(text='D_022_C_004_2', follower='ENDDIALOG', callback=
			Lambda('data().GonzoQuest_GonzosFrau_DialogVergeigt=True'))
	dialog.add_text(text='D_022_T_017', speaker="BARBARA")
	dialog.add_text(text='D_022_T_018', speaker="ALTER_EGO", follower='ENDDIALOG', callback=[
			Lambda('system.notify_timer(data().Timer_GonzoTimeout, data().Timervalue_GonzoTimeout)'),
			Lambda('system.set_qb_entry_state(data().QB_013, UNCOMPLETE)')])
	dialog.start(True, data('zone_3.zone_3').QB_013)

def initCutscene_Dlg_027_GonzosFrau_GonzoTot():
	system.start_cutscene()
	init_cutscene("ALTER_EGO","BARBARA", dx=1.1, dy=1.4, step_away=(get_location("BARBARA") in [2,3,4]))
	objects.turn_to_object("ALTER_EGO","BARBARA", callback=["ONEND", initDlg_027_GonzosFrau_GonzoTot])

def initDlg_027_GonzosFrau_GonzoTot(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_027')
	set_conversation("ALTER_EGO","BARBARA",mode="medium")
	dialog.add_text(text='D_027_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("BARBARA","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_027_T_002', speaker="BARBARA", callback=Lambda('set_conversation("ALTER_EGO","BARBARA",mode="medium")'))
	dialog.add_text(text='D_027_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("BARBARA","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_027_T_004', speaker="BARBARA", callback=Lambda('set_conversation("ALTER_EGO","BARBARA",mode="medium")'))
	dialog.add_text(text='D_027_T_005', speaker="ALTER_EGO", callback=Lambda('set_conversation("BARBARA","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_027_T_006', speaker="BARBARA", callback=Lambda('set_conversation("ALTER_EGO","BARBARA",mode="close")'))
	dialog.add_text(text='D_027_T_007', speaker="ALTER_EGO", callback=Lambda('set_conversation("BARBARA","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_027_T_008', speaker="BARBARA", callback=Lambda('set_conversation("ALTER_EGO","BARBARA",mode="close")'))
	dialog.add_text(text='D_027_T_009', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_027_Ende)
	dialog.start(True, data('zone_3.zone_3').QB_013)

def onDlg_027_Ende():
	data().GonzoQuest_Dialog_27_Erledigt=True
	end_cutscene(chars=["BARBARA", "ALTER_EGO"])
	allow_activity("BARBARA")

def initDlg_028_GonzosFrau_GehtsGut():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_028')
	dialog.add_text(text='D_028_T_001', speaker="BARBARA")
	dialog.add_text(text='D_028_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_013)

def initDlg_082_GonzosFrau_TrauerNachTodGonzosOhneAuftrag():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_082')
	dialog.add_text(text='D_082_T_001', speaker="BARBARA")
	dialog.add_text(text='D_082_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_082_T_003', speaker="BARBARA")
	dialog.add_text(text='D_082_T_004', speaker="ALTER_EGO", follower='ENDDIALOG', callback=[Lambda('data().GonzoQuest_Dialog_27_Erledigt=True')])
	dialog.start(True, data('zone_3.zone_3').QB_013)


def initDlg_038_McKanzee_WillNichtReden():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_038')
	dialog.add_text(text='D_038_T_001', speaker='MCKANZEE', follower='ENDDIALOG')
	dialog.start()


def initDlg_030_McKanzee_WillWasser():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_030')
	if not data().BatterieQuest_McKanzee_Gespraech_Fortsetzen_T_014:
		dialog.add_text(text='D_030_T_001', speaker="ALTER_EGO")
		dialog.add_text(text='D_030_T_002', speaker='MCKANZEE', follower='D_030_C_001')
		dialog.add_choice(text='D_030_C_001_1', follower='D_030_T_007')
		dialog.add_choice(text='D_030_C_001_2', follower='D_030_T_013')
		dialog.add_text(text='D_030_T_007', speaker='MCKANZEE')
		dialog.add_text(text='D_030_T_008', speaker="ALTER_EGO")
		dialog.add_text(text='D_030_T_009', speaker='MCKANZEE')
		dialog.add_text(text='D_030_T_010', speaker="ALTER_EGO")
		dialog.add_text(text='D_030_T_011', speaker='MCKANZEE')
		dialog.add_text(text='D_030_T_012', speaker="ALTER_EGO")
		dialog.add_text(text='D_030_T_013', speaker='MCKANZEE', follower='D_030_C_002')
		dialog.add_choice(text='D_030_C_002_1', follower='D_030_T_015')
		dialog.add_choice(text='D_030_C_002_2', follower='ENDDIALOG',
				callback=Lambda('data().BatterieQuest_McKanzee_Gespraech_Fortsetzen_T_014=True'))
	dialog.add_text(text='D_030_T_014', speaker="ALTER_EGO")
	dialog.add_text(text='D_030_T_015', speaker='MCKANZEE', follower='D_030_T_019')
	dialog.add_text(text='D_030_T_019', speaker='MCKANZEE', follower='D_030_C_003')
	dialog.add_choice(text='D_030_C_003_1', follower='D_030_T_027')
	dialog.add_choice(text='D_030_C_003_2', follower='D_030_T_021')
	dialog.add_choice(text='D_030_C_003_3', follower='D_030_T_023')
	dialog.add_choice(text='D_030_C_003_4', follower='ENDDIALOG')
	dialog.add_text(text='D_030_T_020', speaker="ALTER_EGO", follower='D_030_T_023')
	dialog.add_text(text='D_030_T_021', speaker='MCKANZEE')
	dialog.add_text(text='D_030_T_022', speaker="ALTER_EGO")
	dialog.add_text(text='D_030_T_023', speaker='MCKANZEE')
	dialog.add_text(text='D_030_T_024', speaker="ALTER_EGO", follower='ENDDIALOG', callback=[
			Lambda('system.set_qb_entry_state(data().QB_009, UNCOMPLETE)'),
			Lambda('system.set_qb_entry_state(data().QB_008, INACTIVE)')])
	dialog.add_text(text='D_030_T_027', speaker='MCKANZEE')
	dialog.add_text(text='D_030_T_028', speaker="ALTER_EGO", follower='D_030_C_003')
	dialog.start(False, [data('zone_3.zone_3').QB_008,
						 data('zone_3.zone_3').QB_009])

def initCutscene_Dlg_039_McKanzee_KeinWasser():
	system.start_cutscene()
	init_cutscene("ALTER_EGO","MCKANZEE", dx=1.0, dy=1.5)
	objects.turn_to_object("ALTER_EGO", "MCKANZEE",callback=["ONEND", initDlg_039_McKanzee_KeinWasser])

def initDlg_039_McKanzee_KeinWasser(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_039')
	set_conversation("MCKANZEE","ALTER_EGO", mode="medium")
	dialog.add_text(text='D_039_T_001', speaker="MCKANZEE", callback=Lambda('set_conversation("ALTER_EGO","MCKANZEE", mode="close")'))
	dialog.add_text(text='D_039_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("MCKANZEE","ALTER_EGO", mode="close")'))
	dialog.add_text(text='D_039_T_003', speaker="MCKANZEE", follower='ENDDIALOG', callback=onDlg_039_Ende)
	dialog.start(True, [data('zone_3.zone_3').QB_008,
						data('zone_3.zone_3').QB_009])

def onDlg_039_Ende():
	end_cutscene(chars=["MCKANZEE", "ALTER_EGO"])
	allow_activity("MCKANZEE")

def initCutscene_Dlg_031_McKanzee_BekommtWasser(items = None):
	system.start_cutscene()
	init_cutscene("ALTER_EGO", "MCKANZEE",dx=1.0, dy=1.5)
	objects.turn_to_object("ALTER_EGO", "MCKANZEE", callback=["ONEND", Lambda('initDlg_031_McKanzee_BekommtWasser("ALTER_EGO", %s)' %items)])

def initDlg_031_McKanzee_BekommtWasser(id, items):
	set_conversation("ALTER_EGO","MCKANZEE", mode="medium")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_031')
	dialog.add_text(text='D_031_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("MCKANZEE","ALTER_EGO", mode="medium")'))
	dialog.add_text(text='D_031_T_002', speaker="MCKANZEE", callback=Lambda('set_conversation("ALTER_EGO","MCKANZEE", mode="close")'))
	dialog.add_text(text='D_031_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("MCKANZEE","ALTER_EGO", mode="close")'))
	dialog.add_text(text='D_031_T_004', speaker="MCKANZEE", follower='ENDDIALOG', callback=Lambda('onDlg_031_Ende(%s)'%items))
	dialog.start(True, [data('zone_3.zone_3').QB_008,
						data('zone_3.zone_3').QB_009])

def onDlg_031_Ende(items):
#	print items
	end_cutscene(chars=["MCKANZEE", "ALTER_EGO"])
	system.set_qb_entry_state(data().QB_009, INACTIVE)
	system.set_qb_entry_state(data().QB_008,UNCOMPLETE)

	for pc in items.keys():
		for item in items[pc]:
			objects.remove_item_from_inventory(pc, item)

	objects.transfer_item("MCKANZEE",data().obj_Autobatterie,"ALTER_EGO")
	allow_activity("MCKANZEE")
	allow_activity("HAENDLER")
	character.add_experience_party(data().Exp_McKanzee)

def initDlg_040_McKanzee_HautAb():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_040')
	dialog.add_text(text='D_040_T_001', speaker="MCKANZEE", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_009)


def initCutscene_034_Ratskulls_WhiskyMachtSpass():
	if not system.is_cutscene():
		system.start_cutscene()
	system.set_camera_view(data().CamView_RatskullLagerWhiskyMachtSpass)
	for pc in system.get_pcs():
		if pc != "ALTER_EGO":
			if objects.get_distance(pc,"ALTER_EGO") <= 15.0:
				objects.cancel_commandos(pc)
				character.change_body_mode(pc,"KNEEL")
				objects.turn_to_object(pc,"RATSKULLS A")
	objects.cancel_commandos("ALTER_EGO")
	objects.set_position("ALTER_EGO", 561.82, 422.77)
	character.change_body_mode("ALTER_EGO","KNEEL")
	objects.move_to("ALTER_EGO",560.63,421.28, speed=MT_SLOW)
	objects.turn_to_object("ALTER_EGO","RATSKULLS A")
	data().rs_position_counter = 0
	character.unequip_hands(char_id="RATSKULLS A", direct_unequip=True)
	objects.create_item_in_inventory("RATSKULLS A","SET_EMPTY_BOTTLE")
	character.equip_direct("RATSKULLS A","SET_EMPTY_BOTTLE")
	
	objects.move_to("RATSKULLS A", 558.45, 405.33, "landscape", MT_SLOW, callback=["ONEND", initDlg_034_Ratskulls_WhiskyMachtSpass])
	objects.cancel_commandos("RATSKULLS B")
	objects.move_to("RATSKULLS B", 560.9, 405.2, "landscape", MT_SLOW, callback=["ONEND", initDlg_034_Ratskulls_WhiskyMachtSpass])
	objects.cancel_commandos("RATSKULLS C")
	objects.move_to("RATSKULLS C", 560.0, 407.2, "landscape", MT_SLOW, callback=["ONEND", initDlg_034_Ratskulls_WhiskyMachtSpass])

def initDlg_034_Ratskulls_WhiskyMachtSpass(id):
	objects.turn_to_object(id, "RATSKULLS A")
	data().rs_position_counter += 1
	if data().rs_position_counter == 3:
		dialog.init_dialog(type=DIALOGSMALL)
		dialog.set_dialog_identifier('DH_D_034')
		set_conversation("RATSKULLS A", "RATSKULLS B", mode="far", first_obj="RATSKULLS A")
		dialog.add_text(text='D_034_T_001', speaker="RATSKULLS A", callback=Lambda('set_conversation("RATSKULLS B", "RATSKULLS A", mode="medium_deep")'))
		dialog.add_text(text='D_034_T_002', speaker="RATSKULLS B", callback=Lambda('set_conversation("RATSKULLS C", "RATSKULLS B", mode="medium_deep", first_obj="RATSKULLS B")'))
		dialog.add_text(text='D_034_T_003', speaker="RATSKULLS C", callback=Lambda('set_conversation("RATSKULLS A", "RATSKULLS C", mode="medium_deep", first_obj="RATSKULLS A")'))
		dialog.add_text(text='D_034_T_004', speaker="RATSKULLS A", callback=Lambda('set_conversation("RATSKULLS C", "RATSKULLS A", mode="close_deep")'))
		dialog.add_text(text='D_034_T_005', speaker="RATSKULLS C", callback=Lambda('set_conversation("RATSKULLS B", "RATSKULLS C", mode="close_deep", first_obj="RATSKULLS B")'))
		dialog.add_text(text='D_034_T_006', speaker="RATSKULLS B", callback=Lambda('set_conversation("RATSKULLS A", "RATSKULLS B", mode="close_deep")'))
		dialog.add_text(text='D_034_T_007', speaker="RATSKULLS A", callback=Lambda('set_conversation("RATSKULLS C", "RATSKULLS B", mode="close_deep")'))
		dialog.add_text(text='D_034_T_008', speaker="RATSKULLS C", callback=Lambda('set_conversation("RATSKULLS B", "RATSKULLS C", mode="close_deep")'))
		dialog.add_text(text='D_034_T_009', speaker="RATSKULLS B", follower='ENDDIALOG', callback=onDlg_034_Ende)
		dialog.start(True, data('zone_3.zone_3').QB_006)

def onDlg_034_Ende():
	objects.cancel_commandos("RATSKULLS A")
	objects.move_to("RATSKULLS A", 557.00, 404.00, "landscape", MT_SLOW, callback=["ONEND", initDlg_034_RatskullSchlaeft])
	allow_activity("RATSKULLS A")
	initCutscene_Dlg_049_Ratskulls_BesoffenePenner()
	set_conversation(first_obj="ALTER_EGO")

def initDlg_034_RatskullSchlaeft(id):
	character.play_animation("RATSKULLS A", "CM_NPC_LIEGEN_HINLEGEN", callback=["ONEND", onRatskullBeginsSnorking])
	data().BesoffeneRatskullSchlaeft = True
	character.set_approachable_state("RATSKULLS A",NOTAPPROACHABLE)

def onRatskullBeginsSnorking(char):
	system.notify_timer(data().Timer_RatskullASnork, 1000)
	objects.drop_item("RATSKULLS A","SET_EMPTY_BOTTLE")

def initCutscene_Dlg_049_Ratskulls_BesoffenePenner():
	objects.turn_to_object("ALTER_EGO","BUILDING_1133", callback=["ONEND", initDlg_049_Ratskulls_BesoffenePenner])

def initDlg_049_Ratskulls_BesoffenePenner(id):
	system.set_camera_view(CAMVIEW_RATS_DRUNKEN_OUTTRO)
	objects.turn_to_object("ALTER_EGO","RATSKULLS B")
	character.change_body_mode("ALTER_EGO","STAND")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_049')
	dialog.add_text(text='D_049_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_049_Ende)
	dialog.start(True, data('zone_3.zone_3').QB_006)

def onDlg_049_Ende():
	end_cutscene(chars=["RATSKULLS B", "RATSKULLS C"])
	allow_activity("RATSKULLS B")
	allow_activity("RATSKULLS C")

def initDlg_035_Ratskulls_Gespraech():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_035')
	dialog.add_text(text='D_035_T_001', speaker="RATSKULLS B")
	if (objects.get_attribute('ALTER_EGO', 'gender') == 'male'):
		dialog.add_text(text='D_035_T_002', speaker="RATSKULLS C", follower='D_035_C_001')
	elif (objects.get_attribute('ALTER_EGO', 'gender') == 'female'):
		dialog.add_text(text='D_035_T_002F', speaker="RATSKULLS C", follower='D_035_C_001')
	dialog.add_choice(text='D_035_C_001_1', follower='D_035_T_003')
	dialog.add_choice(text='D_035_C_001_2', follower='D_035_T_006')
	dialog.add_choice(text='D_035_C_001_3', follower='D_035_T_015')
	dialog.add_text(text='D_035_T_003', speaker="RATSKULLS B")
	dialog.add_text(text='D_035_T_004', speaker="ALTER_EGO")
	dialog.add_text(text='D_035_T_005', speaker="RATSKULLS C", follower='ENDDIALOG', callback=[
			Lambda('objects.set_attribute(object="RATSKULLS B", attribute="foes", value=["UISPIELER"])'),
			Lambda('objects.set_attribute(object="RATSKULLS C", attribute="foes", value=["UISPIELER"])')])
	dialog.add_text(text='D_035_T_006', speaker="RATSKULLS B")
	dialog.add_text(text='D_035_T_007', speaker="RATSKULLS C")
	dialog.add_text(text='D_035_T_008', speaker="RATSKULLS B")
	dialog.add_text(text='D_035_T_009', speaker="RATSKULLS B")
	dialog.add_text(text='D_035_T_010', speaker="ALTER_EGO")
	dialog.add_text(text='D_035_T_011', speaker="RATSKULLS B")
	dialog.add_text(text='D_035_T_012', speaker="ALTER_EGO", follower="D_035_T_014")
	dialog.add_text(text='D_035_T_014', speaker="RATSKULLS B", follower='ENDDIALOG', callback=[
			Lambda('objects.set_attribute(object="RATSKULLS B", attribute="foes", value=["UISPIELER"])'),
			Lambda('objects.set_attribute(object="RATSKULLS C", attribute="foes", value=["UISPIELER"])')])
	dialog.add_text(text='D_035_T_015', speaker="RATSKULLS B", follower="D_035_T_018")
	dialog.add_text(text='D_035_T_018', speaker="ALTER_EGO")
	dialog.add_text(text='D_035_T_019', speaker="RATSKULLS B", follower='ENDDIALOG', callback=[
			Lambda('objects.set_attribute(object="RATSKULLS B", attribute="foes", value=["UISPIELER"])'),
			Lambda('objects.set_attribute(object="RATSKULLS C", attribute="foes", value=["UISPIELER"])')])
	dialog.start(True, data('zone_3.zone_3').QB_006)


def initDlg_036_Ratskulls_BewusstloseFrau():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_036')
	dialog.add_text(text='D_036_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()


def initDlg_015_Kinder_NachHause(without_quest = False):
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_015')
	dialog.add_text(text='D_015_T_001', speaker="MIA")
	dialog.add_text(text='D_015_T_002', speaker="PIA")
	dialog.add_text(text='D_015_T_003', speaker="MIA", follower="D_015_C_001")
	dialog.add_choice(text='D_015_C_001_1', follower='D_015_T_009')
	dialog.add_choice(text='D_015_C_001_2', follower='D_015_T_013')
	dialog.add_choice(text='D_015_C_001_3', follower='D_015_T_004')
	dialog.add_choice(text='D_015_C_001_4', follower='ENDDIALOG', callback=onDlg_015_RestartPoint)
	dialog.add_text(text='D_015_T_004', speaker="MIA")
	dialog.add_text(text='D_015_T_005', speaker="PIA")
	dialog.add_text(text='D_015_T_006', speaker="MIA")
	dialog.add_text(text='D_015_T_007', speaker="PIA")
	dialog.add_text(text='D_015_T_008', speaker="MIA", follower='D_015_T_017')
	dialog.add_text(text='D_015_T_009', speaker="MIA")
	dialog.add_text(text='D_015_T_010', speaker="PIA")
	dialog.add_text(text='D_015_T_011', speaker="MIA")
	if (objects.get_attribute('ALTER_EGO', 'gender') == 'male'):
		dialog.add_text(text='D_015_T_012', speaker="PIA", follower='D_015_T_017')
	elif (objects.get_attribute('ALTER_EGO', 'gender') == 'female'):
		dialog.add_text(text='D_015_T_012F', speaker="PIA", follower='D_015_T_017')
	dialog.add_text(text='D_015_T_013', speaker="MIA")
	dialog.add_text(text='D_015_T_014', speaker="PIA")
	dialog.add_text(text='D_015_T_015', speaker="MIA")
	dialog.add_text(text='D_015_T_016', speaker="PIA")
	dialog.add_text(text='D_015_T_017', speaker="ALTER_EGO")
	dialog.add_text(text='D_015_T_018', speaker="PIA")
	dialog.add_text(text='D_015_T_019', speaker="MIA")
	dialog.add_text(text='D_015_T_020', speaker="PIA", follower='D_015_T_022')
	dialog.add_text(text='D_015_T_022', speaker="ALTER_EGO")
	dialog.add_text(text='D_015_T_023', speaker="MIA")
	dialog.add_text(text='D_015_T_024', speaker="ALTER_EGO")
	dialog.add_text(text='D_015_T_025', speaker="MIA")
	if not without_quest:
		dialog.add_text(text='D_015_T_026', speaker="PIA", follower='ENDDIALOG', callback=[
			Lambda('data().miapia_folgen = True'),
			Lambda('objects.cancel_commandos("MIA")'),
			Lambda('objects.cancel_commandos("PIA")'),
			Lambda('system.set_qb_entry_state(data().QB_011, INACTIVE)'),
			Lambda('system.set_qb_entry_state(data().QB_012, UNCOMPLETE)')])
	else:
		dialog.add_text(text='D_015_T_026', speaker="PIA", follower='ENDDIALOG',callback=onDlg_084_Ende1)

	if data().d_015_restart_c_001:
		dialog.jump_to('D_015_C_001')
	dialog.start(False, [data('zone_3.zone_3').QB_011,
						 data('zone_3.zone_3').QB_012])

def onDlg_015_RestartPoint():
	data().d_015_restart_c_001 = True

def initCutscene_Dlg_083_Luisa_RettungOhneAuftrag():
	system.start_cutscene()
	init_cutscene("ALTER_EGO","LUISA",dx=1.3,dy=1.0,step_away=(get_location("LUISA") in [2]))
	objects.turn_to_object("ALTER_EGO","LUISA", callback=["ONEND", initDlg_083_Luisa_RettungOhneAuftrag])
	
def initDlg_083_Luisa_RettungOhneAuftrag(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_083')
	set_conversation("LUISA","ALTER_EGO", mode="medium_deep")
	dialog.add_text(text='D_083_T_001', speaker="LUISA", callback=Lambda('set_conversation("ALTER_EGO","LUISA", mode="close_deep")'))
	dialog.add_text(text='D_083_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("LUISA","ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_083_T_003', speaker="LUISA", follower='ENDDIALOG', callback=onDlg_083_Ende)
	dialog.start(True, [data('zone_3.zone_3').QB_012,
						data('zone_3.zone_3').QB_011])

def onDlg_083_Ende():
	end_cutscene(chars=["LUISA", "ALTER_EGO"])
	allow_activity("LUISA")
	data().ZwillingsQuest_Luisa_HatSichBedankt=True
	system.set_qb_entry_state(data().QB_011,COMPLETE)
	system.set_qb_entry_state(data().QB_012,INACTIVE)

def onDlg_084_Ende1():
	data().miapia_folgen = True
	data().ZwillingsQuest_Gesperrt = False
	objects.cancel_commandos("MIA")
	objects.cancel_commandos("PIA")
	system.set_qb_entry_state(data().QB_011, INACTIVE)
	system.set_qb_entry_state(data().QB_012,UNCOMPLETE)
	data().MiaPia_RettungOhneAuftragAktiv = True

def initDlg_041_Kinder_AufDemWeg():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_041')
	dialog.add_text(text='D_041_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_012,
						data('zone_3.zone_3').QB_011])


def initDlg_042_Kinder_Langweilig():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_042')
	dialog.add_text(text='D_042_T_001', speaker="MIA")
	dialog.add_text(text='D_042_T_002', speaker="PIA", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_012)

def initDlg_029_Einsiedler_BrauchtBatterie():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_029')
	dialog.add_text(text='D_029_T_001', speaker="EINSIEDLER", follower='D_029_C_001')
	dialog.add_choice(text='D_029_C_001_1', follower='D_029_T_003')
	dialog.add_choice(text='D_029_C_001_2', follower='D_029_T_003')
	dialog.add_choice(text='D_029_C_001_3', follower='ENDDIALOG',
			callback=Lambda('data().BatterieQuest_Einsiedler_Dialog_29_Rueckkehr=True'))
	dialog.add_text(text='D_029_T_002', speaker="EINSIEDLER", follower='D_029_C_001')
	if data().BatterieQuest_Einsiedler_Dialog_29_Rueckkehr:
		dialog.jump_to(follower='D_029_T_002')
	dialog.add_text(text='D_029_T_003', speaker="EINSIEDLER", follower='D_029_C_002')
	dialog.add_choice(text='D_029_C_002_1', follower='D_029_T_004')
	dialog.add_choice(text='D_029_C_002_2', follower='D_029_T_004')
	dialog.add_text(text='D_029_T_004', speaker="EINSIEDLER", follower='D_029_C_003')
	dialog.add_choice(text='D_029_C_003_1', follower='ENDDIALOG', callback=[
			Lambda('system.set_qb_entry_state(data().QB_008, UNCOMPLETE)')])
	if object_events.get_speech_skill("ALTER_EGO") >= 75:
		dialog.add_choice(text='D_029_C_003_2', follower='D_029_T_005')
	else: 
		dialog.add_choice(text='D_029_C_003_2', follower='D_029_T_006')
	dialog.add_choice(text='D_029_C_003_3', follower='ENDDIALOG',
			callback=[Lambda('data().BatterieQuest_Vergeigt=True'), Lambda('system.set_qb_entry_state(data().QB_008,IMPOSSIBLE)')])
	#dialog.add_text(text='D_029_T_005', speaker="EINSIEDLER", follower='ENDDIALOG', callback = [Lambda('data().d_032_restart_c_001= True'), initDlg_032_Einsiedler_BekommtBatterie])
	dialog.add_text(text='D_029_T_005', speaker="EINSIEDLER", follower='ENDDIALOG',callback=[
			Lambda('system.set_qb_entry_state(data().QB_008, COMPLETE)'),
			Lambda('objects.remove_closed_lock_by_name("BUILDING_15361", "lock1")'),
			Lambda('objects.create_item_in_inventory("BUILDING_15361","SET_DRAGUNOV",id=data().obj_McKanzeesWumme)'),
			Lambda('objects.set_attribute(object=data().obj_McKanzeesWumme, attribute="generic_item", value=False)'),
			Lambda('character.add_experience_party(data().Exp_Batterie)')])
	dialog.add_text(text='D_029_T_006', speaker="EINSIEDLER", follower='D_029_C_003')
	dialog.start(False, data('zone_3.zone_3').QB_008)


def initDlg_043_Einsiedler_KeineBatterie():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_043')
	dialog.add_text(text='D_043_T_001', speaker="EINSIEDLER")
	dialog.add_text(text='D_043_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_008)


def onDlg_032_Einsiedler_GibtGewehr():
	# wenn man ihm irgendeine Autobatterie gibt
	if enemy_script.count_party_inventory(object_id = "EINSIEDLER", items = "SET_CAR_BATTERY"):
		if not data().car_battery_given:
			objects.transfer_item(enemy_script.get_next_transfer_partner("EINSIEDLER", "SET_CAR_BATTERY"), "SET_CAR_BATTERY", "EINSIEDLER")
			data().car_battery_given = True
	# wenn man ihm die Autobatterei von McKanzee gibt
	if enemy_script.count_party_inventory(object_id = "EINSIEDLER", items = data().obj_Autobatterie):
		if not data().car_battery_given:
			objects.transfer_item(enemy_script.get_next_transfer_partner("EINSIEDLER", data().obj_Autobatterie), data().obj_Autobatterie, "EINSIEDLER")
			data().car_battery_given = True
		## todo: kiste oeffnen
	objects.remove_closed_lock_by_name("BUILDING_15361", "lock1")
	objects.create_item_in_inventory("BUILDING_15361","SET_DRAGUNOV",id=data().obj_McKanzeesWumme)
	objects.set_attribute(object=data().obj_McKanzeesWumme, attribute="generic_item", value=False)


def initDlg_032_Einsiedler_BekommtBatterie():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_032')
	dialog.add_text(text='D_032_T_001', speaker="EINSIEDLER")
	dialog.add_text(text='D_032_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_032_T_003', speaker="EINSIEDLER", follower="D_032_C_001")
	dialog.add_choice(text='D_032_C_001_1', follower='D_032_T_004')
	dialog.add_choice(text='D_032_C_001_2', follower='D_032_T_008')
	dialog.add_choice(text='D_032_C_001_3', follower='ENDDIALOG', callback=[
			Lambda('system.set_qb_entry_state(data().QB_008, IMPOSSIBLE)'),
			Lambda('character.equip("EINSIEDLER", equipment=data().obj_McKanzeesWumme)'),
			Lambda('data().BatterieQuest_Vergeigt=True'),
			Lambda('objects.set_immortal_state("EINSIEDLER", False)'),
			Lambda('objects.set_attribute(object="EINSIEDLER", attribute="foes", value=["UISPIELER"])')])
	dialog.add_text(text='D_032_T_004', speaker="EINSIEDLER", follower="D_032_T_007")
	dialog.add_text(text='D_032_T_007', speaker="ALTER_EGO", follower="ENDDIALOG", callback=[
			Lambda('onDlg_032_Einsiedler_GibtGewehr()'),
			Lambda('system.set_qb_entry_state(data().QB_008, COMPLETE)'),
			Lambda('character.add_experience_party(data().Exp_Batterie)')])
	dialog.add_text(text='D_032_T_008', speaker="EINSIEDLER", follower="ENDDIALOG", callback=[
			Lambda('system.set_qb_entry_state(data().QB_008, COMPLETE)'),
			Lambda('character.add_experience_party(data().Exp_Batterie)')])
	if data().d_032_restart_c_001:
		dialog.jump_to(follower="D_032_C_001")
	dialog.start(False, data('zone_3.zone_3').QB_008)

def initDlg_085_EinsiedlerGluecklich():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_085')
	dialog.add_text(text='D_085_T_001', speaker="EINSIEDLER", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_008)

def initDlg_023_Gonzo_AckertAufDemAcker():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_023')
	if data().Dialog_023 == 1:
		dialog.add_text(text='D_023_T_001', speaker="GONZO", follower='ENDDIALOG')
	elif data().Dialog_023 == 2:
		dialog.add_text(text='D_023_T_002', speaker="GONZO", follower='ENDDIALOG')
	elif data().Dialog_023 == 3:
		dialog.add_text(text='D_023_T_004', speaker="GONZO", follower='ENDDIALOG')
	elif data().Dialog_023 == 4:
		dialog.add_text(text='D_023_T_005', speaker="GONZO", follower='ENDDIALOG')
	elif data().Dialog_023 == 5:
		dialog.add_text(text='D_023_T_003', speaker="GONZO", follower='ENDDIALOG')
	elif data().Dialog_023 == 6:
		dialog.add_text(text='D_023_T_006', speaker="GONZO", follower='ENDDIALOG')
	elif data().Dialog_023 == 7:
		dialog.add_text(text='D_023_T_007', speaker="GONZO", follower='ENDDIALOG')
	elif data().Dialog_023 == 8:
		dialog.add_text(text='D_023_T_008', speaker="GONZO", follower='ENDDIALOG')

	data().Dialog_023 = data().Dialog_023 + 1;
	if data().Dialog_023 > 8:
		data().Dialog_023 = 1

	dialog.start(True, data('zone_3.zone_3').QB_013)


def initDlg_024_Gonzo_KeineZeit():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_024')
	dialog.add_text(text='D_024_T_001', speaker="GONZO")
	dialog.add_text(text='D_024_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_013)


def initDlg_025_Gonzo_MahlzeitWeg():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_025')
	dialog.add_choice(text='D_025_C_001_1', follower='D_025_T_003')
	dialog.add_choice(text='D_025_C_001_2', follower='D_025_T_004')
	dialog.add_choice(text='D_025_C_001_3', follower='D_025_T_001')
	dialog.add_text(text='D_025_T_001', speaker="GONZO")
	dialog.add_text(text='D_025_T_002', speaker="ALTER_EGO", follower="ENDDIALOG", callback=on_dialog_025_gonzo_attacks)
	dialog.add_text(text='D_025_T_003', speaker="GONZO", follower="D_025_C_002")
	dialog.add_choice(text='D_025_C_002_1', follower='D_025_T_004')
	dialog.add_choice(text='D_025_C_002_2', follower='D_025_T_005')
	dialog.add_text(text='D_025_T_004', speaker="GONZO", follower="D_025_T_006")
	dialog.add_text(text='D_025_T_005', speaker="GONZO", follower="D_025_T_006")
	dialog.add_text(text='D_025_T_006', speaker="ALTER_EGO")
	dialog.add_text(text='D_025_T_007', speaker="GONZO")
	dialog.add_text(text='D_025_T_008', speaker="ALTER_EGO", follower="D_025_T_010")
	dialog.add_text(text='D_025_T_010', speaker="GONZO")
	dialog.add_text(text='D_025_T_011', speaker="ALTER_EGO", follower="ENDDIALOG", callback=on_dialog_025_gonzo_attacks)
	dialog.start(True, [data('zone_3.zone_3').QB_013,
						data('zone_3.zone_3').QB_014])

def on_dialog_025_gonzo_attacks():
	#print "gonzo_attacks"
	objects.set_immortal_state('GONZO', False)
	objects.set_attribute(object="GONZO", attribute="foes", value=["UISPIELER"])
	objects.cancel_commandos("GONZO")
	prohibit_activity("GONZO", False)
	character.equip(char="GONZO", equipment="SET_SPECIAL_38", direct_ammo_load=True)
	objects.attack("GONZO", "ALTER_EGO")
	system.set_qb_entry_state(data().QB_013,INACTIVE)
	system.set_qb_entry_state(data().QB_014,UNCOMPLETE)

def initDlg_026_Gonzo_RestInPieces():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_026')
	dialog.add_text(text='D_026_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=on_dialog_026_ende)
	dialog.start(True, [data('zone_3.zone_3').QB_013,
						data('zone_3.zone_3').QB_014])

def on_dialog_026_ende():
	if objects.is_destroyed("BARBARA"):
		system.set_qb_entry_state(data().QB_013, IMPOSSIBLE)
		if system.get_qb_entry_state(data().QB_014) != INACTIVE:
			system.set_qb_entry_state(data().QB_014, INACTIVE)
	if system.get_qb_entry_state(data().QB_013) != IMPOSSIBLE:
		if system.get_qb_entry_state(data().QB_013) != COMPLETE:
			system.set_qb_entry_state(data().QB_013, COMPLETE)
		if system.get_qb_entry_state(data().QB_014) != INACTIVE:
			system.set_qb_entry_state(data().QB_014, INACTIVE)
		character.add_experience_party(data().Exp_Gonzo)
	
## todo: Cutscene Kameraeinstellungen und Triggerung - GONZO BARBARA
def initCutscene_050_Gonzo_MurkstSeineAlte():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_050')
	dialog.add_text(text='D_050_T_001', speaker="GONZO" )
	dialog.add_text(text='D_050_T_002', speaker="BARBARA", follower='ENDDIALOG', callback=onDlg_050_Gonzo_End)
	dialog.start(True, [data('zone_3.zone_3').QB_013,
						data('zone_3.zone_3').QB_014])

def onDlg_050_Gonzo_End():
	system.set_camera_view(CAMVIEW_GONZOBARBARA_MUERTE)
	objects.turn_to_object(object="GONZO", target_object="BARBARA", callback=["ONEND",onDlg_050_GonzoKilltBarbara])

def onDlg_050_GonzoKilltBarbara(id):
	objects.cancel_commandos("GONZO")
	objects.cancel_commandos("BARBARA")
	system.notify_timer(data().Timer_BarbaraAutsch, data().Timervalue_BarbaraAutsch)
	character.play_animation("GONZO", "CM_PRAEPARIEREN_STEHEN_ANSCHRITT")
	character.play_animation("GONZO", "CM_PRAEPARIEREN_STEHEN_LOOP")
	character.play_animation("GONZO", "CM_PRAEPARIEREN_STEHEN_LOOP")
	character.play_animation("GONZO", "CM_PRAEPARIEREN_STEHEN_ENDSCHRITT")#,callback=["ONEND",onBarabaraKilled])

def onBarabaraKilled():
	objects.set_immortal_state("BARBARA", False)
	objects.destroy("BARBARA")
	allow_activity("GONZO")
	objects.step_away("GONZO")
	data().gonzo_killing_spree = False
	system.notify_timer(data().Timer_GonzoSceneCam,data().Timervalue_GonzoSceneCam2)

def initDlg_051_GonzosFrau_Leiche():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_051')
	dialog.add_text(text='D_051_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_013)


def initDlg_052_Dorfbewohnerin_WillNichtMehr():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_052')
	dialog.add_text(text='D_052_T_001', speaker="DORFBEWOHNERIN", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_010,
						data('zone_3.zone_3').QB_011])


def initDlg_053_Dorfbewohnerin_Gluecklich():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_053')
	dialog.add_text(text='D_053_T_001', speaker="DORFBEWOHNERIN", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_012,
						data('zone_3.zone_3').QB_011])


def initDlg_054_Luisa_ImmerNochBesorgt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_054')
	dialog.add_text(text='D_054_T_001', speaker="LUISA")
	dialog.add_text(text='D_054_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_010,
						data('zone_3.zone_3').QB_011])


def initDlg_055_Luisa_HappyHippo():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_055')
	dialog.add_text(text='D_055_T_001', speaker="LUISA", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_012,
						data('zone_3.zone_3').QB_011])


def initDlg_056_GonzosFrau_WillNichtMehr():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_056')
	dialog.add_text(text='D_056_T_001', speaker="BARBARA", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_013)


def initDlg_057_GonzosFrau_Hiiiiiilfe():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_057')
	dialog.add_text(text='D_057_T_001', speaker="BARBARA")
	dialog.add_text(text='D_057_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_013)

def initDlg_058_Gonzos_Durchgeknallt_FrauLebt():
	data().GonzoQuest_Dialog_58_Erledigt = True
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_058')
	dialog.add_text(text='D_058_T_001', speaker="GONZO")
	dialog.add_text(text='D_058_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_058_059_GonzoAttack)
	dialog.start(True, [data('zone_3.zone_3').QB_013,
						data('zone_3.zone_3').QB_014])

def initDlg_059_Gonzos_Durchgeknallt_FrauTot():
	data().GonzoQuest_Dialog_58_Erledigt = True
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_059')
	dialog.add_text(text='D_059_T_001', speaker="GONZO")
	dialog.add_text(text='D_059_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_058_059_GonzoAttack)
	dialog.start(True, [data('zone_3.zone_3').QB_013,
						data('zone_3.zone_3').QB_014])

def onDlg_058_059_GonzoAttack():
	objects.set_immortal_state('GONZO', False)
	objects.set_attribute("GONZO","foes",["UISPIELER"])
	objects.attack( "GONZO", system.get_pcs()[random.randint( 0, len(system.get_pcs())-1 )] )

def initDlg_060_Kuehe_Muh(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_060')
	dialog.add_text(text='D_060_T_001', speaker=id, follower='ENDDIALOG')
	dialog.start()

def initDlg_061_Kuehe_Muh(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_061')
	dialog.add_text(text='D_061_T_001', speaker=id, follower='ENDDIALOG')
	dialog.start()

def initDlg_062_Kuehe_Muh(id):
	# conflict with another dialog
	# raise "bugfix"
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_062')
	dialog.add_text(text='D_062_T_001', speaker=id, follower='ENDDIALOG')
	dialog.start()


def initDlg_063_Kuehe_Lecker():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_063')
	dialog.add_text(text='D_063_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_002])

def initCutscene_Dlg_064_Spieler_Waffenlager():
	system.start_cutscene()
	i = 0
	for id in system.get_pcs():
		if (objects.get_distance_to_position(id, DLG_064_WAYP[i][0], DLG_064_WAYP[i][1]) < 35):
			objects.move_to(id, DLG_064_WAYP[i][0], DLG_064_WAYP[i][1])
			i += 1
			
	system.set_camera_view(data().CamView_WaffenlagerVerlassen)
	
	if not objects.is_active('DONALD RUMS'):
		#Pete bereit stellen
		objects.cancel_commandos('GEORG')
		daily_routine.prohibit_activity('GEORG')
		#daily_routine.finish_activity('GEORG')
		objects.stack_callback('GEORG', Lambda('objects.set_position(object="GEORG", x=492.1, y=271.2)'))
		
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_064')
	dialog.add_text(text='D_064_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_064_End)
	dialog.start(True, data("zone_2.zone_2").QB_013)
	
def onDlg_064_End():
	end_cutscene()
	
	#clean up
	if (was_zone_entered("zone_2.zone_2") and system.get_qb_entry_state(data("zone_2.zone_2").QB_013) == UNCOMPLETE):
		#noch nicht mit Pete geredet
		system.set_qb_entry_state(data("zone_2.zone_2").QB_013,IMPOSSIBLE)
		
	if system.get_qb_entry_state(data().QB_002) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_002, INACTIVE)
		#system.set_qb_entry_state(data("zone_2.zone_2").QB_013,IMPOSSIBLE)
		daily_routine.allow_activity('MAGDA')
	
	if system.get_qb_entry_state(data().QB_003) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_003, INACTIVE)
		#system.set_qb_entry_state(data("zone_2.zone_2").QB_013,IMPOSSIBLE)
	
	if system.get_qb_entry_state(data().QB_004) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_004, INACTIVE)
		#system.set_qb_entry_state(data("zone_2.zone_2").QB_013,IMPOSSIBLE)
	
	#objects.cancel_commandos('GEORG')
	#objects.set_position(object="GEORG", x=494, y=250)
	#Tagesablauf auf Traktor setzen
	
	#objects.move_to(object="GEORG", x=496.4, y=226.0, grid="landscape")
	#character.play_animation("GEORG", "CM_NPC_STEHEN_UNTER_WAGEN_KRIECHEN_START", callback=["ONEND", Lambda('data().Georg_LiegtUnterTraktor=True')])
	if not objects.is_active('DONALD RUMS'):
		objects.cancel_commandos('GEORG')
		data().Georg_LiegtUnterTraktor = True
		daily_routine.allow_activity('GEORG')
		system.notify_region_entered(region="GeorgsTraktor", partyid="UISPIELER")
		system.notify_timer(data().Timer_GeorgGenugGelegen_no_ratskulls, data().Timervalue_GeorgGenugGelegen)


def initCutscene_Dlg_065_Doktor_Untersucht():
	system.start_cutscene()
	init_cutscene("ALTER_EGO","FRANKLIN",dx=1.3, dy=1.4)
	objects.turn_to_object("ALTER_EGO","FRANKLIN", callback=["ONEND", onDlg_065_StartDialog])

def onDlg_065_StartDialog(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_065')
	set_conversation("FRANKLIN","ALTER_EGO", mode="medium_deep")
	dialog.add_text(text='D_065_T_001', speaker="FRANKLIN",callback=Lambda('set_conversation("ALTER_EGO","FRANKLIN",mode="close")'))
	dialog.add_text(text='D_065_T_002', speaker="ALTER_EGO",callback=Lambda('set_conversation("FRANKLIN","ALTER_EGO",mode="medium_deep")'))
	dialog.add_text(text='D_065_T_003', speaker="FRANKLIN",callback=Lambda('set_conversation("ALTER_EGO","FRANKLIN",mode="close")'))
	dialog.add_text(text='D_065_T_004', speaker="ALTER_EGO",callback=Lambda('set_conversation("FRANKLIN","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_065_T_005', speaker="FRANKLIN", follower='ENDDIALOG', callback=Lambda('end_cutscene(chars=["FRANKLIN", "ALTER_EGO"]); allow_activity("FRANKLIN")'))
	dialog.start()

def initDlg_066_Doktor_Ausbildung():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_066')
	dialog.add_text(text='D_066_T_001', speaker="FRANKLIN", follower="D_066_C_001_1")
	dialog.add_choice(text='D_066_C_001_1', follower='D_066_T_003')
	dialog.add_choice(text='D_066_C_001_2', follower='D_066_T_006')
	dialog.add_choice(text='D_066_C_001_3', follower='D_066_T_002')
	dialog.add_choice(text='D_066_C_001_4', follower='ENDDIALOG')
	dialog.add_text(text='D_066_T_002', speaker="FRANKLIN", follower="D_066_C_001")
	dialog.add_text(text='D_066_T_003', speaker="FRANKLIN")
	dialog.add_text(text='D_066_T_004', speaker="ALTER_EGO")
	dialog.add_text(text='D_066_T_005', speaker="FRANKLIN", follower="D_066_C_001")
	dialog.add_text(text='D_066_T_006', speaker="FRANKLIN")
	dialog.add_text(text='D_066_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_066_T_008', speaker="FRANKLIN")
	dialog.add_text(text='D_066_T_009', speaker="ALTER_EGO", follower="ENDDIALOG", callback=onDlg_066_FranklinFolgt)
	dialog.start(True, [data('zone_5.zone_5').QB_003,
						data('zone_5.zone_5').QB_013])

def onDlg_066_FranklinFolgt():
	objects.cancel_commandos("FRANKLIN")
	data().franklin_folgt = True
	#system.notify_timer(timer=data().Timer_Franklin_Folgt, delay=data().Timervalue_Franklin_Folgt)
	objects.set_attribute("FRANKLIN","zone_transfer",True)
	objects.set_attribute("FRANKLIN","zone_transfer_new_party","NPCS")
	if was_zone_entered("zone_5.zone_5"):
		system.set_qb_entry_state(data('zone_5.zone_5').QB_013,UNCOMPLETE)
		system.set_qb_entry_state(data('zone_5.zone_5').QB_003,INACTIVE)

def initDlg_067_Franklin_QuatschNicht():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_067')
	dialog.add_text(text='D_067_T_001', speaker="FRANKLIN", follower='ENDDIALOG')
	dialog.start(True, [data('zone_5.zone_5').QB_003,
						data('zone_5.zone_5').QB_013])


def initDlg_071_Franklin_Ungeduldig():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_071')
	dialog.add_text(text='D_071_T_001', speaker="FRANKLIN", follower='ENDDIALOG')
	dialog.start(True, [data('zone_5.zone_5').QB_003,
						data('zone_5.zone_5').QB_013])


def initDlg_068_Franklin_Verarscht():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_068')
	dialog.add_text(text='D_068_T_001', speaker="FRANKLIN", follower='ENDDIALOG', callback = Dlg_068_QB)
	dialog.start(True, [data('zone_5.zone_5').QB_003,
						data('zone_5.zone_5').QB_013])

def Dlg_068_QB():
	if was_zone_entered("zone_5.zone_5"):
		system.set_qb_entry_state(data('zone_5.zone_5').QB_013,INACTIVE)
		system.set_qb_entry_state(data('zone_5.zone_5').QB_003,IMPOSSIBLE)

def initCutscene_Dlg_069_NeuesZuhause():
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_DONALD_FAMILY_FAR)
	prohibit_activity("DONALD RUMS", False)
	data().ian_linda_paula_folgen = False
	data().felsenwohungsbesichtigung = 0
	onCutscene_Dlg_069_NeuesZuhause_1()
	
def onCutscene_Dlg_069_NeuesZuhause_1():
	for char in ["PAULA", "IAN", "LINDA"]:
		objects.cancel_commandos(char)
		prohibit_activity(char)
		objects.set_attribute(char,"zone_transfer",False)
		objects.set_position(char, 566, 660)
		if char == 'LINDA':
			onCutscene_Dlg_069_NeuesZuhause_2()
			
def onCutscene_Dlg_069_NeuesZuhause_2():
	objects.move_to("PAULA",		566.9, 649.5, "landscape", MT_SLOW, callback = ['ONEND', Lambda('onCutscene_Dlg_069_NeuesZuhause_3("PAULA","DONALD RUMS")')])
	objects.move_to("IAN",		568.2, 649.5, "landscape", MT_SLOW, callback = ['ONEND', Lambda('onCutscene_Dlg_069_NeuesZuhause_3("IAN","DONALD RUMS")')])
	objects.move_to("LINDA",		566.0, 648.6, "landscape", MT_SLOW, callback = ['ONEND', Lambda('onCutscene_Dlg_069_NeuesZuhause_3("LINDA","DONALD RUMS")')])
	objects.move_to("DONALD RUMS",568.5, 646.6, "landscape", MT_SLOW, callback = ['ONEND', onCutscene_Dlg_069_NeuesZuhause_2_1])
	objects.move_to("ALTER_EGO",	565.9, 646.5, "landscape", MT_SLOW, callback = ['ONEND', onCutscene_Dlg_069_NeuesZuhause_2_1])

def onCutscene_Dlg_069_NeuesZuhause_2_1(id):
	if id == 'DONALD RUMS':
		objects.cancel_commandos(id)
		objects.turn_to_position(id,565.9, 646.5, callback=['ONEND', onDlg_069_StartDialog])
	if id == 'ALTER_EGO':
		objects.cancel_commandos(id)
		objects.turn_to_object(id, "DONALD RUMS", callback=['ONEND', onDlg_069_StartDialog])

def onCutscene_Dlg_069_NeuesZuhause_3(id_1, id_2):
	objects.turn_to_object(id_1, id_2, callback=['ONEND', onDlg_069_StartDialog])

def onDlg_069_StartDialog(id):
	#print "onDlg_069_StartDialog"
	data().felsenwohungsbesichtigung += 1
	if data().felsenwohungsbesichtigung >= 5:
		dialog.init_dialog(type=DIALOGSMALL)
		dialog.set_dialog_identifier('DH_D_069')
		set_conversation("DONALD RUMS","PAULA",mode="close", first_obj="DONALD RUMS")
		dialog.add_text(text='D_069_T_001', speaker="DONALD RUMS", callback=Lambda('set_conversation("PAULA","DONALD RUMS",mode="close")'))
		dialog.add_text(text='D_069_T_002', speaker="PAULA"		, callback=Lambda('set_conversation("IAN","PAULA",mode="medium_deep", first_obj="IAN")'))
		dialog.add_text(text='D_069_T_003', speaker="IAN"		, callback=Lambda('set_conversation("ALTER_EGO","IAN",mode="medium_deep")'))
		dialog.add_text(text='D_069_T_004', speaker="ALTER_EGO"	, callback=Lambda('set_conversation("IAN","DONALD RUMS",mode="close_deep", first_obj="IAN")'))
		dialog.add_text(text='D_069_T_005', speaker="IAN"		, callback=Lambda('set_conversation("DONALD RUMS","IAN", mode="close_deep", first_obj="DONALD RUMS")'))
		dialog.add_text(text='D_069_T_006', speaker="DONALD RUMS", callback=Lambda('set_conversation("ALTER_EGO","DONALD RUMS",mode="close_deep")'))
		dialog.add_text(text='D_069_T_007', speaker="ALTER_EGO"	, follower='ENDDIALOG', callback=onDlg_069_DonaldUndCoVerschwinden)
		dialog.start(True, data('zone_5.zone_5').QB_011)

#todo: Donald, Ian, Linda und Paula verschwinden in einer höhle
def onDlg_069_DonaldUndCoVerschwinden():
	set_conversation(first_obj='ALTER_EGO')
	system.set_camera_view(CAMVIEW_DONALD_FAMILY_CLOSE)
	for char in ["DONALD RUMS","PAULA","IAN","LINDA"]:
		objects.cancel_commandos(char)
		objects.move_to(char,578.85,645.47, speed=global_defines.MT_SLOW, callback=["ONEND", onDlg_069_DonaldUndCoVerschwinden_1])
			
def onDlg_069_DonaldUndCoVerschwinden_1(id):
	objects.cancel_commandos(id)
	if id == 'DONALD RUMS':
		if was_zone_entered("zone_5.zone_5"):
			system.set_qb_entry_state(data('zone_5.zone_5').QB_011,COMPLETE)
			if hasattr(data("zone_5.zone_5"),"Familie_Bezahlung"):
				if data("zone_5.zone_5").Familie_Bezahlung:
					objects.create_item_in_inventory("ALTER_EGO",["SET_AMMOPACK_45_DUMDUM","SET_AMMOPACK_2_12_MM"])
		character.add_experience_party( 450 )
		objects.step_to(id,578.85,645.47, speed=global_defines.MT_SLOW)
	elif id == 'PAULA':
		objects.step_to(id,577.85,645.47, speed=global_defines.MT_SLOW, callback = ['ONEND', Lambda('objects.turn_to_position("PAULA", 578.85,645.47)')])
	elif id == 'IAN':
		objects.step_to(id,579.85,645.47, speed=global_defines.MT_SLOW, callback = ['ONEND', Lambda('objects.turn_to_position("IAN", 578.85,645.47)')])
	elif id == 'LINDA':
		objects.step_to(id,578.85,646.47, speed=global_defines.MT_SLOW, callback = ['ONEND', Lambda('objects.turn_to_position("LINDA", 578.85,645.47)')])
		system.notify_timer(data().Timer_DonaldWiederRaus,data().Timervalue_DonaldWiederRaus)
		data("zone_5.zone_5").Familie_wird_Eskortiert = False
		character.set_approachable_state("PAULA", False)
		character.set_approachable_state("IAN", False)
		character.set_approachable_state("LINDA", False)
		system.end_cutscene()

def initDlg_070_Spieler_Zone4Comment():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_070')
	dialog.add_text(text='D_070_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_004])


def initDlg_072_Warnung_Minenguertel():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_072')
	dialog.add_text(text='D_072_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_002])

def initDlg_073_PlayerCharSpotted():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_073')
	dialog.add_text(text='D_073_T_001', speaker="RATSKULLS WAFFENLAGER A", follower='ENDDIALOG')
	dialog.start()

def initDlg_074_DeadCowsSpotted():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_074')
	dialog.add_text(text='D_074_T_001', speaker="RATSKULLS WAFFENLAGER A", follower='ENDDIALOG')
	dialog.start()

def initDlg_075_DeadCowsDiscussion():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier("DeadCowsDontTalk")
	data().DeadCowsDontTalk = True
	dialog.add_text(text='D_075_T_001', speaker="RATSKULLS WAFFENLAGER A")
	dialog.add_text(text='D_075_T_002', speaker="RATSKULLS WAFFENLAGER B")
	dialog.add_text(text='D_075_T_003', speaker="RATSKULLS WAFFENLAGER C")
	dialog.add_text(text='D_075_T_004', speaker="RATSKULLS WAFFENLAGER A")
	dialog.add_text(text='D_075_T_005', speaker="RATSKULLS WAFFENLAGER C")
	dialog.add_text(text='D_075_T_006', speaker="RATSKULLS WAFFENLAGER B")
	dialog.add_text(text='D_075_T_007', speaker="RATSKULLS WAFFENLAGER C", follower='ENDDIALOG',	callback = KuhDiskusion)
	dialog.start()

def initDlg_076_DeadCowsStrange1():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_076')
	dialog.add_text(text='D_076_T_001', speaker="RATSKULLS WAFFENLAGER A", follower='ENDDIALOG', callback = KuhDiskusion)
	dialog.start()

def initDlg_077_DeadCowsStrange2():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_077')
	dialog.add_text(text='D_077_T_001', speaker="RATSKULLS WAFFENLAGER B", follower='ENDDIALOG', callback = KuhDiskusion)
	dialog.start()

def initDlg_078_DeadCowsStrange3():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_078')
	dialog.add_text(text='D_078_T_001', speaker="RATSKULLS WAFFENLAGER C", follower='ENDDIALOG', callback = KuhDiskusion)
	dialog.start()

def KuhDiskusion():
	data().DeadCowsDontTalk = False
	import zone_3
	zone_3.ratskull_says_something_about_dead_cows()

def initDlg_079_BunkerAlert():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_079')
	dialog.add_text(text='D_079_T_001', speaker="RATSKULLS BUNKER A", follower='ENDDIALOG')
	dialog.start()

def initDlg_080_beware_mines():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_080')
	dialog.add_text(text='D_080_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_002])

def initDlg_087_WaldemarSollDasBisonAusweiden():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('D_087_BisonAusweiden')
	dialog.add_text(text='D_087_T_001', speaker="WALDEMAR", follower='D_087_C_001')
	if (data().bison_inspected and not data().BisonKadaberAusgeweidet):
		if not objects.exists("Z3 BISON_MEAT_KADABER"):
			dialog.add_choice(text='D_087_C_001_1', follower='D_087_T_002', auto_deactivation="permanent")
	if (data().BisonDead and not data().BisonDeadAusgeweidet):
		if not objects.exists("Z3 BISON_MEAT_KADABER_KILL"):
			dialog.add_choice(text='D_087_C_001_2', follower='D_087_T_004', auto_deactivation="permanent")
	if (objects.is_destroyed('BERGTIGERIN')):
			if not objects.exists("Z3 TIGER_MEAT"):
				dialog.add_choice(text='D_087_C_001_3', follower='D_087_T_003', auto_deactivation="permanent")
	dialog.add_choice(text='D_087_C_001_4', follower='ENDDIALOG')
	dialog.add_text(text='D_087_T_002', speaker="WALDEMAR", follower='D_087_C_002')
	dialog.add_choice(text='D_087_C_002_1', follower='ENDDIALOG', callback=Lambda('onDlg_087_WaldemarRenntZuBison("%s")'%data().Obj_BisonKadaver)) # rouiting zum toten bison
	dialog.add_choice(text='D_087_C_002_2', follower='ENDDIALOG')
	dialog.add_text(text='D_087_T_003', speaker="WALDEMAR", follower='D_087_C_003')
	dialog.add_choice(text='D_087_C_003_1', follower='ENDDIALOG', callback=onDlg_127_Ende2) # routing zur bergtiegerin
	dialog.add_choice(text='D_087_C_003_2', follower='ENDDIALOG')
	dialog.add_text(text='D_087_T_004', speaker="WALDEMAR", follower='D_087_C_004')
	dialog.add_choice(text='D_087_C_004_1', follower='ENDDIALOG', callback = Lambda('onDlg_087_WaldemarRenntZuBison("BISON")'))
	dialog.add_choice(text='D_087_C_004_2', follower='ENDDIALOG')
	
	dialog.start(False, [data('zone_3.zone_3').QB_019,
						 data('zone_3.zone_3').QB_021])

def onDlg_087_WaldemarRenntZuBison(bison):
	objects.cancel_commandos("WALDEMAR")
	prohibit_activity("WALDEMAR", (get_location("WALDEMAR") == 2))
	data().Waldemar_Unterwegs = 0
	if bison == 'BISON':
		RoutedMoveTo("WALDEMAR",ROUTE_WALDEMAR_BISON_TO,speed=MT_FAST)
	if bison == data().Obj_BisonKadaver:
		RoutedMoveTo("WALDEMAR",ROUTE_WALDEMAR_BISON_TO_KADAVER	,speed=MT_FAST)
	x,y = objects.get_x(bison),objects.get_y(bison)
	objects.move_to("WALDEMAR",x,y,"landscape",speed=MT_SLOW, callback=["ONEND",Lambda('onDlg_087_WaldemarAusweiden("%s")'%bison)])
	
def onDlg_087_WaldemarAusweiden(bison):
	objects.turn_to_object("WALDEMAR", bison)
	character.play_animation("WALDEMAR","CM_NPC_STEHEN_TIER_AUSWEIDEN_START")
	character.play_animation("WALDEMAR","CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
	character.play_animation("WALDEMAR","CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
	character.play_animation("WALDEMAR","CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE", callback=["ONEND",Lambda('onDlg_087_WaldemarMoveBack("%s")'%bison)])
	
def onDlg_087_WaldemarMoveBack(bison):
	if bison == 'BISON':
		if not objects.exists(data().obj_BisonfleischKill):
			new_id = data().obj_BisonfleischKill
			data().BisonDeadAusgeweidet = True
			objects.create_item_in_inventory("WALDEMAR","SET_BISON_MEAT",new_id)
			objects.set_attribute(object=new_id, attribute="generic_item", value=False)
			objects.drop_item("WALDEMAR",new_id)
		else:
			new_id = "Z3 BISON_MEAT_KADABER_KILL_2"
			data().BisonDeadAusgeweidet = True
			objects.create_item_in_inventory("WALDEMAR","SET_BISON_MEAT",new_id)
			objects.set_attribute(object=new_id, attribute="generic_item", value=False)
			objects.drop_item("WALDEMAR",new_id)
			
	elif bison == data().Obj_BisonKadaver:  
		if not objects.exists(data().obj_BisonfleischKadaber):
			new_id = data().obj_BisonfleischKadaber
			data().BisonKadaberAusgeweidet = True
			objects.create_item_in_inventory("WALDEMAR","SET_BISON_MEAT",new_id)
			objects.set_attribute(object=new_id, attribute="generic_item", value=False)
			objects.drop_item("WALDEMAR",new_id)
		else:
			new_id = "Z3 BISON_MEAT_KADABER_2"
			data().BisonKadaberAusgeweidet = True
			objects.create_item_in_inventory("WALDEMAR","SET_BISON_MEAT",new_id)
			objects.set_attribute(object=new_id, attribute="generic_item", value=False)
			objects.drop_item("WALDEMAR",new_id)
	
	elif bison == 'DEAD_BISON':  
		if not objects.exists(data().obj_BisonfleischKadaber):
			new_id = data().obj_BisonfleischKadaber
			data().BisonKadaberAusgeweidet = True
			objects.create_item_in_inventory("WALDEMAR","SET_BISON_MEAT",new_id)
			objects.set_attribute(object=new_id, attribute="generic_item", value=False)
			objects.drop_item("WALDEMAR",new_id)
		else:
			new_id = "Z3 BISON_MEAT_KADABER_2"
			data().BisonKadaberAusgeweidet = True
			objects.create_item_in_inventory("WALDEMAR","SET_BISON_MEAT",new_id)
			objects.set_attribute(object=new_id, attribute="generic_item", value=False)
			objects.drop_item("WALDEMAR",new_id)
	data().mq_animal_ausgeweidet[bison] = True
	data().Waldemar_Unterwegs = 1
	if bison == 'BISON':
		RoutedMoveTo("WALDEMAR",ROUTE_WALDEMAR_BISON_BACK,speed=MT_FAST)
	if bison == data().Obj_BisonKadaver:
		RoutedMoveTo("WALDEMAR",ROUTE_WALDEMAR_BISON_KADAVER_BACK,speed=MT_FAST)
	objects.move_to("WALDEMAR",528.50,707.60,"landscape", MT_SLOW, callback=["ONEND",onDlg_127_WaldemarBack])
	

def initDlg_088_DorfbewohnerinFreutSichUeberMiaUndPia():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_088')
	dialog.add_text(text='D_088_T_001', speaker="DORFBEWOHNERIN", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_012,
						data('zone_3.zone_3').QB_011])

def initDlg_089_McKanzeeInformiertUeberSchattenLeiche():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_089')
	dialog.add_text(text='D_089_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_089_T_002', speaker="MCKANZEE", follower='ENDDIALOG', callback=Lambda('data().Spieler_kennt_Schatten=True'))
	dialog.start()

def initDlg_090_UntersucheLeiche():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_090')
	dialog.add_text(text='D_090_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('data().spieler_leiche_gefunden = True'))
	dialog.start()

def initDlg_091_UntersucheLeiche_SpielerKenntSchatten():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_091')
	dialog.add_text(text='D_091_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('data().spieler_leiche_gefunden = True'))
	dialog.start()

def initDlg_092_WaldemarSagtNichts():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_092')
	dialog.add_text(text='D_092_T_001', speaker="WALDEMAR", follower='ENDDIALOG')
	onDlg_092_marker()
	dialog.start()

def onDlg_092_marker():
	if not data().player_knows_Jaeger_Waldemars_Haus:
		data().player_knows_Jaeger_Waldemars_Haus = True
		system.add_minimap_marker(467,717,"MM_006")#House of Waldemar the hunter
		
def initDlg_093_WaldemarKenntBergtieger():
	onDlg_092_marker()
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_093')
	if not data().Dlg_093_DialogGestartet:
		data().Dlg_093_DialogGestartet = True
		dialog.add_text(text='D_093_T_001', speaker="ALTER_EGO")
		dialog.add_text(text='D_093_T_002', speaker="WALDEMAR", follower='D_093_C_001')
	
	dialog.add_choice(text='D_093_C_001_1', follower='D_093_T_003', callback=[ Lambda('data().d_093_c_001_1_gewaehlt = True'), Lambda('data().WaldemarAngebotErhoeht = True')])
	if (object_events.get_speech_skill("ALTER_EGO") >= 75):
		dialog.add_choice(text='D_093_C_001_2', follower='D_093_T_006')
	else:
		dialog.add_choice(text='D_093_C_001_2', follower='D_093_T_015')
	dialog.add_choice(text='D_093_C_001_3', follower='D_093_T_009', callback = onDlg_093_GiveMenue) 
	dialog.add_choice(text='D_093_C_001_4', follower='ENDDIALOG', callback=onDlg_093_Ende1)
	dialog.add_text(text='D_093_T_003', speaker="WALDEMAR", follower='D_093_C_001')
	dialog.add_text(text='D_093_T_004', speaker="WALDEMAR", follower='D_093_C_001')
	dialog.add_text(text='D_093_T_005', speaker="WALDEMAR", follower='D_093_C_001')
	dialog.add_text(text='D_093_T_006', speaker="WALDEMAR")
	dialog.add_text(text='D_093_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_093_T_008', speaker="WALDEMAR", follower='D_093_T_011')
	dialog.add_text(text='D_093_T_009', speaker="WALDEMAR", follower='D_093_C_001')
	dialog.add_text(text='D_093_T_010', speaker="WALDEMAR")
	dialog.add_text(text='D_093_T_011', speaker="ALTER_EGO")
	dialog.add_text(text='D_093_T_012', speaker="WALDEMAR")
	dialog.add_text(text='D_093_T_013', speaker="ALTER_EGO")
	dialog.add_text(text='D_093_T_014', speaker="WALDEMAR", follower='ENDDIALOG', callback=onDlg_093_Ende2)
	dialog.add_text(text='D_093_T_015', speaker="WALDEMAR", follower='D_093_C_001', callback = Lambda('data().WaldemarAngebotErhoeht = True'))
	
	if data().d_093_restart_t_004 or data().d_093_restart_t_005:
		if data().WaldemarAngebotErhoeht:
			dialog.jump_to('D_093_T_005')
		elif not data().WaldemarAngebotErhoeht:
			dialog.jump_to('D_093_T_004')
	dialog.start(False, [data('zone_3.zone_3').QB_019,
						 data('zone_3.zone_3').QB_020,
						 data('zone_3.zone_3').QB_021])

def onDlg_093_GiveMenue():
	system.item_panel("WALDEMAR","ALTER_EGO", on_give_menu_filter, on_give_menu_closed, on_give_menu_cancel)

def on_give_menu_filter( taker, source, item, item_type ):
	#print "item_panel_filter",item
	if taker in ["LUKE_Z3",'GEORG']:
		if not objects.has_attribute(item, "generic_item"):
			return True
	
	if taker == "WALDEMAR":
		if is_water_repository(item) and not objects.has_attribute(item, "generic_item"):
			return True
	
	if taker == "HERMAN":
#		if is_water_repository(item) and not objects.has_attribute(item, "generic_item"):
		if  not objects.has_attribute(item, "generic_item"):
			return True
	return False

def on_give_menu_closed( taker, items ):
	#print "item_panel_closed", items
	item_types = []
	for act_item in items:
		item_types.append(objects.get_attribute(act_item, "typeid"))
	#print item_types
	
	if taker == "LUKE_Z3":
		if len(items) >= 1:
			dialog.jump_to('D_106_T_003')
			return True
		else:
			dialog.jump_to('D_106_T_004')
			return False
			
	if taker == "GEORG":
		#calc worth
		items_value = 0 
		for item in items:
			if objects.has_attribute(item,'value'):
				items_value += objects.get_attribute(item,'value')
				
		if items_value >= 10:
			dialog.jump_to('D_125_T_007')
			return True
		else:
			dialog.jump_to('D_125_T_008')
			return False

	if taker == "WALDEMAR":
		max_water = 2
		if not data().WaldemarAngebotErhoeht:
			max_water = 2
		else:
			max_water = 6
		liters=0
		for act_item in items:
			liters=liters+objects.get_attribute( act_item, "charge" )
		#print "wassermenge"
		#print liters
		if liters >= max_water:
			dialog.jump_to('D_093_T_010')
			return True
		else:
			dialog.jump_to('D_093_T_009')
			return False
	
	if taker == "HERMAN":
		max_water = 3
		value=0
		for item in items:
			if objects.has_attribute(item, "value"):
				value = value + objects.get_attribute(item,"value")
		#print value
#		print max_water*objects.get_attribute("SET_WATER_SKIN","value")
		if value >= max_water*objects.get_attribute("SET_WATER_SKIN","value"):	# [BrainRipper]
		#print max_water
		#if value >= max_water:													# [BrainRipper]
			dialog.jump_to('D_118_T_005')
			return True
		else:
			dialog.jump_to('D_118_T_004')
			return False
	return False

def on_give_menu_cancel( taker ):
	#print "item_panel_cancel"
	if taker == "WALDEMAR":
		dialog.jump_to('D_093_T_009')
	elif taker == "LUKE_Z3":
		dialog.jump_to('D_106_T_004')
	elif taker == "HERMAN":
		dialog.jump_to('D_118_T_004')
	elif taker == "GEORG":
		dialog.jump_to('D_125_T_008')

def onDlg_093_Ende1():
	if data().d_093_c_001_1_gewaehlt:
		data().d_093_restart_t_004 = True
	else:
		data().d_093_restart_t_005 = True

def onDlg_093_Ende2():
	system.set_qb_entry_state(data().QB_019,INACTIVE)
	system.set_qb_entry_state(data().QB_020,UNCOMPLETE)
	data().D_93_Ende2_gelaufen = True
	system.notify_region_entered(region="Bergtigerin", partyid="UISPIELER")
	system.add_minimap_marker(220.22,594.22,"MM_007")#Bergtigerin
	data().WaldemarHatGesagtWoDerTigerIst = True

def initDlg_094_WaldemarFragtBergtigerTod():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('D_094_BisonKadaber')
	dialog.add_text(text='D_094_T_001', speaker="WALDEMAR")
	dialog.add_text(text='D_094_T_002', speaker="ALTER_EGO", follower='D_094_C_001')
	if (data().bison_inspected and not data().BisonKadaberAusgeweidet):
		if not objects.exists("Z3 BISON_MEAT_KADABER"):
			dialog.add_choice(text='D_094_C_001_1', follower='D_094_T_003', auto_deactivation = "permanent")
	if (data().BisonDead and not data().BisonDeadAusgeweidet):
		if not objects.exists("Z3 BISON_MEAT_KADABER_KILL"):
			dialog.add_choice(text='D_094_C_001_2', follower='D_094_T_004', auto_deactivation = "permanent")
	dialog.add_choice(text='D_094_C_001_3', follower='ENDDIALOG')
	dialog.add_text(text='D_094_T_003', speaker="WALDEMAR")
	dialog.add_choice(text='D_094_C_002_1', follower='ENDDIALOG', callback = Lambda('onDlg_087_WaldemarRenntZuBison("%s")'%data().Obj_BisonKadaver))
	dialog.add_choice(text='D_094_C_002_2', follower='ENDDIALOG')
	dialog.add_text(text='D_094_T_004', speaker="WALDEMAR")
	dialog.add_choice(text='D_094_C_003_1', follower='ENDDIALOG', callback = Lambda('onDlg_087_WaldemarRenntZuBison("BISON")'))
	dialog.add_choice(text='D_094_C_003_2', follower='ENDDIALOG')
	dialog.start(False, [data('zone_3.zone_3').QB_019,
						 data('zone_3.zone_3').QB_021])

def initCutscene_095_WaldemarErfaehrtBergtigerTod():
	data().d_95_gelaufen = True
	system.start_cutscene()
	init_cutscene("ALTER_EGO", "WALDEMAR", dx=1.0, dy=1.3)
	objects.turn_to_object("ALTER_EGO","WALDEMAR",callback=["ONEND",onDlg_095_StartDialog])

def onDlg_095_StartDialog(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_095')
	set_conversation("WALDEMAR","ALTER_EGO",mode='medium_deep')
	dialog.add_text(text='D_095_T_001', speaker="WALDEMAR", callback=Lambda('set_conversation("ALTER_EGO","WALDEMAR",mode="close_deep")'))
	dialog.add_text(text='D_095_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("WALDEMAR","ALTER_EGO",mode="close_deep")'))
	dialog.add_text(text='D_095_T_003', speaker="WALDEMAR", follower='ENDDIALOG', callback=Lambda('end_cutscene(chars=["WALDEMAR", "ALTER_EGO"]); allow_activity("WALDEMAR")'))
	dialog.start(True, [data('zone_3.zone_3').QB_019,
						data('zone_3.zone_3').QB_021])

def onDlg_127_Ende2():
	objects.cancel_commandos("WALDEMAR")
	prohibit_activity("WALDEMAR", (get_location("WALDEMAR") == 2))
	data().Waldemar_Unterwegs = 0
	## Waldemar zum Bergtiger routen, dort ausweiden, dann zurückrouten.
	RoutedMoveTo("WALDEMAR",ROUTE_WALDEMAR_BERGTIGER_TO,speed=MT_FAST)
	x,y = objects.get_x("BERGTIGERIN"),objects.get_y("BERGTIGERIN")
	objects.move_to("WALDEMAR",x,y,"landscape",speed=MT_SLOW, callback=["ONEND",onDlg_127_WaldemarAusweiden])

def onDlg_127_WaldemarAusweiden(id):
	objects.turn_to_object("WALDEMAR", "BERGTIGERIN")
	character.play_animation(id,"CM_NPC_STEHEN_TIER_AUSWEIDEN_START")
	character.play_animation(id,"CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
	character.play_animation(id,"CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
	character.play_animation(id,"CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE", callback=["ONEND",onDlg_127_WaldemarMoveBack])

def onDlg_127_WaldemarMoveBack(id):
	data().BergtigerAusgeweidet = True
	if not objects.exists(data().obj_Tigerfleisch):
		objects.create_item_in_inventory("WALDEMAR","SET_TIGER_MEAT",data().obj_Tigerfleisch)
		objects.set_attribute(object=data().obj_Tigerfleisch, attribute="generic_item", value=False)
		objects.drop_item("WALDEMAR",data().obj_Tigerfleisch)
	else:
		objects.create_item_in_inventory("WALDEMAR","SET_TIGER_MEAT",'Z3 TIGER_MEAT_2')
		objects.set_attribute(object='Z3 TIGER_MEAT_2', attribute="generic_item", value=False)
		objects.drop_item("WALDEMAR",'Z3 TIGER_MEAT_2')
	data().Bergtiger_Fleisch_besorgt = True
	data().mq_animal_ausgeweidet["BERGTIGERIN"] = True
	data().Waldemar_Unterwegs = 1
	RoutedMoveTo("WALDEMAR",ROUTE_WALDEMAR_BERGTIGER_BACK,speed=MT_FAST)
	objects.move_to("WALDEMAR",528.50,707.60,"landscape", MT_SLOW, callback=["ONEND",onDlg_127_WaldemarBack])

def onDlg_127_WaldemarBack(id):
	objects.turn_to_direction("WALDEMAR", global_defines.DIR_WEST)
	allow_activity("WALDEMAR")
	data().Waldemar_Unterwegs = -1

## [NM] Dialog 128: Waldemar hats eilig
def initDlg_128_WaldemarInEile():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_128')
	dialog.add_text(text='D_128_T_001', speaker="WALDEMAR")
	dialog.add_text(text='D_128_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

## [NM] Dialog 129: Waldemar hat alles erledigt
def initDlg_129_WaldermarFertig():
	dialog_data = []
	if data().mq_animal_ausgeweidet[data().Obj_BisonKadaver] or data().mq_animal_ausgeweidet["BISON"]:
		dialog_data = dialog_data+[data('zone_3.zone_3').QB_023,
								   data('zone_3.zone_3').QB_022]
	if data().mq_animal_ausgeweidet["BERGTIGERIN"]:
		dialog_data = dialog_data+[data('zone_3.zone_3').QB_019,
								   data('zone_3.zone_3').QB_021]
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_129')
	dialog.add_text(text='D_129_T_001', speaker="WALDEMAR")
	dialog.add_text(text='D_129_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, dialog_data)
	
def initDlg_096_SpielerFindetBergtigerZone():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_096')
	dialog.add_text(text='D_096_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_019,
						data('zone_3.zone_3').QB_020])

def initDlg_097_SpielerFindetBergtiger():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_097')
	dialog.add_text(text='D_097_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_003,
						data('zone_3.zone_3').QB_013])

def initDlg_098_BergtigerHautAb():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_098')
	dialog.add_text(text='D_098_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_003,
						data('zone_3.zone_3').QB_013])

def initDlg_099_BergtigerGekillt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_099')
	dialog.add_text(text='D_099_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback = Dlg_099_QB)
	dialog.start(True, [data('zone_3.zone_3').QB_003,
						data('zone_3.zone_3').QB_013])

def Dlg_099_QB():
	system.set_qb_entry_state(data().QB_020,INACTIVE)
	system.set_qb_entry_state(data().QB_021,UNCOMPLETE)

## [M] Dialog 100: Der Ratskull-Leader will nicht sterben
def initDlg_100_RatskullLeaderWillNichtSterben():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_100')
	dialog.add_text(text='D_100_T_001', speaker="RATSKULL_LEADER", follower='D_100_C_001')
	dialog.add_choice(text='D_100_C_001_1', follower='D_100_T_004')
	dialog.add_choice(text='D_100_C_001_2', follower='D_100_T_003')
	dialog.add_choice(text='D_100_C_001_3', follower='D_100_T_002')
	dialog.add_text(text='D_100_T_002', speaker="RATSKULL_LEADER", follower='ENDDIALOG', callback=onDlg_100_Ende1)
	dialog.add_text(text='D_100_T_003', speaker="RATSKULL_LEADER", follower='ENDDIALOG', callback=onDlg_100_Ende2)
	dialog.add_text(text='D_100_T_004', speaker="RATSKULL_LEADER")
	dialog.add_text(text='D_100_T_005', speaker="ALTER_EGO", follower='D_100_C_001')
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_003,
						data('zone_3.zone_3').QB_004])

def onDlg_100_QB():
	if was_zone_entered("zone_2.zone_2"):
		system.set_qb_entry_state(data('zone_2.zone_2').QB_013,COMPLETE)
	system.set_qb_entry_state(data().QB_002,INACTIVE)
	system.set_qb_entry_state(data().QB_003,INACTIVE)
	system.set_qb_entry_state(data().QB_004,INACTIVE)
	
def onDlg_100_Ende1():
	# ratskulls angreifen
	onDlg_100_QB()
	for char in ["RATSKULL_LEADER","RATSKULLS BUNKER A","RATSKULLS BUNKER B","RATSKULLS BUNKER C","RATSKULLS BUNKER D"]:
		data().ratskulls_hands_up[char] = False
		character.play_animation(char, "CM_NPC_STEHEN_HAENDE_HOCH_ENDE")
		objects.set_attribute(char,"foes",["UISPIELER"])
		objects.attack(char,random.choice(system.get_pcs()))

def onDlg_100_Ende2():
	# ratskulls laufen lassen
	onDlg_100_QB()
	wps = [[497.89, 238.73],
			[495.32, 242.99],
			[494.27, 252.04],
			[495.42, 268.15],
			[505.17, 267.71],
			[524.60, 268.98],
			[547.60, 267.79],
			[557.13, 248.03],
			[568.00, 223.39],
			[586.42, 166.17]]
	for char in ["RATSKULL_LEADER","RATSKULLS BUNKER A","RATSKULLS BUNKER B","RATSKULLS BUNKER C","RATSKULLS BUNKER D"]:
		inventory = objects.get_inventory_ids(char)
		for item in inventory:
			#print "[debug] item:"+str(item)
			if item[1] > 0:
				for elem in item[0]:
					objects.drop_item(char,elem)
				data().ratskulls_laufen_gelassen = True
		data().ratskulls_hands_up[char] = False
		if char != "RATSKULL_LEADER":
			character.play_animation(char, "CM_NPC_STEHEN_HAENDE_HOCH_ENDE")
		
		for wp in wps:
			if wp == wps[0]:
				if char != "RATSKULL_LEADER":
					objects.move_to(char, wp[0]+random.random(), wp[1]+random.random(),grid="landscape",speed=MT_FAST)
			elif wp == wps[-1]:
				objects.move_to(char, wp[0], wp[1],grid="landscape",speed=MT_FAST,callback=["ONEND", deactivate])
			else:
				objects.move_to(char, wp[0]+random.random(), wp[1]+random.random(),grid="landscape",speed=MT_FAST)
		
	system.notify_timer(timer=data().Timer_Zone4Comment, delay=data().Timervalue_Zone4Comment)
	
def deactivate(id):
	objects.set_active_state(id,INACTIVE)

def initDlg_101_RatskullFrohDassEntkommen(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_101')
	#print "[debug] dialog called"
	dialog.add_text(text='D_101_T_001', speaker=id, follower='ENDDIALOG')
	dialog.start(True, [data('zone_2.zone_2').QB_013,
						data('zone_3.zone_3').QB_003])

#[NM] Dialog 102: Der Spieler schaut sich das Kistenschloss verzweifelt an
def initDlg_102_SpielerVerzweifeltAnKistenschloss(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_102')
	dialog.add_text(text='D_102_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_102_Ende)
	dialog.start(True, data('zone_3.zone_3').QB_015)

def onDlg_102_Ende():
	if not data().schloss_knacken_1_fehlgeschlagen:
		data().schloss_knacken_1_fehlgeschlagen = True
		if system.get_qb_entry_state(data().QB_015) == INACTIVE:
			system.set_qb_entry_state(data().QB_015,UNCOMPLETE)
		data().schloss_knacker_gesucht = True #variable should be obsolete
		data().spieler_am_schloss = ""

#[NM] Dialog 103: Der Spieler schaut das Kistenschloss abschätzend an
def initDlg_103_SpielerWillKistenschlossOeffnen(id, with_crack=False):
	if system.get_qb_entry_state(data().QB_015) == INACTIVE:
		system.set_qb_entry_state(data().QB_015,UNCOMPLETE)
		
	if with_crack:
		if id != data().spieler_am_schloss:
			objects.move_to(id,519, 250,data().Chest_Cutscene_Grid, speed=MT_SLOW, callback = Lambda("objects.turn_to_object('%s','BUILDING_15469')"%id))
			objects.move_to(data().spieler_am_schloss, 518, 250, data().Chest_Cutscene_Grid, speed=MT_FAST)
		object_events.pre_crack_lock( data().spieler_am_schloss )
		#objects.move_to(char,518, 251,"BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID",speed=MT_SLOW)
		#objects.move_to(char,518.06, 249.5,"BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID",speed=MT_SLOW)
		#objects.step_to(char,518.06, 250.6,speed=MT_SLOW)
		objects.stack_callback(data().spieler_am_schloss, callback=Lambda('onDlg_103_Ende(with_crack=%s)' %(str(with_crack))))
		
		if hasattr(data(), 'Chest_Dialog_Played') and data().Chest_Dialog_Played:
			pass
			
		else:
			data().Chest_Dialog_Played = True
			dialog.init_dialog(type=DIALOGSMALL)
			dialog.set_dialog_identifier('DH_D_103')
			dialog.add_text(text='D_103_T_001', speaker="ALTER_EGO", follower='ENDDIALOG') #, callback=Lambda('onDlg_103_Ende(with_crack=%s)' %(str(with_crack))))
			dialog.start(True, data('zone_3.zone_3').QB_015)
		
	else:
			data().Chest_Dialog_Played = True
			dialog.init_dialog(type=DIALOGSMALL)
			dialog.set_dialog_identifier('DH_D_103')
			dialog.add_text(text='D_103_T_001', speaker="ALTER_EGO", follower='ENDDIALOG') #, callback=Lambda('onDlg_103_Ende(with_crack=%s)' %(str(with_crack))))
			dialog.start(True, data('zone_3.zone_3').QB_015)
		

def onDlg_103_Ende(with_crack):
	char = data().spieler_am_schloss
	if with_crack:
		objects.cancel_commandos(char)
		#objects.move_to(char,518.06, 249.5,"BUILDING_BUNKER_SPRENGUNG_INTERIOR_GRID",speed=MT_SLOW)
		objects.move_to(char,518, 251,data().Chest_Cutscene_Grid,speed=MT_SLOW)
		#objects.step_to(char,518, 251,speed=MT_SLOW)
		objects.turn_to_direction(char,global_defines.DIR_SOUTH, callback = onDlg_103_Ende_2)
		

def onDlg_103_Ende_2(id):
	char = data().spieler_am_schloss

	character.play_animation(char,"STEHEND_TUERSCHLOSS_KNACKEN",callback=["ONEND",onDlg_103_PlayerInspectLockDone])	

def onDlg_103_PlayerInspectLockDone(char):
	#Explosion wenn Aufsprengen
	if hasattr(data("pick_lock"), "blast_lock") and data("pick_lock").blast_lock:
		print "Setting Explosion"
		char_id = char
		if data().spieler_am_schloss:
			char_id = data().spieler_am_schloss
		objects.remove_item_from_inventory(char_id, "SET_GUN_POWDER")
		
		interior_object_id = None
		#jan: dummy für schloss sind am interior!! 
		if objects.has_attribute(data().Obj_KisteLuke, "attached_interior_objects" ): #jan: hier muss eigentlich über alle interiors itteriert werden, aber wir nutzen momentan nur 1 interior
			interior_object_id = objects.get_attribute(data().Obj_KisteLuke, "attached_interior_objects" )[0]
		else:
			interior_object_id = data().Obj_KisteLuke
		
		dummy_name = "dmyp_lock"
		x,y,z = objects.get_full_dummy_position(interior_object_id, dummy_name)
		#z = z - objects.get_attribute(interior_object_id,"z") # absolutes z umrechnen auf relatives
		system.start_effect( x, y, z, x, y, z, global_defines.fx_explosion )
		sounds.play_3d_sound( "grenade_explo_fire", x, y, z )
		
	#if objects.has_attribute(data().spieler_am_schloss, "picklock_item"):
	object_events.unequip_and_equip_marked(data().spieler_am_schloss, "picklock_item" )
	#if system.is_cutscene():
	#	system.end_cutscene()
	
	initDlg_104_SpieleKnacktKistenschloss(char)

#[NM] Dialog 104: Der Spieler knackt die Kiste
def initDlg_104_SpieleKnacktKistenschloss(id, no_end=False):
	#objects.step_away(char_id)
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_104')
	if no_end:
		dialog.add_text(text='D_104_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	else:
		dialog.add_text(text='D_104_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_104_Ende)
	dialog.start(True, data('zone_3.zone_3').QB_015)

def onDlg_104_Ende():
	if system.is_cutscene():
		system.end_cutscene()
	system.set_qb_entry_state(data().QB_015,COMPLETE)
	#objects.step_away(char_id)
	data().spieler_am_schloss = ""
	data().schloss_geknackt = True
	data().schloss_knacker_gesucht = False
	objects.remove_closed_lock_by_name(data().Obj_KisteLuke, "lock1")

#[NM] Dialog 105: Luke stellt sich vor
def initDlg_105_LukeStelltSichVor():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_105')
	dialog.add_text(text='D_105_T_001', speaker="LUKE_Z3")
	dialog.add_text(text='D_105_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[M] Dialog 106: Luke öffnet die Kiste f�r lau
def initDlg_106_LukeOeffnetKisteFuerLau():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_106')
	dialog.add_text(text='D_106_T_001', speaker="LUKE_Z3", follower="D_106_C_001")
	dialog.add_choice(text='D_106_C_001_1', follower="D_106_T_002")
	dialog.add_choice(text='D_106_C_001_2', follower="ENDDIALOG", callback=onDlg_106_Ende1)
	dialog.add_text(text='D_106_T_002', speaker="LUKE_Z3", follower="D_106_C_002")
	if object_events.get_speech_skill("ALTER_EGO") >= 75:	# [BrainRipper]
		dialog.add_choice(text='D_106_C_002_1', follower="D_106_T_005")
	dialog.add_choice(text='D_106_C_002_2', follower="D_106_T_006")
	dialog.add_choice(text='D_106_C_002_3', follower="D_106_T_004", callback=onDlg_106_GiveMenue)
	dialog.add_choice(text='D_106_C_002_4', follower="ENDDIALOG", callback=onDlg_106_Ende1)
	dialog.add_text(text='D_106_T_003', speaker="LUKE_Z3", follower="ENDDIALOG", callback=onDlg_106_Ende2)
	dialog.add_text(text='D_106_T_004', speaker="LUKE_Z3", follower="D_106_C_002")
	dialog.add_text(text='D_106_T_005', speaker="LUKE_Z3", follower="ENDDIALOG", callback=onDlg_106_Ende2)
	dialog.add_text(text='D_106_T_006', speaker="LUKE_Z3", follower='D_106_C_002')
	if data().d_106_restart_c_001:
		dialog.jump_to('D_106_C_001')
	dialog.start(False, data('zone_3.zone_3').QB_015)

def onDlg_106_GiveMenue():
	system.item_panel("LUKE_Z3","ALTER_EGO", on_give_menu_filter, on_give_menu_closed, on_give_menu_cancel)

def onDlg_106_Ende1():
	# luke kommt nicht mit
	data().d_106_restart_c_001 = True

def onDlg_106_Ende2():
	# luke kommt mit
	data().Second_Mine_Warning = False
	data().luke_folgt = True
	objects.cancel_commandos("LUKE_Z3")
	system.notify_timer(data().Timer_LukeFolgt,data().Timervalue_LukeFolgt)

#[NM] Dialog 107: Luke will zum Schloss
def initDlg_107_LukeWillZumSchloss():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_107')
	dialog.add_text(text='D_107_T_001', speaker="LUKE_Z3", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_015)

#[NM] Dialog 108: Luke will nicht mehr folgen
def initDlg_108_LukeWillNichtMehr():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_108')
	dialog.add_text(text='D_108_T_001', speaker="LUKE_Z3", follower='ENDDIALOG', callback=onDlg_108_Ende)
	dialog.start(True, data('zone_3.zone_3').QB_015)
	
def onDlg_108_Ende():
	data().luke_folgt = False
	data().spieler_muss_luke_erneut_holen = True
	objects.move_to("LUKE_Z3",481.6,761.7,grid="landscape",speed=MT_SLOW, callback=["ONEND",onDlg_108_LukeHoming])

def onDlg_108_LukeHoming(id):
	objects.turn_to_direction("LUKE_Z3",global_defines.DIR_NORTH)
	allow_activity("LUKE_Z3")

#[NM] Dialog 109: Der Spieler warnt Luke
def initDlg_109_SpielerWarntLuke():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_109')
	dialog.add_text(text='D_109_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_109_T_002', speaker="LUKE_Z3", follower='ENDDIALOG')
	dialog.start(True, data('zone_3.zone_3').QB_015)

#[NM/CS] Dialog 110: Luke inspiziert das Schloss
def initCutscene_110_LukeInspiziertDasSchloss():
	data().counter_dlg_all_there = 110
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_BUNKER_TRESOR)
	objects.move_to("ALTER_EGO",519.3, 251.5,data().Chest_Cutscene_Grid,MT_SLOW)
	objects.turn_to_object("LUKE_Z3","ALTER_EGO", callback=["ONEND",check_all_there])
	objects.move_to("LUKE_Z3",517.68, 250.62,data().Chest_Cutscene_Grid,MT_SLOW)
	objects.turn_to_object("ALTER_EGO","LUKE_Z3", callback=["ONEND",check_all_there])
	
def initDlg_110_LukeInspiziertDasSchloss(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_110')
	#set_conversation("LUKE_Z3","ALTER_EGO",mode='medium_deep', animate=False)
	system.set_camera_view(CAMVIEW_BUNKER_TRESOR)
	dialog.add_text(text='D_110_T_001', speaker="LUKE_Z3", follower='ENDDIALOG', callback=onDlg_110_LukeInspectLock)
	dialog.start(True, [data('zone_3.zone_3').QB_015,
						data('zone_3.zone_3').QB_016])

def onDlg_110_Continue1():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_110')
	set_conversation("LUKE_Z3","ALTER_EGO",mode='medium_deep', new_camera=False)
	system.set_camera_view(CAMVIEW_BUNKER_TRESOR)
	dialog.add_text(text='D_110_T_002', speaker="LUKE_Z3",callback=Lambda('set_conversation("ALTER_EGO","LUKE_Z3",mode="close_deep")'))
	dialog.add_text(text='D_110_T_003', speaker="ALTER_EGO",callback=Lambda('set_conversation("LUKE_Z3","ALTER_EGO",mode="close_deep")'))
	dialog.add_text(text='D_110_T_004', speaker="LUKE_Z3", follower='ENDDIALOG',callback=onDlg_110_Ende)
	dialog.start(True, [data('zone_3.zone_3').QB_015,
						data('zone_3.zone_3').QB_016])

def onDlg_110_LukeInspectLock():
	system.set_camera_view(CAMVIEW_BUNKER_TRESOR)
	objects.move_to("LUKE_Z3",517.68, 250.62,data().Chest_Cutscene_Grid,speed=MT_SLOW, callback = (['ONEND', onDlg_110_LukeInspectLock_1]))
	objects.step_to("LUKE_Z3",517.68, 250.62,speed=MT_SLOW)

def onDlg_110_LukeInspectLock_1(id):
	#objects.step_to(object="LUKE_Z3",x=482.15, y=245.17, speed=MT_SLOW)
	objects.turn_to_direction("LUKE_Z3",global_defines.DIR_SOUTH, callback=["ONEND",onDlg_110_LukeInspect])

def onDlg_110_LukeInspect(char):
	character.play_animation(char,"STEHEND_TUERSCHLOSS_KNACKEN",callback=["ONEND",onDlg_110_LukeInspectLockDone])

def onDlg_110_LukeInspectLockDone(id):
	#objects.step_away("LUKE_Z3")
	#objects.move_to("LUKE_Z3", 486.5, 243.4, "landscape", speed = MT_SLOW)
	objects.turn_to_object("LUKE_Z3", "ALTER_EGO", callback=["ONEND",onDlg_110_ContinueDlg])
	objects.turn_to_object("ALTER_EGO","LUKE_Z3")

def onDlg_110_ContinueDlg(id):
	onDlg_110_Continue1()

def onDlg_110_Ende():
	## spezialdietrich quest
	system.set_qb_entry_state(data().QB_016,UNCOMPLETE)
	system.set_qb_entry_state(data().QB_015,INACTIVE)
	data().luke_hat_kiste_inspiziert = True
	data().luke_dietrich_gesucht = True
	end_cutscene(chars=["LUKE_Z3", "ALTER_EGO"])

#[NM] Dialog 111: Luke erwartet die Spezialdietriche
def initDlg_111_LukeErwartetSpezialdietriche():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_111')
	dialog.add_text(text='D_111_T_001', speaker="LUKE_Z3")
	dialog.add_text(text='D_111_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_015,
						data('zone_3.zone_3').QB_016])

#[NM/CS] Dialog 112: Luke knackt das Schloss
def initCutscene_112_LukeKnacktDasSchloss(exchange_lockpick=True):
	data().counter_dlg_all_there = 112
	system.start_cutscene()
	system.set_camera_view(CAMVIEW_BUNKER_TRESOR)
	objects.move_to("ALTER_EGO",519.3, 251.5,data().Chest_Cutscene_Grid,MT_SLOW)
	objects.turn_to_object("LUKE_Z3","ALTER_EGO", callback=["ONEND",check_all_there])

	objects.move_to("LUKE_Z3",517.68, 250.62,data().Chest_Cutscene_Grid,MT_SLOW)
	#jan
	objects.set_position("LUKE_Z3", 517.68, 250.62,data().Chest_Cutscene_Grid)

	objects.turn_to_object("ALTER_EGO","LUKE_Z3", callback=["ONEND",check_all_there])
	if exchange_lockpick:
		objects.transfer_item(enemy_script.get_next_transfer_partner("LUKE_Z3", 'SET_SPECIAL_PICKLOCK'), 'SET_SPECIAL_PICKLOCK', "LUKE_Z3")

def check_all_there(id):
	data().counter_all_there += 1
	if data().counter_all_there == 2:
		data().counter_all_there = 0
		if data().counter_dlg_all_there == 112:
			initDlg_112_LukeKnacktDasSchloss(id)
		elif data().counter_dlg_all_there == 110:
			initDlg_110_LukeInspiziertDasSchloss(id)
			

def initDlg_112_LukeKnacktDasSchloss(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_112')
	system.set_camera_view(CAMVIEW_BUNKER_TRESOR)
	set_conversation("ALTER_EGO","LUKE_Z3",mode='medium_deep', new_camera=False)
	dialog.add_text(text='D_112_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("LUKE_Z3","ALTER_EGO",mode="close_deep")'))
	dialog.add_text(text='D_112_T_002', speaker="LUKE_Z3", follower='ENDDIALOG', callback=onDlg_112_LukeOpenLock) # schwarzblende kiste offen
	dialog.start(True, [data('zone_3.zone_3').QB_015,
						data('zone_3.zone_3').QB_016])

def onDlg_112_Continue1(id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_112')
	system.set_camera_view(CAMVIEW_BUNKER_TRESOR)
	set_conversation("LUKE_Z3","ALTER_EGO",mode='close_deep', new_camera=False)
	dialog.add_text(text='D_112_T_003', speaker="LUKE_Z3")
	dialog.add_text(text='D_112_T_004', speaker="LUKE_Z3",callback=Lambda('set_conversation("ALTER_EGO","LUKE_Z3",mode="close_deep")'))
	dialog.add_text(text='D_112_T_005', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_112_Ende)
	dialog.start(True, [data('zone_3.zone_3').QB_015,
						data('zone_3.zone_3').QB_016])

def onDlg_112_LukeOpenLock():
	system.set_camera_view(CAMVIEW_BUNKER_TRESOR)
	objects.cancel_commandos('LUKE_Z3')
	#objects.move_to("LUKE_Z3",484.46,244.89,"landscape",speed=MT_SLOW)
	objects.step_to("LUKE_Z3",517.68, 250.62,speed=MT_SLOW)
	objects.cancel_commandos('ALTER_EGO')
	objects.turn_to_direction("ALTER_EGO",global_defines.DIR_WEST)
	objects.turn_to_direction("LUKE_Z3",global_defines.DIR_SOUTH, callback=["ONEND",onDlg_112_LukeInspect])

def onDlg_112_LukeInspect(char):
	character.play_animation(char,"STEHEND_TUERSCHLOSS_KNACKEN",callback=["ONEND",onDlg_112_LukeOpenLockDone])

def onDlg_112_LukeOpenLockDone(id):
	#objects.step_away("LUKE_Z3")
	#objects.move_to("LUKE_Z3",486.5,243.4,"landscape",MT_SLOW)
	objects.turn_to_object("LUKE_Z3","ALTER_EGO", callback=["ONEND",onDlg_112_Continue1])
	objects.turn_to_object("ALTER_EGO","LUKE_Z3")

def onDlg_112_Ende():
	data().luke_an_kiste = False
	data().schloss_geknackt = True
	objects.remove_closed_lock_by_name(data().Obj_KisteLuke, "lock1")
	system.set_qb_entry_state(data().QB_015,COMPLETE)
	system.set_qb_entry_state(data().QB_016,INACTIVE)
	end_cutscene(chars=["LUKE_Z3", "ALTER_EGO"])
	objects.set_immortal_state("LUKE_Z3", False)

	#for wp in ROUTE_LUKE_BACK:
	#	if wp == ROUTE_LUKE_BACK[3]:
	#		if not random.randint(0,10):
	#			objects.move_to("LUKE_Z3", 454.24, 350.86, "landscape",MT_FAST)
	#		else:
	#			objects.move_to("LUKE_Z3", wp[0],wp[1],"landscape",MT_FAST)
	#	else:
	#		objects.move_to("LUKE_Z3", wp[0],wp[1],"landscape",MT_FAST)
	#
	#if objects.is_destroyed("LUKE_Z3"):
	#	return False

	# Tausend Minen, nur fuer dich Luke :)
	for mf in ["MINEFIELD1","MINEFIELD2","MINEFIELD3","MINEFIELD4",
	"MINEFIELD5", "MINEFIELD6","MINEFIELD7","MINEFIELD8",
	"MINEFIELD9","MINEFIELD9a","MINEFIELD9b","MINEFIELD10",
	"MINEFIELD11","MINEFIELD12","MINEFIELD13","MINEFIELD14",
	"MINEFIELD15"]:
		system.notify_region_entered(region=mf, objectid = "LUKE_Z3")

	RoutedMoveTo("LUKE_Z3",ROUTE_LUKE_BACK,speed=MT_FAST)
	objects.turn_to_direction("LUKE_Z3",global_defines.DIR_NORTH, callback=["ONEND",Lambda('data().luke_wieder_zuhause = True; allow_activity("LUKE_Z3")')])
	
#[NM] Dialog 113: Luke will nicht gestört werden
def initDlg_113_LukeWillNichtGestoertWerden():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_113')
	dialog.add_text(text='D_113_T_001', speaker="LUKE_Z3", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 114: Luke hats eilig
def initDlg_114_LukeHatEsEilig():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_114')
	dialog.add_text(text='D_114_T_001', speaker="LUKE_Z3", follower='ENDDIALOG')
	dialog.start()

#[M] Dialog 115: Luke soll noch einmal mitkommen
def initDlg_115_LukeSollErneutMitkommen():
	objects.cancel_commandos("LUKE_Z3")
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_115')
	dialog.add_text(text='D_115_T_001', speaker="LUKE_Z3", follower='D_115_C_001')
	dialog.add_choice(text='D_115_C_001_1', follower='D_115_T_002')
	dialog.add_choice(text='D_115_C_001_2', follower='ENDDIALOG', callback=onDlg_115_Ende1)
	dialog.add_text(text='D_115_T_002', speaker="LUKE_Z3", follower='ENDDIALOG', callback=onDlg_115_Ende2)
	dialog.start(True, data('zone_3.zone_3').QB_015)
	
def onDlg_115_Ende1():
	# luke kommt nicht mit
	pass

def onDlg_115_Ende2():
	# luke kommt mit
	data().luke_folgt = True
	data().spieler_muss_luke_erneut_holen = False
	objects.cancel_commandos("LUKE_Z3")
	system.notify_timer(data().Timer_LukeFolgt,data().Timervalue_LukeFolgt)

## fixme: noch richtig einbauen!
#[NM] Dialog 116: Luke ist explodiert
def initDlg_116_LukeIstExplodiert():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_116')
	dialog.add_text(text='D_116_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 117: Herman ist im Stress
def initDlg_117_HermanIstImStress():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_117')
	dialog.add_text(text='D_117_T_001', speaker="HERMAN")
	dialog.add_text(text='D_117_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	onDlg_117_marker()
	dialog.start()

def onDlg_117_marker():
	if not data().player_knows_Hermans_Schmiede:
		data().player_knows_Hermans_Schmiede = True
		system.add_minimap_marker(578,726,"MM_005")#Herman’s forge

#[M] Dialog 118: Herman hat den Dietrich
def initDlg_118_HermanHatDenDietrich():
	onDlg_117_marker()
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_118')
	dialog.add_text(text='D_118_T_001', speaker="HERMAN", follower='D_118_C_001')
	dialog.add_choice(text='D_118_C_001_1', follower="D_118_T_002")
	dialog.add_choice(text='D_118_C_001_2', follower="ENDDIALOG", callback=onDlg_118_Ende1)
	dialog.add_text(text='D_118_T_002', speaker="HERMAN")
	dialog.add_choice(text='D_118_C_002_1', follower="D_118_T_004", callback=onDlg_118_GiveMenue)
	if object_events.get_speech_skill("ALTER_EGO") >= 75:
		dialog.add_choice(text='D_118_C_002_2', follower="D_118_T_007")
	else:
		dialog.add_choice(text='D_118_C_002_2', follower="D_118_T_008")
	dialog.add_choice(text='D_118_C_002_3', follower="ENDDIALOG", callback=onDlg_118_Ende2)
	dialog.add_text(text='D_118_T_003', speaker="HERMAN", follower='D_118_C_002')
	dialog.add_text(text='D_118_T_004', speaker="HERMAN", follower='ENDDIALOG',callback=onDlg_118_Ende2)
	dialog.add_text(text='D_118_T_005', speaker="HERMAN")
	dialog.add_text(text='D_118_T_006', speaker="ALTER_EGO", follower='ENDDIALOG',callback=onDlg_118_Ende3)
	dialog.add_text(text='D_118_T_007', speaker="HERMAN", follower="D_118_T_005")
	dialog.add_text(text='D_118_T_008', speaker="HERMAN", follower='ENDDIALOG',callback=onDlg_118_Ende2)
	if data().herman_d_118_restart_t_003:
		dialog.jump_to('D_118_T_003')
	dialog.start(False, [data('zone_3.zone_3').QB_015,
						 data('zone_3.zone_3').QB_016])

def onDlg_118_GiveMenue():
	system.item_panel("HERMAN","ALTER_EGO", on_give_menu_filter, on_give_menu_closed, on_give_menu_cancel)

def onDlg_118_Ende1():
	# dialogende
	pass

def onDlg_118_Ende2():
	data().herman_d_118_restart_t_003 = True
	# ende

def onDlg_118_Ende3():
	#dietrich rein, tauschgegenstand raus
	data().spieler_hat_dietrich = True
	if objects.count_in_inventory('HERMAN', 'SET_SPECIAL_PICKLOCK'):
		objects.transfer_item('HERMAN', data().obj_HermansPicklock, 'ALTER_EGO')
	else:
		#catch
		objects.create_item_in_inventory('ALTER_EGO','SET_SPECIAL_PICKLOCK')

	
	
	#pos = objects.get_position("HERMAN")
	#objects.set_position(data().obj_HermansPicklock,x=pos[0],y=pos[1]+0.5)

#[NM] Dialog 119: Der Spieler will nicht mehr mit Herman sprechen
def initDlg_119_SpielerWillHermanNichtMehr():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_119')
	dialog.add_text(text='D_119_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_015,
						data('zone_3.zone_3').QB_016])

#[NM] Dialog 120: Der Spieler klaut den Spezial-Dietrich
def initDlg_120_SpielerKlautDietrich():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_120')
	dialog.add_text(text='D_120_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_120_Ende)
	dialog.start(True, [data('zone_3.zone_3').QB_015,
						data('zone_3.zone_3').QB_016])

def onDlg_120_Ende():
	data().spieler_hat_dietrich = True

#[NM] Dialog 121: Der Spieler untersucht den Spezial-Dietrich
def initDlg_121_SpielerUntersuchtDietrich():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_121')
	if data().luke_dietrich_gesucht:
		dialog.add_text(text='D_121_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_121_T_002', speaker="HERMAN", follower='ENDDIALOG')
	dialog.start(False, [data('zone_3.zone_3').QB_015,
						 data('zone_3.zone_3').QB_016])

# [NM] Dialog 122: Dörfler A hat nichts zu sagen
def initDlg_122_DoerflerAKommentar():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_122')
	dialog.add_text(text='D_122_T_001', speaker="DOERFLER A", follower='ENDDIALOG')
	dialog.start(True, [data('zone_3.zone_3').QB_015,
						data('zone_3.zone_3').QB_016])

#[NM] Dialog 123: Dörfler B hat nichts zu sagen
def initDlg_123_DoerflerBKommentar():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_123')
	dialog.add_text(text='D_123_T_001', speaker="DOERFLER B", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 124: Dörfler C hat nichts zu sagen
def initDlg_124_DoerflerCKommentar():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_124')
	dialog.add_text(text='D_124_T_001', speaker="DOERFLER C", follower='ENDDIALOG')
	dialog.start()

#[M] Dialog 125: Pete verkauft einen Tipp
def initDlg_125_PeteVerkauftTipp():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_D_125')
	dialog.add_text(text='D_125_T_001', speaker="GEORG")
	dialog.add_text(text='D_125_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_125_T_003', speaker="GEORG", follower="D_125_C_001")
	dialog.add_choice(text='D_125_C_001_1',follower='D_125_T_005')
	## todo: auswahl
	dialog.add_choice(text='D_125_C_001_2', follower='D_125_T_007', callback = onDlg_125_GiveMenue)
	#dialog.add_choice(text='D_125_C_001_2', follower='D_125_T_008')
	dialog.add_choice(text='D_125_C_001_3', follower='ENDDIALOG', callback=onDlg_125_Ende1)
	dialog.add_text(text='D_125_T_004', speaker="GEORG", follower="D_125_C_001")
	dialog.add_text(text='D_125_T_005', speaker="GEORG")
	dialog.add_text(text='D_125_T_006', speaker="ALTER_EGO", follower="D_125_C_001")
	dialog.add_text(text='D_125_T_007', speaker="GEORG", follower='ENDDIALOG', callback=onDlg_125_Ende2)
	dialog.add_text(text='D_125_T_008', speaker="GEORG", follower='ENDDIALOG', callback=onDlg_125_Ende1)
	if data().pete_d_125_restart_t_004:
		dialog.jump_to('D_125_T_004')
	dialog.start(False, [data('zone_3.zone_3').QB_017,
						 data('zone_3.zone_3').QB_017])

def onDlg_125_GiveMenue():
	system.item_panel("GEORG","ALTER_EGO", on_give_menu_filter, on_give_menu_closed, on_give_menu_cancel)

def onDlg_125_Ende1():
	data().pete_d_125_restart_t_004 = True
	data().georg_d_126_spoken = False

def onDlg_125_Ende2():
	system.set_qb_entry_state(data().QB_017,UNCOMPLETE)
	objects.set_active_state("DONALD RUMS", 1)
	system.notify_region_entered(region="Steinbruch1", partyid="UISPIELER")
	system.notify_region_entered(region="Steinbruch2", partyid="UISPIELER")
	data().georg_d_126_spoken = True

#[NM] Dialog 126: Pete hat nichts mehr zu sagen
def initDlg_126_GoergHatNixMehrZuSagen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_126')
	dialog.add_text(text='D_126_T_001', speaker="GEORG", follower='ENDDIALOG')
	dialog.start()

#helper: routing
def RoutedMoveTo(id,route,patrol_type='none',speed=MT_SLOW, cancel=False):
	#print "[debug] routed moveto "+id
	if cancel:
		objects.cancel_commandos(id)

	objects.set_attribute(id,"route",route)
	objects.set_attribute(id,"route_type",patrol_type)
	objects.set_attribute(id,"route_speed",speed)

	if patrol_type == 'none':
		for waypoint in route:
			objects.move_to(id,waypoint[0],waypoint[1],"landscape",speed)
	else:
		pass
		#doPatrol(id,route,patrol_type)
		
#[NM] Dialog 130: Der Spieler hat die Bergtigerin erwischt, allerdings ohne Auftrag
def initDlg_130_SpielerHatBergtigerinErledigtOhneAuftrag():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_130')
	dialog.add_text(text='D_130_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback = Dlg_130_QB)
	dialog.start(True, [data('zone_3.zone_3').QB_019,
						data('zone_3.zone_3').QB_020,
						data('zone_3.zone_3').QB_021])

def Dlg_130_QB():
	system.set_qb_entry_state(data().QB_020,INACTIVE)
	system.set_qb_entry_state(data().QB_021,UNCOMPLETE)

# todo: einbauen

#[NM] Dialog 131: Der Spieler findet das Tagebuch
def initDlg_131_SpielerFindetRatskulltagebuch():
	data().ratskull_tagebuch_gelesen = True
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_131')
	dialog.add_text(text='D_131_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

def can_show_cutscene():
	return (objects.get_grid("ALTER_EGO") == "landscape")

bookdo = 'loop'
RatskullDiaryGelesen=0
def buchLoop(char):
	global RatskullDiaryGelesen
	global bookdo
	if not RatskullDiaryGelesen == 1:
		if bookdo == 'loop':
			character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_LOOP",callback=["ONEND",Lambda('buchLoop("ALTER_EGO")')])
		elif bookdo == 'scrape':
			character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_KRATZEN_LOOP",callback=["ONEND",Lambda('buchLoop("ALTER_EGO")')])
			bookdo = 'loop'
		elif bookdo == 'turnOver':
			character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_UMBLAETTERN_LOOP",callback=["ONEND",Lambda('buchLoop("ALTER_EGO")')])
			bookdo = 'loop'
		else:
			character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_LOOP",callback=["ONEND",Lambda('buchLoop("ALTER_EGO")')])
	else:
		character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_ENDE")
		pass
	

def buchLesen():
	global RatskullDiaryGelesen
	RatskullDiaryGelesen=0
	objects.cancel_commandos("ALTER_EGO")
	character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_BUCH_LESEN_START",callback=["ONEND",Lambda('buchLoop("ALTER_EGO")')])
	readBookTurnOver(3.3)
	
def changeBookDo(do):
	global bookdo
	bookdo = do
	
def readBookTurnOver(de):
	if de > 0.0:
		enemy_script.delay(de,Lambda("changeBookDo('turnOver')"))
	else:
		changeBookDo('turnOver')
		pass

def readBookScrape(de):
	if de > 0.0:
		enemy_script.delay(de,Lambda("changeBookDo('scrape')"))
	else:
		changeBookDo('scrape')
		pass
	
	
#[NM/CS] Dialog 132: Der Spieler liest das Tagebuch
def initDlg_132_SpielerLiestRatskulltagebuch():
	if not can_show_cutscene():
		on_dialog_132_start2()
		return True
	system.start_cutscene()
	set_conversation("ALTER_EGO", cam_x=0.0, cam_y=1.0, mode="medium")
	objects.cancel_commandos("ALTER_EGO")
	objects.turn_to_direction("ALTER_EGO", global_defines.DIR_SOUTH, callback=['ONEND', on_dialog_132_start])
	if objects.count_in_inventory('ALTER_EGO', 'Z3 RATSKULL_DIARY'):
		objects.remove_item_from_inventory("ALTER_EGO", "Z3 RATSKULL_DIARY")
	else:
		if 'Z3 RATSKULL_DIARY' in system.get_objects():
			objects.set_active_state('Z3 RATSKULL_DIARY', False)
	if not objects.count_in_inventory("ALTER_EGO", "SET_OPEN_BOOK"):
		objects.create_item_in_inventory("ALTER_EGO", "SET_OPEN_BOOK")
	return None

def on_dialog_132_start(char=None):
	global RatskullDiaryGelesen
	character.equip("ALTER_EGO", "SET_OPEN_BOOK")
	RatskullDiaryGelesen = 0
	buchLesen()
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_132')
	dialog.add_text(text='D_132_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_132_T_002', speaker="ALTER_EGO")
#	dialog.add_text(text='D_132_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("ALTER_EGO", cam_x=0.0, cam_y=0.5, mode="medium")'))
	dialog.add_text(text='D_132_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_132_Ende)
	dialog.start(True, data('zone_3.zone_3').QB_024)

def on_dialog_132_start2():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_132')
	dialog.add_text(text='D_132_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_132_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_132_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_132_Ende)
	dialog.start(True, data('zone_3.zone_3').QB_024)

def onDlg_132_Ende():
	global RatskullDiaryGelesen
	data('zone_3.zone_3').reading_ratskull_diary = False
	if system.is_cutscene():
		RatskullDiaryGelesen = 1
		system.end_cutscene()
		character.un_equip("ALTER_EGO", "SET_OPEN_BOOK")
		objects.remove_item_from_inventory("ALTER_EGO", "SET_OPEN_BOOK")
		if 'Z3 RATSKULL_DIARY' in system.get_objects():
			objects.set_active_state('Z3 RATSKULL_DIARY', True)
		else:
			objects.create_item_in_inventory(object="ALTER_EGO", equipment="SET_RATSKULL_DIARY", id="Z3 RATSKULL_DIARY")
			objects.set_attribute("Z3 RATSKULL_DIARY", "generic_item", False)
	if not was_zone_entered('sqzone_2.sqzone_2'):
		system.set_qb_entry_state(data("zone_3.zone_3").QB_024,UNCOMPLETE) 
	#system.set_qb_entry_state(data().QB_024,UNCOMPLETE)
	if not is_zone_enabled('sqzone_2'):
		character.add_experience_party(50)
	set_zone_enabled("sqzone_2",True)
	
def initDlg_133_HUMVEE():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_D_133')
	dialog.add_text(text='D_133_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback = (Lambda('data().HUMVEE_Z3_Untersucht = True')))
	dialog.start()
	
