# -*- coding: utf-8 -*-
from global_defines import *
from dynamic_camera import *
import npc
import const
import schedules
import enemy_script
import character
import dialog
import object_events
import sounds
from daily_routine import *

#*** actual revision - Revision 34, 9.09.2004 *********************************

# helpers for ear devices
def count_ear_devices(char):
	devices = [data().qi_ear_device_1[0],data().qi_ear_device_2[0],data().qi_ear_device_3[0]]
	r = 0
	erg = enemy_script.count_party_inventory(area = 15, object_id = char, items = devices)
	for device in devices:
		r += erg[device]
	return r

def check_ear_devices(char):
	return (data().rupert_tondoksgegeben + count_ear_devices(char) == 3)

def transfer_ear_devices(char):
	devices = [data().qi_ear_device_1,data().qi_ear_device_2,data().qi_ear_device_3]
	for device in devices:
		objects.transfer_item(enemy_script.get_next_transfer_partner(char, device[0]), device[0], char)

def is_ear_device(item_id):
	return item_id in [data().qi_ear_device_1[0],data().qi_ear_device_2[0],data().qi_ear_device_3[0]]

# helpers for paperdocs
def count_paper_docs(char):
	paperdocs = [data().qi_paper_doc_1[0],data().qi_paper_doc_2[0],data().qi_paper_doc_3[0]]
	r = 0
	erg = enemy_script.count_party_inventory(area = 15, object_id = char, items = paperdocs)
	for paperdoc in paperdocs:
		r += erg[paperdoc]
	return r

def check_paper_docs(char):
	return (data().rupert_schriftdoksgegeben + count_paper_docs(char) == 3)

def transfer_paper_docs(char):
	paperdocs = [data().qi_paper_doc_1,data().qi_paper_doc_2,data().qi_paper_doc_3]
	for paperdoc in paperdocs:
		objects.transfer_item(enemy_script.get_next_transfer_partner(char, paperdoc[0]), paperdoc[0], char)

def is_paper_doc(item_id):
	return item_id in [data().qi_paper_doc_1,data().qi_paper_doc_2,data().qi_paper_doc_3]

def container_sound():
	sounds.play_3d_sound("open_prisondoor", 491.10696411132812, 466.99209594726562, 0)# 28.1953125)

def container_sound_vesseltown():
	sounds.play_3d_sound("open_prisondoor", 517.565673828125, 481.5355224609375, 0)# 12.6640625)

def on_approach( target, operator ):
	if dialog.is_dialog_active():
		return
	if ((not target in data().MAINQUEST_NPCS) 
		or (not target in data().NEBENQUEST_NPCS)):
		if schedules.Dialog(target, operator): 
			return
	if target == "REPORTER":
		if not data().reporter_spoke_to:
			initDlg_147_ReporterIstAufSiegerstasse()
		else:
			initDlg_148_SpielerWillNichtNochmalMitReporterReden()
		
	if target in data().BOTEN_NPCS.keys():
		initDlg_149_SpielerWillNichtMitBotenReden()
		
	if target == "ANIE":
		initDlg_134_SpielerBefragtAnie()
	
	if target in ["GEISEL_1","GEISEL_2","GEISEL_3","GEISEL_4","GEISEL_5"]:
		if not data().GNO_HOSTAGE_INFO:
			initDlg_135_SpielerWillNochNichtMitGeiselnReden()
		else:
			if data().continue_with_d_137:
				initDlg_137_SpielerWillNichtMehrMitGeiselnReden()
			else:
				initCutscene_136_GeiselnWollenSpielerBegleiten()
	
	if target == "ANDREW":
		## Kennenlernen
		if (system.get_qb_entry_state(data().QB_002)==UNCOMPLETE and system.get_qb_entry_state(data().QB_003) == INACTIVE):
			if data().andrew_restart_d_003_t_017 and not data().andrew_restart_d_004:
				initDlg_003_SpielerSprichtAndrewAn()
			elif not data().andrew_restart_d_004:
				initDlg_003_SpielerSprichtAndrewAn()
			elif data().andrew_restart_d_004:
				initDlg_004_SpielerGehtErneutZuAndrew()
		
		## Codequest
		elif (system.get_qb_entry_state(data().QB_003)==UNCOMPLETE):
			if data().andrew_undone == 0 and not data().conny_spielererfolglos and not data().rupert_spielererfolglos:
				initCutscene_006_SpielerUnverrichtetZuAndrew1()
				data().andrew_undone = 1
			elif not data().conny_spielererfolglos and data().rupert_spielererfolglos:
				initCutscene_008_SpielerBeiRupertKeinGlueckAndrewRueckkehr()
			elif data().conny_spielererfolglos and not data().rupert_spielererfolglos:
				initCutscene_009_SpielerBeiConnyKeinGlueckAndrewRueckkehr()
			else:
				initCutscene_007_SpielerUnverrichtetZuAndrew2()
		
		## Codequest geschafft
		elif (system.get_qb_entry_state(data().QB_003)==COMPLETE and system.get_qb_entry_state(data().QB_004)==INACTIVE and
			system.get_qb_entry_state(data().QB_005)==INACTIVE):
			initCutscene_032_SpielerIstWiederBeiAndrew()
		
		## Vergaser Quest
		elif (system.get_qb_entry_state(data().QB_003)==COMPLETE and system.get_qb_entry_state(data().QB_004)==UNCOMPLETE and
			system.get_qb_entry_state(data().QB_005)==INACTIVE):
			erg = enemy_script.count_party_inventory(area = 15, object_id = "ANDREW", items = [data().qi_vergaser[0],data().qi_vergaser_mba[0]])
			if (erg[data().qi_vergaser[0]] and not erg[data().qi_vergaser_mba[0]]) or (not erg[data().qi_vergaser[0]] and erg[data().qi_vergaser_mba[0]]):
				initCutscene_037_SpielerBringtAndrewVergaser()
			elif (erg[data().qi_vergaser[0]] and erg[data().qi_vergaser_mba[0]]):
				initCutscene_039_SpielerBringtAndrew2Vergaser()
			else:
				initDlg_038_SpielerKommtOhneVergaserZuAndrew()
		
		# Andrew im Museum mit Nebenquest
		elif (system.get_qb_entry_state(data().QB_003) == COMPLETE and 
			system.get_qb_entry_state(data().QB_005) == COMPLETE):
			if not data().andrew_first_approach_after_mq:
				initDlg_145_SpielerSauerAufAndrew()
			else:
				if (system.get_qb_entry_state(data().QB_010) == UNCOMPLETE or
					system.get_qb_entry_state(data().QB_011) == UNCOMPLETE):
					initCutscene_052_SpielerSuchtFettUndAlkohol()
				else:
					initCutscene_062_SpielerSuchtWederFettNochAlkohol()
		
	elif target=="RUPERT":
		## noch nicht bei Andrew gewesen
		if (system.get_qb_entry_state(data().QB_003)==INACTIVE):
			initDlg_065_SpielerTrifftRupertVorAndrewsAuftrag()
		
		## Codequest aktiv
		elif (system.get_qb_entry_state(data().QB_003)==UNCOMPLETE):
			if not data().rupert_spielererfolglos and not data().rupert_spielerwarschonda and not data().conny_spielerwarschonda:
				initDlg_010_SpielerTrifftRupertMitAndrewsAuftrag()
			elif not data().rupert_spielererfolglos and not data().rupert_spielerwarschonda and data().conny_spielerwarschonda:
				onDlg_010_ReenterFirstAfterConny()
			elif data().rupert_spielererfolglos:
				onDlg_010_ReenterQuizSecondChance()
			else:
				onDlg_010_ReenterNachSturheit()

		## Codequest geloest
		elif (system.get_qb_entry_state(data().QB_003)==COMPLETE): 
			if (system.get_qb_entry_state(data().QB_005) in [INACTIVE, UNCOMPLETE]):
				## bei rupert geloest
				if data().rupert_geloest:
					initDlg_014_SpielerIstVonRupertGenervt()
				## bei conny geloest
				elif not data().rupert_geloest:
					if not data().rupert_spielerwarschonda:
						initCutscene_021_SpielerTrifftRupertNachErfolgBeiConny()
					else:
						initDlg_022_SpielerTrifftRupertErneutNachErfolgBeiConny()
						data().rupert_spielerwarschonda = True
		
			## Ton und Schriftdokumentquest
			elif system.get_qb_entry_state(data().QB_014) == UNCOMPLETE:
				if ((data().rupert_tondoksgegeben == 3 and check_paper_docs("RUPERT")) or
				(data().rupert_schriftdoksgegeben == 3 and check_ear_devices("RUPERT"))):
					if check_paper_docs("RUPERT"):
						transfer_ear_devices("RUPERT")
					else:
						transfer_paper_docs("RUPERT")
					initDlg_055_SpielerFindetTonUndSchriftDokumente()
				
				elif (check_paper_docs("RUPERT") and check_ear_devices("ALTER_EGO")):
					initDlg_055_SpielerFindetTonUndSchriftDokumente()
					transfer_ear_devices("RUPERT")
					transfer_paper_docs("RUPERT")
					
				elif ((check_paper_docs("RUPERT") and not check_ear_devices("RUPERT")) or
					(not check_paper_docs("RUPERT") and check_ear_devices("RUPERT"))):
					if data().Counter_TonUndSchriftNicht == 0:
						initDlg_056_SpielerFindetNichtAlleTonUndSchriftDokumente()
					elif data().Counter_TonUndSchriftNicht == 1:
						initDlg_073_SpielerFindetNichtAlleTonUndSchriftDokumente2()
					else:
						initDlg_074_SpielerFindetNichtAlleTonUndSchriftDokumente3()
					data().Counter_TonUndSchriftNicht += 1
				else:
					initDlg_059_SpielerFindetKeineTonUndSchriftDokumente()
		
			## Fett und Alkoholquest
			elif (system.get_qb_entry_state(data().QB_010) == UNCOMPLETE and 
				system.get_qb_entry_state(data().QB_011) == UNCOMPLETE and
				system.get_qb_entry_state(data().QB_014) == INACTIVE ):
				initDlg_053_SpielerFindetFettUndAlkohol()
			else:
				initDlg_Z6_147_SpielerHatKeineZeit()

	elif target=="CONNY":
		## noch nicht bei Andrew gewesen
		if (system.get_qb_entry_state(data().QB_003)==INACTIVE):
			initCutscene_067_SpielerTrifftConnyVorAndrewsAuftrag()
		
		## Codequest
		elif (system.get_qb_entry_state(data().QB_003) == UNCOMPLETE):
			# erste Ansprache
			if (system.get_qb_entry_state(data().QB_012)==INACTIVE and not data().conny_spielerwarschonda):
				initDlg_023_SpielerTrifftConnyMitAndrewsAuftrag()
			else:
				Eselquest(target)

		## Codequest geloest
		elif (system.get_qb_entry_state(data().QB_003)==COMPLETE):
			if (data().rupert_geloest and not data().conny_spielerwarschonda  and
			system.get_qb_entry_state(data().QB_010)==INACTIVE and 
			system.get_qb_entry_state(data().QB_011)==INACTIVE):
				initCutscene_027_SpielerVonConnyWeggeschicktWarSchonBeiRupert2()

			#elif (system.get_qb_entry_state(data().QB_010)==UNCOMPLETE and 
			#system.get_qb_entry_state(data().QB_011)==UNCOMPLETE):
			#	if (not data().conny_aufwegzuemily and 
			#	hasItem("ALTER_EGO",data().qi_fett[0]) and 
			#	hasItem("ALTER_EGO",data().qi_alkohol[0])):
			#		initCutscene_057_SpielerSchicktConnyZuEmily()
			elif (not system.get_qb_entry_state(data().QB_012)==INACTIVE):
				Eselquest(target)
			else:
				initDlg_092_SpielerPlaudertMitConny()

################################################################################################################################		
## Dialoge mit Craig und Brad
################################################################################################################################		
	elif target=="BRAD":
		#objects.cancel_commandos(target)
		#objects.turn_to_object(target, operator, callback=["ONEND",dialog_layout_brad])
		dialog_layout_brad(target)
	
	elif target=="CRAIG":
		#objects.cancel_commandos(target)
		#objects.turn_to_object(target, operator, callback=["ONEND",dialog_layout_craig])
		dialog_layout_craig(target)

################################################################################################################################		
## Dialoge mit Emily
################################################################################################################################
	elif target=="EMILY":
		if (system.get_qb_entry_state(data().QB_008)==INACTIVE and
			#not system.get_qb_entry_state(data().QB_009)==UNCOMPLETE and
			#not system.get_qb_entry_state(data().QB_010)==UNCOMPLETE and
			#not system.get_qb_entry_state(data().QB_011)==UNCOMPLETE and
			not data().emily_seansnotizagelesen and
			not system.get_qb_entry_state(data().QB_016)==UNCOMPLETE):
			initDlg_042_SpielerSollKleinFamileHelfen()
		
		elif (system.get_qb_entry_state(data().QB_008)==UNCOMPLETE and
			#system.get_qb_entry_state(data().QB_009)==UNCOMPLETE and
			#system.get_qb_entry_state(data().QB_010)==UNCOMPLETE and
			#system.get_qb_entry_state(data().QB_011)==UNCOMPLETE):
			not system.get_qb_entry_state(data().QB_016)==UNCOMPLETE and
			not data().emily_von_erfindung_berichtet and
			data().emily_seansnotizagelesen):
			#if not data().emily_von_erfindung_berichtet:
			data().emily_von_erfindung_berichtet = True
			initCutscene_043_SpielerKannEmilyVonSeansErfindungBerichten()
		
		elif (system.get_qb_entry_state(data().QB_010)==UNCOMPLETE and
			system.get_qb_entry_state(data().QB_011)==UNCOMPLETE):
				group = enemy_script.is_in_area(system.get_pcs(), 25, 'ALTER_EGO')
				
				#player has no alcohol
				if (not haveItem(group,"SET_TIN_WITH_ALCOHOL") and
					not hasItem("EMILY","SET_TIN_WITH_ALCOHOL") and 
					not haveItem(group,data().qi_alkohol[0]) and
					not hasItem("EMILY",data().qi_alkohol[0])):
					initCutscene_091_SpielerSuchtAlkohol()
				#player has everything
				elif ((	haveItem(group,"SET_TIN_WITH_ALCOHOL")  and 
					haveItem(group,data().qi_fett[0]))
					and (system.get_qb_entry_state(data().QB_009 in [INACTIVE, COMPLETE]))):
					transfer_item(group,"SET_TIN_WITH_ALCOHOL", "EMILY")
					transfer_item(group,data().qi_fett[0], "EMILY")
					if system.get_qb_entry_state(data().QB_009) == COMPLETE and haveItem(group,"Z7 SEANS_NOTE_B"):
						transfer_item(group,"Z7 SEANS_NOTE_B", "EMILY")
					initCutscene_058_SpielerBringtSachenZuEmily()
				elif (	haveItem(group,data().qi_alkohol[0]) and 
					haveItem(group,data().qi_fett[0]) and
					(system.get_qb_entry_state(data().QB_009 in [INACTIVE, COMPLETE]))):
					transfer_item(group,data().qi_alkohol[0], "EMILY")
					transfer_item(group,data().qi_fett[0], "EMILY")
					if system.get_qb_entry_state(data().QB_009) == COMPLETE and haveItem(group,"SEAN_NOTE_B"):
						transfer_item(group,"SEAN_NOTE_B", "EMILY")
					initCutscene_058_SpielerBringtSachenZuEmily()
				
				#player has alcohol, emily the fat
				elif (	haveItem(group,data().qi_alkohol[0])  and 
					hasItem("EMILY",data().qi_fett[0]) ):  
					transfer_item(group,data().qi_alkohol[0], "EMILY")
					initCutscene_058_SpielerBringtSachenZuEmily()
				elif (	haveItem(group,"SET_TIN_WITH_ALCOHOL")  and 
					hasItem("EMILY",data().qi_fett[0]) ):  
					transfer_item(group,"SET_TIN_WITH_ALCOHOL", "EMILY")
					initCutscene_058_SpielerBringtSachenZuEmily()

				#player has fat, emily the alcohol
				elif (	haveItem(group,data().qi_fett[0]) and 
					( hasItem("EMILY","SET_TIN_WITH_ALCOHOL") or hasItem("EMILY",data().qi_alkohol[0]) )):
					#transfer_item(group,qi_fett[0], "EMILY")
					transfer_item(group,data().qi_fett[0], "EMILY")
					initCutscene_058_SpielerBringtSachenZuEmily()
				#player has nothing
				else:
					if not data().conny_beiemily:
						if not random.randint(0,1):
							initDlg_066_SpielerKommtOhneSachenZuEmily()
						else:
							initDlg_112_SpielerKommtOhneSachenZuEmily2()
					else:
						initDlg_117_EmilyBedanktSichBeiSpieler()
		elif (	system.get_qb_entry_state(data().QB_008)==INACTIVE and
			#system.get_qb_entry_state(data().QB_009)==INACTIVE and
			system.get_qb_entry_state(data().QB_010)==INACTIVE and
			system.get_qb_entry_state(data().QB_011)==INACTIVE and
			system.get_qb_entry_state(data().QB_016)==UNCOMPLETE):
			if not data().emily_sonnenschutmittel_fertig:
				initDlg_138_SonnenschutzmittelIstNochNichtFertig()
			else:
				initDlg_139_SonnenschutzmittelIstFertig()
		elif system.get_qb_entry_state(data().QB_008)==COMPLETE:
			initDlg_118_EmilyIstSpielerDankbar()
			
		elif system.get_qb_entry_state(data().QB_008)== UNCOMPLETE:
			Dlg_093_Emily_Kein_Tagebuch()

################################################################################################################################		

def Eselquest(target):
	## Eselquest
	if (system.get_qb_entry_state(data().QB_012)==UNCOMPLETE and not data().conny_spielererfolglos):
		if data().conny_eselzurueck and not data().conny_eseltot:
			initDlg_031_SpielerKehrtMitEselZurueck()
		elif data().conny_eseltot:
			initDlg_130_SpielerHatEselGetoetet()
			character.set_approachable_state("CONNY",NOTAPPROACHABLE)
		else:
			initDlg_028_SpielerKehrtOhneEselZurueck()
	elif data().conny_spielererfolglos: 
		if not data().rupert_spielererfolglos:
			initDlg_024_SpielerVonConnyWeggeschickt()
		else:
			initDlg_025_SpielerVonConnyWeggeschicktWarSchonBeiRupert()

def has_partychar_item_for_target(target, item, remove):
	if not isinstance(item, list):
		item = [item]
	item_to_char_map = {}
	#create map: item - char who has item
	for i in item:
		for pc in system.get_pcs():
			if objects.get_distance(pc, target) < 10.0:
				if objects.count_in_inventory(pc, i):
					eintrag = { i : pc }
					item_to_char_map.update(eintrag)
					break
	
	#compare map - itemlist
	k = item_to_char_map.keys()
	#print ">>> exchange if equal:",item_to_char_map,"with:",item
	k.sort()
	item.sort()
	
	#exchange items
	if k == item and remove:
		for i in item_to_char_map.keys():
			#print ">>> gleiche items gefunden und getauscht", i, item_to_char_map[i]
			objects.transfer_item(item_to_char_map[i],i,target)
		return True
	return False

#*** dialoglayouts
#craig und brad
def dialog_layout_brad(target):
	if (	system.get_qb_entry_state(data().QB_006)==INACTIVE and
		system.get_qb_entry_state(data().QB_007)==INACTIVE):
			#print 'von hier'
			initDlg_045_SpielerSollVesseltownEingangErmoeglichen()
	elif (	system.get_qb_entry_state(data().QB_006)==UNCOMPLETE and
		system.get_qb_entry_state(data().QB_007)==INACTIVE):
		if has_partychar_item_for_target(target,[data().qi_windschutzscheibe[0], data().qi_rotorblatt[0]], True):
			initCutscene_083_SpielerGibtWindschutzscheibeUndRotoblattAb()
			#objects.remove_item_from_inventory("ALTER_EGO",data().qi_windschutzscheibe[0])
			#objects.remove_item_from_inventory("ALTER_EGO",data().qi_rotorblatt[0])
		
		elif has_partychar_item_for_target(target,data().qi_windschutzscheibe[0], data().craigbrad_rotorblattgegeben):
			initCutscene_083_SpielerGibtWindschutzscheibeUndRotoblattAb()
			#objects.remove_item_from_inventory("ALTER_EGO",data().qi_windschutzscheibe[0])
		
		elif has_partychar_item_for_target(target,data().qi_rotorblatt[0], data().craigbrad_windschutzscheibegegeben):
			initCutscene_083_SpielerGibtWindschutzscheibeUndRotoblattAb()
			#objects.remove_item_from_inventory("ALTER_EGO",data().qi_rotorblatt[0])
		else:
			initDlg_049_SpielerOhneFundZuBewohnernZurueck()
	elif (data().craigbrad_craigarbeitetanflughund and not data().craigbrad_flughund_fertig):
		initDlg_119_SpielerWartetAufFlughund()
	elif (data().craigbrad_flughund_fertig and not data().craigbrad_flughund_zerstoert):
		initCutscene_050_SpielerFliegtMitFlughundLos()
	else:
		initDlg_148_SpielerWillNichtNochmalMitReporterReden()
	
def dialog_layout_craig(target):
	if (data().craigbrad_flughund_zerstoert and system.get_qb_entry_state(data().QB_006)==COMPLETE):
		initCutscene_085_SpielerWirdNachUntenGelassen()
	elif (data().craigbrad_craigarbeitetanflughund and not data().craigbrad_flughund_fertig):
		initDlg_119_SpielerWartetAufFlughund()
	elif (	system.get_qb_entry_state(data().QB_006)==UNCOMPLETE and
		system.get_qb_entry_state(data().QB_007)==INACTIVE):
		if has_partychar_item_for_target(target,[data().qi_windschutzscheibe[0], data().qi_rotorblatt[0]], True):
			initCutscene_083_SpielerGibtWindschutzscheibeUndRotoblattAb()
		
		elif has_partychar_item_for_target(target,data().qi_windschutzscheibe[0], data().craigbrad_rotorblattgegeben):
			initCutscene_083_SpielerGibtWindschutzscheibeUndRotoblattAb()
		
		elif has_partychar_item_for_target(target,data().qi_rotorblatt[0], data().craigbrad_windschutzscheibegegeben):
			initCutscene_083_SpielerGibtWindschutzscheibeUndRotoblattAb()
		else:
			initDlg_049_SpielerOhneFundZuBewohnernZurueck()
	elif (data().craigbrad_flughund_fertig and not data().craigbrad_flughund_zerstoert):
		initCutscene_050_SpielerFliegtMitFlughundLos()
	else:
		initDlg_049_SpielerOhneFundZuBewohnernZurueck()



################################################################################################################################
## Dialoge mit Andrew
################################################################################################################################
#[M]Dialog 003: Der Spieler spricht Andrew an
def initDlg_003_SpielerSprichtAndrewAn():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_003')
	dialog.add_text(text='D_003_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_003_T_002', speaker="ANDREW", follower='D_003_C_001')
	dialog.add_choice(text='D_003_C_001_1', follower='D_003_T_018')
	dialog.add_choice(text='D_003_C_001_2', follower='D_003_T_010')
	dialog.add_choice(text='D_003_C_001_3', follower='D_003_T_010')
	dialog.add_choice(text='D_003_C_001_4', follower='ENDDIALOG', callback=onDlg_003_Ende1)
	dialog.add_text(text='D_003_T_010', speaker="ANDREW")
	dialog.add_text(text='D_003_T_011', speaker="ALTER_EGO")
	dialog.add_text(text='D_003_T_012', speaker="ANDREW", follower='D_003_C_004')
	if data().andrew_c_004_1_aktiv:
		dialog.add_choice(text='D_003_C_004_1', follower='D_003_T_015')
	dialog.add_choice(text='D_003_C_004_2', follower='D_003_T_016')
	dialog.add_choice(text='D_003_C_004_3', follower='ENDDIALOG', callback=onDlg_003_Ende2)
	dialog.add_text(text='D_003_T_015', speaker="ANDREW", follower='D_003_C_004', callback=Lambda('data().andrew_c_004_1_aktiv = False'))
	dialog.add_text(text='D_003_T_016', speaker="ANDREW", follower='ENDDIALOG', callback=onDlg_003_Ende3)
	dialog.add_text(text='D_003_T_017', speaker="ANDREW", follower='D_003_C_004')
	dialog.add_text(text='D_003_T_018', speaker="ANDREW")
	dialog.add_text(text='D_003_T_019', speaker="ANDREW", follower='D_003_C_001')
	
	if data().andrew_restart_d_003_t_017 and not data().andrew_restart_d_004:
		dialog.jump_to('D_003_T_017')
	
	dialog.start(False, [data().QB_002, data().QB_003])
	
def onDlg_003_Ende1():
	data().andrew_restart_d_004 = True

def onDlg_003_Ende2():
	data().andrew_restart_d_003_t_017 = True
	data().andrew_restart_d_004 = False

def onDlg_003_Ende3():
	system.set_qb_entry_state(data().QB_003,UNCOMPLETE)

#[M]Dialog 004: Der Spieler geht erneut zu Andrew
def initDlg_004_SpielerGehtErneutZuAndrew():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_004')
	dialog.add_text(text='D_004_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_004_T_002', speaker="ANDREW")
	dialog.add_text(text='D_004_T_003', speaker="ALTER_EGO")
	dialog.add_text(text='D_004_T_004', speaker="ANDREW", follower='D_004_C_001')
	dialog.add_choice(text='D_004_C_001_1', follower='D_004_T_007')
	dialog.add_choice(text='D_004_C_001_2', follower='ENDDIALOG', callback=onDlg_004_Ende)
	dialog.add_text(text='D_004_T_007', speaker="ANDREW", follower='D_004_C_002')
	dialog.add_choice(text='D_004_C_002_1', follower='ENDDIALOG', callback=onDlg_004_Ende)
	dialog.add_choice(text='D_004_C_002_2', follower='ENDDIALOG')
	dialog.start(True, [data().QB_002, data().QB_003])

def onDlg_004_Ende():
	system.set_qb_entry_state(data().QB_003,UNCOMPLETE)

#[NM/CS]Dialog 006: Der Spieler geht unverrichteter Dinge zu Andrew
def initCutscene_006_SpielerUnverrichtetZuAndrew1():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="ANDREW", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="ANDREW", callback=["ONEND", onDlg_006_StartDialog])

def onDlg_006_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_006')
	set_conversation("ANDREW","ALTER_EGO",mode="medium")
	dialog.add_text(text='D_006_T_001', speaker="ANDREW", callback=Lambda('set_conversation("ALTER_EGO","ANDREW",mode="close")'))
	dialog.add_text(text='D_006_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('end_cutscene(chars=["ANDREW", "ALTER_EGO"]); allow_activity("ANDREW")'))
	dialog.start(False, data().QB_003)

#[NM/CS]Dialog 007: Der Spieler geht erneut unverrichteter Dinge zu Andrew
def initCutscene_007_SpielerUnverrichtetZuAndrew2():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="ANDREW", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="ANDREW", callback=["ONEND", onDlg_007_StartDialog])

def onDlg_007_StartDialog(char_id):
	set_conversation("ANDREW","ALTER_EGO",mode="medium")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_007')
	dialog.add_text(text='D_007_T_001', speaker="ANDREW", callback=Lambda('set_conversation("ALTER_EGO","ANDREW",mode="close")'))
	dialog.add_text(text='D_007_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('end_cutscene(chars=["ANDREW", "ALTER_EGO"]); allow_activity("ANDREW")'))
	dialog.start(False, data().QB_003)


#[NM/CS]Dialog 008: Der Spieler hat bei Rupert kein Glück gehabt und kehrt zu Andrew zurück
def initCutscene_008_SpielerBeiRupertKeinGlueckAndrewRueckkehr():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="ANDREW", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="ANDREW", callback=["ONEND", onDlg_008_StartDialog])

def onDlg_008_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_008')
	set_conversation("ALTER_EGO","ANDREW",mode="close")
	dialog.add_text(text='D_008_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("ANDREW","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_008_T_002', speaker="ANDREW", follower='ENDDIALOG', callback=Lambda('end_cutscene(chars=["ANDREW", "ALTER_EGO"]); allow_activity("ANDREW")'))
	dialog.start(False, data().QB_003)

#[NM/CS]Dialog 009: Der Spieler hat bei Conny kein Glück gehabt und kehrt zu Andrew zurück
def initCutscene_009_SpielerBeiConnyKeinGlueckAndrewRueckkehr():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="ANDREW", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="ANDREW", callback=["ONEND", onDlg_009_StartDialog])

def onDlg_009_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_009')
	set_conversation("ALTER_EGO","ANDREW",mode="close")
	dialog.add_text(text='D_009_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("ANDREW","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_009_T_002', speaker="ANDREW", follower='ENDDIALOG', callback=Lambda('end_cutscene(chars=["ANDREW", "ALTER_EGO"]); allow_activity("ANDREW")'))
	dialog.start(False, data().QB_003)

#[NM/CS]Dialog 032: Der Spieler ist wieder bei Andrew, dem Kranführer
def initCutscene_032_SpielerIstWiederBeiAndrew():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="ANDREW", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="ANDREW", callback=["ONEND", onDlg_032_StartDialog])
	for pc in system.get_pcs():
		if pc != "ALTER_EGO":
			objects.turn_to_object(object=pc, target_object="ANDREW")

def unequip_equiped_weapon(char_id):
	inventory = objects.get_inventory_ids(char_id)
	for item in inventory:
		if len(item[0]):
			item_type = item[0][0]
			if objects.has_attribute(item_type, "weapon_type"):
				if character.is_equiped(char=char_id, equipment=item_type):
					character.un_equip_direct(char_id, item_type)

def has_carburator():
	pcs = system.get_pcs()
	for pc in pcs:
		if (objects.count_in_inventory(pc, data().qi_vergaser[0]) or 
			objects.count_in_inventory(pc, data().qi_vergaser_mba[0])):
				return True
	return False

def onDlg_032_StartDialog(char_id):
	data().pc_on_carburator = onDlg_032_CheckPCSkills()
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_032')
	set_conversation("ALTER_EGO","ANDREW",mode="close")
	dialog.add_text(text='D_032_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("ANDREW","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_032_T_002', speaker="ANDREW", callback=Lambda('set_conversation("ALTER_EGO","ANDREW",mode="close")'))
	dialog.add_text(text='D_032_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("ANDREW","ALTER_EGO",mode="close")'))
	
	if data().pc_on_carburator == "NO_ID" and has_carburator():
		dialog.add_text(text='D_032_T_004', speaker="ANDREW", follower='D_032_T_009', callback=Lambda('set_conversation("ALTER_EGO","ANDREW",mode="close")'))
	else:
		dialog.add_text(text='D_032_T_004', speaker="ANDREW", follower='D_032_T_005', callback=Lambda('set_conversation("ALTER_EGO","ANDREW",mode="close")'))

	if data().pc_on_carburator != "NO_ID":
		dialog.add_text(text='D_032_T_005', speaker="ALTER_EGO", follower='D_032_T_006', callback=onDlg_032_SkilledPCWorksOnCarburetor)
		dialog.add_text(text='D_032_T_006', speaker=data().pc_on_carburator, follower='ENDDIALOG')
	else:
		dialog.add_text(text='D_032_T_005', speaker="ALTER_EGO", follower='D_032_T_007')
		dialog.add_text(text='D_032_T_007', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_032_Ende1)
	dialog.add_text(text='D_032_T_009', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_032_AndrewOnCarburator)
	dialog.start(False, [data().QB_002, data().QB_004])
	
def onDlg_032_AndrewOnCarburator():
	erg = enemy_script.count_party_inventory(area = 15, object_id = "ANDREW", items = [data().qi_vergaser[0], data().qi_vergaser_mba[0]])
	if erg[data().qi_vergaser[0]]:
		objects.transfer_item(enemy_script.get_next_transfer_partner("ANDREW", data().qi_vergaser[0]), data().qi_vergaser[0], "ANDREW")
	elif erg[data().qi_vergaser_mba[0]]:
		objects.transfer_item(enemy_script.get_next_transfer_partner("ANDREW", data().qi_vergaser_mba[0]), data().qi_vergaser_mba[0], "ANDREW")
	
	data().pc_on_carburator = "ANDREW"
	onDlg_037_039_AndrewWorksOnCarburetor()

def onDlg_032_ContinueAfterFadeToBlack():
	system.fade(FADE_IN)
	objects.cancel_commandos(data().pc_on_carburator)
	#x,y,z = objects.get_full_dummy_position(const.Z7_CRANE,"dmyp_repair_crane")
	#objects.set_position_free(data().pc_on_carburator,x,y,z, grid="landscape")
	objects.set_to_dummy(data().pc_on_carburator,const.Z7_CRANE,"dmyp_repair_crane")
	objects.set_direction_free(data().pc_on_carburator, 220)
	system.set_camera_view(const.CAMVIEW_WORKONCRANE)
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_START")
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_1")
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_2")
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_3", callback=["ONEND", onDlg_032_FadeOut2])
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_ENDE")

def onDlg_032_ContinueAfterFadeToBlack2():
	system.fade(FADE_IN)
	objects.cancel_commandos(data().pc_on_carburator)
	objects.set_direction_free(data().pc_on_carburator, 30)
	x,y,z = objects.get_full_dummy_position(const.Z7_CRANE,"dmyp_climb_crane")
	objects.set_position_free(data().pc_on_carburator,x+0.39,y-0.49,z, grid="landscape")
	
	#objects.set_to_dummy(data().pc_on_carburator,const.Z7_CRANE,"dmyp_climb_crane")
	
	system.set_camera_view(const.CAMVIEW_CARBURATOR_FOR_ANDREW)
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_RUNTERKLETTERN_HAFENKRAN_START")
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_RUNTERKLETTERN_HAFENKRAN_LOOP", callback=["ONEND", onDlg_032_CharBackToCrew])
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_RUNTERKLETTERN_HAFENKRAN_ENDE")
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_RUNTERKLETTERN_HAFENKRAN_BACKFLIP")
	
def onDlg_032_CharBackToCrew(char):
	system.set_camera_view([496.234375, 491.638916015625, 31.59796142578125, -0.33687669038772583, -0.86279958486557007, -0.37694942951202393])
	enemy_script.delay(0.5, Lambda('crane_work_continue()'))
	
def crane_work_continue(param=None):
	objects.cancel_commandos(data().pc_on_carburator)
	objects.set_position_free(data().pc_on_carburator, 495.79, 486.50, 0)
	pos = objects.get_full_dummy_position(const.Z7_CRANE,"dmyp_climb_crane")
	objects.step_to(data().pc_on_carburator,pos[0]-1.0, pos[1])
	if data().pc_on_carburator == "ANDREW":
		onDlg_037_039_ContinueAfterFadeToBlack()
		return
	else:
		pa = objects.get_position("ANDREW")
		objects.move_to(data().pc_on_carburator, pa[0]+1.7,pa[1]-1.3)
		objects.turn_to_object("ALTER_EGO","ANDREW")
		objects.turn_to_object(data().pc_on_carburator,"ANDREW", callback=["ONEND",onDlg_032_ContinueDialog])

def onDlg_032_FadeOut2(char):
	system.fade(FADE_OUT, Lambda('enemy_script.delay(1.0,Lambda("onDlg_032_ContinueAfterFadeToBlack2()"))'))
	
def onDlg_032_ContinueDialog(char_id):
	set_conversation("ALTER_EGO","ANDREW",mode="close")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_032')
	dialog.add_text(text='D_032_T_008', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_032_Ende2)
	dialog.start(True, [data().QB_002, data().QB_004])

def onDlg_032_CheckPCSkills():
	skilled_id = "NO_ID"
	for id in system.get_pcs():
		if (objects.get_distance(id, "ALTER_EGO") <= 15.0):
			if objects.has_attribute(id,"technic"):
				if objects.get_attribute(id,"technic") >= 80:
					skilled_id = id
			if objects.has_attribute(id,"elektronic"):
				if objects.get_attribute(id,"elektronic") >= 80:
					skilled_id = id
	return skilled_id

def onDlg_032_SkilledPCWorksOnCarburetor():
	objects.cancel_commandos("ALTER_EGO")
	objects.cancel_commandos("ANDREW")
	system.set_camera_view(const.CAMVIEW_CARBURATOR_FOR_ANDREW)
	objects.cancel_commandos(data().pc_on_carburator)
	character.unequip_hands(data().pc_on_carburator)
	objects.move_to_object(data().pc_on_carburator, const.Z7_CRANE, "dmyp_climb_crane", speed=MT_SLOW)
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_KLETTERN_HAFENKRAN_START")
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_KLETTERN_HAFENKRAN_LOOP", callback=["ONEND",onDlg_032_FadeOut])
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_KLETTERN_HAFENKRAN_ENDE")
	character.play_animation(data().pc_on_carburator,"CM_NPC_STEHEN_KLETTERN_HAFENKRAN_BACKFLIP")

def char_climb_crane(char):
	character.play_animation(char,"CM_NPC_STEHEN_KLETTERN_HAFENKRAN_START")
	character.play_animation(char,"CM_NPC_STEHEN_KLETTERN_HAFENKRAN_LOOP")
	character.play_animation(char,"CM_NPC_STEHEN_KLETTERN_HAFENKRAN_ENDE")
	character.play_animation(char,"CM_NPC_STEHEN_KLETTERN_HAFENKRAN_BACKFLIP")

def onDlg_032_CameraClimbCrane(char):
	system.set_camera_view(const.CAMVIEW_CLIMBCRANE)

def onDlg_032_FadeOut(char):
	system.fade(FADE_OUT, Lambda('enemy_script.delay(1.0, Lambda("onDlg_032_ContinueAfterFadeToBlack()"))'))
	
def onDlg_032_Ende1():
	end_cutscene(chars=["ANDREW", "ALTER_EGO"])
	system.set_qb_entry_state(data().QB_004,UNCOMPLETE)
	allow_activity("ANDREW")

def onDlg_032_Ende2():
	system.set_camera_view(const.CAMVIEW_ENTERCRANE_CAGE)
	objects.cancel_commandos("ALTER_EGO")
	objects.cancel_commandos("ANDREW")
	pos = objects.get_full_dummy_position(const.Z7_CRANE,"dmyp_container_open")
	objects.move_to("ALTER_EGO", pos[0]-1.0,pos[1], speed=MT_SLOW)
	onDlg_032_AndrewsClimsCrane()
	objects.move_to_object("ALTER_EGO", const.Z7_CRANE, "dmyp_container_open", callback=["ONEND", onDlg_032_PlayerOpensContainer])
	for pc in system.get_pcs():
		if pc != "ALTER_EGO":
			if objects.get_distance(pc, "ALTER_EGO") <= 20.0:
				objects.move_to(pc, pos[0]-4, pos[1]-2, speed=MT_SLOW, callback=["ONEND", turntoae])

def turntoae(char=None):
	objects.turn_to_object(char, "ALTER_EGO")

def start_sound_crane(object_id):
	system.notify_timer(data().Timer_SoundDelay, 800)

def onDlg_032_PlayerOpensContainer(char):
	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_EINSTEIGEN_HAFENKRANCONTAINER")
	system.notify_timer(data().Timer_Delay, 1500)
	data().delay_count = 1
	
def onDlg_032_AndrewsClimsCrane():
	objects.set_active_state("ANDREW", False)
	start_sound_crane(const.Z7_CRANE)
	"""
	objects.cancel_commandos("ANDREW")
	pos = objects.get_full_dummy_position(const.Z7_CRANE,"dmyp_climb_crane")
	objects.step_to("ANDREW",pos[0]-1.0, pos[1], speed=MT_SLOW)
	objects.move_to_object("ANDREW", const.Z7_CRANE, "dmyp_climb_crane", speed=MT_SLOW)
	character.play_animation("ANDREW","CM_NPC_STEHEN_KLETTERN_HAFENKRAN_START")
	character.play_animation("ANDREW","CM_NPC_STEHEN_KLETTERN_HAFENKRAN_LOOP", callback=["ONEND",Lambda('start_sound_crane(const.Z7_CRANE)')])
	character.play_animation("ANDREW","CM_NPC_STEHEN_KLETTERN_HAFENKRAN_ENDE")
	"""

def onDlg_032_CharsEnterContainer(char):
	pcs = system.get_pcs()
	data().pcs = ['ALTER_EGO']
	objects.cancel_commandos('ALTER_EGO')
	#pae = objects.get_position("ALTER_EGO")
	pae = [491.15,467.85]
	
	for pc in pcs:
		if pc != 'ALTER_EGO':
			data().pcs.append(pc)
			objects.cancel_commandos(pc)
			if objects.get_distance(pc, "ALTER_EGO") > 20.0:
				objects.set_position(pc, pae[0]-7.0, pae[1])
	player_enter_container(data().pcs[0])

def player_enter_container(pc=None):
	pos = data().pcs.index(pc)
	dummy1 = "dmyp_container_path01"
	dummy2 = "dmyp_container_path02"
	dummy3 = "dmyp_container_path03"
	dummy4 = "dmyp_container_path04"
	dummypos1 = objects.get_full_dummy_position(const.Z7_CRANE,dummy1)
	dummypos2 = objects.get_full_dummy_position(const.Z7_CRANE,dummy2)
	dummypos3 = objects.get_full_dummy_position(const.Z7_CRANE,dummy3)
	dummypos4 = objects.get_full_dummy_position(const.Z7_CRANE,dummy4)
	
	if pc != "ALTER_EGO":
		objects.move_to(pc, dummypos1[0],dummypos1[1], speed=MT_SLOW)	
	index = pos +1
	#if not last of group, activate move for next npc
	if index < len(data().pcs):
		next  = data().pcs[index]
		objects.step_to(pc, dummypos2[0],dummypos2[1], speed=MT_SLOW, 
				callback=["ONEND", Lambda('player_enter_container(pc="%s")' %(next))])
	else:
		objects.step_to(pc, dummypos2[0],dummypos2[1], speed=MT_SLOW)
	objects.step_to(pc, dummypos3[0],dummypos3[1], speed=MT_SLOW)
	#middle = ((len(data().pcs)-1)/2)
	#if middle id of group, make fade and continue
	#if (pos < middle):
	if pos < len(data().pcs)-1:
		objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_SLOW)
	else:
		objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_SLOW, callback=["ONEND",on_enter_container_fade])
		
	#else:
	#	if len(data().pcs) == 1:
	#		objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_SLOW, callback=["ONEND",on_enter_container_fade])
	#	else:
	#		objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_SLOW, callback = ["ONEND", Lambda('system.fade(FADE_OUT, on_enter_container_fade)')])

def on_enter_container_fade(char_id=None):
	dummy = "dmyp_container_path08"
	data().counter_players_in_container = 0
	dummypos = objects.get_full_dummy_position(const.Z7_CRANE,dummy)
	for pc in data().pcs:
		objects.cancel_commandos(pc)
		objects.set_position_free(pc, dummypos[0], dummypos[1], 0, grid="landscape")
		onDlg_032_CraneLiftsContainer(pc)

def start_sound_crane_lift(object_id):
	data().counter_sound_delay = 3
	system.notify_timer(data().Timer_SoundDelay, 2500)
	sounds.play_3d_sound_object(sfx_id="crane_lifting_container",object=const.Z7_CRANE,loop=False)

def onDlg_032_CraneLiftsContainer(char=None):
	data().counter_players_in_container += 1
	objects.set_active_state(char, 0)
	if data().counter_players_in_container == len(data().pcs):
		system.set_camera_view(const.CAMVIEW_CRANE_LIFTOFF)
		system.fade(FADE_IN)
		container_sound()
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_EXIT", callback=["ONEND", onDlg_032_CraneBeginsMove])

def onDlg_032_ContinueAfterFadeToBlack_CraneInVesselTown():
	data().counter_sound_delay = 6
	system.notify_timer(data().Timer_SoundDelay, 20000)
	data().delay_count = 2
	system.notify_timer(data().Timer_Delay, 12300)

def onDlg_032_CraneBeginsMove(object_id=None):
	data().counter_players_in_container = 0
	objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_DOWN_TO_VESSELTOWN", callback=["ONEND",onDlg_032_CharsEnterVesselTown])
	start_sound_crane_lift(const.Z7_CRANE)
	data().fade_count = 6
	system.notify_timer(data().Timer_FadeOut, 9000)

def onDlg_032_CharsEnterVesselTown(object_id):
	data().aufenthaltsort = "vesseltown"
	data('rest').legal_rest_areas['zone_7'] = const.REST_VESSELTOUWN
	container_sound_vesseltown()
	objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_VESSELTOWN_OPEN", callback=["ONEND",onDlg_032_ActivationOfChars])
	
def start_sound_crane_stop(object_id = None):
	sounds.stop_sound(id="sound_crane_engine")
	sounds.play_3d_sound_object(sfx_id="crane_engine_off",object=const.Z7_CRANE,loop=False)
	
def onDlg_032_ActivationOfChars(object_id=None):
	pcs = data().pcs
	data().counter_players_in_container = 0
	dummy = "dmyp_container_path08"
	dummypos = objects.get_full_dummy_position(const.Z7_CRANE,dummy)
	for pc in pcs:
		objects.set_active_state(pc, 1)
		#objects.cancel_commandos(pc)
		objects.set_position_free(pc, dummypos[0], dummypos[1], 0, grid="landscape")
	players_leave_container(data().pcs[0])
	
def players_leave_container(pc=None):
	poses = const.POINTS_VESSELTOWN_CONTAINER_EXIT
	pos = data().pcs.index(pc)
	dummy2 = "dmyp_container_path07"
	dummy3 = "dmyp_container_path06"
	dummy4 = "dmyp_container_path05"
	dummypos2 = objects.get_full_dummy_position(const.Z7_CRANE,dummy2)
	dummypos3 = objects.get_full_dummy_position(const.Z7_CRANE,dummy3)
	dummypos4 = objects.get_full_dummy_position(const.Z7_CRANE,dummy4)
	last = len(data().pcs)-1
	if pos == 1 or last == 0:
		system.timed_callback(2000, Lambda('system.set_camera_view(%s)'%(const.CAMVIEW_CRANE_LIFTDOWN_1)))
	index = pos + 1
	#last npc just steps out, others activate step for next npc
	objects.cancel_commandos(pc)
	if index < len(data().pcs):
		next  = data().pcs[index]
		objects.step_to(pc, dummypos2[0],dummypos2[1], speed=MT_SLOW, callback=["ONEND",Lambda('players_leave_container(pc="%s")' %(next))])
	else:
		objects.step_to(pc, dummypos2[0],dummypos2[1], speed=MT_SLOW)
	objects.step_to(pc, dummypos3[0],dummypos3[1], speed=MT_FAST)
	objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_FAST)
	#if last pc gets out, crane stops
	
	if (pos == last):
		objects.move_to(pc, poses[pos][0], poses[pos][1], speed=MT_FAST) #, callback = Lambda('reached_vesseltown_finished_check("move")'))
		enemy_script.delay(2.34, Lambda('start_sound_crane_stop()'))
		system.timed_callback(2000,Lambda('container_sound_vesseltown'))
		system.timed_callback(2000,Lambda('objects.play_animation("%s", "ANIM_CRANE_CONTAINER_VESSELTOWN_EXIT")'%(const.Z7_CRANE)))
	else:
		objects.move_to(pc, poses[pos][0], poses[pos][1], speed=MT_FAST)
	objects.turn_to_direction(pc, DIR_EAST, callback=["ONEND", onDlg_032_CloseContainerAgain])

def onDlg_032_CloseContainerAgain(char):
	#print "reached position",char
	data().counter_players_in_container += 1
	if char == 'ALTER_EGO':
		system.set_camera_view(const.CAMVIEW_CRANE_LIFTDOWN_2)
		initDlg_040_SpielerFaehrtMitKranNachVesselTown()
		system.timed_callback(4000, Lambda('system.set_camera_view(%s)'%(const.CAMVIEW_CRANE_LIFTDOWN_3)))
		system.timed_callback(7000, Lambda('system.set_camera_view(%s)'%(const.CAMVIEW_CRANE_LIFTDOWN_4)))
	if data().counter_players_in_container == len(data().pcs):
		data().counter_players_in_container = 0
		#container_sound_vesseltown()
		#objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_VESSELTOWN_EXIT") #,callback=["ONEND", onDlg_032_TheEnd])
		onDlg_032_TheEnd()

def onDlg_032_TheEnd(object_id=None):
	if data().pc_on_carburator=="ANDREW":
		onDlg_037_039_Ende()
	else:
		#if system.is_cutscene():
		#	end_cutscene(chars=[])
		character.add_experience_party(data().Exp_WegNachVesselTownGefunden)
		if system.get_qb_entry_state(data().QB_004) ==  UNCOMPLETE:
			system.set_qb_entry_state(data().QB_004,COMPLETE)
		if system.get_qb_entry_state(data().QB_002) == UNCOMPLETE:
			system.set_qb_entry_state(data().QB_002,COMPLETE)
		data().andrew_museums_ta_aktiv = True
		objects.set_active_state("ANDREW", 1)
		objects.step_away("ANDREW")
		character.set_main_quest_npc_state("ANDREW", False)
		allow_activity("ANDREW")
		for waypoint in const.WAYPOINTS_ANDREW:
			objects.move_to("ANDREW",waypoint[0],waypoint[1], "landscape",MT_SLOW)
		data().pc_on_carburator = None
		#system.notify_region_entered(data().Region_VesselTown,objectid="ALTER_EGO",permanent=False)
	#print "onDlg_032_TheEnd => reached_vesseltown_finished_check"
	reached_vesseltown_finished_check('move_32')

def reached_vesseltown_finished_check(marker):
	#print "reached_vesseltown_finished_check(marker)", data().reached_vesseltown_finished_check
	data().reached_vesseltown_finished_check += 1
	if data().reached_vesseltown_finished_check > 1:
		system.end_cutscene()
		if marker in ['dialog_32','move_32']:
			system.set_qb_entry_state(data().QB_005, UNCOMPLETE)
			for shadow in data().SCHATTEN_NPCS:
				npc.createFoeCharacter(shadow)

	
#[NM/CS]Dialog 037: Der Spieler bringt Andrew den neuen Vergaser
def initCutscene_037_SpielerBringtAndrewVergaser():
	data().counter_andrew_dialog = 37
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="ANDREW", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="ANDREW", callback=["ONEND", onDlg_037_StartDialog])

def onDlg_037_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_037')
	set_conversation("ALTER_EGO","ANDREW",mode="close")
	dialog.add_text(text='D_037_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_037_039_AndrewWorksOnCarburetor)	
	dialog.start(True, [data().QB_002, data().QB_004])

def onDlg_037_039_ContinueAfterFadeToBlack():
	pa = objects.get_position("ALTER_EGO")
	objects.move_to("ANDREW", pa[0]+1.7,pa[1]-1.3)
	objects.turn_to_object("ALTER_EGO","ANDREW")
	if data().counter_andrew_dialog == 37:
		objects.turn_to_object("ANDREW", "ALTER_EGO", callback=["ONEND",onDlg_037_ContinueDialog])
	elif data().counter_andrew_dialog == 39:
		objects.turn_to_object("ANDREW", "ALTER_EGO", callback=["ONEND",onDlg_039_ContinueDialog])
	else:
		objects.turn_to_object("ANDREW", "ALTER_EGO", callback=["ONEND",onDlg_037_ContinueDialog])

def onDlg_037_ContinueDialog(char_id):
	set_conversation("ALTER_EGO","ANDREW",mode="close")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_037')
	dialog.add_text(text='D_037_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("ANDREW","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_037_T_003', speaker="ANDREW", follower='ENDDIALOG', callback=onDlg_032_Ende2)
	dialog.start(True, [data().QB_002, data().QB_004])

def onDlg_037_039_AndrewWorksOnCarburetor():
	erg = enemy_script.count_party_inventory(area = 35, object_id = "ANDREW", items = [data().qi_vergaser[0], data().qi_vergaser_mba[0]])
	if erg[data().qi_vergaser[0]]:
		objects.transfer_item(enemy_script.get_next_transfer_partner("ANDREW", data().qi_vergaser[0]), data().qi_vergaser[0], "ANDREW")
	elif erg[data().qi_vergaser_mba[0]]:
		objects.transfer_item(enemy_script.get_next_transfer_partner("ANDREW", data().qi_vergaser_mba[0]), data().qi_vergaser_mba[0], "ANDREW")
	objects.cancel_commandos("ANDREW")
	objects.cancel_commandos("ALTER_EGO")
	data().pc_on_carburator = "ANDREW"
	onDlg_032_SkilledPCWorksOnCarburetor()

def onDlg_037_039_Ende():
	#if system.is_cutscene():
	#	end_cutscene("ALTER_EGO")
	if system.get_qb_entry_state(data().QB_004) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_004,COMPLETE)
	if system.get_qb_entry_state(data().QB_002) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_002,COMPLETE)
	character.add_experience_party(data().Exp_MotorschadenBehoben)
	erg = enemy_script.count_party_inventory(area = 15, object_id = "ANDREW", items = [data().qi_vergaser[0],data().qi_vergaser_mba[0]])
	if not objects.count_in_inventory("ANDREW", data().qi_vergaser[0]) and not objects.count_in_inventory("ANDREW", data().qi_vergaser_mba[0]):
		if erg[data().qi_vergaser[0]]:
			objects.transfer_item(enemy_script.get_next_transfer_partner("ANDREW", data().qi_vergaser[0]),data().qi_vergaser[0], "ANDREW")
		elif erg[data().qi_vergaser_mba[0]]:
			objects.transfer_item(enemy_script.get_next_transfer_partner("ANDREW", data().qi_vergaser_mba[0]),data().qi_vergaser_mba[0], "ANDREW")

	objects.set_active_state("ANDREW", 1)
	objects.step_away("ANDREW")
	character.set_main_quest_npc_state("ANDREW", False)
	allow_activity("ANDREW")
	for waypoint in const.WAYPOINTS_ANDREW:
		objects.move_to("ANDREW",waypoint[0],waypoint[1], "landscape",MT_SLOW)
	data().andrew_museums_ta_aktiv = True
	character.add_experience_party(data().Exp_WegNachVesselTownGefunden)
	#system.notify_region_entered(data().Region_VesselTown, objectid="ALTER_EGO", permanent=False)

#[NM]Dialog 038: Der Spieler kommt zu Andrew zurück, bevor er einen Vergaser gefunden hat
def initDlg_038_SpielerKommtOhneVergaserZuAndrew():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_038')
	dialog.add_text(text='D_038_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(False, data().QB_004)

#[NM/CS]Dialog 039: Der Spieler kommt zu Andrew mit zwei Vergasern zurück
def initCutscene_039_SpielerBringtAndrew2Vergaser():
	data().counter_andrew_dialog = 39
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="ANDREW", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="ANDREW", callback=["ONEND", onDlg_039_StartDialog])

def onDlg_039_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_039')
	set_conversation("ALTER_EGO","ANDREW",mode="close")
	dialog.add_text(text='D_039_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_032_AndrewOnCarburator)
	dialog.start(True, [data().QB_002, data().QB_004])
	
def onDlg_039_ContinueDialog(char_id):
	set_conversation("ANDREW","ALTER_EGO",mode="close")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_039')
	dialog.add_text(text='D_039_T_002', speaker="ANDREW", callback=Lambda('set_conversation("ALTER_EGO","ANDREW",mode="close")'))
	dialog.add_text(text='D_039_T_003', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_032_Ende2)
	dialog.start(True, [data().QB_002, data().QB_004])

#[NM/CS]Dialog 052: Der Spieler sucht Fett und Alkohol im Museum
def initCutscene_052_SpielerSuchtFettUndAlkohol():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="ANDREW", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="ANDREW", callback=["ONEND", onDlg_052_StartDialog])

def onDlg_052_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_052')
	set_conversation("ANDREW","ALTER_EGO",mode="close")
	dialog.add_text(text='D_052_T_001', speaker="ANDREW", callback=Lambda('set_conversation("ALTER_EGO","ANDREW",mode="close")'))	
	dialog.add_text(text='D_052_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("ANDREW","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_052_T_003', speaker="ANDREW", follower='ENDDIALOG', callback=Lambda('end_cutscene(chars=["ANDREW", "ALTER_EGO"]); allow_activity("ANDREW")'))	
	dialog.start(False, [data().QB_010, data().QB_011])
	
#[NM/CS]Dialog 062: Der Spieler sucht weder Fett noch Alkohol im Museum
def initCutscene_062_SpielerSuchtWederFettNochAlkohol():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="ANDREW", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="ANDREW", callback=["ONEND", onDlg_062_StartDialog])

def onDlg_062_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_062')
	set_conversation("ANDREW","ALTER_EGO",mode="medium")
	dialog.add_text(text='D_062_T_001', speaker="ANDREW", callback=Lambda('set_conversation("ALTER_EGO","ANDREW",mode="close")'))	
	dialog.add_text(text='D_062_T_002', speaker="ALTER_EGO", callback=Lambda('set_conversation("ANDREW","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_062_T_003', speaker="ANDREW", follower='ENDDIALOG', callback=Lambda('end_cutscene(chars=["ANDREW", "ALTER_EGO"]); allow_activity("ANDREW")'))	
	dialog.start(True)

#[M] Dialog 145: Der Spieler ist sauer auf Andrew
def initDlg_145_SpielerSauerAufAndrew():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_145')
	dialog.add_text(text='D_145_T_001', speaker="ANDREW")	
	dialog.add_text(text='D_145_T_002', speaker="ALTER_EGO")
	dialog.add_text(text='D_145_T_003', speaker="ANDREW", follower='D_145_C_001')
	if object_events.get_speech_skill("ALTER_EGO") >= 80:
		dialog.add_choice(text='D_145_C_001_1', follower='D_145_T_004')
	else:
		dialog.add_choice(text='D_145_C_001_1', follower='D_145_T_005')
	dialog.add_choice(text='D_145_C_001_2', follower='ENDDIALOG', callback=onDlg_145_Ende1)
	dialog.add_text(text='D_145_T_004', speaker="ANDREW", follower='ENDDIALOG', callback=onDlg_145_Ende2)
	dialog.add_text(text='D_145_T_005', speaker="ANDREW", follower='ENDDIALOG', callback=onDlg_145_Ende1)	
	dialog.start(False)

def onDlg_145_Ende1():
	data().andrew_first_approach_after_mq = True
	
def onDlg_145_Ende2():
	data().andrew_first_approach_after_mq = True
	objects.create_item_in_inventory('ANDREW','SET_ALOE_VERA')
	objects.create_item_in_inventory('ANDREW','SET_WOOD_GARLIC')
	objects.create_item_in_inventory('ANDREW','SET_BURNET')
	objects.transfer_item('ANDREW','SET_ALOE_VERA','ALTER_EGO')
	objects.transfer_item('ANDREW','SET_WOOD_GARLIC','ALTER_EGO')
	objects.transfer_item('ANDREW','SET_BURNET','ALTER_EGO')
	
################################################################################################################################
## Dialoge mit Rupert Finntail
################################################################################################################################
#[NM]Dialog 065: Der Spieler trifft Rupert, den Museumsdirektor vor dem MBA (Museum Of Body Art) das erste Mal, bevor er von Andrew den Auftrag bekommen hat
def initDlg_065_SpielerTrifftRupertVorAndrewsAuftrag():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_065')
	dialog.add_text(text='D_065_T_001', speaker="ALTER_EGO")	
	dialog.add_text(text='D_065_T_002', speaker="RUPERT", follower='ENDDIALOG')	
	dialog.start(False)

#[M]Dialog 010: Der Spieler trifft Rupert, den Museumsdirektor vor dem MBA (Museum Of Body Art) das erste Mal, nachdem er von Andrew den Auftrag bekommen hat
def initDlg_010_SpielerTrifftRupertMitAndrewsAuftrag():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_010')
	dialog.add_text(text='D_010_T_001', speaker="ALTER_EGO")	
	dialog.add_text(text='D_010_T_002', speaker="RUPERT", follower='D_010_C_001')	
	dialog.add_choice(text='D_010_C_001_1', follower='D_010_T_003')
	dialog.add_choice(text='D_010_C_001_2', follower='D_010_T_004')
	dialog.add_choice(text='D_010_C_001_3', follower='ENDDIALOG', callback=Lambda('data().d_010_restart_c_001=True'))
	dialog.add_text(text='D_010_T_003', speaker="RUPERT", follower='D_010_T_005')
	dialog.add_text(text='D_010_T_004', speaker="RUPERT", follower='D_010_T_007')	
	dialog.add_text(text='D_010_T_005', speaker="ALTER_EGO")
	dialog.add_text(text='D_010_T_006', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizStart)
	dialog.add_text(text='D_010_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_010_T_008', speaker="RUPERT", follower='D_010_C_002')				
	dialog.add_choice(text='D_010_C_002_1', follower='D_010_T_009')
	dialog.add_choice(text='D_010_C_002_2', follower='ENDDIALOG', callback=onDlg_010_Ende1)
	## Start der Fragen
	dialog.add_text(text='D_010_T_009', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizStart)
	
	if data().d_010_restart_c_001:
		dialog.jump_to('D_010_C_001')
	
	dialog.start(False, data().QB_013)

def onDlg_010_QuizStart():
	data().rupert_zitat_d_aktiv = True
	data().rupert_zitat_e_aktiv = True
	data().rupert_zitat_g_aktiv = True
	data().rupert_richtiges_zitat = 0
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_010')
	dialog.add_text(text='D_010_T_010', speaker="RUPERT", follower='D_010_C_003')
	
	## Frage 1: Wer war der Architekt des MBA?
	dialog.add_choice(text='D_010_C_003_1', follower='D_010_T_011')
	dialog.add_choice(text='D_010_C_003_2', follower='D_010_T_012')
	dialog.add_choice(text='D_010_C_003_3', follower='D_010_T_013')
	dialog.add_choice(text='D_010_C_003_4', follower='D_010_T_011')
	dialog.add_choice(text='D_010_C_003_5', follower='D_010_T_012')
	dialog.add_choice(text='D_010_C_003_6', follower='D_010_T_011')

	dialog.add_text(text='D_010_T_011', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	dialog.add_text(text='D_010_T_012', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	dialog.add_text(text='D_010_T_013', speaker="RUPERT")
	dialog.add_text(text='D_010_T_014', speaker="RUPERT", follower='D_010_C_004')
	
	## Frage 2: Wer war der Erfinder der Body Mummy Art?
	dialog.add_choice(text='D_010_C_004_1', follower='D_010_T_015')
	dialog.add_choice(text='D_010_C_004_2', follower='D_010_T_017')
	dialog.add_choice(text='D_010_C_004_3', follower='D_010_T_016')
	dialog.add_choice(text='D_010_C_004_4', follower='D_010_T_015')
	dialog.add_choice(text='D_010_C_004_5', follower='D_010_T_016')
	dialog.add_choice(text='D_010_C_004_6', follower='D_010_T_015')
	
	dialog.add_text(text='D_010_T_015', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	
	if isMale("ALTER_EGO"):
		dialog.add_text(text='D_010_T_016', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	else:
		dialog.add_text(text='D_010_T_016F', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	
	dialog.add_text(text='D_010_T_017', speaker="RUPERT")
	dialog.add_text(text='D_010_T_018', speaker="RUPERT", follower='D_010_C_005')
	
	## Frage 3: Wann wurde der erste Superstar mumifiziert?
	dialog.add_choice(text='D_010_C_005_1', follower='D_010_T_019')
	dialog.add_choice(text='D_010_C_005_2', follower='D_010_T_020')
	dialog.add_choice(text='D_010_C_005_3', follower='D_010_T_019')
	dialog.add_choice(text='D_010_C_005_4', follower='D_010_T_020')
	dialog.add_choice(text='D_010_C_005_5', follower='D_010_T_019')
	dialog.add_choice(text='D_010_C_005_6', follower='D_010_T_021')
	
	dialog.add_text(text='D_010_T_019', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	dialog.add_text(text='D_010_T_020', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	dialog.add_text(text='D_010_T_021', speaker="RUPERT")
	dialog.add_text(text='D_010_T_022', speaker="RUPERT", follower='D_010_C_006')
	
	## Frage 4: Wer wurde als erste Superstar mumifiziert?
	dialog.add_choice(text='D_010_C_006_1', follower='D_010_T_023')
	dialog.add_choice(text='D_010_C_006_2', follower='D_010_T_024')
	dialog.add_choice(text='D_010_C_006_3', follower='D_010_T_023')
	dialog.add_choice(text='D_010_C_006_4', follower='D_010_T_025')
	dialog.add_choice(text='D_010_C_006_5', follower='D_010_T_023')
	dialog.add_choice(text='D_010_C_006_6', follower='D_010_T_024')

	dialog.add_text(text='D_010_T_023', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	dialog.add_text(text='D_010_T_024', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	dialog.add_text(text='D_010_T_025', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_MultiChoiceFrage5)
	dialog.start(False, data().QB_013)

def onDlg_010_MultiChoiceFrage5():
	data().rupert_richtiges_zitat += 1
	
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_010')
	dialog.add_text(text='D_010_T_026', speaker="RUPERT", follower='D_010_C_007')
	
	## Frage 5: Welche Worte sagte Gene "Angel" Morgan NICHT, als er den Vertrag, als erster Star mumifiziert zu werden, unterschrieb?
	dialog.add_choice(text='D_010_C_007_1', follower='D_010_T_027')
	dialog.add_choice(text='D_010_C_007_2', follower='D_010_T_028')
	dialog.add_choice(text='D_010_C_007_3', follower='D_010_T_027')
	
	if data().rupert_zitat_d_aktiv:
		if (data().rupert_richtiges_zitat < 3):
			dialog.add_choice(text='D_010_C_007_4', follower='D_010_T_029', callback=Lambda('data().rupert_zitat_d_aktiv=False'))
		else:
			dialog.add_choice(text='D_010_C_007_4', follower='D_010_T_031', callback=Lambda('data().rupert_zitat_d_aktiv=False'))
	if data().rupert_zitat_e_aktiv:
		if (data().rupert_richtiges_zitat < 3):	
			dialog.add_choice(text='D_010_C_007_5', follower='D_010_T_029', callback=Lambda('data().rupert_zitat_e_aktiv=False'))
		else:
			dialog.add_choice(text='D_010_C_007_5', follower='D_010_T_031', callback=Lambda('data().rupert_zitat_e_aktiv=False'))
	
	dialog.add_choice(text='D_010_C_007_6', follower='D_010_T_028')
	
	if data().rupert_zitat_g_aktiv:
		if (data().rupert_richtiges_zitat < 3):
			dialog.add_choice(text='D_010_C_007_7', follower='D_010_T_029', callback=Lambda('data().rupert_zitat_g_aktiv=False'))
		else:
			dialog.add_choice(text='D_010_C_007_7', follower='D_010_T_031', callback=Lambda('data().rupert_zitat_g_aktiv=False'))
	
	dialog.add_choice(text='D_010_C_007_8', follower='D_010_T_027')

	dialog.add_text(text='D_010_T_027', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	dialog.add_text(text='D_010_T_028', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	dialog.add_text(text='D_010_T_029', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_MultiChoiceFrage5)
	dialog.add_text(text='D_010_T_031', speaker="RUPERT")
	dialog.add_text(text='D_010_T_032', speaker="RUPERT", follower='D_010_C_008')
	#dialog.start(False)

	## Frage 6: Welches Jahr wurde das Museum eröffnet?
	dialog.add_choice(text='D_010_C_008_1', follower='D_010_T_033')
	dialog.add_choice(text='D_010_C_008_2', follower='D_010_T_034')
	dialog.add_choice(text='D_010_C_008_3', follower='D_010_T_035')
	dialog.add_choice(text='D_010_C_008_4', follower='D_010_T_033')
	dialog.add_choice(text='D_010_C_008_5', follower='D_010_T_034')
	dialog.add_choice(text='D_010_C_008_6', follower='D_010_T_033')
	dialog.add_choice(text='D_010_C_008_7', follower='D_010_T_033')
	dialog.add_choice(text='D_010_C_008_8', follower='D_010_T_034')
	
	dialog.add_text(text='D_010_T_033', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	dialog.add_text(text='D_010_T_034', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizEnde)
	dialog.add_text(text='D_010_T_035', speaker="RUPERT", follower='D_010_T_049')
	dialog.add_text(text='D_010_T_049', speaker="ALTER_EGO")
	dialog.add_text(text='D_010_T_050', speaker="RUPERT")
	dialog.add_text(text='D_010_T_051', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_010_Ende14)
	dialog.start(False, data().QB_013)

def onDlg_010_ReenterQuizSecondChance():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_010')
	dialog.add_text(text='D_010_T_036', speaker="ALTER_EGO")
	dialog.add_text(text='D_010_T_037', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizStart)
	dialog.start(True, data().QB_013)
	
def onDlg_010_ReenterFirstAfterConny():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_010')
	dialog.add_text(text='D_010_T_039', speaker="ALTER_EGO")
	dialog.add_text(text='D_010_T_040', speaker="RUPERT", follower='D_010_C_009')
	
	dialog.add_choice(text='D_010_C_009_1', follower='D_010_T_041')
	dialog.add_choice(text='D_010_C_009_2', follower='D_010_T_042')
	
	dialog.add_text(text='D_010_T_041', speaker="RUPERT", follower='D_010_T_044')
	dialog.add_text(text='D_010_T_042', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_QuizStart)
	dialog.add_text(text='D_010_T_044', speaker="ALTER_EGO")
	dialog.add_text(text='D_010_T_045', speaker="RUPERT")
	dialog.add_text(text='D_010_T_046', speaker="ALTER_EGO")
	dialog.add_text(text='D_010_T_047', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_010_Ende1)
	dialog.start(False, data().QB_013)

def onDlg_010_ReenterNachSturheit():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_010')
	dialog.add_text(text='D_010_T_048', speaker="ALTER_EGO", follower='D_010_T_009')
	dialog.add_text(text='D_010_T_009', speaker="RUPERT", follower='ENDDIALOG',callback=onDlg_010_QuizStart)
	dialog.start(False, data().QB_013)
	
def onDlg_010_Ende1():
	data().rupert_spielerwarschonda = True

def onDlg_010_QuizEnde():
	system.set_qb_entry_state(data().QB_013,UNCOMPLETE)
	data().rupert_restart_d_010_t_036 = True
	data().rupert_spielererfolglos = True
	data().Counter_ruperterfolglos += 1
	if data().Counter_ruperterfolglos == 1:
		initDlg_011_SpielerVerlaesstRupertUnverrichtet()
	elif data().Counter_ruperterfolglos == 2:
		initDlg_012_RupertSchicktSpielerZumZweitenMalWeg()
	elif data().Counter_ruperterfolglos >= 3:
		initCutscene_013_RupertSchicktSpielerZumXtenMalWeg()
	else:
		onDlg_010_Ende1()

def onDlg_010_Ende14():
	system.set_qb_entry_state(data().QB_003, COMPLETE)
	system.set_qb_entry_state(data().QB_013, INACTIVE)
	if data().Counter_ruperterfolglos >= 3:
		data().Exp_CodeRupert=0
		system.set_qb_entry_text(data().QB_003,id_reward="ZONE7_AIM_03_REWARD_0000")
	elif data().Counter_ruperterfolglos == 1:
		data().Exp_CodeRupert-=100
		system.set_qb_entry_text(data().QB_003,id_reward="ZONE7_AIM_03_REWARD_1400")
	elif data().Counter_ruperterfolglos == 2:
		data().Exp_CodeRupert-=200
		system.set_qb_entry_text(data().QB_003,id_reward="ZONE7_AIM_03_REWARD_1300")
	character.add_experience_party(data().Exp_CodeRupert)
	data().rupert_geloest = True
	data().rupert_spielererfolglos = False
	data().rupert_spielererfolgreich = True
	#zone_7.init_lock_state(building='BUILDING_2421', state="unlock")
	data().rupert_museums_ta_aktiv = True

def isMale(id):
	if objects.has_attribute(id,"gender"):
		return objects.get_attribute(id,"gender")=="male"
	else:
		return False

#[NM] Dialog 011: Der Spieler verlässt Rupert, den Museumsdirektor unverrichteter Dinge
def initDlg_011_SpielerVerlaesstRupertUnverrichtet():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_011')
	dialog.add_text(text='D_011_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(False, data().QB_013)

#[NM] Dialog 012: Rupert schickt einen das zweite Mal weg: 
def initDlg_012_RupertSchicktSpielerZumZweitenMalWeg():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_012')
	dialog.add_text(text='D_012_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(False, data().QB_013)
	
#[NM/CS] Dialog 013: Der Spieler wird von Rupert das dritte oder x. Mal weggeschickt.
def initCutscene_013_RupertSchicktSpielerZumXtenMalWeg():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="RUPERT", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="RUPERT", callback=["ONEND", onDlg_013_StartDialog])

def onDlg_013_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_013')
	set_conversation("ALTER_EGO","RUPERT",mode="medium")
	dialog.add_text(text='D_013_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("RUPERT","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_013_T_002', speaker="RUPERT", callback=Lambda('set_conversation("ALTER_EGO","RUPERT",mode="close")'))
	dialog.add_text(text='D_013_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("RUPERT","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_013_T_004', speaker="RUPERT", follower='ENDDIALOG', callback=Lambda('end_cutscene(chars=["RUPERT", "ALTER_EGO"]); allow_activity("RUPERT")'))
	dialog.start(False, data().QB_013)

#[NM] Dialog 014: Der Spieler ist von Rupert genervt
def initDlg_014_SpielerIstVonRupertGenervt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_014')
	if isMale("ALTER_EGO"):
		dialog.add_text(text='D_014_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	else:
		dialog.add_text(text='D_014_T_001F', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(False, data().QB_013)

#[NM/CS]Dialog 021: Der Spieler trifft auf Rupert, nachdem er erfolgreich bei Conny war:
def initCutscene_021_SpielerTrifftRupertNachErfolgBeiConny():
	system.start_cutscene()
	data().rupert_spielerwarschonda = True
	init_cutscene(operator="ALTER_EGO", target="RUPERT", dx=1.3, dy=-1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="RUPERT", callback=["ONEND", onDlg_021_StartDialog])

def onDlg_021_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_021')
	set_conversation("ALTER_EGO","RUPERT",mode="medium")
	dialog.add_text(text='D_021_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("RUPERT","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_021_T_002', speaker="RUPERT", callback=Lambda('set_conversation("ALTER_EGO","RUPERT",mode="close")'))
	dialog.add_text(text='D_021_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("RUPERT","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_021_T_004', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_021_Ende)
	dialog.start()

def onDlg_021_Ende():
	end_cutscene(chars=["RUPERT", "ALTER_EGO"])
	objects.move_to("RUPERT", 264.83, 214.07, grid="ZONE_7_BUILDING_2421_INTERIOR_GRID2", speed=MT_SLOW)
	objects.turn_to_object("RUPERT", "BUILDING_4290", callback=["ONEND", rupert_sitzt_auf_klo])
	#objects.move_to_object("RUPERT", "BUILDING_4290",dummy="dmyp_001", speed=MT_SLOW)
	
	#rupert_sitzt_auf_klo()

def rupert_sitzt_auf_klo(char=None):
	character.play_animation("RUPERT", "CM_NPC_STEHEN_PINKELN")
	character.play_animation("RUPERT", "CM_NPC_STEHEN_PINKELN")
	character.play_animation("RUPERT", "CM_NPC_STEHEN_PINKELN")
	character.play_animation("RUPERT", "CM_NPC_STEHEN_PINKELN")
	character.play_animation("RUPERT", "CM_NPC_STEHEN_PINKELN")
	character.play_animation("RUPERT", "CM_NPC_STEHEN_PINKELN", callback=["ONEND", allow_activity])
	
#[NM]Dialog 022: Der Spieler trifft erneut auf Rupert, nachdem er erfolgreich bei Conny war:
def initDlg_022_SpielerTrifftRupertErneutNachErfolgBeiConny():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_022')
	dialog.add_text(text='D_022_T_001', speaker="RUPERT")
	dialog.add_text(text='D_022_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(False)

#[M]Dialog 053: Der Spieler findet Fett und Alkohol im Museum:
def initDlg_053_SpielerFindetFettUndAlkohol():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_053')
	dialog.add_text(text='D_053_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_053_T_002', speaker="RUPERT", follower='D_053_C_001')
	dialog.add_choice(text='D_053_C_001_1', follower='D_053_T_003')
	dialog.add_choice(text='D_053_C_001_2', follower='D_053_T_004')
	dialog.add_text(text='D_053_T_003', speaker="RUPERT", follower='D_053_T_005')
	dialog.add_text(text='D_053_T_004', speaker="RUPERT")
	dialog.add_text(text='D_053_T_005', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_053_Ende3)
	dialog.start(False, [data().QB_010, data().QB_011, data().QB_014])

def onDlg_053_Ende3():
	system.set_qb_entry_state(data().QB_014,UNCOMPLETE)

#[NM]Dialog 055: Der Spieler findet Ton- und Schriftdokumente im Museum
def initDlg_055_SpielerFindetTonUndSchriftDokumente():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_055')
	dialog.add_text(text='D_055_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_055_T_002', speaker="RUPERT", follower='ENDDIALOG', callback=onDlg_055_Ende)
	dialog.start(True, data().QB_014)

def onDlg_055_Ende():
	system.set_qb_entry_state(data().QB_014,COMPLETE)

#[NM]Dialog 059: Der Spieler findet keine Ton- und Schriftdokumente im Museum
def initDlg_059_SpielerFindetKeineTonUndSchriftDokumente():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_059')
	dialog.add_text(text='D_059_T_001', speaker="RUPERT")
	dialog.add_text(text='D_059_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_014)

#[NM]Dialog 056: Der Spieler findet nicht alle Ton- und Schriftdokumente im Museum
def initDlg_056_SpielerFindetNichtAlleTonUndSchriftDokumente():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_056')
	dialog.add_text(text='D_056_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_056_T_002', speaker="RUPERT", follower='ENDDIALOG')
	dialog.start(True, data().QB_014)

#[NM] Dialog 073: Der Spieler findet nicht alle Ton- und Schriftdokumente im Museum, zweite Ansprache
def initDlg_073_SpielerFindetNichtAlleTonUndSchriftDokumente2():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_073')
	dialog.add_text(text='D_073_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_073_T_002', speaker="RUPERT", follower='ENDDIALOG')
	dialog.start(True, data().QB_014)

#[NM] Dialog 074: Der Spieler findet nicht alle Ton- und Schriftdokumente im Museum, dritte Ansprache
def initDlg_074_SpielerFindetNichtAlleTonUndSchriftDokumente3():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_074')
	dialog.add_text(text='D_074_T_001', speaker="RUPERT", follower='ENDDIALOG')
	dialog.start(True, data().QB_014)
	
################################################################################################################################
## Dialoge mit Conny Finntail
################################################################################################################################

#[NM/CS]Dialog 067: Der Spieler trifft Conny, die Frau des Museumsdirektors, bevor er bei Andrew war
def initCutscene_067_SpielerTrifftConnyVorAndrewsAuftrag():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="CONNY", dx=1.3, dy=+1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="CONNY", callback=["ONEND", onDlg_067_StartDialog])

def onDlg_067_StartDialog(char_id):
	onDlg_067_marker()
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_067')
	set_conversation("ALTER_EGO","CONNY",mode="close")
	dialog.add_text(text='D_067_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("CONNY","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_067_T_002', speaker="CONNY", callback=Lambda('set_conversation("ALTER_EGO","CONNY",mode="close")'))
	dialog.add_text(text='D_067_T_003', speaker="ALTER_EGO", follower='ENDDIALOG',callback=Lambda('end_cutscene(chars=["CONNY", "ALTER_EGO"]); allow_activity("CONNY")'))
	dialog.start(False)

def onDlg_067_marker():
	if not data().player_knows_Conny:
		data().player_knows_Conny = True
		system.add_minimap_marker(370.58, 570.58,"MM_004")# Conny
	
#[M]Dialog 023: Der Spieler trifft Conny, die Frau des Museumsdirektors, nachdem er den Auftrag von Andrew hat:
def initDlg_023_SpielerTrifftConnyMitAndrewsAuftrag():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_023')
	dialog.add_text(text='D_023_T_001', speaker="ALTER_EGO", follower='D_023_T_004')
	dialog.add_text(text='D_023_T_004', speaker="CONNY", follower='D_023_C_001')
	dialog.add_choice(text='D_023_C_001_1', follower='D_023_T_006')
	dialog.add_choice(text='D_023_C_001_2', follower='D_023_T_014')
	dialog.add_choice(text='D_023_C_001_3', follower='D_023_T_005')
	dialog.add_text(text='D_023_T_005', speaker="CONNY", follower='ENDDIALOG', callback=onDlg_023_NoReturn)
	dialog.add_text(text='D_023_T_006', speaker="CONNY")
	dialog.add_text(text='D_023_T_007', speaker="ALTER_EGO")
	dialog.add_text(text='D_023_T_008', speaker="CONNY")
	dialog.add_text(text='D_023_T_009', speaker="ALTER_EGO")
	dialog.add_text(text='D_023_T_010', speaker="CONNY", follower='D_023_C_002')
	dialog.add_choice(text='D_023_C_002_1', follower='D_023_T_011')
	if object_events.get_speech_skill("ALTER_EGO") >= 80:
		dialog.add_choice(text='D_023_C_002_2', follower='D_023_T_012')
	else:
		dialog.add_choice(text='D_023_C_002_2', follower='D_023_T_020')
	dialog.add_text(text='D_023_T_011', speaker="CONNY", follower='ENDDIALOG', callback=onDlg_023_NoReturn)
	dialog.add_text(text='D_023_T_012', speaker="CONNY")	
	dialog.add_text(text='D_023_T_013', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_023_Ende5)
	dialog.add_text(text='D_023_T_014', speaker="CONNY", follower='D_023_C_003')
	dialog.add_choice(text='D_023_C_003_1', follower='D_023_T_016')
	dialog.add_choice(text='D_023_C_003_2', follower='D_023_T_015')
	dialog.add_text(text='D_023_T_015', speaker="CONNY", follower='ENDDIALOG', callback=onDlg_023_NoReturn)
	dialog.add_text(text='D_023_T_016', speaker="CONNY", follower='D_023_C_004')
	dialog.add_choice(text='D_023_C_004_1', follower='D_023_T_017')
	dialog.add_choice(text='D_023_C_004_2', follower='D_023_T_018')
	dialog.add_text(text='D_023_T_017', speaker="CONNY", follower='ENDDIALOG', callback=onDlg_023_NoReturn)
	dialog.add_text(text='D_023_T_018', speaker="CONNY")
	dialog.add_text(text='D_023_T_019', speaker="CONNY", follower='D_023_C_005')	# [BrainRipper]
	dialog.add_choice(text='D_023_C_005_1', follower='ENDDIALOG', callback=onDlg_023_Ende5)
	dialog.add_choice(text='D_023_C_005_2', follower='ENDDIALOG', callback=Lambda('data().d_023_restart_t_019=True'))
	dialog.add_text(text='D_023_T_020', speaker="CONNY", follower='ENDDIALOG', callback=onDlg_023_NoReturn)
	if data().d_023_restart_t_019:
		dialog.jump_to('D_023_T_019')
	dialog.start(False, [data().QB_003, data().QB_012])

def onDlg_023_NoReturn():
	# character.set_approachable_state("CONNY",NOTAPPROACHABLE)
	data().conny_spielererfolglos = True
	data().conny_spielerwarschonda = True
	data().rupert_d_010_start_t_039 = True
	if not data().rupert_spielererfolglos:
		initDlg_024_SpielerVonConnyWeggeschickt()
	else:
		initDlg_025_SpielerVonConnyWeggeschicktWarSchonBeiRupert()

def onDlg_023_Ende5():
	data().conny_spielerwarschonda = True
	system.set_qb_entry_state(data().QB_012,UNCOMPLETE)

#[NM]Dialog 024: Der Spieler ist von der beleidigten Conny weggeschickt worden:
def initDlg_024_SpielerVonConnyWeggeschickt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_024')
	dialog.add_text(text='D_024_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(False, data().QB_003)

#[NM]Dialog 025: Der Spieler war schon einmal bei Rupert und ist von der beleidigten Conny weggeschickt worden:
def initDlg_025_SpielerVonConnyWeggeschicktWarSchonBeiRupert():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_025')
	dialog.add_text(text='D_025_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(False, data().QB_003)

#[NM/CS]Dialog 027: Der Spieler war schon erfolgreich bei Rupert und trifft Conny:
def initCutscene_027_SpielerVonConnyWeggeschicktWarSchonBeiRupert2():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="CONNY", dx=1.3, dy=+1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="CONNY", callback=["ONEND", onDlg_027_StartDialog])

def onDlg_027_StartDialog(char_id):
	onDlg_067_marker()
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_027')
	set_conversation("ALTER_EGO","CONNY",mode="close")
	dialog.add_text(text='D_027_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("CONNY","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_027_T_002', speaker="CONNY", callback=Lambda('set_conversation("ALTER_EGO","CONNY",mode="close")'))
	dialog.add_text(text='D_027_T_003', speaker="ALTER_EGO", follower='ENDDIALOG',callback=Lambda('end_cutscene(chars=["CONNY", "ALTER_EGO"]); allow_activity("CONNY")'))
	dialog.start(False)

#[M] Dialog 028: Der Spieler kehrt zu Conny zurück, nachdem er den Esel noch nicht gefunden hat.
def initDlg_028_SpielerKehrtOhneEselZurueck():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_028')
	dialog.add_choice(text='D_028_C_001_1', follower='D_028_T_001')
	dialog.add_choice(text='D_028_C_001_2', follower='D_028_T_002')
	dialog.add_text(text='D_028_T_001', speaker="CONNY", follower='ENDDIALOG', callback=onDlg_028_Ende1)
	dialog.add_text(text='D_028_T_002', speaker="CONNY")
	dialog.add_text(text='D_028_T_003', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(False, data().QB_012)

#[NM] Dialog 130: Der Spieler hat den Esel getötet
def initDlg_130_SpielerHatEselGetoetet():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_130')
	dialog.add_text(text='D_130_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_130_T_002', speaker="CONNY", follower='ENDDIALOG', callback=Lambda('system.set_qb_entry_state(data().QB_012,IMPOSSIBLE)'))
	dialog.start(True, data().QB_012)
	
def onDlg_028_Ende1():
	system.set_qb_entry_state(data().QB_012,IMPOSSIBLE)
	#character.set_approachable_state("CONNY",NOTAPPROACHABLE)
	data().conny_spielererfolglos = True
	data().rupert_d_010_start_t_039 = True

#[NM] Dialog 031: Der Spieler kehrt zu Conny zurück, nachdem er den Esel gefunden hat.  
def initDlg_031_SpielerKehrtMitEselZurueck():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_031')
	dialog.add_text(text='D_031_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_031_T_002', speaker="CONNY", follower='ENDDIALOG', callback=onDlg_031_QBUpdate)
	dialog.start(False, [data().QB_003, data().QB_012])

def onDlg_031_QBUpdate():
	system.set_qb_entry_state(data().QB_012,INACTIVE)
	system.set_qb_entry_state(data().QB_003,COMPLETE)
	system.set_qb_entry_text(data().QB_003,id_reward="ZONE7_AIM_03_REWARD_1000")
	character.add_experience_party(data().Exp_CodeConny)
	data().conny_spielererfolglos = False
	data().conny_spielererfolgreich = True
	data().conny_geloest = True
	#zone_7.init_lock_state(building='BUILDING_2421', state="unlock")
	data().rupert_museums_ta_aktiv = True
	
#[NM/CS]Dialog 057: Der Spieler schickt Conny zu Emily
def initCutscene_057_SpielerSchicktConnyZuEmily():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="CONNY", dx=1.3, dy=+1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="CONNY", callback=["ONEND", onDlg_057_StartDialog])

def onDlg_057_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_057')
	set_conversation("ALTER_EGO","CONNY",mode="medium")
	dialog.add_text(text='D_057_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("CONNY","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_057_T_002', speaker="CONNY", callback=Lambda('set_conversation("ALTER_EGO","CONNY",mode="close")'))
	dialog.add_text(text='D_057_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("CONNY","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_057_T_004', speaker="CONNY", follower='ENDDIALOG',callback=onDlg_057_ConnyGehtZuCraig)
	dialog.start(False, [data().QB_011, data().QB_012])

def onDlg_057_ConnyGehtZuCraig():
	end_cutscene(chars=["CONNY", "ALTER_EGO"])
	objects.remove_item_from_inventory("ALTER_EGO",data().qi_fett[0])
	if hasItem("ALTER_EGO",data().qi_alkohol[0] ):
		objects.remove_item_from_inventory("ALTER_EGO",data().qi_alkohol[0])
	elif hasItem("ALTER_EGO",data().qi_alkohol[0] ):
		objects.remove_item_from_inventory("ALTER_EGO","SET_TIN_WITH_ALCOHOL")
	#system.set_qb_entry_state(data().QB_010,COMPLETE)
	#system.set_qb_entry_state(data().QB_011,COMPLETE)
	
	system.set_qb_entry_state(data().QB_010,INACTIVE)
	system.set_qb_entry_state(data().QB_011,INACTIVE)
	data().conny_aufwegzuemily = True
	for waypoint in const.WAYPOINTS_CONNY:
		objects.move_to("CONNY",waypoint[0],waypoint[1],"landscape",MT_SLOW)
	x=objects.get_x("CRAIG")-1
	y=objects.get_y("CRAIG")-1
	objects.move_to("CONNY",x,y,"landscape",MT_SLOW)
	objects.turn_to_object("CONNY","CRAIG", callback=["ONEND",onDlg_057_ConnyGehtZuEmily])

def onDlg_057_ConnyGehtZuEmily(id):
	objects.cancel_commandos("CONNY")
	pos = objects.get_position(const.OBJ_STRIPPE)
	objects.set_position(id,pos[0]+5.0,pos[1])
	for waypoint in const.WAYPOINTS_CONNY_EMILY:
		objects.move_to("CONNY",waypoint[0],waypoint[1],"landscape",MT_SLOW)
	objects.move_to_object("CONNY","EMILY")
	objects.turn_to_object("CONNY","EMILY", callback=["ONEND", onDlg_057_ConnyBeiEmily])
	
def onDlg_057_ConnyBeiEmily(char=None):
	data().conny_beiemily = True

#[NM] Dialog 092: Der Spieler plaudert kurz mit Conny
def initDlg_092_SpielerPlaudertMitConny():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_092')
	dialog.add_text(text='D_092_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_092_T_002', speaker="CONNY", follower='ENDDIALOG')
	dialog.start(False)

################################################################################################################################
## Monologe des Spielers
################################################################################################################################

#[NM]Dialog 001: Der Spieler treibt sich vor und in der Stadt herum
def initDlg_001_SpielerBetrittStadt():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_001')
	dialog.add_text(text='D_001_T_001', speaker="ALTER_EGO", follower='ENDDIALOG',callback=onDlg_001_QBUpdate)
	dialog.start(True, data().QB_002)

def onDlg_001_QBUpdate():	
	system.notify_region_entered(data().Region_Kran, partyid="UISPIELER",permanent=False)

#[NM]Dialog 068: Der Spieler findet den Esel, bevor Conny ihn beauftragt hat
def initDlg_068_SpielerFindetEselTeil1():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_068')
	dialog.add_text(text='D_068_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()	

#[NM]Dialog 069: Der Spieler findet den Esel, bevor Conny ihn beauftragt hat – zweite und weitere "Ansprache"
def initDlg_069_SpielerFindetEselTeil2():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_069')
	dialog.add_text(text='D_069_T_001', speaker="ESEL")
	dialog.add_text(text='D_069_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM]Dialog 029: Der Spieler findet den Esel, nachdem Conny ihn beauftragt hat.
def initDlg_029_SpielerFindetEselMitConnyAuftrag():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_029')
	dialog.add_text(text='D_029_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_EselFolgtSpieler)
	dialog.start(True, data().QB_012)

#[NM]Dialog 030: Der Spieler zerrt den Esel, nachdem Conny ihn beauftragt hat.
def initDlg_030_SpielerZerrtEselMitConnyAuftrag():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_030')
	dialog.add_text(text='D_030_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_EselFolgtSpieler)
	dialog.start(True, data().QB_012)

def onDlg_EselFolgtSpieler():
	data().conny_esel_folgt_spieler = True
	system.notify_timer(data().Timer_EselFolgtSpieler,data().Timervalue_EselFolgtSpieler)
		

#[NM] Dialog 071: Nebenquest 2: Der Spieler sucht Fett und Alkohol im Museum
def initDlg_071_SpielerSuchtFettUndAkloholImMuseum():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_071')
	dialog.add_text(text='D_071_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 034: Der Spieler findet einen Vergaser im Museum
def initDlg_034_SpielerFindetVergaserImMuseum():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_034')
	dialog.add_text(text='D_034_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_004)

#[NM] Dialog 035: Der Spieler findet einen Vergaser im Museum, nachdem  er schon den anderen gefunden hat
def initDlg_035_SpielerFindetZweitenVergaserImMuseum():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_035')
	dialog.add_text(text='D_035_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_004)

#[NM]Dialog 064: Der Spieler sieht das Museum, bevor er das erste Mal bei Andrew war: 
def initDlg_064_SpielerSiehtMuseumVorAndrew():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_064')
	dialog.add_text(text='D_064_T_001', speaker="ALTER_EGO")
	dialog.add_text(text='D_064_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM]Dialog 016: Der Spieler findet die MBA-Broschüre nachdem er von Andrew den Auftrag bekommen hat
def initDlg_016_SpielerFindetMBABroschuereMitAndrewsAuftrag():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_016')
	dialog.add_text(text='D_016_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_013)

#[NM]Dialog 017: Falls man auf die Broschüren stößt, nachdem  man beim Direktor war und Fehler gemacht hat:
def initDlg_017_SpielerFindetMBABroschuereNachQuizVersagen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_017')
	dialog.add_text(text='D_017_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_013)

#[NM]Dialog 063: Der Spieler findet die MBA-Broschüre bevor er von Andrew den Auftrag bekommen hat
def initDlg_063_SpielerFindetMBABroschuereOhneAndrewsAuftrag():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_063')
	dialog.add_text(text='D_063_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 002: Der Spieler nähert sich dem Kran
def initDlg_002_SpielerNaehertSichKran():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_002')
	dialog.add_text(text='D_002_T_001', speaker="ALTER_EGO",callback=onDlg_002_QBUpdate)
	dialog.add_text(text='D_002_T_002', speaker="ALTER_EGO", follower='ENDDIALOG',callback=onDlg_002_QBUpdate)
	dialog.start(True, [data().QB_001, data().QB_002])

def onDlg_002_QBUpdate(id):
	if id == 'D_002_T_001':
		system.set_camera_view(const.CAM_VESSELTOWN_LEFT)
	else:
		end_cutscene(chars=[])
		system.set_qb_entry_state(data().QB_001,INACTIVE)
		system.set_qb_entry_state(data().QB_002,UNCOMPLETE)
		character.set_approachable_state("ANDREW", APPROACHABLE)
		data().andrew_visible = True
		finish_activity("ANDREW")
		

#[NM] Dialog 113: Der Spieler untersucht den Kran
def initDlg_113_SpielerUntersuchtKran():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_113')
	dialog.add_text(text='D_113_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 114: Der Spieler untersucht den kaputten Kran
def initDlg_114_SpielerUntersuchtKaputtenKran():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_114')
	dialog.add_text(text='D_114_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM/CS] Dialog 040: Der Spieler fährt im Kran nach Vesseltown
def initDlg_040_SpielerFaehrtMitKranNachVesselTown():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_040')
	dialog.add_text(text='D_040_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_041_Ende)
	dialog.start(True, [data().QB_002, data().QB_005])

#[NM] Dialog 051: Der Spieler sucht nach Fett und Alkohol für Emily:
def initDlg_051_SpielerSuchtFettUndAlkoholFuerEmily():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_051')
	dialog.add_text(text='D_051_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_010, data().QB_011])

#[NM] Dialog 111: Der Spieler will zur Basis der Schatten
def initDlg_111_SpielerWillZurSchattenbasis():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_111')
	dialog.add_text(text='D_111_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_002)

#[NM] Dialog 033: Der Spieler findet einen Vergaser in einer alten Garage
def initDlg_033_SpielerFindetVergaserInGarage(char = 'ALTER_EGO'):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_033')
	dialog.add_text(text='D_033_T_001', speaker=char, follower='ENDDIALOG', callback=onDlg_033_036_GetCarburator)
	dialog.start()

def onDlg_033_036_GetCarburator(id, text, char):
	## Vergaser 1 fuer Andrew - Garage
	objects.create_item_in_inventory(char, data().qi_vergaser[1],data().qi_vergaser[0])
	objects.set_attribute(object=data().qi_vergaser[0], attribute="generic_item", value=False)
	data().andrew_spielerhatvergaser = True

#[NM]Dialog 036: Der Spieler findet einen Vergaser in der Garage, nachdem  er schon den anderen gefunden hat
def initDlg_036_SpielerFindetVergaserInGarageHatSchonAnderen(char = 'ALTER_EGO'):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_036')
	dialog.add_text(text='D_036_T_001', speaker=char, follower='ENDDIALOG', callback=onDlg_033_036_GetCarburator)
	dialog.start()

#[NM] Dialog 076: Der sterbende Schatten beschimpft den Spieler
def initDlg_076_SchattenBeschimpftSpieler(group2):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_076')
	dialog.add_text(text='D_076_T_001', speaker="DYING_SHADOW")
	dialog.add_text(text='D_076_T_002', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('onDlg_076_QBUpdate(%s)'%group2))
	dialog.start(True, data().QB_005)

def onDlg_076_QBUpdate(group2):
	character.change_body_mode('ALTER_EGO', 'STAND')
	letzter_Schatten2_end(group2)
	# end_cutscene(chars=[])
	system.set_qb_entry_state(data().QB_005,COMPLETE)
	character.add_experience_party(data().Exp_SchattenGetoetet)
	## Vesseltown NPCs tauchen wieder auf
	allVesselTownies = []
	for id in const.NPCS_IN_VESSELTOWN:
		allVesselTownies.append(id)
	for id in data().TAGESABLAUF_NPCS:
		allVesselTownies.append(id)

	for id in allVesselTownies:
		character.set_approachable_state("CRAIG", NOTAPPROACHABLE)
		character.set_approachable_state("BRAD", NOTAPPROACHABLE)
		objects.set_active_state(id,1)
		character.set_main_quest_npc_state(char="CRAIG", state=False)
		character.set_main_quest_npc_state(char="BRAD", state=False)
		group = data().NEBENQUEST_NPCS
		if id in data().MAINQUEST_NPCS:
			group = data().MAINQUEST_NPCS
		if id in data().TAGESABLAUF_NPCS:
			group = data().TAGESABLAUF_NPCS
		if (id in ["CRAIG","BRAD"]):
			objects.move_to(id,group[id][0][0],group[id][0][1],"landscape",MT_SLOW,callback=["ONEND",onCraigBradMoveFinished])
		elif (id == "EMILY"):
			objects.move_to(id,group[id][0][0],group[id][0][1],"landscape",MT_SLOW,callback=["ONEND",notifyEmilyTimer])
		else:
			objects.move_to(id,group[id][0][0],group[id][0][1],"landscape",MT_SLOW)
		objects.turn_to_direction(id,group[id][2])

def onCraigBradMoveFinished(id):
	# character.set_approachable_state("CRAIG", APPROACHABLE)
	character.set_approachable_state("BRAD", APPROACHABLE)
	character.set_main_quest_npc_state(char="CRAIG", state=True)
	character.set_main_quest_npc_state(char="BRAD", state=True)
		
	system.notify_region_entered(data().Region_Strippe,objectid="ALTER_EGO",permanent=False)
	
def notifyEmilyTimer(id):
	if not data().emily_timernotified:
		system.notify_timer(data().Timer_EmilyAnprechen,data().Timervalue_EmilyAnprechen)
		data().emily_timernotified = True

#######################################################################################################################################
## Dialoge mit Craig und Brad
#######################################################################################################################################
#[M] Dialog 045: Der Spieler soll einen neuen Eingang nach Vesseltown ermöglichen. 
def initDlg_045_SpielerSollVesseltownEingangErmoeglichen():
	data().ae_weis_von_flughund = True
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_045')
	if not data().craigbrad_restart_d_045_c_001:
		dialog.add_text(text='D_045_T_012', speaker="BRAD")
		dialog.add_text(text='D_045_T_013', speaker="CRAIG")
		dialog.add_text(text='D_045_T_014', speaker="BRAD", follower='D_045_C_001')
	if data().craigbrad_c_001_1_aktiv:
		dialog.add_choice(text='D_045_C_001_1', follower='D_045_T_016')
	dialog.add_choice(text='D_045_C_001_2', follower='D_045_T_017')
	if data().craigbrad_c_001_3_aktiv:
		dialog.add_choice(text='D_045_C_001_3', follower='D_045_T_015')
	dialog.add_text(text='D_045_T_015', speaker="BRAD", follower='ENDDIALOG', callback=onDlg_045_ChoiceUpdate1)
	dialog.add_text(text='D_045_T_016', speaker="BRAD", follower='ENDDIALOG', callback=onDlg_045_ChoiceUpdate2)
	dialog.add_text(text='D_045_T_017', speaker="BRAD")
	dialog.add_text(text='D_045_T_018', speaker="CRAIG")
	dialog.add_text(text='D_045_T_019', speaker="BRAD", follower='D_045_C_002')
	dialog.add_choice(text='D_045_C_002_1', follower='ENDDIALOG', callback=onDlg_045_QBUpdate)
	dialog.add_choice(text='D_045_C_002_2', follower='ENDDIALOG', callback=Lambda('data().d_045_restart_t_020=True'))
	dialog.add_text(text='D_045_T_020', speaker="BRAD", follower='D_045_C_001')
	if data().d_045_restart_t_020:
		dialog.jump_to('D_045_T_020')
	dialog.start(False, data().QB_006)

def onDlg_045_QBUpdate():
	system.set_qb_entry_state(data().QB_006, UNCOMPLETE)
	#craig und brad gehen zum flughund
	for wp in const.WAYPOINTS_CRAIG_BRAD_FLUGHUND:
		objects.move_to("CRAIG", wp[0],wp[1], speed=MT_SLOW)
		objects.move_to("BRAD", wp[0],wp[1], speed=MT_SLOW)
		if wp == const.WAYPOINTS_CRAIG_BRAD_FLUGHUND[-1]:
			objects.move_to("CRAIG", 610.5, 421.91, "landscape", MT_SLOW)
			objects.move_to("BRAD", 609.35, 419.52, "landscape", MT_SLOW)
			objects.turn_to_object("CRAIG", data().qi_flughund_done[0])
			objects.turn_to_object("BRAD", data().qi_flughund_done[0])
			character.set_approachable_state("CRAIG", APPROACHABLE)

def onDlg_045_ChoiceUpdate1():
	data().craigbrad_c_001_3_aktiv = False
	data().craigbrad_restart_d_045_c_001 = True
	initDlg_045_SpielerSollVesseltownEingangErmoeglichen()
 	
def onDlg_045_ChoiceUpdate2():
	data().craigbrad_c_001_1_aktiv = False
	data().craigbrad_restart_d_045_c_001 = True
	initDlg_045_SpielerSollVesseltownEingangErmoeglichen()
 
#[NM] Dialog 049: Der Spieler hat noch nichts gefunden und kehrt zu den Bewohnern zurück.
def initDlg_049_SpielerOhneFundZuBewohnernZurueck():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_049')
	dialog.add_text(text='D_049_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_006)

#[NM/CS] Dialog 083: Der Spieler gibt Windschutzscheibe und Rotorblatt ab
def initCutscene_083_SpielerGibtWindschutzscheibeUndRotoblattAb():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="BRAD", dx=1.5, dy=+1.3)
	objects.turn_to_object(object="ALTER_EGO", target_object="BRAD", callback=["ONEND", onDlg_083_StartDialog])

def onDlg_083_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_083')
	set_conversation("BRAD","ALTER_EGO",mode="medium")
	dialog.add_text(text='D_083_T_001', speaker="BRAD", callback=Lambda('set_conversation("CRAIG","ALTER_EGO",mode="medium")'))
	
	if system.get_language() not in ["Russian","French","Polish","Czech","Hungarian","Spanish"]:
		if objects.get_attribute('ALTER_EGO', 'gender') == 'male':
			dialog.add_text(text='D_083_T_002', speaker="CRAIG", callback=Lambda('set_conversation("ALTER_EGO","BRAD",mode="close")'))
		else:
			dialog.add_text(text='D_083_T_002F', speaker="CRAIG", callback=Lambda('set_conversation("ALTER_EGO","BRAD",mode="close")'))
	else:
		dialog.add_text(text='D_083_T_002', speaker="CRAIG", callback=Lambda('set_conversation("ALTER_EGO","BRAD",mode="close")'))
	dialog.add_text(text='D_083_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("BRAD","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_083_T_004', speaker="BRAD", follower='ENDDIALOG', callback=onDlg_083_QBUpdate)
	dialog.start(True, [data().QB_006, data().QB_007])

def onDlg_083_QBUpdate():
	end_cutscene(chars=["CRAIG", "BRAD", "ALTER_EGO"])
	allow_activity("CRAIG")
	allow_activity("BRAD")
	system.set_qb_entry_state(data().QB_006, INACTIVE)
	system.set_qb_entry_state(data().QB_007, UNCOMPLETE)
	data().craigbrad_craigarbeitetanflughund = True
	finish_activity("CRAIG")
	objects.set_attribute("CRAIG", "strength", 20)
	objects.set_attribute("CRAIG", "agility", 20)
	character.set_approachable_state("CRAIG", APPROACHABLE)
	system.notify_timer(data().Timer_FlughundFertigstellung,data().Timervalue_FlughundFertigstellung)

#[NM] Dialog 119: Der Spieler wartet auf den fertigen Flughund
def initDlg_119_SpielerWartetAufFlughund():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_119')
	dialog.add_text(text='D_119_T_001', speaker="BRAD", follower='ENDDIALOG')
	dialog.start(True, data().QB_007)

#[NM/CS]Dialog 050: Der Flughund ist fertig und der Spieler fliegt los.
def initCutscene_050_SpielerFliegtMitFlughundLos():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="BRAD", dx=1.5, dy=+1.3)
	objects.turn_to_object(object="ALTER_EGO", target_object="BRAD", callback=["ONEND", onDlg_050_StartDialog])

def onDlg_050_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_050')
	set_conversation("BRAD","ALTER_EGO",mode="medium")
	dialog.add_text(text='D_050_T_001', speaker="BRAD", callback=Lambda('set_conversation("CRAIG","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_050_T_002', speaker="CRAIG", callback=Lambda('set_conversation("ALTER_EGO","BRAD",mode="close")'))
	dialog.add_text(text='D_050_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("BRAD","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_050_T_004', speaker="BRAD", follower='ENDDIALOG', callback=onDlg_050_NextScene)
	dialog.start(True, data().QB_007)

def onDlg_050_NextScene():
	if not system.is_cutscene():
		system.start_cutscene()
	flughund_sequence_start()
	objects.cancel_commandos("CRAIG")
	objects.cancel_commandos("BRAD")

# these function start fade in and out for sequence start
def flughund_sequence_start(param=None):
	system.fade(FADE_OUT, flughund_sequence_start_continue)

def flughund_sequence_start_continue(param=None):
	data().scale_fac = objects.get_scale('ALTER_EGO')
	if objects.get_attribute('ALTER_EGO', 'gender') == 'male':
		objects.set_scale('ALTER_EGO', 1.0)
	elif objects.get_attribute('ALTER_EGO', 'gender') == 'female':
		objects.set_scale('ALTER_EGO', 1.054)
	objects.set_active_state(data().qi_flughund_done[0],0)
	objects.set_active_state(data().qi_flughund_start[0],1)
	system.set_camera_view(const.CAMVIEW_FLUGHUND_GETIN)
	system.fade(FADE_IN,flughund_start)

# functions for start of fh
def flughund_start():
	data().flughund_flug = True
	objects.cancel_commandos("ALTER_EGO")
	x,y,z = objects.get_full_dummy_position(data().qi_flughund_start[0],"dmyp_001")
	objects.set_position_free("ALTER_EGO",x-3,y+2,z)
	#system.create_object("RES3D_VEGET_PLANT_01",x,y,"muuh")
	objects.step_to("ALTER_EGO", x-1.0,y, speed=MT_SLOW)
	objects.move_to_object("ALTER_EGO", data().qi_flughund_start[0], "dmyp_001")
	character.play_animation("ALTER_EGO", 'CM_STEHEN_FLUGHUND_BENUTZEN_START', callback=["ONSTART", flughund_start_2])
	character.play_animation("ALTER_EGO", 'CM_STEHEN_FLUGHUND_BENUTZEN_START_BACKFLIP', callback=["ONEND",flughund_crash])

def flughund_start_2(param=None):
	data().saved_speedfactor = objects.get_attribute("ALTER_EGO", "speed_factor")
	objects.set_attribute("ALTER_EGO", "speed_factor", 1.0)
	sounds.play_3d_sound_object(sfx_id="gyrocopter_start", object=data().qi_flughund_start[0])
	objects.play_animation(data().qi_flughund_start[0], 'ANIM_FLUGHUND_START')
	enemy_script.delay(6.0, Lambda('system.set_camera_view(const.CAMVIEW_FLUGHUND_ACCELERATE)'))
	enemy_script.delay(9.0, Lambda('system.set_camera_view(const.CAMVIEW_FLUGHUND_LIFTOFF)'))
	#enemy_script.delay(12.95, Lambda('flughund_crash()'))

# functions for crash of fh
def flughund_crash(param=None):
	objects.set_active_state(data().qi_flughund_crash[0],1)
	x,y,z = objects.get_full_dummy_position(data().qi_flughund_crash[0], "dmyp_002")
	#objects.cancel_commandos("ALTER_EGO")
	objects.set_position_free("ALTER_EGO",x,y,z)
	#objects.set_direction("ALTER_EGO", objects.get_direction( data().qi_flughund_crash[0] ) )
	objects.set_direction_free("ALTER_EGO", objects.get_direction( data().qi_flughund_crash[0] ) )
	#objects.set_direction("ALTER_EGO", 155)
	#objects.set_direction_free("ALTER_EGO", 155)
	enemy_script.delay(0.01, Lambda('system.set_camera_view(const.CAMVIEW_FLUGHUND_INCOMING)'))
	character.play_animation("ALTER_EGO", 'CM_STEHEN_FLUGHUND_BENUTZEN_ABSTURZ', callback=["ONSTART", flughund_crash_2])
	character.play_animation("ALTER_EGO", 'CM_STEHEN_FLUGHUND_BENUTZEN_ABSTURZ_BACKFLIP')
	character.play_animation("ALTER_EGO", 'CM_NPC_STEHEN_WARTEN_5')
	
def flughund_crash_2(param=None):
	sounds.play_3d_sound_object(sfx_id="gyrocopter_crash", object=data().qi_flughund_crash[0])
	objects.play_animation(data().qi_flughund_crash[0], 'ANIM_FLUGHUND_ABSTURZ')
	enemy_script.delay(4.0, Lambda('system.set_camera_view(const.CAMVIEW_FLUGHUND_CRASHED)'))
	enemy_script.delay(8.0, Lambda('system.fade(FADE_OUT)'))
	enemy_script.delay(11.0, Lambda('flughund_sequence_end()'))

# these function start fade in and out for sequence start
def flughund_sequence_end(param=None):
	objects.set_active_state(data().qi_flughund_start[0],0)
	system.set_camera_view(const.CAMVIEW_CARBURATOR_FOR_ANDREW)
	data().flughund_flug = False
	data().flughund_endcutscene = True
	objects.set_scale('ALTER_EGO', data().scale_fac)
	data().scale_fac = 1.0
	objects.set_attribute("ALTER_EGO", "speed_factor", data().saved_speedfactor)
	flughund_sequence_end_continue()

def flughund_sequence_end_continue(param=None):
	data().aufenthaltsort = "seaport"
	data('rest').legal_rest_areas['zone_7'] = const.REST_NONE_VESSELTOUWN
	objects.cancel_commandos("ALTER_EGO")
	objects.set_position_free("ALTER_EGO", 492.63, 458.03, 0)
	system.fade(FADE_IN)
	objects.move_to("ALTER_EGO",494.04, 487.66, grid="landscape", speed=MT_FAST)
	objects.move_to_object("ALTER_EGO",const.Z7_CRANE,"dmyp_climb_crane")
	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_KLETTERN_HAFENKRAN_START")
	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_KLETTERN_HAFENKRAN_LOOP", callback=["ONEND", char_reaches_crane])
	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_KLETTERN_HAFENKRAN_ENDE")

## sequenz:spieler am kran
def char_reaches_crane(param=None):
	system.fade(FADE_OUT,char_starts_crane)

def char_starts_crane(param=None):
	data().pcs = []
	data().pcs.append("CRAIG")
	data().pcs.append("BRAD")
	character.set_main_quest_npc_state(char="BRAD", state=False)
	for pc in system.get_pcs():
		if pc != "ALTER_EGO":
			data().pcs.append(pc)
	if data().anie_folgt:
		if "ANIE" in system.get_npcs():
			if objects.is_active("ANIE"):
				data().pcs.append("ANIE")
				objects.cancel_commandos("ANIE")
				data().anie_folgt = False
	data().crane_location = "vesseltown"
	data().craigbrad_flughund_zerstoert=True
	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_RUNTERKLETTERN_HAFENKRAN_START", callback=["ONEND",on_container_arrive_short_fade_in])
	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_RUNTERKLETTERN_HAFENKRAN_LOOP")
	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_RUNTERKLETTERN_HAFENKRAN_ENDE", callback=["ONEND", char_done_cranedown])

def char_done_cranedown(param=None):
	pos = objects.get_full_dummy_position(const.Z7_CRANE,"dmyp_climb_crane")
	objects.step_to("ALTER_EGO",pos[0]-1.0, pos[1])
	objects.move_to("ALTER_EGO",487.57, 463.05, grid="landscape",speed=MT_FAST)
	objects.turn_to_object("ALTER_EGO", "BRAD", callback=["ONEND", check_start_dlg_084])

#[NM/CS] Dialog 084: Brad und Craig kommen mit dem Kran nach oben
def initCutscene_084_BradUndCraigKommenMitKranHoch():
	if not system.is_cutscene():
		system.start_cutscene()
	objects.move_to("CRAIG",489.56, 461.47, grid="landscape",speed=MT_SLOW)
	objects.move_to("BRAD",489.91, 463.27, grid="landscape",speed=MT_SLOW)
	#enemy_script.delay(2.0, Lambda('
	system.set_camera_view(const.CAMVIEW_CRAIG_BRAD_COME)#'))
	objects.turn_to_object("CRAIG", "ALTER_EGO", callback=["ONEND", check_start_dlg_084])
	objects.turn_to_object("BRAD", "ALTER_EGO", callback=["ONEND", check_start_dlg_084])

def check_start_dlg_084(char=None):
	if not hasattr(data(), "counter_dialog_start_cbae"):
		data().counter_dialog_start_cbae = 0
	data().counter_dialog_start_cbae += 1
	if data().counter_dialog_start_cbae == 3:
		data().counter_dialog_start_cbae = 0
		onDlg_084_StartDialog()

def onDlg_084_StartDialog(char=None):
	#set_conversation("BRAD","ALTER_EGO",mode="medium_deep")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_084')
	dialog.add_text(text='D_084_T_001', speaker="BRAD", callback=Lambda('set_conversation("CRAIG","ALTER_EGO",mode="medium_deep")'))
	dialog.add_text(text='D_084_T_002', speaker="CRAIG", callback=Lambda('set_conversation("ALTER_EGO", "CRAIG",mode="close_deep")'))
	dialog.add_text(text='D_084_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("BRAD","ALTER_EGO",mode="close_deep")'))
	dialog.add_text(text='D_084_T_004', speaker="BRAD", follower='ENDDIALOG', callback=onDlg_084_Ende)
	dialog.start(True, [data().QB_006, data().QB_007])

def onDlg_084_Ende():
	end_cutscene(chars=["CRAIG", "BRAD", "ALTER_EGO"])
	data().flughund_endcutscene = False
	allow_activity("CRAIG")
	allow_activity("BRAD")
	system.set_qb_entry_state(data().QB_006, COMPLETE)
	system.set_qb_entry_state(data().QB_007, INACTIVE)
	character.add_experience_party(data().Exp_AusgangVesselTownGefunden)
	data().craigbrad_ta_aktiv = True
	data().flughund_flug = False
#jan: die folgenden zeilen hat thomas mal eingefügt, kann sich aber an den genauen grund nicht erinnern. zu diesem zeitpunkt ist das aber ev. falsch, da anie einem hier noch lange nicht folgen muss
#	objects.set_attribute("ANIE","zone_transfer",True)
#	objects.set_attribute("ANIE","zone_transfer_new_party","NPCS")
#	data().anie_folgt = True
	system.notify_region_entered(data().Region_VerlasseneHafenstadt,objectid="ALTER_EGO",permanent=False)

#[NM/CS] Dialog 085: Der Spieler wird nach unten gelassen
def initCutscene_085_SpielerWirdNachUntenGelassen():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="CRAIG", dx=1.5, dy=+1.3)
	objects.turn_to_object(object="ALTER_EGO", target_object="CRAIG", callback=["ONEND", onDlg_085_StartDialog])

def onDlg_085_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_085')
	set_conversation("ALTER_EGO","CRAIG",mode="medium")
	dialog.add_text(text='D_085_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("CRAIG","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_085_T_002', speaker="CRAIG", follower='ENDDIALOG', callback=onDlg_085_Ende)
	dialog.start()

def onDlg_085_Ende():
	end_cutscene(chars=["CRAIG", "ALTER_EGO"])
	data().crane_location = "abandoned_seaport"
	crane_sequence_starts()
	allow_activity("CRAIG")

#######################################################################################################################################
## Dialoge mit Emily und Family
#######################################################################################################################################

#[M]Dialog 042: Nebenquest 2 Der Spieler soll einer Kleinfamilie helfen
def initDlg_042_SpielerSollKleinFamileHelfen():
	dialog.init_dialog(type=DIALOGLARGE)
	dialog.set_dialog_identifier('DH_042')
	dialog.add_text(text='D_042_T_001', speaker="EMILY", follower='D_042_C_001')
	dialog.add_choice(text='D_042_C_001_1', follower='D_042_T_002')
	dialog.add_choice(text='D_042_C_001_2', follower='ENDDIALOG', callback=onDlg_042_RestartText5)
	dialog.add_text(text='D_042_T_002', speaker="EMILY", follower='D_042_C_002')
	dialog.add_choice(text='D_042_C_002_1', follower='D_042_T_003')
	dialog.add_choice(text='D_042_C_002_2', follower='ENDDIALOG', callback=onDlg_042_RestartText5)
	dialog.add_text(text='D_042_T_003', speaker="EMILY", follower='D_042_C_003')
	dialog.add_choice(text='D_042_C_003_1', follower='D_042_T_004')
	dialog.add_choice(text='D_042_C_003_3', follower='ENDDIALOG', callback=onDlg_042_RestartText5)
	dialog.add_text(text='D_042_T_004', speaker="EMILY", follower='ENDDIALOG', callback=onDlg_042_Ende4)
	dialog.add_text(text='D_042_T_005', speaker="ALTER_EGO", follower='D_042_T_003')
	if data().d_042_restart_t_005:
		dialog.jump_to('D_042_T_005')
	dialog.start(False, data().QB_008)

def onDlg_042_RestartText5():
	allow_activity("EMILY")
	data().d_042_restart_t_005 = True

def onDlg_042_Ende4():
	system.set_qb_entry_state(data().QB_008,UNCOMPLETE)
	system.notify_region_entered(data().Region_MaschinenRaum,objectid="ALTER_EGO",permanent=False)
	## Seans Notizen
	system.create_object(data().qi_seansnotizena[1],653.0,460.0,data().qi_seansnotizena[0],direction=DIR_SOUTH_WEST)
	objects.set_attribute(object=data().qi_seansnotizena[0], attribute="generic_item", value=False)
	system.create_object(data().qi_seansnotizenb[1],650.0,461.5,data().qi_seansnotizenb[0],direction=DIR_NORTH)
	objects.set_attribute(object=data().qi_seansnotizenb[0], attribute="generic_item", value=False)
	allow_activity("EMILY")

#[NM/CS]Dialog 043: Der Spieler kann Emily über Seans Erfindung berichten
def initCutscene_043_SpielerKannEmilyVonSeansErfindungBerichten():
	character.unequip_hands("EMILY",False)
	system.start_cutscene()
	prohibit_activity("HARRY")
	prohibit_activity("LARRY")
	init_cutscene(operator="ALTER_EGO", target="EMILY", dx=-1.3, dy=+1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="EMILY", callback=["ONEND", onDlg_043_StartDialog])

def onDlg_043_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_043')
	set_conversation("EMILY","ALTER_EGO",mode="medium")
	dialog.add_text(text='D_043_T_001', speaker="EMILY", callback=Lambda('set_conversation("ALTER_EGO","EMILY",mode="medium")'))
	dialog.add_text(text='D_043_T_002', speaker="ALTER_EGO", follower='D_043_T_022', callback=Lambda('set_conversation("EMILY","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_043_T_022', speaker="EMILY", follower='D_043_T_021', callback=Lambda('set_conversation("ALTER_EGO","EMILY",mode="medium")'))
	dialog.add_text(text='D_043_T_021', speaker="ALTER_EGO", follower='D_043_T_003', callback=Lambda('set_conversation("EMILY","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_043_T_003', speaker="EMILY", callback=Lambda('set_conversation("ALTER_EGO","EMILY",mode="medium")'))
	dialog.add_text(text='D_043_T_004', speaker="ALTER_EGO", callback=Lambda('set_conversation("HARRY","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_043_T_005', speaker="HARRY", follower='D_043_T_015', callback=Lambda('set_conversation("EMILY","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_043_T_015', speaker="EMILY", follower='D_043_T_016', callback=Lambda('set_conversation("ALTER_EGO","EMILY",mode="close")'))
	
	data().pc_on_plants = onDlg_043_CheckSkills()
	if data().pc_on_plants == None:
		dialog.add_text(text='D_043_T_016', speaker="ALTER_EGO", follower='D_043_T_018', callback=Lambda('set_conversation("ALTER_EGO","EMILY",mode="medium_deep")'))
	elif data().pc_on_plants == "ALTER_EGO":
		dialog.add_text(text='D_043_T_016', speaker="ALTER_EGO", follower='D_043_T_017', callback=Lambda('set_conversation("ALTER_EGO","EMILY",mode="medium_deep")'))
	else:
		objects.cancel_commandos("ALTER_EGO")
		objects.turn_to_object("ALTER_EGO", data().pc_on_plants)
		dialog.add_text(text='D_043_T_016', speaker="ALTER_EGO", follower='D_043_T_019', callback=Lambda('set_conversation("ALTER_EGO","EMILY",mode="medium_deep")'))
	
	dialog.add_text(text='D_043_T_017', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_043_Ende1)
	dialog.add_text(text='D_043_T_018', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_043_Ende2)
	dialog.add_text(text='D_043_T_019', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_043_PflanzenUntersuchung)
	dialog.start(False, [data().QB_008, data().QB_009, data().QB_010, data().QB_011])

def onDlg_043_PflanzenUntersuchung():
	system.fade(FADE_OUT)
	data().fade_count = "emily_plant_explore"
	system.notify_timer(data().Timer_Fade, data().Timervalue_Fade)

def onDlg_043_ContinueAfterFade_InspectPlants():
	plant = random.choice(const.OBJECTS_TA_EMILY)
	pos = objects.get_position(plant)
	objects.set_position(data().pc_on_plants,pos[0]-1, pos[1]-1)
	system.set_camera_view(const.CAMVIEW_PLANT_WORKER)
	objects.turn_to_object(data().pc_on_plants, plant, callback=["ONEND", start_work_plants])

def start_work_plants(char):
	character.play_animation(data().pc_on_plants, 'CM_NPC_STEHEN_TIER_AUSWEIDEN_START', callback=["ONEND",plant_work_sound])
	character.play_animation(data().pc_on_plants, 'CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP')
	character.play_animation(data().pc_on_plants, 'CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE', callback=["ONEND", end_work_plants])

def end_work_plants(char):
	system.fade(FADE_OUT)
	data().fade_count = "plant_explore_done"
	system.notify_timer(data().Timer_Fade, data().Timervalue_Fade)

def plant_work_sound(char):
	import anidata.events
	anidata.events.sound_fissling_plants(data().pc_on_plants,0,0)
	
def onDlg_043_ContinueAfterFade_PlantsInspected():
	set_conversation("ALTER_EGO", "EMILY", mode="medium_deep")
	pos = objects.get_position("ALTER_EGO")
	objects.set_position(data().pc_on_plants,pos[0]-1, pos[1]-2)
	objects.turn_to_object(data().pc_on_plants, "ALTER_EGO", callback=["ONEND", onDlg_043_TheEnd])

def onDlg_043_TheEnd(char):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_043')
	dialog.add_text(text='D_043_T_020', speaker=data().pc_on_plants, follower='ENDDIALOG', callback=onDlg_043_Ende2)
	dialog.start(True, [data().QB_008, data().QB_009, data().QB_010, data().QB_011])

def onDlg_043_CheckSkills():
	highest = [None, 0]
	current = 0
	pcs = system.get_pcs()
	for pc in pcs:
		if (objects.has_attribute(pc,"survival")):
			current = objects.get_attribute(pc,"survival")
			if current >= 80 and pc == 'ALTER_EGO':
				return 'ALTER_EGO'
			if current > highest[1]:
				highest[1] = current
				highest[0] = pc
				#if pc == "ALTER_EGO":
				#	return highest[0]
	if highest[1] < 80:
		if data().emily_seansnotizbgelesen:
			highest[0] = 'ALTER_EGO'
		else:
			highest[0] = None
			system.set_qb_entry_state(data().QB_009, UNCOMPLETE)
			
	return highest[0]

def onDlg_043_Ende1():
	end_cutscene(chars=["EMILY", "HARRY", "LARRY", "ALTER_EGO"])
	allow_activity("EMILY")
	allow_activity("HARRY")
	allow_activity("LARRY")
	system.set_qb_entry_state(data().QB_010, UNCOMPLETE)
	system.set_qb_entry_state(data().QB_011, UNCOMPLETE)
	system.set_qb_entry_state(data().QB_008, INACTIVE)
	
def onDlg_043_Ende2():
	end_cutscene(chars=["EMILY", "HARRY", "LARRY", "ALTER_EGO"])
	allow_activity("EMILY")
	allow_activity("HARRY")
	allow_activity("LARRY")
	system.set_qb_entry_state(data().QB_010, UNCOMPLETE)
	system.set_qb_entry_state(data().QB_011, UNCOMPLETE)
	system.set_qb_entry_state(data().QB_008, INACTIVE)

#[NM/CS] Dialog 091: Der Spieler sucht nach Alkohol
def initCutscene_091_SpielerSuchtAlkohol():
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="EMILY", dx=-1.3, dy=+1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="EMILY", callback=["ONEND", onDlg_091_StartDialog])
	
def onDlg_091_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_091')
	set_conversation("EMILY","ALTER_EGO",mode="medium")
	dialog.add_text(text='D_091_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("EMILY","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_091_T_002', speaker="EMILY", follower='ENDDIALOG',callback=Lambda('end_cutscene(chars=["EMILY", "ALTER_EGO"]); allow_activity("EMILY")'))
	dialog.start(True, [data().QB_008, data().QB_011])

#[NM/CS]Dialog 058: Der Spieler bringt die Sachen zu Emily: 
def initCutscene_058_SpielerBringtSachenZuEmily():
	#if system.get_qb_entry_state(data().QB_009) == COMPLETE and haveItem(group,"SEAN_NOTE_B"):
	#	transfer_item(group,"SEAN_NOTE_B", "EMILY")
	character.unequip_hands("EMILY",False)
	prohibit_activity("HARRY")
	prohibit_activity("LARRY")
	system.start_cutscene()
	init_cutscene(operator="ALTER_EGO", target="EMILY", dx=-1.3, dy=+1.5)
	objects.turn_to_object(object="ALTER_EGO", target_object="EMILY", callback=["ONEND", onDlg_058_StartDialog])
	
def onDlg_058_StartDialog(char_id):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_058')
	set_conversation("EMILY","ALTER_EGO",mode="medium")
	dialog.add_text(text='D_058_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("EMILY","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_058_T_002', speaker="EMILY", callback=Lambda('set_conversation("ALTER_EGO","EMILY",mode="medium")'))
	dialog.add_text(text='D_058_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("LARRY","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_058_T_004', speaker="LARRY", callback=Lambda('set_conversation("ALTER_EGO", "LARRY",mode="close")'))
	dialog.add_text(text='D_058_T_005', speaker="ALTER_EGO", follower='ENDDIALOG',callback=onDlg_058_QBUpdate)
	dialog.start(True, [data().QB_009, data().QB_010, data().QB_011, data().QB_016])

def onDlg_058_QBUpdate():
	end_cutscene(chars=["EMILY", "HARRY", "LARRY", "ALTER_EGO"])
	allow_activity("HARRY")
	allow_activity("LARRY")
	#system.set_qb_entry_state(data().QB_009, INACTIVE)
	system.set_qb_entry_state(data().QB_010, INACTIVE)
	system.set_qb_entry_state(data().QB_011, INACTIVE)
	system.set_qb_entry_state(data().QB_016, UNCOMPLETE)
	character.add_experience_party(data().Exp_EmilyGeholfen)
	system.notify_timer(data().Timer_EmilyMachtSonneschutmittelFertig, data().Timervalue_EmilyMachtSonneschutmittelFertig)
	prohibit_activity("EMILY",False)
	objects.step_away("EMILY")
	objects.move_to_object("EMILY", random.choice(const.OBJECTS_TA_EMILY))
	character.play_animation('EMILY', 'CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_START')
	animate_emily_panters()
	
def animate_emily_panters(char=None):
	if not data().emily_sonnenschutmittel_fertig:
		r = random.randint(1,3)
		character.play_animation('EMILY', 'CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_LOOP_%s'%(r), callback=["ONEND",animate_emily_panters])
	else:
		character.play_animation('EMILY', 'CM_NPC_STEHEN_HAFENKRAN_REPARIEREN_ENDE')
		allow_activity("EMILY")

#[NM]Dialog 066: Der Spieler kommt unverrichteter Dinge zu Emily: 
def initDlg_066_SpielerKommtOhneSachenZuEmily():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_066')
	dialog.add_text(text='D_066_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_009, data().QB_010, data().QB_011])

#[NM]Dialog 112: Der Spieler kommt ein zweites Mal unverrichteter Dinge zu Emily: 
def initDlg_112_SpielerKommtOhneSachenZuEmily2():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_112')
	dialog.add_text(text='D_112_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, [data().QB_009, data().QB_010, data().QB_011])

def Dlg_093_Emily_Kein_Tagebuch():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_093')
	dialog.add_text(text='D_093_T_001', speaker="EMILY")
	dialog.add_text(text='D_093_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()
	
#[NM] Dialog 117: Emily bedankt sich bei dem Spieler
def initDlg_117_EmilyBedanktSichBeiSpieler():
	system.start_cutscene()
	init_cutscene("ALTER_EGO", "EMILY", dx=1.4, dy=1.4)
	objects.turn_to_object("ALTER_EGO", "EMILY", callback=["ONEND", onDlg_117_StartDialog])

def onDlg_117_StartDialog(char):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_117')
	dialog.add_text(text='D_117_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("EMILY", "ALTER_EGO", mode="medium_deep")'))
	dialog.add_text(text='D_117_T_002', speaker="EMILY", callback=Lambda('set_conversation("ALTER_EGO", "EMILY", mode="close_deep")'))
	dialog.add_text(text='D_117_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("LARRY", "ALTER_EGO", mode="close_deep")'))
	dialog.add_text(text='D_117_T_004', speaker="LARRY", callback=Lambda('set_conversation("ALTER_EGO", "LARRY", mode="close_deep")'))
	dialog.add_text(text='D_117_T_005', speaker="ALTER_EGO", follower='ENDDIALOG',callback=onDlg_117_Ende)
	dialog.start(True, [data().QB_009, data().QB_010, data().QB_011, data().QB_016])
	
def onDlg_117_Ende():
	end_cutscene(chars=["ALTER_EGO", "LARRY", "EMILY"])
	#system.set_qb_entry_state(data().QB_009, INACTIVE)
	system.set_qb_entry_state(data().QB_010, INACTIVE)
	system.set_qb_entry_state(data().QB_011, INACTIVE)
	system.set_qb_entry_state(data().QB_016, UNCOMPLETE)
	data().conny_aufwegzuemily = False

#[NM]Dialog 118: Emily ist dem Spieler dankbar
def initDlg_118_EmilyIstSpielerDankbar():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_118')
	dialog.add_text(text='D_118_T_001', speaker="EMILY", follower='ENDDIALOG')
	dialog.start(True, data().QB_009)

#[NM]Dialog 041: Der Spieler ist in Vesseltown angekommen
def initDlg_041_SpielerErreichtVesselTown():
	#Dieser Dialog scheint nicht benutzt zu werden!
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_041')
	dialog.add_text(text='D_041_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_041_Ende)
	dialog.start(True, [data().QB_002, data().QB_005])

def onDlg_041_Ende():#callback_check_endcutscene
	#system.set_qb_entry_state(data().QB_005, UNCOMPLETE)
	#for shadow in data().SCHATTEN_NPCS:
	#	npc.createFoeCharacter(shadow)
	#if system.is_cutscene():
	#	system.end_cutscene()
	#print"onDlg_041_Ende => reached_vesseltown_finished_check"
	reached_vesseltown_finished_check('dialog_32')

#[NM]Dialog 075: Der Spieler wundert sich über die Schatten
def initDlg_075_SpielerWundertSichUeberSchatten():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_075')
	dialog.add_text(text='D_075_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_005)

#[NM] Dialog 077: Der Spieler findet die Windschutzscheibe
def initDlg_077_SpielerFindetWindschutzcheibe():
	onDlg_081_077_getWindShield()
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_077')
	dialog.add_text(text='D_077_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	#dialog.add_text(text='D_077_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_081_077_getWindShield)
	dialog.start(True, data().QB_006)

#[NM] Dialog 079: Der Spieler findet die Windschutzscheibe, kann sie aber noch nicht gebrauchen
def initDlg_079_SpielerFindetWindschutzscheibeNochNutzlos():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_079')
	dialog.add_text(text='D_079_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('data().craigbrad_windschutzscheibegefunden=True'))
	dialog.start()

#[NM] Dialog 081: Der Spieler braucht die Windschutzscheibe, nachdem er sie vorher schon mal gefunden hatte
def initDlg_081_SpielerBrauchtWindschutzscheibe():
	onDlg_081_077_getWindShield()
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_081')
	dialog.add_text(text='D_081_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	# dialog.add_text(text='D_081_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_081_077_getWindShield)
	dialog.start(True, data().QB_006)

def onDlg_081_077_getWindShield():
#	objects.create_item_in_inventory("ALTER_EGO",data().qi_windschutzscheibe[1],data().qi_windschutzscheibe[0])
#	objects.set_attribute(object=data().qi_windschutzscheibe[0], attribute="generic_item", value=False)
#	data().craigbrad_spielerhatwindschutzscheibe = True
	if not objects.count_in_inventory("BUILDING_1853",data().qi_windschutzscheibe[0]):
		objects.create_item_in_inventory("BUILDING_1853",data().qi_windschutzscheibe[1],data().qi_windschutzscheibe[0])
	objects.set_attribute(object=data().qi_windschutzscheibe[0], attribute="generic_item", value=False)
	system.item_panel( "ALTER_EGO", "BUILDING_1853",callback_close=on_close_car_inventory )

def on_close_car_inventory(id1,id2):
	#print "on_close_car"
	if objects.count_in_inventory("ALTER_EGO",data().qi_windschutzscheibe[0]) >0:
		data().craigbrad_spielerhatwindschutzscheibe = True
		if enemy_script.count_party_inventory(area = 30, object_id = "ALTER_EGO", party = system.get_pcs(), items = data().qi_rotorblatt[0]):
			initDlg_048_SpielerHatNachAuftragGenugGefunden()

#[NM]Dialog 078: Der Spieler findet das Rotorblatt
def initDlg_078_SpielerFindetRotorblatt():
	system.start_cutscene()
	system.set_camera_view(const.CAMVIEW_HELI_ROTOR_FAR)
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_078')
	dialog.add_text(text='D_078_T_001', speaker="ALTER_EGO", callback=on_inspect_char_approach)
	dialog.add_text(text='D_078_T_002', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_006)

def on_inspect_char_approach():
	character.unequip_hands("ALTER_EGO",direct_unequip=False)
	objects.step_to("ALTER_EGO", 740.23, 295.34, speed=MT_SLOW)
	objects.turn_to_direction("ALTER_EGO", DIR_NORTH_EAST, callback=["ONEND",onDlg_078_082_SpielerNimmtRotorBlatt])
	
def onDlg_078_082_SpielerNimmtRotorBlatt(char=None):
	data().craigbrad_spielerhatrotorblatt = True
	system.set_camera_view(const.CAMVIEW_HELI_ROTOR_BACK)
	character.play_animation("ALTER_EGO", "CM_STEHEN_NACH_OBEN_GREIFEN")
	character.play_animation("ALTER_EGO", "CM_STEHEN_NACH_OBEN_GREIFEN", callback=["ONEND", on_work_fade_out])

def on_work_fade_in(char=None):
	on_work_change_object()
	system.fade(FADE_IN, on_work_ae_move)
	
def on_work_ae_move(param=None):
	objects.step_to("ALTER_EGO", 739.68, 296.07, MT_SLOW)
	character.play_animation("ALTER_EGO", "CM_NPC_STEHEN_WARTEN_4", callback=["ONEND", on_work_finish])

def on_work_finish(char=None):
	system.end_cutscene()
	objects.create_item_in_inventory("ALTER_EGO",data().qi_rotorblatt[1],data().qi_rotorblatt[0])
	objects.set_attribute(object=data().qi_rotorblatt[0], attribute="generic_item", value=False)
	if enemy_script.count_party_inventory(area = 30, object_id = "ALTER_EGO", party = system.get_pcs(), items = data().qi_windschutzscheibe[0]):
		initDlg_048_SpielerHatNachAuftragGenugGefunden()

def on_work_fade_out(char):
	system.fade(FADE_OUT, on_work_fade_in)

def on_work_change_object(char=None):
	objects.set_active_state("HELI_WITH_ROTOR",INACTIVE)
	objects.set_active_state(const.OBJ_HELIKOPTER, ACTIVE)

#NM]Dialog 080: Der Spieler kann mit dem wracken Hubschrauber nichts anfangen
def initDlg_080_SpielerKannMitHubschrauberNixAnfangen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_080')
	dialog.add_text(text='D_080_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=Lambda('data().craigbrad_rotorblattgefunden=True'))
	dialog.start()

#[NM]Dialog 082: Der Spieler kann jetzt doch mit dem wracken Hubschrauber etwas anfangen
def initDlg_082_SpielerBrauchtHubschrauberWrack():
	system.start_cutscene()
	system.set_camera_view([731.371337890625, 304.18325805664062, 9.2067470550537109, 0.37060597538948059, -0.90356290340423584, -0.21500036120414734])
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_082')
	dialog.add_text(text='D_082_T_001', speaker="ALTER_EGO", follower='ENDDIALOG',callback=onDlg_078_082_SpielerNimmtRotorBlatt)
	dialog.start(True, data().QB_006)

#[NM]Dialog 044: Der Spieler sucht in Vesseltown nach den Rohstoffen
def initDlg_044_SpielerSuchtNachRohstoffen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_044')
	dialog.add_text(text='D_044_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_010)

#[NM]Dialog 115: Der Spieler wartet vergeblich
def initDlg_115_SpielerWartetAnStrippe():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_115')
	dialog.add_text(text='D_115_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM]Dialog 116: Der Spieler betätigt die Strippe, während Craig oben wacht
def initDlg_116_SpielerBetaetigtStrippeCraigAmKran():
	data().crane_location = "vesseltown"
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_116')
	dialog.add_text(text='D_116_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=crane_sequence_starts)
	dialog.start()

def crane_sequence_starts():
	system.start_cutscene()
	if data().crane_location == "vesseltown":
		system.set_camera_view(const.CAMVIEW_EXITCRANE_CAGE)
		container_sound_vesseltown()
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_VESSELTOWN_OPEN", callback=["ONEND", crane_player_enter])
	else:
		system.set_camera_view(const.CAMVIEW_ENTERCRANE_CAGE)
		container_sound()
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_OPEN", callback=["ONEND", crane_player_enter])
	
def crane_player_enter(object_id = None):
	data().pcs = []
	data().pcs = system.get_pcs()
	if data().anie_folgt:
		if "ANIE" in system.get_npcs():
			if objects.is_active("ANIE"):
				data().pcs.append("ANIE")
				objects.cancel_commandos("ANIE")
				data().anie_folgt = False
	crane_party_chars_follow()

def crane_party_chars_follow():
	#pae = objects.get_position("ALTER_EGO")
	if data().crane_location == "vesseltown":
		pae = [517.75,481.68]
	else:
		pae = [491.15,467.85]
	for pc in data().pcs:
		objects.cancel_commandos(pc)
		if objects.get_distance(pc, "ALTER_EGO") > 20.0:
			objects.set_position(pc, pae[0]-7.0, pae[1])
	player_enter_container_short(data().pcs[0])

def player_enter_container_short(pc=None):
	pos = data().pcs.index(pc)
	if data().crane_location == "vesseltown":
		dummy1 = "dmyp_container_path05"
		dummy2 = "dmyp_container_path06"
		dummy3 = "dmyp_container_path07"
		dummy4 = "dmyp_container_path08"
	else:
		dummy1 = "dmyp_container_path01"
		dummy2 = "dmyp_container_path02"
		dummy3 = "dmyp_container_path03"
		dummy4 = "dmyp_container_path04"
		
	dummypos1 = objects.get_full_dummy_position(const.Z7_CRANE,dummy1)
	dummypos2 = objects.get_full_dummy_position(const.Z7_CRANE,dummy2)
	dummypos3 = objects.get_full_dummy_position(const.Z7_CRANE,dummy3)
	dummypos4 = objects.get_full_dummy_position(const.Z7_CRANE,dummy4)
	
	objects.move_to(pc, dummypos1[0],dummypos1[1], speed=MT_SLOW)
	index = pos + 1	
	if index < len(data().pcs):
		next  = data().pcs[index]
		objects.step_to(pc, dummypos2[0],dummypos2[1], speed=MT_SLOW, callback=["ONEND", Lambda('player_enter_container_short(pc="%s")' %(next))])
	else:
		objects.step_to(pc, dummypos2[0],dummypos2[1], speed=MT_SLOW)
	objects.step_to(pc, dummypos3[0],dummypos3[1], speed=MT_SLOW)
	#middle = ((len(data().pcs)-1)/2)
	#if (pos < middle):
	#	objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_SLOW)
	#else:
	#	if len(data().pcs) > 1:
	#		objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_SLOW, callback=["ONEND",on_enter_container_short_fade])
	#	else:
	#		objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_SLOW, callback=["ONEND",crane_check_liftoff])
	if pos < len(data().pcs)-1:
		objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_SLOW, callback=["ONEND",Lambda('objects.set_active_state("%s",0)'%(pc))])
	else:
		objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_SLOW, callback=["ONEND",crane_check_liftoff])

		
def on_enter_container_short_fade(char=None):
	system.fade(FADE_OUT, on_enter_container_short_fade_in)

def on_enter_container_short_fade_in(char=None):
	for pc in data().pcs:
		objects.set_active_state(pc, 0)
	system.fade(FADE_IN, crane_check_liftoff)

def crane_check_liftoff(char=None):
	if char != None:
		if isinstance(char, str):
			objects.set_active_state(char, 0)
	if data().crane_location == "vesseltown":
		container_sound_vesseltown()
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_VESSELTOWN_EXIT", callback=["ONEND", Lambda('sounds.play_3d_sound_object(sfx_id="crane_working_steel_cable",object=const.Z7_CRANE,loop=False)')])
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_SHORT_VESSELTOWN_UP", callback=["ONEND", on_container_arrive_short_fade])
	else:
		container_sound()
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_EXIT", callback=["ONEND", Lambda('sounds.play_3d_sound_object(sfx_id="crane_working_steel_cable",object=const.Z7_CRANE,loop=False)')])
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_SHORT_ABANDONED_SEAPORT_UP", callback=["ONEND", on_container_arrive_short_fade])

def on_container_arrive_short_fade(char=None):
	system.fade(FADE_OUT, on_container_arrive_short_fade_in)

def on_container_arrive_short_fade_in(char=None):
	if data().crane_location == "vesseltown":
		system.set_camera_view(const.CAM_ABANDONED_SEAPORT_SHORT_OUT)
	else:
		system.set_camera_view(const.CAMVIEW_EXITCRANE_CAGE)
	system.fade(FADE_IN, crane_get_down)

def crane_get_down(object_id = None):
	enemy_script.delay(1.3, Lambda('sounds.play_3d_sound_object(sfx_id="crane_setting_down_container",object=const.Z7_CRANE,loop=False)'))
	if data().crane_location == "vesseltown":
		data().aufenthaltsort = "seaport"
		data('rest').legal_rest_areas['zone_7'] = const.REST_NONE_VESSELTOUWN
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_SHORT_ABANDONED_SEAPORT_DOWN")
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_OPEN", callback=["ONEND", crane_player_leave])
	else:
		data().aufenthaltsort = "vesseltown"
		data('rest').legal_rest_areas['zone_7'] = const.REST_VESSELTOUWN
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_SHORT_VESSELTOWN_DOWN")
		objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_VESSELTOWN_OPEN", callback=["ONEND", crane_player_leave])

def crane_player_leave(object_id = None):
	if data().aufenthaltsort == "vesseltown":
		container_sound()
	else:
		container_sound_vesseltown()
	crane_activate_partychars()
	
def crane_activate_partychars(object_id=None):
	pcs = data().pcs
	if data().crane_location == "vesseltown":
		dummy = "dmyp_container_path04"
	else:
		dummy = "dmyp_container_path08"
	dummypos = objects.get_full_dummy_position(const.Z7_CRANE,dummy)
	for pc in pcs:
		objects.set_active_state(pc, 1)
		objects.cancel_commandos(pc)
		objects.set_position_free(pc, dummypos[0], dummypos[1], dummypos[2])
	players_leave_container_short(data().pcs[0])
	
def players_leave_container_short(pc=None):
	pos = data().pcs.index(pc)
	if data().crane_location == "vesseltown":
		poses = const.POINTS_ABANDONED_SEAPORT_CONTAINER_EXIT
		dummy2 = "dmyp_container_path03"
		dummy3 = "dmyp_container_path02"
		dummy4 = "dmyp_container_path01"
	else:
		poses = const.POINTS_VESSELTOWN_CONTAINER_EXIT
		dummy2 = "dmyp_container_path07"
		dummy3 = "dmyp_container_path06"
		dummy4 = "dmyp_container_path05"
	dummypos2 = objects.get_full_dummy_position(const.Z7_CRANE,dummy2)
	dummypos3 = objects.get_full_dummy_position(const.Z7_CRANE,dummy3)
	dummypos4 = objects.get_full_dummy_position(const.Z7_CRANE,dummy4)
	index = pos + 1
	if index < len(data().pcs):
		next  = data().pcs[index]
		objects.step_to(pc, dummypos2[0],dummypos2[1], speed=MT_SLOW, callback=["ONEND",Lambda('players_leave_container_short(pc="%s")' %(next))])
	else:
		objects.step_to(pc, dummypos2[0],dummypos2[1], speed=MT_SLOW)
	objects.step_to(pc, dummypos3[0],dummypos3[1], speed=MT_SLOW)
	objects.step_to(pc, dummypos4[0],dummypos4[1], speed=MT_SLOW)
	last = len(data().pcs)-1
	if pc not in ["CRAIG", "BRAD"]:
		if ((not "CRAIG" in data().pcs) and (not "BRAD" in data().pcs)):
			objects.move_to(pc, poses[pos][0], poses[pos][1], speed=MT_SLOW)
		else:
			objects.move_to(pc, 485.22, 466.78, speed=MT_SLOW, callback=["ONEND", Lambda('objects.turn_to_object("%s", "ALTER_EGO")'%(pc))])
	else:
		if pos == last:
			enemy_script.delay(1.34, Lambda('start_sound_crane_stop()'))
		if pc == "CRAIG":
			objects.move_to(pc, 490.39, 461.80)
		elif pc == "BRAD":
			objects.move_to(pc, 490.18, 464.04)

	if data().crane_location == "vesseltown":
		objects.turn_to_direction(pc, DIR_WEST, callback=["ONEND", crane_container_closes])
	else:
		objects.turn_to_direction(pc, DIR_EAST, callback=["ONEND", crane_container_closes])

def crane_container_closes(char=None):
	if char == data().pcs[-1]:
		if "ANIE" in data().pcs:
			data().anie_folgt = True
		if data().crane_location == "vesseltown":
			container_sound()
			objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_EXIT")
		else:
			container_sound_vesseltown()
			objects.play_animation(const.Z7_CRANE, "ANIM_CRANE_CONTAINER_VESSELTOWN_EXIT")
		if not data().flughund_endcutscene:
			end_cutscene()
		else:
			initCutscene_084_BradUndCraigKommenMitKranHoch()

#[NM]Dialog 086: Der Spieler ist von Seans Plantage beeindruckt
def initDlg_086_SpielerIstBeeindrucktVonSeansPlantage():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_086')
	dialog.add_text(text='D_086_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM]Dialog 087: Der Spieler findet Seans Notizen
def initDlg_087_SpielerFindetSeansNotizen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_087')
	dialog.add_text(text='D_087_T_006', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_087_SpielerLiestNotizen)
	dialog.start(True, [data().QB_008, data().QB_009, data().QB_010, data().QB_011])

def onDlg_087_SpielerLiestNotizen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_087')
	dialog.add_text(text='SEAN_NOTE_A', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_087_QBUpdate)
	dialog.start(True, [data().QB_008, data().QB_009, data().QB_010, data().QB_011])

def onDlg_087_QBUpdate():
	if not data().emily_seansnotizagelesen:
		data().emily_seansnotizagelesen = True
		#system.set_qb_entry_state(data().QB_008,COMPLETE)
		#if system.get_qb_entry_state(data().QB_009) == UNCOMPLETE
		#	system.set_qb_entry_state(data().QB_009,COMPLETE)
		#system.set_qb_entry_state(data().QB_010,UNCOMPLETE)
		#system.set_qb_entry_state(data().QB_011,UNCOMPLETE)
	
#[NM]Dialog 089: Der Spieler findet Seans Notizen B
def initDlg_089_SpielerFindetSeansNotizenB():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_089')
	dialog.add_text(text='D_089_T_001', speaker="ALTER_EGO", follower='ENDDIALOG', callback=onDlg_089_SpielerLiestNotizen)
	dialog.start(True, data().QB_008)

def onDlg_089_SpielerLiestNotizen():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_089')
	dialog.add_text(text='SEAN_NOTE_B', speaker="ALTER_EGO", follower='ENDDIALOG', callback=initDlg_090_SpielerFindetSeansNotizenBNachsatz)
	dialog.start(True, data().QB_008)
	
#[NM]Dialog 090: Nachsatz nach Anschauen von Notiz B
def initDlg_090_SpielerFindetSeansNotizenBNachsatz():
	if system.get_qb_entry_state(data().QB_009) == UNCOMPLETE:
		system.set_qb_entry_state(data().QB_009,COMPLETE)
	
	if not data().emily_seansnotizbgelesen:
		data().emily_seansnotizbgelesen = True
		dialog.init_dialog(type=DIALOGSMALL)
		dialog.set_dialog_identifier('DH_090')
		dialog.add_text(text='D_090_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
		dialog.start(True, [data().QB_008, data().QB_008, data().QB_011])

#[NM]Dialog 048: Der Spieler hat nach dem Auftrag genug gefunden. 
def initDlg_048_SpielerHatNachAuftragGenugGefunden():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_048')
	dialog.add_text(text='D_048_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_006)

def hasItem(id,item):
	if (objects.count_in_inventory(id, item)==0):
		return False
	else:
		#print "hasItem "
		#print id
		#print item
		return True
def haveItem(group,item):
	for char in group:
		if hasItem(char,item):
			#print "haveItem"
			return True
	return False
def transfer_item(group,item,target):
	for char in group:
		if hasItem(char,item):
			objects.transfer_item(char,item ,target)
			return True
	return False

def initDlg(_text, _speaker):
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text=_text, speaker=_speaker, follower="ENDDIALOG")
	dialog.start()
	set_spoken_flag( _speaker )
	
#[NM/CS] Dialog 133: Der Spieler befreit die Geiseln
def initCutscene_133_SpielerBefreitGeiseln(character_id = 'ALTER_EGO'):
	character.unequip_hands("ALTER_EGO")
	objects.cancel_commandos("ALTER_EGO")
	if character_id != 'ALTER_EGO':
		objects.cancel_commandos(character_id)
		character.unequip_hands(character_id)
		
	system.start_cutscene()
	#set_camera(const.CAMVIEW_HOSTAGERESCUE_FAR)
	set_camera(const.CAMVIEW_HOSTAGERESCUE_CLOSE)
	if objects.get_distance_to_object("ALTER_EGO","BUILDING_2405") > 20:
		system.fade(FADE_OUT,callback = Lambda("initCutscene_133_SpielerBefreitGeiseln_2('%s')" %(character_id)))
		
	else:
		objects.step_to("ALTER_EGO",598.6,356.25, speed=MT_AUTO)
		initCutscene_133_SpielerBefreitGeiseln_3(character_id)
		
def initCutscene_133_SpielerBefreitGeiseln_2(character_id = 'ALTER_EGO'):
	objects.set_position("ALTER_EGO",593,355)
	system.fade(FADE_IN,callback = Lambda("initCutscene_133_SpielerBefreitGeiseln_3('%s')"%(character_id)))
	objects.step_to("ALTER_EGO",598.6,356.25, speed=MT_AUTO)
	objects.turn_to_object("ALTER_EGO", "ANIE")
	
def initCutscene_133_SpielerBefreitGeiseln_3(character_id = 'ALTER_EGO'):
	#objects.move_to("ALTER_EGO",602.76,353.89, callback=["ONEND", onDlg_133_PlayerReachesCage])
	objects.move_to_object(character_id,"BUILDING_2405","dmyp_001",callback=["ONEND", onDlg_133_PlayerReachesCage])

def onDlg_133_PlayerReachesCage(character_id = 'ALTER_EGO'):
	objects.turn_to_object(character_id, "ANIE", callback=["ONEND", onDlg_133_PlayerHasAnieBack])
	#onDlg_133_PlayerHasAnieBack()
	#character.play_animation("ALTER_EGO", "CM_STEHEN_KAEFIG_OEFFNEN",callback=["ONEND", onDlg_133_PlayerFreesHostages])
	character.play_animation(character_id, "CM_STEHEN_TASCHENDIEBSTAHL_VORN",callback=["ONEND", onDlg_133_PlayerFreesHostages])
	n=0
	for pc in system.get_pcs():
		if ((pc != "ALTER_EGO") and (objects.get_distance(pc, "ALTER_EGO") <= 15.0)):
			if pc != character_id:
				objects.cancel_commandos(pc)
			if n == 0:
				objects.move_to(pc, 595.82,354.8, callback=["ONEND", onDlg_133_CharTurnToAE])
			elif n == 1:
				objects.move_to(pc, 594.82,354.5, callback=["ONEND", onDlg_133_CharTurnToAE])
			elif n == 2:
				objects.move_to(pc, 593.82,354.6, callback=["ONEND", onDlg_133_CharTurnToAE])
			elif n == 3:
				objects.move_to(pc, 594.82,355.7, callback=["ONEND", onDlg_133_CharTurnToAE])
			elif n == 4:
				objects.move_to(pc, 593.82,355.8, callback=["ONEND", onDlg_133_CharTurnToAE])
			elif n == 5:
				objects.move_to(pc, 595.82,355.8, callback=["ONEND", onDlg_133_CharTurnToAE])
		n += 1

def onDlg_133_PlayerHasAnieBack(char_id=None):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_133')
	dialog.add_text(text='D_133_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, [data().QB_002, data().QB_015])

def onDlg_133_PlayerFreesHostages(char_id=None):
	data().saved_ae_scale = objects.get_scale("ALTER_EGO")
	objects.cancel_commandos("ALTER_EGO")
	anie_scale = objects.get_scale("ANIE")
	#print "-----> scales anie:",anie_scale,"ae:",data().saved_ae_scale
	objects.set_scale("ALTER_EGO", anie_scale)
	# blast_lock
	if (hasattr(data("pick_lock"), "blast_lock") and data("pick_lock").blast_lock):
		
		dummy_name = "door"
		x,y,z = objects.get_full_dummy_position('BUILDING_2405', dummy_name)
		#z = z - objects.get_attribute(interior_object_id,"z") # absolutes z umrechnen auf relatives
		system.start_effect( x-0.7, y-1.3, z+0.5, x, y, z, global_defines.fx_explosion )
		sounds.play_3d_sound( "grenade_explo_fire", x, y, z )

	set_camera(const.CAMVIEW_HOSTAGERESCUE_FAR)
	data().anie_ae_hug_counter = 0
	objects.move_to("ANIE",600.4,355.3, grid="landscape", speed=MT_SLOW, callback=["ONEND", hostage_out])
	objects.step_to("ALTER_EGO",598.6,356.25, speed=MT_SLOW, callback=["ONEND",onDlg_133_PlayerHugsAnie])
#	step_to doesnt work because position is on another grid
#	objects.step_to("ANIE", 598.6,355.7, speed=MT_SLOW, callback=["ONEND",onDlg_133_PlayerHugsAnie])
	objects.move_to("ANIE", 598.6,355.7, speed=MT_SLOW, callback=["ONEND",onDlg_133_PlayerHugsAnie])
	
#hostages leave cage
def hostage_out(char=None):
	if char == "ANIE":
		objects.move_to("GEISEL_1",602.76,353.89, grid="landscape", speed=MT_SLOW)
		objects.move_to("GEISEL_1", 598.48, 352.60, grid="landscape", speed=MT_SLOW, callback=["ONEND", hostage_out])
	else:
		onDlg_133_CharTurnToAE(char)
		if char=="GEISEL_1":
			objects.move_to("GEISEL_2",602.76,353.89, grid="landscape", speed=MT_SLOW)
			objects.move_to("GEISEL_2", 599.51, 352.45, grid="landscape", speed=MT_SLOW, callback=["ONEND", hostage_out])
		elif char=="GEISEL_2":
			objects.move_to("GEISEL_3",602.76,353.89, grid="landscape", speed=MT_SLOW)
			objects.move_to("GEISEL_3", 600.42, 352.73, grid="landscape", speed=MT_SLOW, callback=["ONEND", hostage_out])
		elif char=="GEISEL_3":
			objects.move_to("GEISEL_4",602.76,353.89, grid="landscape", speed=MT_SLOW)
			objects.move_to("GEISEL_4", 600.19, 350.49, grid="landscape", speed=MT_SLOW, callback=["ONEND", hostage_out])
		else:
			objects.move_to("GEISEL_5",602.76,353.89, grid="landscape", speed=MT_SLOW)
			objects.move_to("GEISEL_5", 600.32, 351.46, grid="landscape", speed=MT_SLOW, callback=["ONEND", onDlg_133_CharTurnToAE])

def onDlg_133_PlayerHugsAnie(char=None):
	data().anie_ae_hug_counter += 1
	if data().anie_ae_hug_counter == 2:
		data().anie_ae_hug_counter = 0
		objects.cancel_commandos("ALTER_EGO")
		objects.cancel_commandos("ANIE")
		system.set_camera_view([593.79888916015625, 359.1409912109375, 6.6902999877929687, 0.76403743028640747, -0.54252070188522339, -0.34916767477989197])
		objects.turn_to_object("ALTER_EGO", "ANIE", callback=["ONEND", hug])
		objects.turn_to_object("ANIE", "ALTER_EGO", callback=["ONEND", hug])
	
def hug(char=None):
	data().anie_ae_hug_counter += 1
	if data().anie_ae_hug_counter == 2:
		data().anie_ae_hug_counter = 0
		objects.cancel_commandos("ANIE")
		objects.cancel_commandos("ALTER_EGO")
		character.play_animation("ANIE", 'CM_STEHEN_UMARMEN_MANN_3', callback=["ONEND", onDlg_133_AnieContinue])
		character.play_animation("ALTER_EGO", 'CM_STEHEN_UMARMEN_FRAU', callback=["ONEND", onDlg_133_AnieContinue])
		dialog.init_dialog(DIALOGSMALL)
		dialog.set_dialog_identifier('DH_133')
		dialog.add_text(text='D_133_T_002', speaker='ALTER_EGO', follower='ENDDIALOG')
		dialog.start()

def onDlg_133_AnieContinue(char=None):
	data().anie_ae_hug_counter += 1
	if data().anie_ae_hug_counter == 2:
		data().anie_ae_hug_counter = 0
		pos = objects.get_position("ALTER_EGO")
		objects.set_scale("ALTER_EGO", data().saved_ae_scale)
		#objects.set_active_state("SHADOW_GUARD",0)
		objects.cancel_commandos("ANIE")
		objects.set_position_free("ANIE",599.3,354.9,0)
		objects.set_position_free("ALTER_EGO",pos[0],pos[1]+0.2,0)
		system.set_camera_view(const.CAMVIEW_ANIE_AE_AFTER_HUG)
		objects.turn_to_object("ALTER_EGO","ANIE",callback=["ONEND",onDlg_133_ContinueAfterPlayerMetAnie])
		objects.turn_to_object("ANIE","ALTER_EGO",callback=["ONEND",onDlg_133_ContinueAfterPlayerMetAnie])
	
def onDlg_133_CharTurnToAE(char_id):
	objects.turn_to_object(char_id,"ALTER_EGO")

def onDlg_133_ContinueAfterPlayerMetAnie(char_id):
	data().anie_ae_hug_counter += 1
	if data().anie_ae_hug_counter == 2:
		data().anie_ae_hug_counter = 0
		dialog.init_dialog(DIALOGSMALL)
		dialog.set_dialog_identifier('DH_133')
		dialog.add_text(text='D_133_T_003', speaker='ANIE', callback=Lambda('set_conversation("ALTER_EGO","ANIE",mode="medium")'))
		dialog.add_text(text='D_133_T_004', speaker='ALTER_EGO', callback=Lambda('set_conversation("ANIE","ALTER_EGO",mode="close")'))
		dialog.add_text(text='D_133_T_005', speaker='ANIE')
		dialog.add_text(text='D_133_T_006', speaker='ANIE', callback=Lambda('set_conversation("ALTER_EGO","ANIE",mode="close")'))
		dialog.add_text(text='D_133_T_007', speaker='ALTER_EGO', callback=Lambda('set_conversation("ANIE","ALTER_EGO",mode="close")'))
		dialog.add_text(text='D_133_T_008', speaker='ANIE', callback=Lambda('set_conversation("ALTER_EGO","ANIE",mode="close")'))
		dialog.add_text(text='D_133_T_009', speaker='ALTER_EGO', callback=Lambda('set_conversation("ANIE","ALTER_EGO",mode="close")'))
		dialog.add_text(text='D_133_T_010', speaker='ANIE', callback=Lambda('set_conversation("ALTER_EGO","ANIE",mode="close")'))
		dialog.add_text(text='D_133_T_011', speaker='ALTER_EGO', callback=Lambda('set_conversation("ANIE","ALTER_EGO",mode="close")'))
		dialog.add_text(text='D_133_T_012', speaker='ANIE', callback=Lambda('set_conversation("ALTER_EGO","ANIE",mode="close")'))
		dialog.add_text(text='D_133_T_013', speaker='ALTER_EGO', callback=Lambda('set_conversation("ANIE","ALTER_EGO",mode="close")'))
		dialog.add_text(text='D_133_T_014', speaker='ANIE', callback=Lambda('set_conversation("ALTER_EGO","ANIE",mode="close")'))
		dialog.add_text(text='D_133_T_015', speaker='ALTER_EGO', follower='ENDDIALOG', callback=onDlg_133_Ende)
		dialog.start(True, [data().QB_002, data().QB_015])

def onDlg_133_Ende():
	data().d_133_restart_t_011 = True
	if not is_zone_enabled('zone_8'):
		character.add_experience_party(50)
	set_zone_enabled("zone_8",True)
	system.set_qb_entry_state(data().QB_015, UNCOMPLETE)
	end_cutscene(chars=["ANIE", "ALTER_EGO"])
	objects.set_attribute("ANIE","zone_transfer",True)
	objects.set_attribute("ANIE","zone_transfer_new_party","NPCS")
	data().anie_folgt = True

def checkWesleyDead():
	if was_zone_entered("zone_1.zone_1"):
		return data("zone_1.zone_1").wesley_killed
	return False
			
#[M] Dialog 134: Der Spieler befragt Anie
def initDlg_134_SpielerBefragtAnie():
	dialog.init_dialog(DIALOGLARGE)
	dialog.set_dialog_identifier('DH_134')
	if data().anie_befragung[0]:
		dialog.add_choice(text='D_134_C_001_1', follower='D_134_T_001', callback=Lambda('data().anie_befragung[0]=False'))
	if data().anie_befragung[1]:
		dialog.add_choice(text='D_134_C_001_2', follower='D_134_T_004', callback=Lambda('data().anie_befragung[1]=False'))
	if data().anie_befragung[2]:
		dialog.add_choice(text='D_134_C_001_3', follower='D_134_T_009', callback=Lambda('data().anie_befragung[2]=False'))
	if data().anie_befragung[3]:
		dialog.add_choice(text='D_134_C_001_4', follower='D_134_T_010', callback=Lambda('data().anie_befragung[3]=False'))
	dialog.add_choice(text='D_134_C_001_5', follower='ENDDIALOG', callback=onDlg_134_Ende)
	if checkWesleyDead():
		dialog.add_text(text='D_134_T_001', speaker='ANIE', follower='D_134_T_002')
	else:
		dialog.add_text(text='D_134_T_001', speaker='ANIE', follower='D_134_T_003')
	dialog.add_text(text='D_134_T_002', speaker='ALTER_EGO', follower='D_134_C_001')
	dialog.add_text(text='D_134_T_003', speaker='ALTER_EGO', follower='D_134_C_001')
	dialog.add_text(text='D_134_T_004', speaker='ANIE')
	dialog.add_text(text='D_134_T_005', speaker='ALTER_EGO', follower='D_134_C_001')
	dialog.add_text(text='D_134_T_009', speaker='ANIE', follower='D_134_C_001')
	dialog.add_text(text='D_134_T_010', speaker='ANIE')
	dialog.add_text(text='D_134_T_011', speaker='ALTER_EGO', follower='D_134_C_001', callback=Lambda('data().GNO_HOSTAGE_INFO = True'))
	dialog.start(False)

def onDlg_134_Ende():
	objects.set_attribute("ANIE","zone_transfer",True)
	objects.set_attribute("ANIE","zone_transfer_new_party","NPCS")
	data().anie_folgt = True

#[NM] Dialog 135: Der Spieler will noch nicht mit den Geiseln reden
def initDlg_135_SpielerWillNochNichtMitGeiselnReden():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_135')
	dialog.add_text(text='D_135_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 137: Der Spieler will nicht mehr mit den Geiseln reden
def initDlg_137_SpielerWillNichtMehrMitGeiselnReden():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_137')
	dialog.add_text(text='D_137_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start()

#[NM/CS] Dialog 136: Die Geiseln wollen den Spieler begleiten
def initCutscene_136_GeiselnWollenSpielerBegleiten():
	system.start_cutscene()
	for id in const.NPCS_IN_HOSTAGECAGE_WOA:
		prohibit_activity(id, False)
		objects.turn_to_object(id,"ALTER_EGO")
	data().anie_folgt = False
	objects.move_to("ANIE", 599.0,355.0)
	objects.turn_to_object("ANIE","ALTER_EGO")
	system.set_camera_view(const.CAMVIEW_AE_HOSTAGES)
	objects.move_to("ALTER_EGO",599.6,353.9, callback=["ONEND", onDlg_136_StartDialog])

def onDlg_136_StartDialog(char_id):
	set_conversation("GEISEL_1","ALTER_EGO",mode="far",new_camera=False)
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_136')
	dialog.add_text(text='D_136_T_001', speaker='GEISEL_1', callback=Lambda('set_conversation("GEISEL_2","ALTER_EGO",mode="medium")'))
	dialog.add_text(text='D_136_T_002', speaker='GEISEL_2', callback=Lambda('set_conversation("ALTER_EGO","GEISEL_2",mode="medium")'))
	dialog.add_text(text='D_136_T_003', speaker='ALTER_EGO', callback=Lambda('set_conversation("GEISEL_3","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_136_T_004', speaker='GEISEL_3', callback=Lambda('set_conversation("ALTER_EGO","GEISEL_3",mode="medium")'))
	dialog.add_text(text='D_136_T_005', speaker='ALTER_EGO', callback=Lambda('set_conversation("GEISEL_2","ALTER_EGO",mode="close")'))
	dialog.add_text(text='D_136_T_006', speaker='GEISEL_2', callback=Lambda('set_conversation("ALTER_EGO","GEISEL_2",mode="medium")'))
	dialog.add_text(text='D_136_T_007', speaker='ALTER_EGO', follower='ENDDIALOG', callback=onDlg_136_Ende)
	dialog.start(True, data().QB_015)

def onDlg_136_Ende():
	data().continue_with_d_137 = True
	end_cutscene(chars=["GEISEL_1","GEISEL_2","GEISEL_3","ALTER_EGO"])
	for id in const.NPCS_IN_HOSTAGECAGE_WOA:
		allow_activity(id)
	system.notify_timer(data().Timer_GeiselnVerschwinden, data().Timervalue_GeiselnVerschwinden)
	objects.set_attribute("ANIE","zone_transfer",True)
	objects.set_attribute("ANIE","zone_transfer_new_party","NPCS")
	data().anie_folgt = True
	system.notify_timer(data().Timer_AnieFolgt,data().Timervalue_AnieFolgt)

#[NM] Dialog 131: Der Spieler will die Geiseln noch nicht befreien
def initDlg_131_SpielerWillGeiselnNochNichtBefreien():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_131')
	dialog.add_text(text='D_131_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 146: Der Spieler kann den Käfig nicht öffnen
def initDlg_146_SpielerKannKaefigNichtOeffnen(character_id = "ALTER_EGO"):
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_146')
	dialog.add_text(text='D_146_T_001', speaker=character_id, follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 132: Der Spieler will die Geiseln noch immer nicht befreien
def initDlg_132_SpielerWillGeiselnImmerNochNichtBefreien():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_132')
	dialog.add_text(text='D_132_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data().QB_005)

def initDlg_MBA_Museeumsleichen(object_id):
	text = const.OBJECTS_MBA_LEICHEN[object_id]
	dialog.init_dialog(DIALOGSMALL)
	dialog.add_text(text=text, speaker='RUPERT', follower='ENDDIALOG')
	dialog.start()

def MercenaryDenyTalk(id,type='default'):
	gender = objects.get_attribute("ALTER_EGO","gender")
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_Mercenary_Deny')
	if type == 'default':
		if gender == MALE:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_DEFAULT_DENY_F', speaker=id, follower='ENDDIALOG')
	else:
		if gender == MALE:
			dialog.add_text(text='MERCENERY_USEITEM_DENY', speaker=id, follower='ENDDIALOG')
		else:
			dialog.add_text(text='MERCENERY_USEITEM_DENY_F', speaker=id, follower='ENDDIALOG')
	dialog.start(False)

#[NM] Dialog 138: Sonnenschutzmittel ist noch nicht fertig
def initDlg_138_SonnenschutzmittelIstNochNichtFertig():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_138')
	dialog.add_text(text='D_138_T_001', speaker='EMILY', follower='ENDDIALOG')
	dialog.start(True, data().QB_016)

#[NM] Dialog 139: Sonnenschutzmittel ist fertig
def initDlg_139_SonnenschutzmittelIstFertig():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_139')
	dialog.add_text(text='D_139_T_001', speaker='EMILY')
	objects.create_item_in_inventory("ALTER_EGO",["SET_SUNTAN_LOTION"])
	dialog.add_text(text='D_139_T_002', speaker='ALTER_EGO', follower='ENDDIALOG', callback=onDlg_139_Ende)
	dialog.start(False, [data().QB_008, data().QB_016])

def onDlg_139_Ende():
	system.set_qb_entry_state(data().QB_016, INACTIVE)
	system.set_qb_entry_state(data().QB_008, COMPLETE)

#[NM] Dialog 140: Der Spieler findet den Reinigungsalkohol
def initDlg_140_SpielerFindetDenReinigungsalkohol():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_140')
	dialog.add_text(text='D_140_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data().QB_011)

#[NM] Dialog 141: Der Spieler findet das Pflanzenöl
def initDlg_141_SpielerFindetDenReinigungsalkohol():
	dialog.init_dialog(DIALOGSMALL)
	dialog.set_dialog_identifier('DH_141')
	dialog.add_text(text='D_141_T_001', speaker='ALTER_EGO', follower='ENDDIALOG')
	dialog.start(True, data().QB_010)

#[NM] Dialog 142: Der Spieler schneidet die Pflanze nicht an, Variante: Keine Ahnung
def initDlg_142_SpielerSchneidetPflanzeNicht_KeineAhnung():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_142')
	dialog.add_text(text='D_142_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 143: Der Spieler schneidet die Pflanze nicht an, Variante: Ein bisschen Ahnung
def initDlg_143_SpielerSchneidetPflanzeNicht_EinBischenAhnung():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_143')
	dialog.add_text(text='D_143_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_009)

#[NM] Dialog 144: Der Spieler schneidet die Pflanze nicht an, Variante: Ahnung
def initDlg_144_SpielerSchneidetPflanzeNicht_Ahnung():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_144')
	dialog.add_text(text='D_144_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start(True, data().QB_009)

#[NM/CS] Dialog 147: Der Reporter ist auf der Siegerstraße
def initDlg_147_ReporterIstAufSiegerstasse():
	system.start_cutscene()
	set_conversation("REPORTER", cam_x=-3, cam_y=-3, mode="medium")
	init_cutscene("ALTER_EGO", "REPORTER", dx=-1.4, dy=1.4)
	objects.turn_to_object("ALTER_EGO", "REPORTER", callback=["ONEND", on_dialog_147_start])

def on_dialog_147_start(char):
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_147')
	dialog.add_text(text='D_147_T_001', speaker="ALTER_EGO", callback=Lambda('set_conversation("REPORTER","ALTER_EGO",mode="medium_deep")'))
	dialog.add_text(text='D_147_T_002', speaker="REPORTER", callback=Lambda('set_conversation("ALTER_EGO","REPORTER",mode="medium_deep")'))
	dialog.add_text(text='D_147_T_003', speaker="ALTER_EGO", callback=Lambda('set_conversation("REPORTER","ALTER_EGO",mode="medium_deep")'))
	dialog.add_text(text='D_147_T_004', speaker="REPORTER", follower='ENDDIALOG', callback=on_dialog_147_ende)
	dialog.start(True, data("zone_2.zone_2").QB_007)

def on_dialog_147_ende():
	end_cutscene(chars=["ALTER_EGO", "REPORTER"])
	data().reporter_spoke_to = True

#[NM] Dialog 148: Der Spieler will nicht noch mal mit dem Reporter sprechen
def initDlg_148_SpielerWillNichtNochmalMitReporterReden():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_148')
	dialog.add_text(text='D_148_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

#[NM] Dialog 149: Der Spieler will nicht mit den Boten reden
def initDlg_149_SpielerWillNichtMitBotenReden():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_149')
	dialog.add_text(text='D_149_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()

## spieler hat keine zeit zu reden mit rupert
def initDlg_Z6_147_SpielerHatKeineZeit():
	dialog.init_dialog(type=DIALOGSMALL)
	dialog.set_dialog_identifier('DH_147')
	dialog.add_text(text='Z6_D_147_T_001', speaker="ALTER_EGO", follower='ENDDIALOG')
	dialog.start()


def letzter_Schatten():
	system.fade(FADE_OUT)
	system.start_cutscene()
	system.set_camera_view([598.84423828125, 463.25885009765625, 7.9935150146484375, -0.65628403425216675, 0.27834174036979675, -0.70129674673080444])
	mindist = 1000
	ShId = ""
	for shad in const.DEADSHADOWS:
		ndist = objects.get_distance_to_position(shad, 592, 465.5)
		if ((ndist < mindist) and (objects.get_attribute(shad,"gender") == "male")):
			mindist = ndist
			ShId = shad

	if objects.count_in_inventory("DYING_SHADOW",data().qi_cagekey[0]):
		objects.transfer_item("DYING_SHADOW", data().qi_cagekey[0], ShId)
	objects.set_position_free(ShId, 592, 465.5, 0, grid="landscape")
	letzter_Schatten2(ShId)

def letzter_Schatten2(ShId):
	group = system.get_pcs()
	group2 = []
	for folger in ["FRANKLIN", "IAN", "LINDA", "PAULA", "ABRAHAM", "MICKEY", "SUE_Z7", "FJODR"]:
		if folger in system.get_npcs():
			if not objects.is_destroyed(folger) and objects.is_active(folger):
				objects.cancel_commandos(folger)
				prohibit_activity(folger)
				group2.append(folger)

	count = 0
	for nid in group + group2:
		x,y = const.ZUSCHAUER[count]
		objects.set_position(nid, x, y)
		objects.turn_to_object(nid, ShId)
		count += 1

	system.fade(FADE_IN)
	objects.move_to("ALTER_EGO", 592.90, 466.16, speed=MT_SLOW, callback=["ONEND",Lambda('letzter_Schatten3("%s",%s)'%(ShId,group2))])
	
def letzter_Schatten3(ShId, group2):
	objects.turn_to_object("ALTER_EGO","DYING_SHADOW")
	character.change_body_mode('ALTER_EGO', 'KNEEL')
	initDlg_076_SchattenBeschimpftSpieler(group2)
#	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_TIER_AUSWEIDEN_START", callback=["ONEND", Lambda('initDlg_076_SchattenBeschimpftSpieler()')])
#	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
#	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
#	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
#	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
#	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
#	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_TIER_AUSWEIDEN_LOOP")
#	character.play_animation("ALTER_EGO","CM_NPC_STEHEN_TIER_AUSWEIDEN_ENDE")
#	letzter_Schatten2_end(group2)

def letzter_Schatten2_end(group2):
	for id in system.get_pcs() + group2:
		if not objects.is_destroyed(id) and objects.is_active(id):
			objects.step_away(id)
			allow_activity(id)
	end_cutscene(chars=[])

